/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*115 cases */, 127|128,58/*7551*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->7556
/*     5*/  OPC_Scope, 114|128,58/*7538*/, /*->7546*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 89|128,5/*729*/, TARGET_VAL(ISD::AssertZext),// ->743
/*    14*/    OPC_MoveChild0,
/*    15*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    18*/    OPC_RecordMemRef,
/*    19*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    20*/    OPC_CheckFoldableChainNode,
/*    21*/    OPC_Scope, 60|128,3/*444*/, /*->468*/ // 2 children in Scope
/*    24*/     OPC_MoveChild1,
/*    25*/     OPC_SwitchOpcode /*3 cases */, 13|128,1/*141*/, TARGET_VAL(ISD::ADD),// ->171
/*    30*/      OPC_RecordChild0, // #1 = $addr
/*    31*/      OPC_RecordChild1, // #2 = $off
/*    32*/      OPC_MoveChild1,
/*    33*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*    36*/      OPC_MoveParent,
/*    37*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*    39*/      OPC_SwitchType /*2 cases */, 63, MVT::i32,// ->105
/*    42*/       OPC_MoveParent,
/*    43*/       OPC_MoveChild2,
/*    44*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    47*/       OPC_RecordChild0, // #3 = $exp
/*    48*/       OPC_MoveParent,
/*    49*/       OPC_MoveChild3,
/*    50*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    53*/       OPC_RecordChild0, // #4 = $new
/*    54*/       OPC_MoveParent,
/*    55*/       OPC_Scope, 23, /*->80*/ // 2 children in Scope
/*    57*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*    59*/        OPC_MoveParent,
/*    60*/        OPC_MoveParent,
/*    61*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    63*/        OPC_EmitMergeInputChains1_0,
/*    64*/        OPC_EmitInteger, MVT::i32, 0, 
/*    67*/        OPC_EmitConvertToTarget, 2,
/*    69*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*    80*/       /*Scope*/ 23, /*->104*/
/*    81*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*    83*/        OPC_MoveParent,
/*    84*/        OPC_MoveParent,
/*    85*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    87*/        OPC_EmitMergeInputChains1_0,
/*    88*/        OPC_EmitInteger, MVT::i32, 0, 
/*    91*/        OPC_EmitConvertToTarget, 2,
/*    93*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   104*/       0, /*End of Scope*/
/*   105*/      /*SwitchType*/ 63, MVT::i64,// ->170
/*   107*/       OPC_MoveParent,
/*   108*/       OPC_MoveChild2,
/*   109*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   112*/       OPC_RecordChild0, // #3 = $exp
/*   113*/       OPC_MoveParent,
/*   114*/       OPC_MoveChild3,
/*   115*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   118*/       OPC_RecordChild0, // #4 = $new
/*   119*/       OPC_MoveParent,
/*   120*/       OPC_Scope, 23, /*->145*/ // 2 children in Scope
/*   122*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   124*/        OPC_MoveParent,
/*   125*/        OPC_MoveParent,
/*   126*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   128*/        OPC_EmitMergeInputChains1_0,
/*   129*/        OPC_EmitInteger, MVT::i32, 0, 
/*   132*/        OPC_EmitConvertToTarget, 2,
/*   134*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   145*/       /*Scope*/ 23, /*->169*/
/*   146*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   148*/        OPC_MoveParent,
/*   149*/        OPC_MoveParent,
/*   150*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   152*/        OPC_EmitMergeInputChains1_0,
/*   153*/        OPC_EmitInteger, MVT::i32, 0, 
/*   156*/        OPC_EmitConvertToTarget, 2,
/*   158*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   169*/       0, /*End of Scope*/
/*   170*/      0, // EndSwitchType
/*   171*/     /*SwitchOpcode*/ 13|128,1/*141*/, TARGET_VAL(ISD::OR),// ->316
/*   175*/      OPC_RecordChild0, // #1 = $addr
/*   176*/      OPC_RecordChild1, // #2 = $off
/*   177*/      OPC_MoveChild1,
/*   178*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*   181*/      OPC_MoveParent,
/*   182*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*   184*/      OPC_SwitchType /*2 cases */, 63, MVT::i32,// ->250
/*   187*/       OPC_MoveParent,
/*   188*/       OPC_MoveChild2,
/*   189*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   192*/       OPC_RecordChild0, // #3 = $exp
/*   193*/       OPC_MoveParent,
/*   194*/       OPC_MoveChild3,
/*   195*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   198*/       OPC_RecordChild0, // #4 = $new
/*   199*/       OPC_MoveParent,
/*   200*/       OPC_Scope, 23, /*->225*/ // 2 children in Scope
/*   202*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   204*/        OPC_MoveParent,
/*   205*/        OPC_MoveParent,
/*   206*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   208*/        OPC_EmitMergeInputChains1_0,
/*   209*/        OPC_EmitInteger, MVT::i32, 0, 
/*   212*/        OPC_EmitConvertToTarget, 2,
/*   214*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   225*/       /*Scope*/ 23, /*->249*/
/*   226*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   228*/        OPC_MoveParent,
/*   229*/        OPC_MoveParent,
/*   230*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   232*/        OPC_EmitMergeInputChains1_0,
/*   233*/        OPC_EmitInteger, MVT::i32, 0, 
/*   236*/        OPC_EmitConvertToTarget, 2,
/*   238*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   249*/       0, /*End of Scope*/
/*   250*/      /*SwitchType*/ 63, MVT::i64,// ->315
/*   252*/       OPC_MoveParent,
/*   253*/       OPC_MoveChild2,
/*   254*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   257*/       OPC_RecordChild0, // #3 = $exp
/*   258*/       OPC_MoveParent,
/*   259*/       OPC_MoveChild3,
/*   260*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   263*/       OPC_RecordChild0, // #4 = $new
/*   264*/       OPC_MoveParent,
/*   265*/       OPC_Scope, 23, /*->290*/ // 2 children in Scope
/*   267*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   269*/        OPC_MoveParent,
/*   270*/        OPC_MoveParent,
/*   271*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   273*/        OPC_EmitMergeInputChains1_0,
/*   274*/        OPC_EmitInteger, MVT::i32, 0, 
/*   277*/        OPC_EmitConvertToTarget, 2,
/*   279*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   290*/       /*Scope*/ 23, /*->314*/
/*   291*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   293*/        OPC_MoveParent,
/*   294*/        OPC_MoveParent,
/*   295*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/        OPC_EmitMergeInputChains1_0,
/*   298*/        OPC_EmitInteger, MVT::i32, 0, 
/*   301*/        OPC_EmitConvertToTarget, 2,
/*   303*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   314*/       0, /*End of Scope*/
/*   315*/      0, // EndSwitchType
/*   316*/     /*SwitchOpcode*/ 19|128,1/*147*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->467
/*   320*/      OPC_RecordChild0, // #1 = $off
/*   321*/      OPC_MoveChild0,
/*   322*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   325*/      OPC_MoveParent,
/*   326*/      OPC_MoveParent,
/*   327*/      OPC_MoveChild2,
/*   328*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   331*/      OPC_RecordChild0, // #2 = $exp
/*   332*/      OPC_MoveParent,
/*   333*/      OPC_MoveChild3,
/*   334*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   337*/      OPC_RecordChild0, // #3 = $new
/*   338*/      OPC_MoveParent,
/*   339*/      OPC_Scope, 62, /*->403*/ // 2 children in Scope
/*   341*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   343*/       OPC_MoveParent,
/*   344*/       OPC_MoveParent,
/*   345*/       OPC_Scope, 27, /*->374*/ // 2 children in Scope
/*   347*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*   349*/        OPC_EmitMergeInputChains1_0,
/*   350*/        OPC_EmitInteger, MVT::i32, 0, 
/*   353*/        OPC_EmitInteger, MVT::i32, 0, 
/*   356*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*   363*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   374*/       /*Scope*/ 27, /*->402*/
/*   375*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*   377*/        OPC_EmitMergeInputChains1_0,
/*   378*/        OPC_EmitInteger, MVT::i32, 0, 
/*   381*/        OPC_EmitInteger, MVT::i64, 0, 
/*   384*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*   391*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   402*/       0, /*End of Scope*/
/*   403*/      /*Scope*/ 62, /*->466*/
/*   404*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   406*/       OPC_MoveParent,
/*   407*/       OPC_MoveParent,
/*   408*/       OPC_Scope, 27, /*->437*/ // 2 children in Scope
/*   410*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*   412*/        OPC_EmitMergeInputChains1_0,
/*   413*/        OPC_EmitInteger, MVT::i32, 0, 
/*   416*/        OPC_EmitInteger, MVT::i32, 0, 
/*   419*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*   426*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   437*/       /*Scope*/ 27, /*->465*/
/*   438*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*   440*/        OPC_EmitMergeInputChains1_0,
/*   441*/        OPC_EmitInteger, MVT::i32, 0, 
/*   444*/        OPC_EmitInteger, MVT::i64, 0, 
/*   447*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*   454*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   465*/       0, /*End of Scope*/
/*   466*/      0, /*End of Scope*/
/*   467*/     0, // EndSwitchOpcode
/*   468*/    /*Scope*/ 16|128,2/*272*/, /*->742*/
/*   470*/     OPC_RecordChild1, // #1 = $off
/*   471*/     OPC_Scope, 5|128,1/*133*/, /*->607*/ // 3 children in Scope
/*   474*/      OPC_MoveChild1,
/*   475*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*   478*/      OPC_MoveParent,
/*   479*/      OPC_MoveChild2,
/*   480*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   483*/      OPC_RecordChild0, // #2 = $exp
/*   484*/      OPC_MoveParent,
/*   485*/      OPC_MoveChild3,
/*   486*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   489*/      OPC_RecordChild0, // #3 = $new
/*   490*/      OPC_MoveParent,
/*   491*/      OPC_Scope, 56, /*->549*/ // 2 children in Scope
/*   493*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   495*/       OPC_MoveParent,
/*   496*/       OPC_MoveParent,
/*   497*/       OPC_EmitMergeInputChains1_0,
/*   498*/       OPC_EmitInteger, MVT::i32, 0, 
/*   501*/       OPC_EmitConvertToTarget, 1,
/*   503*/       OPC_Scope, 21, /*->526*/ // 2 children in Scope
/*   505*/        OPC_EmitInteger, MVT::i32, 0, 
/*   508*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/*   515*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   526*/       /*Scope*/ 21, /*->548*/
/*   527*/        OPC_EmitInteger, MVT::i64, 0, 
/*   530*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/*   537*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   548*/       0, /*End of Scope*/
/*   549*/      /*Scope*/ 56, /*->606*/
/*   550*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   552*/       OPC_MoveParent,
/*   553*/       OPC_MoveParent,
/*   554*/       OPC_EmitMergeInputChains1_0,
/*   555*/       OPC_EmitInteger, MVT::i32, 0, 
/*   558*/       OPC_EmitConvertToTarget, 1,
/*   560*/       OPC_Scope, 21, /*->583*/ // 2 children in Scope
/*   562*/        OPC_EmitInteger, MVT::i32, 0, 
/*   565*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/*   572*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   583*/       /*Scope*/ 21, /*->605*/
/*   584*/        OPC_EmitInteger, MVT::i64, 0, 
/*   587*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/*   594*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   605*/       0, /*End of Scope*/
/*   606*/      0, /*End of Scope*/
/*   607*/     /*Scope*/ 66, /*->674*/
/*   608*/      OPC_CheckChild1Type, MVT::i32,
/*   610*/      OPC_MoveChild2,
/*   611*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   614*/      OPC_RecordChild0, // #2 = $exp
/*   615*/      OPC_MoveParent,
/*   616*/      OPC_MoveChild3,
/*   617*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   620*/      OPC_RecordChild0, // #3 = $new
/*   621*/      OPC_MoveParent,
/*   622*/      OPC_Scope, 24, /*->648*/ // 2 children in Scope
/*   624*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   626*/       OPC_MoveParent,
/*   627*/       OPC_MoveParent,
/*   628*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   630*/       OPC_EmitMergeInputChains1_0,
/*   631*/       OPC_EmitInteger, MVT::i32, 0, 
/*   634*/       OPC_EmitInteger, MVT::i32, 0, 
/*   637*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   648*/      /*Scope*/ 24, /*->673*/
/*   649*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   651*/       OPC_MoveParent,
/*   652*/       OPC_MoveParent,
/*   653*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   655*/       OPC_EmitMergeInputChains1_0,
/*   656*/       OPC_EmitInteger, MVT::i32, 0, 
/*   659*/       OPC_EmitInteger, MVT::i32, 0, 
/*   662*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   673*/      0, /*End of Scope*/
/*   674*/     /*Scope*/ 66, /*->741*/
/*   675*/      OPC_CheckChild1Type, MVT::i64,
/*   677*/      OPC_MoveChild2,
/*   678*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   681*/      OPC_RecordChild0, // #2 = $exp
/*   682*/      OPC_MoveParent,
/*   683*/      OPC_MoveChild3,
/*   684*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   687*/      OPC_RecordChild0, // #3 = $new
/*   688*/      OPC_MoveParent,
/*   689*/      OPC_Scope, 24, /*->715*/ // 2 children in Scope
/*   691*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*   693*/       OPC_MoveParent,
/*   694*/       OPC_MoveParent,
/*   695*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/       OPC_EmitMergeInputChains1_0,
/*   698*/       OPC_EmitInteger, MVT::i32, 0, 
/*   701*/       OPC_EmitInteger, MVT::i64, 0, 
/*   704*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   715*/      /*Scope*/ 24, /*->740*/
/*   716*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*   718*/       OPC_MoveParent,
/*   719*/       OPC_MoveParent,
/*   720*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   722*/       OPC_EmitMergeInputChains1_0,
/*   723*/       OPC_EmitInteger, MVT::i32, 0, 
/*   726*/       OPC_EmitInteger, MVT::i64, 0, 
/*   729*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   740*/      0, /*End of Scope*/
/*   741*/     0, /*End of Scope*/
/*   742*/    0, /*End of Scope*/
/*   743*/   /*SwitchOpcode*/ 38|128,3/*422*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->1169
/*   747*/    OPC_RecordMemRef,
/*   748*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   749*/    OPC_Scope, 6|128,2/*262*/, /*->1014*/ // 2 children in Scope
/*   752*/     OPC_MoveChild1,
/*   753*/     OPC_SwitchOpcode /*3 cases */, 85, TARGET_VAL(ISD::ADD),// ->842
/*   757*/      OPC_RecordChild0, // #1 = $addr
/*   758*/      OPC_RecordChild1, // #2 = $off
/*   759*/      OPC_MoveChild1,
/*   760*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*   763*/      OPC_MoveParent,
/*   764*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*   766*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->804
/*   769*/       OPC_MoveParent,
/*   770*/       OPC_MoveChild2,
/*   771*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   774*/       OPC_RecordChild0, // #3 = $exp
/*   775*/       OPC_MoveParent,
/*   776*/       OPC_MoveChild3,
/*   777*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   780*/       OPC_RecordChild0, // #4 = $new
/*   781*/       OPC_MoveParent,
/*   782*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*   784*/       OPC_MoveParent,
/*   785*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   787*/       OPC_EmitMergeInputChains1_0,
/*   788*/       OPC_EmitInteger, MVT::i32, 0, 
/*   791*/       OPC_EmitConvertToTarget, 2,
/*   793*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 20
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   804*/      /*SwitchType*/ 35, MVT::i64,// ->841
/*   806*/       OPC_MoveParent,
/*   807*/       OPC_MoveChild2,
/*   808*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   811*/       OPC_RecordChild0, // #3 = $exp
/*   812*/       OPC_MoveParent,
/*   813*/       OPC_MoveChild3,
/*   814*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   817*/       OPC_RecordChild0, // #4 = $new
/*   818*/       OPC_MoveParent,
/*   819*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*   821*/       OPC_MoveParent,
/*   822*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   824*/       OPC_EmitMergeInputChains1_0,
/*   825*/       OPC_EmitInteger, MVT::i32, 0, 
/*   828*/       OPC_EmitConvertToTarget, 2,
/*   830*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 20
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   841*/      0, // EndSwitchType
/*   842*/     /*SwitchOpcode*/ 85, TARGET_VAL(ISD::OR),// ->930
/*   845*/      OPC_RecordChild0, // #1 = $addr
/*   846*/      OPC_RecordChild1, // #2 = $off
/*   847*/      OPC_MoveChild1,
/*   848*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*   851*/      OPC_MoveParent,
/*   852*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*   854*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->892
/*   857*/       OPC_MoveParent,
/*   858*/       OPC_MoveChild2,
/*   859*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/       OPC_RecordChild0, // #3 = $exp
/*   863*/       OPC_MoveParent,
/*   864*/       OPC_MoveChild3,
/*   865*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   868*/       OPC_RecordChild0, // #4 = $new
/*   869*/       OPC_MoveParent,
/*   870*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*   872*/       OPC_MoveParent,
/*   873*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   875*/       OPC_EmitMergeInputChains1_0,
/*   876*/       OPC_EmitInteger, MVT::i32, 0, 
/*   879*/       OPC_EmitConvertToTarget, 2,
/*   881*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 20
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   892*/      /*SwitchType*/ 35, MVT::i64,// ->929
/*   894*/       OPC_MoveParent,
/*   895*/       OPC_MoveChild2,
/*   896*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   899*/       OPC_RecordChild0, // #3 = $exp
/*   900*/       OPC_MoveParent,
/*   901*/       OPC_MoveChild3,
/*   902*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   905*/       OPC_RecordChild0, // #4 = $new
/*   906*/       OPC_MoveParent,
/*   907*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*   909*/       OPC_MoveParent,
/*   910*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   912*/       OPC_EmitMergeInputChains1_0,
/*   913*/       OPC_EmitInteger, MVT::i32, 0, 
/*   916*/       OPC_EmitConvertToTarget, 2,
/*   918*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 20
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   929*/      0, // EndSwitchType
/*   930*/     /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::Wrapper),// ->1013
/*   933*/      OPC_RecordChild0, // #1 = $off
/*   934*/      OPC_MoveChild0,
/*   935*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   938*/      OPC_MoveParent,
/*   939*/      OPC_MoveParent,
/*   940*/      OPC_MoveChild2,
/*   941*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   944*/      OPC_RecordChild0, // #2 = $exp
/*   945*/      OPC_MoveParent,
/*   946*/      OPC_MoveChild3,
/*   947*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   950*/      OPC_RecordChild0, // #3 = $new
/*   951*/      OPC_MoveParent,
/*   952*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*   954*/      OPC_MoveParent,
/*   955*/      OPC_Scope, 27, /*->984*/ // 2 children in Scope
/*   957*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*   959*/       OPC_EmitMergeInputChains1_0,
/*   960*/       OPC_EmitInteger, MVT::i32, 0, 
/*   963*/       OPC_EmitInteger, MVT::i32, 0, 
/*   966*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*   973*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 19
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*   984*/      /*Scope*/ 27, /*->1012*/
/*   985*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*   987*/       OPC_EmitMergeInputChains1_0,
/*   988*/       OPC_EmitInteger, MVT::i32, 0, 
/*   991*/       OPC_EmitInteger, MVT::i64, 0, 
/*   994*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  1001*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 19
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  1012*/      0, /*End of Scope*/
/*  1013*/     0, // EndSwitchOpcode
/*  1014*/    /*Scope*/ 24|128,1/*152*/, /*->1168*/
/*  1016*/     OPC_RecordChild1, // #1 = $off
/*  1017*/     OPC_Scope, 72, /*->1091*/ // 3 children in Scope
/*  1019*/      OPC_MoveChild1,
/*  1020*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  1023*/      OPC_MoveParent,
/*  1024*/      OPC_MoveChild2,
/*  1025*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1028*/      OPC_RecordChild0, // #2 = $exp
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_MoveChild3,
/*  1031*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1034*/      OPC_RecordChild0, // #3 = $new
/*  1035*/      OPC_MoveParent,
/*  1036*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*  1038*/      OPC_MoveParent,
/*  1039*/      OPC_EmitMergeInputChains1_0,
/*  1040*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1043*/      OPC_EmitConvertToTarget, 1,
/*  1045*/      OPC_Scope, 21, /*->1068*/ // 2 children in Scope
/*  1047*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1050*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/*  1057*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 16
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  1068*/      /*Scope*/ 21, /*->1090*/
/*  1069*/       OPC_EmitInteger, MVT::i64, 0, 
/*  1072*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/*  1079*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 16
                 // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  1090*/      0, /*End of Scope*/
/*  1091*/     /*Scope*/ 37, /*->1129*/
/*  1092*/      OPC_CheckChild1Type, MVT::i32,
/*  1094*/      OPC_MoveChild2,
/*  1095*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1098*/      OPC_RecordChild0, // #2 = $exp
/*  1099*/      OPC_MoveParent,
/*  1100*/      OPC_MoveChild3,
/*  1101*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1104*/      OPC_RecordChild0, // #3 = $new
/*  1105*/      OPC_MoveParent,
/*  1106*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*  1108*/      OPC_MoveParent,
/*  1109*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1111*/      OPC_EmitMergeInputChains1_0,
/*  1112*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1115*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 13
                // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  1129*/     /*Scope*/ 37, /*->1167*/
/*  1130*/      OPC_CheckChild1Type, MVT::i64,
/*  1132*/      OPC_MoveChild2,
/*  1133*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1136*/      OPC_RecordChild0, // #2 = $exp
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_MoveChild3,
/*  1139*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1142*/      OPC_RecordChild0, // #3 = $new
/*  1143*/      OPC_MoveParent,
/*  1144*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/*  1146*/      OPC_MoveParent,
/*  1147*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1149*/      OPC_EmitMergeInputChains1_0,
/*  1150*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1153*/      OPC_EmitInteger, MVT::i64, 0, 
/*  1156*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 13
                // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  1167*/     0, /*End of Scope*/
/*  1168*/    0, /*End of Scope*/
/*  1169*/   /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->2091
/*  1173*/    OPC_RecordMemRef,
/*  1174*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1175*/    OPC_Scope, 28|128,4/*540*/, /*->1718*/ // 2 children in Scope
/*  1178*/     OPC_MoveChild1,
/*  1179*/     OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->1349
/*  1184*/      OPC_RecordChild0, // #1 = $addr
/*  1185*/      OPC_RecordChild1, // #2 = $off
/*  1186*/      OPC_MoveChild1,
/*  1187*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  1190*/      OPC_MoveParent,
/*  1191*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  1193*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->1271
/*  1196*/       OPC_MoveParent,
/*  1197*/       OPC_MoveChild2,
/*  1198*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1201*/       OPC_RecordChild0, // #3 = $val
/*  1202*/       OPC_MoveParent,
/*  1203*/       OPC_Scope, 21, /*->1226*/ // 3 children in Scope
/*  1205*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1207*/        OPC_MoveParent,
/*  1208*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1210*/        OPC_EmitMergeInputChains1_0,
/*  1211*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1214*/        OPC_EmitConvertToTarget, 2,
/*  1216*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1226*/       /*Scope*/ 21, /*->1248*/
/*  1227*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1229*/        OPC_MoveParent,
/*  1230*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1232*/        OPC_EmitMergeInputChains1_0,
/*  1233*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1236*/        OPC_EmitConvertToTarget, 2,
/*  1238*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1248*/       /*Scope*/ 21, /*->1270*/
/*  1249*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1251*/        OPC_MoveParent,
/*  1252*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1254*/        OPC_EmitMergeInputChains1_0,
/*  1255*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1258*/        OPC_EmitConvertToTarget, 2,
/*  1260*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1270*/       0, /*End of Scope*/
/*  1271*/      /*SwitchType*/ 75, MVT::i64,// ->1348
/*  1273*/       OPC_MoveParent,
/*  1274*/       OPC_MoveChild2,
/*  1275*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1278*/       OPC_RecordChild0, // #3 = $val
/*  1279*/       OPC_MoveParent,
/*  1280*/       OPC_Scope, 21, /*->1303*/ // 3 children in Scope
/*  1282*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1284*/        OPC_MoveParent,
/*  1285*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1287*/        OPC_EmitMergeInputChains1_0,
/*  1288*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1291*/        OPC_EmitConvertToTarget, 2,
/*  1293*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  1303*/       /*Scope*/ 21, /*->1325*/
/*  1304*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1306*/        OPC_MoveParent,
/*  1307*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1309*/        OPC_EmitMergeInputChains1_0,
/*  1310*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1313*/        OPC_EmitConvertToTarget, 2,
/*  1315*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  1325*/       /*Scope*/ 21, /*->1347*/
/*  1326*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1328*/        OPC_MoveParent,
/*  1329*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1331*/        OPC_EmitMergeInputChains1_0,
/*  1332*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1335*/        OPC_EmitConvertToTarget, 2,
/*  1337*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  1347*/       0, /*End of Scope*/
/*  1348*/      0, // EndSwitchType
/*  1349*/     /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::OR),// ->1518
/*  1353*/      OPC_RecordChild0, // #1 = $addr
/*  1354*/      OPC_RecordChild1, // #2 = $off
/*  1355*/      OPC_MoveChild1,
/*  1356*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  1359*/      OPC_MoveParent,
/*  1360*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  1362*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->1440
/*  1365*/       OPC_MoveParent,
/*  1366*/       OPC_MoveChild2,
/*  1367*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1370*/       OPC_RecordChild0, // #3 = $val
/*  1371*/       OPC_MoveParent,
/*  1372*/       OPC_Scope, 21, /*->1395*/ // 3 children in Scope
/*  1374*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1376*/        OPC_MoveParent,
/*  1377*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1379*/        OPC_EmitMergeInputChains1_0,
/*  1380*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1383*/        OPC_EmitConvertToTarget, 2,
/*  1385*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1395*/       /*Scope*/ 21, /*->1417*/
/*  1396*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1398*/        OPC_MoveParent,
/*  1399*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1401*/        OPC_EmitMergeInputChains1_0,
/*  1402*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1405*/        OPC_EmitConvertToTarget, 2,
/*  1407*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1417*/       /*Scope*/ 21, /*->1439*/
/*  1418*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1420*/        OPC_MoveParent,
/*  1421*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1423*/        OPC_EmitMergeInputChains1_0,
/*  1424*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1427*/        OPC_EmitConvertToTarget, 2,
/*  1429*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1439*/       0, /*End of Scope*/
/*  1440*/      /*SwitchType*/ 75, MVT::i64,// ->1517
/*  1442*/       OPC_MoveParent,
/*  1443*/       OPC_MoveChild2,
/*  1444*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1447*/       OPC_RecordChild0, // #3 = $val
/*  1448*/       OPC_MoveParent,
/*  1449*/       OPC_Scope, 21, /*->1472*/ // 3 children in Scope
/*  1451*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1453*/        OPC_MoveParent,
/*  1454*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1456*/        OPC_EmitMergeInputChains1_0,
/*  1457*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1460*/        OPC_EmitConvertToTarget, 2,
/*  1462*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  1472*/       /*Scope*/ 21, /*->1494*/
/*  1473*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1475*/        OPC_MoveParent,
/*  1476*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1478*/        OPC_EmitMergeInputChains1_0,
/*  1479*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1482*/        OPC_EmitConvertToTarget, 2,
/*  1484*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  1494*/       /*Scope*/ 21, /*->1516*/
/*  1495*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1497*/        OPC_MoveParent,
/*  1498*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1500*/        OPC_EmitMergeInputChains1_0,
/*  1501*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1504*/        OPC_EmitConvertToTarget, 2,
/*  1506*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  1516*/       0, /*End of Scope*/
/*  1517*/      0, // EndSwitchType
/*  1518*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->1717
/*  1522*/      OPC_RecordChild0, // #1 = $off
/*  1523*/      OPC_MoveChild0,
/*  1524*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1527*/      OPC_MoveParent,
/*  1528*/      OPC_MoveParent,
/*  1529*/      OPC_MoveChild2,
/*  1530*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1533*/      OPC_RecordChild0, // #2 = $val
/*  1534*/      OPC_MoveParent,
/*  1535*/      OPC_Scope, 59, /*->1596*/ // 3 children in Scope
/*  1537*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1539*/       OPC_MoveParent,
/*  1540*/       OPC_Scope, 26, /*->1568*/ // 2 children in Scope
/*  1542*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  1544*/        OPC_EmitMergeInputChains1_0,
/*  1545*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1548*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1551*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  1558*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  1568*/       /*Scope*/ 26, /*->1595*/
/*  1569*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  1571*/        OPC_EmitMergeInputChains1_0,
/*  1572*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1575*/        OPC_EmitInteger, MVT::i64, 0, 
/*  1578*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  1585*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  1595*/       0, /*End of Scope*/
/*  1596*/      /*Scope*/ 59, /*->1656*/
/*  1597*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1599*/       OPC_MoveParent,
/*  1600*/       OPC_Scope, 26, /*->1628*/ // 2 children in Scope
/*  1602*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  1604*/        OPC_EmitMergeInputChains1_0,
/*  1605*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1608*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1611*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  1618*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  1628*/       /*Scope*/ 26, /*->1655*/
/*  1629*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  1631*/        OPC_EmitMergeInputChains1_0,
/*  1632*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1635*/        OPC_EmitInteger, MVT::i64, 0, 
/*  1638*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  1645*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  1655*/       0, /*End of Scope*/
/*  1656*/      /*Scope*/ 59, /*->1716*/
/*  1657*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1659*/       OPC_MoveParent,
/*  1660*/       OPC_Scope, 26, /*->1688*/ // 2 children in Scope
/*  1662*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  1664*/        OPC_EmitMergeInputChains1_0,
/*  1665*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1668*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1671*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  1678*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  1688*/       /*Scope*/ 26, /*->1715*/
/*  1689*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  1691*/        OPC_EmitMergeInputChains1_0,
/*  1692*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1695*/        OPC_EmitInteger, MVT::i64, 0, 
/*  1698*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  1705*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  1715*/       0, /*End of Scope*/
/*  1716*/      0, /*End of Scope*/
/*  1717*/     0, // EndSwitchOpcode
/*  1718*/    /*Scope*/ 114|128,2/*370*/, /*->2090*/
/*  1720*/     OPC_RecordChild1, // #1 = $off
/*  1721*/     OPC_Scope, 77|128,1/*205*/, /*->1929*/ // 3 children in Scope
/*  1724*/      OPC_MoveChild1,
/*  1725*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  1728*/      OPC_MoveParent,
/*  1729*/      OPC_MoveChild2,
/*  1730*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1733*/      OPC_RecordChild0, // #2 = $val
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_Scope, 63, /*->1800*/ // 3 children in Scope
/*  1737*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1739*/       OPC_MoveParent,
/*  1740*/       OPC_Scope, 28, /*->1770*/ // 2 children in Scope
/*  1742*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1744*/        OPC_EmitMergeInputChains1_0,
/*  1745*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1748*/        OPC_EmitConvertToTarget, 1,
/*  1750*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1753*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  1760*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  1770*/       /*Scope*/ 28, /*->1799*/
/*  1771*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/        OPC_EmitMergeInputChains1_0,
/*  1774*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1777*/        OPC_EmitConvertToTarget, 1,
/*  1779*/        OPC_EmitInteger, MVT::i64, 0, 
/*  1782*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  1789*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  1799*/       0, /*End of Scope*/
/*  1800*/      /*Scope*/ 63, /*->1864*/
/*  1801*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1803*/       OPC_MoveParent,
/*  1804*/       OPC_Scope, 28, /*->1834*/ // 2 children in Scope
/*  1806*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1808*/        OPC_EmitMergeInputChains1_0,
/*  1809*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1812*/        OPC_EmitConvertToTarget, 1,
/*  1814*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1817*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  1824*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  1834*/       /*Scope*/ 28, /*->1863*/
/*  1835*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1837*/        OPC_EmitMergeInputChains1_0,
/*  1838*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1841*/        OPC_EmitConvertToTarget, 1,
/*  1843*/        OPC_EmitInteger, MVT::i64, 0, 
/*  1846*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  1853*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  1863*/       0, /*End of Scope*/
/*  1864*/      /*Scope*/ 63, /*->1928*/
/*  1865*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1867*/       OPC_MoveParent,
/*  1868*/       OPC_Scope, 28, /*->1898*/ // 2 children in Scope
/*  1870*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1872*/        OPC_EmitMergeInputChains1_0,
/*  1873*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1876*/        OPC_EmitConvertToTarget, 1,
/*  1878*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1881*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  1888*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  1898*/       /*Scope*/ 28, /*->1927*/
/*  1899*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1901*/        OPC_EmitMergeInputChains1_0,
/*  1902*/        OPC_EmitInteger, MVT::i32, 0, 
/*  1905*/        OPC_EmitConvertToTarget, 1,
/*  1907*/        OPC_EmitInteger, MVT::i64, 0, 
/*  1910*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  1917*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  1927*/       0, /*End of Scope*/
/*  1928*/      0, /*End of Scope*/
/*  1929*/     /*Scope*/ 79, /*->2009*/
/*  1930*/      OPC_CheckChild1Type, MVT::i32,
/*  1932*/      OPC_MoveChild2,
/*  1933*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1936*/      OPC_RecordChild0, // #2 = $val
/*  1937*/      OPC_MoveParent,
/*  1938*/      OPC_Scope, 22, /*->1962*/ // 3 children in Scope
/*  1940*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1942*/       OPC_MoveParent,
/*  1943*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1945*/       OPC_EmitMergeInputChains1_0,
/*  1946*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1949*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1952*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1962*/      /*Scope*/ 22, /*->1985*/
/*  1963*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1965*/       OPC_MoveParent,
/*  1966*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1968*/       OPC_EmitMergeInputChains1_0,
/*  1969*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1972*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1975*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1985*/      /*Scope*/ 22, /*->2008*/
/*  1986*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  1988*/       OPC_MoveParent,
/*  1989*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1991*/       OPC_EmitMergeInputChains1_0,
/*  1992*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1995*/       OPC_EmitInteger, MVT::i32, 0, 
/*  1998*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2008*/      0, /*End of Scope*/
/*  2009*/     /*Scope*/ 79, /*->2089*/
/*  2010*/      OPC_CheckChild1Type, MVT::i64,
/*  2012*/      OPC_MoveChild2,
/*  2013*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2016*/      OPC_RecordChild0, // #2 = $val
/*  2017*/      OPC_MoveParent,
/*  2018*/      OPC_Scope, 22, /*->2042*/ // 3 children in Scope
/*  2020*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  2022*/       OPC_MoveParent,
/*  2023*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2025*/       OPC_EmitMergeInputChains1_0,
/*  2026*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2029*/       OPC_EmitInteger, MVT::i64, 0, 
/*  2032*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2042*/      /*Scope*/ 22, /*->2065*/
/*  2043*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  2045*/       OPC_MoveParent,
/*  2046*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2048*/       OPC_EmitMergeInputChains1_0,
/*  2049*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2052*/       OPC_EmitInteger, MVT::i64, 0, 
/*  2055*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2065*/      /*Scope*/ 22, /*->2088*/
/*  2066*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/*  2068*/       OPC_MoveParent,
/*  2069*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2071*/       OPC_EmitMergeInputChains1_0,
/*  2072*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2075*/       OPC_EmitInteger, MVT::i64, 0, 
/*  2078*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2088*/      0, /*End of Scope*/
/*  2089*/     0, /*End of Scope*/
/*  2090*/    0, /*End of Scope*/
/*  2091*/   /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->3013
/*  2095*/    OPC_RecordMemRef,
/*  2096*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  2097*/    OPC_Scope, 28|128,4/*540*/, /*->2640*/ // 2 children in Scope
/*  2100*/     OPC_MoveChild1,
/*  2101*/     OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->2271
/*  2106*/      OPC_RecordChild0, // #1 = $addr
/*  2107*/      OPC_RecordChild1, // #2 = $off
/*  2108*/      OPC_MoveChild1,
/*  2109*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2112*/      OPC_MoveParent,
/*  2113*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  2115*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->2193
/*  2118*/       OPC_MoveParent,
/*  2119*/       OPC_MoveChild2,
/*  2120*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2123*/       OPC_RecordChild0, // #3 = $val
/*  2124*/       OPC_MoveParent,
/*  2125*/       OPC_Scope, 21, /*->2148*/ // 3 children in Scope
/*  2127*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2129*/        OPC_MoveParent,
/*  2130*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2132*/        OPC_EmitMergeInputChains1_0,
/*  2133*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2136*/        OPC_EmitConvertToTarget, 2,
/*  2138*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2148*/       /*Scope*/ 21, /*->2170*/
/*  2149*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2151*/        OPC_MoveParent,
/*  2152*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2154*/        OPC_EmitMergeInputChains1_0,
/*  2155*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2158*/        OPC_EmitConvertToTarget, 2,
/*  2160*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2170*/       /*Scope*/ 21, /*->2192*/
/*  2171*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2173*/        OPC_MoveParent,
/*  2174*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2176*/        OPC_EmitMergeInputChains1_0,
/*  2177*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2180*/        OPC_EmitConvertToTarget, 2,
/*  2182*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2192*/       0, /*End of Scope*/
/*  2193*/      /*SwitchType*/ 75, MVT::i64,// ->2270
/*  2195*/       OPC_MoveParent,
/*  2196*/       OPC_MoveChild2,
/*  2197*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2200*/       OPC_RecordChild0, // #3 = $val
/*  2201*/       OPC_MoveParent,
/*  2202*/       OPC_Scope, 21, /*->2225*/ // 3 children in Scope
/*  2204*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2206*/        OPC_MoveParent,
/*  2207*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2209*/        OPC_EmitMergeInputChains1_0,
/*  2210*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2213*/        OPC_EmitConvertToTarget, 2,
/*  2215*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2225*/       /*Scope*/ 21, /*->2247*/
/*  2226*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2228*/        OPC_MoveParent,
/*  2229*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2231*/        OPC_EmitMergeInputChains1_0,
/*  2232*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2235*/        OPC_EmitConvertToTarget, 2,
/*  2237*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2247*/       /*Scope*/ 21, /*->2269*/
/*  2248*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2250*/        OPC_MoveParent,
/*  2251*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2253*/        OPC_EmitMergeInputChains1_0,
/*  2254*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2257*/        OPC_EmitConvertToTarget, 2,
/*  2259*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2269*/       0, /*End of Scope*/
/*  2270*/      0, // EndSwitchType
/*  2271*/     /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::OR),// ->2440
/*  2275*/      OPC_RecordChild0, // #1 = $addr
/*  2276*/      OPC_RecordChild1, // #2 = $off
/*  2277*/      OPC_MoveChild1,
/*  2278*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2281*/      OPC_MoveParent,
/*  2282*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  2284*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->2362
/*  2287*/       OPC_MoveParent,
/*  2288*/       OPC_MoveChild2,
/*  2289*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2292*/       OPC_RecordChild0, // #3 = $val
/*  2293*/       OPC_MoveParent,
/*  2294*/       OPC_Scope, 21, /*->2317*/ // 3 children in Scope
/*  2296*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2298*/        OPC_MoveParent,
/*  2299*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2301*/        OPC_EmitMergeInputChains1_0,
/*  2302*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2305*/        OPC_EmitConvertToTarget, 2,
/*  2307*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2317*/       /*Scope*/ 21, /*->2339*/
/*  2318*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2320*/        OPC_MoveParent,
/*  2321*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2323*/        OPC_EmitMergeInputChains1_0,
/*  2324*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2327*/        OPC_EmitConvertToTarget, 2,
/*  2329*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2339*/       /*Scope*/ 21, /*->2361*/
/*  2340*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2342*/        OPC_MoveParent,
/*  2343*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2345*/        OPC_EmitMergeInputChains1_0,
/*  2346*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2349*/        OPC_EmitConvertToTarget, 2,
/*  2351*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2361*/       0, /*End of Scope*/
/*  2362*/      /*SwitchType*/ 75, MVT::i64,// ->2439
/*  2364*/       OPC_MoveParent,
/*  2365*/       OPC_MoveChild2,
/*  2366*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2369*/       OPC_RecordChild0, // #3 = $val
/*  2370*/       OPC_MoveParent,
/*  2371*/       OPC_Scope, 21, /*->2394*/ // 3 children in Scope
/*  2373*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2375*/        OPC_MoveParent,
/*  2376*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2378*/        OPC_EmitMergeInputChains1_0,
/*  2379*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2382*/        OPC_EmitConvertToTarget, 2,
/*  2384*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2394*/       /*Scope*/ 21, /*->2416*/
/*  2395*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2397*/        OPC_MoveParent,
/*  2398*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2400*/        OPC_EmitMergeInputChains1_0,
/*  2401*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2404*/        OPC_EmitConvertToTarget, 2,
/*  2406*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2416*/       /*Scope*/ 21, /*->2438*/
/*  2417*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2419*/        OPC_MoveParent,
/*  2420*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2422*/        OPC_EmitMergeInputChains1_0,
/*  2423*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2426*/        OPC_EmitConvertToTarget, 2,
/*  2428*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2438*/       0, /*End of Scope*/
/*  2439*/      0, // EndSwitchType
/*  2440*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->2639
/*  2444*/      OPC_RecordChild0, // #1 = $off
/*  2445*/      OPC_MoveChild0,
/*  2446*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  2449*/      OPC_MoveParent,
/*  2450*/      OPC_MoveParent,
/*  2451*/      OPC_MoveChild2,
/*  2452*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2455*/      OPC_RecordChild0, // #2 = $val
/*  2456*/      OPC_MoveParent,
/*  2457*/      OPC_Scope, 59, /*->2518*/ // 3 children in Scope
/*  2459*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2461*/       OPC_MoveParent,
/*  2462*/       OPC_Scope, 26, /*->2490*/ // 2 children in Scope
/*  2464*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  2466*/        OPC_EmitMergeInputChains1_0,
/*  2467*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2470*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2473*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  2480*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  2490*/       /*Scope*/ 26, /*->2517*/
/*  2491*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  2493*/        OPC_EmitMergeInputChains1_0,
/*  2494*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2497*/        OPC_EmitInteger, MVT::i64, 0, 
/*  2500*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  2507*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  2517*/       0, /*End of Scope*/
/*  2518*/      /*Scope*/ 59, /*->2578*/
/*  2519*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2521*/       OPC_MoveParent,
/*  2522*/       OPC_Scope, 26, /*->2550*/ // 2 children in Scope
/*  2524*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  2526*/        OPC_EmitMergeInputChains1_0,
/*  2527*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2530*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2533*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  2540*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  2550*/       /*Scope*/ 26, /*->2577*/
/*  2551*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  2553*/        OPC_EmitMergeInputChains1_0,
/*  2554*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2557*/        OPC_EmitInteger, MVT::i64, 0, 
/*  2560*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  2567*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  2577*/       0, /*End of Scope*/
/*  2578*/      /*Scope*/ 59, /*->2638*/
/*  2579*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2581*/       OPC_MoveParent,
/*  2582*/       OPC_Scope, 26, /*->2610*/ // 2 children in Scope
/*  2584*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  2586*/        OPC_EmitMergeInputChains1_0,
/*  2587*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2590*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2593*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  2600*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  2610*/       /*Scope*/ 26, /*->2637*/
/*  2611*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  2613*/        OPC_EmitMergeInputChains1_0,
/*  2614*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2617*/        OPC_EmitInteger, MVT::i64, 0, 
/*  2620*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  2627*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  2637*/       0, /*End of Scope*/
/*  2638*/      0, /*End of Scope*/
/*  2639*/     0, // EndSwitchOpcode
/*  2640*/    /*Scope*/ 114|128,2/*370*/, /*->3012*/
/*  2642*/     OPC_RecordChild1, // #1 = $off
/*  2643*/     OPC_Scope, 77|128,1/*205*/, /*->2851*/ // 3 children in Scope
/*  2646*/      OPC_MoveChild1,
/*  2647*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2650*/      OPC_MoveParent,
/*  2651*/      OPC_MoveChild2,
/*  2652*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2655*/      OPC_RecordChild0, // #2 = $val
/*  2656*/      OPC_MoveParent,
/*  2657*/      OPC_Scope, 63, /*->2722*/ // 3 children in Scope
/*  2659*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2661*/       OPC_MoveParent,
/*  2662*/       OPC_Scope, 28, /*->2692*/ // 2 children in Scope
/*  2664*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2666*/        OPC_EmitMergeInputChains1_0,
/*  2667*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2670*/        OPC_EmitConvertToTarget, 1,
/*  2672*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2675*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  2682*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  2692*/       /*Scope*/ 28, /*->2721*/
/*  2693*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2695*/        OPC_EmitMergeInputChains1_0,
/*  2696*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2699*/        OPC_EmitConvertToTarget, 1,
/*  2701*/        OPC_EmitInteger, MVT::i64, 0, 
/*  2704*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  2711*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  2721*/       0, /*End of Scope*/
/*  2722*/      /*Scope*/ 63, /*->2786*/
/*  2723*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2725*/       OPC_MoveParent,
/*  2726*/       OPC_Scope, 28, /*->2756*/ // 2 children in Scope
/*  2728*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2730*/        OPC_EmitMergeInputChains1_0,
/*  2731*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2734*/        OPC_EmitConvertToTarget, 1,
/*  2736*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2739*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  2746*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  2756*/       /*Scope*/ 28, /*->2785*/
/*  2757*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2759*/        OPC_EmitMergeInputChains1_0,
/*  2760*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2763*/        OPC_EmitConvertToTarget, 1,
/*  2765*/        OPC_EmitInteger, MVT::i64, 0, 
/*  2768*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  2775*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  2785*/       0, /*End of Scope*/
/*  2786*/      /*Scope*/ 63, /*->2850*/
/*  2787*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2789*/       OPC_MoveParent,
/*  2790*/       OPC_Scope, 28, /*->2820*/ // 2 children in Scope
/*  2792*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2794*/        OPC_EmitMergeInputChains1_0,
/*  2795*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2798*/        OPC_EmitConvertToTarget, 1,
/*  2800*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2803*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  2810*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  2820*/       /*Scope*/ 28, /*->2849*/
/*  2821*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2823*/        OPC_EmitMergeInputChains1_0,
/*  2824*/        OPC_EmitInteger, MVT::i32, 0, 
/*  2827*/        OPC_EmitConvertToTarget, 1,
/*  2829*/        OPC_EmitInteger, MVT::i64, 0, 
/*  2832*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  2839*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  2849*/       0, /*End of Scope*/
/*  2850*/      0, /*End of Scope*/
/*  2851*/     /*Scope*/ 79, /*->2931*/
/*  2852*/      OPC_CheckChild1Type, MVT::i32,
/*  2854*/      OPC_MoveChild2,
/*  2855*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2858*/      OPC_RecordChild0, // #2 = $val
/*  2859*/      OPC_MoveParent,
/*  2860*/      OPC_Scope, 22, /*->2884*/ // 3 children in Scope
/*  2862*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2864*/       OPC_MoveParent,
/*  2865*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2867*/       OPC_EmitMergeInputChains1_0,
/*  2868*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2871*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2874*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2884*/      /*Scope*/ 22, /*->2907*/
/*  2885*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2887*/       OPC_MoveParent,
/*  2888*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2890*/       OPC_EmitMergeInputChains1_0,
/*  2891*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2894*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2897*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2907*/      /*Scope*/ 22, /*->2930*/
/*  2908*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2910*/       OPC_MoveParent,
/*  2911*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2913*/       OPC_EmitMergeInputChains1_0,
/*  2914*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2917*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2920*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2930*/      0, /*End of Scope*/
/*  2931*/     /*Scope*/ 79, /*->3011*/
/*  2932*/      OPC_CheckChild1Type, MVT::i64,
/*  2934*/      OPC_MoveChild2,
/*  2935*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2938*/      OPC_RecordChild0, // #2 = $val
/*  2939*/      OPC_MoveParent,
/*  2940*/      OPC_Scope, 22, /*->2964*/ // 3 children in Scope
/*  2942*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2944*/       OPC_MoveParent,
/*  2945*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2947*/       OPC_EmitMergeInputChains1_0,
/*  2948*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2951*/       OPC_EmitInteger, MVT::i64, 0, 
/*  2954*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2964*/      /*Scope*/ 22, /*->2987*/
/*  2965*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2967*/       OPC_MoveParent,
/*  2968*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2970*/       OPC_EmitMergeInputChains1_0,
/*  2971*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2974*/       OPC_EmitInteger, MVT::i64, 0, 
/*  2977*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2987*/      /*Scope*/ 22, /*->3010*/
/*  2988*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/*  2990*/       OPC_MoveParent,
/*  2991*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2993*/       OPC_EmitMergeInputChains1_0,
/*  2994*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2997*/       OPC_EmitInteger, MVT::i64, 0, 
/*  3000*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3010*/      0, /*End of Scope*/
/*  3011*/     0, /*End of Scope*/
/*  3012*/    0, /*End of Scope*/
/*  3013*/   /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->3935
/*  3017*/    OPC_RecordMemRef,
/*  3018*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  3019*/    OPC_Scope, 28|128,4/*540*/, /*->3562*/ // 2 children in Scope
/*  3022*/     OPC_MoveChild1,
/*  3023*/     OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->3193
/*  3028*/      OPC_RecordChild0, // #1 = $addr
/*  3029*/      OPC_RecordChild1, // #2 = $off
/*  3030*/      OPC_MoveChild1,
/*  3031*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3034*/      OPC_MoveParent,
/*  3035*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  3037*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->3115
/*  3040*/       OPC_MoveParent,
/*  3041*/       OPC_MoveChild2,
/*  3042*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3045*/       OPC_RecordChild0, // #3 = $val
/*  3046*/       OPC_MoveParent,
/*  3047*/       OPC_Scope, 21, /*->3070*/ // 3 children in Scope
/*  3049*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3051*/        OPC_MoveParent,
/*  3052*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3054*/        OPC_EmitMergeInputChains1_0,
/*  3055*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3058*/        OPC_EmitConvertToTarget, 2,
/*  3060*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3070*/       /*Scope*/ 21, /*->3092*/
/*  3071*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3073*/        OPC_MoveParent,
/*  3074*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3076*/        OPC_EmitMergeInputChains1_0,
/*  3077*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3080*/        OPC_EmitConvertToTarget, 2,
/*  3082*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3092*/       /*Scope*/ 21, /*->3114*/
/*  3093*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3095*/        OPC_MoveParent,
/*  3096*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3098*/        OPC_EmitMergeInputChains1_0,
/*  3099*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3102*/        OPC_EmitConvertToTarget, 2,
/*  3104*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3114*/       0, /*End of Scope*/
/*  3115*/      /*SwitchType*/ 75, MVT::i64,// ->3192
/*  3117*/       OPC_MoveParent,
/*  3118*/       OPC_MoveChild2,
/*  3119*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3122*/       OPC_RecordChild0, // #3 = $val
/*  3123*/       OPC_MoveParent,
/*  3124*/       OPC_Scope, 21, /*->3147*/ // 3 children in Scope
/*  3126*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3128*/        OPC_MoveParent,
/*  3129*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3131*/        OPC_EmitMergeInputChains1_0,
/*  3132*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3135*/        OPC_EmitConvertToTarget, 2,
/*  3137*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3147*/       /*Scope*/ 21, /*->3169*/
/*  3148*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3150*/        OPC_MoveParent,
/*  3151*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3153*/        OPC_EmitMergeInputChains1_0,
/*  3154*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3157*/        OPC_EmitConvertToTarget, 2,
/*  3159*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3169*/       /*Scope*/ 21, /*->3191*/
/*  3170*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3172*/        OPC_MoveParent,
/*  3173*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3175*/        OPC_EmitMergeInputChains1_0,
/*  3176*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3179*/        OPC_EmitConvertToTarget, 2,
/*  3181*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3191*/       0, /*End of Scope*/
/*  3192*/      0, // EndSwitchType
/*  3193*/     /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::OR),// ->3362
/*  3197*/      OPC_RecordChild0, // #1 = $addr
/*  3198*/      OPC_RecordChild1, // #2 = $off
/*  3199*/      OPC_MoveChild1,
/*  3200*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3203*/      OPC_MoveParent,
/*  3204*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  3206*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->3284
/*  3209*/       OPC_MoveParent,
/*  3210*/       OPC_MoveChild2,
/*  3211*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3214*/       OPC_RecordChild0, // #3 = $val
/*  3215*/       OPC_MoveParent,
/*  3216*/       OPC_Scope, 21, /*->3239*/ // 3 children in Scope
/*  3218*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3220*/        OPC_MoveParent,
/*  3221*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3223*/        OPC_EmitMergeInputChains1_0,
/*  3224*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3227*/        OPC_EmitConvertToTarget, 2,
/*  3229*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3239*/       /*Scope*/ 21, /*->3261*/
/*  3240*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3242*/        OPC_MoveParent,
/*  3243*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3245*/        OPC_EmitMergeInputChains1_0,
/*  3246*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3249*/        OPC_EmitConvertToTarget, 2,
/*  3251*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3261*/       /*Scope*/ 21, /*->3283*/
/*  3262*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3264*/        OPC_MoveParent,
/*  3265*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3267*/        OPC_EmitMergeInputChains1_0,
/*  3268*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3271*/        OPC_EmitConvertToTarget, 2,
/*  3273*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3283*/       0, /*End of Scope*/
/*  3284*/      /*SwitchType*/ 75, MVT::i64,// ->3361
/*  3286*/       OPC_MoveParent,
/*  3287*/       OPC_MoveChild2,
/*  3288*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3291*/       OPC_RecordChild0, // #3 = $val
/*  3292*/       OPC_MoveParent,
/*  3293*/       OPC_Scope, 21, /*->3316*/ // 3 children in Scope
/*  3295*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3297*/        OPC_MoveParent,
/*  3298*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3300*/        OPC_EmitMergeInputChains1_0,
/*  3301*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3304*/        OPC_EmitConvertToTarget, 2,
/*  3306*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3316*/       /*Scope*/ 21, /*->3338*/
/*  3317*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3319*/        OPC_MoveParent,
/*  3320*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3322*/        OPC_EmitMergeInputChains1_0,
/*  3323*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3326*/        OPC_EmitConvertToTarget, 2,
/*  3328*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3338*/       /*Scope*/ 21, /*->3360*/
/*  3339*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3341*/        OPC_MoveParent,
/*  3342*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3344*/        OPC_EmitMergeInputChains1_0,
/*  3345*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3348*/        OPC_EmitConvertToTarget, 2,
/*  3350*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3360*/       0, /*End of Scope*/
/*  3361*/      0, // EndSwitchType
/*  3362*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->3561
/*  3366*/      OPC_RecordChild0, // #1 = $off
/*  3367*/      OPC_MoveChild0,
/*  3368*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3371*/      OPC_MoveParent,
/*  3372*/      OPC_MoveParent,
/*  3373*/      OPC_MoveChild2,
/*  3374*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3377*/      OPC_RecordChild0, // #2 = $val
/*  3378*/      OPC_MoveParent,
/*  3379*/      OPC_Scope, 59, /*->3440*/ // 3 children in Scope
/*  3381*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3383*/       OPC_MoveParent,
/*  3384*/       OPC_Scope, 26, /*->3412*/ // 2 children in Scope
/*  3386*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  3388*/        OPC_EmitMergeInputChains1_0,
/*  3389*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3392*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3395*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  3402*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  3412*/       /*Scope*/ 26, /*->3439*/
/*  3413*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  3415*/        OPC_EmitMergeInputChains1_0,
/*  3416*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3419*/        OPC_EmitInteger, MVT::i64, 0, 
/*  3422*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  3429*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  3439*/       0, /*End of Scope*/
/*  3440*/      /*Scope*/ 59, /*->3500*/
/*  3441*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3443*/       OPC_MoveParent,
/*  3444*/       OPC_Scope, 26, /*->3472*/ // 2 children in Scope
/*  3446*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  3448*/        OPC_EmitMergeInputChains1_0,
/*  3449*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3452*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3455*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  3462*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  3472*/       /*Scope*/ 26, /*->3499*/
/*  3473*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  3475*/        OPC_EmitMergeInputChains1_0,
/*  3476*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3479*/        OPC_EmitInteger, MVT::i64, 0, 
/*  3482*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  3489*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  3499*/       0, /*End of Scope*/
/*  3500*/      /*Scope*/ 59, /*->3560*/
/*  3501*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3503*/       OPC_MoveParent,
/*  3504*/       OPC_Scope, 26, /*->3532*/ // 2 children in Scope
/*  3506*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  3508*/        OPC_EmitMergeInputChains1_0,
/*  3509*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3512*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3515*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  3522*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  3532*/       /*Scope*/ 26, /*->3559*/
/*  3533*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  3535*/        OPC_EmitMergeInputChains1_0,
/*  3536*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3539*/        OPC_EmitInteger, MVT::i64, 0, 
/*  3542*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  3549*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  3559*/       0, /*End of Scope*/
/*  3560*/      0, /*End of Scope*/
/*  3561*/     0, // EndSwitchOpcode
/*  3562*/    /*Scope*/ 114|128,2/*370*/, /*->3934*/
/*  3564*/     OPC_RecordChild1, // #1 = $off
/*  3565*/     OPC_Scope, 77|128,1/*205*/, /*->3773*/ // 3 children in Scope
/*  3568*/      OPC_MoveChild1,
/*  3569*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3572*/      OPC_MoveParent,
/*  3573*/      OPC_MoveChild2,
/*  3574*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3577*/      OPC_RecordChild0, // #2 = $val
/*  3578*/      OPC_MoveParent,
/*  3579*/      OPC_Scope, 63, /*->3644*/ // 3 children in Scope
/*  3581*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3583*/       OPC_MoveParent,
/*  3584*/       OPC_Scope, 28, /*->3614*/ // 2 children in Scope
/*  3586*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3588*/        OPC_EmitMergeInputChains1_0,
/*  3589*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3592*/        OPC_EmitConvertToTarget, 1,
/*  3594*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3597*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  3604*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  3614*/       /*Scope*/ 28, /*->3643*/
/*  3615*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3617*/        OPC_EmitMergeInputChains1_0,
/*  3618*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3621*/        OPC_EmitConvertToTarget, 1,
/*  3623*/        OPC_EmitInteger, MVT::i64, 0, 
/*  3626*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  3633*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  3643*/       0, /*End of Scope*/
/*  3644*/      /*Scope*/ 63, /*->3708*/
/*  3645*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3647*/       OPC_MoveParent,
/*  3648*/       OPC_Scope, 28, /*->3678*/ // 2 children in Scope
/*  3650*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3652*/        OPC_EmitMergeInputChains1_0,
/*  3653*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3656*/        OPC_EmitConvertToTarget, 1,
/*  3658*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3661*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  3668*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  3678*/       /*Scope*/ 28, /*->3707*/
/*  3679*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3681*/        OPC_EmitMergeInputChains1_0,
/*  3682*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3685*/        OPC_EmitConvertToTarget, 1,
/*  3687*/        OPC_EmitInteger, MVT::i64, 0, 
/*  3690*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  3697*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  3707*/       0, /*End of Scope*/
/*  3708*/      /*Scope*/ 63, /*->3772*/
/*  3709*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3711*/       OPC_MoveParent,
/*  3712*/       OPC_Scope, 28, /*->3742*/ // 2 children in Scope
/*  3714*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3716*/        OPC_EmitMergeInputChains1_0,
/*  3717*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3720*/        OPC_EmitConvertToTarget, 1,
/*  3722*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3725*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  3732*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  3742*/       /*Scope*/ 28, /*->3771*/
/*  3743*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3745*/        OPC_EmitMergeInputChains1_0,
/*  3746*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3749*/        OPC_EmitConvertToTarget, 1,
/*  3751*/        OPC_EmitInteger, MVT::i64, 0, 
/*  3754*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  3761*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  3771*/       0, /*End of Scope*/
/*  3772*/      0, /*End of Scope*/
/*  3773*/     /*Scope*/ 79, /*->3853*/
/*  3774*/      OPC_CheckChild1Type, MVT::i32,
/*  3776*/      OPC_MoveChild2,
/*  3777*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3780*/      OPC_RecordChild0, // #2 = $val
/*  3781*/      OPC_MoveParent,
/*  3782*/      OPC_Scope, 22, /*->3806*/ // 3 children in Scope
/*  3784*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3786*/       OPC_MoveParent,
/*  3787*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3789*/       OPC_EmitMergeInputChains1_0,
/*  3790*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3793*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3796*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3806*/      /*Scope*/ 22, /*->3829*/
/*  3807*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3809*/       OPC_MoveParent,
/*  3810*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3812*/       OPC_EmitMergeInputChains1_0,
/*  3813*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3816*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3819*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3829*/      /*Scope*/ 22, /*->3852*/
/*  3830*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3832*/       OPC_MoveParent,
/*  3833*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3835*/       OPC_EmitMergeInputChains1_0,
/*  3836*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3839*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3842*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3852*/      0, /*End of Scope*/
/*  3853*/     /*Scope*/ 79, /*->3933*/
/*  3854*/      OPC_CheckChild1Type, MVT::i64,
/*  3856*/      OPC_MoveChild2,
/*  3857*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3860*/      OPC_RecordChild0, // #2 = $val
/*  3861*/      OPC_MoveParent,
/*  3862*/      OPC_Scope, 22, /*->3886*/ // 3 children in Scope
/*  3864*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3866*/       OPC_MoveParent,
/*  3867*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3869*/       OPC_EmitMergeInputChains1_0,
/*  3870*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3873*/       OPC_EmitInteger, MVT::i64, 0, 
/*  3876*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3886*/      /*Scope*/ 22, /*->3909*/
/*  3887*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3889*/       OPC_MoveParent,
/*  3890*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3892*/       OPC_EmitMergeInputChains1_0,
/*  3893*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3896*/       OPC_EmitInteger, MVT::i64, 0, 
/*  3899*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3909*/      /*Scope*/ 22, /*->3932*/
/*  3910*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/*  3912*/       OPC_MoveParent,
/*  3913*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3915*/       OPC_EmitMergeInputChains1_0,
/*  3916*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3919*/       OPC_EmitInteger, MVT::i64, 0, 
/*  3922*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3932*/      0, /*End of Scope*/
/*  3933*/     0, /*End of Scope*/
/*  3934*/    0, /*End of Scope*/
/*  3935*/   /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->4857
/*  3939*/    OPC_RecordMemRef,
/*  3940*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  3941*/    OPC_Scope, 28|128,4/*540*/, /*->4484*/ // 2 children in Scope
/*  3944*/     OPC_MoveChild1,
/*  3945*/     OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->4115
/*  3950*/      OPC_RecordChild0, // #1 = $addr
/*  3951*/      OPC_RecordChild1, // #2 = $off
/*  3952*/      OPC_MoveChild1,
/*  3953*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3956*/      OPC_MoveParent,
/*  3957*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  3959*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->4037
/*  3962*/       OPC_MoveParent,
/*  3963*/       OPC_MoveChild2,
/*  3964*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3967*/       OPC_RecordChild0, // #3 = $val
/*  3968*/       OPC_MoveParent,
/*  3969*/       OPC_Scope, 21, /*->3992*/ // 3 children in Scope
/*  3971*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  3973*/        OPC_MoveParent,
/*  3974*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3976*/        OPC_EmitMergeInputChains1_0,
/*  3977*/        OPC_EmitInteger, MVT::i32, 0, 
/*  3980*/        OPC_EmitConvertToTarget, 2,
/*  3982*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3992*/       /*Scope*/ 21, /*->4014*/
/*  3993*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  3995*/        OPC_MoveParent,
/*  3996*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3998*/        OPC_EmitMergeInputChains1_0,
/*  3999*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4002*/        OPC_EmitConvertToTarget, 2,
/*  4004*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4014*/       /*Scope*/ 21, /*->4036*/
/*  4015*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4017*/        OPC_MoveParent,
/*  4018*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4020*/        OPC_EmitMergeInputChains1_0,
/*  4021*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4024*/        OPC_EmitConvertToTarget, 2,
/*  4026*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4036*/       0, /*End of Scope*/
/*  4037*/      /*SwitchType*/ 75, MVT::i64,// ->4114
/*  4039*/       OPC_MoveParent,
/*  4040*/       OPC_MoveChild2,
/*  4041*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4044*/       OPC_RecordChild0, // #3 = $val
/*  4045*/       OPC_MoveParent,
/*  4046*/       OPC_Scope, 21, /*->4069*/ // 3 children in Scope
/*  4048*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4050*/        OPC_MoveParent,
/*  4051*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4053*/        OPC_EmitMergeInputChains1_0,
/*  4054*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4057*/        OPC_EmitConvertToTarget, 2,
/*  4059*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4069*/       /*Scope*/ 21, /*->4091*/
/*  4070*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4072*/        OPC_MoveParent,
/*  4073*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4075*/        OPC_EmitMergeInputChains1_0,
/*  4076*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4079*/        OPC_EmitConvertToTarget, 2,
/*  4081*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4091*/       /*Scope*/ 21, /*->4113*/
/*  4092*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4094*/        OPC_MoveParent,
/*  4095*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4097*/        OPC_EmitMergeInputChains1_0,
/*  4098*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4101*/        OPC_EmitConvertToTarget, 2,
/*  4103*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4113*/       0, /*End of Scope*/
/*  4114*/      0, // EndSwitchType
/*  4115*/     /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::OR),// ->4284
/*  4119*/      OPC_RecordChild0, // #1 = $addr
/*  4120*/      OPC_RecordChild1, // #2 = $off
/*  4121*/      OPC_MoveChild1,
/*  4122*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4125*/      OPC_MoveParent,
/*  4126*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  4128*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->4206
/*  4131*/       OPC_MoveParent,
/*  4132*/       OPC_MoveChild2,
/*  4133*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4136*/       OPC_RecordChild0, // #3 = $val
/*  4137*/       OPC_MoveParent,
/*  4138*/       OPC_Scope, 21, /*->4161*/ // 3 children in Scope
/*  4140*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4142*/        OPC_MoveParent,
/*  4143*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4145*/        OPC_EmitMergeInputChains1_0,
/*  4146*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4149*/        OPC_EmitConvertToTarget, 2,
/*  4151*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4161*/       /*Scope*/ 21, /*->4183*/
/*  4162*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4164*/        OPC_MoveParent,
/*  4165*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4167*/        OPC_EmitMergeInputChains1_0,
/*  4168*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4171*/        OPC_EmitConvertToTarget, 2,
/*  4173*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4183*/       /*Scope*/ 21, /*->4205*/
/*  4184*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4186*/        OPC_MoveParent,
/*  4187*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4189*/        OPC_EmitMergeInputChains1_0,
/*  4190*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4193*/        OPC_EmitConvertToTarget, 2,
/*  4195*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4205*/       0, /*End of Scope*/
/*  4206*/      /*SwitchType*/ 75, MVT::i64,// ->4283
/*  4208*/       OPC_MoveParent,
/*  4209*/       OPC_MoveChild2,
/*  4210*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4213*/       OPC_RecordChild0, // #3 = $val
/*  4214*/       OPC_MoveParent,
/*  4215*/       OPC_Scope, 21, /*->4238*/ // 3 children in Scope
/*  4217*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4219*/        OPC_MoveParent,
/*  4220*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4222*/        OPC_EmitMergeInputChains1_0,
/*  4223*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4226*/        OPC_EmitConvertToTarget, 2,
/*  4228*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4238*/       /*Scope*/ 21, /*->4260*/
/*  4239*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4241*/        OPC_MoveParent,
/*  4242*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4244*/        OPC_EmitMergeInputChains1_0,
/*  4245*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4248*/        OPC_EmitConvertToTarget, 2,
/*  4250*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4260*/       /*Scope*/ 21, /*->4282*/
/*  4261*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4263*/        OPC_MoveParent,
/*  4264*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4266*/        OPC_EmitMergeInputChains1_0,
/*  4267*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4270*/        OPC_EmitConvertToTarget, 2,
/*  4272*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4282*/       0, /*End of Scope*/
/*  4283*/      0, // EndSwitchType
/*  4284*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->4483
/*  4288*/      OPC_RecordChild0, // #1 = $off
/*  4289*/      OPC_MoveChild0,
/*  4290*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4293*/      OPC_MoveParent,
/*  4294*/      OPC_MoveParent,
/*  4295*/      OPC_MoveChild2,
/*  4296*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4299*/      OPC_RecordChild0, // #2 = $val
/*  4300*/      OPC_MoveParent,
/*  4301*/      OPC_Scope, 59, /*->4362*/ // 3 children in Scope
/*  4303*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4305*/       OPC_MoveParent,
/*  4306*/       OPC_Scope, 26, /*->4334*/ // 2 children in Scope
/*  4308*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  4310*/        OPC_EmitMergeInputChains1_0,
/*  4311*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4314*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4317*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  4324*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4334*/       /*Scope*/ 26, /*->4361*/
/*  4335*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  4337*/        OPC_EmitMergeInputChains1_0,
/*  4338*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4341*/        OPC_EmitInteger, MVT::i64, 0, 
/*  4344*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  4351*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  4361*/       0, /*End of Scope*/
/*  4362*/      /*Scope*/ 59, /*->4422*/
/*  4363*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4365*/       OPC_MoveParent,
/*  4366*/       OPC_Scope, 26, /*->4394*/ // 2 children in Scope
/*  4368*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  4370*/        OPC_EmitMergeInputChains1_0,
/*  4371*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4374*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4377*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  4384*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4394*/       /*Scope*/ 26, /*->4421*/
/*  4395*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  4397*/        OPC_EmitMergeInputChains1_0,
/*  4398*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4401*/        OPC_EmitInteger, MVT::i64, 0, 
/*  4404*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  4411*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  4421*/       0, /*End of Scope*/
/*  4422*/      /*Scope*/ 59, /*->4482*/
/*  4423*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4425*/       OPC_MoveParent,
/*  4426*/       OPC_Scope, 26, /*->4454*/ // 2 children in Scope
/*  4428*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  4430*/        OPC_EmitMergeInputChains1_0,
/*  4431*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4434*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4437*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  4444*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4454*/       /*Scope*/ 26, /*->4481*/
/*  4455*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  4457*/        OPC_EmitMergeInputChains1_0,
/*  4458*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4461*/        OPC_EmitInteger, MVT::i64, 0, 
/*  4464*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  4471*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  4481*/       0, /*End of Scope*/
/*  4482*/      0, /*End of Scope*/
/*  4483*/     0, // EndSwitchOpcode
/*  4484*/    /*Scope*/ 114|128,2/*370*/, /*->4856*/
/*  4486*/     OPC_RecordChild1, // #1 = $off
/*  4487*/     OPC_Scope, 77|128,1/*205*/, /*->4695*/ // 3 children in Scope
/*  4490*/      OPC_MoveChild1,
/*  4491*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4494*/      OPC_MoveParent,
/*  4495*/      OPC_MoveChild2,
/*  4496*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4499*/      OPC_RecordChild0, // #2 = $val
/*  4500*/      OPC_MoveParent,
/*  4501*/      OPC_Scope, 63, /*->4566*/ // 3 children in Scope
/*  4503*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4505*/       OPC_MoveParent,
/*  4506*/       OPC_Scope, 28, /*->4536*/ // 2 children in Scope
/*  4508*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4510*/        OPC_EmitMergeInputChains1_0,
/*  4511*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4514*/        OPC_EmitConvertToTarget, 1,
/*  4516*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4519*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  4526*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4536*/       /*Scope*/ 28, /*->4565*/
/*  4537*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4539*/        OPC_EmitMergeInputChains1_0,
/*  4540*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4543*/        OPC_EmitConvertToTarget, 1,
/*  4545*/        OPC_EmitInteger, MVT::i64, 0, 
/*  4548*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  4555*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  4565*/       0, /*End of Scope*/
/*  4566*/      /*Scope*/ 63, /*->4630*/
/*  4567*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4569*/       OPC_MoveParent,
/*  4570*/       OPC_Scope, 28, /*->4600*/ // 2 children in Scope
/*  4572*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4574*/        OPC_EmitMergeInputChains1_0,
/*  4575*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4578*/        OPC_EmitConvertToTarget, 1,
/*  4580*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4583*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  4590*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4600*/       /*Scope*/ 28, /*->4629*/
/*  4601*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4603*/        OPC_EmitMergeInputChains1_0,
/*  4604*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4607*/        OPC_EmitConvertToTarget, 1,
/*  4609*/        OPC_EmitInteger, MVT::i64, 0, 
/*  4612*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  4619*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  4629*/       0, /*End of Scope*/
/*  4630*/      /*Scope*/ 63, /*->4694*/
/*  4631*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4633*/       OPC_MoveParent,
/*  4634*/       OPC_Scope, 28, /*->4664*/ // 2 children in Scope
/*  4636*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4638*/        OPC_EmitMergeInputChains1_0,
/*  4639*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4642*/        OPC_EmitConvertToTarget, 1,
/*  4644*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4647*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  4654*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4664*/       /*Scope*/ 28, /*->4693*/
/*  4665*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4667*/        OPC_EmitMergeInputChains1_0,
/*  4668*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4671*/        OPC_EmitConvertToTarget, 1,
/*  4673*/        OPC_EmitInteger, MVT::i64, 0, 
/*  4676*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  4683*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  4693*/       0, /*End of Scope*/
/*  4694*/      0, /*End of Scope*/
/*  4695*/     /*Scope*/ 79, /*->4775*/
/*  4696*/      OPC_CheckChild1Type, MVT::i32,
/*  4698*/      OPC_MoveChild2,
/*  4699*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4702*/      OPC_RecordChild0, // #2 = $val
/*  4703*/      OPC_MoveParent,
/*  4704*/      OPC_Scope, 22, /*->4728*/ // 3 children in Scope
/*  4706*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4708*/       OPC_MoveParent,
/*  4709*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4711*/       OPC_EmitMergeInputChains1_0,
/*  4712*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4715*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4718*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4728*/      /*Scope*/ 22, /*->4751*/
/*  4729*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4731*/       OPC_MoveParent,
/*  4732*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4734*/       OPC_EmitMergeInputChains1_0,
/*  4735*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4738*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4741*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4751*/      /*Scope*/ 22, /*->4774*/
/*  4752*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4754*/       OPC_MoveParent,
/*  4755*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4757*/       OPC_EmitMergeInputChains1_0,
/*  4758*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4761*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4764*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4774*/      0, /*End of Scope*/
/*  4775*/     /*Scope*/ 79, /*->4855*/
/*  4776*/      OPC_CheckChild1Type, MVT::i64,
/*  4778*/      OPC_MoveChild2,
/*  4779*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4782*/      OPC_RecordChild0, // #2 = $val
/*  4783*/      OPC_MoveParent,
/*  4784*/      OPC_Scope, 22, /*->4808*/ // 3 children in Scope
/*  4786*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  4788*/       OPC_MoveParent,
/*  4789*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4791*/       OPC_EmitMergeInputChains1_0,
/*  4792*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4795*/       OPC_EmitInteger, MVT::i64, 0, 
/*  4798*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4808*/      /*Scope*/ 22, /*->4831*/
/*  4809*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4811*/       OPC_MoveParent,
/*  4812*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4814*/       OPC_EmitMergeInputChains1_0,
/*  4815*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4818*/       OPC_EmitInteger, MVT::i64, 0, 
/*  4821*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4831*/      /*Scope*/ 22, /*->4854*/
/*  4832*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/*  4834*/       OPC_MoveParent,
/*  4835*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4837*/       OPC_EmitMergeInputChains1_0,
/*  4838*/       OPC_EmitInteger, MVT::i32, 0, 
/*  4841*/       OPC_EmitInteger, MVT::i64, 0, 
/*  4844*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4854*/      0, /*End of Scope*/
/*  4855*/     0, /*End of Scope*/
/*  4856*/    0, /*End of Scope*/
/*  4857*/   /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->5779
/*  4861*/    OPC_RecordMemRef,
/*  4862*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  4863*/    OPC_Scope, 28|128,4/*540*/, /*->5406*/ // 2 children in Scope
/*  4866*/     OPC_MoveChild1,
/*  4867*/     OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->5037
/*  4872*/      OPC_RecordChild0, // #1 = $addr
/*  4873*/      OPC_RecordChild1, // #2 = $off
/*  4874*/      OPC_MoveChild1,
/*  4875*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4878*/      OPC_MoveParent,
/*  4879*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  4881*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->4959
/*  4884*/       OPC_MoveParent,
/*  4885*/       OPC_MoveChild2,
/*  4886*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4889*/       OPC_RecordChild0, // #3 = $val
/*  4890*/       OPC_MoveParent,
/*  4891*/       OPC_Scope, 21, /*->4914*/ // 3 children in Scope
/*  4893*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  4895*/        OPC_MoveParent,
/*  4896*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4898*/        OPC_EmitMergeInputChains1_0,
/*  4899*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4902*/        OPC_EmitConvertToTarget, 2,
/*  4904*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4914*/       /*Scope*/ 21, /*->4936*/
/*  4915*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  4917*/        OPC_MoveParent,
/*  4918*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4920*/        OPC_EmitMergeInputChains1_0,
/*  4921*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4924*/        OPC_EmitConvertToTarget, 2,
/*  4926*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4936*/       /*Scope*/ 21, /*->4958*/
/*  4937*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  4939*/        OPC_MoveParent,
/*  4940*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4942*/        OPC_EmitMergeInputChains1_0,
/*  4943*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4946*/        OPC_EmitConvertToTarget, 2,
/*  4948*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4958*/       0, /*End of Scope*/
/*  4959*/      /*SwitchType*/ 75, MVT::i64,// ->5036
/*  4961*/       OPC_MoveParent,
/*  4962*/       OPC_MoveChild2,
/*  4963*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4966*/       OPC_RecordChild0, // #3 = $val
/*  4967*/       OPC_MoveParent,
/*  4968*/       OPC_Scope, 21, /*->4991*/ // 3 children in Scope
/*  4970*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  4972*/        OPC_MoveParent,
/*  4973*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4975*/        OPC_EmitMergeInputChains1_0,
/*  4976*/        OPC_EmitInteger, MVT::i32, 0, 
/*  4979*/        OPC_EmitConvertToTarget, 2,
/*  4981*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  4991*/       /*Scope*/ 21, /*->5013*/
/*  4992*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  4994*/        OPC_MoveParent,
/*  4995*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4997*/        OPC_EmitMergeInputChains1_0,
/*  4998*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5001*/        OPC_EmitConvertToTarget, 2,
/*  5003*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5013*/       /*Scope*/ 21, /*->5035*/
/*  5014*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5016*/        OPC_MoveParent,
/*  5017*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5019*/        OPC_EmitMergeInputChains1_0,
/*  5020*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5023*/        OPC_EmitConvertToTarget, 2,
/*  5025*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5035*/       0, /*End of Scope*/
/*  5036*/      0, // EndSwitchType
/*  5037*/     /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::OR),// ->5206
/*  5041*/      OPC_RecordChild0, // #1 = $addr
/*  5042*/      OPC_RecordChild1, // #2 = $off
/*  5043*/      OPC_MoveChild1,
/*  5044*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  5047*/      OPC_MoveParent,
/*  5048*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  5050*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->5128
/*  5053*/       OPC_MoveParent,
/*  5054*/       OPC_MoveChild2,
/*  5055*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5058*/       OPC_RecordChild0, // #3 = $val
/*  5059*/       OPC_MoveParent,
/*  5060*/       OPC_Scope, 21, /*->5083*/ // 3 children in Scope
/*  5062*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5064*/        OPC_MoveParent,
/*  5065*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5067*/        OPC_EmitMergeInputChains1_0,
/*  5068*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5071*/        OPC_EmitConvertToTarget, 2,
/*  5073*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5083*/       /*Scope*/ 21, /*->5105*/
/*  5084*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5086*/        OPC_MoveParent,
/*  5087*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5089*/        OPC_EmitMergeInputChains1_0,
/*  5090*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5093*/        OPC_EmitConvertToTarget, 2,
/*  5095*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5105*/       /*Scope*/ 21, /*->5127*/
/*  5106*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5108*/        OPC_MoveParent,
/*  5109*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5111*/        OPC_EmitMergeInputChains1_0,
/*  5112*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5115*/        OPC_EmitConvertToTarget, 2,
/*  5117*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5127*/       0, /*End of Scope*/
/*  5128*/      /*SwitchType*/ 75, MVT::i64,// ->5205
/*  5130*/       OPC_MoveParent,
/*  5131*/       OPC_MoveChild2,
/*  5132*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5135*/       OPC_RecordChild0, // #3 = $val
/*  5136*/       OPC_MoveParent,
/*  5137*/       OPC_Scope, 21, /*->5160*/ // 3 children in Scope
/*  5139*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5141*/        OPC_MoveParent,
/*  5142*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5144*/        OPC_EmitMergeInputChains1_0,
/*  5145*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5148*/        OPC_EmitConvertToTarget, 2,
/*  5150*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5160*/       /*Scope*/ 21, /*->5182*/
/*  5161*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5163*/        OPC_MoveParent,
/*  5164*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5166*/        OPC_EmitMergeInputChains1_0,
/*  5167*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5170*/        OPC_EmitConvertToTarget, 2,
/*  5172*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5182*/       /*Scope*/ 21, /*->5204*/
/*  5183*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5185*/        OPC_MoveParent,
/*  5186*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5188*/        OPC_EmitMergeInputChains1_0,
/*  5189*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5192*/        OPC_EmitConvertToTarget, 2,
/*  5194*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5204*/       0, /*End of Scope*/
/*  5205*/      0, // EndSwitchType
/*  5206*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->5405
/*  5210*/      OPC_RecordChild0, // #1 = $off
/*  5211*/      OPC_MoveChild0,
/*  5212*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5215*/      OPC_MoveParent,
/*  5216*/      OPC_MoveParent,
/*  5217*/      OPC_MoveChild2,
/*  5218*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5221*/      OPC_RecordChild0, // #2 = $val
/*  5222*/      OPC_MoveParent,
/*  5223*/      OPC_Scope, 59, /*->5284*/ // 3 children in Scope
/*  5225*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5227*/       OPC_MoveParent,
/*  5228*/       OPC_Scope, 26, /*->5256*/ // 2 children in Scope
/*  5230*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  5232*/        OPC_EmitMergeInputChains1_0,
/*  5233*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5236*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5239*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5246*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5256*/       /*Scope*/ 26, /*->5283*/
/*  5257*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  5259*/        OPC_EmitMergeInputChains1_0,
/*  5260*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5263*/        OPC_EmitInteger, MVT::i64, 0, 
/*  5266*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  5273*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  5283*/       0, /*End of Scope*/
/*  5284*/      /*Scope*/ 59, /*->5344*/
/*  5285*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5287*/       OPC_MoveParent,
/*  5288*/       OPC_Scope, 26, /*->5316*/ // 2 children in Scope
/*  5290*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  5292*/        OPC_EmitMergeInputChains1_0,
/*  5293*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5296*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5299*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5306*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5316*/       /*Scope*/ 26, /*->5343*/
/*  5317*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  5319*/        OPC_EmitMergeInputChains1_0,
/*  5320*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5323*/        OPC_EmitInteger, MVT::i64, 0, 
/*  5326*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  5333*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  5343*/       0, /*End of Scope*/
/*  5344*/      /*Scope*/ 59, /*->5404*/
/*  5345*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5347*/       OPC_MoveParent,
/*  5348*/       OPC_Scope, 26, /*->5376*/ // 2 children in Scope
/*  5350*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  5352*/        OPC_EmitMergeInputChains1_0,
/*  5353*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5356*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5359*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5366*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5376*/       /*Scope*/ 26, /*->5403*/
/*  5377*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  5379*/        OPC_EmitMergeInputChains1_0,
/*  5380*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5383*/        OPC_EmitInteger, MVT::i64, 0, 
/*  5386*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  5393*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  5403*/       0, /*End of Scope*/
/*  5404*/      0, /*End of Scope*/
/*  5405*/     0, // EndSwitchOpcode
/*  5406*/    /*Scope*/ 114|128,2/*370*/, /*->5778*/
/*  5408*/     OPC_RecordChild1, // #1 = $off
/*  5409*/     OPC_Scope, 77|128,1/*205*/, /*->5617*/ // 3 children in Scope
/*  5412*/      OPC_MoveChild1,
/*  5413*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  5416*/      OPC_MoveParent,
/*  5417*/      OPC_MoveChild2,
/*  5418*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5421*/      OPC_RecordChild0, // #2 = $val
/*  5422*/      OPC_MoveParent,
/*  5423*/      OPC_Scope, 63, /*->5488*/ // 3 children in Scope
/*  5425*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5427*/       OPC_MoveParent,
/*  5428*/       OPC_Scope, 28, /*->5458*/ // 2 children in Scope
/*  5430*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5432*/        OPC_EmitMergeInputChains1_0,
/*  5433*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5436*/        OPC_EmitConvertToTarget, 1,
/*  5438*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5441*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  5448*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5458*/       /*Scope*/ 28, /*->5487*/
/*  5459*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5461*/        OPC_EmitMergeInputChains1_0,
/*  5462*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5465*/        OPC_EmitConvertToTarget, 1,
/*  5467*/        OPC_EmitInteger, MVT::i64, 0, 
/*  5470*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  5477*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  5487*/       0, /*End of Scope*/
/*  5488*/      /*Scope*/ 63, /*->5552*/
/*  5489*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5491*/       OPC_MoveParent,
/*  5492*/       OPC_Scope, 28, /*->5522*/ // 2 children in Scope
/*  5494*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5496*/        OPC_EmitMergeInputChains1_0,
/*  5497*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5500*/        OPC_EmitConvertToTarget, 1,
/*  5502*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5505*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  5512*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5522*/       /*Scope*/ 28, /*->5551*/
/*  5523*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5525*/        OPC_EmitMergeInputChains1_0,
/*  5526*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5529*/        OPC_EmitConvertToTarget, 1,
/*  5531*/        OPC_EmitInteger, MVT::i64, 0, 
/*  5534*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  5541*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  5551*/       0, /*End of Scope*/
/*  5552*/      /*Scope*/ 63, /*->5616*/
/*  5553*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5555*/       OPC_MoveParent,
/*  5556*/       OPC_Scope, 28, /*->5586*/ // 2 children in Scope
/*  5558*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5560*/        OPC_EmitMergeInputChains1_0,
/*  5561*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5564*/        OPC_EmitConvertToTarget, 1,
/*  5566*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5569*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  5576*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5586*/       /*Scope*/ 28, /*->5615*/
/*  5587*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5589*/        OPC_EmitMergeInputChains1_0,
/*  5590*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5593*/        OPC_EmitConvertToTarget, 1,
/*  5595*/        OPC_EmitInteger, MVT::i64, 0, 
/*  5598*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  5605*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  5615*/       0, /*End of Scope*/
/*  5616*/      0, /*End of Scope*/
/*  5617*/     /*Scope*/ 79, /*->5697*/
/*  5618*/      OPC_CheckChild1Type, MVT::i32,
/*  5620*/      OPC_MoveChild2,
/*  5621*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5624*/      OPC_RecordChild0, // #2 = $val
/*  5625*/      OPC_MoveParent,
/*  5626*/      OPC_Scope, 22, /*->5650*/ // 3 children in Scope
/*  5628*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5630*/       OPC_MoveParent,
/*  5631*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5633*/       OPC_EmitMergeInputChains1_0,
/*  5634*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5637*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5640*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5650*/      /*Scope*/ 22, /*->5673*/
/*  5651*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5653*/       OPC_MoveParent,
/*  5654*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5656*/       OPC_EmitMergeInputChains1_0,
/*  5657*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5660*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5663*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5673*/      /*Scope*/ 22, /*->5696*/
/*  5674*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5676*/       OPC_MoveParent,
/*  5677*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5679*/       OPC_EmitMergeInputChains1_0,
/*  5680*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5683*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5686*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5696*/      0, /*End of Scope*/
/*  5697*/     /*Scope*/ 79, /*->5777*/
/*  5698*/      OPC_CheckChild1Type, MVT::i64,
/*  5700*/      OPC_MoveChild2,
/*  5701*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5704*/      OPC_RecordChild0, // #2 = $val
/*  5705*/      OPC_MoveParent,
/*  5706*/      OPC_Scope, 22, /*->5730*/ // 3 children in Scope
/*  5708*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5710*/       OPC_MoveParent,
/*  5711*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5713*/       OPC_EmitMergeInputChains1_0,
/*  5714*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5717*/       OPC_EmitInteger, MVT::i64, 0, 
/*  5720*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5730*/      /*Scope*/ 22, /*->5753*/
/*  5731*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5733*/       OPC_MoveParent,
/*  5734*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5736*/       OPC_EmitMergeInputChains1_0,
/*  5737*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5740*/       OPC_EmitInteger, MVT::i64, 0, 
/*  5743*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5753*/      /*Scope*/ 22, /*->5776*/
/*  5754*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/*  5756*/       OPC_MoveParent,
/*  5757*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5759*/       OPC_EmitMergeInputChains1_0,
/*  5760*/       OPC_EmitInteger, MVT::i32, 0, 
/*  5763*/       OPC_EmitInteger, MVT::i64, 0, 
/*  5766*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5776*/      0, /*End of Scope*/
/*  5777*/     0, /*End of Scope*/
/*  5778*/    0, /*End of Scope*/
/*  5779*/   /*SwitchOpcode*/ 22|128,7/*918*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->6701
/*  5783*/    OPC_RecordMemRef,
/*  5784*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  5785*/    OPC_Scope, 28|128,4/*540*/, /*->6328*/ // 2 children in Scope
/*  5788*/     OPC_MoveChild1,
/*  5789*/     OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->5959
/*  5794*/      OPC_RecordChild0, // #1 = $addr
/*  5795*/      OPC_RecordChild1, // #2 = $off
/*  5796*/      OPC_MoveChild1,
/*  5797*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  5800*/      OPC_MoveParent,
/*  5801*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  5803*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->5881
/*  5806*/       OPC_MoveParent,
/*  5807*/       OPC_MoveChild2,
/*  5808*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5811*/       OPC_RecordChild0, // #3 = $val
/*  5812*/       OPC_MoveParent,
/*  5813*/       OPC_Scope, 21, /*->5836*/ // 3 children in Scope
/*  5815*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  5817*/        OPC_MoveParent,
/*  5818*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5820*/        OPC_EmitMergeInputChains1_0,
/*  5821*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5824*/        OPC_EmitConvertToTarget, 2,
/*  5826*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5836*/       /*Scope*/ 21, /*->5858*/
/*  5837*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  5839*/        OPC_MoveParent,
/*  5840*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5842*/        OPC_EmitMergeInputChains1_0,
/*  5843*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5846*/        OPC_EmitConvertToTarget, 2,
/*  5848*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5858*/       /*Scope*/ 21, /*->5880*/
/*  5859*/        OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  5861*/        OPC_MoveParent,
/*  5862*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5864*/        OPC_EmitMergeInputChains1_0,
/*  5865*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5868*/        OPC_EmitConvertToTarget, 2,
/*  5870*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  5880*/       0, /*End of Scope*/
/*  5881*/      /*SwitchType*/ 75, MVT::i64,// ->5958
/*  5883*/       OPC_MoveParent,
/*  5884*/       OPC_MoveChild2,
/*  5885*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5888*/       OPC_RecordChild0, // #3 = $val
/*  5889*/       OPC_MoveParent,
/*  5890*/       OPC_Scope, 21, /*->5913*/ // 3 children in Scope
/*  5892*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  5894*/        OPC_MoveParent,
/*  5895*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5897*/        OPC_EmitMergeInputChains1_0,
/*  5898*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5901*/        OPC_EmitConvertToTarget, 2,
/*  5903*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5913*/       /*Scope*/ 21, /*->5935*/
/*  5914*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  5916*/        OPC_MoveParent,
/*  5917*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5919*/        OPC_EmitMergeInputChains1_0,
/*  5920*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5923*/        OPC_EmitConvertToTarget, 2,
/*  5925*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5935*/       /*Scope*/ 21, /*->5957*/
/*  5936*/        OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  5938*/        OPC_MoveParent,
/*  5939*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5941*/        OPC_EmitMergeInputChains1_0,
/*  5942*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5945*/        OPC_EmitConvertToTarget, 2,
/*  5947*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  5957*/       0, /*End of Scope*/
/*  5958*/      0, // EndSwitchType
/*  5959*/     /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::OR),// ->6128
/*  5963*/      OPC_RecordChild0, // #1 = $addr
/*  5964*/      OPC_RecordChild1, // #2 = $off
/*  5965*/      OPC_MoveChild1,
/*  5966*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  5969*/      OPC_MoveParent,
/*  5970*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  5972*/      OPC_SwitchType /*2 cases */, 75, MVT::i32,// ->6050
/*  5975*/       OPC_MoveParent,
/*  5976*/       OPC_MoveChild2,
/*  5977*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5980*/       OPC_RecordChild0, // #3 = $val
/*  5981*/       OPC_MoveParent,
/*  5982*/       OPC_Scope, 21, /*->6005*/ // 3 children in Scope
/*  5984*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  5986*/        OPC_MoveParent,
/*  5987*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  5989*/        OPC_EmitMergeInputChains1_0,
/*  5990*/        OPC_EmitInteger, MVT::i32, 0, 
/*  5993*/        OPC_EmitConvertToTarget, 2,
/*  5995*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  6005*/       /*Scope*/ 21, /*->6027*/
/*  6006*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6008*/        OPC_MoveParent,
/*  6009*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6011*/        OPC_EmitMergeInputChains1_0,
/*  6012*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6015*/        OPC_EmitConvertToTarget, 2,
/*  6017*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  6027*/       /*Scope*/ 21, /*->6049*/
/*  6028*/        OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  6030*/        OPC_MoveParent,
/*  6031*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6033*/        OPC_EmitMergeInputChains1_0,
/*  6034*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6037*/        OPC_EmitConvertToTarget, 2,
/*  6039*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  6049*/       0, /*End of Scope*/
/*  6050*/      /*SwitchType*/ 75, MVT::i64,// ->6127
/*  6052*/       OPC_MoveParent,
/*  6053*/       OPC_MoveChild2,
/*  6054*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6057*/       OPC_RecordChild0, // #3 = $val
/*  6058*/       OPC_MoveParent,
/*  6059*/       OPC_Scope, 21, /*->6082*/ // 3 children in Scope
/*  6061*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6063*/        OPC_MoveParent,
/*  6064*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6066*/        OPC_EmitMergeInputChains1_0,
/*  6067*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6070*/        OPC_EmitConvertToTarget, 2,
/*  6072*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  6082*/       /*Scope*/ 21, /*->6104*/
/*  6083*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6085*/        OPC_MoveParent,
/*  6086*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6088*/        OPC_EmitMergeInputChains1_0,
/*  6089*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6092*/        OPC_EmitConvertToTarget, 2,
/*  6094*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  6104*/       /*Scope*/ 21, /*->6126*/
/*  6105*/        OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  6107*/        OPC_MoveParent,
/*  6108*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6110*/        OPC_EmitMergeInputChains1_0,
/*  6111*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6114*/        OPC_EmitConvertToTarget, 2,
/*  6116*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  6126*/       0, /*End of Scope*/
/*  6127*/      0, // EndSwitchType
/*  6128*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->6327
/*  6132*/      OPC_RecordChild0, // #1 = $off
/*  6133*/      OPC_MoveChild0,
/*  6134*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6137*/      OPC_MoveParent,
/*  6138*/      OPC_MoveParent,
/*  6139*/      OPC_MoveChild2,
/*  6140*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6143*/      OPC_RecordChild0, // #2 = $val
/*  6144*/      OPC_MoveParent,
/*  6145*/      OPC_Scope, 59, /*->6206*/ // 3 children in Scope
/*  6147*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6149*/       OPC_MoveParent,
/*  6150*/       OPC_Scope, 26, /*->6178*/ // 2 children in Scope
/*  6152*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  6154*/        OPC_EmitMergeInputChains1_0,
/*  6155*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6158*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6161*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6168*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6178*/       /*Scope*/ 26, /*->6205*/
/*  6179*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  6181*/        OPC_EmitMergeInputChains1_0,
/*  6182*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6185*/        OPC_EmitInteger, MVT::i64, 0, 
/*  6188*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  6195*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  6205*/       0, /*End of Scope*/
/*  6206*/      /*Scope*/ 59, /*->6266*/
/*  6207*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6209*/       OPC_MoveParent,
/*  6210*/       OPC_Scope, 26, /*->6238*/ // 2 children in Scope
/*  6212*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  6214*/        OPC_EmitMergeInputChains1_0,
/*  6215*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6218*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6221*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6228*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6238*/       /*Scope*/ 26, /*->6265*/
/*  6239*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  6241*/        OPC_EmitMergeInputChains1_0,
/*  6242*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6245*/        OPC_EmitInteger, MVT::i64, 0, 
/*  6248*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  6255*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  6265*/       0, /*End of Scope*/
/*  6266*/      /*Scope*/ 59, /*->6326*/
/*  6267*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  6269*/       OPC_MoveParent,
/*  6270*/       OPC_Scope, 26, /*->6298*/ // 2 children in Scope
/*  6272*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  6274*/        OPC_EmitMergeInputChains1_0,
/*  6275*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6278*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6281*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6288*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6298*/       /*Scope*/ 26, /*->6325*/
/*  6299*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  6301*/        OPC_EmitMergeInputChains1_0,
/*  6302*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6305*/        OPC_EmitInteger, MVT::i64, 0, 
/*  6308*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  6315*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  6325*/       0, /*End of Scope*/
/*  6326*/      0, /*End of Scope*/
/*  6327*/     0, // EndSwitchOpcode
/*  6328*/    /*Scope*/ 114|128,2/*370*/, /*->6700*/
/*  6330*/     OPC_RecordChild1, // #1 = $off
/*  6331*/     OPC_Scope, 77|128,1/*205*/, /*->6539*/ // 3 children in Scope
/*  6334*/      OPC_MoveChild1,
/*  6335*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6338*/      OPC_MoveParent,
/*  6339*/      OPC_MoveChild2,
/*  6340*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6343*/      OPC_RecordChild0, // #2 = $val
/*  6344*/      OPC_MoveParent,
/*  6345*/      OPC_Scope, 63, /*->6410*/ // 3 children in Scope
/*  6347*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6349*/       OPC_MoveParent,
/*  6350*/       OPC_Scope, 28, /*->6380*/ // 2 children in Scope
/*  6352*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6354*/        OPC_EmitMergeInputChains1_0,
/*  6355*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6358*/        OPC_EmitConvertToTarget, 1,
/*  6360*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6363*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  6370*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6380*/       /*Scope*/ 28, /*->6409*/
/*  6381*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6383*/        OPC_EmitMergeInputChains1_0,
/*  6384*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6387*/        OPC_EmitConvertToTarget, 1,
/*  6389*/        OPC_EmitInteger, MVT::i64, 0, 
/*  6392*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  6399*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  6409*/       0, /*End of Scope*/
/*  6410*/      /*Scope*/ 63, /*->6474*/
/*  6411*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6413*/       OPC_MoveParent,
/*  6414*/       OPC_Scope, 28, /*->6444*/ // 2 children in Scope
/*  6416*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6418*/        OPC_EmitMergeInputChains1_0,
/*  6419*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6422*/        OPC_EmitConvertToTarget, 1,
/*  6424*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6427*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  6434*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6444*/       /*Scope*/ 28, /*->6473*/
/*  6445*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6447*/        OPC_EmitMergeInputChains1_0,
/*  6448*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6451*/        OPC_EmitConvertToTarget, 1,
/*  6453*/        OPC_EmitInteger, MVT::i64, 0, 
/*  6456*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  6463*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  6473*/       0, /*End of Scope*/
/*  6474*/      /*Scope*/ 63, /*->6538*/
/*  6475*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  6477*/       OPC_MoveParent,
/*  6478*/       OPC_Scope, 28, /*->6508*/ // 2 children in Scope
/*  6480*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6482*/        OPC_EmitMergeInputChains1_0,
/*  6483*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6486*/        OPC_EmitConvertToTarget, 1,
/*  6488*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6491*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  6498*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6508*/       /*Scope*/ 28, /*->6537*/
/*  6509*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6511*/        OPC_EmitMergeInputChains1_0,
/*  6512*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6515*/        OPC_EmitConvertToTarget, 1,
/*  6517*/        OPC_EmitInteger, MVT::i64, 0, 
/*  6520*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  6527*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  6537*/       0, /*End of Scope*/
/*  6538*/      0, /*End of Scope*/
/*  6539*/     /*Scope*/ 79, /*->6619*/
/*  6540*/      OPC_CheckChild1Type, MVT::i32,
/*  6542*/      OPC_MoveChild2,
/*  6543*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6546*/      OPC_RecordChild0, // #2 = $val
/*  6547*/      OPC_MoveParent,
/*  6548*/      OPC_Scope, 22, /*->6572*/ // 3 children in Scope
/*  6550*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6552*/       OPC_MoveParent,
/*  6553*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6555*/       OPC_EmitMergeInputChains1_0,
/*  6556*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6559*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6562*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  6572*/      /*Scope*/ 22, /*->6595*/
/*  6573*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6575*/       OPC_MoveParent,
/*  6576*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6578*/       OPC_EmitMergeInputChains1_0,
/*  6579*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6582*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6585*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  6595*/      /*Scope*/ 22, /*->6618*/
/*  6596*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  6598*/       OPC_MoveParent,
/*  6599*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6601*/       OPC_EmitMergeInputChains1_0,
/*  6602*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6605*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6608*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  6618*/      0, /*End of Scope*/
/*  6619*/     /*Scope*/ 79, /*->6699*/
/*  6620*/      OPC_CheckChild1Type, MVT::i64,
/*  6622*/      OPC_MoveChild2,
/*  6623*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6626*/      OPC_RecordChild0, // #2 = $val
/*  6627*/      OPC_MoveParent,
/*  6628*/      OPC_Scope, 22, /*->6652*/ // 3 children in Scope
/*  6630*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6632*/       OPC_MoveParent,
/*  6633*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6635*/       OPC_EmitMergeInputChains1_0,
/*  6636*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6639*/       OPC_EmitInteger, MVT::i64, 0, 
/*  6642*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  6652*/      /*Scope*/ 22, /*->6675*/
/*  6653*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6655*/       OPC_MoveParent,
/*  6656*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6658*/       OPC_EmitMergeInputChains1_0,
/*  6659*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6662*/       OPC_EmitInteger, MVT::i64, 0, 
/*  6665*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  6675*/      /*Scope*/ 22, /*->6698*/
/*  6676*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/*  6678*/       OPC_MoveParent,
/*  6679*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  6681*/       OPC_EmitMergeInputChains1_0,
/*  6682*/       OPC_EmitInteger, MVT::i32, 0, 
/*  6685*/       OPC_EmitInteger, MVT::i64, 0, 
/*  6688*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  6698*/      0, /*End of Scope*/
/*  6699*/     0, /*End of Scope*/
/*  6700*/    0, /*End of Scope*/
/*  6701*/   /*SwitchOpcode*/ 72|128,6/*840*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7545
/*  6705*/    OPC_RecordMemRef,
/*  6706*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6707*/    OPC_Scope, 108|128,3/*492*/, /*->7202*/ // 2 children in Scope
/*  6710*/     OPC_MoveChild1,
/*  6711*/     OPC_SwitchOpcode /*3 cases */, 19|128,1/*147*/, TARGET_VAL(ISD::ADD),// ->6863
/*  6716*/      OPC_RecordChild0, // #1 = $addr
/*  6717*/      OPC_RecordChild1, // #2 = $off
/*  6718*/      OPC_MoveChild1,
/*  6719*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6722*/      OPC_MoveParent,
/*  6723*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  6725*/      OPC_SwitchType /*2 cases */, 66, MVT::i32,// ->6794
/*  6728*/       OPC_MoveParent,
/*  6729*/       OPC_Scope, 20, /*->6751*/ // 3 children in Scope
/*  6731*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6733*/        OPC_MoveParent,
/*  6734*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  6736*/        OPC_EmitMergeInputChains1_0,
/*  6737*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6740*/        OPC_EmitConvertToTarget, 2,
/*  6742*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6751*/       /*Scope*/ 20, /*->6772*/
/*  6752*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6754*/        OPC_MoveParent,
/*  6755*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  6757*/        OPC_EmitMergeInputChains1_0,
/*  6758*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6761*/        OPC_EmitConvertToTarget, 2,
/*  6763*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6772*/       /*Scope*/ 20, /*->6793*/
/*  6773*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  6775*/        OPC_MoveParent,
/*  6776*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  6778*/        OPC_EmitMergeInputChains1_0,
/*  6779*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6782*/        OPC_EmitConvertToTarget, 2,
/*  6784*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_32>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6793*/       0, /*End of Scope*/
/*  6794*/      /*SwitchType*/ 66, MVT::i64,// ->6862
/*  6796*/       OPC_MoveParent,
/*  6797*/       OPC_Scope, 20, /*->6819*/ // 3 children in Scope
/*  6799*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6801*/        OPC_MoveParent,
/*  6802*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  6804*/        OPC_EmitMergeInputChains1_0,
/*  6805*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6808*/        OPC_EmitConvertToTarget, 2,
/*  6810*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/*  6819*/       /*Scope*/ 20, /*->6840*/
/*  6820*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6822*/        OPC_MoveParent,
/*  6823*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  6825*/        OPC_EmitMergeInputChains1_0,
/*  6826*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6829*/        OPC_EmitConvertToTarget, 2,
/*  6831*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/*  6840*/       /*Scope*/ 20, /*->6861*/
/*  6841*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  6843*/        OPC_MoveParent,
/*  6844*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  6846*/        OPC_EmitMergeInputChains1_0,
/*  6847*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6850*/        OPC_EmitConvertToTarget, 2,
/*  6852*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_32>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/*  6861*/       0, /*End of Scope*/
/*  6862*/      0, // EndSwitchType
/*  6863*/     /*SwitchOpcode*/ 19|128,1/*147*/, TARGET_VAL(ISD::OR),// ->7014
/*  6867*/      OPC_RecordChild0, // #1 = $addr
/*  6868*/      OPC_RecordChild1, // #2 = $off
/*  6869*/      OPC_MoveChild1,
/*  6870*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6873*/      OPC_MoveParent,
/*  6874*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  6876*/      OPC_SwitchType /*2 cases */, 66, MVT::i32,// ->6945
/*  6879*/       OPC_MoveParent,
/*  6880*/       OPC_Scope, 20, /*->6902*/ // 3 children in Scope
/*  6882*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6884*/        OPC_MoveParent,
/*  6885*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  6887*/        OPC_EmitMergeInputChains1_0,
/*  6888*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6891*/        OPC_EmitConvertToTarget, 2,
/*  6893*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6902*/       /*Scope*/ 20, /*->6923*/
/*  6903*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6905*/        OPC_MoveParent,
/*  6906*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  6908*/        OPC_EmitMergeInputChains1_0,
/*  6909*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6912*/        OPC_EmitConvertToTarget, 2,
/*  6914*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6923*/       /*Scope*/ 20, /*->6944*/
/*  6924*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  6926*/        OPC_MoveParent,
/*  6927*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  6929*/        OPC_EmitMergeInputChains1_0,
/*  6930*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6933*/        OPC_EmitConvertToTarget, 2,
/*  6935*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_32>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6944*/       0, /*End of Scope*/
/*  6945*/      /*SwitchType*/ 66, MVT::i64,// ->7013
/*  6947*/       OPC_MoveParent,
/*  6948*/       OPC_Scope, 20, /*->6970*/ // 3 children in Scope
/*  6950*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6952*/        OPC_MoveParent,
/*  6953*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  6955*/        OPC_EmitMergeInputChains1_0,
/*  6956*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6959*/        OPC_EmitConvertToTarget, 2,
/*  6961*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/*  6970*/       /*Scope*/ 20, /*->6991*/
/*  6971*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6973*/        OPC_MoveParent,
/*  6974*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  6976*/        OPC_EmitMergeInputChains1_0,
/*  6977*/        OPC_EmitInteger, MVT::i32, 0, 
/*  6980*/        OPC_EmitConvertToTarget, 2,
/*  6982*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/*  6991*/       /*Scope*/ 20, /*->7012*/
/*  6992*/        OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  6994*/        OPC_MoveParent,
/*  6995*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  6997*/        OPC_EmitMergeInputChains1_0,
/*  6998*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7001*/        OPC_EmitConvertToTarget, 2,
/*  7003*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_32>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/*  7012*/       0, /*End of Scope*/
/*  7013*/      0, // EndSwitchType
/*  7014*/     /*SwitchOpcode*/ 55|128,1/*183*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->7201
/*  7018*/      OPC_RecordChild0, // #1 = $off
/*  7019*/      OPC_MoveChild0,
/*  7020*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7023*/      OPC_MoveParent,
/*  7024*/      OPC_MoveParent,
/*  7025*/      OPC_Scope, 57, /*->7084*/ // 3 children in Scope
/*  7027*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  7029*/       OPC_MoveParent,
/*  7030*/       OPC_Scope, 25, /*->7057*/ // 2 children in Scope
/*  7032*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/*  7034*/        OPC_EmitMergeInputChains1_0,
/*  7035*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7038*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7041*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/*  7048*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/*  7057*/       /*Scope*/ 25, /*->7083*/
/*  7058*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/*  7060*/        OPC_EmitMergeInputChains1_0,
/*  7061*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7064*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7067*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/*  7074*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/*  7083*/       0, /*End of Scope*/
/*  7084*/      /*Scope*/ 57, /*->7142*/
/*  7085*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  7087*/       OPC_MoveParent,
/*  7088*/       OPC_Scope, 25, /*->7115*/ // 2 children in Scope
/*  7090*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/*  7092*/        OPC_EmitMergeInputChains1_0,
/*  7093*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7096*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7099*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/*  7106*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/*  7115*/       /*Scope*/ 25, /*->7141*/
/*  7116*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/*  7118*/        OPC_EmitMergeInputChains1_0,
/*  7119*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7122*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7125*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/*  7132*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/*  7141*/       0, /*End of Scope*/
/*  7142*/      /*Scope*/ 57, /*->7200*/
/*  7143*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  7145*/       OPC_MoveParent,
/*  7146*/       OPC_Scope, 25, /*->7173*/ // 2 children in Scope
/*  7148*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/*  7150*/        OPC_EmitMergeInputChains1_0,
/*  7151*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7154*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7157*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/*  7164*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_32>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/*  7173*/       /*Scope*/ 25, /*->7199*/
/*  7174*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/*  7176*/        OPC_EmitMergeInputChains1_0,
/*  7177*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7180*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7183*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/*  7190*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_32>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/*  7199*/       0, /*End of Scope*/
/*  7200*/      0, /*End of Scope*/
/*  7201*/     0, // EndSwitchOpcode
/*  7202*/    /*Scope*/ 84|128,2/*340*/, /*->7544*/
/*  7204*/     OPC_RecordChild1, // #1 = $off
/*  7205*/     OPC_Scope, 65|128,1/*193*/, /*->7401*/ // 3 children in Scope
/*  7208*/      OPC_MoveChild1,
/*  7209*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  7212*/      OPC_MoveParent,
/*  7213*/      OPC_Scope, 61, /*->7276*/ // 3 children in Scope
/*  7215*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  7217*/       OPC_MoveParent,
/*  7218*/       OPC_Scope, 27, /*->7247*/ // 2 children in Scope
/*  7220*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  7222*/        OPC_EmitMergeInputChains1_0,
/*  7223*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7226*/        OPC_EmitConvertToTarget, 1,
/*  7228*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7231*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  7238*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/*  7247*/       /*Scope*/ 27, /*->7275*/
/*  7248*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  7250*/        OPC_EmitMergeInputChains1_0,
/*  7251*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7254*/        OPC_EmitConvertToTarget, 1,
/*  7256*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7259*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  7266*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/*  7275*/       0, /*End of Scope*/
/*  7276*/      /*Scope*/ 61, /*->7338*/
/*  7277*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  7279*/       OPC_MoveParent,
/*  7280*/       OPC_Scope, 27, /*->7309*/ // 2 children in Scope
/*  7282*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  7284*/        OPC_EmitMergeInputChains1_0,
/*  7285*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7288*/        OPC_EmitConvertToTarget, 1,
/*  7290*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7293*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  7300*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/*  7309*/       /*Scope*/ 27, /*->7337*/
/*  7310*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  7312*/        OPC_EmitMergeInputChains1_0,
/*  7313*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7316*/        OPC_EmitConvertToTarget, 1,
/*  7318*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7321*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  7328*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/*  7337*/       0, /*End of Scope*/
/*  7338*/      /*Scope*/ 61, /*->7400*/
/*  7339*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  7341*/       OPC_MoveParent,
/*  7342*/       OPC_Scope, 27, /*->7371*/ // 2 children in Scope
/*  7344*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  7346*/        OPC_EmitMergeInputChains1_0,
/*  7347*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7350*/        OPC_EmitConvertToTarget, 1,
/*  7352*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7355*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  7362*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_32>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/*  7371*/       /*Scope*/ 27, /*->7399*/
/*  7372*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  7374*/        OPC_EmitMergeInputChains1_0,
/*  7375*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7378*/        OPC_EmitConvertToTarget, 1,
/*  7380*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7383*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  7390*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_32>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/*  7399*/       0, /*End of Scope*/
/*  7400*/      0, /*End of Scope*/
/*  7401*/     /*Scope*/ 70, /*->7472*/
/*  7402*/      OPC_CheckChild1Type, MVT::i32,
/*  7404*/      OPC_Scope, 21, /*->7427*/ // 3 children in Scope
/*  7406*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  7408*/       OPC_MoveParent,
/*  7409*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  7411*/       OPC_EmitMergeInputChains1_0,
/*  7412*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7415*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7418*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/*  7427*/      /*Scope*/ 21, /*->7449*/
/*  7428*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  7430*/       OPC_MoveParent,
/*  7431*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  7433*/       OPC_EmitMergeInputChains1_0,
/*  7434*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7437*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7440*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/*  7449*/      /*Scope*/ 21, /*->7471*/
/*  7450*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  7452*/       OPC_MoveParent,
/*  7453*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/*  7455*/       OPC_EmitMergeInputChains1_0,
/*  7456*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7459*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7462*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_32>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/*  7471*/      0, /*End of Scope*/
/*  7472*/     /*Scope*/ 70, /*->7543*/
/*  7473*/      OPC_CheckChild1Type, MVT::i64,
/*  7475*/      OPC_Scope, 21, /*->7498*/ // 3 children in Scope
/*  7477*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  7479*/       OPC_MoveParent,
/*  7480*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  7482*/       OPC_EmitMergeInputChains1_0,
/*  7483*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7486*/       OPC_EmitInteger, MVT::i64, 0, 
/*  7489*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_8>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/*  7498*/      /*Scope*/ 21, /*->7520*/
/*  7499*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  7501*/       OPC_MoveParent,
/*  7502*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  7504*/       OPC_EmitMergeInputChains1_0,
/*  7505*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7508*/       OPC_EmitInteger, MVT::i64, 0, 
/*  7511*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_16>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/*  7520*/      /*Scope*/ 21, /*->7542*/
/*  7521*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/*  7523*/       OPC_MoveParent,
/*  7524*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/*  7526*/       OPC_EmitMergeInputChains1_0,
/*  7527*/       OPC_EmitInteger, MVT::i32, 0, 
/*  7530*/       OPC_EmitInteger, MVT::i64, 0, 
/*  7533*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_32>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/*  7542*/      0, /*End of Scope*/
/*  7543*/     0, /*End of Scope*/
/*  7544*/    0, /*End of Scope*/
/*  7545*/   0, // EndSwitchOpcode
/*  7546*/  /*Scope*/ 8, /*->7555*/
/*  7547*/   OPC_RecordChild0, // #0 = $src
/*  7548*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  7555*/  0, /*End of Scope*/
/*  7556*/ /*SwitchOpcode*/ 66|128,41/*5314*/, TARGET_VAL(ISD::ANY_EXTEND),// ->12874
/*  7560*/  OPC_Scope, 53|128,41/*5301*/, /*->12864*/ // 2 children in Scope
/*  7563*/   OPC_MoveChild0,
/*  7564*/   OPC_SwitchOpcode /*8 cases */, 89|128,5/*729*/, TARGET_VAL(ISD::AssertZext),// ->8298
/*  7569*/    OPC_MoveChild0,
/*  7570*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  7573*/    OPC_RecordMemRef,
/*  7574*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  7575*/    OPC_CheckFoldableChainNode,
/*  7576*/    OPC_Scope, 60|128,3/*444*/, /*->8023*/ // 2 children in Scope
/*  7579*/     OPC_MoveChild1,
/*  7580*/     OPC_SwitchOpcode /*3 cases */, 13|128,1/*141*/, TARGET_VAL(ISD::ADD),// ->7726
/*  7585*/      OPC_RecordChild0, // #1 = $addr
/*  7586*/      OPC_RecordChild1, // #2 = $off
/*  7587*/      OPC_MoveChild1,
/*  7588*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  7591*/      OPC_MoveParent,
/*  7592*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  7594*/      OPC_SwitchType /*2 cases */, 63, MVT::i32,// ->7660
/*  7597*/       OPC_MoveParent,
/*  7598*/       OPC_MoveChild2,
/*  7599*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7602*/       OPC_RecordChild0, // #3 = $exp
/*  7603*/       OPC_MoveParent,
/*  7604*/       OPC_MoveChild3,
/*  7605*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7608*/       OPC_RecordChild0, // #4 = $new
/*  7609*/       OPC_MoveParent,
/*  7610*/       OPC_Scope, 23, /*->7635*/ // 2 children in Scope
/*  7612*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  7614*/        OPC_MoveParent,
/*  7615*/        OPC_MoveParent,
/*  7616*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7618*/        OPC_EmitMergeInputChains1_0,
/*  7619*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7622*/        OPC_EmitConvertToTarget, 2,
/*  7624*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7635*/       /*Scope*/ 23, /*->7659*/
/*  7636*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  7638*/        OPC_MoveParent,
/*  7639*/        OPC_MoveParent,
/*  7640*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7642*/        OPC_EmitMergeInputChains1_0,
/*  7643*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7646*/        OPC_EmitConvertToTarget, 2,
/*  7648*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7659*/       0, /*End of Scope*/
/*  7660*/      /*SwitchType*/ 63, MVT::i64,// ->7725
/*  7662*/       OPC_MoveParent,
/*  7663*/       OPC_MoveChild2,
/*  7664*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7667*/       OPC_RecordChild0, // #3 = $exp
/*  7668*/       OPC_MoveParent,
/*  7669*/       OPC_MoveChild3,
/*  7670*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7673*/       OPC_RecordChild0, // #4 = $new
/*  7674*/       OPC_MoveParent,
/*  7675*/       OPC_Scope, 23, /*->7700*/ // 2 children in Scope
/*  7677*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  7679*/        OPC_MoveParent,
/*  7680*/        OPC_MoveParent,
/*  7681*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7683*/        OPC_EmitMergeInputChains1_0,
/*  7684*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7687*/        OPC_EmitConvertToTarget, 2,
/*  7689*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7700*/       /*Scope*/ 23, /*->7724*/
/*  7701*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  7703*/        OPC_MoveParent,
/*  7704*/        OPC_MoveParent,
/*  7705*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7707*/        OPC_EmitMergeInputChains1_0,
/*  7708*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7711*/        OPC_EmitConvertToTarget, 2,
/*  7713*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7724*/       0, /*End of Scope*/
/*  7725*/      0, // EndSwitchType
/*  7726*/     /*SwitchOpcode*/ 13|128,1/*141*/, TARGET_VAL(ISD::OR),// ->7871
/*  7730*/      OPC_RecordChild0, // #1 = $addr
/*  7731*/      OPC_RecordChild1, // #2 = $off
/*  7732*/      OPC_MoveChild1,
/*  7733*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  7736*/      OPC_MoveParent,
/*  7737*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  7739*/      OPC_SwitchType /*2 cases */, 63, MVT::i32,// ->7805
/*  7742*/       OPC_MoveParent,
/*  7743*/       OPC_MoveChild2,
/*  7744*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7747*/       OPC_RecordChild0, // #3 = $exp
/*  7748*/       OPC_MoveParent,
/*  7749*/       OPC_MoveChild3,
/*  7750*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7753*/       OPC_RecordChild0, // #4 = $new
/*  7754*/       OPC_MoveParent,
/*  7755*/       OPC_Scope, 23, /*->7780*/ // 2 children in Scope
/*  7757*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  7759*/        OPC_MoveParent,
/*  7760*/        OPC_MoveParent,
/*  7761*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7763*/        OPC_EmitMergeInputChains1_0,
/*  7764*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7767*/        OPC_EmitConvertToTarget, 2,
/*  7769*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7780*/       /*Scope*/ 23, /*->7804*/
/*  7781*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  7783*/        OPC_MoveParent,
/*  7784*/        OPC_MoveParent,
/*  7785*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7787*/        OPC_EmitMergeInputChains1_0,
/*  7788*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7791*/        OPC_EmitConvertToTarget, 2,
/*  7793*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7804*/       0, /*End of Scope*/
/*  7805*/      /*SwitchType*/ 63, MVT::i64,// ->7870
/*  7807*/       OPC_MoveParent,
/*  7808*/       OPC_MoveChild2,
/*  7809*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7812*/       OPC_RecordChild0, // #3 = $exp
/*  7813*/       OPC_MoveParent,
/*  7814*/       OPC_MoveChild3,
/*  7815*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7818*/       OPC_RecordChild0, // #4 = $new
/*  7819*/       OPC_MoveParent,
/*  7820*/       OPC_Scope, 23, /*->7845*/ // 2 children in Scope
/*  7822*/        OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  7824*/        OPC_MoveParent,
/*  7825*/        OPC_MoveParent,
/*  7826*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7828*/        OPC_EmitMergeInputChains1_0,
/*  7829*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7832*/        OPC_EmitConvertToTarget, 2,
/*  7834*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7845*/       /*Scope*/ 23, /*->7869*/
/*  7846*/        OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  7848*/        OPC_MoveParent,
/*  7849*/        OPC_MoveParent,
/*  7850*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7852*/        OPC_EmitMergeInputChains1_0,
/*  7853*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7856*/        OPC_EmitConvertToTarget, 2,
/*  7858*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7869*/       0, /*End of Scope*/
/*  7870*/      0, // EndSwitchType
/*  7871*/     /*SwitchOpcode*/ 19|128,1/*147*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->8022
/*  7875*/      OPC_RecordChild0, // #1 = $off
/*  7876*/      OPC_MoveChild0,
/*  7877*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7880*/      OPC_MoveParent,
/*  7881*/      OPC_MoveParent,
/*  7882*/      OPC_MoveChild2,
/*  7883*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7886*/      OPC_RecordChild0, // #2 = $exp
/*  7887*/      OPC_MoveParent,
/*  7888*/      OPC_MoveChild3,
/*  7889*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  7892*/      OPC_RecordChild0, // #3 = $new
/*  7893*/      OPC_MoveParent,
/*  7894*/      OPC_Scope, 62, /*->7958*/ // 2 children in Scope
/*  7896*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  7898*/       OPC_MoveParent,
/*  7899*/       OPC_MoveParent,
/*  7900*/       OPC_Scope, 27, /*->7929*/ // 2 children in Scope
/*  7902*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  7904*/        OPC_EmitMergeInputChains1_0,
/*  7905*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7908*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7911*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  7918*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7929*/       /*Scope*/ 27, /*->7957*/
/*  7930*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  7932*/        OPC_EmitMergeInputChains1_0,
/*  7933*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7936*/        OPC_EmitInteger, MVT::i64, 0, 
/*  7939*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  7946*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7957*/       0, /*End of Scope*/
/*  7958*/      /*Scope*/ 62, /*->8021*/
/*  7959*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  7961*/       OPC_MoveParent,
/*  7962*/       OPC_MoveParent,
/*  7963*/       OPC_Scope, 27, /*->7992*/ // 2 children in Scope
/*  7965*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  7967*/        OPC_EmitMergeInputChains1_0,
/*  7968*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7971*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7974*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  7981*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  7992*/       /*Scope*/ 27, /*->8020*/
/*  7993*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  7995*/        OPC_EmitMergeInputChains1_0,
/*  7996*/        OPC_EmitInteger, MVT::i32, 0, 
/*  7999*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8002*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  8009*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8020*/       0, /*End of Scope*/
/*  8021*/      0, /*End of Scope*/
/*  8022*/     0, // EndSwitchOpcode
/*  8023*/    /*Scope*/ 16|128,2/*272*/, /*->8297*/
/*  8025*/     OPC_RecordChild1, // #1 = $off
/*  8026*/     OPC_Scope, 5|128,1/*133*/, /*->8162*/ // 3 children in Scope
/*  8029*/      OPC_MoveChild1,
/*  8030*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  8033*/      OPC_MoveParent,
/*  8034*/      OPC_MoveChild2,
/*  8035*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8038*/      OPC_RecordChild0, // #2 = $exp
/*  8039*/      OPC_MoveParent,
/*  8040*/      OPC_MoveChild3,
/*  8041*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8044*/      OPC_RecordChild0, // #3 = $new
/*  8045*/      OPC_MoveParent,
/*  8046*/      OPC_Scope, 56, /*->8104*/ // 2 children in Scope
/*  8048*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  8050*/       OPC_MoveParent,
/*  8051*/       OPC_MoveParent,
/*  8052*/       OPC_EmitMergeInputChains1_0,
/*  8053*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8056*/       OPC_EmitConvertToTarget, 1,
/*  8058*/       OPC_Scope, 21, /*->8081*/ // 2 children in Scope
/*  8060*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8063*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/*  8070*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8081*/       /*Scope*/ 21, /*->8103*/
/*  8082*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8085*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/*  8092*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8103*/       0, /*End of Scope*/
/*  8104*/      /*Scope*/ 56, /*->8161*/
/*  8105*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  8107*/       OPC_MoveParent,
/*  8108*/       OPC_MoveParent,
/*  8109*/       OPC_EmitMergeInputChains1_0,
/*  8110*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8113*/       OPC_EmitConvertToTarget, 1,
/*  8115*/       OPC_Scope, 21, /*->8138*/ // 2 children in Scope
/*  8117*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8120*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/*  8127*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8138*/       /*Scope*/ 21, /*->8160*/
/*  8139*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8142*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/*  8149*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                  // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 19
                  // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8160*/       0, /*End of Scope*/
/*  8161*/      0, /*End of Scope*/
/*  8162*/     /*Scope*/ 66, /*->8229*/
/*  8163*/      OPC_CheckChild1Type, MVT::i32,
/*  8165*/      OPC_MoveChild2,
/*  8166*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8169*/      OPC_RecordChild0, // #2 = $exp
/*  8170*/      OPC_MoveParent,
/*  8171*/      OPC_MoveChild3,
/*  8172*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8175*/      OPC_RecordChild0, // #3 = $new
/*  8176*/      OPC_MoveParent,
/*  8177*/      OPC_Scope, 24, /*->8203*/ // 2 children in Scope
/*  8179*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  8181*/       OPC_MoveParent,
/*  8182*/       OPC_MoveParent,
/*  8183*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8185*/       OPC_EmitMergeInputChains1_0,
/*  8186*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8189*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8192*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8203*/      /*Scope*/ 24, /*->8228*/
/*  8204*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  8206*/       OPC_MoveParent,
/*  8207*/       OPC_MoveParent,
/*  8208*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8210*/       OPC_EmitMergeInputChains1_0,
/*  8211*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8214*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8217*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8228*/      0, /*End of Scope*/
/*  8229*/     /*Scope*/ 66, /*->8296*/
/*  8230*/      OPC_CheckChild1Type, MVT::i64,
/*  8232*/      OPC_MoveChild2,
/*  8233*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8236*/      OPC_RecordChild0, // #2 = $exp
/*  8237*/      OPC_MoveParent,
/*  8238*/      OPC_MoveChild3,
/*  8239*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8242*/      OPC_RecordChild0, // #3 = $new
/*  8243*/      OPC_MoveParent,
/*  8244*/      OPC_Scope, 24, /*->8270*/ // 2 children in Scope
/*  8246*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  8248*/       OPC_MoveParent,
/*  8249*/       OPC_MoveParent,
/*  8250*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8252*/       OPC_EmitMergeInputChains1_0,
/*  8253*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8256*/       OPC_EmitInteger, MVT::i64, 0, 
/*  8259*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8270*/      /*Scope*/ 24, /*->8295*/
/*  8271*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  8273*/       OPC_MoveParent,
/*  8274*/       OPC_MoveParent,
/*  8275*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8277*/       OPC_EmitMergeInputChains1_0,
/*  8278*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8281*/       OPC_EmitInteger, MVT::i64, 0, 
/*  8284*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                 // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 16
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/*  8295*/      0, /*End of Scope*/
/*  8296*/     0, /*End of Scope*/
/*  8297*/    0, /*End of Scope*/
/*  8298*/   /*SwitchOpcode*/ 18|128,5/*658*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->8960
/*  8302*/    OPC_RecordMemRef,
/*  8303*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  8304*/    OPC_Scope, 6|128,3/*390*/, /*->8697*/ // 2 children in Scope
/*  8307*/     OPC_MoveChild1,
/*  8308*/     OPC_SwitchOpcode /*3 cases */, 121, TARGET_VAL(ISD::ADD),// ->8433
/*  8312*/      OPC_RecordChild0, // #1 = $addr
/*  8313*/      OPC_RecordChild1, // #2 = $off
/*  8314*/      OPC_MoveChild1,
/*  8315*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  8318*/      OPC_MoveParent,
/*  8319*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  8321*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->8377
/*  8324*/       OPC_MoveParent,
/*  8325*/       OPC_MoveChild2,
/*  8326*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8329*/       OPC_RecordChild0, // #3 = $val
/*  8330*/       OPC_MoveParent,
/*  8331*/       OPC_Scope, 21, /*->8354*/ // 2 children in Scope
/*  8333*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8335*/        OPC_MoveParent,
/*  8336*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8338*/        OPC_EmitMergeInputChains1_0,
/*  8339*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8342*/        OPC_EmitConvertToTarget, 2,
/*  8344*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  8354*/       /*Scope*/ 21, /*->8376*/
/*  8355*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8357*/        OPC_MoveParent,
/*  8358*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8360*/        OPC_EmitMergeInputChains1_0,
/*  8361*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8364*/        OPC_EmitConvertToTarget, 2,
/*  8366*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  8376*/       0, /*End of Scope*/
/*  8377*/      /*SwitchType*/ 53, MVT::i64,// ->8432
/*  8379*/       OPC_MoveParent,
/*  8380*/       OPC_MoveChild2,
/*  8381*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8384*/       OPC_RecordChild0, // #3 = $val
/*  8385*/       OPC_MoveParent,
/*  8386*/       OPC_Scope, 21, /*->8409*/ // 2 children in Scope
/*  8388*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8390*/        OPC_MoveParent,
/*  8391*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8393*/        OPC_EmitMergeInputChains1_0,
/*  8394*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8397*/        OPC_EmitConvertToTarget, 2,
/*  8399*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  8409*/       /*Scope*/ 21, /*->8431*/
/*  8410*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8412*/        OPC_MoveParent,
/*  8413*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8415*/        OPC_EmitMergeInputChains1_0,
/*  8416*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8419*/        OPC_EmitConvertToTarget, 2,
/*  8421*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  8431*/       0, /*End of Scope*/
/*  8432*/      0, // EndSwitchType
/*  8433*/     /*SwitchOpcode*/ 121, TARGET_VAL(ISD::OR),// ->8557
/*  8436*/      OPC_RecordChild0, // #1 = $addr
/*  8437*/      OPC_RecordChild1, // #2 = $off
/*  8438*/      OPC_MoveChild1,
/*  8439*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  8442*/      OPC_MoveParent,
/*  8443*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  8445*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->8501
/*  8448*/       OPC_MoveParent,
/*  8449*/       OPC_MoveChild2,
/*  8450*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8453*/       OPC_RecordChild0, // #3 = $val
/*  8454*/       OPC_MoveParent,
/*  8455*/       OPC_Scope, 21, /*->8478*/ // 2 children in Scope
/*  8457*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8459*/        OPC_MoveParent,
/*  8460*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8462*/        OPC_EmitMergeInputChains1_0,
/*  8463*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8466*/        OPC_EmitConvertToTarget, 2,
/*  8468*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  8478*/       /*Scope*/ 21, /*->8500*/
/*  8479*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8481*/        OPC_MoveParent,
/*  8482*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8484*/        OPC_EmitMergeInputChains1_0,
/*  8485*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8488*/        OPC_EmitConvertToTarget, 2,
/*  8490*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  8500*/       0, /*End of Scope*/
/*  8501*/      /*SwitchType*/ 53, MVT::i64,// ->8556
/*  8503*/       OPC_MoveParent,
/*  8504*/       OPC_MoveChild2,
/*  8505*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8508*/       OPC_RecordChild0, // #3 = $val
/*  8509*/       OPC_MoveParent,
/*  8510*/       OPC_Scope, 21, /*->8533*/ // 2 children in Scope
/*  8512*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8514*/        OPC_MoveParent,
/*  8515*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8517*/        OPC_EmitMergeInputChains1_0,
/*  8518*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8521*/        OPC_EmitConvertToTarget, 2,
/*  8523*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  8533*/       /*Scope*/ 21, /*->8555*/
/*  8534*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8536*/        OPC_MoveParent,
/*  8537*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8539*/        OPC_EmitMergeInputChains1_0,
/*  8540*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8543*/        OPC_EmitConvertToTarget, 2,
/*  8545*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  8555*/       0, /*End of Scope*/
/*  8556*/      0, // EndSwitchType
/*  8557*/     /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->8696
/*  8561*/      OPC_RecordChild0, // #1 = $off
/*  8562*/      OPC_MoveChild0,
/*  8563*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  8566*/      OPC_MoveParent,
/*  8567*/      OPC_MoveParent,
/*  8568*/      OPC_MoveChild2,
/*  8569*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8572*/      OPC_RecordChild0, // #2 = $val
/*  8573*/      OPC_MoveParent,
/*  8574*/      OPC_Scope, 59, /*->8635*/ // 2 children in Scope
/*  8576*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8578*/       OPC_MoveParent,
/*  8579*/       OPC_Scope, 26, /*->8607*/ // 2 children in Scope
/*  8581*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  8583*/        OPC_EmitMergeInputChains1_0,
/*  8584*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8587*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8590*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  8597*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  8607*/       /*Scope*/ 26, /*->8634*/
/*  8608*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  8610*/        OPC_EmitMergeInputChains1_0,
/*  8611*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8614*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8617*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  8624*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  8634*/       0, /*End of Scope*/
/*  8635*/      /*Scope*/ 59, /*->8695*/
/*  8636*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8638*/       OPC_MoveParent,
/*  8639*/       OPC_Scope, 26, /*->8667*/ // 2 children in Scope
/*  8641*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  8643*/        OPC_EmitMergeInputChains1_0,
/*  8644*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8647*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8650*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  8657*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  8667*/       /*Scope*/ 26, /*->8694*/
/*  8668*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  8670*/        OPC_EmitMergeInputChains1_0,
/*  8671*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8674*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8677*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  8684*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  8694*/       0, /*End of Scope*/
/*  8695*/      0, /*End of Scope*/
/*  8696*/     0, // EndSwitchOpcode
/*  8697*/    /*Scope*/ 4|128,2/*260*/, /*->8959*/
/*  8699*/     OPC_RecordChild1, // #1 = $off
/*  8700*/     OPC_Scope, 13|128,1/*141*/, /*->8844*/ // 3 children in Scope
/*  8703*/      OPC_MoveChild1,
/*  8704*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  8707*/      OPC_MoveParent,
/*  8708*/      OPC_MoveChild2,
/*  8709*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8712*/      OPC_RecordChild0, // #2 = $val
/*  8713*/      OPC_MoveParent,
/*  8714*/      OPC_Scope, 63, /*->8779*/ // 2 children in Scope
/*  8716*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8718*/       OPC_MoveParent,
/*  8719*/       OPC_Scope, 28, /*->8749*/ // 2 children in Scope
/*  8721*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8723*/        OPC_EmitMergeInputChains1_0,
/*  8724*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8727*/        OPC_EmitConvertToTarget, 1,
/*  8729*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8732*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  8739*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  8749*/       /*Scope*/ 28, /*->8778*/
/*  8750*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8752*/        OPC_EmitMergeInputChains1_0,
/*  8753*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8756*/        OPC_EmitConvertToTarget, 1,
/*  8758*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8761*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  8768*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  8778*/       0, /*End of Scope*/
/*  8779*/      /*Scope*/ 63, /*->8843*/
/*  8780*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8782*/       OPC_MoveParent,
/*  8783*/       OPC_Scope, 28, /*->8813*/ // 2 children in Scope
/*  8785*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8787*/        OPC_EmitMergeInputChains1_0,
/*  8788*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8791*/        OPC_EmitConvertToTarget, 1,
/*  8793*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8796*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  8803*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  8813*/       /*Scope*/ 28, /*->8842*/
/*  8814*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8816*/        OPC_EmitMergeInputChains1_0,
/*  8817*/        OPC_EmitInteger, MVT::i32, 0, 
/*  8820*/        OPC_EmitConvertToTarget, 1,
/*  8822*/        OPC_EmitInteger, MVT::i64, 0, 
/*  8825*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  8832*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  8842*/       0, /*End of Scope*/
/*  8843*/      0, /*End of Scope*/
/*  8844*/     /*Scope*/ 56, /*->8901*/
/*  8845*/      OPC_CheckChild1Type, MVT::i32,
/*  8847*/      OPC_MoveChild2,
/*  8848*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8851*/      OPC_RecordChild0, // #2 = $val
/*  8852*/      OPC_MoveParent,
/*  8853*/      OPC_Scope, 22, /*->8877*/ // 2 children in Scope
/*  8855*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8857*/       OPC_MoveParent,
/*  8858*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8860*/       OPC_EmitMergeInputChains1_0,
/*  8861*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8864*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8867*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  8877*/      /*Scope*/ 22, /*->8900*/
/*  8878*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8880*/       OPC_MoveParent,
/*  8881*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8883*/       OPC_EmitMergeInputChains1_0,
/*  8884*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8887*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8890*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  8900*/      0, /*End of Scope*/
/*  8901*/     /*Scope*/ 56, /*->8958*/
/*  8902*/      OPC_CheckChild1Type, MVT::i64,
/*  8904*/      OPC_MoveChild2,
/*  8905*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8908*/      OPC_RecordChild0, // #2 = $val
/*  8909*/      OPC_MoveParent,
/*  8910*/      OPC_Scope, 22, /*->8934*/ // 2 children in Scope
/*  8912*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8914*/       OPC_MoveParent,
/*  8915*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8917*/       OPC_EmitMergeInputChains1_0,
/*  8918*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8921*/       OPC_EmitInteger, MVT::i64, 0, 
/*  8924*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  8934*/      /*Scope*/ 22, /*->8957*/
/*  8935*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8937*/       OPC_MoveParent,
/*  8938*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8940*/       OPC_EmitMergeInputChains1_0,
/*  8941*/       OPC_EmitInteger, MVT::i32, 0, 
/*  8944*/       OPC_EmitInteger, MVT::i64, 0, 
/*  8947*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  8957*/      0, /*End of Scope*/
/*  8958*/     0, /*End of Scope*/
/*  8959*/    0, /*End of Scope*/
/*  8960*/   /*SwitchOpcode*/ 18|128,5/*658*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->9622
/*  8964*/    OPC_RecordMemRef,
/*  8965*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  8966*/    OPC_Scope, 6|128,3/*390*/, /*->9359*/ // 2 children in Scope
/*  8969*/     OPC_MoveChild1,
/*  8970*/     OPC_SwitchOpcode /*3 cases */, 121, TARGET_VAL(ISD::ADD),// ->9095
/*  8974*/      OPC_RecordChild0, // #1 = $addr
/*  8975*/      OPC_RecordChild1, // #2 = $off
/*  8976*/      OPC_MoveChild1,
/*  8977*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  8980*/      OPC_MoveParent,
/*  8981*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  8983*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->9039
/*  8986*/       OPC_MoveParent,
/*  8987*/       OPC_MoveChild2,
/*  8988*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  8991*/       OPC_RecordChild0, // #3 = $val
/*  8992*/       OPC_MoveParent,
/*  8993*/       OPC_Scope, 21, /*->9016*/ // 2 children in Scope
/*  8995*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  8997*/        OPC_MoveParent,
/*  8998*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9000*/        OPC_EmitMergeInputChains1_0,
/*  9001*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9004*/        OPC_EmitConvertToTarget, 2,
/*  9006*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9016*/       /*Scope*/ 21, /*->9038*/
/*  9017*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9019*/        OPC_MoveParent,
/*  9020*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9022*/        OPC_EmitMergeInputChains1_0,
/*  9023*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9026*/        OPC_EmitConvertToTarget, 2,
/*  9028*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9038*/       0, /*End of Scope*/
/*  9039*/      /*SwitchType*/ 53, MVT::i64,// ->9094
/*  9041*/       OPC_MoveParent,
/*  9042*/       OPC_MoveChild2,
/*  9043*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9046*/       OPC_RecordChild0, // #3 = $val
/*  9047*/       OPC_MoveParent,
/*  9048*/       OPC_Scope, 21, /*->9071*/ // 2 children in Scope
/*  9050*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9052*/        OPC_MoveParent,
/*  9053*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9055*/        OPC_EmitMergeInputChains1_0,
/*  9056*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9059*/        OPC_EmitConvertToTarget, 2,
/*  9061*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9071*/       /*Scope*/ 21, /*->9093*/
/*  9072*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9074*/        OPC_MoveParent,
/*  9075*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9077*/        OPC_EmitMergeInputChains1_0,
/*  9078*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9081*/        OPC_EmitConvertToTarget, 2,
/*  9083*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9093*/       0, /*End of Scope*/
/*  9094*/      0, // EndSwitchType
/*  9095*/     /*SwitchOpcode*/ 121, TARGET_VAL(ISD::OR),// ->9219
/*  9098*/      OPC_RecordChild0, // #1 = $addr
/*  9099*/      OPC_RecordChild1, // #2 = $off
/*  9100*/      OPC_MoveChild1,
/*  9101*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  9104*/      OPC_MoveParent,
/*  9105*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  9107*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->9163
/*  9110*/       OPC_MoveParent,
/*  9111*/       OPC_MoveChild2,
/*  9112*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9115*/       OPC_RecordChild0, // #3 = $val
/*  9116*/       OPC_MoveParent,
/*  9117*/       OPC_Scope, 21, /*->9140*/ // 2 children in Scope
/*  9119*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9121*/        OPC_MoveParent,
/*  9122*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9124*/        OPC_EmitMergeInputChains1_0,
/*  9125*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9128*/        OPC_EmitConvertToTarget, 2,
/*  9130*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9140*/       /*Scope*/ 21, /*->9162*/
/*  9141*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9143*/        OPC_MoveParent,
/*  9144*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9146*/        OPC_EmitMergeInputChains1_0,
/*  9147*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9150*/        OPC_EmitConvertToTarget, 2,
/*  9152*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9162*/       0, /*End of Scope*/
/*  9163*/      /*SwitchType*/ 53, MVT::i64,// ->9218
/*  9165*/       OPC_MoveParent,
/*  9166*/       OPC_MoveChild2,
/*  9167*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9170*/       OPC_RecordChild0, // #3 = $val
/*  9171*/       OPC_MoveParent,
/*  9172*/       OPC_Scope, 21, /*->9195*/ // 2 children in Scope
/*  9174*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9176*/        OPC_MoveParent,
/*  9177*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9179*/        OPC_EmitMergeInputChains1_0,
/*  9180*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9183*/        OPC_EmitConvertToTarget, 2,
/*  9185*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9195*/       /*Scope*/ 21, /*->9217*/
/*  9196*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9198*/        OPC_MoveParent,
/*  9199*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9201*/        OPC_EmitMergeInputChains1_0,
/*  9202*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9205*/        OPC_EmitConvertToTarget, 2,
/*  9207*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9217*/       0, /*End of Scope*/
/*  9218*/      0, // EndSwitchType
/*  9219*/     /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->9358
/*  9223*/      OPC_RecordChild0, // #1 = $off
/*  9224*/      OPC_MoveChild0,
/*  9225*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  9228*/      OPC_MoveParent,
/*  9229*/      OPC_MoveParent,
/*  9230*/      OPC_MoveChild2,
/*  9231*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9234*/      OPC_RecordChild0, // #2 = $val
/*  9235*/      OPC_MoveParent,
/*  9236*/      OPC_Scope, 59, /*->9297*/ // 2 children in Scope
/*  9238*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9240*/       OPC_MoveParent,
/*  9241*/       OPC_Scope, 26, /*->9269*/ // 2 children in Scope
/*  9243*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9245*/        OPC_EmitMergeInputChains1_0,
/*  9246*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9249*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9252*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  9259*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  9269*/       /*Scope*/ 26, /*->9296*/
/*  9270*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9272*/        OPC_EmitMergeInputChains1_0,
/*  9273*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9276*/        OPC_EmitInteger, MVT::i64, 0, 
/*  9279*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  9286*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  9296*/       0, /*End of Scope*/
/*  9297*/      /*Scope*/ 59, /*->9357*/
/*  9298*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9300*/       OPC_MoveParent,
/*  9301*/       OPC_Scope, 26, /*->9329*/ // 2 children in Scope
/*  9303*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9305*/        OPC_EmitMergeInputChains1_0,
/*  9306*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9309*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9312*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  9319*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  9329*/       /*Scope*/ 26, /*->9356*/
/*  9330*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9332*/        OPC_EmitMergeInputChains1_0,
/*  9333*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9336*/        OPC_EmitInteger, MVT::i64, 0, 
/*  9339*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  9346*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  9356*/       0, /*End of Scope*/
/*  9357*/      0, /*End of Scope*/
/*  9358*/     0, // EndSwitchOpcode
/*  9359*/    /*Scope*/ 4|128,2/*260*/, /*->9621*/
/*  9361*/     OPC_RecordChild1, // #1 = $off
/*  9362*/     OPC_Scope, 13|128,1/*141*/, /*->9506*/ // 3 children in Scope
/*  9365*/      OPC_MoveChild1,
/*  9366*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  9369*/      OPC_MoveParent,
/*  9370*/      OPC_MoveChild2,
/*  9371*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9374*/      OPC_RecordChild0, // #2 = $val
/*  9375*/      OPC_MoveParent,
/*  9376*/      OPC_Scope, 63, /*->9441*/ // 2 children in Scope
/*  9378*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9380*/       OPC_MoveParent,
/*  9381*/       OPC_Scope, 28, /*->9411*/ // 2 children in Scope
/*  9383*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9385*/        OPC_EmitMergeInputChains1_0,
/*  9386*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9389*/        OPC_EmitConvertToTarget, 1,
/*  9391*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9394*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  9401*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  9411*/       /*Scope*/ 28, /*->9440*/
/*  9412*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9414*/        OPC_EmitMergeInputChains1_0,
/*  9415*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9418*/        OPC_EmitConvertToTarget, 1,
/*  9420*/        OPC_EmitInteger, MVT::i64, 0, 
/*  9423*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  9430*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  9440*/       0, /*End of Scope*/
/*  9441*/      /*Scope*/ 63, /*->9505*/
/*  9442*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9444*/       OPC_MoveParent,
/*  9445*/       OPC_Scope, 28, /*->9475*/ // 2 children in Scope
/*  9447*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9449*/        OPC_EmitMergeInputChains1_0,
/*  9450*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9453*/        OPC_EmitConvertToTarget, 1,
/*  9455*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9458*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/*  9465*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  9475*/       /*Scope*/ 28, /*->9504*/
/*  9476*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9478*/        OPC_EmitMergeInputChains1_0,
/*  9479*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9482*/        OPC_EmitConvertToTarget, 1,
/*  9484*/        OPC_EmitInteger, MVT::i64, 0, 
/*  9487*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/*  9494*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  9504*/       0, /*End of Scope*/
/*  9505*/      0, /*End of Scope*/
/*  9506*/     /*Scope*/ 56, /*->9563*/
/*  9507*/      OPC_CheckChild1Type, MVT::i32,
/*  9509*/      OPC_MoveChild2,
/*  9510*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9513*/      OPC_RecordChild0, // #2 = $val
/*  9514*/      OPC_MoveParent,
/*  9515*/      OPC_Scope, 22, /*->9539*/ // 2 children in Scope
/*  9517*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9519*/       OPC_MoveParent,
/*  9520*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9522*/       OPC_EmitMergeInputChains1_0,
/*  9523*/       OPC_EmitInteger, MVT::i32, 0, 
/*  9526*/       OPC_EmitInteger, MVT::i32, 0, 
/*  9529*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9539*/      /*Scope*/ 22, /*->9562*/
/*  9540*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9542*/       OPC_MoveParent,
/*  9543*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9545*/       OPC_EmitMergeInputChains1_0,
/*  9546*/       OPC_EmitInteger, MVT::i32, 0, 
/*  9549*/       OPC_EmitInteger, MVT::i32, 0, 
/*  9552*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9562*/      0, /*End of Scope*/
/*  9563*/     /*Scope*/ 56, /*->9620*/
/*  9564*/      OPC_CheckChild1Type, MVT::i64,
/*  9566*/      OPC_MoveChild2,
/*  9567*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9570*/      OPC_RecordChild0, // #2 = $val
/*  9571*/      OPC_MoveParent,
/*  9572*/      OPC_Scope, 22, /*->9596*/ // 2 children in Scope
/*  9574*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9576*/       OPC_MoveParent,
/*  9577*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9579*/       OPC_EmitMergeInputChains1_0,
/*  9580*/       OPC_EmitInteger, MVT::i32, 0, 
/*  9583*/       OPC_EmitInteger, MVT::i64, 0, 
/*  9586*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9596*/      /*Scope*/ 22, /*->9619*/
/*  9597*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9599*/       OPC_MoveParent,
/*  9600*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9602*/       OPC_EmitMergeInputChains1_0,
/*  9603*/       OPC_EmitInteger, MVT::i32, 0, 
/*  9606*/       OPC_EmitInteger, MVT::i64, 0, 
/*  9609*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9619*/      0, /*End of Scope*/
/*  9620*/     0, /*End of Scope*/
/*  9621*/    0, /*End of Scope*/
/*  9622*/   /*SwitchOpcode*/ 18|128,5/*658*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->10284
/*  9626*/    OPC_RecordMemRef,
/*  9627*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  9628*/    OPC_Scope, 6|128,3/*390*/, /*->10021*/ // 2 children in Scope
/*  9631*/     OPC_MoveChild1,
/*  9632*/     OPC_SwitchOpcode /*3 cases */, 121, TARGET_VAL(ISD::ADD),// ->9757
/*  9636*/      OPC_RecordChild0, // #1 = $addr
/*  9637*/      OPC_RecordChild1, // #2 = $off
/*  9638*/      OPC_MoveChild1,
/*  9639*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  9642*/      OPC_MoveParent,
/*  9643*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/*  9645*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->9701
/*  9648*/       OPC_MoveParent,
/*  9649*/       OPC_MoveChild2,
/*  9650*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9653*/       OPC_RecordChild0, // #3 = $val
/*  9654*/       OPC_MoveParent,
/*  9655*/       OPC_Scope, 21, /*->9678*/ // 2 children in Scope
/*  9657*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  9659*/        OPC_MoveParent,
/*  9660*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9662*/        OPC_EmitMergeInputChains1_0,
/*  9663*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9666*/        OPC_EmitConvertToTarget, 2,
/*  9668*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9678*/       /*Scope*/ 21, /*->9700*/
/*  9679*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  9681*/        OPC_MoveParent,
/*  9682*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9684*/        OPC_EmitMergeInputChains1_0,
/*  9685*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9688*/        OPC_EmitConvertToTarget, 2,
/*  9690*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9700*/       0, /*End of Scope*/
/*  9701*/      /*SwitchType*/ 53, MVT::i64,// ->9756
/*  9703*/       OPC_MoveParent,
/*  9704*/       OPC_MoveChild2,
/*  9705*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9708*/       OPC_RecordChild0, // #3 = $val
/*  9709*/       OPC_MoveParent,
/*  9710*/       OPC_Scope, 21, /*->9733*/ // 2 children in Scope
/*  9712*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  9714*/        OPC_MoveParent,
/*  9715*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9717*/        OPC_EmitMergeInputChains1_0,
/*  9718*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9721*/        OPC_EmitConvertToTarget, 2,
/*  9723*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9733*/       /*Scope*/ 21, /*->9755*/
/*  9734*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  9736*/        OPC_MoveParent,
/*  9737*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9739*/        OPC_EmitMergeInputChains1_0,
/*  9740*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9743*/        OPC_EmitConvertToTarget, 2,
/*  9745*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9755*/       0, /*End of Scope*/
/*  9756*/      0, // EndSwitchType
/*  9757*/     /*SwitchOpcode*/ 121, TARGET_VAL(ISD::OR),// ->9881
/*  9760*/      OPC_RecordChild0, // #1 = $addr
/*  9761*/      OPC_RecordChild1, // #2 = $off
/*  9762*/      OPC_MoveChild1,
/*  9763*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  9766*/      OPC_MoveParent,
/*  9767*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/*  9769*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->9825
/*  9772*/       OPC_MoveParent,
/*  9773*/       OPC_MoveChild2,
/*  9774*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9777*/       OPC_RecordChild0, // #3 = $val
/*  9778*/       OPC_MoveParent,
/*  9779*/       OPC_Scope, 21, /*->9802*/ // 2 children in Scope
/*  9781*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  9783*/        OPC_MoveParent,
/*  9784*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9786*/        OPC_EmitMergeInputChains1_0,
/*  9787*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9790*/        OPC_EmitConvertToTarget, 2,
/*  9792*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9802*/       /*Scope*/ 21, /*->9824*/
/*  9803*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  9805*/        OPC_MoveParent,
/*  9806*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9808*/        OPC_EmitMergeInputChains1_0,
/*  9809*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9812*/        OPC_EmitConvertToTarget, 2,
/*  9814*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  9824*/       0, /*End of Scope*/
/*  9825*/      /*SwitchType*/ 53, MVT::i64,// ->9880
/*  9827*/       OPC_MoveParent,
/*  9828*/       OPC_MoveChild2,
/*  9829*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9832*/       OPC_RecordChild0, // #3 = $val
/*  9833*/       OPC_MoveParent,
/*  9834*/       OPC_Scope, 21, /*->9857*/ // 2 children in Scope
/*  9836*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  9838*/        OPC_MoveParent,
/*  9839*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9841*/        OPC_EmitMergeInputChains1_0,
/*  9842*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9845*/        OPC_EmitConvertToTarget, 2,
/*  9847*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9857*/       /*Scope*/ 21, /*->9879*/
/*  9858*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  9860*/        OPC_MoveParent,
/*  9861*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9863*/        OPC_EmitMergeInputChains1_0,
/*  9864*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9867*/        OPC_EmitConvertToTarget, 2,
/*  9869*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  9879*/       0, /*End of Scope*/
/*  9880*/      0, // EndSwitchType
/*  9881*/     /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->10020
/*  9885*/      OPC_RecordChild0, // #1 = $off
/*  9886*/      OPC_MoveChild0,
/*  9887*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  9890*/      OPC_MoveParent,
/*  9891*/      OPC_MoveParent,
/*  9892*/      OPC_MoveChild2,
/*  9893*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  9896*/      OPC_RecordChild0, // #2 = $val
/*  9897*/      OPC_MoveParent,
/*  9898*/      OPC_Scope, 59, /*->9959*/ // 2 children in Scope
/*  9900*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  9902*/       OPC_MoveParent,
/*  9903*/       OPC_Scope, 26, /*->9931*/ // 2 children in Scope
/*  9905*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9907*/        OPC_EmitMergeInputChains1_0,
/*  9908*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9911*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9914*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  9921*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  9931*/       /*Scope*/ 26, /*->9958*/
/*  9932*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9934*/        OPC_EmitMergeInputChains1_0,
/*  9935*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9938*/        OPC_EmitInteger, MVT::i64, 0, 
/*  9941*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/*  9948*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/*  9958*/       0, /*End of Scope*/
/*  9959*/      /*Scope*/ 59, /*->10019*/
/*  9960*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  9962*/       OPC_MoveParent,
/*  9963*/       OPC_Scope, 26, /*->9991*/ // 2 children in Scope
/*  9965*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9967*/        OPC_EmitMergeInputChains1_0,
/*  9968*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9971*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9974*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  9981*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  9991*/       /*Scope*/ 26, /*->10018*/
/*  9992*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/*  9994*/        OPC_EmitMergeInputChains1_0,
/*  9995*/        OPC_EmitInteger, MVT::i32, 0, 
/*  9998*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10001*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 10008*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10018*/       0, /*End of Scope*/
/* 10019*/      0, /*End of Scope*/
/* 10020*/     0, // EndSwitchOpcode
/* 10021*/    /*Scope*/ 4|128,2/*260*/, /*->10283*/
/* 10023*/     OPC_RecordChild1, // #1 = $off
/* 10024*/     OPC_Scope, 13|128,1/*141*/, /*->10168*/ // 3 children in Scope
/* 10027*/      OPC_MoveChild1,
/* 10028*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10031*/      OPC_MoveParent,
/* 10032*/      OPC_MoveChild2,
/* 10033*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10036*/      OPC_RecordChild0, // #2 = $val
/* 10037*/      OPC_MoveParent,
/* 10038*/      OPC_Scope, 63, /*->10103*/ // 2 children in Scope
/* 10040*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 10042*/       OPC_MoveParent,
/* 10043*/       OPC_Scope, 28, /*->10073*/ // 2 children in Scope
/* 10045*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10047*/        OPC_EmitMergeInputChains1_0,
/* 10048*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10051*/        OPC_EmitConvertToTarget, 1,
/* 10053*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10056*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10063*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10073*/       /*Scope*/ 28, /*->10102*/
/* 10074*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10076*/        OPC_EmitMergeInputChains1_0,
/* 10077*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10080*/        OPC_EmitConvertToTarget, 1,
/* 10082*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10085*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 10092*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10102*/       0, /*End of Scope*/
/* 10103*/      /*Scope*/ 63, /*->10167*/
/* 10104*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 10106*/       OPC_MoveParent,
/* 10107*/       OPC_Scope, 28, /*->10137*/ // 2 children in Scope
/* 10109*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10111*/        OPC_EmitMergeInputChains1_0,
/* 10112*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10115*/        OPC_EmitConvertToTarget, 1,
/* 10117*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10120*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10127*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10137*/       /*Scope*/ 28, /*->10166*/
/* 10138*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10140*/        OPC_EmitMergeInputChains1_0,
/* 10141*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10144*/        OPC_EmitConvertToTarget, 1,
/* 10146*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10149*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 10156*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10166*/       0, /*End of Scope*/
/* 10167*/      0, /*End of Scope*/
/* 10168*/     /*Scope*/ 56, /*->10225*/
/* 10169*/      OPC_CheckChild1Type, MVT::i32,
/* 10171*/      OPC_MoveChild2,
/* 10172*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10175*/      OPC_RecordChild0, // #2 = $val
/* 10176*/      OPC_MoveParent,
/* 10177*/      OPC_Scope, 22, /*->10201*/ // 2 children in Scope
/* 10179*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 10181*/       OPC_MoveParent,
/* 10182*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10184*/       OPC_EmitMergeInputChains1_0,
/* 10185*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10188*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10191*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10201*/      /*Scope*/ 22, /*->10224*/
/* 10202*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 10204*/       OPC_MoveParent,
/* 10205*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10207*/       OPC_EmitMergeInputChains1_0,
/* 10208*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10211*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10214*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10224*/      0, /*End of Scope*/
/* 10225*/     /*Scope*/ 56, /*->10282*/
/* 10226*/      OPC_CheckChild1Type, MVT::i64,
/* 10228*/      OPC_MoveChild2,
/* 10229*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10232*/      OPC_RecordChild0, // #2 = $val
/* 10233*/      OPC_MoveParent,
/* 10234*/      OPC_Scope, 22, /*->10258*/ // 2 children in Scope
/* 10236*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 10238*/       OPC_MoveParent,
/* 10239*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10241*/       OPC_EmitMergeInputChains1_0,
/* 10242*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10245*/       OPC_EmitInteger, MVT::i64, 0, 
/* 10248*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10258*/      /*Scope*/ 22, /*->10281*/
/* 10259*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 10261*/       OPC_MoveParent,
/* 10262*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10264*/       OPC_EmitMergeInputChains1_0,
/* 10265*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10268*/       OPC_EmitInteger, MVT::i64, 0, 
/* 10271*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10281*/      0, /*End of Scope*/
/* 10282*/     0, /*End of Scope*/
/* 10283*/    0, /*End of Scope*/
/* 10284*/   /*SwitchOpcode*/ 18|128,5/*658*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->10946
/* 10288*/    OPC_RecordMemRef,
/* 10289*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 10290*/    OPC_Scope, 6|128,3/*390*/, /*->10683*/ // 2 children in Scope
/* 10293*/     OPC_MoveChild1,
/* 10294*/     OPC_SwitchOpcode /*3 cases */, 121, TARGET_VAL(ISD::ADD),// ->10419
/* 10298*/      OPC_RecordChild0, // #1 = $addr
/* 10299*/      OPC_RecordChild1, // #2 = $off
/* 10300*/      OPC_MoveChild1,
/* 10301*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10304*/      OPC_MoveParent,
/* 10305*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 10307*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->10363
/* 10310*/       OPC_MoveParent,
/* 10311*/       OPC_MoveChild2,
/* 10312*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10315*/       OPC_RecordChild0, // #3 = $val
/* 10316*/       OPC_MoveParent,
/* 10317*/       OPC_Scope, 21, /*->10340*/ // 2 children in Scope
/* 10319*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10321*/        OPC_MoveParent,
/* 10322*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10324*/        OPC_EmitMergeInputChains1_0,
/* 10325*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10328*/        OPC_EmitConvertToTarget, 2,
/* 10330*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10340*/       /*Scope*/ 21, /*->10362*/
/* 10341*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10343*/        OPC_MoveParent,
/* 10344*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10346*/        OPC_EmitMergeInputChains1_0,
/* 10347*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10350*/        OPC_EmitConvertToTarget, 2,
/* 10352*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10362*/       0, /*End of Scope*/
/* 10363*/      /*SwitchType*/ 53, MVT::i64,// ->10418
/* 10365*/       OPC_MoveParent,
/* 10366*/       OPC_MoveChild2,
/* 10367*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10370*/       OPC_RecordChild0, // #3 = $val
/* 10371*/       OPC_MoveParent,
/* 10372*/       OPC_Scope, 21, /*->10395*/ // 2 children in Scope
/* 10374*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10376*/        OPC_MoveParent,
/* 10377*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10379*/        OPC_EmitMergeInputChains1_0,
/* 10380*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10383*/        OPC_EmitConvertToTarget, 2,
/* 10385*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10395*/       /*Scope*/ 21, /*->10417*/
/* 10396*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10398*/        OPC_MoveParent,
/* 10399*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10401*/        OPC_EmitMergeInputChains1_0,
/* 10402*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10405*/        OPC_EmitConvertToTarget, 2,
/* 10407*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10417*/       0, /*End of Scope*/
/* 10418*/      0, // EndSwitchType
/* 10419*/     /*SwitchOpcode*/ 121, TARGET_VAL(ISD::OR),// ->10543
/* 10422*/      OPC_RecordChild0, // #1 = $addr
/* 10423*/      OPC_RecordChild1, // #2 = $off
/* 10424*/      OPC_MoveChild1,
/* 10425*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10428*/      OPC_MoveParent,
/* 10429*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 10431*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->10487
/* 10434*/       OPC_MoveParent,
/* 10435*/       OPC_MoveChild2,
/* 10436*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10439*/       OPC_RecordChild0, // #3 = $val
/* 10440*/       OPC_MoveParent,
/* 10441*/       OPC_Scope, 21, /*->10464*/ // 2 children in Scope
/* 10443*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10445*/        OPC_MoveParent,
/* 10446*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10448*/        OPC_EmitMergeInputChains1_0,
/* 10449*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10452*/        OPC_EmitConvertToTarget, 2,
/* 10454*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10464*/       /*Scope*/ 21, /*->10486*/
/* 10465*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10467*/        OPC_MoveParent,
/* 10468*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10470*/        OPC_EmitMergeInputChains1_0,
/* 10471*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10474*/        OPC_EmitConvertToTarget, 2,
/* 10476*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10486*/       0, /*End of Scope*/
/* 10487*/      /*SwitchType*/ 53, MVT::i64,// ->10542
/* 10489*/       OPC_MoveParent,
/* 10490*/       OPC_MoveChild2,
/* 10491*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10494*/       OPC_RecordChild0, // #3 = $val
/* 10495*/       OPC_MoveParent,
/* 10496*/       OPC_Scope, 21, /*->10519*/ // 2 children in Scope
/* 10498*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10500*/        OPC_MoveParent,
/* 10501*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10503*/        OPC_EmitMergeInputChains1_0,
/* 10504*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10507*/        OPC_EmitConvertToTarget, 2,
/* 10509*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10519*/       /*Scope*/ 21, /*->10541*/
/* 10520*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10522*/        OPC_MoveParent,
/* 10523*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10525*/        OPC_EmitMergeInputChains1_0,
/* 10526*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10529*/        OPC_EmitConvertToTarget, 2,
/* 10531*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10541*/       0, /*End of Scope*/
/* 10542*/      0, // EndSwitchType
/* 10543*/     /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->10682
/* 10547*/      OPC_RecordChild0, // #1 = $off
/* 10548*/      OPC_MoveChild0,
/* 10549*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10552*/      OPC_MoveParent,
/* 10553*/      OPC_MoveParent,
/* 10554*/      OPC_MoveChild2,
/* 10555*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10558*/      OPC_RecordChild0, // #2 = $val
/* 10559*/      OPC_MoveParent,
/* 10560*/      OPC_Scope, 59, /*->10621*/ // 2 children in Scope
/* 10562*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10564*/       OPC_MoveParent,
/* 10565*/       OPC_Scope, 26, /*->10593*/ // 2 children in Scope
/* 10567*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 10569*/        OPC_EmitMergeInputChains1_0,
/* 10570*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10573*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10576*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 10583*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10593*/       /*Scope*/ 26, /*->10620*/
/* 10594*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 10596*/        OPC_EmitMergeInputChains1_0,
/* 10597*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10600*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10603*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 10610*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10620*/       0, /*End of Scope*/
/* 10621*/      /*Scope*/ 59, /*->10681*/
/* 10622*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10624*/       OPC_MoveParent,
/* 10625*/       OPC_Scope, 26, /*->10653*/ // 2 children in Scope
/* 10627*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 10629*/        OPC_EmitMergeInputChains1_0,
/* 10630*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10633*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10636*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 10643*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10653*/       /*Scope*/ 26, /*->10680*/
/* 10654*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 10656*/        OPC_EmitMergeInputChains1_0,
/* 10657*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10660*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10663*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 10670*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10680*/       0, /*End of Scope*/
/* 10681*/      0, /*End of Scope*/
/* 10682*/     0, // EndSwitchOpcode
/* 10683*/    /*Scope*/ 4|128,2/*260*/, /*->10945*/
/* 10685*/     OPC_RecordChild1, // #1 = $off
/* 10686*/     OPC_Scope, 13|128,1/*141*/, /*->10830*/ // 3 children in Scope
/* 10689*/      OPC_MoveChild1,
/* 10690*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10693*/      OPC_MoveParent,
/* 10694*/      OPC_MoveChild2,
/* 10695*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10698*/      OPC_RecordChild0, // #2 = $val
/* 10699*/      OPC_MoveParent,
/* 10700*/      OPC_Scope, 63, /*->10765*/ // 2 children in Scope
/* 10702*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10704*/       OPC_MoveParent,
/* 10705*/       OPC_Scope, 28, /*->10735*/ // 2 children in Scope
/* 10707*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10709*/        OPC_EmitMergeInputChains1_0,
/* 10710*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10713*/        OPC_EmitConvertToTarget, 1,
/* 10715*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10718*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10725*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10735*/       /*Scope*/ 28, /*->10764*/
/* 10736*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10738*/        OPC_EmitMergeInputChains1_0,
/* 10739*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10742*/        OPC_EmitConvertToTarget, 1,
/* 10744*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10747*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 10754*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10764*/       0, /*End of Scope*/
/* 10765*/      /*Scope*/ 63, /*->10829*/
/* 10766*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10768*/       OPC_MoveParent,
/* 10769*/       OPC_Scope, 28, /*->10799*/ // 2 children in Scope
/* 10771*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10773*/        OPC_EmitMergeInputChains1_0,
/* 10774*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10777*/        OPC_EmitConvertToTarget, 1,
/* 10779*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10782*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10789*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10799*/       /*Scope*/ 28, /*->10828*/
/* 10800*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10802*/        OPC_EmitMergeInputChains1_0,
/* 10803*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10806*/        OPC_EmitConvertToTarget, 1,
/* 10808*/        OPC_EmitInteger, MVT::i64, 0, 
/* 10811*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 10818*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 10828*/       0, /*End of Scope*/
/* 10829*/      0, /*End of Scope*/
/* 10830*/     /*Scope*/ 56, /*->10887*/
/* 10831*/      OPC_CheckChild1Type, MVT::i32,
/* 10833*/      OPC_MoveChild2,
/* 10834*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10837*/      OPC_RecordChild0, // #2 = $val
/* 10838*/      OPC_MoveParent,
/* 10839*/      OPC_Scope, 22, /*->10863*/ // 2 children in Scope
/* 10841*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10843*/       OPC_MoveParent,
/* 10844*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10846*/       OPC_EmitMergeInputChains1_0,
/* 10847*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10850*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10853*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10863*/      /*Scope*/ 22, /*->10886*/
/* 10864*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10866*/       OPC_MoveParent,
/* 10867*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10869*/       OPC_EmitMergeInputChains1_0,
/* 10870*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10873*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10876*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 10886*/      0, /*End of Scope*/
/* 10887*/     /*Scope*/ 56, /*->10944*/
/* 10888*/      OPC_CheckChild1Type, MVT::i64,
/* 10890*/      OPC_MoveChild2,
/* 10891*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10894*/      OPC_RecordChild0, // #2 = $val
/* 10895*/      OPC_MoveParent,
/* 10896*/      OPC_Scope, 22, /*->10920*/ // 2 children in Scope
/* 10898*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10900*/       OPC_MoveParent,
/* 10901*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10903*/       OPC_EmitMergeInputChains1_0,
/* 10904*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10907*/       OPC_EmitInteger, MVT::i64, 0, 
/* 10910*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10920*/      /*Scope*/ 22, /*->10943*/
/* 10921*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10923*/       OPC_MoveParent,
/* 10924*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10926*/       OPC_EmitMergeInputChains1_0,
/* 10927*/       OPC_EmitInteger, MVT::i32, 0, 
/* 10930*/       OPC_EmitInteger, MVT::i64, 0, 
/* 10933*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 10943*/      0, /*End of Scope*/
/* 10944*/     0, /*End of Scope*/
/* 10945*/    0, /*End of Scope*/
/* 10946*/   /*SwitchOpcode*/ 18|128,5/*658*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->11608
/* 10950*/    OPC_RecordMemRef,
/* 10951*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 10952*/    OPC_Scope, 6|128,3/*390*/, /*->11345*/ // 2 children in Scope
/* 10955*/     OPC_MoveChild1,
/* 10956*/     OPC_SwitchOpcode /*3 cases */, 121, TARGET_VAL(ISD::ADD),// ->11081
/* 10960*/      OPC_RecordChild0, // #1 = $addr
/* 10961*/      OPC_RecordChild1, // #2 = $off
/* 10962*/      OPC_MoveChild1,
/* 10963*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10966*/      OPC_MoveParent,
/* 10967*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 10969*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->11025
/* 10972*/       OPC_MoveParent,
/* 10973*/       OPC_MoveChild2,
/* 10974*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10977*/       OPC_RecordChild0, // #3 = $val
/* 10978*/       OPC_MoveParent,
/* 10979*/       OPC_Scope, 21, /*->11002*/ // 2 children in Scope
/* 10981*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 10983*/        OPC_MoveParent,
/* 10984*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10986*/        OPC_EmitMergeInputChains1_0,
/* 10987*/        OPC_EmitInteger, MVT::i32, 0, 
/* 10990*/        OPC_EmitConvertToTarget, 2,
/* 10992*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11002*/       /*Scope*/ 21, /*->11024*/
/* 11003*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11005*/        OPC_MoveParent,
/* 11006*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11008*/        OPC_EmitMergeInputChains1_0,
/* 11009*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11012*/        OPC_EmitConvertToTarget, 2,
/* 11014*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11024*/       0, /*End of Scope*/
/* 11025*/      /*SwitchType*/ 53, MVT::i64,// ->11080
/* 11027*/       OPC_MoveParent,
/* 11028*/       OPC_MoveChild2,
/* 11029*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11032*/       OPC_RecordChild0, // #3 = $val
/* 11033*/       OPC_MoveParent,
/* 11034*/       OPC_Scope, 21, /*->11057*/ // 2 children in Scope
/* 11036*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11038*/        OPC_MoveParent,
/* 11039*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11041*/        OPC_EmitMergeInputChains1_0,
/* 11042*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11045*/        OPC_EmitConvertToTarget, 2,
/* 11047*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11057*/       /*Scope*/ 21, /*->11079*/
/* 11058*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11060*/        OPC_MoveParent,
/* 11061*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11063*/        OPC_EmitMergeInputChains1_0,
/* 11064*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11067*/        OPC_EmitConvertToTarget, 2,
/* 11069*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11079*/       0, /*End of Scope*/
/* 11080*/      0, // EndSwitchType
/* 11081*/     /*SwitchOpcode*/ 121, TARGET_VAL(ISD::OR),// ->11205
/* 11084*/      OPC_RecordChild0, // #1 = $addr
/* 11085*/      OPC_RecordChild1, // #2 = $off
/* 11086*/      OPC_MoveChild1,
/* 11087*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11090*/      OPC_MoveParent,
/* 11091*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 11093*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->11149
/* 11096*/       OPC_MoveParent,
/* 11097*/       OPC_MoveChild2,
/* 11098*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11101*/       OPC_RecordChild0, // #3 = $val
/* 11102*/       OPC_MoveParent,
/* 11103*/       OPC_Scope, 21, /*->11126*/ // 2 children in Scope
/* 11105*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11107*/        OPC_MoveParent,
/* 11108*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11110*/        OPC_EmitMergeInputChains1_0,
/* 11111*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11114*/        OPC_EmitConvertToTarget, 2,
/* 11116*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11126*/       /*Scope*/ 21, /*->11148*/
/* 11127*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11129*/        OPC_MoveParent,
/* 11130*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11132*/        OPC_EmitMergeInputChains1_0,
/* 11133*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11136*/        OPC_EmitConvertToTarget, 2,
/* 11138*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11148*/       0, /*End of Scope*/
/* 11149*/      /*SwitchType*/ 53, MVT::i64,// ->11204
/* 11151*/       OPC_MoveParent,
/* 11152*/       OPC_MoveChild2,
/* 11153*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11156*/       OPC_RecordChild0, // #3 = $val
/* 11157*/       OPC_MoveParent,
/* 11158*/       OPC_Scope, 21, /*->11181*/ // 2 children in Scope
/* 11160*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11162*/        OPC_MoveParent,
/* 11163*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11165*/        OPC_EmitMergeInputChains1_0,
/* 11166*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11169*/        OPC_EmitConvertToTarget, 2,
/* 11171*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11181*/       /*Scope*/ 21, /*->11203*/
/* 11182*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11184*/        OPC_MoveParent,
/* 11185*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11187*/        OPC_EmitMergeInputChains1_0,
/* 11188*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11191*/        OPC_EmitConvertToTarget, 2,
/* 11193*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11203*/       0, /*End of Scope*/
/* 11204*/      0, // EndSwitchType
/* 11205*/     /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->11344
/* 11209*/      OPC_RecordChild0, // #1 = $off
/* 11210*/      OPC_MoveChild0,
/* 11211*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11214*/      OPC_MoveParent,
/* 11215*/      OPC_MoveParent,
/* 11216*/      OPC_MoveChild2,
/* 11217*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11220*/      OPC_RecordChild0, // #2 = $val
/* 11221*/      OPC_MoveParent,
/* 11222*/      OPC_Scope, 59, /*->11283*/ // 2 children in Scope
/* 11224*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11226*/       OPC_MoveParent,
/* 11227*/       OPC_Scope, 26, /*->11255*/ // 2 children in Scope
/* 11229*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11231*/        OPC_EmitMergeInputChains1_0,
/* 11232*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11235*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11238*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 11245*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 11255*/       /*Scope*/ 26, /*->11282*/
/* 11256*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11258*/        OPC_EmitMergeInputChains1_0,
/* 11259*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11262*/        OPC_EmitInteger, MVT::i64, 0, 
/* 11265*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 11272*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 11282*/       0, /*End of Scope*/
/* 11283*/      /*Scope*/ 59, /*->11343*/
/* 11284*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11286*/       OPC_MoveParent,
/* 11287*/       OPC_Scope, 26, /*->11315*/ // 2 children in Scope
/* 11289*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11291*/        OPC_EmitMergeInputChains1_0,
/* 11292*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11295*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11298*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 11305*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 11315*/       /*Scope*/ 26, /*->11342*/
/* 11316*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11318*/        OPC_EmitMergeInputChains1_0,
/* 11319*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11322*/        OPC_EmitInteger, MVT::i64, 0, 
/* 11325*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 11332*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 11342*/       0, /*End of Scope*/
/* 11343*/      0, /*End of Scope*/
/* 11344*/     0, // EndSwitchOpcode
/* 11345*/    /*Scope*/ 4|128,2/*260*/, /*->11607*/
/* 11347*/     OPC_RecordChild1, // #1 = $off
/* 11348*/     OPC_Scope, 13|128,1/*141*/, /*->11492*/ // 3 children in Scope
/* 11351*/      OPC_MoveChild1,
/* 11352*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11355*/      OPC_MoveParent,
/* 11356*/      OPC_MoveChild2,
/* 11357*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11360*/      OPC_RecordChild0, // #2 = $val
/* 11361*/      OPC_MoveParent,
/* 11362*/      OPC_Scope, 63, /*->11427*/ // 2 children in Scope
/* 11364*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11366*/       OPC_MoveParent,
/* 11367*/       OPC_Scope, 28, /*->11397*/ // 2 children in Scope
/* 11369*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11371*/        OPC_EmitMergeInputChains1_0,
/* 11372*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11375*/        OPC_EmitConvertToTarget, 1,
/* 11377*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11380*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 11387*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 11397*/       /*Scope*/ 28, /*->11426*/
/* 11398*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11400*/        OPC_EmitMergeInputChains1_0,
/* 11401*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11404*/        OPC_EmitConvertToTarget, 1,
/* 11406*/        OPC_EmitInteger, MVT::i64, 0, 
/* 11409*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 11416*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 11426*/       0, /*End of Scope*/
/* 11427*/      /*Scope*/ 63, /*->11491*/
/* 11428*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11430*/       OPC_MoveParent,
/* 11431*/       OPC_Scope, 28, /*->11461*/ // 2 children in Scope
/* 11433*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11435*/        OPC_EmitMergeInputChains1_0,
/* 11436*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11439*/        OPC_EmitConvertToTarget, 1,
/* 11441*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11444*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 11451*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 11461*/       /*Scope*/ 28, /*->11490*/
/* 11462*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11464*/        OPC_EmitMergeInputChains1_0,
/* 11465*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11468*/        OPC_EmitConvertToTarget, 1,
/* 11470*/        OPC_EmitInteger, MVT::i64, 0, 
/* 11473*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 11480*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 11490*/       0, /*End of Scope*/
/* 11491*/      0, /*End of Scope*/
/* 11492*/     /*Scope*/ 56, /*->11549*/
/* 11493*/      OPC_CheckChild1Type, MVT::i32,
/* 11495*/      OPC_MoveChild2,
/* 11496*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11499*/      OPC_RecordChild0, // #2 = $val
/* 11500*/      OPC_MoveParent,
/* 11501*/      OPC_Scope, 22, /*->11525*/ // 2 children in Scope
/* 11503*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11505*/       OPC_MoveParent,
/* 11506*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11508*/       OPC_EmitMergeInputChains1_0,
/* 11509*/       OPC_EmitInteger, MVT::i32, 0, 
/* 11512*/       OPC_EmitInteger, MVT::i32, 0, 
/* 11515*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11525*/      /*Scope*/ 22, /*->11548*/
/* 11526*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11528*/       OPC_MoveParent,
/* 11529*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11531*/       OPC_EmitMergeInputChains1_0,
/* 11532*/       OPC_EmitInteger, MVT::i32, 0, 
/* 11535*/       OPC_EmitInteger, MVT::i32, 0, 
/* 11538*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11548*/      0, /*End of Scope*/
/* 11549*/     /*Scope*/ 56, /*->11606*/
/* 11550*/      OPC_CheckChild1Type, MVT::i64,
/* 11552*/      OPC_MoveChild2,
/* 11553*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11556*/      OPC_RecordChild0, // #2 = $val
/* 11557*/      OPC_MoveParent,
/* 11558*/      OPC_Scope, 22, /*->11582*/ // 2 children in Scope
/* 11560*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11562*/       OPC_MoveParent,
/* 11563*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11565*/       OPC_EmitMergeInputChains1_0,
/* 11566*/       OPC_EmitInteger, MVT::i32, 0, 
/* 11569*/       OPC_EmitInteger, MVT::i64, 0, 
/* 11572*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11582*/      /*Scope*/ 22, /*->11605*/
/* 11583*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11585*/       OPC_MoveParent,
/* 11586*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11588*/       OPC_EmitMergeInputChains1_0,
/* 11589*/       OPC_EmitInteger, MVT::i32, 0, 
/* 11592*/       OPC_EmitInteger, MVT::i64, 0, 
/* 11595*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11605*/      0, /*End of Scope*/
/* 11606*/     0, /*End of Scope*/
/* 11607*/    0, /*End of Scope*/
/* 11608*/   /*SwitchOpcode*/ 18|128,5/*658*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->12270
/* 11612*/    OPC_RecordMemRef,
/* 11613*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 11614*/    OPC_Scope, 6|128,3/*390*/, /*->12007*/ // 2 children in Scope
/* 11617*/     OPC_MoveChild1,
/* 11618*/     OPC_SwitchOpcode /*3 cases */, 121, TARGET_VAL(ISD::ADD),// ->11743
/* 11622*/      OPC_RecordChild0, // #1 = $addr
/* 11623*/      OPC_RecordChild1, // #2 = $off
/* 11624*/      OPC_MoveChild1,
/* 11625*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11628*/      OPC_MoveParent,
/* 11629*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 11631*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->11687
/* 11634*/       OPC_MoveParent,
/* 11635*/       OPC_MoveChild2,
/* 11636*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11639*/       OPC_RecordChild0, // #3 = $val
/* 11640*/       OPC_MoveParent,
/* 11641*/       OPC_Scope, 21, /*->11664*/ // 2 children in Scope
/* 11643*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 11645*/        OPC_MoveParent,
/* 11646*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11648*/        OPC_EmitMergeInputChains1_0,
/* 11649*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11652*/        OPC_EmitConvertToTarget, 2,
/* 11654*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11664*/       /*Scope*/ 21, /*->11686*/
/* 11665*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 11667*/        OPC_MoveParent,
/* 11668*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11670*/        OPC_EmitMergeInputChains1_0,
/* 11671*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11674*/        OPC_EmitConvertToTarget, 2,
/* 11676*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11686*/       0, /*End of Scope*/
/* 11687*/      /*SwitchType*/ 53, MVT::i64,// ->11742
/* 11689*/       OPC_MoveParent,
/* 11690*/       OPC_MoveChild2,
/* 11691*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11694*/       OPC_RecordChild0, // #3 = $val
/* 11695*/       OPC_MoveParent,
/* 11696*/       OPC_Scope, 21, /*->11719*/ // 2 children in Scope
/* 11698*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 11700*/        OPC_MoveParent,
/* 11701*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11703*/        OPC_EmitMergeInputChains1_0,
/* 11704*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11707*/        OPC_EmitConvertToTarget, 2,
/* 11709*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11719*/       /*Scope*/ 21, /*->11741*/
/* 11720*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 11722*/        OPC_MoveParent,
/* 11723*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11725*/        OPC_EmitMergeInputChains1_0,
/* 11726*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11729*/        OPC_EmitConvertToTarget, 2,
/* 11731*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11741*/       0, /*End of Scope*/
/* 11742*/      0, // EndSwitchType
/* 11743*/     /*SwitchOpcode*/ 121, TARGET_VAL(ISD::OR),// ->11867
/* 11746*/      OPC_RecordChild0, // #1 = $addr
/* 11747*/      OPC_RecordChild1, // #2 = $off
/* 11748*/      OPC_MoveChild1,
/* 11749*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11752*/      OPC_MoveParent,
/* 11753*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 11755*/      OPC_SwitchType /*2 cases */, 53, MVT::i32,// ->11811
/* 11758*/       OPC_MoveParent,
/* 11759*/       OPC_MoveChild2,
/* 11760*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11763*/       OPC_RecordChild0, // #3 = $val
/* 11764*/       OPC_MoveParent,
/* 11765*/       OPC_Scope, 21, /*->11788*/ // 2 children in Scope
/* 11767*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 11769*/        OPC_MoveParent,
/* 11770*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11772*/        OPC_EmitMergeInputChains1_0,
/* 11773*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11776*/        OPC_EmitConvertToTarget, 2,
/* 11778*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11788*/       /*Scope*/ 21, /*->11810*/
/* 11789*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 11791*/        OPC_MoveParent,
/* 11792*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11794*/        OPC_EmitMergeInputChains1_0,
/* 11795*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11798*/        OPC_EmitConvertToTarget, 2,
/* 11800*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 11810*/       0, /*End of Scope*/
/* 11811*/      /*SwitchType*/ 53, MVT::i64,// ->11866
/* 11813*/       OPC_MoveParent,
/* 11814*/       OPC_MoveChild2,
/* 11815*/       OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11818*/       OPC_RecordChild0, // #3 = $val
/* 11819*/       OPC_MoveParent,
/* 11820*/       OPC_Scope, 21, /*->11843*/ // 2 children in Scope
/* 11822*/        OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 11824*/        OPC_MoveParent,
/* 11825*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11827*/        OPC_EmitMergeInputChains1_0,
/* 11828*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11831*/        OPC_EmitConvertToTarget, 2,
/* 11833*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11843*/       /*Scope*/ 21, /*->11865*/
/* 11844*/        OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 11846*/        OPC_MoveParent,
/* 11847*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 11849*/        OPC_EmitMergeInputChains1_0,
/* 11850*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11853*/        OPC_EmitConvertToTarget, 2,
/* 11855*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 11865*/       0, /*End of Scope*/
/* 11866*/      0, // EndSwitchType
/* 11867*/     /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->12006
/* 11871*/      OPC_RecordChild0, // #1 = $off
/* 11872*/      OPC_MoveChild0,
/* 11873*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11876*/      OPC_MoveParent,
/* 11877*/      OPC_MoveParent,
/* 11878*/      OPC_MoveChild2,
/* 11879*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 11882*/      OPC_RecordChild0, // #2 = $val
/* 11883*/      OPC_MoveParent,
/* 11884*/      OPC_Scope, 59, /*->11945*/ // 2 children in Scope
/* 11886*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 11888*/       OPC_MoveParent,
/* 11889*/       OPC_Scope, 26, /*->11917*/ // 2 children in Scope
/* 11891*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11893*/        OPC_EmitMergeInputChains1_0,
/* 11894*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11897*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11900*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 11907*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 11917*/       /*Scope*/ 26, /*->11944*/
/* 11918*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11920*/        OPC_EmitMergeInputChains1_0,
/* 11921*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11924*/        OPC_EmitInteger, MVT::i64, 0, 
/* 11927*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 11934*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 11944*/       0, /*End of Scope*/
/* 11945*/      /*Scope*/ 59, /*->12005*/
/* 11946*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 11948*/       OPC_MoveParent,
/* 11949*/       OPC_Scope, 26, /*->11977*/ // 2 children in Scope
/* 11951*/        OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11953*/        OPC_EmitMergeInputChains1_0,
/* 11954*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11957*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11960*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 11967*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 11977*/       /*Scope*/ 26, /*->12004*/
/* 11978*/        OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 11980*/        OPC_EmitMergeInputChains1_0,
/* 11981*/        OPC_EmitInteger, MVT::i32, 0, 
/* 11984*/        OPC_EmitInteger, MVT::i64, 0, 
/* 11987*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 11994*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 16
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 12004*/       0, /*End of Scope*/
/* 12005*/      0, /*End of Scope*/
/* 12006*/     0, // EndSwitchOpcode
/* 12007*/    /*Scope*/ 4|128,2/*260*/, /*->12269*/
/* 12009*/     OPC_RecordChild1, // #1 = $off
/* 12010*/     OPC_Scope, 13|128,1/*141*/, /*->12154*/ // 3 children in Scope
/* 12013*/      OPC_MoveChild1,
/* 12014*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12017*/      OPC_MoveParent,
/* 12018*/      OPC_MoveChild2,
/* 12019*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12022*/      OPC_RecordChild0, // #2 = $val
/* 12023*/      OPC_MoveParent,
/* 12024*/      OPC_Scope, 63, /*->12089*/ // 2 children in Scope
/* 12026*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 12028*/       OPC_MoveParent,
/* 12029*/       OPC_Scope, 28, /*->12059*/ // 2 children in Scope
/* 12031*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12033*/        OPC_EmitMergeInputChains1_0,
/* 12034*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12037*/        OPC_EmitConvertToTarget, 1,
/* 12039*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12042*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 12049*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 12059*/       /*Scope*/ 28, /*->12088*/
/* 12060*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12062*/        OPC_EmitMergeInputChains1_0,
/* 12063*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12066*/        OPC_EmitConvertToTarget, 1,
/* 12068*/        OPC_EmitInteger, MVT::i64, 0, 
/* 12071*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 12078*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 12088*/       0, /*End of Scope*/
/* 12089*/      /*Scope*/ 63, /*->12153*/
/* 12090*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 12092*/       OPC_MoveParent,
/* 12093*/       OPC_Scope, 28, /*->12123*/ // 2 children in Scope
/* 12095*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12097*/        OPC_EmitMergeInputChains1_0,
/* 12098*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12101*/        OPC_EmitConvertToTarget, 1,
/* 12103*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12106*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 12113*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 12123*/       /*Scope*/ 28, /*->12152*/
/* 12124*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12126*/        OPC_EmitMergeInputChains1_0,
/* 12127*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12130*/        OPC_EmitConvertToTarget, 1,
/* 12132*/        OPC_EmitInteger, MVT::i64, 0, 
/* 12135*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 12142*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 13
                  // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 12152*/       0, /*End of Scope*/
/* 12153*/      0, /*End of Scope*/
/* 12154*/     /*Scope*/ 56, /*->12211*/
/* 12155*/      OPC_CheckChild1Type, MVT::i32,
/* 12157*/      OPC_MoveChild2,
/* 12158*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12161*/      OPC_RecordChild0, // #2 = $val
/* 12162*/      OPC_MoveParent,
/* 12163*/      OPC_Scope, 22, /*->12187*/ // 2 children in Scope
/* 12165*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 12167*/       OPC_MoveParent,
/* 12168*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12170*/       OPC_EmitMergeInputChains1_0,
/* 12171*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12174*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12177*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12187*/      /*Scope*/ 22, /*->12210*/
/* 12188*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 12190*/       OPC_MoveParent,
/* 12191*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12193*/       OPC_EmitMergeInputChains1_0,
/* 12194*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12197*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12200*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12210*/      0, /*End of Scope*/
/* 12211*/     /*Scope*/ 56, /*->12268*/
/* 12212*/      OPC_CheckChild1Type, MVT::i64,
/* 12214*/      OPC_MoveChild2,
/* 12215*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12218*/      OPC_RecordChild0, // #2 = $val
/* 12219*/      OPC_MoveParent,
/* 12220*/      OPC_Scope, 22, /*->12244*/ // 2 children in Scope
/* 12222*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 12224*/       OPC_MoveParent,
/* 12225*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12227*/       OPC_EmitMergeInputChains1_0,
/* 12228*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12231*/       OPC_EmitInteger, MVT::i64, 0, 
/* 12234*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 12244*/      /*Scope*/ 22, /*->12267*/
/* 12245*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 12247*/       OPC_MoveParent,
/* 12248*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 12250*/       OPC_EmitMergeInputChains1_0,
/* 12251*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12254*/       OPC_EmitInteger, MVT::i64, 0, 
/* 12257*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                 // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 12267*/      0, /*End of Scope*/
/* 12268*/     0, /*End of Scope*/
/* 12269*/    0, /*End of Scope*/
/* 12270*/   /*SwitchOpcode*/ 77|128,4/*589*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->12863
/* 12274*/    OPC_RecordMemRef,
/* 12275*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 12276*/    OPC_Scope, 91|128,2/*347*/, /*->12626*/ // 2 children in Scope
/* 12279*/     OPC_MoveChild1,
/* 12280*/     OPC_SwitchOpcode /*3 cases */, 105, TARGET_VAL(ISD::ADD),// ->12389
/* 12284*/      OPC_RecordChild0, // #1 = $addr
/* 12285*/      OPC_RecordChild1, // #2 = $off
/* 12286*/      OPC_MoveChild1,
/* 12287*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12290*/      OPC_MoveParent,
/* 12291*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 12293*/      OPC_SwitchType /*2 cases */, 45, MVT::i32,// ->12341
/* 12296*/       OPC_MoveParent,
/* 12297*/       OPC_Scope, 20, /*->12319*/ // 2 children in Scope
/* 12299*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12301*/        OPC_MoveParent,
/* 12302*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12304*/        OPC_EmitMergeInputChains1_0,
/* 12305*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12308*/        OPC_EmitConvertToTarget, 2,
/* 12310*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 12319*/       /*Scope*/ 20, /*->12340*/
/* 12320*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12322*/        OPC_MoveParent,
/* 12323*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12325*/        OPC_EmitMergeInputChains1_0,
/* 12326*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12329*/        OPC_EmitConvertToTarget, 2,
/* 12331*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 12340*/       0, /*End of Scope*/
/* 12341*/      /*SwitchType*/ 45, MVT::i64,// ->12388
/* 12343*/       OPC_MoveParent,
/* 12344*/       OPC_Scope, 20, /*->12366*/ // 2 children in Scope
/* 12346*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12348*/        OPC_MoveParent,
/* 12349*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12351*/        OPC_EmitMergeInputChains1_0,
/* 12352*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12355*/        OPC_EmitConvertToTarget, 2,
/* 12357*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 12366*/       /*Scope*/ 20, /*->12387*/
/* 12367*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12369*/        OPC_MoveParent,
/* 12370*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12372*/        OPC_EmitMergeInputChains1_0,
/* 12373*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12376*/        OPC_EmitConvertToTarget, 2,
/* 12378*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 12387*/       0, /*End of Scope*/
/* 12388*/      0, // EndSwitchType
/* 12389*/     /*SwitchOpcode*/ 105, TARGET_VAL(ISD::OR),// ->12497
/* 12392*/      OPC_RecordChild0, // #1 = $addr
/* 12393*/      OPC_RecordChild1, // #2 = $off
/* 12394*/      OPC_MoveChild1,
/* 12395*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12398*/      OPC_MoveParent,
/* 12399*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 12401*/      OPC_SwitchType /*2 cases */, 45, MVT::i32,// ->12449
/* 12404*/       OPC_MoveParent,
/* 12405*/       OPC_Scope, 20, /*->12427*/ // 2 children in Scope
/* 12407*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12409*/        OPC_MoveParent,
/* 12410*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12412*/        OPC_EmitMergeInputChains1_0,
/* 12413*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12416*/        OPC_EmitConvertToTarget, 2,
/* 12418*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 12427*/       /*Scope*/ 20, /*->12448*/
/* 12428*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12430*/        OPC_MoveParent,
/* 12431*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12433*/        OPC_EmitMergeInputChains1_0,
/* 12434*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12437*/        OPC_EmitConvertToTarget, 2,
/* 12439*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 12448*/       0, /*End of Scope*/
/* 12449*/      /*SwitchType*/ 45, MVT::i64,// ->12496
/* 12451*/       OPC_MoveParent,
/* 12452*/       OPC_Scope, 20, /*->12474*/ // 2 children in Scope
/* 12454*/        OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12456*/        OPC_MoveParent,
/* 12457*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12459*/        OPC_EmitMergeInputChains1_0,
/* 12460*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12463*/        OPC_EmitConvertToTarget, 2,
/* 12465*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 12474*/       /*Scope*/ 20, /*->12495*/
/* 12475*/        OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12477*/        OPC_MoveParent,
/* 12478*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12480*/        OPC_EmitMergeInputChains1_0,
/* 12481*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12484*/        OPC_EmitConvertToTarget, 2,
/* 12486*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 12495*/       0, /*End of Scope*/
/* 12496*/      0, // EndSwitchType
/* 12497*/     /*SwitchOpcode*/ 125, TARGET_VAL(WebAssemblyISD::Wrapper),// ->12625
/* 12500*/      OPC_RecordChild0, // #1 = $off
/* 12501*/      OPC_MoveChild0,
/* 12502*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12505*/      OPC_MoveParent,
/* 12506*/      OPC_MoveParent,
/* 12507*/      OPC_Scope, 57, /*->12566*/ // 2 children in Scope
/* 12509*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12511*/       OPC_MoveParent,
/* 12512*/       OPC_Scope, 25, /*->12539*/ // 2 children in Scope
/* 12514*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12516*/        OPC_EmitMergeInputChains1_0,
/* 12517*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12520*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12523*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 12530*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 12539*/       /*Scope*/ 25, /*->12565*/
/* 12540*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12542*/        OPC_EmitMergeInputChains1_0,
/* 12543*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12546*/        OPC_EmitInteger, MVT::i64, 0, 
/* 12549*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 12556*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 12565*/       0, /*End of Scope*/
/* 12566*/      /*Scope*/ 57, /*->12624*/
/* 12567*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12569*/       OPC_MoveParent,
/* 12570*/       OPC_Scope, 25, /*->12597*/ // 2 children in Scope
/* 12572*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12574*/        OPC_EmitMergeInputChains1_0,
/* 12575*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12578*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12581*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 12588*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 12597*/       /*Scope*/ 25, /*->12623*/
/* 12598*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 12600*/        OPC_EmitMergeInputChains1_0,
/* 12601*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12604*/        OPC_EmitInteger, MVT::i64, 0, 
/* 12607*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 12614*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>) - Complexity = 13
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 12623*/       0, /*End of Scope*/
/* 12624*/      0, /*End of Scope*/
/* 12625*/     0, // EndSwitchOpcode
/* 12626*/    /*Scope*/ 106|128,1/*234*/, /*->12862*/
/* 12628*/     OPC_RecordChild1, // #1 = $off
/* 12629*/     OPC_Scope, 3|128,1/*131*/, /*->12763*/ // 3 children in Scope
/* 12632*/      OPC_MoveChild1,
/* 12633*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12636*/      OPC_MoveParent,
/* 12637*/      OPC_Scope, 61, /*->12700*/ // 2 children in Scope
/* 12639*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12641*/       OPC_MoveParent,
/* 12642*/       OPC_Scope, 27, /*->12671*/ // 2 children in Scope
/* 12644*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12646*/        OPC_EmitMergeInputChains1_0,
/* 12647*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12650*/        OPC_EmitConvertToTarget, 1,
/* 12652*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12655*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 12662*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 12671*/       /*Scope*/ 27, /*->12699*/
/* 12672*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12674*/        OPC_EmitMergeInputChains1_0,
/* 12675*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12678*/        OPC_EmitConvertToTarget, 1,
/* 12680*/        OPC_EmitInteger, MVT::i64, 0, 
/* 12683*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 12690*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 12699*/       0, /*End of Scope*/
/* 12700*/      /*Scope*/ 61, /*->12762*/
/* 12701*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12703*/       OPC_MoveParent,
/* 12704*/       OPC_Scope, 27, /*->12733*/ // 2 children in Scope
/* 12706*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12708*/        OPC_EmitMergeInputChains1_0,
/* 12709*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12712*/        OPC_EmitConvertToTarget, 1,
/* 12714*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12717*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 12724*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 12733*/       /*Scope*/ 27, /*->12761*/
/* 12734*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12736*/        OPC_EmitMergeInputChains1_0,
/* 12737*/        OPC_EmitInteger, MVT::i32, 0, 
/* 12740*/        OPC_EmitConvertToTarget, 1,
/* 12742*/        OPC_EmitInteger, MVT::i64, 0, 
/* 12745*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 12752*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>) - Complexity = 10
                  // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 12761*/       0, /*End of Scope*/
/* 12762*/      0, /*End of Scope*/
/* 12763*/     /*Scope*/ 48, /*->12812*/
/* 12764*/      OPC_CheckChild1Type, MVT::i32,
/* 12766*/      OPC_Scope, 21, /*->12789*/ // 2 children in Scope
/* 12768*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12770*/       OPC_MoveParent,
/* 12771*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12773*/       OPC_EmitMergeInputChains1_0,
/* 12774*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12777*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12780*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 12789*/      /*Scope*/ 21, /*->12811*/
/* 12790*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12792*/       OPC_MoveParent,
/* 12793*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 12795*/       OPC_EmitMergeInputChains1_0,
/* 12796*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12799*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12802*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 12811*/      0, /*End of Scope*/
/* 12812*/     /*Scope*/ 48, /*->12861*/
/* 12813*/      OPC_CheckChild1Type, MVT::i64,
/* 12815*/      OPC_Scope, 21, /*->12838*/ // 2 children in Scope
/* 12817*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 12819*/       OPC_MoveParent,
/* 12820*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12822*/       OPC_EmitMergeInputChains1_0,
/* 12823*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12826*/       OPC_EmitInteger, MVT::i64, 0, 
/* 12829*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_8>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 12838*/      /*Scope*/ 21, /*->12860*/
/* 12839*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 12841*/       OPC_MoveParent,
/* 12842*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 12844*/       OPC_EmitMergeInputChains1_0,
/* 12845*/       OPC_EmitInteger, MVT::i32, 0, 
/* 12848*/       OPC_EmitInteger, MVT::i64, 0, 
/* 12851*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_16>>) - Complexity = 7
                 // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 12860*/      0, /*End of Scope*/
/* 12861*/     0, /*End of Scope*/
/* 12862*/    0, /*End of Scope*/
/* 12863*/   0, // EndSwitchOpcode
/* 12864*/  /*Scope*/ 8, /*->12873*/
/* 12865*/   OPC_RecordChild0, // #0 = $src
/* 12866*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 12873*/  0, /*End of Scope*/
/* 12874*/ /*SwitchOpcode*/ 120|128,2/*376*/, TARGET_VAL(ISD::AND),// ->13254
/* 12878*/  OPC_Scope, 126, /*->13006*/ // 6 children in Scope
/* 12880*/   OPC_MoveChild0,
/* 12881*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/* 12884*/   OPC_Scope, 59, /*->12945*/ // 2 children in Scope
/* 12886*/    OPC_CheckChild0Integer, 16|128,13|128,1/*18064*/, 
/* 12890*/    OPC_RecordChild1, // #0 = $x
/* 12891*/    OPC_Scope, 12, /*->12905*/ // 4 children in Scope
/* 12893*/     OPC_CheckChild1Type, MVT::v16i8,
/* 12895*/     OPC_MoveParent,
/* 12896*/     OPC_CheckChild1Integer, 2, 
/* 12898*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/* 12905*/    /*Scope*/ 12, /*->12918*/
/* 12906*/     OPC_CheckChild1Type, MVT::v8i16,
/* 12908*/     OPC_MoveParent,
/* 12909*/     OPC_CheckChild1Integer, 2, 
/* 12911*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/* 12918*/    /*Scope*/ 12, /*->12931*/
/* 12919*/     OPC_CheckChild1Type, MVT::v4i32,
/* 12921*/     OPC_MoveParent,
/* 12922*/     OPC_CheckChild1Integer, 2, 
/* 12924*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/* 12931*/    /*Scope*/ 12, /*->12944*/
/* 12932*/     OPC_CheckChild1Type, MVT::v2i64,
/* 12934*/     OPC_MoveParent,
/* 12935*/     OPC_CheckChild1Integer, 2, 
/* 12937*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/* 12944*/    0, /*End of Scope*/
/* 12945*/   /*Scope*/ 59, /*->13005*/
/* 12946*/    OPC_CheckChild0Integer, 14|128,13|128,1/*18062*/, 
/* 12950*/    OPC_RecordChild1, // #0 = $x
/* 12951*/    OPC_Scope, 12, /*->12965*/ // 4 children in Scope
/* 12953*/     OPC_CheckChild1Type, MVT::v16i8,
/* 12955*/     OPC_MoveParent,
/* 12956*/     OPC_CheckChild1Integer, 2, 
/* 12958*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/* 12965*/    /*Scope*/ 12, /*->12978*/
/* 12966*/     OPC_CheckChild1Type, MVT::v8i16,
/* 12968*/     OPC_MoveParent,
/* 12969*/     OPC_CheckChild1Integer, 2, 
/* 12971*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/* 12978*/    /*Scope*/ 12, /*->12991*/
/* 12979*/     OPC_CheckChild1Type, MVT::v4i32,
/* 12981*/     OPC_MoveParent,
/* 12982*/     OPC_CheckChild1Integer, 2, 
/* 12984*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/* 12991*/    /*Scope*/ 12, /*->13004*/
/* 12992*/     OPC_CheckChild1Type, MVT::v2i64,
/* 12994*/     OPC_MoveParent,
/* 12995*/     OPC_CheckChild1Integer, 2, 
/* 12997*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/* 13004*/    0, /*End of Scope*/
/* 13005*/   0, /*End of Scope*/
/* 13006*/  /*Scope*/ 33, /*->13040*/
/* 13007*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13010*/   OPC_MoveChild0,
/* 13011*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 13014*/   OPC_RecordChild0, // #0 = $vec
/* 13015*/   OPC_CheckChild0Type, MVT::v16i8,
/* 13017*/   OPC_RecordChild1, // #1 = $idx
/* 13018*/   OPC_MoveChild1,
/* 13019*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13022*/   OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 13024*/   OPC_CheckType, MVT::i32,
/* 13026*/   OPC_MoveParent,
/* 13027*/   OPC_MoveParent,
/* 13028*/   OPC_CheckType, MVT::i32,
/* 13030*/   OPC_EmitConvertToTarget, 1,
/* 13032*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13040*/  /*Scope*/ 34, /*->13075*/
/* 13041*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13045*/   OPC_MoveChild0,
/* 13046*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 13049*/   OPC_RecordChild0, // #0 = $vec
/* 13050*/   OPC_CheckChild0Type, MVT::v8i16,
/* 13052*/   OPC_RecordChild1, // #1 = $idx
/* 13053*/   OPC_MoveChild1,
/* 13054*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13057*/   OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 13059*/   OPC_CheckType, MVT::i32,
/* 13061*/   OPC_MoveParent,
/* 13062*/   OPC_MoveParent,
/* 13063*/   OPC_CheckType, MVT::i32,
/* 13065*/   OPC_EmitConvertToTarget, 1,
/* 13067*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13075*/  /*Scope*/ 79, /*->13155*/
/* 13076*/   OPC_RecordChild0, // #0 = $lhs
/* 13077*/   OPC_Scope, 23, /*->13102*/ // 2 children in Scope
/* 13079*/    OPC_RecordChild1, // #1 = $rhs
/* 13080*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13091
/* 13083*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I32), 0,
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13091*/    /*SwitchType*/ 8, MVT::i64,// ->13101
/* 13093*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I64), 0,
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13101*/    0, // EndSwitchType
/* 13102*/   /*Scope*/ 51, /*->13154*/
/* 13103*/    OPC_MoveChild1,
/* 13104*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13107*/    OPC_RecordChild0, // #1 = $rhs
/* 13108*/    OPC_MoveChild1,
/* 13109*/    OPC_CheckImmAllOnesV,
/* 13110*/    OPC_MoveParent,
/* 13111*/    OPC_MoveParent,
/* 13112*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13123
/* 13115*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 13123*/    /*SwitchType*/ 8, MVT::v8i16,// ->13133
/* 13125*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 13133*/    /*SwitchType*/ 8, MVT::v4i32,// ->13143
/* 13135*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 13143*/    /*SwitchType*/ 8, MVT::v2i64,// ->13153
/* 13145*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 13153*/    0, // EndSwitchType
/* 13154*/   0, /*End of Scope*/
/* 13155*/  /*Scope*/ 52, /*->13208*/
/* 13156*/   OPC_MoveChild0,
/* 13157*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 13160*/   OPC_RecordChild0, // #0 = $rhs
/* 13161*/   OPC_MoveChild1,
/* 13162*/   OPC_CheckImmAllOnesV,
/* 13163*/   OPC_MoveParent,
/* 13164*/   OPC_MoveParent,
/* 13165*/   OPC_RecordChild1, // #1 = $lhs
/* 13166*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13177
/* 13169*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 13177*/   /*SwitchType*/ 8, MVT::v8i16,// ->13187
/* 13179*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 13187*/   /*SwitchType*/ 8, MVT::v4i32,// ->13197
/* 13189*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 13197*/   /*SwitchType*/ 8, MVT::v2i64,// ->13207
/* 13199*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 13207*/   0, // EndSwitchType
/* 13208*/  /*Scope*/ 44, /*->13253*/
/* 13209*/   OPC_RecordChild0, // #0 = $lhs
/* 13210*/   OPC_RecordChild1, // #1 = $rhs
/* 13211*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13222
/* 13214*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 13222*/   /*SwitchType*/ 8, MVT::v8i16,// ->13232
/* 13224*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 13232*/   /*SwitchType*/ 8, MVT::v4i32,// ->13242
/* 13234*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 13242*/   /*SwitchType*/ 8, MVT::v2i64,// ->13252
/* 13244*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 13252*/   0, // EndSwitchType
/* 13253*/  0, /*End of Scope*/
/* 13254*/ /*SwitchOpcode*/ 109|128,12/*1645*/, TARGET_VAL(ISD::SETCC),// ->14903
/* 13258*/  OPC_Scope, 24|128,2/*280*/, /*->13541*/ // 2 children in Scope
/* 13261*/   OPC_MoveChild0,
/* 13262*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/* 13265*/   OPC_Scope, 7|128,1/*135*/, /*->13403*/ // 2 children in Scope
/* 13268*/    OPC_CheckChild0Integer, 16|128,13|128,1/*18064*/, 
/* 13272*/    OPC_RecordChild1, // #0 = $x
/* 13273*/    OPC_Scope, 31, /*->13306*/ // 4 children in Scope
/* 13275*/     OPC_CheckChild1Type, MVT::v16i8,
/* 13277*/     OPC_MoveParent,
/* 13278*/     OPC_CheckType, MVT::i32,
/* 13280*/     OPC_Scope, 11, /*->13293*/ // 2 children in Scope
/* 13282*/      OPC_CheckChild1Integer, 0, 
/* 13284*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13286*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/* 13293*/     /*Scope*/ 11, /*->13305*/
/* 13294*/      OPC_CheckChild1Integer, 2, 
/* 13296*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13298*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/* 13305*/     0, /*End of Scope*/
/* 13306*/    /*Scope*/ 31, /*->13338*/
/* 13307*/     OPC_CheckChild1Type, MVT::v8i16,
/* 13309*/     OPC_MoveParent,
/* 13310*/     OPC_CheckType, MVT::i32,
/* 13312*/     OPC_Scope, 11, /*->13325*/ // 2 children in Scope
/* 13314*/      OPC_CheckChild1Integer, 0, 
/* 13316*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13318*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/* 13325*/     /*Scope*/ 11, /*->13337*/
/* 13326*/      OPC_CheckChild1Integer, 2, 
/* 13328*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13330*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/* 13337*/     0, /*End of Scope*/
/* 13338*/    /*Scope*/ 31, /*->13370*/
/* 13339*/     OPC_CheckChild1Type, MVT::v4i32,
/* 13341*/     OPC_MoveParent,
/* 13342*/     OPC_CheckType, MVT::i32,
/* 13344*/     OPC_Scope, 11, /*->13357*/ // 2 children in Scope
/* 13346*/      OPC_CheckChild1Integer, 0, 
/* 13348*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13350*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/* 13357*/     /*Scope*/ 11, /*->13369*/
/* 13358*/      OPC_CheckChild1Integer, 2, 
/* 13360*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/* 13369*/     0, /*End of Scope*/
/* 13370*/    /*Scope*/ 31, /*->13402*/
/* 13371*/     OPC_CheckChild1Type, MVT::v2i64,
/* 13373*/     OPC_MoveParent,
/* 13374*/     OPC_CheckType, MVT::i32,
/* 13376*/     OPC_Scope, 11, /*->13389*/ // 2 children in Scope
/* 13378*/      OPC_CheckChild1Integer, 0, 
/* 13380*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13382*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/* 13389*/     /*Scope*/ 11, /*->13401*/
/* 13390*/      OPC_CheckChild1Integer, 2, 
/* 13392*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13394*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/* 13401*/     0, /*End of Scope*/
/* 13402*/    0, /*End of Scope*/
/* 13403*/   /*Scope*/ 7|128,1/*135*/, /*->13540*/
/* 13405*/    OPC_CheckChild0Integer, 14|128,13|128,1/*18062*/, 
/* 13409*/    OPC_RecordChild1, // #0 = $x
/* 13410*/    OPC_Scope, 31, /*->13443*/ // 4 children in Scope
/* 13412*/     OPC_CheckChild1Type, MVT::v16i8,
/* 13414*/     OPC_MoveParent,
/* 13415*/     OPC_CheckType, MVT::i32,
/* 13417*/     OPC_Scope, 11, /*->13430*/ // 2 children in Scope
/* 13419*/      OPC_CheckChild1Integer, 0, 
/* 13421*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13423*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/* 13430*/     /*Scope*/ 11, /*->13442*/
/* 13431*/      OPC_CheckChild1Integer, 2, 
/* 13433*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13435*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/* 13442*/     0, /*End of Scope*/
/* 13443*/    /*Scope*/ 31, /*->13475*/
/* 13444*/     OPC_CheckChild1Type, MVT::v8i16,
/* 13446*/     OPC_MoveParent,
/* 13447*/     OPC_CheckType, MVT::i32,
/* 13449*/     OPC_Scope, 11, /*->13462*/ // 2 children in Scope
/* 13451*/      OPC_CheckChild1Integer, 0, 
/* 13453*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13455*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/* 13462*/     /*Scope*/ 11, /*->13474*/
/* 13463*/      OPC_CheckChild1Integer, 2, 
/* 13465*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13467*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/* 13474*/     0, /*End of Scope*/
/* 13475*/    /*Scope*/ 31, /*->13507*/
/* 13476*/     OPC_CheckChild1Type, MVT::v4i32,
/* 13478*/     OPC_MoveParent,
/* 13479*/     OPC_CheckType, MVT::i32,
/* 13481*/     OPC_Scope, 11, /*->13494*/ // 2 children in Scope
/* 13483*/      OPC_CheckChild1Integer, 0, 
/* 13485*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13487*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/* 13494*/     /*Scope*/ 11, /*->13506*/
/* 13495*/      OPC_CheckChild1Integer, 2, 
/* 13497*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13499*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/* 13506*/     0, /*End of Scope*/
/* 13507*/    /*Scope*/ 31, /*->13539*/
/* 13508*/     OPC_CheckChild1Type, MVT::v2i64,
/* 13510*/     OPC_MoveParent,
/* 13511*/     OPC_CheckType, MVT::i32,
/* 13513*/     OPC_Scope, 11, /*->13526*/ // 2 children in Scope
/* 13515*/      OPC_CheckChild1Integer, 0, 
/* 13517*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13519*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/* 13526*/     /*Scope*/ 11, /*->13538*/
/* 13527*/      OPC_CheckChild1Integer, 2, 
/* 13529*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13531*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/* 13538*/     0, /*End of Scope*/
/* 13539*/    0, /*End of Scope*/
/* 13540*/   0, /*End of Scope*/
/* 13541*/  /*Scope*/ 79|128,10/*1359*/, /*->14902*/
/* 13543*/   OPC_RecordChild0, // #0 = $src
/* 13544*/   OPC_SwitchType /*5 cases */, 32|128,4/*544*/, MVT::i32,// ->14092
/* 13548*/    OPC_Scope, 2|128,1/*130*/, /*->13681*/ // 4 children in Scope
/* 13551*/     OPC_CheckChild0Type, MVT::i32,
/* 13553*/     OPC_Scope, 11, /*->13566*/ // 2 children in Scope
/* 13555*/      OPC_CheckChild1Integer, 0, 
/* 13557*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 13566*/     /*Scope*/ 113, /*->13680*/
/* 13567*/      OPC_RecordChild1, // #1 = $rhs
/* 13568*/      OPC_Scope, 10, /*->13580*/ // 10 children in Scope
/* 13570*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13572*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13580*/      /*Scope*/ 10, /*->13591*/
/* 13581*/       OPC_CheckChild2CondCode, ISD::SETNE,
/* 13583*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13591*/      /*Scope*/ 10, /*->13602*/
/* 13592*/       OPC_CheckChild2CondCode, ISD::SETLT,
/* 13594*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13602*/      /*Scope*/ 10, /*->13613*/
/* 13603*/       OPC_CheckChild2CondCode, ISD::SETULT,
/* 13605*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13613*/      /*Scope*/ 10, /*->13624*/
/* 13614*/       OPC_CheckChild2CondCode, ISD::SETGT,
/* 13616*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13624*/      /*Scope*/ 10, /*->13635*/
/* 13625*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/* 13627*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13635*/      /*Scope*/ 10, /*->13646*/
/* 13636*/       OPC_CheckChild2CondCode, ISD::SETLE,
/* 13638*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13646*/      /*Scope*/ 10, /*->13657*/
/* 13647*/       OPC_CheckChild2CondCode, ISD::SETULE,
/* 13649*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13657*/      /*Scope*/ 10, /*->13668*/
/* 13658*/       OPC_CheckChild2CondCode, ISD::SETGE,
/* 13660*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13668*/      /*Scope*/ 10, /*->13679*/
/* 13669*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/* 13671*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13679*/      0, /*End of Scope*/
/* 13680*/     0, /*End of Scope*/
/* 13681*/    /*Scope*/ 2|128,1/*130*/, /*->13813*/
/* 13683*/     OPC_CheckChild0Type, MVT::i64,
/* 13685*/     OPC_Scope, 11, /*->13698*/ // 2 children in Scope
/* 13687*/      OPC_CheckChild1Integer, 0, 
/* 13689*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13691*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I64), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 13698*/     /*Scope*/ 113, /*->13812*/
/* 13699*/      OPC_RecordChild1, // #1 = $rhs
/* 13700*/      OPC_Scope, 10, /*->13712*/ // 10 children in Scope
/* 13702*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13704*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13712*/      /*Scope*/ 10, /*->13723*/
/* 13713*/       OPC_CheckChild2CondCode, ISD::SETNE,
/* 13715*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13723*/      /*Scope*/ 10, /*->13734*/
/* 13724*/       OPC_CheckChild2CondCode, ISD::SETLT,
/* 13726*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13734*/      /*Scope*/ 10, /*->13745*/
/* 13735*/       OPC_CheckChild2CondCode, ISD::SETULT,
/* 13737*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13745*/      /*Scope*/ 10, /*->13756*/
/* 13746*/       OPC_CheckChild2CondCode, ISD::SETGT,
/* 13748*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13756*/      /*Scope*/ 10, /*->13767*/
/* 13757*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/* 13759*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13767*/      /*Scope*/ 10, /*->13778*/
/* 13768*/       OPC_CheckChild2CondCode, ISD::SETLE,
/* 13770*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13778*/      /*Scope*/ 10, /*->13789*/
/* 13779*/       OPC_CheckChild2CondCode, ISD::SETULE,
/* 13781*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13789*/      /*Scope*/ 10, /*->13800*/
/* 13790*/       OPC_CheckChild2CondCode, ISD::SETGE,
/* 13792*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13800*/      /*Scope*/ 10, /*->13811*/
/* 13801*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/* 13803*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13811*/      0, /*End of Scope*/
/* 13812*/     0, /*End of Scope*/
/* 13813*/    /*Scope*/ 9|128,1/*137*/, /*->13952*/
/* 13815*/     OPC_CheckChild0Type, MVT::f32,
/* 13817*/     OPC_RecordChild1, // #1 = $rhs
/* 13818*/     OPC_Scope, 10, /*->13830*/ // 12 children in Scope
/* 13820*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/* 13822*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 13830*/     /*Scope*/ 10, /*->13841*/
/* 13831*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/* 13833*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 13841*/     /*Scope*/ 10, /*->13852*/
/* 13842*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/* 13844*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 13852*/     /*Scope*/ 10, /*->13863*/
/* 13853*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/* 13855*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 13863*/     /*Scope*/ 10, /*->13874*/
/* 13864*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/* 13866*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 13874*/     /*Scope*/ 10, /*->13885*/
/* 13875*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/* 13877*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 13885*/     /*Scope*/ 10, /*->13896*/
/* 13886*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 13888*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 13896*/     /*Scope*/ 10, /*->13907*/
/* 13897*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 13899*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 13907*/     /*Scope*/ 10, /*->13918*/
/* 13908*/      OPC_CheckChild2CondCode, ISD::SETLT,
/* 13910*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 13918*/     /*Scope*/ 10, /*->13929*/
/* 13919*/      OPC_CheckChild2CondCode, ISD::SETLE,
/* 13921*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 13929*/     /*Scope*/ 10, /*->13940*/
/* 13930*/      OPC_CheckChild2CondCode, ISD::SETGT,
/* 13932*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 13940*/     /*Scope*/ 10, /*->13951*/
/* 13941*/      OPC_CheckChild2CondCode, ISD::SETGE,
/* 13943*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 13951*/     0, /*End of Scope*/
/* 13952*/    /*Scope*/ 9|128,1/*137*/, /*->14091*/
/* 13954*/     OPC_CheckChild0Type, MVT::f64,
/* 13956*/     OPC_RecordChild1, // #1 = $rhs
/* 13957*/     OPC_Scope, 10, /*->13969*/ // 12 children in Scope
/* 13959*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/* 13961*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 13969*/     /*Scope*/ 10, /*->13980*/
/* 13970*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/* 13972*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 13980*/     /*Scope*/ 10, /*->13991*/
/* 13981*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/* 13983*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 13991*/     /*Scope*/ 10, /*->14002*/
/* 13992*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/* 13994*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 14002*/     /*Scope*/ 10, /*->14013*/
/* 14003*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/* 14005*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 14013*/     /*Scope*/ 10, /*->14024*/
/* 14014*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/* 14016*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 14024*/     /*Scope*/ 10, /*->14035*/
/* 14025*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14027*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 14035*/     /*Scope*/ 10, /*->14046*/
/* 14036*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 14038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 14046*/     /*Scope*/ 10, /*->14057*/
/* 14047*/      OPC_CheckChild2CondCode, ISD::SETLT,
/* 14049*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 14057*/     /*Scope*/ 10, /*->14068*/
/* 14058*/      OPC_CheckChild2CondCode, ISD::SETLE,
/* 14060*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 14068*/     /*Scope*/ 10, /*->14079*/
/* 14069*/      OPC_CheckChild2CondCode, ISD::SETGT,
/* 14071*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 14079*/     /*Scope*/ 10, /*->14090*/
/* 14080*/      OPC_CheckChild2CondCode, ISD::SETGE,
/* 14082*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 14090*/     0, /*End of Scope*/
/* 14091*/    0, /*End of Scope*/
/* 14092*/   /*SwitchType*/ 7|128,1/*135*/, MVT::v16i8,// ->14230
/* 14095*/    OPC_CheckChild0Type, MVT::v16i8,
/* 14097*/    OPC_RecordChild1, // #1 = $rhs
/* 14098*/    OPC_Scope, 12, /*->14112*/ // 10 children in Scope
/* 14100*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14102*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14104*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14112*/    /*Scope*/ 12, /*->14125*/
/* 14113*/     OPC_CheckChild2CondCode, ISD::SETNE,
/* 14115*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14117*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14125*/    /*Scope*/ 12, /*->14138*/
/* 14126*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 14128*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14130*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14138*/    /*Scope*/ 12, /*->14151*/
/* 14139*/     OPC_CheckChild2CondCode, ISD::SETULT,
/* 14141*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14143*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14151*/    /*Scope*/ 12, /*->14164*/
/* 14152*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 14154*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14156*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14164*/    /*Scope*/ 12, /*->14177*/
/* 14165*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/* 14167*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14169*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14177*/    /*Scope*/ 12, /*->14190*/
/* 14178*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 14180*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14182*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14190*/    /*Scope*/ 12, /*->14203*/
/* 14191*/     OPC_CheckChild2CondCode, ISD::SETULE,
/* 14193*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14195*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14203*/    /*Scope*/ 12, /*->14216*/
/* 14204*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 14206*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14208*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14216*/    /*Scope*/ 12, /*->14229*/
/* 14217*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/* 14219*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14221*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14229*/    0, /*End of Scope*/
/* 14230*/   /*SwitchType*/ 7|128,1/*135*/, MVT::v8i16,// ->14368
/* 14233*/    OPC_CheckChild0Type, MVT::v8i16,
/* 14235*/    OPC_RecordChild1, // #1 = $rhs
/* 14236*/    OPC_Scope, 12, /*->14250*/ // 10 children in Scope
/* 14238*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14240*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14242*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14250*/    /*Scope*/ 12, /*->14263*/
/* 14251*/     OPC_CheckChild2CondCode, ISD::SETNE,
/* 14253*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14255*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14263*/    /*Scope*/ 12, /*->14276*/
/* 14264*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 14266*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14268*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14276*/    /*Scope*/ 12, /*->14289*/
/* 14277*/     OPC_CheckChild2CondCode, ISD::SETULT,
/* 14279*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14281*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14289*/    /*Scope*/ 12, /*->14302*/
/* 14290*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 14292*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14294*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14302*/    /*Scope*/ 12, /*->14315*/
/* 14303*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/* 14305*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14307*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14315*/    /*Scope*/ 12, /*->14328*/
/* 14316*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 14318*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14320*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14328*/    /*Scope*/ 12, /*->14341*/
/* 14329*/     OPC_CheckChild2CondCode, ISD::SETULE,
/* 14331*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14333*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14341*/    /*Scope*/ 12, /*->14354*/
/* 14342*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 14344*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14346*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14354*/    /*Scope*/ 12, /*->14367*/
/* 14355*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/* 14357*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14359*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14367*/    0, /*End of Scope*/
/* 14368*/   /*SwitchType*/ 34|128,2/*290*/, MVT::v4i32,// ->14661
/* 14371*/    OPC_Scope, 7|128,1/*135*/, /*->14509*/ // 2 children in Scope
/* 14374*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14376*/     OPC_RecordChild1, // #1 = $rhs
/* 14377*/     OPC_Scope, 12, /*->14391*/ // 10 children in Scope
/* 14379*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14381*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14383*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14391*/     /*Scope*/ 12, /*->14404*/
/* 14392*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 14394*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14396*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14404*/     /*Scope*/ 12, /*->14417*/
/* 14405*/      OPC_CheckChild2CondCode, ISD::SETLT,
/* 14407*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14409*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14417*/     /*Scope*/ 12, /*->14430*/
/* 14418*/      OPC_CheckChild2CondCode, ISD::SETULT,
/* 14420*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14422*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14430*/     /*Scope*/ 12, /*->14443*/
/* 14431*/      OPC_CheckChild2CondCode, ISD::SETGT,
/* 14433*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14435*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14443*/     /*Scope*/ 12, /*->14456*/
/* 14444*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/* 14446*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14448*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14456*/     /*Scope*/ 12, /*->14469*/
/* 14457*/      OPC_CheckChild2CondCode, ISD::SETLE,
/* 14459*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14461*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14469*/     /*Scope*/ 12, /*->14482*/
/* 14470*/      OPC_CheckChild2CondCode, ISD::SETULE,
/* 14472*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14474*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14482*/     /*Scope*/ 12, /*->14495*/
/* 14483*/      OPC_CheckChild2CondCode, ISD::SETGE,
/* 14485*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14487*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14495*/     /*Scope*/ 12, /*->14508*/
/* 14496*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/* 14498*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14500*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14508*/     0, /*End of Scope*/
/* 14509*/    /*Scope*/ 21|128,1/*149*/, /*->14660*/
/* 14511*/     OPC_CheckChild0Type, MVT::v4f32,
/* 14513*/     OPC_RecordChild1, // #1 = $rhs
/* 14514*/     OPC_Scope, 12, /*->14528*/ // 12 children in Scope
/* 14516*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/* 14518*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14520*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 14528*/     /*Scope*/ 12, /*->14541*/
/* 14529*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/* 14531*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 14541*/     /*Scope*/ 12, /*->14554*/
/* 14542*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/* 14544*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14546*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 14554*/     /*Scope*/ 12, /*->14567*/
/* 14555*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/* 14557*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 14567*/     /*Scope*/ 12, /*->14580*/
/* 14568*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/* 14570*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14572*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 14580*/     /*Scope*/ 12, /*->14593*/
/* 14581*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/* 14583*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14585*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 14593*/     /*Scope*/ 10, /*->14604*/
/* 14594*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14596*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/* 14604*/     /*Scope*/ 10, /*->14615*/
/* 14605*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 14607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/* 14615*/     /*Scope*/ 10, /*->14626*/
/* 14616*/      OPC_CheckChild2CondCode, ISD::SETLT,
/* 14618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/* 14626*/     /*Scope*/ 10, /*->14637*/
/* 14627*/      OPC_CheckChild2CondCode, ISD::SETGT,
/* 14629*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/* 14637*/     /*Scope*/ 10, /*->14648*/
/* 14638*/      OPC_CheckChild2CondCode, ISD::SETLE,
/* 14640*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/* 14648*/     /*Scope*/ 10, /*->14659*/
/* 14649*/      OPC_CheckChild2CondCode, ISD::SETGE,
/* 14651*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/* 14659*/     0, /*End of Scope*/
/* 14660*/    0, /*End of Scope*/
/* 14661*/   /*SwitchType*/ 109|128,1/*237*/, MVT::v2i64,// ->14901
/* 14664*/    OPC_Scope, 83, /*->14749*/ // 2 children in Scope
/* 14666*/     OPC_CheckChild0Type, MVT::v2i64,
/* 14668*/     OPC_RecordChild1, // #1 = $rhs
/* 14669*/     OPC_Scope, 12, /*->14683*/ // 6 children in Scope
/* 14671*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14673*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14675*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14683*/     /*Scope*/ 12, /*->14696*/
/* 14684*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 14686*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14688*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14696*/     /*Scope*/ 12, /*->14709*/
/* 14697*/      OPC_CheckChild2CondCode, ISD::SETLT,
/* 14699*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14701*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14709*/     /*Scope*/ 12, /*->14722*/
/* 14710*/      OPC_CheckChild2CondCode, ISD::SETGT,
/* 14712*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14722*/     /*Scope*/ 12, /*->14735*/
/* 14723*/      OPC_CheckChild2CondCode, ISD::SETLE,
/* 14725*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14727*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14735*/     /*Scope*/ 12, /*->14748*/
/* 14736*/      OPC_CheckChild2CondCode, ISD::SETGE,
/* 14738*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14740*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14748*/     0, /*End of Scope*/
/* 14749*/    /*Scope*/ 21|128,1/*149*/, /*->14900*/
/* 14751*/     OPC_CheckChild0Type, MVT::v2f64,
/* 14753*/     OPC_RecordChild1, // #1 = $rhs
/* 14754*/     OPC_Scope, 12, /*->14768*/ // 12 children in Scope
/* 14756*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/* 14758*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14760*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 14768*/     /*Scope*/ 12, /*->14781*/
/* 14769*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/* 14771*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14773*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 14781*/     /*Scope*/ 12, /*->14794*/
/* 14782*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/* 14784*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14786*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 14794*/     /*Scope*/ 12, /*->14807*/
/* 14795*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/* 14797*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14799*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 14807*/     /*Scope*/ 12, /*->14820*/
/* 14808*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/* 14810*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14812*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 14820*/     /*Scope*/ 12, /*->14833*/
/* 14821*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/* 14823*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 14825*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 14833*/     /*Scope*/ 10, /*->14844*/
/* 14834*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/* 14836*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/* 14844*/     /*Scope*/ 10, /*->14855*/
/* 14845*/      OPC_CheckChild2CondCode, ISD::SETNE,
/* 14847*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/* 14855*/     /*Scope*/ 10, /*->14866*/
/* 14856*/      OPC_CheckChild2CondCode, ISD::SETLT,
/* 14858*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/* 14866*/     /*Scope*/ 10, /*->14877*/
/* 14867*/      OPC_CheckChild2CondCode, ISD::SETGT,
/* 14869*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/* 14877*/     /*Scope*/ 10, /*->14888*/
/* 14878*/      OPC_CheckChild2CondCode, ISD::SETLE,
/* 14880*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/* 14888*/     /*Scope*/ 10, /*->14899*/
/* 14889*/      OPC_CheckChild2CondCode, ISD::SETGE,
/* 14891*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/* 14899*/     0, /*End of Scope*/
/* 14900*/    0, /*End of Scope*/
/* 14901*/   0, // EndSwitchType
/* 14902*/  0, /*End of Scope*/
/* 14903*/ /*SwitchOpcode*/ 50|128,8/*1074*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->15981
/* 14907*/  OPC_Scope, 90|128,4/*602*/, /*->15512*/ // 3 children in Scope
/* 14910*/   OPC_RecordMemRef,
/* 14911*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/* 14912*/   OPC_Scope, 62|128,1/*190*/, /*->15105*/ // 3 children in Scope
/* 14915*/    OPC_CheckChild1Integer, 40|128,13|128,1/*18088*/, 
/* 14919*/    OPC_MoveChild2,
/* 14920*/    OPC_SwitchOpcode /*3 cases */, 55, TARGET_VAL(ISD::ADD),// ->14979
/* 14924*/     OPC_RecordChild0, // #1 = $addr
/* 14925*/     OPC_RecordChild1, // #2 = $off
/* 14926*/     OPC_MoveChild1,
/* 14927*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 14930*/     OPC_MoveParent,
/* 14931*/     OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 14933*/     OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->14956
/* 14936*/      OPC_MoveParent,
/* 14937*/      OPC_RecordChild3, // #3 = $count
/* 14938*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 14940*/      OPC_EmitMergeInputChains1_0,
/* 14941*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14944*/      OPC_EmitConvertToTarget, 2,
/* 14946*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, I32:{ *:[i32] }:$count) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 14956*/     /*SwitchType*/ 20, MVT::i64,// ->14978
/* 14958*/      OPC_MoveParent,
/* 14959*/      OPC_RecordChild3, // #3 = $count
/* 14960*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 14962*/      OPC_EmitMergeInputChains1_0,
/* 14963*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14966*/      OPC_EmitConvertToTarget, 2,
/* 14968*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, I32:{ *:[i32] }:$count) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, I32:{ *:[i32] }:$count)
/* 14978*/     0, // EndSwitchType
/* 14979*/    /*SwitchOpcode*/ 55, TARGET_VAL(ISD::OR),// ->15037
/* 14982*/     OPC_RecordChild0, // #1 = $addr
/* 14983*/     OPC_RecordChild1, // #2 = $off
/* 14984*/     OPC_MoveChild1,
/* 14985*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 14988*/     OPC_MoveParent,
/* 14989*/     OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 14991*/     OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->15014
/* 14994*/      OPC_MoveParent,
/* 14995*/      OPC_RecordChild3, // #3 = $count
/* 14996*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 14998*/      OPC_EmitMergeInputChains1_0,
/* 14999*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15002*/      OPC_EmitConvertToTarget, 2,
/* 15004*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, I32:{ *:[i32] }:$count) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 15014*/     /*SwitchType*/ 20, MVT::i64,// ->15036
/* 15016*/      OPC_MoveParent,
/* 15017*/      OPC_RecordChild3, // #3 = $count
/* 15018*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15020*/      OPC_EmitMergeInputChains1_0,
/* 15021*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15024*/      OPC_EmitConvertToTarget, 2,
/* 15026*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, I32:{ *:[i32] }:$count) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, I32:{ *:[i32] }:$count)
/* 15036*/     0, // EndSwitchType
/* 15037*/    /*SwitchOpcode*/ 64, TARGET_VAL(WebAssemblyISD::Wrapper),// ->15104
/* 15040*/     OPC_RecordChild0, // #1 = $off
/* 15041*/     OPC_MoveChild0,
/* 15042*/     OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 15045*/     OPC_MoveParent,
/* 15046*/     OPC_MoveParent,
/* 15047*/     OPC_RecordChild3, // #2 = $count
/* 15048*/     OPC_Scope, 26, /*->15076*/ // 2 children in Scope
/* 15050*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 15052*/      OPC_EmitMergeInputChains1_0,
/* 15053*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15056*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15059*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 15066*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), I32:{ *:[i32] }:$count) - Complexity = 14
                // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), I32:{ *:[i32] }:$count)
/* 15076*/     /*Scope*/ 26, /*->15103*/
/* 15077*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 15079*/      OPC_EmitMergeInputChains1_0,
/* 15080*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15083*/      OPC_EmitInteger, MVT::i64, 0, 
/* 15086*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 15093*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), I32:{ *:[i32] }:$count) - Complexity = 14
                // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), I32:{ *:[i32] }:$count)
/* 15103*/     0, /*End of Scope*/
/* 15104*/    0, // EndSwitchOpcode
/* 15105*/   /*Scope*/ 73|128,1/*201*/, /*->15308*/
/* 15107*/    OPC_CheckChild1Integer, 42|128,13|128,1/*18090*/, 
/* 15111*/    OPC_MoveChild2,
/* 15112*/    OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->15175
/* 15116*/     OPC_RecordChild0, // #1 = $addr
/* 15117*/     OPC_RecordChild1, // #2 = $off
/* 15118*/     OPC_MoveChild1,
/* 15119*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15122*/     OPC_MoveParent,
/* 15123*/     OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 15125*/     OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->15150
/* 15128*/      OPC_MoveParent,
/* 15129*/      OPC_RecordChild3, // #3 = $exp
/* 15130*/      OPC_RecordChild4, // #4 = $timeout
/* 15131*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15133*/      OPC_EmitMergeInputChains1_0,
/* 15134*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15137*/      OPC_EmitConvertToTarget, 2,
/* 15139*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15150*/     /*SwitchType*/ 22, MVT::i64,// ->15174
/* 15152*/      OPC_MoveParent,
/* 15153*/      OPC_RecordChild3, // #3 = $exp
/* 15154*/      OPC_RecordChild4, // #4 = $timeout
/* 15155*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15157*/      OPC_EmitMergeInputChains1_0,
/* 15158*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15161*/      OPC_EmitConvertToTarget, 2,
/* 15163*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15174*/     0, // EndSwitchType
/* 15175*/    /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->15237
/* 15178*/     OPC_RecordChild0, // #1 = $addr
/* 15179*/     OPC_RecordChild1, // #2 = $off
/* 15180*/     OPC_MoveChild1,
/* 15181*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15184*/     OPC_MoveParent,
/* 15185*/     OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 15187*/     OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->15212
/* 15190*/      OPC_MoveParent,
/* 15191*/      OPC_RecordChild3, // #3 = $exp
/* 15192*/      OPC_RecordChild4, // #4 = $timeout
/* 15193*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15195*/      OPC_EmitMergeInputChains1_0,
/* 15196*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15199*/      OPC_EmitConvertToTarget, 2,
/* 15201*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15212*/     /*SwitchType*/ 22, MVT::i64,// ->15236
/* 15214*/      OPC_MoveParent,
/* 15215*/      OPC_RecordChild3, // #3 = $exp
/* 15216*/      OPC_RecordChild4, // #4 = $timeout
/* 15217*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15219*/      OPC_EmitMergeInputChains1_0,
/* 15220*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15223*/      OPC_EmitConvertToTarget, 2,
/* 15225*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15236*/     0, // EndSwitchType
/* 15237*/    /*SwitchOpcode*/ 67, TARGET_VAL(WebAssemblyISD::Wrapper),// ->15307
/* 15240*/     OPC_RecordChild0, // #1 = $off
/* 15241*/     OPC_MoveChild0,
/* 15242*/     OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 15245*/     OPC_MoveParent,
/* 15246*/     OPC_MoveParent,
/* 15247*/     OPC_RecordChild3, // #2 = $exp
/* 15248*/     OPC_RecordChild4, // #3 = $timeout
/* 15249*/     OPC_Scope, 27, /*->15278*/ // 2 children in Scope
/* 15251*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 15253*/      OPC_EmitMergeInputChains1_0,
/* 15254*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15257*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15260*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15278*/     /*Scope*/ 27, /*->15306*/
/* 15279*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 15281*/      OPC_EmitMergeInputChains1_0,
/* 15282*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15285*/      OPC_EmitInteger, MVT::i64, 0, 
/* 15288*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 15295*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15306*/     0, /*End of Scope*/
/* 15307*/    0, // EndSwitchOpcode
/* 15308*/   /*Scope*/ 73|128,1/*201*/, /*->15511*/
/* 15310*/    OPC_CheckChild1Integer, 44|128,13|128,1/*18092*/, 
/* 15314*/    OPC_MoveChild2,
/* 15315*/    OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->15378
/* 15319*/     OPC_RecordChild0, // #1 = $addr
/* 15320*/     OPC_RecordChild1, // #2 = $off
/* 15321*/     OPC_MoveChild1,
/* 15322*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15325*/     OPC_MoveParent,
/* 15326*/     OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 15328*/     OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->15353
/* 15331*/      OPC_MoveParent,
/* 15332*/      OPC_RecordChild3, // #3 = $exp
/* 15333*/      OPC_RecordChild4, // #4 = $timeout
/* 15334*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15336*/      OPC_EmitMergeInputChains1_0,
/* 15337*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15340*/      OPC_EmitConvertToTarget, 2,
/* 15342*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15353*/     /*SwitchType*/ 22, MVT::i64,// ->15377
/* 15355*/      OPC_MoveParent,
/* 15356*/      OPC_RecordChild3, // #3 = $exp
/* 15357*/      OPC_RecordChild4, // #4 = $timeout
/* 15358*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15360*/      OPC_EmitMergeInputChains1_0,
/* 15361*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15364*/      OPC_EmitConvertToTarget, 2,
/* 15366*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15377*/     0, // EndSwitchType
/* 15378*/    /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->15440
/* 15381*/     OPC_RecordChild0, // #1 = $addr
/* 15382*/     OPC_RecordChild1, // #2 = $off
/* 15383*/     OPC_MoveChild1,
/* 15384*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15387*/     OPC_MoveParent,
/* 15388*/     OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 15390*/     OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->15415
/* 15393*/      OPC_MoveParent,
/* 15394*/      OPC_RecordChild3, // #3 = $exp
/* 15395*/      OPC_RecordChild4, // #4 = $timeout
/* 15396*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15398*/      OPC_EmitMergeInputChains1_0,
/* 15399*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15402*/      OPC_EmitConvertToTarget, 2,
/* 15404*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15415*/     /*SwitchType*/ 22, MVT::i64,// ->15439
/* 15417*/      OPC_MoveParent,
/* 15418*/      OPC_RecordChild3, // #3 = $exp
/* 15419*/      OPC_RecordChild4, // #4 = $timeout
/* 15420*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15422*/      OPC_EmitMergeInputChains1_0,
/* 15423*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15426*/      OPC_EmitConvertToTarget, 2,
/* 15428*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15439*/     0, // EndSwitchType
/* 15440*/    /*SwitchOpcode*/ 67, TARGET_VAL(WebAssemblyISD::Wrapper),// ->15510
/* 15443*/     OPC_RecordChild0, // #1 = $off
/* 15444*/     OPC_MoveChild0,
/* 15445*/     OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 15448*/     OPC_MoveParent,
/* 15449*/     OPC_MoveParent,
/* 15450*/     OPC_RecordChild3, // #2 = $exp
/* 15451*/     OPC_RecordChild4, // #3 = $timeout
/* 15452*/     OPC_Scope, 27, /*->15481*/ // 2 children in Scope
/* 15454*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 15456*/      OPC_EmitMergeInputChains1_0,
/* 15457*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15460*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15463*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15481*/     /*Scope*/ 27, /*->15509*/
/* 15482*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 15484*/      OPC_EmitMergeInputChains1_0,
/* 15485*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15488*/      OPC_EmitInteger, MVT::i64, 0, 
/* 15491*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 15498*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15509*/     0, /*End of Scope*/
/* 15510*/    0, // EndSwitchOpcode
/* 15511*/   0, /*End of Scope*/
/* 15512*/  /*Scope*/ 84, /*->15597*/
/* 15513*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/* 15514*/   OPC_Scope, 36, /*->15552*/ // 2 children in Scope
/* 15516*/    OPC_CheckChild1Integer, 48|128,13|128,1/*18096*/, 
/* 15520*/    OPC_RecordChild2, // #1 = $flags
/* 15521*/    OPC_MoveChild2,
/* 15522*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15525*/    OPC_MoveParent,
/* 15526*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->15539
/* 15529*/     OPC_EmitMergeInputChains1_0,
/* 15530*/     OPC_EmitConvertToTarget, 1,
/* 15532*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4326MEMORY_SIZE_A32), 0|OPFL_Chain,
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9048:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_4326MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/* 15539*/    /*SwitchType*/ 10, MVT::i64,// ->15551
/* 15541*/     OPC_EmitMergeInputChains1_0,
/* 15542*/     OPC_EmitConvertToTarget, 1,
/* 15544*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4327MEMORY_SIZE_A64), 0|OPFL_Chain,
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 9048:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_4327MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/* 15551*/    0, // EndSwitchType
/* 15552*/   /*Scope*/ 43, /*->15596*/
/* 15553*/    OPC_CheckChild1Integer, 46|128,13|128,1/*18094*/, 
/* 15557*/    OPC_RecordChild2, // #1 = $flags
/* 15558*/    OPC_MoveChild2,
/* 15559*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15562*/    OPC_MoveParent,
/* 15563*/    OPC_RecordChild3, // #2 = $delta
/* 15564*/    OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->15580
/* 15567*/     OPC_CheckChild3Type, MVT::i32,
/* 15569*/     OPC_EmitMergeInputChains1_0,
/* 15570*/     OPC_EmitConvertToTarget, 1,
/* 15572*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4326MEMORY_GROW_A32), 0|OPFL_Chain,
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9047:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_4326MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/* 15580*/    /*SwitchType*/ 13, MVT::i64,// ->15595
/* 15582*/     OPC_CheckChild3Type, MVT::i64,
/* 15584*/     OPC_EmitMergeInputChains1_0,
/* 15585*/     OPC_EmitConvertToTarget, 1,
/* 15587*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4327MEMORY_GROW_A64), 0|OPFL_Chain,
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 9047:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_4327MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/* 15595*/    0, // EndSwitchType
/* 15596*/   0, /*End of Scope*/
/* 15597*/  /*Scope*/ 125|128,2/*381*/, /*->15980*/
/* 15599*/   OPC_RecordMemRef,
/* 15600*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/* 15601*/   OPC_Scope, 120, /*->15723*/ // 3 children in Scope
/* 15603*/    OPC_CheckChild1Integer, 40|128,13|128,1/*18088*/, 
/* 15607*/    OPC_RecordChild2, // #1 = $off
/* 15608*/    OPC_Scope, 66, /*->15676*/ // 3 children in Scope
/* 15610*/     OPC_MoveChild2,
/* 15611*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15614*/     OPC_MoveParent,
/* 15615*/     OPC_RecordChild3, // #2 = $count
/* 15616*/     OPC_Scope, 28, /*->15646*/ // 2 children in Scope
/* 15618*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15620*/      OPC_EmitMergeInputChains1_0,
/* 15621*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15624*/      OPC_EmitConvertToTarget, 1,
/* 15626*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15629*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15636*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, I32:{ *:[i32] }:$count) - Complexity = 11
                // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), I32:{ *:[i32] }:$count)
/* 15646*/     /*Scope*/ 28, /*->15675*/
/* 15647*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15649*/      OPC_EmitMergeInputChains1_0,
/* 15650*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15653*/      OPC_EmitConvertToTarget, 1,
/* 15655*/      OPC_EmitInteger, MVT::i64, 0, 
/* 15658*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 15665*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, I32:{ *:[i32] }:$count) - Complexity = 11
                // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), I32:{ *:[i32] }:$count)
/* 15675*/     0, /*End of Scope*/
/* 15676*/    /*Scope*/ 22, /*->15699*/
/* 15677*/     OPC_CheckChild2Type, MVT::i32,
/* 15679*/     OPC_RecordChild3, // #2 = $count
/* 15680*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15682*/     OPC_EmitMergeInputChains1_0,
/* 15683*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15686*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15689*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count) - Complexity = 8
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 15699*/    /*Scope*/ 22, /*->15722*/
/* 15700*/     OPC_CheckChild2Type, MVT::i64,
/* 15702*/     OPC_RecordChild3, // #2 = $count
/* 15703*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15705*/     OPC_EmitMergeInputChains1_0,
/* 15706*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15709*/     OPC_EmitInteger, MVT::i64, 0, 
/* 15712*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9044:{ *:[iPTR] }, I64:{ *:[i64] }:$addr, I32:{ *:[i32] }:$count) - Complexity = 8
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, I32:{ *:[i32] }:$count)
/* 15722*/    0, /*End of Scope*/
/* 15723*/   /*Scope*/ 127, /*->15851*/
/* 15724*/    OPC_CheckChild1Integer, 42|128,13|128,1/*18090*/, 
/* 15728*/    OPC_RecordChild2, // #1 = $off
/* 15729*/    OPC_Scope, 69, /*->15800*/ // 3 children in Scope
/* 15731*/     OPC_MoveChild2,
/* 15732*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15735*/     OPC_MoveParent,
/* 15736*/     OPC_RecordChild3, // #2 = $exp
/* 15737*/     OPC_RecordChild4, // #3 = $timeout
/* 15738*/     OPC_Scope, 29, /*->15769*/ // 2 children in Scope
/* 15740*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15742*/      OPC_EmitMergeInputChains1_0,
/* 15743*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15746*/      OPC_EmitConvertToTarget, 1,
/* 15748*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15751*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 15758*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 11
                // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15769*/     /*Scope*/ 29, /*->15799*/
/* 15770*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15772*/      OPC_EmitMergeInputChains1_0,
/* 15773*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15776*/      OPC_EmitConvertToTarget, 1,
/* 15778*/      OPC_EmitInteger, MVT::i64, 0, 
/* 15781*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 15788*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 11
                // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15799*/     0, /*End of Scope*/
/* 15800*/    /*Scope*/ 24, /*->15825*/
/* 15801*/     OPC_CheckChild2Type, MVT::i32,
/* 15803*/     OPC_RecordChild3, // #2 = $exp
/* 15804*/     OPC_RecordChild4, // #3 = $timeout
/* 15805*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15807*/     OPC_EmitMergeInputChains1_0,
/* 15808*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15811*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15814*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 8
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15825*/    /*Scope*/ 24, /*->15850*/
/* 15826*/     OPC_CheckChild2Type, MVT::i64,
/* 15828*/     OPC_RecordChild3, // #2 = $exp
/* 15829*/     OPC_RecordChild4, // #3 = $timeout
/* 15830*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15832*/     OPC_EmitMergeInputChains1_0,
/* 15833*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15836*/     OPC_EmitInteger, MVT::i64, 0, 
/* 15839*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9045:{ *:[iPTR] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 8
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15850*/    0, /*End of Scope*/
/* 15851*/   /*Scope*/ 127, /*->15979*/
/* 15852*/    OPC_CheckChild1Integer, 44|128,13|128,1/*18092*/, 
/* 15856*/    OPC_RecordChild2, // #1 = $off
/* 15857*/    OPC_Scope, 69, /*->15928*/ // 3 children in Scope
/* 15859*/     OPC_MoveChild2,
/* 15860*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15863*/     OPC_MoveParent,
/* 15864*/     OPC_RecordChild3, // #2 = $exp
/* 15865*/     OPC_RecordChild4, // #3 = $timeout
/* 15866*/     OPC_Scope, 29, /*->15897*/ // 2 children in Scope
/* 15868*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15870*/      OPC_EmitMergeInputChains1_0,
/* 15871*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15874*/      OPC_EmitConvertToTarget, 1,
/* 15876*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15879*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 15886*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 11
                // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15897*/     /*Scope*/ 29, /*->15927*/
/* 15898*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15900*/      OPC_EmitMergeInputChains1_0,
/* 15901*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15904*/      OPC_EmitConvertToTarget, 1,
/* 15906*/      OPC_EmitInteger, MVT::i64, 0, 
/* 15909*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 15916*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 11
                // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15927*/     0, /*End of Scope*/
/* 15928*/    /*Scope*/ 24, /*->15953*/
/* 15929*/     OPC_CheckChild2Type, MVT::i32,
/* 15931*/     OPC_RecordChild3, // #2 = $exp
/* 15932*/     OPC_RecordChild4, // #3 = $timeout
/* 15933*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15935*/     OPC_EmitMergeInputChains1_0,
/* 15936*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15939*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15942*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 8
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15953*/    /*Scope*/ 24, /*->15978*/
/* 15954*/     OPC_CheckChild2Type, MVT::i64,
/* 15956*/     OPC_RecordChild3, // #2 = $exp
/* 15957*/     OPC_RecordChild4, // #3 = $timeout
/* 15958*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 15960*/     OPC_EmitMergeInputChains1_0,
/* 15961*/     OPC_EmitInteger, MVT::i32, 0, 
/* 15964*/     OPC_EmitInteger, MVT::i64, 0, 
/* 15967*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9046:{ *:[iPTR] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 8
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 15978*/    0, /*End of Scope*/
/* 15979*/   0, /*End of Scope*/
/* 15980*/  0, /*End of Scope*/
/* 15981*/ /*SwitchOpcode*/ 75|128,14/*1867*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->17852
/* 15985*/  OPC_RecordMemRef,
/* 15986*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/* 15987*/  OPC_Scope, 25|128,7/*921*/, /*->16911*/ // 4 children in Scope
/* 15990*/   OPC_MoveChild1,
/* 15991*/   OPC_SwitchOpcode /*3 cases */, 87|128,2/*343*/, TARGET_VAL(ISD::ADD),// ->16339
/* 15996*/    OPC_RecordChild0, // #1 = $addr
/* 15997*/    OPC_RecordChild1, // #2 = $off
/* 15998*/    OPC_MoveChild1,
/* 15999*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 16002*/    OPC_MoveParent,
/* 16003*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 16005*/    OPC_SwitchType /*2 cases */, 35|128,1/*163*/, MVT::i32,// ->16172
/* 16009*/     OPC_MoveParent,
/* 16010*/     OPC_Scope, 68, /*->16080*/ // 2 children in Scope
/* 16012*/      OPC_MoveChild2,
/* 16013*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16016*/      OPC_RecordChild0, // #3 = $val
/* 16017*/      OPC_MoveParent,
/* 16018*/      OPC_Scope, 19, /*->16039*/ // 3 children in Scope
/* 16020*/       OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16022*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16024*/       OPC_EmitMergeInputChains1_0,
/* 16025*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16028*/       OPC_EmitConvertToTarget, 2,
/* 16030*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 14
                 // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16039*/      /*Scope*/ 19, /*->16059*/
/* 16040*/       OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16042*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16044*/       OPC_EmitMergeInputChains1_0,
/* 16045*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16048*/       OPC_EmitConvertToTarget, 2,
/* 16050*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 14
                 // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16059*/      /*Scope*/ 19, /*->16079*/
/* 16060*/       OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16062*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16064*/       OPC_EmitMergeInputChains1_0,
/* 16065*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16068*/       OPC_EmitConvertToTarget, 2,
/* 16070*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 14
                 // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16079*/      0, /*End of Scope*/
/* 16080*/     /*Scope*/ 90, /*->16171*/
/* 16081*/      OPC_RecordChild2, // #3 = $val
/* 16082*/      OPC_Scope, 64, /*->16148*/ // 2 children in Scope
/* 16084*/       OPC_CheckChild2Type, MVT::i32,
/* 16086*/       OPC_Scope, 19, /*->16107*/ // 3 children in Scope
/* 16088*/        OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16090*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16092*/        OPC_EmitMergeInputChains1_0,
/* 16093*/        OPC_EmitInteger, MVT::i32, 0, 
/* 16096*/        OPC_EmitConvertToTarget, 2,
/* 16098*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 11
                  // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16107*/       /*Scope*/ 19, /*->16127*/
/* 16108*/        OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16110*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16112*/        OPC_EmitMergeInputChains1_0,
/* 16113*/        OPC_EmitInteger, MVT::i32, 0, 
/* 16116*/        OPC_EmitConvertToTarget, 2,
/* 16118*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 11
                  // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16127*/       /*Scope*/ 19, /*->16147*/
/* 16128*/        OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16130*/        OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16132*/        OPC_EmitMergeInputChains1_0,
/* 16133*/        OPC_EmitInteger, MVT::i32, 0, 
/* 16136*/        OPC_EmitConvertToTarget, 2,
/* 16138*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 11
                  // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16147*/       0, /*End of Scope*/
/* 16148*/      /*Scope*/ 21, /*->16170*/
/* 16149*/       OPC_CheckChild2Type, MVT::i64,
/* 16151*/       OPC_CheckPredicate, 7, // Predicate_atomic_store_64
/* 16153*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16155*/       OPC_EmitMergeInputChains1_0,
/* 16156*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16159*/       OPC_EmitConvertToTarget, 2,
/* 16161*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 11
                 // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16170*/      0, /*End of Scope*/
/* 16171*/     0, /*End of Scope*/
/* 16172*/    /*SwitchType*/ 35|128,1/*163*/, MVT::i64,// ->16338
/* 16175*/     OPC_MoveParent,
/* 16176*/     OPC_Scope, 68, /*->16246*/ // 2 children in Scope
/* 16178*/      OPC_MoveChild2,
/* 16179*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16182*/      OPC_RecordChild0, // #3 = $val
/* 16183*/      OPC_MoveParent,
/* 16184*/      OPC_Scope, 19, /*->16205*/ // 3 children in Scope
/* 16186*/       OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16188*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16190*/       OPC_EmitMergeInputChains1_0,
/* 16191*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16194*/       OPC_EmitConvertToTarget, 2,
/* 16196*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 14
                 // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16205*/      /*Scope*/ 19, /*->16225*/
/* 16206*/       OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16208*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16210*/       OPC_EmitMergeInputChains1_0,
/* 16211*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16214*/       OPC_EmitConvertToTarget, 2,
/* 16216*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 14
                 // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16225*/      /*Scope*/ 19, /*->16245*/
/* 16226*/       OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16228*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16230*/       OPC_EmitMergeInputChains1_0,
/* 16231*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16234*/       OPC_EmitConvertToTarget, 2,
/* 16236*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 14
                 // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16245*/      0, /*End of Scope*/
/* 16246*/     /*Scope*/ 90, /*->16337*/
/* 16247*/      OPC_RecordChild2, // #3 = $val
/* 16248*/      OPC_Scope, 64, /*->16314*/ // 2 children in Scope
/* 16250*/       OPC_CheckChild2Type, MVT::i32,
/* 16252*/       OPC_Scope, 19, /*->16273*/ // 3 children in Scope
/* 16254*/        OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16256*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16258*/        OPC_EmitMergeInputChains1_0,
/* 16259*/        OPC_EmitInteger, MVT::i32, 0, 
/* 16262*/        OPC_EmitConvertToTarget, 2,
/* 16264*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 11
                  // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 16273*/       /*Scope*/ 19, /*->16293*/
/* 16274*/        OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16276*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16278*/        OPC_EmitMergeInputChains1_0,
/* 16279*/        OPC_EmitInteger, MVT::i32, 0, 
/* 16282*/        OPC_EmitConvertToTarget, 2,
/* 16284*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 11
                  // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 16293*/       /*Scope*/ 19, /*->16313*/
/* 16294*/        OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16296*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16298*/        OPC_EmitMergeInputChains1_0,
/* 16299*/        OPC_EmitInteger, MVT::i32, 0, 
/* 16302*/        OPC_EmitConvertToTarget, 2,
/* 16304*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 1, 3, 
                  // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 11
                  // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 16313*/       0, /*End of Scope*/
/* 16314*/      /*Scope*/ 21, /*->16336*/
/* 16315*/       OPC_CheckChild2Type, MVT::i64,
/* 16317*/       OPC_CheckPredicate, 7, // Predicate_atomic_store_64
/* 16319*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16321*/       OPC_EmitMergeInputChains1_0,
/* 16322*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16325*/       OPC_EmitConvertToTarget, 2,
/* 16327*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 11
                 // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16336*/      0, /*End of Scope*/
/* 16337*/     0, /*End of Scope*/
/* 16338*/    0, // EndSwitchType
/* 16339*/   /*SwitchOpcode*/ 123|128,1/*251*/, TARGET_VAL(ISD::OR),// ->16594
/* 16343*/    OPC_RecordChild0, // #1 = $addr
/* 16344*/    OPC_RecordChild1, // #2 = $off
/* 16345*/    OPC_MoveChild1,
/* 16346*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 16349*/    OPC_MoveParent,
/* 16350*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 16352*/    OPC_SwitchType /*2 cases */, 118, MVT::i32,// ->16473
/* 16355*/     OPC_MoveParent,
/* 16356*/     OPC_Scope, 68, /*->16426*/ // 2 children in Scope
/* 16358*/      OPC_MoveChild2,
/* 16359*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16362*/      OPC_RecordChild0, // #3 = $val
/* 16363*/      OPC_MoveParent,
/* 16364*/      OPC_Scope, 19, /*->16385*/ // 3 children in Scope
/* 16366*/       OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16368*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16370*/       OPC_EmitMergeInputChains1_0,
/* 16371*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16374*/       OPC_EmitConvertToTarget, 2,
/* 16376*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 14
                 // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16385*/      /*Scope*/ 19, /*->16405*/
/* 16386*/       OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16388*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16390*/       OPC_EmitMergeInputChains1_0,
/* 16391*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16394*/       OPC_EmitConvertToTarget, 2,
/* 16396*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 14
                 // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16405*/      /*Scope*/ 19, /*->16425*/
/* 16406*/       OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16408*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16410*/       OPC_EmitMergeInputChains1_0,
/* 16411*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16414*/       OPC_EmitConvertToTarget, 2,
/* 16416*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 14
                 // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 16425*/      0, /*End of Scope*/
/* 16426*/     /*Scope*/ 45, /*->16472*/
/* 16427*/      OPC_RecordChild2, // #3 = $val
/* 16428*/      OPC_CheckChild2Type, MVT::i32,
/* 16430*/      OPC_Scope, 19, /*->16451*/ // 2 children in Scope
/* 16432*/       OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16434*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16436*/       OPC_EmitMergeInputChains1_0,
/* 16437*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16440*/       OPC_EmitConvertToTarget, 2,
/* 16442*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 11
                 // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16451*/      /*Scope*/ 19, /*->16471*/
/* 16452*/       OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16454*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16456*/       OPC_EmitMergeInputChains1_0,
/* 16457*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16460*/       OPC_EmitConvertToTarget, 2,
/* 16462*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 11
                 // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16471*/      0, /*End of Scope*/
/* 16472*/     0, /*End of Scope*/
/* 16473*/    /*SwitchType*/ 118, MVT::i64,// ->16593
/* 16475*/     OPC_MoveParent,
/* 16476*/     OPC_Scope, 68, /*->16546*/ // 2 children in Scope
/* 16478*/      OPC_MoveChild2,
/* 16479*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16482*/      OPC_RecordChild0, // #3 = $val
/* 16483*/      OPC_MoveParent,
/* 16484*/      OPC_Scope, 19, /*->16505*/ // 3 children in Scope
/* 16486*/       OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16488*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16490*/       OPC_EmitMergeInputChains1_0,
/* 16491*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16494*/       OPC_EmitConvertToTarget, 2,
/* 16496*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 14
                 // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16505*/      /*Scope*/ 19, /*->16525*/
/* 16506*/       OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16508*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16510*/       OPC_EmitMergeInputChains1_0,
/* 16511*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16514*/       OPC_EmitConvertToTarget, 2,
/* 16516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 14
                 // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16525*/      /*Scope*/ 19, /*->16545*/
/* 16526*/       OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16528*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16530*/       OPC_EmitMergeInputChains1_0,
/* 16531*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16534*/       OPC_EmitConvertToTarget, 2,
/* 16536*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 14
                 // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 16545*/      0, /*End of Scope*/
/* 16546*/     /*Scope*/ 45, /*->16592*/
/* 16547*/      OPC_RecordChild2, // #3 = $val
/* 16548*/      OPC_CheckChild2Type, MVT::i32,
/* 16550*/      OPC_Scope, 19, /*->16571*/ // 2 children in Scope
/* 16552*/       OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16554*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16556*/       OPC_EmitMergeInputChains1_0,
/* 16557*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16560*/       OPC_EmitConvertToTarget, 2,
/* 16562*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 11
                 // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 16571*/      /*Scope*/ 19, /*->16591*/
/* 16572*/       OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16574*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16576*/       OPC_EmitMergeInputChains1_0,
/* 16577*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16580*/       OPC_EmitConvertToTarget, 2,
/* 16582*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_store (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 11
                 // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 16591*/      0, /*End of Scope*/
/* 16592*/     0, /*End of Scope*/
/* 16593*/    0, // EndSwitchType
/* 16594*/   /*SwitchOpcode*/ 56|128,2/*312*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->16910
/* 16598*/    OPC_RecordChild0, // #1 = $off
/* 16599*/    OPC_MoveChild0,
/* 16600*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 16603*/    OPC_MoveParent,
/* 16604*/    OPC_MoveParent,
/* 16605*/    OPC_Scope, 51|128,1/*179*/, /*->16787*/ // 2 children in Scope
/* 16608*/     OPC_MoveChild2,
/* 16609*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16612*/     OPC_RecordChild0, // #2 = $val
/* 16613*/     OPC_MoveParent,
/* 16614*/     OPC_Scope, 56, /*->16672*/ // 3 children in Scope
/* 16616*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16618*/      OPC_Scope, 25, /*->16645*/ // 2 children in Scope
/* 16620*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16622*/       OPC_EmitMergeInputChains1_0,
/* 16623*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16626*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16629*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 16636*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 13
                 // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 16645*/      /*Scope*/ 25, /*->16671*/
/* 16646*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16648*/       OPC_EmitMergeInputChains1_0,
/* 16649*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16652*/       OPC_EmitInteger, MVT::i64, 0, 
/* 16655*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 16662*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 13
                 // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 16671*/      0, /*End of Scope*/
/* 16672*/     /*Scope*/ 56, /*->16729*/
/* 16673*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16675*/      OPC_Scope, 25, /*->16702*/ // 2 children in Scope
/* 16677*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16679*/       OPC_EmitMergeInputChains1_0,
/* 16680*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16683*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16686*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 16693*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 13
                 // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 16702*/      /*Scope*/ 25, /*->16728*/
/* 16703*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16705*/       OPC_EmitMergeInputChains1_0,
/* 16706*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16709*/       OPC_EmitInteger, MVT::i64, 0, 
/* 16712*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 16719*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 13
                 // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 16728*/      0, /*End of Scope*/
/* 16729*/     /*Scope*/ 56, /*->16786*/
/* 16730*/      OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16732*/      OPC_Scope, 25, /*->16759*/ // 2 children in Scope
/* 16734*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16736*/       OPC_EmitMergeInputChains1_0,
/* 16737*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16740*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16743*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 16750*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 13
                 // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 16759*/      /*Scope*/ 25, /*->16785*/
/* 16760*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16762*/       OPC_EmitMergeInputChains1_0,
/* 16763*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16766*/       OPC_EmitInteger, MVT::i64, 0, 
/* 16769*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 16776*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 13
                 // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 16785*/      0, /*End of Scope*/
/* 16786*/     0, /*End of Scope*/
/* 16787*/    /*Scope*/ 121, /*->16909*/
/* 16788*/     OPC_RecordChild2, // #2 = $val
/* 16789*/     OPC_Scope, 58, /*->16849*/ // 2 children in Scope
/* 16791*/      OPC_CheckChild2Type, MVT::i32,
/* 16793*/      OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 16795*/      OPC_Scope, 25, /*->16822*/ // 2 children in Scope
/* 16797*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16799*/       OPC_EmitMergeInputChains1_0,
/* 16800*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16803*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16806*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 16813*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 10
                 // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 16822*/      /*Scope*/ 25, /*->16848*/
/* 16823*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16825*/       OPC_EmitMergeInputChains1_0,
/* 16826*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16829*/       OPC_EmitInteger, MVT::i64, 0, 
/* 16832*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 16839*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 10
                 // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 16848*/      0, /*End of Scope*/
/* 16849*/     /*Scope*/ 58, /*->16908*/
/* 16850*/      OPC_CheckChild2Type, MVT::i64,
/* 16852*/      OPC_CheckPredicate, 7, // Predicate_atomic_store_64
/* 16854*/      OPC_Scope, 25, /*->16881*/ // 2 children in Scope
/* 16856*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16858*/       OPC_EmitMergeInputChains1_0,
/* 16859*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16862*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16865*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 16872*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 10
                 // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 16881*/      /*Scope*/ 25, /*->16907*/
/* 16882*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 16884*/       OPC_EmitMergeInputChains1_0,
/* 16885*/       OPC_EmitInteger, MVT::i32, 0, 
/* 16888*/       OPC_EmitInteger, MVT::i64, 0, 
/* 16891*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 16898*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 10
                 // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 16907*/      0, /*End of Scope*/
/* 16908*/     0, /*End of Scope*/
/* 16909*/    0, /*End of Scope*/
/* 16910*/   0, // EndSwitchOpcode
/* 16911*/  /*Scope*/ 69|128,1/*197*/, /*->17110*/
/* 16913*/   OPC_RecordChild1, // #1 = $off
/* 16914*/   OPC_MoveChild1,
/* 16915*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 16918*/   OPC_MoveParent,
/* 16919*/   OPC_MoveChild2,
/* 16920*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16923*/   OPC_RecordChild0, // #2 = $val
/* 16924*/   OPC_MoveParent,
/* 16925*/   OPC_Scope, 60, /*->16987*/ // 3 children in Scope
/* 16927*/    OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 16929*/    OPC_Scope, 27, /*->16958*/ // 2 children in Scope
/* 16931*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16933*/     OPC_EmitMergeInputChains1_0,
/* 16934*/     OPC_EmitInteger, MVT::i32, 0, 
/* 16937*/     OPC_EmitConvertToTarget, 1,
/* 16939*/     OPC_EmitInteger, MVT::i32, 0, 
/* 16942*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 16949*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 6, 2, 
               // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 10
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 16958*/    /*Scope*/ 27, /*->16986*/
/* 16959*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16961*/     OPC_EmitMergeInputChains1_0,
/* 16962*/     OPC_EmitInteger, MVT::i32, 0, 
/* 16965*/     OPC_EmitConvertToTarget, 1,
/* 16967*/     OPC_EmitInteger, MVT::i64, 0, 
/* 16970*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 16977*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 6, 2, 
               // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 10
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 16986*/    0, /*End of Scope*/
/* 16987*/   /*Scope*/ 60, /*->17048*/
/* 16988*/    OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 16990*/    OPC_Scope, 27, /*->17019*/ // 2 children in Scope
/* 16992*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 16994*/     OPC_EmitMergeInputChains1_0,
/* 16995*/     OPC_EmitInteger, MVT::i32, 0, 
/* 16998*/     OPC_EmitConvertToTarget, 1,
/* 17000*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17003*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17010*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 6, 2, 
               // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 10
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 17019*/    /*Scope*/ 27, /*->17047*/
/* 17020*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17022*/     OPC_EmitMergeInputChains1_0,
/* 17023*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17026*/     OPC_EmitConvertToTarget, 1,
/* 17028*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17031*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 17038*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 6, 2, 
               // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 10
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 17047*/    0, /*End of Scope*/
/* 17048*/   /*Scope*/ 60, /*->17109*/
/* 17049*/    OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 17051*/    OPC_Scope, 27, /*->17080*/ // 2 children in Scope
/* 17053*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17055*/     OPC_EmitMergeInputChains1_0,
/* 17056*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17059*/     OPC_EmitConvertToTarget, 1,
/* 17061*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17064*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17071*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 6, 2, 
               // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 10
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 17080*/    /*Scope*/ 27, /*->17108*/
/* 17081*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17083*/     OPC_EmitMergeInputChains1_0,
/* 17084*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17087*/     OPC_EmitConvertToTarget, 1,
/* 17089*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17092*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 17099*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 6, 2, 
               // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 10
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 17108*/    0, /*End of Scope*/
/* 17109*/   0, /*End of Scope*/
/* 17110*/  /*Scope*/ 2|128,1/*130*/, /*->17242*/
/* 17112*/   OPC_MoveChild1,
/* 17113*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 17116*/   OPC_RecordChild0, // #1 = $off
/* 17117*/   OPC_MoveChild0,
/* 17118*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 17121*/   OPC_MoveParent,
/* 17122*/   OPC_MoveParent,
/* 17123*/   OPC_RecordChild2, // #2 = $val
/* 17124*/   OPC_CheckChild2Type, MVT::i32,
/* 17126*/   OPC_Scope, 56, /*->17184*/ // 2 children in Scope
/* 17128*/    OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 17130*/    OPC_Scope, 25, /*->17157*/ // 2 children in Scope
/* 17132*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 17134*/     OPC_EmitMergeInputChains1_0,
/* 17135*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17138*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17141*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 17148*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 1, 5, 2, 
               // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 10
               // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 17157*/    /*Scope*/ 25, /*->17183*/
/* 17158*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 17160*/     OPC_EmitMergeInputChains1_0,
/* 17161*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17164*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17167*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 17174*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 1, 5, 2, 
               // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 10
               // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 17183*/    0, /*End of Scope*/
/* 17184*/   /*Scope*/ 56, /*->17241*/
/* 17185*/    OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 17187*/    OPC_Scope, 25, /*->17214*/ // 2 children in Scope
/* 17189*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 17191*/     OPC_EmitMergeInputChains1_0,
/* 17192*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17195*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17198*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 17205*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 1, 5, 2, 
               // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 10
               // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 17214*/    /*Scope*/ 25, /*->17240*/
/* 17215*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 17217*/     OPC_EmitMergeInputChains1_0,
/* 17218*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17221*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17224*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 17231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 1, 5, 2, 
               // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 10
               // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 17240*/    0, /*End of Scope*/
/* 17241*/   0, /*End of Scope*/
/* 17242*/  /*Scope*/ 95|128,4/*607*/, /*->17851*/
/* 17244*/   OPC_RecordChild1, // #1 = $addr
/* 17245*/   OPC_Scope, 73, /*->17320*/ // 5 children in Scope
/* 17247*/    OPC_CheckChild1Type, MVT::i32,
/* 17249*/    OPC_MoveChild2,
/* 17250*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17253*/    OPC_RecordChild0, // #2 = $val
/* 17254*/    OPC_MoveParent,
/* 17255*/    OPC_Scope, 20, /*->17277*/ // 3 children in Scope
/* 17257*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 17259*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17261*/     OPC_EmitMergeInputChains1_0,
/* 17262*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17265*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17268*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 7
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 17277*/    /*Scope*/ 20, /*->17298*/
/* 17278*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 17280*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17282*/     OPC_EmitMergeInputChains1_0,
/* 17283*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17286*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17289*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 7
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 17298*/    /*Scope*/ 20, /*->17319*/
/* 17299*/     OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 17301*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17303*/     OPC_EmitMergeInputChains1_0,
/* 17304*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17307*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17310*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 7
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 17319*/    0, /*End of Scope*/
/* 17320*/   /*Scope*/ 73, /*->17394*/
/* 17321*/    OPC_CheckChild1Type, MVT::i64,
/* 17323*/    OPC_MoveChild2,
/* 17324*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17327*/    OPC_RecordChild0, // #2 = $val
/* 17328*/    OPC_MoveParent,
/* 17329*/    OPC_Scope, 20, /*->17351*/ // 3 children in Scope
/* 17331*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 17333*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17335*/     OPC_EmitMergeInputChains1_0,
/* 17336*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17339*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17342*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 7
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 17351*/    /*Scope*/ 20, /*->17372*/
/* 17352*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 17354*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17356*/     OPC_EmitMergeInputChains1_0,
/* 17357*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17360*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17363*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 7
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 17372*/    /*Scope*/ 20, /*->17393*/
/* 17373*/     OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 17375*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17377*/     OPC_EmitMergeInputChains1_0,
/* 17378*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17381*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17384*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I64:{ *:[i64] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 7
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 17393*/    0, /*End of Scope*/
/* 17394*/   /*Scope*/ 4|128,2/*260*/, /*->17656*/
/* 17396*/    OPC_MoveChild1,
/* 17397*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17400*/    OPC_MoveParent,
/* 17401*/    OPC_RecordChild2, // #2 = $val
/* 17402*/    OPC_Scope, 59|128,1/*187*/, /*->17592*/ // 2 children in Scope
/* 17405*/     OPC_CheckChild2Type, MVT::i32,
/* 17407*/     OPC_Scope, 60, /*->17469*/ // 3 children in Scope
/* 17409*/      OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 17411*/      OPC_Scope, 27, /*->17440*/ // 2 children in Scope
/* 17413*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17415*/       OPC_EmitMergeInputChains1_0,
/* 17416*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17419*/       OPC_EmitConvertToTarget, 1,
/* 17421*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17424*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17431*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 7
                 // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 17440*/      /*Scope*/ 27, /*->17468*/
/* 17441*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17443*/       OPC_EmitMergeInputChains1_0,
/* 17444*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17447*/       OPC_EmitConvertToTarget, 1,
/* 17449*/       OPC_EmitInteger, MVT::i64, 0, 
/* 17452*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 17459*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 7
                 // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 17468*/      0, /*End of Scope*/
/* 17469*/     /*Scope*/ 60, /*->17530*/
/* 17470*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 17472*/      OPC_Scope, 27, /*->17501*/ // 2 children in Scope
/* 17474*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17476*/       OPC_EmitMergeInputChains1_0,
/* 17477*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17480*/       OPC_EmitConvertToTarget, 1,
/* 17482*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17485*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17492*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 7
                 // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 17501*/      /*Scope*/ 27, /*->17529*/
/* 17502*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17504*/       OPC_EmitMergeInputChains1_0,
/* 17505*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17508*/       OPC_EmitConvertToTarget, 1,
/* 17510*/       OPC_EmitInteger, MVT::i64, 0, 
/* 17513*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 17520*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 7
                 // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 17529*/      0, /*End of Scope*/
/* 17530*/     /*Scope*/ 60, /*->17591*/
/* 17531*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 17533*/      OPC_Scope, 27, /*->17562*/ // 2 children in Scope
/* 17535*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17537*/       OPC_EmitMergeInputChains1_0,
/* 17538*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17541*/       OPC_EmitConvertToTarget, 1,
/* 17543*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17546*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17553*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 7
                 // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 17562*/      /*Scope*/ 27, /*->17590*/
/* 17563*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17565*/       OPC_EmitMergeInputChains1_0,
/* 17566*/       OPC_EmitInteger, MVT::i32, 0, 
/* 17569*/       OPC_EmitConvertToTarget, 1,
/* 17571*/       OPC_EmitInteger, MVT::i64, 0, 
/* 17574*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 17581*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 7
                 // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 17590*/      0, /*End of Scope*/
/* 17591*/     0, /*End of Scope*/
/* 17592*/    /*Scope*/ 62, /*->17655*/
/* 17593*/     OPC_CheckChild2Type, MVT::i64,
/* 17595*/     OPC_CheckPredicate, 7, // Predicate_atomic_store_64
/* 17597*/     OPC_Scope, 27, /*->17626*/ // 2 children in Scope
/* 17599*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17601*/      OPC_EmitMergeInputChains1_0,
/* 17602*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17605*/      OPC_EmitConvertToTarget, 1,
/* 17607*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17610*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17617*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 7
                // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 17626*/     /*Scope*/ 27, /*->17654*/
/* 17627*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17629*/      OPC_EmitMergeInputChains1_0,
/* 17630*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17633*/      OPC_EmitConvertToTarget, 1,
/* 17635*/      OPC_EmitInteger, MVT::i64, 0, 
/* 17638*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 17645*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 7
                // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 17654*/     0, /*End of Scope*/
/* 17655*/    0, /*End of Scope*/
/* 17656*/   /*Scope*/ 96, /*->17753*/
/* 17657*/    OPC_CheckChild1Type, MVT::i32,
/* 17659*/    OPC_RecordChild2, // #2 = $val
/* 17660*/    OPC_Scope, 67, /*->17729*/ // 2 children in Scope
/* 17662*/     OPC_CheckChild2Type, MVT::i32,
/* 17664*/     OPC_Scope, 20, /*->17686*/ // 3 children in Scope
/* 17666*/      OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 17668*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17670*/      OPC_EmitMergeInputChains1_0,
/* 17671*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17674*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17677*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_store I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 4
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 17686*/     /*Scope*/ 20, /*->17707*/
/* 17687*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 17689*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17691*/      OPC_EmitMergeInputChains1_0,
/* 17692*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17695*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17698*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_store I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 4
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 17707*/     /*Scope*/ 20, /*->17728*/
/* 17708*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 17710*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17712*/      OPC_EmitMergeInputChains1_0,
/* 17713*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17716*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17719*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_store I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 4
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 17728*/     0, /*End of Scope*/
/* 17729*/    /*Scope*/ 22, /*->17752*/
/* 17730*/     OPC_CheckChild2Type, MVT::i64,
/* 17732*/     OPC_CheckPredicate, 7, // Predicate_atomic_store_64
/* 17734*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17736*/     OPC_EmitMergeInputChains1_0,
/* 17737*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17740*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17743*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 4
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 17752*/    0, /*End of Scope*/
/* 17753*/   /*Scope*/ 96, /*->17850*/
/* 17754*/    OPC_CheckChild1Type, MVT::i64,
/* 17756*/    OPC_RecordChild2, // #2 = $val
/* 17757*/    OPC_Scope, 67, /*->17826*/ // 2 children in Scope
/* 17759*/     OPC_CheckChild2Type, MVT::i32,
/* 17761*/     OPC_Scope, 20, /*->17783*/ // 3 children in Scope
/* 17763*/      OPC_CheckPredicate, 4, // Predicate_atomic_store_32
/* 17765*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17767*/      OPC_EmitMergeInputChains1_0,
/* 17768*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17771*/      OPC_EmitInteger, MVT::i64, 0, 
/* 17774*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_store I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 4
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 17783*/     /*Scope*/ 20, /*->17804*/
/* 17784*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 17786*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17788*/      OPC_EmitMergeInputChains1_0,
/* 17789*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17792*/      OPC_EmitInteger, MVT::i64, 0, 
/* 17795*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_store I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 4
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 17804*/     /*Scope*/ 20, /*->17825*/
/* 17805*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 17807*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17809*/      OPC_EmitMergeInputChains1_0,
/* 17810*/      OPC_EmitInteger, MVT::i32, 0, 
/* 17813*/      OPC_EmitInteger, MVT::i64, 0, 
/* 17816*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_store I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 4
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 17825*/     0, /*End of Scope*/
/* 17826*/    /*Scope*/ 22, /*->17849*/
/* 17827*/     OPC_CheckChild2Type, MVT::i64,
/* 17829*/     OPC_CheckPredicate, 7, // Predicate_atomic_store_64
/* 17831*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 17833*/     OPC_EmitMergeInputChains1_0,
/* 17834*/     OPC_EmitInteger, MVT::i32, 0, 
/* 17837*/     OPC_EmitInteger, MVT::i64, 0, 
/* 17840*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_store I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 4
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 17849*/    0, /*End of Scope*/
/* 17850*/   0, /*End of Scope*/
/* 17851*/  0, /*End of Scope*/
/* 17852*/ /*SwitchOpcode*/ 100, TARGET_VAL(ISD::BRCOND),// ->17955
/* 17855*/  OPC_RecordNode, // #0 = 'brcond' chained node
/* 17856*/  OPC_Scope, 78, /*->17936*/ // 2 children in Scope
/* 17858*/   OPC_MoveChild1,
/* 17859*/   OPC_SwitchOpcode /*2 cases */, 24, TARGET_VAL(ISD::XOR),// ->17887
/* 17863*/    OPC_RecordChild0, // #1 = $cond
/* 17864*/    OPC_MoveChild0,
/* 17865*/    OPC_CheckPredicate, 8, // Predicate_bool_node
/* 17867*/    OPC_MoveParent,
/* 17868*/    OPC_CheckChild1Integer, 2, 
/* 17870*/    OPC_CheckType, MVT::i32,
/* 17872*/    OPC_MoveParent,
/* 17873*/    OPC_RecordChild2, // #2 = $dst
/* 17874*/    OPC_MoveChild2,
/* 17875*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 17878*/    OPC_MoveParent,
/* 17879*/    OPC_EmitMergeInputChains1_0,
/* 17880*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 17887*/   /*SwitchOpcode*/ 45, TARGET_VAL(ISD::SETCC),// ->17935
/* 17890*/    OPC_RecordChild0, // #1 = $cond
/* 17891*/    OPC_CheckChild0Type, MVT::i32,
/* 17893*/    OPC_CheckChild1Integer, 0, 
/* 17895*/    OPC_CheckType, MVT::i32,
/* 17897*/    OPC_Scope, 17, /*->17916*/ // 2 children in Scope
/* 17899*/     OPC_CheckChild2CondCode, ISD::SETNE,
/* 17901*/     OPC_MoveParent,
/* 17902*/     OPC_RecordChild2, // #2 = $dst
/* 17903*/     OPC_MoveChild2,
/* 17904*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 17907*/     OPC_MoveParent,
/* 17908*/     OPC_EmitMergeInputChains1_0,
/* 17909*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 17916*/    /*Scope*/ 17, /*->17934*/
/* 17917*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/* 17919*/     OPC_MoveParent,
/* 17920*/     OPC_RecordChild2, // #2 = $dst
/* 17921*/     OPC_MoveChild2,
/* 17922*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 17925*/     OPC_MoveParent,
/* 17926*/     OPC_EmitMergeInputChains1_0,
/* 17927*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 17934*/    0, /*End of Scope*/
/* 17935*/   0, // EndSwitchOpcode
/* 17936*/  /*Scope*/ 17, /*->17954*/
/* 17937*/   OPC_RecordChild1, // #1 = $cond
/* 17938*/   OPC_CheckChild1Type, MVT::i32,
/* 17940*/   OPC_RecordChild2, // #2 = $dst
/* 17941*/   OPC_MoveChild2,
/* 17942*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 17945*/   OPC_MoveParent,
/* 17946*/   OPC_EmitMergeInputChains1_0,
/* 17947*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/* 17954*/  0, /*End of Scope*/
/* 17955*/ /*SwitchOpcode*/ 10|128,53/*6794*/, TARGET_VAL(ISD::STORE),// ->24753
/* 17959*/  OPC_RecordMemRef,
/* 17960*/  OPC_RecordNode, // #0 = 'st' chained node
/* 17961*/  OPC_Scope, 63|128,2/*319*/, /*->18283*/ // 2 children in Scope
/* 17964*/   OPC_MoveChild1,
/* 17965*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 17968*/   OPC_RecordChild0, // #1 = $vec
/* 17969*/   OPC_Scope, 79, /*->18050*/ // 4 children in Scope
/* 17971*/    OPC_CheckChild0Type, MVT::v16i8,
/* 17973*/    OPC_RecordChild1, // #2 = $idx
/* 17974*/    OPC_MoveChild1,
/* 17975*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17978*/    OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 17980*/    OPC_CheckType, MVT::i32,
/* 17982*/    OPC_MoveParent,
/* 17983*/    OPC_CheckType, MVT::i32,
/* 17985*/    OPC_MoveParent,
/* 17986*/    OPC_RecordChild2, // #3 = $addr
/* 17987*/    OPC_Scope, 29, /*->18018*/ // 2 children in Scope
/* 17989*/     OPC_CheckChild2Type, MVT::i32,
/* 17991*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 17993*/     OPC_CheckPredicate, 10, // Predicate_truncstore
/* 17995*/     OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 17997*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 17999*/     OPC_EmitMergeInputChains1_0,
/* 18000*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18003*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18006*/     OPC_EmitConvertToTarget, 2,
/* 18008*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 12
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 18018*/    /*Scope*/ 30, /*->18049*/
/* 18019*/     OPC_CheckChild2Type, MVT::i64,
/* 18021*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18023*/     OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18025*/     OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18027*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18029*/     OPC_EmitMergeInputChains1_0,
/* 18030*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18033*/     OPC_EmitInteger, MVT::i64, 0, 
/* 18036*/     OPC_EmitConvertToTarget, 2,
/* 18038*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 12
               // Dst: (STORE_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 18049*/    0, /*End of Scope*/
/* 18050*/   /*Scope*/ 79, /*->18130*/
/* 18051*/    OPC_CheckChild0Type, MVT::v8i16,
/* 18053*/    OPC_RecordChild1, // #2 = $idx
/* 18054*/    OPC_MoveChild1,
/* 18055*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18058*/    OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 18060*/    OPC_CheckType, MVT::i32,
/* 18062*/    OPC_MoveParent,
/* 18063*/    OPC_CheckType, MVT::i32,
/* 18065*/    OPC_MoveParent,
/* 18066*/    OPC_RecordChild2, // #3 = $addr
/* 18067*/    OPC_Scope, 29, /*->18098*/ // 2 children in Scope
/* 18069*/     OPC_CheckChild2Type, MVT::i32,
/* 18071*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18073*/     OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18075*/     OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18077*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18079*/     OPC_EmitMergeInputChains1_0,
/* 18080*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18083*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18086*/     OPC_EmitConvertToTarget, 2,
/* 18088*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 12
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 18098*/    /*Scope*/ 30, /*->18129*/
/* 18099*/     OPC_CheckChild2Type, MVT::i64,
/* 18101*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18103*/     OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18105*/     OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18107*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18109*/     OPC_EmitMergeInputChains1_0,
/* 18110*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18113*/     OPC_EmitInteger, MVT::i64, 0, 
/* 18116*/     OPC_EmitConvertToTarget, 2,
/* 18118*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 12
               // Dst: (STORE_LANE_I16x8_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 18129*/    0, /*End of Scope*/
/* 18130*/   /*Scope*/ 75, /*->18206*/
/* 18131*/    OPC_CheckChild0Type, MVT::v4i32,
/* 18133*/    OPC_RecordChild1, // #2 = $idx
/* 18134*/    OPC_MoveChild1,
/* 18135*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18138*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 18140*/    OPC_CheckType, MVT::i32,
/* 18142*/    OPC_MoveParent,
/* 18143*/    OPC_CheckType, MVT::i32,
/* 18145*/    OPC_MoveParent,
/* 18146*/    OPC_RecordChild2, // #3 = $addr
/* 18147*/    OPC_Scope, 27, /*->18176*/ // 2 children in Scope
/* 18149*/     OPC_CheckChild2Type, MVT::i32,
/* 18151*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18153*/     OPC_CheckPredicate, 14, // Predicate_store
/* 18155*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18157*/     OPC_EmitMergeInputChains1_0,
/* 18158*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18161*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18164*/     OPC_EmitConvertToTarget, 2,
/* 18166*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 12
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 18176*/    /*Scope*/ 28, /*->18205*/
/* 18177*/     OPC_CheckChild2Type, MVT::i64,
/* 18179*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18181*/     OPC_CheckPredicate, 14, // Predicate_store
/* 18183*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18185*/     OPC_EmitMergeInputChains1_0,
/* 18186*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18189*/     OPC_EmitInteger, MVT::i64, 0, 
/* 18192*/     OPC_EmitConvertToTarget, 2,
/* 18194*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 12
               // Dst: (STORE_LANE_I32x4_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 18205*/    0, /*End of Scope*/
/* 18206*/   /*Scope*/ 75, /*->18282*/
/* 18207*/    OPC_CheckChild0Type, MVT::v2i64,
/* 18209*/    OPC_RecordChild1, // #2 = $idx
/* 18210*/    OPC_MoveChild1,
/* 18211*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18214*/    OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 18216*/    OPC_CheckType, MVT::i32,
/* 18218*/    OPC_MoveParent,
/* 18219*/    OPC_CheckType, MVT::i64,
/* 18221*/    OPC_MoveParent,
/* 18222*/    OPC_RecordChild2, // #3 = $addr
/* 18223*/    OPC_Scope, 27, /*->18252*/ // 2 children in Scope
/* 18225*/     OPC_CheckChild2Type, MVT::i32,
/* 18227*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18229*/     OPC_CheckPredicate, 14, // Predicate_store
/* 18231*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18233*/     OPC_EmitMergeInputChains1_0,
/* 18234*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18237*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18240*/     OPC_EmitConvertToTarget, 2,
/* 18242*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 12
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 18252*/    /*Scope*/ 28, /*->18281*/
/* 18253*/     OPC_CheckChild2Type, MVT::i64,
/* 18255*/     OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18257*/     OPC_CheckPredicate, 14, // Predicate_store
/* 18259*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18261*/     OPC_EmitMergeInputChains1_0,
/* 18262*/     OPC_EmitInteger, MVT::i32, 0, 
/* 18265*/     OPC_EmitInteger, MVT::i64, 0, 
/* 18268*/     OPC_EmitConvertToTarget, 2,
/* 18270*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 3, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 12
               // Dst: (STORE_LANE_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 18281*/    0, /*End of Scope*/
/* 18282*/   0, /*End of Scope*/
/* 18283*/  /*Scope*/ 67|128,50/*6467*/, /*->24752*/
/* 18285*/   OPC_RecordChild1, // #1 = $val
/* 18286*/   OPC_Scope, 104|128,6/*872*/, /*->19161*/ // 10 children in Scope
/* 18289*/    OPC_CheckChild1Type, MVT::i32,
/* 18291*/    OPC_Scope, 0|128,4/*512*/, /*->18806*/ // 2 children in Scope
/* 18294*/     OPC_MoveChild2,
/* 18295*/     OPC_SwitchOpcode /*3 cases */, 27|128,1/*155*/, TARGET_VAL(ISD::ADD),// ->18455
/* 18300*/      OPC_RecordChild0, // #2 = $addr
/* 18301*/      OPC_RecordChild1, // #3 = $off
/* 18302*/      OPC_MoveChild1,
/* 18303*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18306*/      OPC_MoveParent,
/* 18307*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 18309*/      OPC_SwitchType /*2 cases */, 70, MVT::i32,// ->18382
/* 18312*/       OPC_MoveParent,
/* 18313*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18315*/       OPC_Scope, 19, /*->18336*/ // 2 children in Scope
/* 18317*/        OPC_CheckPredicate, 14, // Predicate_store
/* 18319*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18321*/        OPC_EmitMergeInputChains1_0,
/* 18322*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18325*/        OPC_EmitConvertToTarget, 3,
/* 18327*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 18336*/       /*Scope*/ 44, /*->18381*/
/* 18337*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18339*/        OPC_Scope, 19, /*->18360*/ // 2 children in Scope
/* 18341*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18343*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18345*/         OPC_EmitMergeInputChains1_0,
/* 18346*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18349*/         OPC_EmitConvertToTarget, 3,
/* 18351*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 18360*/        /*Scope*/ 19, /*->18380*/
/* 18361*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18363*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18365*/         OPC_EmitMergeInputChains1_0,
/* 18366*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18369*/         OPC_EmitConvertToTarget, 3,
/* 18371*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 18380*/        0, /*End of Scope*/
/* 18381*/       0, /*End of Scope*/
/* 18382*/      /*SwitchType*/ 70, MVT::i64,// ->18454
/* 18384*/       OPC_MoveParent,
/* 18385*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18387*/       OPC_Scope, 19, /*->18408*/ // 2 children in Scope
/* 18389*/        OPC_CheckPredicate, 14, // Predicate_store
/* 18391*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18393*/        OPC_EmitMergeInputChains1_0,
/* 18394*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18397*/        OPC_EmitConvertToTarget, 3,
/* 18399*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 18408*/       /*Scope*/ 44, /*->18453*/
/* 18409*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18411*/        OPC_Scope, 19, /*->18432*/ // 2 children in Scope
/* 18413*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18415*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18417*/         OPC_EmitMergeInputChains1_0,
/* 18418*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18421*/         OPC_EmitConvertToTarget, 3,
/* 18423*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 18432*/        /*Scope*/ 19, /*->18452*/
/* 18433*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18435*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18437*/         OPC_EmitMergeInputChains1_0,
/* 18438*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18441*/         OPC_EmitConvertToTarget, 3,
/* 18443*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 18452*/        0, /*End of Scope*/
/* 18453*/       0, /*End of Scope*/
/* 18454*/      0, // EndSwitchType
/* 18455*/     /*SwitchOpcode*/ 27|128,1/*155*/, TARGET_VAL(ISD::OR),// ->18614
/* 18459*/      OPC_RecordChild0, // #2 = $addr
/* 18460*/      OPC_RecordChild1, // #3 = $off
/* 18461*/      OPC_MoveChild1,
/* 18462*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18465*/      OPC_MoveParent,
/* 18466*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 18468*/      OPC_SwitchType /*2 cases */, 70, MVT::i32,// ->18541
/* 18471*/       OPC_MoveParent,
/* 18472*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18474*/       OPC_Scope, 19, /*->18495*/ // 2 children in Scope
/* 18476*/        OPC_CheckPredicate, 14, // Predicate_store
/* 18478*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18480*/        OPC_EmitMergeInputChains1_0,
/* 18481*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18484*/        OPC_EmitConvertToTarget, 3,
/* 18486*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 18495*/       /*Scope*/ 44, /*->18540*/
/* 18496*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18498*/        OPC_Scope, 19, /*->18519*/ // 2 children in Scope
/* 18500*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18502*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18504*/         OPC_EmitMergeInputChains1_0,
/* 18505*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18508*/         OPC_EmitConvertToTarget, 3,
/* 18510*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 18519*/        /*Scope*/ 19, /*->18539*/
/* 18520*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18522*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18524*/         OPC_EmitMergeInputChains1_0,
/* 18525*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18528*/         OPC_EmitConvertToTarget, 3,
/* 18530*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 18539*/        0, /*End of Scope*/
/* 18540*/       0, /*End of Scope*/
/* 18541*/      /*SwitchType*/ 70, MVT::i64,// ->18613
/* 18543*/       OPC_MoveParent,
/* 18544*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18546*/       OPC_Scope, 19, /*->18567*/ // 2 children in Scope
/* 18548*/        OPC_CheckPredicate, 14, // Predicate_store
/* 18550*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18552*/        OPC_EmitMergeInputChains1_0,
/* 18553*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18556*/        OPC_EmitConvertToTarget, 3,
/* 18558*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 18567*/       /*Scope*/ 44, /*->18612*/
/* 18568*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18570*/        OPC_Scope, 19, /*->18591*/ // 2 children in Scope
/* 18572*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18574*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18576*/         OPC_EmitMergeInputChains1_0,
/* 18577*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18580*/         OPC_EmitConvertToTarget, 3,
/* 18582*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 18591*/        /*Scope*/ 19, /*->18611*/
/* 18592*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18594*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18596*/         OPC_EmitMergeInputChains1_0,
/* 18597*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18600*/         OPC_EmitConvertToTarget, 3,
/* 18602*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 18611*/        0, /*End of Scope*/
/* 18612*/       0, /*End of Scope*/
/* 18613*/      0, // EndSwitchType
/* 18614*/     /*SwitchOpcode*/ 59|128,1/*187*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->18805
/* 18618*/      OPC_RecordChild0, // #2 = $off
/* 18619*/      OPC_MoveChild0,
/* 18620*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18623*/      OPC_MoveParent,
/* 18624*/      OPC_MoveParent,
/* 18625*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18627*/      OPC_Scope, 56, /*->18685*/ // 2 children in Scope
/* 18629*/       OPC_CheckPredicate, 14, // Predicate_store
/* 18631*/       OPC_Scope, 25, /*->18658*/ // 2 children in Scope
/* 18633*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 18635*/        OPC_EmitMergeInputChains1_0,
/* 18636*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18639*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18642*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18649*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_I32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 18658*/       /*Scope*/ 25, /*->18684*/
/* 18659*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 18661*/        OPC_EmitMergeInputChains1_0,
/* 18662*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18665*/        OPC_EmitInteger, MVT::i64, 0, 
/* 18668*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 18675*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_I32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 18684*/       0, /*End of Scope*/
/* 18685*/      /*Scope*/ 118, /*->18804*/
/* 18686*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18688*/       OPC_Scope, 56, /*->18746*/ // 2 children in Scope
/* 18690*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18692*/        OPC_Scope, 25, /*->18719*/ // 2 children in Scope
/* 18694*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 18696*/         OPC_EmitMergeInputChains1_0,
/* 18697*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18700*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18703*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18710*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                   // Dst: (STORE8_I32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 18719*/        /*Scope*/ 25, /*->18745*/
/* 18720*/         OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 18722*/         OPC_EmitMergeInputChains1_0,
/* 18723*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18726*/         OPC_EmitInteger, MVT::i64, 0, 
/* 18729*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 18736*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                   // Dst: (STORE8_I32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 18745*/        0, /*End of Scope*/
/* 18746*/       /*Scope*/ 56, /*->18803*/
/* 18747*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18749*/        OPC_Scope, 25, /*->18776*/ // 2 children in Scope
/* 18751*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 18753*/         OPC_EmitMergeInputChains1_0,
/* 18754*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18757*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18760*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18767*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                   // Dst: (STORE16_I32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 18776*/        /*Scope*/ 25, /*->18802*/
/* 18777*/         OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 18779*/         OPC_EmitMergeInputChains1_0,
/* 18780*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18783*/         OPC_EmitInteger, MVT::i64, 0, 
/* 18786*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 18793*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                   // Dst: (STORE16_I32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 18802*/        0, /*End of Scope*/
/* 18803*/       0, /*End of Scope*/
/* 18804*/      0, /*End of Scope*/
/* 18805*/     0, // EndSwitchOpcode
/* 18806*/    /*Scope*/ 96|128,2/*352*/, /*->19160*/
/* 18808*/     OPC_RecordChild2, // #2 = $off
/* 18809*/     OPC_Scope, 69|128,1/*197*/, /*->19009*/ // 3 children in Scope
/* 18812*/      OPC_MoveChild2,
/* 18813*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18816*/      OPC_MoveParent,
/* 18817*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 18819*/      OPC_Scope, 60, /*->18881*/ // 2 children in Scope
/* 18821*/       OPC_CheckPredicate, 14, // Predicate_store
/* 18823*/       OPC_Scope, 27, /*->18852*/ // 2 children in Scope
/* 18825*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18827*/        OPC_EmitMergeInputChains1_0,
/* 18828*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18831*/        OPC_EmitConvertToTarget, 2,
/* 18833*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18836*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 18843*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 18852*/       /*Scope*/ 27, /*->18880*/
/* 18853*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18855*/        OPC_EmitMergeInputChains1_0,
/* 18856*/        OPC_EmitInteger, MVT::i32, 0, 
/* 18859*/        OPC_EmitConvertToTarget, 2,
/* 18861*/        OPC_EmitInteger, MVT::i64, 0, 
/* 18864*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 18871*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 18880*/       0, /*End of Scope*/
/* 18881*/      /*Scope*/ 126, /*->19008*/
/* 18882*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 18884*/       OPC_Scope, 60, /*->18946*/ // 2 children in Scope
/* 18886*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 18888*/        OPC_Scope, 27, /*->18917*/ // 2 children in Scope
/* 18890*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18892*/         OPC_EmitMergeInputChains1_0,
/* 18893*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18896*/         OPC_EmitConvertToTarget, 2,
/* 18898*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18901*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 18908*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 7
                   // Dst: (STORE8_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 18917*/        /*Scope*/ 27, /*->18945*/
/* 18918*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18920*/         OPC_EmitMergeInputChains1_0,
/* 18921*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18924*/         OPC_EmitConvertToTarget, 2,
/* 18926*/         OPC_EmitInteger, MVT::i64, 0, 
/* 18929*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 18936*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 7
                   // Dst: (STORE8_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 18945*/        0, /*End of Scope*/
/* 18946*/       /*Scope*/ 60, /*->19007*/
/* 18947*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 18949*/        OPC_Scope, 27, /*->18978*/ // 2 children in Scope
/* 18951*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 18953*/         OPC_EmitMergeInputChains1_0,
/* 18954*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18957*/         OPC_EmitConvertToTarget, 2,
/* 18959*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18962*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 18969*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 7
                   // Dst: (STORE16_I32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 18978*/        /*Scope*/ 27, /*->19006*/
/* 18979*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 18981*/         OPC_EmitMergeInputChains1_0,
/* 18982*/         OPC_EmitInteger, MVT::i32, 0, 
/* 18985*/         OPC_EmitConvertToTarget, 2,
/* 18987*/         OPC_EmitInteger, MVT::i64, 0, 
/* 18990*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 18997*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 7
                   // Dst: (STORE16_I32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 19006*/        0, /*End of Scope*/
/* 19007*/       0, /*End of Scope*/
/* 19008*/      0, /*End of Scope*/
/* 19009*/     /*Scope*/ 74, /*->19084*/
/* 19010*/      OPC_CheckChild2Type, MVT::i32,
/* 19012*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19014*/      OPC_Scope, 20, /*->19036*/ // 2 children in Scope
/* 19016*/       OPC_CheckPredicate, 14, // Predicate_store
/* 19018*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19020*/       OPC_EmitMergeInputChains1_0,
/* 19021*/       OPC_EmitInteger, MVT::i32, 0, 
/* 19024*/       OPC_EmitInteger, MVT::i32, 0, 
/* 19027*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_I32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 19036*/      /*Scope*/ 46, /*->19083*/
/* 19037*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19039*/       OPC_Scope, 20, /*->19061*/ // 2 children in Scope
/* 19041*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19043*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19045*/        OPC_EmitMergeInputChains1_0,
/* 19046*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19049*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19052*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 4
                  // Dst: (STORE8_I32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 19061*/       /*Scope*/ 20, /*->19082*/
/* 19062*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19064*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19066*/        OPC_EmitMergeInputChains1_0,
/* 19067*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19070*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19073*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 4
                  // Dst: (STORE16_I32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 19082*/       0, /*End of Scope*/
/* 19083*/      0, /*End of Scope*/
/* 19084*/     /*Scope*/ 74, /*->19159*/
/* 19085*/      OPC_CheckChild2Type, MVT::i64,
/* 19087*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19089*/      OPC_Scope, 20, /*->19111*/ // 2 children in Scope
/* 19091*/       OPC_CheckPredicate, 14, // Predicate_store
/* 19093*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19095*/       OPC_EmitMergeInputChains1_0,
/* 19096*/       OPC_EmitInteger, MVT::i32, 0, 
/* 19099*/       OPC_EmitInteger, MVT::i64, 0, 
/* 19102*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_I32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 19111*/      /*Scope*/ 46, /*->19158*/
/* 19112*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19114*/       OPC_Scope, 20, /*->19136*/ // 2 children in Scope
/* 19116*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19118*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19120*/        OPC_EmitMergeInputChains1_0,
/* 19121*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19124*/        OPC_EmitInteger, MVT::i64, 0, 
/* 19127*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 4
                  // Dst: (STORE8_I32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 19136*/       /*Scope*/ 20, /*->19157*/
/* 19137*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19139*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19141*/        OPC_EmitMergeInputChains1_0,
/* 19142*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19145*/        OPC_EmitInteger, MVT::i64, 0, 
/* 19148*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i32:{ *:[i32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 4
                  // Dst: (STORE16_I32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 19157*/       0, /*End of Scope*/
/* 19158*/      0, /*End of Scope*/
/* 19159*/     0, /*End of Scope*/
/* 19160*/    0, /*End of Scope*/
/* 19161*/   /*Scope*/ 90|128,8/*1114*/, /*->20277*/
/* 19163*/    OPC_CheckChild1Type, MVT::i64,
/* 19165*/    OPC_Scope, 10|128,5/*650*/, /*->19818*/ // 2 children in Scope
/* 19168*/     OPC_MoveChild2,
/* 19169*/     OPC_SwitchOpcode /*3 cases */, 67|128,1/*195*/, TARGET_VAL(ISD::ADD),// ->19369
/* 19174*/      OPC_RecordChild0, // #2 = $addr
/* 19175*/      OPC_RecordChild1, // #3 = $off
/* 19176*/      OPC_MoveChild1,
/* 19177*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19180*/      OPC_MoveParent,
/* 19181*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 19183*/      OPC_SwitchType /*2 cases */, 90, MVT::i32,// ->19276
/* 19186*/       OPC_MoveParent,
/* 19187*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19189*/       OPC_Scope, 19, /*->19210*/ // 2 children in Scope
/* 19191*/        OPC_CheckPredicate, 14, // Predicate_store
/* 19193*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19195*/        OPC_EmitMergeInputChains1_0,
/* 19196*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19199*/        OPC_EmitConvertToTarget, 3,
/* 19201*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19210*/       /*Scope*/ 64, /*->19275*/
/* 19211*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19213*/        OPC_Scope, 19, /*->19234*/ // 3 children in Scope
/* 19215*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19217*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19219*/         OPC_EmitMergeInputChains1_0,
/* 19220*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19223*/         OPC_EmitConvertToTarget, 3,
/* 19225*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19234*/        /*Scope*/ 19, /*->19254*/
/* 19235*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19237*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19239*/         OPC_EmitMergeInputChains1_0,
/* 19240*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19243*/         OPC_EmitConvertToTarget, 3,
/* 19245*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19254*/        /*Scope*/ 19, /*->19274*/
/* 19255*/         OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 19257*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19259*/         OPC_EmitMergeInputChains1_0,
/* 19260*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19263*/         OPC_EmitConvertToTarget, 3,
/* 19265*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 11
                   // Dst: (STORE32_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19274*/        0, /*End of Scope*/
/* 19275*/       0, /*End of Scope*/
/* 19276*/      /*SwitchType*/ 90, MVT::i64,// ->19368
/* 19278*/       OPC_MoveParent,
/* 19279*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19281*/       OPC_Scope, 19, /*->19302*/ // 2 children in Scope
/* 19283*/        OPC_CheckPredicate, 14, // Predicate_store
/* 19285*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19287*/        OPC_EmitMergeInputChains1_0,
/* 19288*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19291*/        OPC_EmitConvertToTarget, 3,
/* 19293*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19302*/       /*Scope*/ 64, /*->19367*/
/* 19303*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19305*/        OPC_Scope, 19, /*->19326*/ // 3 children in Scope
/* 19307*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19309*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19311*/         OPC_EmitMergeInputChains1_0,
/* 19312*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19315*/         OPC_EmitConvertToTarget, 3,
/* 19317*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19326*/        /*Scope*/ 19, /*->19346*/
/* 19327*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19329*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19331*/         OPC_EmitMergeInputChains1_0,
/* 19332*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19335*/         OPC_EmitConvertToTarget, 3,
/* 19337*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19346*/        /*Scope*/ 19, /*->19366*/
/* 19347*/         OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 19349*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19351*/         OPC_EmitMergeInputChains1_0,
/* 19352*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19355*/         OPC_EmitConvertToTarget, 3,
/* 19357*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 11
                   // Dst: (STORE32_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19366*/        0, /*End of Scope*/
/* 19367*/       0, /*End of Scope*/
/* 19368*/      0, // EndSwitchType
/* 19369*/     /*SwitchOpcode*/ 67|128,1/*195*/, TARGET_VAL(ISD::OR),// ->19568
/* 19373*/      OPC_RecordChild0, // #2 = $addr
/* 19374*/      OPC_RecordChild1, // #3 = $off
/* 19375*/      OPC_MoveChild1,
/* 19376*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19379*/      OPC_MoveParent,
/* 19380*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 19382*/      OPC_SwitchType /*2 cases */, 90, MVT::i32,// ->19475
/* 19385*/       OPC_MoveParent,
/* 19386*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19388*/       OPC_Scope, 19, /*->19409*/ // 2 children in Scope
/* 19390*/        OPC_CheckPredicate, 14, // Predicate_store
/* 19392*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19394*/        OPC_EmitMergeInputChains1_0,
/* 19395*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19398*/        OPC_EmitConvertToTarget, 3,
/* 19400*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19409*/       /*Scope*/ 64, /*->19474*/
/* 19410*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19412*/        OPC_Scope, 19, /*->19433*/ // 3 children in Scope
/* 19414*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19416*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19418*/         OPC_EmitMergeInputChains1_0,
/* 19419*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19422*/         OPC_EmitConvertToTarget, 3,
/* 19424*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19433*/        /*Scope*/ 19, /*->19453*/
/* 19434*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19436*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19438*/         OPC_EmitMergeInputChains1_0,
/* 19439*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19442*/         OPC_EmitConvertToTarget, 3,
/* 19444*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19453*/        /*Scope*/ 19, /*->19473*/
/* 19454*/         OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 19456*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19458*/         OPC_EmitMergeInputChains1_0,
/* 19459*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19462*/         OPC_EmitConvertToTarget, 3,
/* 19464*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 11
                   // Dst: (STORE32_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19473*/        0, /*End of Scope*/
/* 19474*/       0, /*End of Scope*/
/* 19475*/      /*SwitchType*/ 90, MVT::i64,// ->19567
/* 19477*/       OPC_MoveParent,
/* 19478*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19480*/       OPC_Scope, 19, /*->19501*/ // 2 children in Scope
/* 19482*/        OPC_CheckPredicate, 14, // Predicate_store
/* 19484*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19486*/        OPC_EmitMergeInputChains1_0,
/* 19487*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19490*/        OPC_EmitConvertToTarget, 3,
/* 19492*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19501*/       /*Scope*/ 64, /*->19566*/
/* 19502*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19504*/        OPC_Scope, 19, /*->19525*/ // 3 children in Scope
/* 19506*/         OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19508*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19510*/         OPC_EmitMergeInputChains1_0,
/* 19511*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19514*/         OPC_EmitConvertToTarget, 3,
/* 19516*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                   // Dst: (STORE8_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19525*/        /*Scope*/ 19, /*->19545*/
/* 19526*/         OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19528*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19530*/         OPC_EmitMergeInputChains1_0,
/* 19531*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19534*/         OPC_EmitConvertToTarget, 3,
/* 19536*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                   // Dst: (STORE16_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19545*/        /*Scope*/ 19, /*->19565*/
/* 19546*/         OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 19548*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19550*/         OPC_EmitMergeInputChains1_0,
/* 19551*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19554*/         OPC_EmitConvertToTarget, 3,
/* 19556*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 4, 5, 2, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 11
                   // Dst: (STORE32_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 19565*/        0, /*End of Scope*/
/* 19566*/       0, /*End of Scope*/
/* 19567*/      0, // EndSwitchType
/* 19568*/     /*SwitchOpcode*/ 117|128,1/*245*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->19817
/* 19572*/      OPC_RecordChild0, // #2 = $off
/* 19573*/      OPC_MoveChild0,
/* 19574*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 19577*/      OPC_MoveParent,
/* 19578*/      OPC_MoveParent,
/* 19579*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19581*/      OPC_Scope, 56, /*->19639*/ // 2 children in Scope
/* 19583*/       OPC_CheckPredicate, 14, // Predicate_store
/* 19585*/       OPC_Scope, 25, /*->19612*/ // 2 children in Scope
/* 19587*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19589*/        OPC_EmitMergeInputChains1_0,
/* 19590*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19593*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19596*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19603*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19612*/       /*Scope*/ 25, /*->19638*/
/* 19613*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19615*/        OPC_EmitMergeInputChains1_0,
/* 19616*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19619*/        OPC_EmitInteger, MVT::i64, 0, 
/* 19622*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 19629*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 19638*/       0, /*End of Scope*/
/* 19639*/      /*Scope*/ 47|128,1/*175*/, /*->19816*/
/* 19641*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19643*/       OPC_Scope, 56, /*->19701*/ // 3 children in Scope
/* 19645*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19647*/        OPC_Scope, 25, /*->19674*/ // 2 children in Scope
/* 19649*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19651*/         OPC_EmitMergeInputChains1_0,
/* 19652*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19655*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19658*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19665*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                   // Dst: (STORE8_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19674*/        /*Scope*/ 25, /*->19700*/
/* 19675*/         OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19677*/         OPC_EmitMergeInputChains1_0,
/* 19678*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19681*/         OPC_EmitInteger, MVT::i64, 0, 
/* 19684*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 19691*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                   // Dst: (STORE8_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 19700*/        0, /*End of Scope*/
/* 19701*/       /*Scope*/ 56, /*->19758*/
/* 19702*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19704*/        OPC_Scope, 25, /*->19731*/ // 2 children in Scope
/* 19706*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19708*/         OPC_EmitMergeInputChains1_0,
/* 19709*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19712*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19715*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19722*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                   // Dst: (STORE16_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19731*/        /*Scope*/ 25, /*->19757*/
/* 19732*/         OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19734*/         OPC_EmitMergeInputChains1_0,
/* 19735*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19738*/         OPC_EmitInteger, MVT::i64, 0, 
/* 19741*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 19748*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                   // Dst: (STORE16_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 19757*/        0, /*End of Scope*/
/* 19758*/       /*Scope*/ 56, /*->19815*/
/* 19759*/        OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 19761*/        OPC_Scope, 25, /*->19788*/ // 2 children in Scope
/* 19763*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19765*/         OPC_EmitMergeInputChains1_0,
/* 19766*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19769*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19772*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19779*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 10
                   // Dst: (STORE32_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19788*/        /*Scope*/ 25, /*->19814*/
/* 19789*/         OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 19791*/         OPC_EmitMergeInputChains1_0,
/* 19792*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19795*/         OPC_EmitInteger, MVT::i64, 0, 
/* 19798*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 19805*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 2, 5, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 10
                   // Dst: (STORE32_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 19814*/        0, /*End of Scope*/
/* 19815*/       0, /*End of Scope*/
/* 19816*/      0, /*End of Scope*/
/* 19817*/     0, // EndSwitchOpcode
/* 19818*/    /*Scope*/ 72|128,3/*456*/, /*->20276*/
/* 19820*/     OPC_RecordChild2, // #2 = $off
/* 19821*/     OPC_Scope, 3|128,2/*259*/, /*->20083*/ // 3 children in Scope
/* 19824*/      OPC_MoveChild2,
/* 19825*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19828*/      OPC_MoveParent,
/* 19829*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 19831*/      OPC_Scope, 60, /*->19893*/ // 2 children in Scope
/* 19833*/       OPC_CheckPredicate, 14, // Predicate_store
/* 19835*/       OPC_Scope, 27, /*->19864*/ // 2 children in Scope
/* 19837*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19839*/        OPC_EmitMergeInputChains1_0,
/* 19840*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19843*/        OPC_EmitConvertToTarget, 2,
/* 19845*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19848*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 19855*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19864*/       /*Scope*/ 27, /*->19892*/
/* 19865*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19867*/        OPC_EmitMergeInputChains1_0,
/* 19868*/        OPC_EmitInteger, MVT::i32, 0, 
/* 19871*/        OPC_EmitConvertToTarget, 2,
/* 19873*/        OPC_EmitInteger, MVT::i64, 0, 
/* 19876*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 19883*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 19892*/       0, /*End of Scope*/
/* 19893*/      /*Scope*/ 59|128,1/*187*/, /*->20082*/
/* 19895*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 19897*/       OPC_Scope, 60, /*->19959*/ // 3 children in Scope
/* 19899*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 19901*/        OPC_Scope, 27, /*->19930*/ // 2 children in Scope
/* 19903*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19905*/         OPC_EmitMergeInputChains1_0,
/* 19906*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19909*/         OPC_EmitConvertToTarget, 2,
/* 19911*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19914*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 19921*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 7
                   // Dst: (STORE8_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19930*/        /*Scope*/ 27, /*->19958*/
/* 19931*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19933*/         OPC_EmitMergeInputChains1_0,
/* 19934*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19937*/         OPC_EmitConvertToTarget, 2,
/* 19939*/         OPC_EmitInteger, MVT::i64, 0, 
/* 19942*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 19949*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 7
                   // Dst: (STORE8_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 19958*/        0, /*End of Scope*/
/* 19959*/       /*Scope*/ 60, /*->20020*/
/* 19960*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 19962*/        OPC_Scope, 27, /*->19991*/ // 2 children in Scope
/* 19964*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 19966*/         OPC_EmitMergeInputChains1_0,
/* 19967*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19970*/         OPC_EmitConvertToTarget, 2,
/* 19972*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19975*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 19982*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 7
                   // Dst: (STORE16_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19991*/        /*Scope*/ 27, /*->20019*/
/* 19992*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 19994*/         OPC_EmitMergeInputChains1_0,
/* 19995*/         OPC_EmitInteger, MVT::i32, 0, 
/* 19998*/         OPC_EmitConvertToTarget, 2,
/* 20000*/         OPC_EmitInteger, MVT::i64, 0, 
/* 20003*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 20010*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 7
                   // Dst: (STORE16_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 20019*/        0, /*End of Scope*/
/* 20020*/       /*Scope*/ 60, /*->20081*/
/* 20021*/        OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 20023*/        OPC_Scope, 27, /*->20052*/ // 2 children in Scope
/* 20025*/         OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20027*/         OPC_EmitMergeInputChains1_0,
/* 20028*/         OPC_EmitInteger, MVT::i32, 0, 
/* 20031*/         OPC_EmitConvertToTarget, 2,
/* 20033*/         OPC_EmitInteger, MVT::i32, 0, 
/* 20036*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                       MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 20043*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 7
                   // Dst: (STORE32_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20052*/        /*Scope*/ 27, /*->20080*/
/* 20053*/         OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20055*/         OPC_EmitMergeInputChains1_0,
/* 20056*/         OPC_EmitInteger, MVT::i32, 0, 
/* 20059*/         OPC_EmitConvertToTarget, 2,
/* 20061*/         OPC_EmitInteger, MVT::i64, 0, 
/* 20064*/         OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                       MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 20071*/         OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                       4/*#Ops*/, 3, 4, 6, 1, 
                   // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 7
                   // Dst: (STORE32_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 20080*/        0, /*End of Scope*/
/* 20081*/       0, /*End of Scope*/
/* 20082*/      0, /*End of Scope*/
/* 20083*/     /*Scope*/ 95, /*->20179*/
/* 20084*/      OPC_CheckChild2Type, MVT::i32,
/* 20086*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20088*/      OPC_Scope, 20, /*->20110*/ // 2 children in Scope
/* 20090*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20092*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20094*/       OPC_EmitMergeInputChains1_0,
/* 20095*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20098*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20101*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20110*/      /*Scope*/ 67, /*->20178*/
/* 20111*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 20113*/       OPC_Scope, 20, /*->20135*/ // 3 children in Scope
/* 20115*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 20117*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20119*/        OPC_EmitMergeInputChains1_0,
/* 20120*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20123*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20126*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 4
                  // Dst: (STORE8_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20135*/       /*Scope*/ 20, /*->20156*/
/* 20136*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 20138*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20140*/        OPC_EmitMergeInputChains1_0,
/* 20141*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20144*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20147*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 4
                  // Dst: (STORE16_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20156*/       /*Scope*/ 20, /*->20177*/
/* 20157*/        OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 20159*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20161*/        OPC_EmitMergeInputChains1_0,
/* 20162*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20165*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20168*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 4
                  // Dst: (STORE32_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20177*/       0, /*End of Scope*/
/* 20178*/      0, /*End of Scope*/
/* 20179*/     /*Scope*/ 95, /*->20275*/
/* 20180*/      OPC_CheckChild2Type, MVT::i64,
/* 20182*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20184*/      OPC_Scope, 20, /*->20206*/ // 2 children in Scope
/* 20186*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20188*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20190*/       OPC_EmitMergeInputChains1_0,
/* 20191*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20194*/       OPC_EmitInteger, MVT::i64, 0, 
/* 20197*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 20206*/      /*Scope*/ 67, /*->20274*/
/* 20207*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 20209*/       OPC_Scope, 20, /*->20231*/ // 3 children in Scope
/* 20211*/        OPC_CheckPredicate, 11, // Predicate_truncstorei8
/* 20213*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20215*/        OPC_EmitMergeInputChains1_0,
/* 20216*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20219*/        OPC_EmitInteger, MVT::i64, 0, 
/* 20222*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 4
                  // Dst: (STORE8_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 20231*/       /*Scope*/ 20, /*->20252*/
/* 20232*/        OPC_CheckPredicate, 12, // Predicate_truncstorei16
/* 20234*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20236*/        OPC_EmitMergeInputChains1_0,
/* 20237*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20240*/        OPC_EmitInteger, MVT::i64, 0, 
/* 20243*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 4
                  // Dst: (STORE16_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 20252*/       /*Scope*/ 20, /*->20273*/
/* 20253*/        OPC_CheckPredicate, 16, // Predicate_truncstorei32
/* 20255*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20257*/        OPC_EmitMergeInputChains1_0,
/* 20258*/        OPC_EmitInteger, MVT::i32, 0, 
/* 20261*/        OPC_EmitInteger, MVT::i64, 0, 
/* 20264*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 2, 1, 
                  // Src: (st i64:{ *:[i64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 4
                  // Dst: (STORE32_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 20273*/       0, /*End of Scope*/
/* 20274*/      0, /*End of Scope*/
/* 20275*/     0, /*End of Scope*/
/* 20276*/    0, /*End of Scope*/
/* 20277*/   /*Scope*/ 67|128,2/*323*/, /*->20602*/
/* 20279*/    OPC_CheckChild1Type, MVT::f32,
/* 20281*/    OPC_Scope, 67|128,1/*195*/, /*->20479*/ // 2 children in Scope
/* 20284*/     OPC_MoveChild2,
/* 20285*/     OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->20348
/* 20289*/      OPC_RecordChild0, // #2 = $addr
/* 20290*/      OPC_RecordChild1, // #3 = $off
/* 20291*/      OPC_MoveChild1,
/* 20292*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20295*/      OPC_MoveParent,
/* 20296*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 20298*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->20323
/* 20301*/       OPC_MoveParent,
/* 20302*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20304*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20306*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20308*/       OPC_EmitMergeInputChains1_0,
/* 20309*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20312*/       OPC_EmitConvertToTarget, 3,
/* 20314*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 20323*/      /*SwitchType*/ 22, MVT::i64,// ->20347
/* 20325*/       OPC_MoveParent,
/* 20326*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20328*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20330*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20332*/       OPC_EmitMergeInputChains1_0,
/* 20333*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20336*/       OPC_EmitConvertToTarget, 3,
/* 20338*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/* 20347*/      0, // EndSwitchType
/* 20348*/     /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->20410
/* 20351*/      OPC_RecordChild0, // #2 = $addr
/* 20352*/      OPC_RecordChild1, // #3 = $off
/* 20353*/      OPC_MoveChild1,
/* 20354*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20357*/      OPC_MoveParent,
/* 20358*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 20360*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->20385
/* 20363*/       OPC_MoveParent,
/* 20364*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20366*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20368*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20370*/       OPC_EmitMergeInputChains1_0,
/* 20371*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20374*/       OPC_EmitConvertToTarget, 3,
/* 20376*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 20385*/      /*SwitchType*/ 22, MVT::i64,// ->20409
/* 20387*/       OPC_MoveParent,
/* 20388*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20390*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20392*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20394*/       OPC_EmitMergeInputChains1_0,
/* 20395*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20398*/       OPC_EmitConvertToTarget, 3,
/* 20400*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/* 20409*/      0, // EndSwitchType
/* 20410*/     /*SwitchOpcode*/ 65, TARGET_VAL(WebAssemblyISD::Wrapper),// ->20478
/* 20413*/      OPC_RecordChild0, // #2 = $off
/* 20414*/      OPC_MoveChild0,
/* 20415*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 20418*/      OPC_MoveParent,
/* 20419*/      OPC_MoveParent,
/* 20420*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20422*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20424*/      OPC_Scope, 25, /*->20451*/ // 2 children in Scope
/* 20426*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 20428*/       OPC_EmitMergeInputChains1_0,
/* 20429*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20432*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20435*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20442*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_F32_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f32:{ *:[f32] }:$val)
/* 20451*/      /*Scope*/ 25, /*->20477*/
/* 20452*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 20454*/       OPC_EmitMergeInputChains1_0,
/* 20455*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20458*/       OPC_EmitInteger, MVT::i64, 0, 
/* 20461*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 20468*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_F32_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), f32:{ *:[f32] }:$val)
/* 20477*/      0, /*End of Scope*/
/* 20478*/     0, // EndSwitchOpcode
/* 20479*/    /*Scope*/ 121, /*->20601*/
/* 20480*/     OPC_RecordChild2, // #2 = $off
/* 20481*/     OPC_Scope, 67, /*->20550*/ // 3 children in Scope
/* 20483*/      OPC_MoveChild2,
/* 20484*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20487*/      OPC_MoveParent,
/* 20488*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20490*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20492*/      OPC_Scope, 27, /*->20521*/ // 2 children in Scope
/* 20494*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20496*/       OPC_EmitMergeInputChains1_0,
/* 20497*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20500*/       OPC_EmitConvertToTarget, 2,
/* 20502*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20505*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 20512*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_F32_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f32:{ *:[f32] }:$val)
/* 20521*/      /*Scope*/ 27, /*->20549*/
/* 20522*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20524*/       OPC_EmitMergeInputChains1_0,
/* 20525*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20528*/       OPC_EmitConvertToTarget, 2,
/* 20530*/       OPC_EmitInteger, MVT::i64, 0, 
/* 20533*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 20540*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st f32:{ *:[f32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_F32_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), f32:{ *:[f32] }:$val)
/* 20549*/      0, /*End of Scope*/
/* 20550*/     /*Scope*/ 24, /*->20575*/
/* 20551*/      OPC_CheckChild2Type, MVT::i32,
/* 20553*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20555*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20557*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20559*/      OPC_EmitMergeInputChains1_0,
/* 20560*/      OPC_EmitInteger, MVT::i32, 0, 
/* 20563*/      OPC_EmitInteger, MVT::i32, 0, 
/* 20566*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st f32:{ *:[f32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_F32_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 20575*/     /*Scope*/ 24, /*->20600*/
/* 20576*/      OPC_CheckChild2Type, MVT::i64,
/* 20578*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20580*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20582*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20584*/      OPC_EmitMergeInputChains1_0,
/* 20585*/      OPC_EmitInteger, MVT::i32, 0, 
/* 20588*/      OPC_EmitInteger, MVT::i64, 0, 
/* 20591*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st f32:{ *:[f32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_F32_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/* 20600*/     0, /*End of Scope*/
/* 20601*/    0, /*End of Scope*/
/* 20602*/   /*Scope*/ 67|128,2/*323*/, /*->20927*/
/* 20604*/    OPC_CheckChild1Type, MVT::f64,
/* 20606*/    OPC_Scope, 67|128,1/*195*/, /*->20804*/ // 2 children in Scope
/* 20609*/     OPC_MoveChild2,
/* 20610*/     OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->20673
/* 20614*/      OPC_RecordChild0, // #2 = $addr
/* 20615*/      OPC_RecordChild1, // #3 = $off
/* 20616*/      OPC_MoveChild1,
/* 20617*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20620*/      OPC_MoveParent,
/* 20621*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 20623*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->20648
/* 20626*/       OPC_MoveParent,
/* 20627*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20629*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20631*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20633*/       OPC_EmitMergeInputChains1_0,
/* 20634*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20637*/       OPC_EmitConvertToTarget, 3,
/* 20639*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 20648*/      /*SwitchType*/ 22, MVT::i64,// ->20672
/* 20650*/       OPC_MoveParent,
/* 20651*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20653*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20655*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20657*/       OPC_EmitMergeInputChains1_0,
/* 20658*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20661*/       OPC_EmitConvertToTarget, 3,
/* 20663*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/* 20672*/      0, // EndSwitchType
/* 20673*/     /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->20735
/* 20676*/      OPC_RecordChild0, // #2 = $addr
/* 20677*/      OPC_RecordChild1, // #3 = $off
/* 20678*/      OPC_MoveChild1,
/* 20679*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20682*/      OPC_MoveParent,
/* 20683*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 20685*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->20710
/* 20688*/       OPC_MoveParent,
/* 20689*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20691*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20693*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20695*/       OPC_EmitMergeInputChains1_0,
/* 20696*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20699*/       OPC_EmitConvertToTarget, 3,
/* 20701*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 20710*/      /*SwitchType*/ 22, MVT::i64,// ->20734
/* 20712*/       OPC_MoveParent,
/* 20713*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20715*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20717*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20719*/       OPC_EmitMergeInputChains1_0,
/* 20720*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20723*/       OPC_EmitConvertToTarget, 3,
/* 20725*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_F64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/* 20734*/      0, // EndSwitchType
/* 20735*/     /*SwitchOpcode*/ 65, TARGET_VAL(WebAssemblyISD::Wrapper),// ->20803
/* 20738*/      OPC_RecordChild0, // #2 = $off
/* 20739*/      OPC_MoveChild0,
/* 20740*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 20743*/      OPC_MoveParent,
/* 20744*/      OPC_MoveParent,
/* 20745*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20747*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20749*/      OPC_Scope, 25, /*->20776*/ // 2 children in Scope
/* 20751*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 20753*/       OPC_EmitMergeInputChains1_0,
/* 20754*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20757*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20760*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20767*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_F64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f64:{ *:[f64] }:$val)
/* 20776*/      /*Scope*/ 25, /*->20802*/
/* 20777*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 20779*/       OPC_EmitMergeInputChains1_0,
/* 20780*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20783*/       OPC_EmitInteger, MVT::i64, 0, 
/* 20786*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 20793*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_F64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), f64:{ *:[f64] }:$val)
/* 20802*/      0, /*End of Scope*/
/* 20803*/     0, // EndSwitchOpcode
/* 20804*/    /*Scope*/ 121, /*->20926*/
/* 20805*/     OPC_RecordChild2, // #2 = $off
/* 20806*/     OPC_Scope, 67, /*->20875*/ // 3 children in Scope
/* 20808*/      OPC_MoveChild2,
/* 20809*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20812*/      OPC_MoveParent,
/* 20813*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20815*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20817*/      OPC_Scope, 27, /*->20846*/ // 2 children in Scope
/* 20819*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20821*/       OPC_EmitMergeInputChains1_0,
/* 20822*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20825*/       OPC_EmitConvertToTarget, 2,
/* 20827*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20830*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 20837*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_F64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f64:{ *:[f64] }:$val)
/* 20846*/      /*Scope*/ 27, /*->20874*/
/* 20847*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20849*/       OPC_EmitMergeInputChains1_0,
/* 20850*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20853*/       OPC_EmitConvertToTarget, 2,
/* 20855*/       OPC_EmitInteger, MVT::i64, 0, 
/* 20858*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 20865*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st f64:{ *:[f64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_F64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), f64:{ *:[f64] }:$val)
/* 20874*/      0, /*End of Scope*/
/* 20875*/     /*Scope*/ 24, /*->20900*/
/* 20876*/      OPC_CheckChild2Type, MVT::i32,
/* 20878*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20880*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20882*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20884*/      OPC_EmitMergeInputChains1_0,
/* 20885*/      OPC_EmitInteger, MVT::i32, 0, 
/* 20888*/      OPC_EmitInteger, MVT::i32, 0, 
/* 20891*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st f64:{ *:[f64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_F64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 20900*/     /*Scope*/ 24, /*->20925*/
/* 20901*/      OPC_CheckChild2Type, MVT::i64,
/* 20903*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20905*/      OPC_CheckPredicate, 14, // Predicate_store
/* 20907*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20909*/      OPC_EmitMergeInputChains1_0,
/* 20910*/      OPC_EmitInteger, MVT::i32, 0, 
/* 20913*/      OPC_EmitInteger, MVT::i64, 0, 
/* 20916*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st f64:{ *:[f64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_F64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/* 20925*/     0, /*End of Scope*/
/* 20926*/    0, /*End of Scope*/
/* 20927*/   /*Scope*/ 67|128,2/*323*/, /*->21252*/
/* 20929*/    OPC_CheckChild1Type, MVT::v16i8,
/* 20931*/    OPC_Scope, 67|128,1/*195*/, /*->21129*/ // 2 children in Scope
/* 20934*/     OPC_MoveChild2,
/* 20935*/     OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->20998
/* 20939*/      OPC_RecordChild0, // #2 = $addr
/* 20940*/      OPC_RecordChild1, // #3 = $off
/* 20941*/      OPC_MoveChild1,
/* 20942*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20945*/      OPC_MoveParent,
/* 20946*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 20948*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->20973
/* 20951*/       OPC_MoveParent,
/* 20952*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20954*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20956*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 20958*/       OPC_EmitMergeInputChains1_0,
/* 20959*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20962*/       OPC_EmitConvertToTarget, 3,
/* 20964*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 20973*/      /*SwitchType*/ 22, MVT::i64,// ->20997
/* 20975*/       OPC_MoveParent,
/* 20976*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 20978*/       OPC_CheckPredicate, 14, // Predicate_store
/* 20980*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 20982*/       OPC_EmitMergeInputChains1_0,
/* 20983*/       OPC_EmitInteger, MVT::i32, 0, 
/* 20986*/       OPC_EmitConvertToTarget, 3,
/* 20988*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 20997*/      0, // EndSwitchType
/* 20998*/     /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->21060
/* 21001*/      OPC_RecordChild0, // #2 = $addr
/* 21002*/      OPC_RecordChild1, // #3 = $off
/* 21003*/      OPC_MoveChild1,
/* 21004*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21007*/      OPC_MoveParent,
/* 21008*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 21010*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->21035
/* 21013*/       OPC_MoveParent,
/* 21014*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21016*/       OPC_CheckPredicate, 14, // Predicate_store
/* 21018*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21020*/       OPC_EmitMergeInputChains1_0,
/* 21021*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21024*/       OPC_EmitConvertToTarget, 3,
/* 21026*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 21035*/      /*SwitchType*/ 22, MVT::i64,// ->21059
/* 21037*/       OPC_MoveParent,
/* 21038*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21040*/       OPC_CheckPredicate, 14, // Predicate_store
/* 21042*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21044*/       OPC_EmitMergeInputChains1_0,
/* 21045*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21048*/       OPC_EmitConvertToTarget, 3,
/* 21050*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 21059*/      0, // EndSwitchType
/* 21060*/     /*SwitchOpcode*/ 65, TARGET_VAL(WebAssemblyISD::Wrapper),// ->21128
/* 21063*/      OPC_RecordChild0, // #2 = $off
/* 21064*/      OPC_MoveChild0,
/* 21065*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 21068*/      OPC_MoveParent,
/* 21069*/      OPC_MoveParent,
/* 21070*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21072*/      OPC_CheckPredicate, 14, // Predicate_store
/* 21074*/      OPC_Scope, 25, /*->21101*/ // 2 children in Scope
/* 21076*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 21078*/       OPC_EmitMergeInputChains1_0,
/* 21079*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21082*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21085*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 21092*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v16i8:{ *:[v16i8] }:$val)
/* 21101*/      /*Scope*/ 25, /*->21127*/
/* 21102*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 21104*/       OPC_EmitMergeInputChains1_0,
/* 21105*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21108*/       OPC_EmitInteger, MVT::i64, 0, 
/* 21111*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 21118*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v16i8:{ *:[v16i8] }:$val)
/* 21127*/      0, /*End of Scope*/
/* 21128*/     0, // EndSwitchOpcode
/* 21129*/    /*Scope*/ 121, /*->21251*/
/* 21130*/     OPC_RecordChild2, // #2 = $off
/* 21131*/     OPC_Scope, 67, /*->21200*/ // 3 children in Scope
/* 21133*/      OPC_MoveChild2,
/* 21134*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21137*/      OPC_MoveParent,
/* 21138*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21140*/      OPC_CheckPredicate, 14, // Predicate_store
/* 21142*/      OPC_Scope, 27, /*->21171*/ // 2 children in Scope
/* 21144*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21146*/       OPC_EmitMergeInputChains1_0,
/* 21147*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21150*/       OPC_EmitConvertToTarget, 2,
/* 21152*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21155*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 21162*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v16i8:{ *:[v16i8] }:$val)
/* 21171*/      /*Scope*/ 27, /*->21199*/
/* 21172*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21174*/       OPC_EmitMergeInputChains1_0,
/* 21175*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21178*/       OPC_EmitConvertToTarget, 2,
/* 21180*/       OPC_EmitInteger, MVT::i64, 0, 
/* 21183*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 21190*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v16i8:{ *:[v16i8] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v16i8:{ *:[v16i8] }:$val)
/* 21199*/      0, /*End of Scope*/
/* 21200*/     /*Scope*/ 24, /*->21225*/
/* 21201*/      OPC_CheckChild2Type, MVT::i32,
/* 21203*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21205*/      OPC_CheckPredicate, 14, // Predicate_store
/* 21207*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21209*/      OPC_EmitMergeInputChains1_0,
/* 21210*/      OPC_EmitInteger, MVT::i32, 0, 
/* 21213*/      OPC_EmitInteger, MVT::i32, 0, 
/* 21216*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v16i8:{ *:[v16i8] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 21225*/     /*Scope*/ 24, /*->21250*/
/* 21226*/      OPC_CheckChild2Type, MVT::i64,
/* 21228*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21230*/      OPC_CheckPredicate, 14, // Predicate_store
/* 21232*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21234*/      OPC_EmitMergeInputChains1_0,
/* 21235*/      OPC_EmitInteger, MVT::i32, 0, 
/* 21238*/      OPC_EmitInteger, MVT::i64, 0, 
/* 21241*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v16i8:{ *:[v16i8] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 21250*/     0, /*End of Scope*/
/* 21251*/    0, /*End of Scope*/
/* 21252*/   /*Scope*/ 60|128,10/*1340*/, /*->22594*/
/* 21254*/    OPC_CheckChild1Type, MVT::v8i16,
/* 21256*/    OPC_Scope, 31|128,6/*799*/, /*->22058*/ // 2 children in Scope
/* 21259*/     OPC_MoveChild2,
/* 21260*/     OPC_SwitchOpcode /*3 cases */, 127|128,1/*255*/, TARGET_VAL(ISD::ADD),// ->21520
/* 21265*/      OPC_RecordChild0, // #2 = $addr
/* 21266*/      OPC_RecordChild1, // #3 = $off
/* 21267*/      OPC_MoveChild1,
/* 21268*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21271*/      OPC_MoveParent,
/* 21272*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 21274*/      OPC_SwitchType /*2 cases */, 120, MVT::i32,// ->21397
/* 21277*/       OPC_MoveParent,
/* 21278*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21280*/       OPC_Scope, 19, /*->21301*/ // 2 children in Scope
/* 21282*/        OPC_CheckPredicate, 14, // Predicate_store
/* 21284*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21286*/        OPC_EmitMergeInputChains1_0,
/* 21287*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21290*/        OPC_EmitConvertToTarget, 3,
/* 21292*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 21301*/       /*Scope*/ 94, /*->21396*/
/* 21302*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 21304*/        OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 21306*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21308*/        OPC_EmitMergeInputChains1_0,
/* 21309*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21312*/        OPC_EmitConvertToTarget, 3,
/* 21314*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21318*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21322*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21326*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21330*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21334*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21338*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21342*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21346*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 6, 7, 8, 9, 10, 11, 12, 13,  // Results = #14
/* 21360*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 21368*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 21376*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21379*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 16, 17,  // Results = #18
/* 21387*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 18, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 11
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, ?:{ *:[i32] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 21396*/       0, /*End of Scope*/
/* 21397*/      /*SwitchType*/ 120, MVT::i64,// ->21519
/* 21399*/       OPC_MoveParent,
/* 21400*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21402*/       OPC_Scope, 19, /*->21423*/ // 2 children in Scope
/* 21404*/        OPC_CheckPredicate, 14, // Predicate_store
/* 21406*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21408*/        OPC_EmitMergeInputChains1_0,
/* 21409*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21412*/        OPC_EmitConvertToTarget, 3,
/* 21414*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 21423*/       /*Scope*/ 94, /*->21518*/
/* 21424*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 21426*/        OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 21428*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21430*/        OPC_EmitMergeInputChains1_0,
/* 21431*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21434*/        OPC_EmitConvertToTarget, 3,
/* 21436*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21440*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21444*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21448*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21452*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21456*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21460*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21464*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21468*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 6, 7, 8, 9, 10, 11, 12, 13,  // Results = #14
/* 21482*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 21490*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 21498*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21501*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 16, 17,  // Results = #18
/* 21509*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 18, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 11
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, ?:{ *:[i64] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 21518*/       0, /*End of Scope*/
/* 21519*/      0, // EndSwitchType
/* 21520*/     /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::OR),// ->21779
/* 21524*/      OPC_RecordChild0, // #2 = $addr
/* 21525*/      OPC_RecordChild1, // #3 = $off
/* 21526*/      OPC_MoveChild1,
/* 21527*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21530*/      OPC_MoveParent,
/* 21531*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 21533*/      OPC_SwitchType /*2 cases */, 120, MVT::i32,// ->21656
/* 21536*/       OPC_MoveParent,
/* 21537*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21539*/       OPC_Scope, 19, /*->21560*/ // 2 children in Scope
/* 21541*/        OPC_CheckPredicate, 14, // Predicate_store
/* 21543*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21545*/        OPC_EmitMergeInputChains1_0,
/* 21546*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21549*/        OPC_EmitConvertToTarget, 3,
/* 21551*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 21560*/       /*Scope*/ 94, /*->21655*/
/* 21561*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 21563*/        OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 21565*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 21567*/        OPC_EmitMergeInputChains1_0,
/* 21568*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21571*/        OPC_EmitConvertToTarget, 3,
/* 21573*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21577*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21581*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21585*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21589*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21593*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21597*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21601*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21605*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 6, 7, 8, 9, 10, 11, 12, 13,  // Results = #14
/* 21619*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 21627*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 21635*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21638*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 16, 17,  // Results = #18
/* 21646*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 18, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 11
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, ?:{ *:[i32] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 21655*/       0, /*End of Scope*/
/* 21656*/      /*SwitchType*/ 120, MVT::i64,// ->21778
/* 21658*/       OPC_MoveParent,
/* 21659*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21661*/       OPC_Scope, 19, /*->21682*/ // 2 children in Scope
/* 21663*/        OPC_CheckPredicate, 14, // Predicate_store
/* 21665*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21667*/        OPC_EmitMergeInputChains1_0,
/* 21668*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21671*/        OPC_EmitConvertToTarget, 3,
/* 21673*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 21682*/       /*Scope*/ 94, /*->21777*/
/* 21683*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 21685*/        OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 21687*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 21689*/        OPC_EmitMergeInputChains1_0,
/* 21690*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21693*/        OPC_EmitConvertToTarget, 3,
/* 21695*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21699*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21703*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21707*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21711*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21715*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21719*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21723*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21727*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 6, 7, 8, 9, 10, 11, 12, 13,  // Results = #14
/* 21741*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 21749*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 21757*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21760*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 16, 17,  // Results = #18
/* 21768*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 18, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 11
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, ?:{ *:[i64] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 21777*/       0, /*End of Scope*/
/* 21778*/      0, // EndSwitchType
/* 21779*/     /*SwitchOpcode*/ 18|128,2/*274*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->22057
/* 21783*/      OPC_RecordChild0, // #2 = $off
/* 21784*/      OPC_MoveChild0,
/* 21785*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 21788*/      OPC_MoveParent,
/* 21789*/      OPC_MoveParent,
/* 21790*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 21792*/      OPC_Scope, 56, /*->21850*/ // 2 children in Scope
/* 21794*/       OPC_CheckPredicate, 14, // Predicate_store
/* 21796*/       OPC_Scope, 25, /*->21823*/ // 2 children in Scope
/* 21798*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 21800*/        OPC_EmitMergeInputChains1_0,
/* 21801*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21804*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21807*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 21814*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v8i16:{ *:[v8i16] }:$val)
/* 21823*/       /*Scope*/ 25, /*->21849*/
/* 21824*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 21826*/        OPC_EmitMergeInputChains1_0,
/* 21827*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21830*/        OPC_EmitInteger, MVT::i64, 0, 
/* 21833*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 21840*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v8i16:{ *:[v8i16] }:$val)
/* 21849*/       0, /*End of Scope*/
/* 21850*/      /*Scope*/ 76|128,1/*204*/, /*->22056*/
/* 21852*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 21854*/       OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 21856*/       OPC_Scope, 98, /*->21956*/ // 2 children in Scope
/* 21858*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 21860*/        OPC_EmitMergeInputChains1_0,
/* 21861*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21864*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21867*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 21874*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21878*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21882*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21886*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21890*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21894*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21898*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21902*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21906*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 6, 7, 8, 9, 10, 11, 12, 13,  // Results = #14
/* 21920*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 21928*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 21936*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21939*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 16, 17,  // Results = #18
/* 21947*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 18, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 10
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 21956*/       /*Scope*/ 98, /*->22055*/
/* 21957*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 21959*/        OPC_EmitMergeInputChains1_0,
/* 21960*/        OPC_EmitInteger, MVT::i32, 0, 
/* 21963*/        OPC_EmitInteger, MVT::i64, 0, 
/* 21966*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 21973*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21977*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21981*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21985*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21989*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21993*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 21997*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22001*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22005*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 6, 7, 8, 9, 10, 11, 12, 13,  // Results = #14
/* 22019*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 22027*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 22035*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22038*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 16, 17,  // Results = #18
/* 22046*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 18, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 10
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 22055*/       0, /*End of Scope*/
/* 22056*/      0, /*End of Scope*/
/* 22057*/     0, // EndSwitchOpcode
/* 22058*/    /*Scope*/ 21|128,4/*533*/, /*->22593*/
/* 22060*/     OPC_RecordChild2, // #2 = $off
/* 22061*/     OPC_Scope, 24|128,2/*280*/, /*->22344*/ // 3 children in Scope
/* 22064*/      OPC_MoveChild2,
/* 22065*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22068*/      OPC_MoveParent,
/* 22069*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22071*/      OPC_Scope, 60, /*->22133*/ // 2 children in Scope
/* 22073*/       OPC_CheckPredicate, 14, // Predicate_store
/* 22075*/       OPC_Scope, 27, /*->22104*/ // 2 children in Scope
/* 22077*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22079*/        OPC_EmitMergeInputChains1_0,
/* 22080*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22083*/        OPC_EmitConvertToTarget, 2,
/* 22085*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22088*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 22095*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v8i16:{ *:[v8i16] }:$val)
/* 22104*/       /*Scope*/ 27, /*->22132*/
/* 22105*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22107*/        OPC_EmitMergeInputChains1_0,
/* 22108*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22111*/        OPC_EmitConvertToTarget, 2,
/* 22113*/        OPC_EmitInteger, MVT::i64, 0, 
/* 22116*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 22123*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v8i16:{ *:[v8i16] }:$val)
/* 22132*/       0, /*End of Scope*/
/* 22133*/      /*Scope*/ 80|128,1/*208*/, /*->22343*/
/* 22135*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22137*/       OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 22139*/       OPC_Scope, 100, /*->22241*/ // 2 children in Scope
/* 22141*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22143*/        OPC_EmitMergeInputChains1_0,
/* 22144*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22147*/        OPC_EmitConvertToTarget, 2,
/* 22149*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22152*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 22159*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22163*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22167*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22171*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22175*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22179*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22183*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22187*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22191*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 7, 8, 9, 10, 11, 12, 13, 14,  // Results = #15
/* 22205*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 22213*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 16, 1,  // Results = #17
/* 22221*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22224*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 17, 18,  // Results = #19
/* 22232*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 19, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 7
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 22241*/       /*Scope*/ 100, /*->22342*/
/* 22242*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22244*/        OPC_EmitMergeInputChains1_0,
/* 22245*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22248*/        OPC_EmitConvertToTarget, 2,
/* 22250*/        OPC_EmitInteger, MVT::i64, 0, 
/* 22253*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 22260*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22264*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22268*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22272*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22276*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22280*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22284*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22288*/        OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22292*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                      MVT::v16i8, 8/*#Ops*/, 7, 8, 9, 10, 11, 12, 13, 14,  // Results = #15
/* 22306*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 15, 1,  // Results = #16
/* 22314*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                      MVT::v16i8, 2/*#Ops*/, 16, 1,  // Results = #17
/* 22322*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22325*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 17, 18,  // Results = #19
/* 22333*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 19, 
                  // Src: (st v8i16:{ *:[v8i16] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 7
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 22342*/       0, /*End of Scope*/
/* 22343*/      0, /*End of Scope*/
/* 22344*/     /*Scope*/ 123, /*->22468*/
/* 22345*/      OPC_CheckChild2Type, MVT::i32,
/* 22347*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22349*/      OPC_Scope, 20, /*->22371*/ // 2 children in Scope
/* 22351*/       OPC_CheckPredicate, 14, // Predicate_store
/* 22353*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22355*/       OPC_EmitMergeInputChains1_0,
/* 22356*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22359*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22362*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st v8i16:{ *:[v8i16] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 22371*/      /*Scope*/ 95, /*->22467*/
/* 22372*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22374*/       OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 22376*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22378*/       OPC_EmitMergeInputChains1_0,
/* 22379*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22382*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22385*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22389*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22393*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22397*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22401*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22405*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22409*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22413*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22417*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                     MVT::v16i8, 8/*#Ops*/, 5, 6, 7, 8, 9, 10, 11, 12,  // Results = #13
/* 22431*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                     MVT::v16i8, 2/*#Ops*/, 13, 1,  // Results = #14
/* 22439*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                     MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 22447*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22450*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                     MVT::i64, 2/*#Ops*/, 15, 16,  // Results = #17
/* 22458*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 17, 
                 // Src: (st v8i16:{ *:[v8i16] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 4
                 // Dst: (STORE_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, ?:{ *:[i32] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 22467*/      0, /*End of Scope*/
/* 22468*/     /*Scope*/ 123, /*->22592*/
/* 22469*/      OPC_CheckChild2Type, MVT::i64,
/* 22471*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22473*/      OPC_Scope, 20, /*->22495*/ // 2 children in Scope
/* 22475*/       OPC_CheckPredicate, 14, // Predicate_store
/* 22477*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22479*/       OPC_EmitMergeInputChains1_0,
/* 22480*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22483*/       OPC_EmitInteger, MVT::i64, 0, 
/* 22486*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st v8i16:{ *:[v8i16] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 22495*/      /*Scope*/ 95, /*->22591*/
/* 22496*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22498*/       OPC_CheckPredicate, 17, // Predicate_truncstorevi8
/* 22500*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22502*/       OPC_EmitMergeInputChains1_0,
/* 22503*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22506*/       OPC_EmitInteger, MVT::i64, 0, 
/* 22509*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22513*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22517*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22521*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22525*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22529*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22533*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22537*/       OPC_EmitInteger, MVT::i32, 126|128,3/*510*/, 
/* 22541*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                     MVT::v16i8, 8/*#Ops*/, 5, 6, 7, 8, 9, 10, 11, 12,  // Results = #13
/* 22555*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                     MVT::v16i8, 2/*#Ops*/, 13, 1,  // Results = #14
/* 22563*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                     MVT::v16i8, 2/*#Ops*/, 14, 1,  // Results = #15
/* 22571*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22574*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                     MVT::i64, 2/*#Ops*/, 15, 16,  // Results = #17
/* 22582*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 17, 
                 // Src: (st v8i16:{ *:[v8i16] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi8>> - Complexity = 4
                 // Dst: (STORE_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, ?:{ *:[i64] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I8x16:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I16x8:{ *:[v16i8] } 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }, 255:{ *:[i32] }), ?:{ *:[v8i16] }:$val), ?:{ *:[v8i16] }:$val), 0:{ *:[i32] }))
/* 22591*/      0, /*End of Scope*/
/* 22592*/     0, /*End of Scope*/
/* 22593*/    0, /*End of Scope*/
/* 22594*/   /*Scope*/ 28|128,9/*1180*/, /*->23776*/
/* 22596*/    OPC_CheckChild1Type, MVT::v4i32,
/* 22598*/    OPC_Scope, 63|128,5/*703*/, /*->23304*/ // 2 children in Scope
/* 22601*/     OPC_MoveChild2,
/* 22602*/     OPC_SwitchOpcode /*3 cases */, 95|128,1/*223*/, TARGET_VAL(ISD::ADD),// ->22830
/* 22607*/      OPC_RecordChild0, // #2 = $addr
/* 22608*/      OPC_RecordChild1, // #3 = $off
/* 22609*/      OPC_MoveChild1,
/* 22610*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22613*/      OPC_MoveParent,
/* 22614*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 22616*/      OPC_SwitchType /*2 cases */, 104, MVT::i32,// ->22723
/* 22619*/       OPC_MoveParent,
/* 22620*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22622*/       OPC_Scope, 19, /*->22643*/ // 2 children in Scope
/* 22624*/        OPC_CheckPredicate, 14, // Predicate_store
/* 22626*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22628*/        OPC_EmitMergeInputChains1_0,
/* 22629*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22632*/        OPC_EmitConvertToTarget, 3,
/* 22634*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 22643*/       /*Scope*/ 78, /*->22722*/
/* 22644*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22646*/        OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 22648*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22650*/        OPC_EmitMergeInputChains1_0,
/* 22651*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22654*/        OPC_EmitConvertToTarget, 3,
/* 22656*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22661*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22666*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22671*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22676*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 6, 7, 8, 9,  // Results = #10
/* 22686*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 22694*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 22702*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22705*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 12, 13,  // Results = #14
/* 22713*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 14, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 11
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, ?:{ *:[i32] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 22722*/       0, /*End of Scope*/
/* 22723*/      /*SwitchType*/ 104, MVT::i64,// ->22829
/* 22725*/       OPC_MoveParent,
/* 22726*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22728*/       OPC_Scope, 19, /*->22749*/ // 2 children in Scope
/* 22730*/        OPC_CheckPredicate, 14, // Predicate_store
/* 22732*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22734*/        OPC_EmitMergeInputChains1_0,
/* 22735*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22738*/        OPC_EmitConvertToTarget, 3,
/* 22740*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 22749*/       /*Scope*/ 78, /*->22828*/
/* 22750*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22752*/        OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 22754*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22756*/        OPC_EmitMergeInputChains1_0,
/* 22757*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22760*/        OPC_EmitConvertToTarget, 3,
/* 22762*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22767*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22772*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22777*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22782*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 6, 7, 8, 9,  // Results = #10
/* 22792*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 22800*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 22808*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22811*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 12, 13,  // Results = #14
/* 22819*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 14, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 11
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, ?:{ *:[i64] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 22828*/       0, /*End of Scope*/
/* 22829*/      0, // EndSwitchType
/* 22830*/     /*SwitchOpcode*/ 95|128,1/*223*/, TARGET_VAL(ISD::OR),// ->23057
/* 22834*/      OPC_RecordChild0, // #2 = $addr
/* 22835*/      OPC_RecordChild1, // #3 = $off
/* 22836*/      OPC_MoveChild1,
/* 22837*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22840*/      OPC_MoveParent,
/* 22841*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 22843*/      OPC_SwitchType /*2 cases */, 104, MVT::i32,// ->22950
/* 22846*/       OPC_MoveParent,
/* 22847*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22849*/       OPC_Scope, 19, /*->22870*/ // 2 children in Scope
/* 22851*/        OPC_CheckPredicate, 14, // Predicate_store
/* 22853*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22855*/        OPC_EmitMergeInputChains1_0,
/* 22856*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22859*/        OPC_EmitConvertToTarget, 3,
/* 22861*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 22870*/       /*Scope*/ 78, /*->22949*/
/* 22871*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22873*/        OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 22875*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 22877*/        OPC_EmitMergeInputChains1_0,
/* 22878*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22881*/        OPC_EmitConvertToTarget, 3,
/* 22883*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22888*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22893*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22898*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22903*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 6, 7, 8, 9,  // Results = #10
/* 22913*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 22921*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 22929*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22932*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 12, 13,  // Results = #14
/* 22940*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 14, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 11
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, ?:{ *:[i32] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 22949*/       0, /*End of Scope*/
/* 22950*/      /*SwitchType*/ 104, MVT::i64,// ->23056
/* 22952*/       OPC_MoveParent,
/* 22953*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 22955*/       OPC_Scope, 19, /*->22976*/ // 2 children in Scope
/* 22957*/        OPC_CheckPredicate, 14, // Predicate_store
/* 22959*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22961*/        OPC_EmitMergeInputChains1_0,
/* 22962*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22965*/        OPC_EmitConvertToTarget, 3,
/* 22967*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 22976*/       /*Scope*/ 78, /*->23055*/
/* 22977*/        OPC_CheckPredicate, 10, // Predicate_truncstore
/* 22979*/        OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 22981*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 22983*/        OPC_EmitMergeInputChains1_0,
/* 22984*/        OPC_EmitInteger, MVT::i32, 0, 
/* 22987*/        OPC_EmitConvertToTarget, 3,
/* 22989*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22994*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 22999*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23004*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23009*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 6, 7, 8, 9,  // Results = #10
/* 23019*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 23027*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 23035*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23038*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 12, 13,  // Results = #14
/* 23046*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 4, 5, 2, 14, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 11
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, ?:{ *:[i64] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23055*/       0, /*End of Scope*/
/* 23056*/      0, // EndSwitchType
/* 23057*/     /*SwitchOpcode*/ 114|128,1/*242*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->23303
/* 23061*/      OPC_RecordChild0, // #2 = $off
/* 23062*/      OPC_MoveChild0,
/* 23063*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 23066*/      OPC_MoveParent,
/* 23067*/      OPC_MoveParent,
/* 23068*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23070*/      OPC_Scope, 56, /*->23128*/ // 2 children in Scope
/* 23072*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23074*/       OPC_Scope, 25, /*->23101*/ // 2 children in Scope
/* 23076*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 23078*/        OPC_EmitMergeInputChains1_0,
/* 23079*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23082*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23085*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23092*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$val)
/* 23101*/       /*Scope*/ 25, /*->23127*/
/* 23102*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 23104*/        OPC_EmitMergeInputChains1_0,
/* 23105*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23108*/        OPC_EmitInteger, MVT::i64, 0, 
/* 23111*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 23118*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v4i32:{ *:[v4i32] }:$val)
/* 23127*/       0, /*End of Scope*/
/* 23128*/      /*Scope*/ 44|128,1/*172*/, /*->23302*/
/* 23130*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 23132*/       OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 23134*/       OPC_Scope, 82, /*->23218*/ // 2 children in Scope
/* 23136*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 23138*/        OPC_EmitMergeInputChains1_0,
/* 23139*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23142*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23145*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23152*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23157*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23162*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23167*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23172*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 6, 7, 8, 9,  // Results = #10
/* 23182*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 23190*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 23198*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23201*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 12, 13,  // Results = #14
/* 23209*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 14, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 10
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23218*/       /*Scope*/ 82, /*->23301*/
/* 23219*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 23221*/        OPC_EmitMergeInputChains1_0,
/* 23222*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23225*/        OPC_EmitInteger, MVT::i64, 0, 
/* 23228*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 23235*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23240*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23245*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23250*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23255*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 6, 7, 8, 9,  // Results = #10
/* 23265*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 23273*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 23281*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23284*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 12, 13,  // Results = #14
/* 23292*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 2, 5, 14, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 10
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23301*/       0, /*End of Scope*/
/* 23302*/      0, /*End of Scope*/
/* 23303*/     0, // EndSwitchOpcode
/* 23304*/    /*Scope*/ 85|128,3/*469*/, /*->23775*/
/* 23306*/     OPC_RecordChild2, // #2 = $off
/* 23307*/     OPC_Scope, 120|128,1/*248*/, /*->23558*/ // 3 children in Scope
/* 23310*/      OPC_MoveChild2,
/* 23311*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23314*/      OPC_MoveParent,
/* 23315*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23317*/      OPC_Scope, 60, /*->23379*/ // 2 children in Scope
/* 23319*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23321*/       OPC_Scope, 27, /*->23350*/ // 2 children in Scope
/* 23323*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23325*/        OPC_EmitMergeInputChains1_0,
/* 23326*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23329*/        OPC_EmitConvertToTarget, 2,
/* 23331*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23334*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 23341*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$val)
/* 23350*/       /*Scope*/ 27, /*->23378*/
/* 23351*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 23353*/        OPC_EmitMergeInputChains1_0,
/* 23354*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23357*/        OPC_EmitConvertToTarget, 2,
/* 23359*/        OPC_EmitInteger, MVT::i64, 0, 
/* 23362*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 23369*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 1, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                  // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v4i32:{ *:[v4i32] }:$val)
/* 23378*/       0, /*End of Scope*/
/* 23379*/      /*Scope*/ 48|128,1/*176*/, /*->23557*/
/* 23381*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 23383*/       OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 23385*/       OPC_Scope, 84, /*->23471*/ // 2 children in Scope
/* 23387*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23389*/        OPC_EmitMergeInputChains1_0,
/* 23390*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23393*/        OPC_EmitConvertToTarget, 2,
/* 23395*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23398*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 23405*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23410*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23415*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23420*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23425*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 7, 8, 9, 10,  // Results = #11
/* 23435*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 23443*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 12, 1,  // Results = #13
/* 23451*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23454*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 13, 14,  // Results = #15
/* 23462*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 15, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 7
                  // Dst: (STORE_I64_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23471*/       /*Scope*/ 84, /*->23556*/
/* 23472*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 23474*/        OPC_EmitMergeInputChains1_0,
/* 23475*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23478*/        OPC_EmitConvertToTarget, 2,
/* 23480*/        OPC_EmitInteger, MVT::i64, 0, 
/* 23483*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 23490*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23495*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23500*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23505*/        OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23510*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                      MVT::v16i8, 4/*#Ops*/, 7, 8, 9, 10,  // Results = #11
/* 23520*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                      MVT::v16i8, 2/*#Ops*/, 11, 1,  // Results = #12
/* 23528*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                      MVT::v16i8, 2/*#Ops*/, 12, 1,  // Results = #13
/* 23536*/        OPC_EmitInteger, MVT::i32, 0, 
/* 23539*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                      MVT::i64, 2/*#Ops*/, 13, 14,  // Results = #15
/* 23547*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 15, 
                  // Src: (st v4i32:{ *:[v4i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 7
                  // Dst: (STORE_I64_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23556*/       0, /*End of Scope*/
/* 23557*/      0, /*End of Scope*/
/* 23558*/     /*Scope*/ 107, /*->23666*/
/* 23559*/      OPC_CheckChild2Type, MVT::i32,
/* 23561*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23563*/      OPC_Scope, 20, /*->23585*/ // 2 children in Scope
/* 23565*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23567*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23569*/       OPC_EmitMergeInputChains1_0,
/* 23570*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23573*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23576*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st v4i32:{ *:[v4i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 23585*/      /*Scope*/ 79, /*->23665*/
/* 23586*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 23588*/       OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 23590*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23592*/       OPC_EmitMergeInputChains1_0,
/* 23593*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23596*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23599*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23604*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23609*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23614*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23619*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                     MVT::v16i8, 4/*#Ops*/, 5, 6, 7, 8,  // Results = #9
/* 23629*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                     MVT::v16i8, 2/*#Ops*/, 9, 1,  // Results = #10
/* 23637*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                     MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 23645*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23648*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                     MVT::i64, 2/*#Ops*/, 11, 12,  // Results = #13
/* 23656*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 13, 
                 // Src: (st v4i32:{ *:[v4i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 4
                 // Dst: (STORE_I64_A32 0:{ *:[i32] }, 0:{ *:[i32] }, ?:{ *:[i32] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23665*/      0, /*End of Scope*/
/* 23666*/     /*Scope*/ 107, /*->23774*/
/* 23667*/      OPC_CheckChild2Type, MVT::i64,
/* 23669*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23671*/      OPC_Scope, 20, /*->23693*/ // 2 children in Scope
/* 23673*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23675*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 23677*/       OPC_EmitMergeInputChains1_0,
/* 23678*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23681*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23684*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 1, 
                 // Src: (st v4i32:{ *:[v4i32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 23693*/      /*Scope*/ 79, /*->23773*/
/* 23694*/       OPC_CheckPredicate, 10, // Predicate_truncstore
/* 23696*/       OPC_CheckPredicate, 18, // Predicate_truncstorevi16
/* 23698*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 23700*/       OPC_EmitMergeInputChains1_0,
/* 23701*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23704*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23707*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23712*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23717*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23722*/       OPC_EmitInteger, MVT::i32, 126|128,127|128,7/*131070*/, 
/* 23727*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                     MVT::v16i8, 4/*#Ops*/, 5, 6, 7, 8,  // Results = #9
/* 23737*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::AND), 0,
                     MVT::v16i8, 2/*#Ops*/, 9, 1,  // Results = #10
/* 23745*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                     MVT::v16i8, 2/*#Ops*/, 10, 1,  // Results = #11
/* 23753*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23756*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                     MVT::i64, 2/*#Ops*/, 11, 12,  // Results = #13
/* 23764*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 2, 13, 
                 // Src: (st v4i32:{ *:[v4i32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorevi16>> - Complexity = 4
                 // Dst: (STORE_I64_A64 0:{ *:[i32] }, 0:{ *:[i64] }, ?:{ *:[i64] }:$addr, (EXTRACT_LANE_I64x2:{ *:[i64] } (NARROW_U_I16x8:{ *:[v16i8] } (AND:{ *:[v16i8] } (CONST_V128_I32x4:{ *:[v16i8] } 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }, 65535:{ *:[i32] }), ?:{ *:[v4i32] }:$val), ?:{ *:[v4i32] }:$val), 0:{ *:[i32] }))
/* 23773*/      0, /*End of Scope*/
/* 23774*/     0, /*End of Scope*/
/* 23775*/    0, /*End of Scope*/
/* 23776*/   /*Scope*/ 67|128,2/*323*/, /*->24101*/
/* 23778*/    OPC_CheckChild1Type, MVT::v2i64,
/* 23780*/    OPC_Scope, 67|128,1/*195*/, /*->23978*/ // 2 children in Scope
/* 23783*/     OPC_MoveChild2,
/* 23784*/     OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->23847
/* 23788*/      OPC_RecordChild0, // #2 = $addr
/* 23789*/      OPC_RecordChild1, // #3 = $off
/* 23790*/      OPC_MoveChild1,
/* 23791*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23794*/      OPC_MoveParent,
/* 23795*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 23797*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->23822
/* 23800*/       OPC_MoveParent,
/* 23801*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23803*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23805*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23807*/       OPC_EmitMergeInputChains1_0,
/* 23808*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23811*/       OPC_EmitConvertToTarget, 3,
/* 23813*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 23822*/      /*SwitchType*/ 22, MVT::i64,// ->23846
/* 23824*/       OPC_MoveParent,
/* 23825*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23827*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23829*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 23831*/       OPC_EmitMergeInputChains1_0,
/* 23832*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23835*/       OPC_EmitConvertToTarget, 3,
/* 23837*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 23846*/      0, // EndSwitchType
/* 23847*/     /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->23909
/* 23850*/      OPC_RecordChild0, // #2 = $addr
/* 23851*/      OPC_RecordChild1, // #3 = $off
/* 23852*/      OPC_MoveChild1,
/* 23853*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23856*/      OPC_MoveParent,
/* 23857*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 23859*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->23884
/* 23862*/       OPC_MoveParent,
/* 23863*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23865*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23867*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23869*/       OPC_EmitMergeInputChains1_0,
/* 23870*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23873*/       OPC_EmitConvertToTarget, 3,
/* 23875*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 23884*/      /*SwitchType*/ 22, MVT::i64,// ->23908
/* 23886*/       OPC_MoveParent,
/* 23887*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23889*/       OPC_CheckPredicate, 14, // Predicate_store
/* 23891*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 23893*/       OPC_EmitMergeInputChains1_0,
/* 23894*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23897*/       OPC_EmitConvertToTarget, 3,
/* 23899*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 23908*/      0, // EndSwitchType
/* 23909*/     /*SwitchOpcode*/ 65, TARGET_VAL(WebAssemblyISD::Wrapper),// ->23977
/* 23912*/      OPC_RecordChild0, // #2 = $off
/* 23913*/      OPC_MoveChild0,
/* 23914*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 23917*/      OPC_MoveParent,
/* 23918*/      OPC_MoveParent,
/* 23919*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23921*/      OPC_CheckPredicate, 14, // Predicate_store
/* 23923*/      OPC_Scope, 25, /*->23950*/ // 2 children in Scope
/* 23925*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 23927*/       OPC_EmitMergeInputChains1_0,
/* 23928*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23931*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23934*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23941*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2i64:{ *:[v2i64] }:$val)
/* 23950*/      /*Scope*/ 25, /*->23976*/
/* 23951*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 23953*/       OPC_EmitMergeInputChains1_0,
/* 23954*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23957*/       OPC_EmitInteger, MVT::i64, 0, 
/* 23960*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 23967*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v2i64:{ *:[v2i64] }:$val)
/* 23976*/      0, /*End of Scope*/
/* 23977*/     0, // EndSwitchOpcode
/* 23978*/    /*Scope*/ 121, /*->24100*/
/* 23979*/     OPC_RecordChild2, // #2 = $off
/* 23980*/     OPC_Scope, 67, /*->24049*/ // 3 children in Scope
/* 23982*/      OPC_MoveChild2,
/* 23983*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23986*/      OPC_MoveParent,
/* 23987*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 23989*/      OPC_CheckPredicate, 14, // Predicate_store
/* 23991*/      OPC_Scope, 27, /*->24020*/ // 2 children in Scope
/* 23993*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 23995*/       OPC_EmitMergeInputChains1_0,
/* 23996*/       OPC_EmitInteger, MVT::i32, 0, 
/* 23999*/       OPC_EmitConvertToTarget, 2,
/* 24001*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24004*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 24011*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2i64:{ *:[v2i64] }:$val)
/* 24020*/      /*Scope*/ 27, /*->24048*/
/* 24021*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24023*/       OPC_EmitMergeInputChains1_0,
/* 24024*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24027*/       OPC_EmitConvertToTarget, 2,
/* 24029*/       OPC_EmitInteger, MVT::i64, 0, 
/* 24032*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 24039*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v2i64:{ *:[v2i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v2i64:{ *:[v2i64] }:$val)
/* 24048*/      0, /*End of Scope*/
/* 24049*/     /*Scope*/ 24, /*->24074*/
/* 24050*/      OPC_CheckChild2Type, MVT::i32,
/* 24052*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24054*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24056*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24058*/      OPC_EmitMergeInputChains1_0,
/* 24059*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24062*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24065*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v2i64:{ *:[v2i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 24074*/     /*Scope*/ 24, /*->24099*/
/* 24075*/      OPC_CheckChild2Type, MVT::i64,
/* 24077*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24079*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24081*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24083*/      OPC_EmitMergeInputChains1_0,
/* 24084*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24087*/      OPC_EmitInteger, MVT::i64, 0, 
/* 24090*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v2i64:{ *:[v2i64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 24099*/     0, /*End of Scope*/
/* 24100*/    0, /*End of Scope*/
/* 24101*/   /*Scope*/ 67|128,2/*323*/, /*->24426*/
/* 24103*/    OPC_CheckChild1Type, MVT::v4f32,
/* 24105*/    OPC_Scope, 67|128,1/*195*/, /*->24303*/ // 2 children in Scope
/* 24108*/     OPC_MoveChild2,
/* 24109*/     OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->24172
/* 24113*/      OPC_RecordChild0, // #2 = $addr
/* 24114*/      OPC_RecordChild1, // #3 = $off
/* 24115*/      OPC_MoveChild1,
/* 24116*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24119*/      OPC_MoveParent,
/* 24120*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 24122*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->24147
/* 24125*/       OPC_MoveParent,
/* 24126*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24128*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24130*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24132*/       OPC_EmitMergeInputChains1_0,
/* 24133*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24136*/       OPC_EmitConvertToTarget, 3,
/* 24138*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 24147*/      /*SwitchType*/ 22, MVT::i64,// ->24171
/* 24149*/       OPC_MoveParent,
/* 24150*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24152*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24154*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24156*/       OPC_EmitMergeInputChains1_0,
/* 24157*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24160*/       OPC_EmitConvertToTarget, 3,
/* 24162*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 24171*/      0, // EndSwitchType
/* 24172*/     /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->24234
/* 24175*/      OPC_RecordChild0, // #2 = $addr
/* 24176*/      OPC_RecordChild1, // #3 = $off
/* 24177*/      OPC_MoveChild1,
/* 24178*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24181*/      OPC_MoveParent,
/* 24182*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 24184*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->24209
/* 24187*/       OPC_MoveParent,
/* 24188*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24190*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24192*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24194*/       OPC_EmitMergeInputChains1_0,
/* 24195*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24198*/       OPC_EmitConvertToTarget, 3,
/* 24200*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 24209*/      /*SwitchType*/ 22, MVT::i64,// ->24233
/* 24211*/       OPC_MoveParent,
/* 24212*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24214*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24216*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24218*/       OPC_EmitMergeInputChains1_0,
/* 24219*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24222*/       OPC_EmitConvertToTarget, 3,
/* 24224*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 24233*/      0, // EndSwitchType
/* 24234*/     /*SwitchOpcode*/ 65, TARGET_VAL(WebAssemblyISD::Wrapper),// ->24302
/* 24237*/      OPC_RecordChild0, // #2 = $off
/* 24238*/      OPC_MoveChild0,
/* 24239*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 24242*/      OPC_MoveParent,
/* 24243*/      OPC_MoveParent,
/* 24244*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24246*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24248*/      OPC_Scope, 25, /*->24275*/ // 2 children in Scope
/* 24250*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 24252*/       OPC_EmitMergeInputChains1_0,
/* 24253*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24256*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24259*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 24266*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4f32:{ *:[v4f32] }:$val)
/* 24275*/      /*Scope*/ 25, /*->24301*/
/* 24276*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 24278*/       OPC_EmitMergeInputChains1_0,
/* 24279*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24282*/       OPC_EmitInteger, MVT::i64, 0, 
/* 24285*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 24292*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v4f32:{ *:[v4f32] }:$val)
/* 24301*/      0, /*End of Scope*/
/* 24302*/     0, // EndSwitchOpcode
/* 24303*/    /*Scope*/ 121, /*->24425*/
/* 24304*/     OPC_RecordChild2, // #2 = $off
/* 24305*/     OPC_Scope, 67, /*->24374*/ // 3 children in Scope
/* 24307*/      OPC_MoveChild2,
/* 24308*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24311*/      OPC_MoveParent,
/* 24312*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24314*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24316*/      OPC_Scope, 27, /*->24345*/ // 2 children in Scope
/* 24318*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24320*/       OPC_EmitMergeInputChains1_0,
/* 24321*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24324*/       OPC_EmitConvertToTarget, 2,
/* 24326*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24329*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 24336*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4f32:{ *:[v4f32] }:$val)
/* 24345*/      /*Scope*/ 27, /*->24373*/
/* 24346*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24348*/       OPC_EmitMergeInputChains1_0,
/* 24349*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24352*/       OPC_EmitConvertToTarget, 2,
/* 24354*/       OPC_EmitInteger, MVT::i64, 0, 
/* 24357*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 24364*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v4f32:{ *:[v4f32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v4f32:{ *:[v4f32] }:$val)
/* 24373*/      0, /*End of Scope*/
/* 24374*/     /*Scope*/ 24, /*->24399*/
/* 24375*/      OPC_CheckChild2Type, MVT::i32,
/* 24377*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24379*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24381*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24383*/      OPC_EmitMergeInputChains1_0,
/* 24384*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24387*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24390*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v4f32:{ *:[v4f32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 24399*/     /*Scope*/ 24, /*->24424*/
/* 24400*/      OPC_CheckChild2Type, MVT::i64,
/* 24402*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24404*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24406*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24408*/      OPC_EmitMergeInputChains1_0,
/* 24409*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24412*/      OPC_EmitInteger, MVT::i64, 0, 
/* 24415*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v4f32:{ *:[v4f32] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 24424*/     0, /*End of Scope*/
/* 24425*/    0, /*End of Scope*/
/* 24426*/   /*Scope*/ 67|128,2/*323*/, /*->24751*/
/* 24428*/    OPC_CheckChild1Type, MVT::v2f64,
/* 24430*/    OPC_Scope, 67|128,1/*195*/, /*->24628*/ // 2 children in Scope
/* 24433*/     OPC_MoveChild2,
/* 24434*/     OPC_SwitchOpcode /*3 cases */, 59, TARGET_VAL(ISD::ADD),// ->24497
/* 24438*/      OPC_RecordChild0, // #2 = $addr
/* 24439*/      OPC_RecordChild1, // #3 = $off
/* 24440*/      OPC_MoveChild1,
/* 24441*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24444*/      OPC_MoveParent,
/* 24445*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 24447*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->24472
/* 24450*/       OPC_MoveParent,
/* 24451*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24453*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24455*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24457*/       OPC_EmitMergeInputChains1_0,
/* 24458*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24461*/       OPC_EmitConvertToTarget, 3,
/* 24463*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 24472*/      /*SwitchType*/ 22, MVT::i64,// ->24496
/* 24474*/       OPC_MoveParent,
/* 24475*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24477*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24479*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24481*/       OPC_EmitMergeInputChains1_0,
/* 24482*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24485*/       OPC_EmitConvertToTarget, 3,
/* 24487*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 24496*/      0, // EndSwitchType
/* 24497*/     /*SwitchOpcode*/ 59, TARGET_VAL(ISD::OR),// ->24559
/* 24500*/      OPC_RecordChild0, // #2 = $addr
/* 24501*/      OPC_RecordChild1, // #3 = $off
/* 24502*/      OPC_MoveChild1,
/* 24503*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24506*/      OPC_MoveParent,
/* 24507*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 24509*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->24534
/* 24512*/       OPC_MoveParent,
/* 24513*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24515*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24517*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24519*/       OPC_EmitMergeInputChains1_0,
/* 24520*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24523*/       OPC_EmitConvertToTarget, 3,
/* 24525*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 24534*/      /*SwitchType*/ 22, MVT::i64,// ->24558
/* 24536*/       OPC_MoveParent,
/* 24537*/       OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24539*/       OPC_CheckPredicate, 14, // Predicate_store
/* 24541*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24543*/       OPC_EmitMergeInputChains1_0,
/* 24544*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24547*/       OPC_EmitConvertToTarget, 3,
/* 24549*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 4, 5, 2, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 24558*/      0, // EndSwitchType
/* 24559*/     /*SwitchOpcode*/ 65, TARGET_VAL(WebAssemblyISD::Wrapper),// ->24627
/* 24562*/      OPC_RecordChild0, // #2 = $off
/* 24563*/      OPC_MoveChild0,
/* 24564*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 24567*/      OPC_MoveParent,
/* 24568*/      OPC_MoveParent,
/* 24569*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24571*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24573*/      OPC_Scope, 25, /*->24600*/ // 2 children in Scope
/* 24575*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 24577*/       OPC_EmitMergeInputChains1_0,
/* 24578*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24581*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24584*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 24591*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2f64:{ *:[v2f64] }:$val)
/* 24600*/      /*Scope*/ 25, /*->24626*/
/* 24601*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 24603*/       OPC_EmitMergeInputChains1_0,
/* 24604*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24607*/       OPC_EmitInteger, MVT::i64, 0, 
/* 24610*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 24617*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 2, 5, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v2f64:{ *:[v2f64] }:$val)
/* 24626*/      0, /*End of Scope*/
/* 24627*/     0, // EndSwitchOpcode
/* 24628*/    /*Scope*/ 121, /*->24750*/
/* 24629*/     OPC_RecordChild2, // #2 = $off
/* 24630*/     OPC_Scope, 67, /*->24699*/ // 3 children in Scope
/* 24632*/      OPC_MoveChild2,
/* 24633*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24636*/      OPC_MoveParent,
/* 24637*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24639*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24641*/      OPC_Scope, 27, /*->24670*/ // 2 children in Scope
/* 24643*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24645*/       OPC_EmitMergeInputChains1_0,
/* 24646*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24649*/       OPC_EmitConvertToTarget, 2,
/* 24651*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24654*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 24661*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2f64:{ *:[v2f64] }:$val)
/* 24670*/      /*Scope*/ 27, /*->24698*/
/* 24671*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24673*/       OPC_EmitMergeInputChains1_0,
/* 24674*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24677*/       OPC_EmitConvertToTarget, 2,
/* 24679*/       OPC_EmitInteger, MVT::i64, 0, 
/* 24682*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 24689*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 3, 4, 6, 1, 
                 // Src: (st v2f64:{ *:[v2f64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                 // Dst: (STORE_V128_A64 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), v2f64:{ *:[v2f64] }:$val)
/* 24698*/      0, /*End of Scope*/
/* 24699*/     /*Scope*/ 24, /*->24724*/
/* 24700*/      OPC_CheckChild2Type, MVT::i32,
/* 24702*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24704*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24706*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24708*/      OPC_EmitMergeInputChains1_0,
/* 24709*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24712*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24715*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v2f64:{ *:[v2f64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 24724*/     /*Scope*/ 24, /*->24749*/
/* 24725*/      OPC_CheckChild2Type, MVT::i64,
/* 24727*/      OPC_CheckPredicate, 9, // Predicate_unindexedstore
/* 24729*/      OPC_CheckPredicate, 14, // Predicate_store
/* 24731*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 24733*/      OPC_EmitMergeInputChains1_0,
/* 24734*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24737*/      OPC_EmitInteger, MVT::i64, 0, 
/* 24740*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 3, 4, 2, 1, 
                // Src: (st v2f64:{ *:[v2f64] }:$val, I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                // Dst: (STORE_V128_A64 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 24749*/     0, /*End of Scope*/
/* 24750*/    0, /*End of Scope*/
/* 24751*/   0, /*End of Scope*/
/* 24752*/  0, /*End of Scope*/
/* 24753*/ /*SwitchOpcode*/ 8|128,73/*9352*/, TARGET_VAL(ISD::LOAD),// ->34109
/* 24757*/  OPC_RecordMemRef,
/* 24758*/  OPC_RecordNode, // #0 = 'ld' chained node
/* 24759*/  OPC_Scope, 3|128,21/*2691*/, /*->27453*/ // 8 children in Scope
/* 24762*/   OPC_MoveChild1,
/* 24763*/   OPC_SwitchOpcode /*3 cases */, 51|128,6/*819*/, TARGET_VAL(ISD::ADD),// ->25587
/* 24768*/    OPC_RecordChild0, // #1 = $addr
/* 24769*/    OPC_RecordChild1, // #2 = $off
/* 24770*/    OPC_MoveChild1,
/* 24771*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24774*/    OPC_MoveParent,
/* 24775*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 24777*/    OPC_SwitchType /*2 cases */, 17|128,3/*401*/, MVT::i32,// ->25182
/* 24781*/     OPC_MoveParent,
/* 24782*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 24784*/     OPC_Scope, 42, /*->24828*/ // 12 children in Scope
/* 24786*/      OPC_CheckPredicate, 20, // Predicate_load
/* 24788*/      OPC_SwitchType /*2 cases */, 17, MVT::i32,// ->24808
/* 24791*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24793*/       OPC_EmitMergeInputChains1_0,
/* 24794*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24797*/       OPC_EmitConvertToTarget, 2,
/* 24799*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24808*/      /*SwitchType*/ 17, MVT::i64,// ->24827
/* 24810*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24812*/       OPC_EmitMergeInputChains1_0,
/* 24813*/       OPC_EmitInteger, MVT::i32, 0, 
/* 24816*/       OPC_EmitConvertToTarget, 2,
/* 24818*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24827*/      0, // EndSwitchType
/* 24828*/     /*Scope*/ 23, /*->24852*/
/* 24829*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 24831*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 24833*/      OPC_CheckType, MVT::i32,
/* 24835*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24837*/      OPC_EmitMergeInputChains1_0,
/* 24838*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24841*/      OPC_EmitConvertToTarget, 2,
/* 24843*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24852*/     /*Scope*/ 23, /*->24876*/
/* 24853*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 24855*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 24857*/      OPC_CheckType, MVT::i32,
/* 24859*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24861*/      OPC_EmitMergeInputChains1_0,
/* 24862*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24865*/      OPC_EmitConvertToTarget, 2,
/* 24867*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24876*/     /*Scope*/ 23, /*->24900*/
/* 24877*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 24879*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 24881*/      OPC_CheckType, MVT::i32,
/* 24883*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24885*/      OPC_EmitMergeInputChains1_0,
/* 24886*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24889*/      OPC_EmitConvertToTarget, 2,
/* 24891*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24900*/     /*Scope*/ 23, /*->24924*/
/* 24901*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 24903*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 24905*/      OPC_CheckType, MVT::i32,
/* 24907*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24909*/      OPC_EmitMergeInputChains1_0,
/* 24910*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24913*/      OPC_EmitConvertToTarget, 2,
/* 24915*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24924*/     /*Scope*/ 23, /*->24948*/
/* 24925*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 24927*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 24929*/      OPC_CheckType, MVT::i64,
/* 24931*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24933*/      OPC_EmitMergeInputChains1_0,
/* 24934*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24937*/      OPC_EmitConvertToTarget, 2,
/* 24939*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24948*/     /*Scope*/ 23, /*->24972*/
/* 24949*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 24951*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 24953*/      OPC_CheckType, MVT::i64,
/* 24955*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24957*/      OPC_EmitMergeInputChains1_0,
/* 24958*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24961*/      OPC_EmitConvertToTarget, 2,
/* 24963*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24972*/     /*Scope*/ 23, /*->24996*/
/* 24973*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 24975*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 24977*/      OPC_CheckType, MVT::i64,
/* 24979*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 24981*/      OPC_EmitMergeInputChains1_0,
/* 24982*/      OPC_EmitInteger, MVT::i32, 0, 
/* 24985*/      OPC_EmitConvertToTarget, 2,
/* 24987*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 24996*/     /*Scope*/ 23, /*->25020*/
/* 24997*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 24999*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 25001*/      OPC_CheckType, MVT::i64,
/* 25003*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25005*/      OPC_EmitMergeInputChains1_0,
/* 25006*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25009*/      OPC_EmitConvertToTarget, 2,
/* 25011*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25020*/     /*Scope*/ 23, /*->25044*/
/* 25021*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25023*/      OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 25025*/      OPC_CheckType, MVT::i64,
/* 25027*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25029*/      OPC_EmitMergeInputChains1_0,
/* 25030*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25033*/      OPC_EmitConvertToTarget, 2,
/* 25035*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 11
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25044*/     /*Scope*/ 23, /*->25068*/
/* 25045*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25047*/      OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 25049*/      OPC_CheckType, MVT::i64,
/* 25051*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25053*/      OPC_EmitMergeInputChains1_0,
/* 25054*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25057*/      OPC_EmitConvertToTarget, 2,
/* 25059*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 11
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25068*/     /*Scope*/ 112, /*->25181*/
/* 25069*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 25071*/      OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->25116
/* 25074*/       OPC_Scope, 19, /*->25095*/ // 2 children in Scope
/* 25076*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 25078*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25080*/        OPC_EmitMergeInputChains1_0,
/* 25081*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25084*/        OPC_EmitConvertToTarget, 2,
/* 25086*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25095*/       /*Scope*/ 19, /*->25115*/
/* 25096*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 25098*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25100*/        OPC_EmitMergeInputChains1_0,
/* 25101*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25104*/        OPC_EmitConvertToTarget, 2,
/* 25106*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25115*/       0, /*End of Scope*/
/* 25116*/      /*SwitchType*/ 62, MVT::i64,// ->25180
/* 25118*/       OPC_Scope, 19, /*->25139*/ // 3 children in Scope
/* 25120*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 25122*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25124*/        OPC_EmitMergeInputChains1_0,
/* 25125*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25128*/        OPC_EmitConvertToTarget, 2,
/* 25130*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25139*/       /*Scope*/ 19, /*->25159*/
/* 25140*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 25142*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25144*/        OPC_EmitMergeInputChains1_0,
/* 25145*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25148*/        OPC_EmitConvertToTarget, 2,
/* 25150*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25159*/       /*Scope*/ 19, /*->25179*/
/* 25160*/        OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 25162*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25164*/        OPC_EmitMergeInputChains1_0,
/* 25165*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25168*/        OPC_EmitConvertToTarget, 2,
/* 25170*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 11
                  // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25179*/       0, /*End of Scope*/
/* 25180*/      0, // EndSwitchType
/* 25181*/     0, /*End of Scope*/
/* 25182*/    /*SwitchType*/ 17|128,3/*401*/, MVT::i64,// ->25586
/* 25185*/     OPC_MoveParent,
/* 25186*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 25188*/     OPC_Scope, 42, /*->25232*/ // 12 children in Scope
/* 25190*/      OPC_CheckPredicate, 20, // Predicate_load
/* 25192*/      OPC_SwitchType /*2 cases */, 17, MVT::i32,// ->25212
/* 25195*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25197*/       OPC_EmitMergeInputChains1_0,
/* 25198*/       OPC_EmitInteger, MVT::i32, 0, 
/* 25201*/       OPC_EmitConvertToTarget, 2,
/* 25203*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25212*/      /*SwitchType*/ 17, MVT::i64,// ->25231
/* 25214*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25216*/       OPC_EmitMergeInputChains1_0,
/* 25217*/       OPC_EmitInteger, MVT::i32, 0, 
/* 25220*/       OPC_EmitConvertToTarget, 2,
/* 25222*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25231*/      0, // EndSwitchType
/* 25232*/     /*Scope*/ 23, /*->25256*/
/* 25233*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25235*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 25237*/      OPC_CheckType, MVT::i32,
/* 25239*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25241*/      OPC_EmitMergeInputChains1_0,
/* 25242*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25245*/      OPC_EmitConvertToTarget, 2,
/* 25247*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25256*/     /*Scope*/ 23, /*->25280*/
/* 25257*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25259*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 25261*/      OPC_CheckType, MVT::i32,
/* 25263*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25265*/      OPC_EmitMergeInputChains1_0,
/* 25266*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25269*/      OPC_EmitConvertToTarget, 2,
/* 25271*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25280*/     /*Scope*/ 23, /*->25304*/
/* 25281*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25283*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 25285*/      OPC_CheckType, MVT::i32,
/* 25287*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25289*/      OPC_EmitMergeInputChains1_0,
/* 25290*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25293*/      OPC_EmitConvertToTarget, 2,
/* 25295*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25304*/     /*Scope*/ 23, /*->25328*/
/* 25305*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25307*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 25309*/      OPC_CheckType, MVT::i32,
/* 25311*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25313*/      OPC_EmitMergeInputChains1_0,
/* 25314*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25317*/      OPC_EmitConvertToTarget, 2,
/* 25319*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25328*/     /*Scope*/ 23, /*->25352*/
/* 25329*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25331*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 25333*/      OPC_CheckType, MVT::i64,
/* 25335*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25337*/      OPC_EmitMergeInputChains1_0,
/* 25338*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25341*/      OPC_EmitConvertToTarget, 2,
/* 25343*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25352*/     /*Scope*/ 23, /*->25376*/
/* 25353*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25355*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 25357*/      OPC_CheckType, MVT::i64,
/* 25359*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25361*/      OPC_EmitMergeInputChains1_0,
/* 25362*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25365*/      OPC_EmitConvertToTarget, 2,
/* 25367*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25376*/     /*Scope*/ 23, /*->25400*/
/* 25377*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25379*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 25381*/      OPC_CheckType, MVT::i64,
/* 25383*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25385*/      OPC_EmitMergeInputChains1_0,
/* 25386*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25389*/      OPC_EmitConvertToTarget, 2,
/* 25391*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25400*/     /*Scope*/ 23, /*->25424*/
/* 25401*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25403*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 25405*/      OPC_CheckType, MVT::i64,
/* 25407*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25409*/      OPC_EmitMergeInputChains1_0,
/* 25410*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25413*/      OPC_EmitConvertToTarget, 2,
/* 25415*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25424*/     /*Scope*/ 23, /*->25448*/
/* 25425*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25427*/      OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 25429*/      OPC_CheckType, MVT::i64,
/* 25431*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25433*/      OPC_EmitMergeInputChains1_0,
/* 25434*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25437*/      OPC_EmitConvertToTarget, 2,
/* 25439*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 11
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25448*/     /*Scope*/ 23, /*->25472*/
/* 25449*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25451*/      OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 25453*/      OPC_CheckType, MVT::i64,
/* 25455*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25457*/      OPC_EmitMergeInputChains1_0,
/* 25458*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25461*/      OPC_EmitConvertToTarget, 2,
/* 25463*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 11
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25472*/     /*Scope*/ 112, /*->25585*/
/* 25473*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 25475*/      OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->25520
/* 25478*/       OPC_Scope, 19, /*->25499*/ // 2 children in Scope
/* 25480*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 25482*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25484*/        OPC_EmitMergeInputChains1_0,
/* 25485*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25488*/        OPC_EmitConvertToTarget, 2,
/* 25490*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25499*/       /*Scope*/ 19, /*->25519*/
/* 25500*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 25502*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25504*/        OPC_EmitMergeInputChains1_0,
/* 25505*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25508*/        OPC_EmitConvertToTarget, 2,
/* 25510*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25519*/       0, /*End of Scope*/
/* 25520*/      /*SwitchType*/ 62, MVT::i64,// ->25584
/* 25522*/       OPC_Scope, 19, /*->25543*/ // 3 children in Scope
/* 25524*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 25526*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25528*/        OPC_EmitMergeInputChains1_0,
/* 25529*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25532*/        OPC_EmitConvertToTarget, 2,
/* 25534*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25543*/       /*Scope*/ 19, /*->25563*/
/* 25544*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 25546*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25548*/        OPC_EmitMergeInputChains1_0,
/* 25549*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25552*/        OPC_EmitConvertToTarget, 2,
/* 25554*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25563*/       /*Scope*/ 19, /*->25583*/
/* 25564*/        OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 25566*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 25568*/        OPC_EmitMergeInputChains1_0,
/* 25569*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25572*/        OPC_EmitConvertToTarget, 2,
/* 25574*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 11
                  // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 25583*/       0, /*End of Scope*/
/* 25584*/      0, // EndSwitchType
/* 25585*/     0, /*End of Scope*/
/* 25586*/    0, // EndSwitchType
/* 25587*/   /*SwitchOpcode*/ 51|128,6/*819*/, TARGET_VAL(ISD::OR),// ->26410
/* 25591*/    OPC_RecordChild0, // #1 = $addr
/* 25592*/    OPC_RecordChild1, // #2 = $off
/* 25593*/    OPC_MoveChild1,
/* 25594*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 25597*/    OPC_MoveParent,
/* 25598*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 25600*/    OPC_SwitchType /*2 cases */, 17|128,3/*401*/, MVT::i32,// ->26005
/* 25604*/     OPC_MoveParent,
/* 25605*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 25607*/     OPC_Scope, 42, /*->25651*/ // 12 children in Scope
/* 25609*/      OPC_CheckPredicate, 20, // Predicate_load
/* 25611*/      OPC_SwitchType /*2 cases */, 17, MVT::i32,// ->25631
/* 25614*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25616*/       OPC_EmitMergeInputChains1_0,
/* 25617*/       OPC_EmitInteger, MVT::i32, 0, 
/* 25620*/       OPC_EmitConvertToTarget, 2,
/* 25622*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25631*/      /*SwitchType*/ 17, MVT::i64,// ->25650
/* 25633*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25635*/       OPC_EmitMergeInputChains1_0,
/* 25636*/       OPC_EmitInteger, MVT::i32, 0, 
/* 25639*/       OPC_EmitConvertToTarget, 2,
/* 25641*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25650*/      0, // EndSwitchType
/* 25651*/     /*Scope*/ 23, /*->25675*/
/* 25652*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25654*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 25656*/      OPC_CheckType, MVT::i32,
/* 25658*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25660*/      OPC_EmitMergeInputChains1_0,
/* 25661*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25664*/      OPC_EmitConvertToTarget, 2,
/* 25666*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25675*/     /*Scope*/ 23, /*->25699*/
/* 25676*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25678*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 25680*/      OPC_CheckType, MVT::i32,
/* 25682*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25684*/      OPC_EmitMergeInputChains1_0,
/* 25685*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25688*/      OPC_EmitConvertToTarget, 2,
/* 25690*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25699*/     /*Scope*/ 23, /*->25723*/
/* 25700*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25702*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 25704*/      OPC_CheckType, MVT::i32,
/* 25706*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25708*/      OPC_EmitMergeInputChains1_0,
/* 25709*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25712*/      OPC_EmitConvertToTarget, 2,
/* 25714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25723*/     /*Scope*/ 23, /*->25747*/
/* 25724*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25726*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 25728*/      OPC_CheckType, MVT::i32,
/* 25730*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25732*/      OPC_EmitMergeInputChains1_0,
/* 25733*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25736*/      OPC_EmitConvertToTarget, 2,
/* 25738*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25747*/     /*Scope*/ 23, /*->25771*/
/* 25748*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25750*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 25752*/      OPC_CheckType, MVT::i64,
/* 25754*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25756*/      OPC_EmitMergeInputChains1_0,
/* 25757*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25760*/      OPC_EmitConvertToTarget, 2,
/* 25762*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25771*/     /*Scope*/ 23, /*->25795*/
/* 25772*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25774*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 25776*/      OPC_CheckType, MVT::i64,
/* 25778*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25780*/      OPC_EmitMergeInputChains1_0,
/* 25781*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25784*/      OPC_EmitConvertToTarget, 2,
/* 25786*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25795*/     /*Scope*/ 23, /*->25819*/
/* 25796*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25798*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 25800*/      OPC_CheckType, MVT::i64,
/* 25802*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25804*/      OPC_EmitMergeInputChains1_0,
/* 25805*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25808*/      OPC_EmitConvertToTarget, 2,
/* 25810*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25819*/     /*Scope*/ 23, /*->25843*/
/* 25820*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25822*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 25824*/      OPC_CheckType, MVT::i64,
/* 25826*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25828*/      OPC_EmitMergeInputChains1_0,
/* 25829*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25832*/      OPC_EmitConvertToTarget, 2,
/* 25834*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25843*/     /*Scope*/ 23, /*->25867*/
/* 25844*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 25846*/      OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 25848*/      OPC_CheckType, MVT::i64,
/* 25850*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25852*/      OPC_EmitMergeInputChains1_0,
/* 25853*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25856*/      OPC_EmitConvertToTarget, 2,
/* 25858*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 11
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25867*/     /*Scope*/ 23, /*->25891*/
/* 25868*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 25870*/      OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 25872*/      OPC_CheckType, MVT::i64,
/* 25874*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25876*/      OPC_EmitMergeInputChains1_0,
/* 25877*/      OPC_EmitInteger, MVT::i32, 0, 
/* 25880*/      OPC_EmitConvertToTarget, 2,
/* 25882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 11
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25891*/     /*Scope*/ 112, /*->26004*/
/* 25892*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 25894*/      OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->25939
/* 25897*/       OPC_Scope, 19, /*->25918*/ // 2 children in Scope
/* 25899*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 25901*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25903*/        OPC_EmitMergeInputChains1_0,
/* 25904*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25907*/        OPC_EmitConvertToTarget, 2,
/* 25909*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25918*/       /*Scope*/ 19, /*->25938*/
/* 25919*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 25921*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25923*/        OPC_EmitMergeInputChains1_0,
/* 25924*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25927*/        OPC_EmitConvertToTarget, 2,
/* 25929*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25938*/       0, /*End of Scope*/
/* 25939*/      /*SwitchType*/ 62, MVT::i64,// ->26003
/* 25941*/       OPC_Scope, 19, /*->25962*/ // 3 children in Scope
/* 25943*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 25945*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25947*/        OPC_EmitMergeInputChains1_0,
/* 25948*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25951*/        OPC_EmitConvertToTarget, 2,
/* 25953*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25962*/       /*Scope*/ 19, /*->25982*/
/* 25963*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 25965*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25967*/        OPC_EmitMergeInputChains1_0,
/* 25968*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25971*/        OPC_EmitConvertToTarget, 2,
/* 25973*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 25982*/       /*Scope*/ 19, /*->26002*/
/* 25983*/        OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 25985*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 25987*/        OPC_EmitMergeInputChains1_0,
/* 25988*/        OPC_EmitInteger, MVT::i32, 0, 
/* 25991*/        OPC_EmitConvertToTarget, 2,
/* 25993*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 11
                  // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26002*/       0, /*End of Scope*/
/* 26003*/      0, // EndSwitchType
/* 26004*/     0, /*End of Scope*/
/* 26005*/    /*SwitchType*/ 17|128,3/*401*/, MVT::i64,// ->26409
/* 26008*/     OPC_MoveParent,
/* 26009*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 26011*/     OPC_Scope, 42, /*->26055*/ // 12 children in Scope
/* 26013*/      OPC_CheckPredicate, 20, // Predicate_load
/* 26015*/      OPC_SwitchType /*2 cases */, 17, MVT::i32,// ->26035
/* 26018*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26020*/       OPC_EmitMergeInputChains1_0,
/* 26021*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26024*/       OPC_EmitConvertToTarget, 2,
/* 26026*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26035*/      /*SwitchType*/ 17, MVT::i64,// ->26054
/* 26037*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26039*/       OPC_EmitMergeInputChains1_0,
/* 26040*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26043*/       OPC_EmitConvertToTarget, 2,
/* 26045*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26054*/      0, // EndSwitchType
/* 26055*/     /*Scope*/ 23, /*->26079*/
/* 26056*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 26058*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 26060*/      OPC_CheckType, MVT::i32,
/* 26062*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26064*/      OPC_EmitMergeInputChains1_0,
/* 26065*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26068*/      OPC_EmitConvertToTarget, 2,
/* 26070*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26079*/     /*Scope*/ 23, /*->26103*/
/* 26080*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 26082*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 26084*/      OPC_CheckType, MVT::i32,
/* 26086*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26088*/      OPC_EmitMergeInputChains1_0,
/* 26089*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26092*/      OPC_EmitConvertToTarget, 2,
/* 26094*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26103*/     /*Scope*/ 23, /*->26127*/
/* 26104*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 26106*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 26108*/      OPC_CheckType, MVT::i32,
/* 26110*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26112*/      OPC_EmitMergeInputChains1_0,
/* 26113*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26116*/      OPC_EmitConvertToTarget, 2,
/* 26118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26127*/     /*Scope*/ 23, /*->26151*/
/* 26128*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 26130*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 26132*/      OPC_CheckType, MVT::i32,
/* 26134*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26136*/      OPC_EmitMergeInputChains1_0,
/* 26137*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26140*/      OPC_EmitConvertToTarget, 2,
/* 26142*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26151*/     /*Scope*/ 23, /*->26175*/
/* 26152*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 26154*/      OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 26156*/      OPC_CheckType, MVT::i64,
/* 26158*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26160*/      OPC_EmitMergeInputChains1_0,
/* 26161*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26164*/      OPC_EmitConvertToTarget, 2,
/* 26166*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26175*/     /*Scope*/ 23, /*->26199*/
/* 26176*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 26178*/      OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 26180*/      OPC_CheckType, MVT::i64,
/* 26182*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26184*/      OPC_EmitMergeInputChains1_0,
/* 26185*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26188*/      OPC_EmitConvertToTarget, 2,
/* 26190*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26199*/     /*Scope*/ 23, /*->26223*/
/* 26200*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 26202*/      OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 26204*/      OPC_CheckType, MVT::i64,
/* 26206*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26208*/      OPC_EmitMergeInputChains1_0,
/* 26209*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26212*/      OPC_EmitConvertToTarget, 2,
/* 26214*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26223*/     /*Scope*/ 23, /*->26247*/
/* 26224*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 26226*/      OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 26228*/      OPC_CheckType, MVT::i64,
/* 26230*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26232*/      OPC_EmitMergeInputChains1_0,
/* 26233*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26236*/      OPC_EmitConvertToTarget, 2,
/* 26238*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26247*/     /*Scope*/ 23, /*->26271*/
/* 26248*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 26250*/      OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 26252*/      OPC_CheckType, MVT::i64,
/* 26254*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26256*/      OPC_EmitMergeInputChains1_0,
/* 26257*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26260*/      OPC_EmitConvertToTarget, 2,
/* 26262*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 11
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26271*/     /*Scope*/ 23, /*->26295*/
/* 26272*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 26274*/      OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 26276*/      OPC_CheckType, MVT::i64,
/* 26278*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26280*/      OPC_EmitMergeInputChains1_0,
/* 26281*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26284*/      OPC_EmitConvertToTarget, 2,
/* 26286*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 11
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26295*/     /*Scope*/ 112, /*->26408*/
/* 26296*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 26298*/      OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->26343
/* 26301*/       OPC_Scope, 19, /*->26322*/ // 2 children in Scope
/* 26303*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 26305*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26307*/        OPC_EmitMergeInputChains1_0,
/* 26308*/        OPC_EmitInteger, MVT::i32, 0, 
/* 26311*/        OPC_EmitConvertToTarget, 2,
/* 26313*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26322*/       /*Scope*/ 19, /*->26342*/
/* 26323*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 26325*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26327*/        OPC_EmitMergeInputChains1_0,
/* 26328*/        OPC_EmitInteger, MVT::i32, 0, 
/* 26331*/        OPC_EmitConvertToTarget, 2,
/* 26333*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26342*/       0, /*End of Scope*/
/* 26343*/      /*SwitchType*/ 62, MVT::i64,// ->26407
/* 26345*/       OPC_Scope, 19, /*->26366*/ // 3 children in Scope
/* 26347*/        OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 26349*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26351*/        OPC_EmitMergeInputChains1_0,
/* 26352*/        OPC_EmitInteger, MVT::i32, 0, 
/* 26355*/        OPC_EmitConvertToTarget, 2,
/* 26357*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                  // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26366*/       /*Scope*/ 19, /*->26386*/
/* 26367*/        OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 26369*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26371*/        OPC_EmitMergeInputChains1_0,
/* 26372*/        OPC_EmitInteger, MVT::i32, 0, 
/* 26375*/        OPC_EmitConvertToTarget, 2,
/* 26377*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                  // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26386*/       /*Scope*/ 19, /*->26406*/
/* 26387*/        OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 26389*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 26391*/        OPC_EmitMergeInputChains1_0,
/* 26392*/        OPC_EmitInteger, MVT::i32, 0, 
/* 26395*/        OPC_EmitConvertToTarget, 2,
/* 26397*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                  // Src: (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 11
                  // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 26406*/       0, /*End of Scope*/
/* 26407*/      0, // EndSwitchType
/* 26408*/     0, /*End of Scope*/
/* 26409*/    0, // EndSwitchType
/* 26410*/   /*SwitchOpcode*/ 14|128,8/*1038*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->27452
/* 26414*/    OPC_RecordChild0, // #1 = $off
/* 26415*/    OPC_MoveChild0,
/* 26416*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 26419*/    OPC_MoveParent,
/* 26420*/    OPC_MoveParent,
/* 26421*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 26423*/    OPC_Scope, 116, /*->26541*/ // 12 children in Scope
/* 26425*/     OPC_CheckPredicate, 20, // Predicate_load
/* 26427*/     OPC_SwitchType /*2 cases */, 54, MVT::i32,// ->26484
/* 26430*/      OPC_Scope, 25, /*->26457*/ // 2 children in Scope
/* 26432*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26434*/       OPC_EmitMergeInputChains1_0,
/* 26435*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26438*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26441*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26448*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26457*/      /*Scope*/ 25, /*->26483*/
/* 26458*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26460*/       OPC_EmitMergeInputChains1_0,
/* 26461*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26464*/       OPC_EmitInteger, MVT::i64, 0, 
/* 26467*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26474*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26483*/      0, /*End of Scope*/
/* 26484*/     /*SwitchType*/ 54, MVT::i64,// ->26540
/* 26486*/      OPC_Scope, 25, /*->26513*/ // 2 children in Scope
/* 26488*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26490*/       OPC_EmitMergeInputChains1_0,
/* 26491*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26494*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26497*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26504*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26513*/      /*Scope*/ 25, /*->26539*/
/* 26514*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26516*/       OPC_EmitMergeInputChains1_0,
/* 26517*/       OPC_EmitInteger, MVT::i32, 0, 
/* 26520*/       OPC_EmitInteger, MVT::i64, 0, 
/* 26523*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26530*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26539*/      0, /*End of Scope*/
/* 26540*/     0, // EndSwitchType
/* 26541*/    /*Scope*/ 60, /*->26602*/
/* 26542*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 26544*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 26546*/     OPC_CheckType, MVT::i32,
/* 26548*/     OPC_Scope, 25, /*->26575*/ // 2 children in Scope
/* 26550*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26552*/      OPC_EmitMergeInputChains1_0,
/* 26553*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26556*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26559*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26566*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26575*/     /*Scope*/ 25, /*->26601*/
/* 26576*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26578*/      OPC_EmitMergeInputChains1_0,
/* 26579*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26582*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26585*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26592*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26601*/     0, /*End of Scope*/
/* 26602*/    /*Scope*/ 60, /*->26663*/
/* 26603*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 26605*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 26607*/     OPC_CheckType, MVT::i32,
/* 26609*/     OPC_Scope, 25, /*->26636*/ // 2 children in Scope
/* 26611*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26613*/      OPC_EmitMergeInputChains1_0,
/* 26614*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26617*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26620*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26627*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26636*/     /*Scope*/ 25, /*->26662*/
/* 26637*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26639*/      OPC_EmitMergeInputChains1_0,
/* 26640*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26643*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26646*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26653*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26662*/     0, /*End of Scope*/
/* 26663*/    /*Scope*/ 60, /*->26724*/
/* 26664*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 26666*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 26668*/     OPC_CheckType, MVT::i32,
/* 26670*/     OPC_Scope, 25, /*->26697*/ // 2 children in Scope
/* 26672*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26674*/      OPC_EmitMergeInputChains1_0,
/* 26675*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26678*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26681*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26688*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26697*/     /*Scope*/ 25, /*->26723*/
/* 26698*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26700*/      OPC_EmitMergeInputChains1_0,
/* 26701*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26704*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26707*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26723*/     0, /*End of Scope*/
/* 26724*/    /*Scope*/ 60, /*->26785*/
/* 26725*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 26727*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 26729*/     OPC_CheckType, MVT::i32,
/* 26731*/     OPC_Scope, 25, /*->26758*/ // 2 children in Scope
/* 26733*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26735*/      OPC_EmitMergeInputChains1_0,
/* 26736*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26739*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26742*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26749*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26758*/     /*Scope*/ 25, /*->26784*/
/* 26759*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26761*/      OPC_EmitMergeInputChains1_0,
/* 26762*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26765*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26768*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26775*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26784*/     0, /*End of Scope*/
/* 26785*/    /*Scope*/ 60, /*->26846*/
/* 26786*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 26788*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 26790*/     OPC_CheckType, MVT::i64,
/* 26792*/     OPC_Scope, 25, /*->26819*/ // 2 children in Scope
/* 26794*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26796*/      OPC_EmitMergeInputChains1_0,
/* 26797*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26800*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26803*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26810*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26819*/     /*Scope*/ 25, /*->26845*/
/* 26820*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26822*/      OPC_EmitMergeInputChains1_0,
/* 26823*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26826*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26829*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26836*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26845*/     0, /*End of Scope*/
/* 26846*/    /*Scope*/ 60, /*->26907*/
/* 26847*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 26849*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 26851*/     OPC_CheckType, MVT::i64,
/* 26853*/     OPC_Scope, 25, /*->26880*/ // 2 children in Scope
/* 26855*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26857*/      OPC_EmitMergeInputChains1_0,
/* 26858*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26861*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26864*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26871*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26880*/     /*Scope*/ 25, /*->26906*/
/* 26881*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26883*/      OPC_EmitMergeInputChains1_0,
/* 26884*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26887*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26890*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26897*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26906*/     0, /*End of Scope*/
/* 26907*/    /*Scope*/ 60, /*->26968*/
/* 26908*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 26910*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 26912*/     OPC_CheckType, MVT::i64,
/* 26914*/     OPC_Scope, 25, /*->26941*/ // 2 children in Scope
/* 26916*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26918*/      OPC_EmitMergeInputChains1_0,
/* 26919*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26922*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26925*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26932*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26941*/     /*Scope*/ 25, /*->26967*/
/* 26942*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26944*/      OPC_EmitMergeInputChains1_0,
/* 26945*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26948*/      OPC_EmitInteger, MVT::i64, 0, 
/* 26951*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 26958*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 26967*/     0, /*End of Scope*/
/* 26968*/    /*Scope*/ 60, /*->27029*/
/* 26969*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 26971*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 26973*/     OPC_CheckType, MVT::i64,
/* 26975*/     OPC_Scope, 25, /*->27002*/ // 2 children in Scope
/* 26977*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 26979*/      OPC_EmitMergeInputChains1_0,
/* 26980*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26983*/      OPC_EmitInteger, MVT::i32, 0, 
/* 26986*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26993*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27002*/     /*Scope*/ 25, /*->27028*/
/* 27003*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27005*/      OPC_EmitMergeInputChains1_0,
/* 27006*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27009*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27012*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27019*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27028*/     0, /*End of Scope*/
/* 27029*/    /*Scope*/ 60, /*->27090*/
/* 27030*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 27032*/     OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 27034*/     OPC_CheckType, MVT::i64,
/* 27036*/     OPC_Scope, 25, /*->27063*/ // 2 children in Scope
/* 27038*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27040*/      OPC_EmitMergeInputChains1_0,
/* 27041*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27044*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27047*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27054*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 10
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27063*/     /*Scope*/ 25, /*->27089*/
/* 27064*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27066*/      OPC_EmitMergeInputChains1_0,
/* 27067*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27070*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27073*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27080*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 10
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27089*/     0, /*End of Scope*/
/* 27090*/    /*Scope*/ 60, /*->27151*/
/* 27091*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 27093*/     OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 27095*/     OPC_CheckType, MVT::i64,
/* 27097*/     OPC_Scope, 25, /*->27124*/ // 2 children in Scope
/* 27099*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27101*/      OPC_EmitMergeInputChains1_0,
/* 27102*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27105*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27108*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27115*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 10
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27124*/     /*Scope*/ 25, /*->27150*/
/* 27125*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27127*/      OPC_EmitMergeInputChains1_0,
/* 27128*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27131*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27134*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27141*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 10
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27150*/     0, /*End of Scope*/
/* 27151*/    /*Scope*/ 42|128,2/*298*/, /*->27451*/
/* 27153*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 27155*/     OPC_SwitchType /*2 cases */, 116, MVT::i32,// ->27274
/* 27158*/      OPC_Scope, 56, /*->27216*/ // 2 children in Scope
/* 27160*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 27162*/       OPC_Scope, 25, /*->27189*/ // 2 children in Scope
/* 27164*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27166*/        OPC_EmitMergeInputChains1_0,
/* 27167*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27170*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27173*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27180*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                  // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27189*/       /*Scope*/ 25, /*->27215*/
/* 27190*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27192*/        OPC_EmitMergeInputChains1_0,
/* 27193*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27196*/        OPC_EmitInteger, MVT::i64, 0, 
/* 27199*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27206*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                  // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27215*/       0, /*End of Scope*/
/* 27216*/      /*Scope*/ 56, /*->27273*/
/* 27217*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 27219*/       OPC_Scope, 25, /*->27246*/ // 2 children in Scope
/* 27221*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27223*/        OPC_EmitMergeInputChains1_0,
/* 27224*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27227*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27230*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27237*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                  // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27246*/       /*Scope*/ 25, /*->27272*/
/* 27247*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27249*/        OPC_EmitMergeInputChains1_0,
/* 27250*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27253*/        OPC_EmitInteger, MVT::i64, 0, 
/* 27256*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27263*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                  // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27272*/       0, /*End of Scope*/
/* 27273*/      0, /*End of Scope*/
/* 27274*/     /*SwitchType*/ 45|128,1/*173*/, MVT::i64,// ->27450
/* 27277*/      OPC_Scope, 56, /*->27335*/ // 3 children in Scope
/* 27279*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 27281*/       OPC_Scope, 25, /*->27308*/ // 2 children in Scope
/* 27283*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27285*/        OPC_EmitMergeInputChains1_0,
/* 27286*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27289*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27292*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27299*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                  // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27308*/       /*Scope*/ 25, /*->27334*/
/* 27309*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27311*/        OPC_EmitMergeInputChains1_0,
/* 27312*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27315*/        OPC_EmitInteger, MVT::i64, 0, 
/* 27318*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27325*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                  // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27334*/       0, /*End of Scope*/
/* 27335*/      /*Scope*/ 56, /*->27392*/
/* 27336*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 27338*/       OPC_Scope, 25, /*->27365*/ // 2 children in Scope
/* 27340*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27342*/        OPC_EmitMergeInputChains1_0,
/* 27343*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27346*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27349*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27356*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                  // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27365*/       /*Scope*/ 25, /*->27391*/
/* 27366*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27368*/        OPC_EmitMergeInputChains1_0,
/* 27369*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27372*/        OPC_EmitInteger, MVT::i64, 0, 
/* 27375*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27382*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                  // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27391*/       0, /*End of Scope*/
/* 27392*/      /*Scope*/ 56, /*->27449*/
/* 27393*/       OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 27395*/       OPC_Scope, 25, /*->27422*/ // 2 children in Scope
/* 27397*/        OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27399*/        OPC_EmitMergeInputChains1_0,
/* 27400*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27403*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27406*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 27413*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 10
                  // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27422*/       /*Scope*/ 25, /*->27448*/
/* 27423*/        OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 27425*/        OPC_EmitMergeInputChains1_0,
/* 27426*/        OPC_EmitInteger, MVT::i32, 0, 
/* 27429*/        OPC_EmitInteger, MVT::i64, 0, 
/* 27432*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 27439*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                  // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 10
                  // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27448*/       0, /*End of Scope*/
/* 27449*/      0, /*End of Scope*/
/* 27450*/     0, // EndSwitchType
/* 27451*/    0, /*End of Scope*/
/* 27452*/   0, // EndSwitchOpcode
/* 27453*/  /*Scope*/ 31|128,15/*1951*/, /*->29406*/
/* 27455*/   OPC_RecordChild1, // #1 = $off
/* 27456*/   OPC_Scope, 80|128,8/*1104*/, /*->28563*/ // 3 children in Scope
/* 27459*/    OPC_MoveChild1,
/* 27460*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27463*/    OPC_MoveParent,
/* 27464*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 27466*/    OPC_Scope, 124, /*->27592*/ // 12 children in Scope
/* 27468*/     OPC_CheckPredicate, 20, // Predicate_load
/* 27470*/     OPC_SwitchType /*2 cases */, 58, MVT::i32,// ->27531
/* 27473*/      OPC_Scope, 27, /*->27502*/ // 2 children in Scope
/* 27475*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27477*/       OPC_EmitMergeInputChains1_0,
/* 27478*/       OPC_EmitInteger, MVT::i32, 0, 
/* 27481*/       OPC_EmitConvertToTarget, 1,
/* 27483*/       OPC_EmitInteger, MVT::i32, 0, 
/* 27486*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27493*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27502*/      /*Scope*/ 27, /*->27530*/
/* 27503*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27505*/       OPC_EmitMergeInputChains1_0,
/* 27506*/       OPC_EmitInteger, MVT::i32, 0, 
/* 27509*/       OPC_EmitConvertToTarget, 1,
/* 27511*/       OPC_EmitInteger, MVT::i64, 0, 
/* 27514*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27521*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27530*/      0, /*End of Scope*/
/* 27531*/     /*SwitchType*/ 58, MVT::i64,// ->27591
/* 27533*/      OPC_Scope, 27, /*->27562*/ // 2 children in Scope
/* 27535*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27537*/       OPC_EmitMergeInputChains1_0,
/* 27538*/       OPC_EmitInteger, MVT::i32, 0, 
/* 27541*/       OPC_EmitConvertToTarget, 1,
/* 27543*/       OPC_EmitInteger, MVT::i32, 0, 
/* 27546*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27553*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27562*/      /*Scope*/ 27, /*->27590*/
/* 27563*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27565*/       OPC_EmitMergeInputChains1_0,
/* 27566*/       OPC_EmitInteger, MVT::i32, 0, 
/* 27569*/       OPC_EmitConvertToTarget, 1,
/* 27571*/       OPC_EmitInteger, MVT::i64, 0, 
/* 27574*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27581*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27590*/      0, /*End of Scope*/
/* 27591*/     0, // EndSwitchType
/* 27592*/    /*Scope*/ 64, /*->27657*/
/* 27593*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 27595*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 27597*/     OPC_CheckType, MVT::i32,
/* 27599*/     OPC_Scope, 27, /*->27628*/ // 2 children in Scope
/* 27601*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27603*/      OPC_EmitMergeInputChains1_0,
/* 27604*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27607*/      OPC_EmitConvertToTarget, 1,
/* 27609*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27612*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27619*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 7
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27628*/     /*Scope*/ 27, /*->27656*/
/* 27629*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27631*/      OPC_EmitMergeInputChains1_0,
/* 27632*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27635*/      OPC_EmitConvertToTarget, 1,
/* 27637*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27640*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27647*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 7
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27656*/     0, /*End of Scope*/
/* 27657*/    /*Scope*/ 64, /*->27722*/
/* 27658*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 27660*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 27662*/     OPC_CheckType, MVT::i32,
/* 27664*/     OPC_Scope, 27, /*->27693*/ // 2 children in Scope
/* 27666*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27668*/      OPC_EmitMergeInputChains1_0,
/* 27669*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27672*/      OPC_EmitConvertToTarget, 1,
/* 27674*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27677*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27684*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 7
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27693*/     /*Scope*/ 27, /*->27721*/
/* 27694*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27696*/      OPC_EmitMergeInputChains1_0,
/* 27697*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27700*/      OPC_EmitConvertToTarget, 1,
/* 27702*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27705*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27712*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 7
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27721*/     0, /*End of Scope*/
/* 27722*/    /*Scope*/ 64, /*->27787*/
/* 27723*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 27725*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 27727*/     OPC_CheckType, MVT::i32,
/* 27729*/     OPC_Scope, 27, /*->27758*/ // 2 children in Scope
/* 27731*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27733*/      OPC_EmitMergeInputChains1_0,
/* 27734*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27737*/      OPC_EmitConvertToTarget, 1,
/* 27739*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27742*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27749*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 7
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27758*/     /*Scope*/ 27, /*->27786*/
/* 27759*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27761*/      OPC_EmitMergeInputChains1_0,
/* 27762*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27765*/      OPC_EmitConvertToTarget, 1,
/* 27767*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27770*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27777*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 7
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27786*/     0, /*End of Scope*/
/* 27787*/    /*Scope*/ 64, /*->27852*/
/* 27788*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 27790*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 27792*/     OPC_CheckType, MVT::i32,
/* 27794*/     OPC_Scope, 27, /*->27823*/ // 2 children in Scope
/* 27796*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27798*/      OPC_EmitMergeInputChains1_0,
/* 27799*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27802*/      OPC_EmitConvertToTarget, 1,
/* 27804*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27807*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27814*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 7
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27823*/     /*Scope*/ 27, /*->27851*/
/* 27824*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27826*/      OPC_EmitMergeInputChains1_0,
/* 27827*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27830*/      OPC_EmitConvertToTarget, 1,
/* 27832*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27835*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27842*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 7
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27851*/     0, /*End of Scope*/
/* 27852*/    /*Scope*/ 64, /*->27917*/
/* 27853*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 27855*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 27857*/     OPC_CheckType, MVT::i64,
/* 27859*/     OPC_Scope, 27, /*->27888*/ // 2 children in Scope
/* 27861*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27863*/      OPC_EmitMergeInputChains1_0,
/* 27864*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27867*/      OPC_EmitConvertToTarget, 1,
/* 27869*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27872*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27879*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 7
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27888*/     /*Scope*/ 27, /*->27916*/
/* 27889*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27891*/      OPC_EmitMergeInputChains1_0,
/* 27892*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27895*/      OPC_EmitConvertToTarget, 1,
/* 27897*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27900*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27907*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 7
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27916*/     0, /*End of Scope*/
/* 27917*/    /*Scope*/ 64, /*->27982*/
/* 27918*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 27920*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 27922*/     OPC_CheckType, MVT::i64,
/* 27924*/     OPC_Scope, 27, /*->27953*/ // 2 children in Scope
/* 27926*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27928*/      OPC_EmitMergeInputChains1_0,
/* 27929*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27932*/      OPC_EmitConvertToTarget, 1,
/* 27934*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27937*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 27944*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 7
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 27953*/     /*Scope*/ 27, /*->27981*/
/* 27954*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 27956*/      OPC_EmitMergeInputChains1_0,
/* 27957*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27960*/      OPC_EmitConvertToTarget, 1,
/* 27962*/      OPC_EmitInteger, MVT::i64, 0, 
/* 27965*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 27972*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 7
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 27981*/     0, /*End of Scope*/
/* 27982*/    /*Scope*/ 64, /*->28047*/
/* 27983*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 27985*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 27987*/     OPC_CheckType, MVT::i64,
/* 27989*/     OPC_Scope, 27, /*->28018*/ // 2 children in Scope
/* 27991*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 27993*/      OPC_EmitMergeInputChains1_0,
/* 27994*/      OPC_EmitInteger, MVT::i32, 0, 
/* 27997*/      OPC_EmitConvertToTarget, 1,
/* 27999*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28002*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28009*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 7
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28018*/     /*Scope*/ 27, /*->28046*/
/* 28019*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28021*/      OPC_EmitMergeInputChains1_0,
/* 28022*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28025*/      OPC_EmitConvertToTarget, 1,
/* 28027*/      OPC_EmitInteger, MVT::i64, 0, 
/* 28030*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28037*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 7
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28046*/     0, /*End of Scope*/
/* 28047*/    /*Scope*/ 64, /*->28112*/
/* 28048*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28050*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 28052*/     OPC_CheckType, MVT::i64,
/* 28054*/     OPC_Scope, 27, /*->28083*/ // 2 children in Scope
/* 28056*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28058*/      OPC_EmitMergeInputChains1_0,
/* 28059*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28062*/      OPC_EmitConvertToTarget, 1,
/* 28064*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28067*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28074*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 7
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28083*/     /*Scope*/ 27, /*->28111*/
/* 28084*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28086*/      OPC_EmitMergeInputChains1_0,
/* 28087*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28090*/      OPC_EmitConvertToTarget, 1,
/* 28092*/      OPC_EmitInteger, MVT::i64, 0, 
/* 28095*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28102*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 7
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28111*/     0, /*End of Scope*/
/* 28112*/    /*Scope*/ 64, /*->28177*/
/* 28113*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 28115*/     OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 28117*/     OPC_CheckType, MVT::i64,
/* 28119*/     OPC_Scope, 27, /*->28148*/ // 2 children in Scope
/* 28121*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28123*/      OPC_EmitMergeInputChains1_0,
/* 28124*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28127*/      OPC_EmitConvertToTarget, 1,
/* 28129*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28132*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28139*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 7
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28148*/     /*Scope*/ 27, /*->28176*/
/* 28149*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28151*/      OPC_EmitMergeInputChains1_0,
/* 28152*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28155*/      OPC_EmitConvertToTarget, 1,
/* 28157*/      OPC_EmitInteger, MVT::i64, 0, 
/* 28160*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 7
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28176*/     0, /*End of Scope*/
/* 28177*/    /*Scope*/ 64, /*->28242*/
/* 28178*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28180*/     OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 28182*/     OPC_CheckType, MVT::i64,
/* 28184*/     OPC_Scope, 27, /*->28213*/ // 2 children in Scope
/* 28186*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28188*/      OPC_EmitMergeInputChains1_0,
/* 28189*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28192*/      OPC_EmitConvertToTarget, 1,
/* 28194*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28197*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28204*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 7
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28213*/     /*Scope*/ 27, /*->28241*/
/* 28214*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28216*/      OPC_EmitMergeInputChains1_0,
/* 28217*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28220*/      OPC_EmitConvertToTarget, 1,
/* 28222*/      OPC_EmitInteger, MVT::i64, 0, 
/* 28225*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28232*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 7
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28241*/     0, /*End of Scope*/
/* 28242*/    /*Scope*/ 62|128,2/*318*/, /*->28562*/
/* 28244*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 28246*/     OPC_SwitchType /*2 cases */, 124, MVT::i32,// ->28373
/* 28249*/      OPC_Scope, 60, /*->28311*/ // 2 children in Scope
/* 28251*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 28253*/       OPC_Scope, 27, /*->28282*/ // 2 children in Scope
/* 28255*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28257*/        OPC_EmitMergeInputChains1_0,
/* 28258*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28261*/        OPC_EmitConvertToTarget, 1,
/* 28263*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28266*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28273*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 7
                  // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28282*/       /*Scope*/ 27, /*->28310*/
/* 28283*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28285*/        OPC_EmitMergeInputChains1_0,
/* 28286*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28289*/        OPC_EmitConvertToTarget, 1,
/* 28291*/        OPC_EmitInteger, MVT::i64, 0, 
/* 28294*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28301*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 7
                  // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28310*/       0, /*End of Scope*/
/* 28311*/      /*Scope*/ 60, /*->28372*/
/* 28312*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 28314*/       OPC_Scope, 27, /*->28343*/ // 2 children in Scope
/* 28316*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28318*/        OPC_EmitMergeInputChains1_0,
/* 28319*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28322*/        OPC_EmitConvertToTarget, 1,
/* 28324*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28327*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28334*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 7
                  // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28343*/       /*Scope*/ 27, /*->28371*/
/* 28344*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28346*/        OPC_EmitMergeInputChains1_0,
/* 28347*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28350*/        OPC_EmitConvertToTarget, 1,
/* 28352*/        OPC_EmitInteger, MVT::i64, 0, 
/* 28355*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28362*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 7
                  // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28371*/       0, /*End of Scope*/
/* 28372*/      0, /*End of Scope*/
/* 28373*/     /*SwitchType*/ 57|128,1/*185*/, MVT::i64,// ->28561
/* 28376*/      OPC_Scope, 60, /*->28438*/ // 3 children in Scope
/* 28378*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 28380*/       OPC_Scope, 27, /*->28409*/ // 2 children in Scope
/* 28382*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28384*/        OPC_EmitMergeInputChains1_0,
/* 28385*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28388*/        OPC_EmitConvertToTarget, 1,
/* 28390*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28393*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28400*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 7
                  // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28409*/       /*Scope*/ 27, /*->28437*/
/* 28410*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28412*/        OPC_EmitMergeInputChains1_0,
/* 28413*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28416*/        OPC_EmitConvertToTarget, 1,
/* 28418*/        OPC_EmitInteger, MVT::i64, 0, 
/* 28421*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28428*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 7
                  // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28437*/       0, /*End of Scope*/
/* 28438*/      /*Scope*/ 60, /*->28499*/
/* 28439*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 28441*/       OPC_Scope, 27, /*->28470*/ // 2 children in Scope
/* 28443*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28445*/        OPC_EmitMergeInputChains1_0,
/* 28446*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28449*/        OPC_EmitConvertToTarget, 1,
/* 28451*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28454*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28461*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 7
                  // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28470*/       /*Scope*/ 27, /*->28498*/
/* 28471*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28473*/        OPC_EmitMergeInputChains1_0,
/* 28474*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28477*/        OPC_EmitConvertToTarget, 1,
/* 28479*/        OPC_EmitInteger, MVT::i64, 0, 
/* 28482*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28489*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 7
                  // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28498*/       0, /*End of Scope*/
/* 28499*/      /*Scope*/ 60, /*->28560*/
/* 28500*/       OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 28502*/       OPC_Scope, 27, /*->28531*/ // 2 children in Scope
/* 28504*/        OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28506*/        OPC_EmitMergeInputChains1_0,
/* 28507*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28510*/        OPC_EmitConvertToTarget, 1,
/* 28512*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28515*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 28522*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 7
                  // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 28531*/       /*Scope*/ 27, /*->28559*/
/* 28532*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28534*/        OPC_EmitMergeInputChains1_0,
/* 28535*/        OPC_EmitInteger, MVT::i32, 0, 
/* 28538*/        OPC_EmitConvertToTarget, 1,
/* 28540*/        OPC_EmitInteger, MVT::i64, 0, 
/* 28543*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 28550*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                      MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                  // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 7
                  // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 28559*/       0, /*End of Scope*/
/* 28560*/      0, /*End of Scope*/
/* 28561*/     0, // EndSwitchType
/* 28562*/    0, /*End of Scope*/
/* 28563*/   /*Scope*/ 35|128,3/*419*/, /*->28984*/
/* 28565*/    OPC_CheckChild1Type, MVT::i32,
/* 28567*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 28569*/    OPC_Scope, 44, /*->28615*/ // 12 children in Scope
/* 28571*/     OPC_CheckPredicate, 20, // Predicate_load
/* 28573*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->28594
/* 28576*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28578*/      OPC_EmitMergeInputChains1_0,
/* 28579*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28582*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28585*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28594*/     /*SwitchType*/ 18, MVT::i64,// ->28614
/* 28596*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28598*/      OPC_EmitMergeInputChains1_0,
/* 28599*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28602*/      OPC_EmitInteger, MVT::i32, 0, 
/* 28605*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28614*/     0, // EndSwitchType
/* 28615*/    /*Scope*/ 24, /*->28640*/
/* 28616*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 28618*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 28620*/     OPC_CheckType, MVT::i32,
/* 28622*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28624*/     OPC_EmitMergeInputChains1_0,
/* 28625*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28628*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28631*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 4
               // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28640*/    /*Scope*/ 24, /*->28665*/
/* 28641*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28643*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 28645*/     OPC_CheckType, MVT::i32,
/* 28647*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28649*/     OPC_EmitMergeInputChains1_0,
/* 28650*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28653*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28656*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 4
               // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28665*/    /*Scope*/ 24, /*->28690*/
/* 28666*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 28668*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 28670*/     OPC_CheckType, MVT::i32,
/* 28672*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28674*/     OPC_EmitMergeInputChains1_0,
/* 28675*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28678*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28681*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 4
               // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28690*/    /*Scope*/ 24, /*->28715*/
/* 28691*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28693*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 28695*/     OPC_CheckType, MVT::i32,
/* 28697*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28699*/     OPC_EmitMergeInputChains1_0,
/* 28700*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28703*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28706*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 4
               // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28715*/    /*Scope*/ 24, /*->28740*/
/* 28716*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 28718*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 28720*/     OPC_CheckType, MVT::i64,
/* 28722*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28724*/     OPC_EmitMergeInputChains1_0,
/* 28725*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28728*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28731*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 4
               // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28740*/    /*Scope*/ 24, /*->28765*/
/* 28741*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28743*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 28745*/     OPC_CheckType, MVT::i64,
/* 28747*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28749*/     OPC_EmitMergeInputChains1_0,
/* 28750*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28753*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28756*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 4
               // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28765*/    /*Scope*/ 24, /*->28790*/
/* 28766*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 28768*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 28770*/     OPC_CheckType, MVT::i64,
/* 28772*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28774*/     OPC_EmitMergeInputChains1_0,
/* 28775*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28778*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28781*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 4
               // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28790*/    /*Scope*/ 24, /*->28815*/
/* 28791*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28793*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 28795*/     OPC_CheckType, MVT::i64,
/* 28797*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28799*/     OPC_EmitMergeInputChains1_0,
/* 28800*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28803*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28806*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 4
               // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28815*/    /*Scope*/ 24, /*->28840*/
/* 28816*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 28818*/     OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 28820*/     OPC_CheckType, MVT::i64,
/* 28822*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28824*/     OPC_EmitMergeInputChains1_0,
/* 28825*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28828*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28831*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 4
               // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28840*/    /*Scope*/ 24, /*->28865*/
/* 28841*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 28843*/     OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 28845*/     OPC_CheckType, MVT::i64,
/* 28847*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28849*/     OPC_EmitMergeInputChains1_0,
/* 28850*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28853*/     OPC_EmitInteger, MVT::i32, 0, 
/* 28856*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 4
               // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28865*/    /*Scope*/ 117, /*->28983*/
/* 28866*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 28868*/     OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->28915
/* 28871*/      OPC_Scope, 20, /*->28893*/ // 2 children in Scope
/* 28873*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 28875*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28877*/       OPC_EmitMergeInputChains1_0,
/* 28878*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28881*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28884*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 4
                 // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28893*/      /*Scope*/ 20, /*->28914*/
/* 28894*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 28896*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28898*/       OPC_EmitMergeInputChains1_0,
/* 28899*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28902*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28905*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 4
                 // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28914*/      0, /*End of Scope*/
/* 28915*/     /*SwitchType*/ 65, MVT::i64,// ->28982
/* 28917*/      OPC_Scope, 20, /*->28939*/ // 3 children in Scope
/* 28919*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 28921*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28923*/       OPC_EmitMergeInputChains1_0,
/* 28924*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28927*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28930*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 4
                 // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28939*/      /*Scope*/ 20, /*->28960*/
/* 28940*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 28942*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28944*/       OPC_EmitMergeInputChains1_0,
/* 28945*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28948*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28951*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 4
                 // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28960*/      /*Scope*/ 20, /*->28981*/
/* 28961*/       OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 28963*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 28965*/       OPC_EmitMergeInputChains1_0,
/* 28966*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28969*/       OPC_EmitInteger, MVT::i32, 0, 
/* 28972*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 4
                 // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 28981*/      0, /*End of Scope*/
/* 28982*/     0, // EndSwitchType
/* 28983*/    0, /*End of Scope*/
/* 28984*/   /*Scope*/ 35|128,3/*419*/, /*->29405*/
/* 28986*/    OPC_CheckChild1Type, MVT::i64,
/* 28988*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 28990*/    OPC_Scope, 44, /*->29036*/ // 12 children in Scope
/* 28992*/     OPC_CheckPredicate, 20, // Predicate_load
/* 28994*/     OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->29015
/* 28997*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 28999*/      OPC_EmitMergeInputChains1_0,
/* 29000*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29003*/      OPC_EmitInteger, MVT::i64, 0, 
/* 29006*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29015*/     /*SwitchType*/ 18, MVT::i64,// ->29035
/* 29017*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29019*/      OPC_EmitMergeInputChains1_0,
/* 29020*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29023*/      OPC_EmitInteger, MVT::i64, 0, 
/* 29026*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29035*/     0, // EndSwitchType
/* 29036*/    /*Scope*/ 24, /*->29061*/
/* 29037*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 29039*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 29041*/     OPC_CheckType, MVT::i32,
/* 29043*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29045*/     OPC_EmitMergeInputChains1_0,
/* 29046*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29049*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29052*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 4
               // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29061*/    /*Scope*/ 24, /*->29086*/
/* 29062*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 29064*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 29066*/     OPC_CheckType, MVT::i32,
/* 29068*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29070*/     OPC_EmitMergeInputChains1_0,
/* 29071*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29074*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29077*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 4
               // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29086*/    /*Scope*/ 24, /*->29111*/
/* 29087*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 29089*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 29091*/     OPC_CheckType, MVT::i32,
/* 29093*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29095*/     OPC_EmitMergeInputChains1_0,
/* 29096*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29099*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29102*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 4
               // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29111*/    /*Scope*/ 24, /*->29136*/
/* 29112*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 29114*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 29116*/     OPC_CheckType, MVT::i32,
/* 29118*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29120*/     OPC_EmitMergeInputChains1_0,
/* 29121*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29124*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29127*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 4
               // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29136*/    /*Scope*/ 24, /*->29161*/
/* 29137*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 29139*/     OPC_CheckPredicate, 1, // Predicate_sextloadi8
/* 29141*/     OPC_CheckType, MVT::i64,
/* 29143*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29145*/     OPC_EmitMergeInputChains1_0,
/* 29146*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29149*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29152*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 4
               // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29161*/    /*Scope*/ 24, /*->29186*/
/* 29162*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 29164*/     OPC_CheckPredicate, 1, // Predicate_zextloadi8
/* 29166*/     OPC_CheckType, MVT::i64,
/* 29168*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29170*/     OPC_EmitMergeInputChains1_0,
/* 29171*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29174*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29177*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 4
               // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29186*/    /*Scope*/ 24, /*->29211*/
/* 29187*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 29189*/     OPC_CheckPredicate, 2, // Predicate_sextloadi16
/* 29191*/     OPC_CheckType, MVT::i64,
/* 29193*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29195*/     OPC_EmitMergeInputChains1_0,
/* 29196*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29199*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29202*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 4
               // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29211*/    /*Scope*/ 24, /*->29236*/
/* 29212*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 29214*/     OPC_CheckPredicate, 2, // Predicate_zextloadi16
/* 29216*/     OPC_CheckType, MVT::i64,
/* 29218*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29220*/     OPC_EmitMergeInputChains1_0,
/* 29221*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29224*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29227*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 4
               // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29236*/    /*Scope*/ 24, /*->29261*/
/* 29237*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 29239*/     OPC_CheckPredicate, 4, // Predicate_sextloadi32
/* 29241*/     OPC_CheckType, MVT::i64,
/* 29243*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29245*/     OPC_EmitMergeInputChains1_0,
/* 29246*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29249*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29252*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 4
               // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29261*/    /*Scope*/ 24, /*->29286*/
/* 29262*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 29264*/     OPC_CheckPredicate, 4, // Predicate_zextloadi32
/* 29266*/     OPC_CheckType, MVT::i64,
/* 29268*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29270*/     OPC_EmitMergeInputChains1_0,
/* 29271*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29274*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29277*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 4
               // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29286*/    /*Scope*/ 117, /*->29404*/
/* 29287*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 29289*/     OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->29336
/* 29292*/      OPC_Scope, 20, /*->29314*/ // 2 children in Scope
/* 29294*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 29296*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29298*/       OPC_EmitMergeInputChains1_0,
/* 29299*/       OPC_EmitInteger, MVT::i32, 0, 
/* 29302*/       OPC_EmitInteger, MVT::i64, 0, 
/* 29305*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 4
                 // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29314*/      /*Scope*/ 20, /*->29335*/
/* 29315*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 29317*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29319*/       OPC_EmitMergeInputChains1_0,
/* 29320*/       OPC_EmitInteger, MVT::i32, 0, 
/* 29323*/       OPC_EmitInteger, MVT::i64, 0, 
/* 29326*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 4
                 // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29335*/      0, /*End of Scope*/
/* 29336*/     /*SwitchType*/ 65, MVT::i64,// ->29403
/* 29338*/      OPC_Scope, 20, /*->29360*/ // 3 children in Scope
/* 29340*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 29342*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29344*/       OPC_EmitMergeInputChains1_0,
/* 29345*/       OPC_EmitInteger, MVT::i32, 0, 
/* 29348*/       OPC_EmitInteger, MVT::i64, 0, 
/* 29351*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 4
                 // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29360*/      /*Scope*/ 20, /*->29381*/
/* 29361*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 29363*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29365*/       OPC_EmitMergeInputChains1_0,
/* 29366*/       OPC_EmitInteger, MVT::i32, 0, 
/* 29369*/       OPC_EmitInteger, MVT::i64, 0, 
/* 29372*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 4
                 // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29381*/      /*Scope*/ 20, /*->29402*/
/* 29382*/       OPC_CheckPredicate, 4, // Predicate_extloadi32
/* 29384*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29386*/       OPC_EmitMergeInputChains1_0,
/* 29387*/       OPC_EmitInteger, MVT::i32, 0, 
/* 29390*/       OPC_EmitInteger, MVT::i64, 0, 
/* 29393*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                 // Src: (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 4
                 // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29402*/      0, /*End of Scope*/
/* 29403*/     0, // EndSwitchType
/* 29404*/    0, /*End of Scope*/
/* 29405*/   0, /*End of Scope*/
/* 29406*/  /*Scope*/ 91|128,2/*347*/, /*->29755*/
/* 29408*/   OPC_MoveChild1,
/* 29409*/   OPC_SwitchOpcode /*3 cases */, 105, TARGET_VAL(ISD::ADD),// ->29518
/* 29413*/    OPC_RecordChild0, // #1 = $addr
/* 29414*/    OPC_RecordChild1, // #2 = $off
/* 29415*/    OPC_MoveChild1,
/* 29416*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 29419*/    OPC_MoveParent,
/* 29420*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 29422*/    OPC_SwitchType /*2 cases */, 45, MVT::i32,// ->29470
/* 29425*/     OPC_MoveParent,
/* 29426*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29428*/     OPC_CheckPredicate, 20, // Predicate_load
/* 29430*/     OPC_SwitchType /*2 cases */, 17, MVT::f32,// ->29450
/* 29433*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29435*/      OPC_EmitMergeInputChains1_0,
/* 29436*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29439*/      OPC_EmitConvertToTarget, 2,
/* 29441*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29450*/     /*SwitchType*/ 17, MVT::f64,// ->29469
/* 29452*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29454*/      OPC_EmitMergeInputChains1_0,
/* 29455*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29458*/      OPC_EmitConvertToTarget, 2,
/* 29460*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29469*/     0, // EndSwitchType
/* 29470*/    /*SwitchType*/ 45, MVT::i64,// ->29517
/* 29472*/     OPC_MoveParent,
/* 29473*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29475*/     OPC_CheckPredicate, 20, // Predicate_load
/* 29477*/     OPC_SwitchType /*2 cases */, 17, MVT::f32,// ->29497
/* 29480*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29482*/      OPC_EmitMergeInputChains1_0,
/* 29483*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29486*/      OPC_EmitConvertToTarget, 2,
/* 29488*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 29497*/     /*SwitchType*/ 17, MVT::f64,// ->29516
/* 29499*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29501*/      OPC_EmitMergeInputChains1_0,
/* 29502*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29505*/      OPC_EmitConvertToTarget, 2,
/* 29507*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 29516*/     0, // EndSwitchType
/* 29517*/    0, // EndSwitchType
/* 29518*/   /*SwitchOpcode*/ 105, TARGET_VAL(ISD::OR),// ->29626
/* 29521*/    OPC_RecordChild0, // #1 = $addr
/* 29522*/    OPC_RecordChild1, // #2 = $off
/* 29523*/    OPC_MoveChild1,
/* 29524*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 29527*/    OPC_MoveParent,
/* 29528*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 29530*/    OPC_SwitchType /*2 cases */, 45, MVT::i32,// ->29578
/* 29533*/     OPC_MoveParent,
/* 29534*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29536*/     OPC_CheckPredicate, 20, // Predicate_load
/* 29538*/     OPC_SwitchType /*2 cases */, 17, MVT::f32,// ->29558
/* 29541*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29543*/      OPC_EmitMergeInputChains1_0,
/* 29544*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29547*/      OPC_EmitConvertToTarget, 2,
/* 29549*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29558*/     /*SwitchType*/ 17, MVT::f64,// ->29577
/* 29560*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29562*/      OPC_EmitMergeInputChains1_0,
/* 29563*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29566*/      OPC_EmitConvertToTarget, 2,
/* 29568*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29577*/     0, // EndSwitchType
/* 29578*/    /*SwitchType*/ 45, MVT::i64,// ->29625
/* 29580*/     OPC_MoveParent,
/* 29581*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29583*/     OPC_CheckPredicate, 20, // Predicate_load
/* 29585*/     OPC_SwitchType /*2 cases */, 17, MVT::f32,// ->29605
/* 29588*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29590*/      OPC_EmitMergeInputChains1_0,
/* 29591*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29594*/      OPC_EmitConvertToTarget, 2,
/* 29596*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 29605*/     /*SwitchType*/ 17, MVT::f64,// ->29624
/* 29607*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29609*/      OPC_EmitMergeInputChains1_0,
/* 29610*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29613*/      OPC_EmitConvertToTarget, 2,
/* 29615*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[f64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 29624*/     0, // EndSwitchType
/* 29625*/    0, // EndSwitchType
/* 29626*/   /*SwitchOpcode*/ 125, TARGET_VAL(WebAssemblyISD::Wrapper),// ->29754
/* 29629*/    OPC_RecordChild0, // #1 = $off
/* 29630*/    OPC_MoveChild0,
/* 29631*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 29634*/    OPC_MoveParent,
/* 29635*/    OPC_MoveParent,
/* 29636*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29638*/    OPC_CheckPredicate, 20, // Predicate_load
/* 29640*/    OPC_SwitchType /*2 cases */, 54, MVT::f32,// ->29697
/* 29643*/     OPC_Scope, 25, /*->29670*/ // 2 children in Scope
/* 29645*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 29647*/      OPC_EmitMergeInputChains1_0,
/* 29648*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29651*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29654*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 29661*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 29670*/     /*Scope*/ 25, /*->29696*/
/* 29671*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 29673*/      OPC_EmitMergeInputChains1_0,
/* 29674*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29677*/      OPC_EmitInteger, MVT::i64, 0, 
/* 29680*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 29687*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 29696*/     0, /*End of Scope*/
/* 29697*/    /*SwitchType*/ 54, MVT::f64,// ->29753
/* 29699*/     OPC_Scope, 25, /*->29726*/ // 2 children in Scope
/* 29701*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 29703*/      OPC_EmitMergeInputChains1_0,
/* 29704*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29707*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29710*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 29717*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 29726*/     /*Scope*/ 25, /*->29752*/
/* 29727*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 29729*/      OPC_EmitMergeInputChains1_0,
/* 29730*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29733*/      OPC_EmitInteger, MVT::i64, 0, 
/* 29736*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 29743*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 29752*/     0, /*End of Scope*/
/* 29753*/    0, // EndSwitchType
/* 29754*/   0, // EndSwitchOpcode
/* 29755*/  /*Scope*/ 106|128,1/*234*/, /*->29991*/
/* 29757*/   OPC_RecordChild1, // #1 = $off
/* 29758*/   OPC_Scope, 3|128,1/*131*/, /*->29892*/ // 3 children in Scope
/* 29761*/    OPC_MoveChild1,
/* 29762*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 29765*/    OPC_MoveParent,
/* 29766*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29768*/    OPC_CheckPredicate, 20, // Predicate_load
/* 29770*/    OPC_SwitchType /*2 cases */, 58, MVT::f32,// ->29831
/* 29773*/     OPC_Scope, 27, /*->29802*/ // 2 children in Scope
/* 29775*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29777*/      OPC_EmitMergeInputChains1_0,
/* 29778*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29781*/      OPC_EmitConvertToTarget, 1,
/* 29783*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29786*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29793*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[f32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 29802*/     /*Scope*/ 27, /*->29830*/
/* 29803*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29805*/      OPC_EmitMergeInputChains1_0,
/* 29806*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29809*/      OPC_EmitConvertToTarget, 1,
/* 29811*/      OPC_EmitInteger, MVT::i64, 0, 
/* 29814*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 29821*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[f32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 29830*/     0, /*End of Scope*/
/* 29831*/    /*SwitchType*/ 58, MVT::f64,// ->29891
/* 29833*/     OPC_Scope, 27, /*->29862*/ // 2 children in Scope
/* 29835*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29837*/      OPC_EmitMergeInputChains1_0,
/* 29838*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29841*/      OPC_EmitConvertToTarget, 1,
/* 29843*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29846*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29853*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[f64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 29862*/     /*Scope*/ 27, /*->29890*/
/* 29863*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29865*/      OPC_EmitMergeInputChains1_0,
/* 29866*/      OPC_EmitInteger, MVT::i32, 0, 
/* 29869*/      OPC_EmitConvertToTarget, 1,
/* 29871*/      OPC_EmitInteger, MVT::i64, 0, 
/* 29874*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 29881*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::f64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[f64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 29890*/     0, /*End of Scope*/
/* 29891*/    0, // EndSwitchType
/* 29892*/   /*Scope*/ 48, /*->29941*/
/* 29893*/    OPC_CheckChild1Type, MVT::i32,
/* 29895*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29897*/    OPC_CheckPredicate, 20, // Predicate_load
/* 29899*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->29920
/* 29902*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29904*/     OPC_EmitMergeInputChains1_0,
/* 29905*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29908*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29911*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 29920*/    /*SwitchType*/ 18, MVT::f64,// ->29940
/* 29922*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 29924*/     OPC_EmitMergeInputChains1_0,
/* 29925*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29928*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29931*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 29940*/    0, // EndSwitchType
/* 29941*/   /*Scope*/ 48, /*->29990*/
/* 29942*/    OPC_CheckChild1Type, MVT::i64,
/* 29944*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 29946*/    OPC_CheckPredicate, 20, // Predicate_load
/* 29948*/    OPC_SwitchType /*2 cases */, 18, MVT::f32,// ->29969
/* 29951*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29953*/     OPC_EmitMergeInputChains1_0,
/* 29954*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29957*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29960*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29969*/    /*SwitchType*/ 18, MVT::f64,// ->29989
/* 29971*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 29973*/     OPC_EmitMergeInputChains1_0,
/* 29974*/     OPC_EmitInteger, MVT::i32, 0, 
/* 29977*/     OPC_EmitInteger, MVT::i64, 0, 
/* 29980*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 29989*/    0, // EndSwitchType
/* 29990*/   0, /*End of Scope*/
/* 29991*/  /*Scope*/ 127|128,15/*2047*/, /*->32040*/
/* 29993*/   OPC_MoveChild1,
/* 29994*/   OPC_SwitchOpcode /*3 cases */, 109|128,4/*621*/, TARGET_VAL(ISD::ADD),// ->30620
/* 29999*/    OPC_RecordChild0, // #1 = $addr
/* 30000*/    OPC_RecordChild1, // #2 = $off
/* 30001*/    OPC_MoveChild1,
/* 30002*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 30005*/    OPC_MoveParent,
/* 30006*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 30008*/    OPC_SwitchType /*2 cases */, 46|128,2/*302*/, MVT::i32,// ->30314
/* 30012*/     OPC_MoveParent,
/* 30013*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 30015*/     OPC_Scope, 80, /*->30097*/ // 10 children in Scope
/* 30017*/      OPC_CheckPredicate, 20, // Predicate_load
/* 30019*/      OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->30039
/* 30022*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30024*/       OPC_EmitMergeInputChains1_0,
/* 30025*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30028*/       OPC_EmitConvertToTarget, 2,
/* 30030*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v16i8] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30039*/      /*SwitchType*/ 17, MVT::v8i16,// ->30058
/* 30041*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30043*/       OPC_EmitMergeInputChains1_0,
/* 30044*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30047*/       OPC_EmitConvertToTarget, 2,
/* 30049*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30058*/      /*SwitchType*/ 17, MVT::v4i32,// ->30077
/* 30060*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30062*/       OPC_EmitMergeInputChains1_0,
/* 30063*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30066*/       OPC_EmitConvertToTarget, 2,
/* 30068*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30077*/      /*SwitchType*/ 17, MVT::v2i64,// ->30096
/* 30079*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30081*/       OPC_EmitMergeInputChains1_0,
/* 30082*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30085*/       OPC_EmitConvertToTarget, 2,
/* 30087*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30096*/      0, // EndSwitchType
/* 30097*/     /*Scope*/ 23, /*->30121*/
/* 30098*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30100*/      OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 30102*/      OPC_CheckType, MVT::v8i16,
/* 30104*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30106*/      OPC_EmitMergeInputChains1_0,
/* 30107*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30110*/      OPC_EmitConvertToTarget, 2,
/* 30112*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30121*/     /*Scope*/ 23, /*->30145*/
/* 30122*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30124*/      OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 30126*/      OPC_CheckType, MVT::v8i16,
/* 30128*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30130*/      OPC_EmitMergeInputChains1_0,
/* 30131*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30134*/      OPC_EmitConvertToTarget, 2,
/* 30136*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30145*/     /*Scope*/ 23, /*->30169*/
/* 30146*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30148*/      OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 30150*/      OPC_CheckType, MVT::v8i16,
/* 30152*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30154*/      OPC_EmitMergeInputChains1_0,
/* 30155*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30158*/      OPC_EmitConvertToTarget, 2,
/* 30160*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30169*/     /*Scope*/ 23, /*->30193*/
/* 30170*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30172*/      OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 30174*/      OPC_CheckType, MVT::v4i32,
/* 30176*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30178*/      OPC_EmitMergeInputChains1_0,
/* 30179*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30182*/      OPC_EmitConvertToTarget, 2,
/* 30184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30193*/     /*Scope*/ 23, /*->30217*/
/* 30194*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30196*/      OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 30198*/      OPC_CheckType, MVT::v4i32,
/* 30200*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30202*/      OPC_EmitMergeInputChains1_0,
/* 30203*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30206*/      OPC_EmitConvertToTarget, 2,
/* 30208*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30217*/     /*Scope*/ 23, /*->30241*/
/* 30218*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30220*/      OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 30222*/      OPC_CheckType, MVT::v4i32,
/* 30224*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30226*/      OPC_EmitMergeInputChains1_0,
/* 30227*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30230*/      OPC_EmitConvertToTarget, 2,
/* 30232*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30241*/     /*Scope*/ 23, /*->30265*/
/* 30242*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30244*/      OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 30246*/      OPC_CheckType, MVT::v2i64,
/* 30248*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30250*/      OPC_EmitMergeInputChains1_0,
/* 30251*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30254*/      OPC_EmitConvertToTarget, 2,
/* 30256*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30265*/     /*Scope*/ 23, /*->30289*/
/* 30266*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30268*/      OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 30270*/      OPC_CheckType, MVT::v2i64,
/* 30272*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30274*/      OPC_EmitMergeInputChains1_0,
/* 30275*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30278*/      OPC_EmitConvertToTarget, 2,
/* 30280*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30289*/     /*Scope*/ 23, /*->30313*/
/* 30290*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30292*/      OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 30294*/      OPC_CheckType, MVT::v2i64,
/* 30296*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30298*/      OPC_EmitMergeInputChains1_0,
/* 30299*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30302*/      OPC_EmitConvertToTarget, 2,
/* 30304*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30313*/     0, /*End of Scope*/
/* 30314*/    /*SwitchType*/ 46|128,2/*302*/, MVT::i64,// ->30619
/* 30317*/     OPC_MoveParent,
/* 30318*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 30320*/     OPC_Scope, 80, /*->30402*/ // 10 children in Scope
/* 30322*/      OPC_CheckPredicate, 20, // Predicate_load
/* 30324*/      OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->30344
/* 30327*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30329*/       OPC_EmitMergeInputChains1_0,
/* 30330*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30333*/       OPC_EmitConvertToTarget, 2,
/* 30335*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v16i8] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30344*/      /*SwitchType*/ 17, MVT::v8i16,// ->30363
/* 30346*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30348*/       OPC_EmitMergeInputChains1_0,
/* 30349*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30352*/       OPC_EmitConvertToTarget, 2,
/* 30354*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v8i16] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30363*/      /*SwitchType*/ 17, MVT::v4i32,// ->30382
/* 30365*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30367*/       OPC_EmitMergeInputChains1_0,
/* 30368*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30371*/       OPC_EmitConvertToTarget, 2,
/* 30373*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v4i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30382*/      /*SwitchType*/ 17, MVT::v2i64,// ->30401
/* 30384*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30386*/       OPC_EmitMergeInputChains1_0,
/* 30387*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30390*/       OPC_EmitConvertToTarget, 2,
/* 30392*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v2i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30401*/      0, // EndSwitchType
/* 30402*/     /*Scope*/ 23, /*->30426*/
/* 30403*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30405*/      OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 30407*/      OPC_CheckType, MVT::v8i16,
/* 30409*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30411*/      OPC_EmitMergeInputChains1_0,
/* 30412*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30415*/      OPC_EmitConvertToTarget, 2,
/* 30417*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30426*/     /*Scope*/ 23, /*->30450*/
/* 30427*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30429*/      OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 30431*/      OPC_CheckType, MVT::v8i16,
/* 30433*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30435*/      OPC_EmitMergeInputChains1_0,
/* 30436*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30439*/      OPC_EmitConvertToTarget, 2,
/* 30441*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30450*/     /*Scope*/ 23, /*->30474*/
/* 30451*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30453*/      OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 30455*/      OPC_CheckType, MVT::v8i16,
/* 30457*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30459*/      OPC_EmitMergeInputChains1_0,
/* 30460*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30463*/      OPC_EmitConvertToTarget, 2,
/* 30465*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30474*/     /*Scope*/ 23, /*->30498*/
/* 30475*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30477*/      OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 30479*/      OPC_CheckType, MVT::v4i32,
/* 30481*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30483*/      OPC_EmitMergeInputChains1_0,
/* 30484*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30487*/      OPC_EmitConvertToTarget, 2,
/* 30489*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30498*/     /*Scope*/ 23, /*->30522*/
/* 30499*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30501*/      OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 30503*/      OPC_CheckType, MVT::v4i32,
/* 30505*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30507*/      OPC_EmitMergeInputChains1_0,
/* 30508*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30511*/      OPC_EmitConvertToTarget, 2,
/* 30513*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30522*/     /*Scope*/ 23, /*->30546*/
/* 30523*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30525*/      OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 30527*/      OPC_CheckType, MVT::v4i32,
/* 30529*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30531*/      OPC_EmitMergeInputChains1_0,
/* 30532*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30535*/      OPC_EmitConvertToTarget, 2,
/* 30537*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30546*/     /*Scope*/ 23, /*->30570*/
/* 30547*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30549*/      OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 30551*/      OPC_CheckType, MVT::v2i64,
/* 30553*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30555*/      OPC_EmitMergeInputChains1_0,
/* 30556*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30559*/      OPC_EmitConvertToTarget, 2,
/* 30561*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30570*/     /*Scope*/ 23, /*->30594*/
/* 30571*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30573*/      OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 30575*/      OPC_CheckType, MVT::v2i64,
/* 30577*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30579*/      OPC_EmitMergeInputChains1_0,
/* 30580*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30583*/      OPC_EmitConvertToTarget, 2,
/* 30585*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30594*/     /*Scope*/ 23, /*->30618*/
/* 30595*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30597*/      OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 30599*/      OPC_CheckType, MVT::v2i64,
/* 30601*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30603*/      OPC_EmitMergeInputChains1_0,
/* 30604*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30607*/      OPC_EmitConvertToTarget, 2,
/* 30609*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30618*/     0, /*End of Scope*/
/* 30619*/    0, // EndSwitchType
/* 30620*/   /*SwitchOpcode*/ 109|128,4/*621*/, TARGET_VAL(ISD::OR),// ->31245
/* 30624*/    OPC_RecordChild0, // #1 = $addr
/* 30625*/    OPC_RecordChild1, // #2 = $off
/* 30626*/    OPC_MoveChild1,
/* 30627*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 30630*/    OPC_MoveParent,
/* 30631*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 30633*/    OPC_SwitchType /*2 cases */, 46|128,2/*302*/, MVT::i32,// ->30939
/* 30637*/     OPC_MoveParent,
/* 30638*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 30640*/     OPC_Scope, 80, /*->30722*/ // 10 children in Scope
/* 30642*/      OPC_CheckPredicate, 20, // Predicate_load
/* 30644*/      OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->30664
/* 30647*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30649*/       OPC_EmitMergeInputChains1_0,
/* 30650*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30653*/       OPC_EmitConvertToTarget, 2,
/* 30655*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v16i8] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30664*/      /*SwitchType*/ 17, MVT::v8i16,// ->30683
/* 30666*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30668*/       OPC_EmitMergeInputChains1_0,
/* 30669*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30672*/       OPC_EmitConvertToTarget, 2,
/* 30674*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v8i16] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30683*/      /*SwitchType*/ 17, MVT::v4i32,// ->30702
/* 30685*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30687*/       OPC_EmitMergeInputChains1_0,
/* 30688*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30691*/       OPC_EmitConvertToTarget, 2,
/* 30693*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v4i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30702*/      /*SwitchType*/ 17, MVT::v2i64,// ->30721
/* 30704*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30706*/       OPC_EmitMergeInputChains1_0,
/* 30707*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30710*/       OPC_EmitConvertToTarget, 2,
/* 30712*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v2i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30721*/      0, // EndSwitchType
/* 30722*/     /*Scope*/ 23, /*->30746*/
/* 30723*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30725*/      OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 30727*/      OPC_CheckType, MVT::v8i16,
/* 30729*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30731*/      OPC_EmitMergeInputChains1_0,
/* 30732*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30735*/      OPC_EmitConvertToTarget, 2,
/* 30737*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30746*/     /*Scope*/ 23, /*->30770*/
/* 30747*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30749*/      OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 30751*/      OPC_CheckType, MVT::v8i16,
/* 30753*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30755*/      OPC_EmitMergeInputChains1_0,
/* 30756*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30759*/      OPC_EmitConvertToTarget, 2,
/* 30761*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30770*/     /*Scope*/ 23, /*->30794*/
/* 30771*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30773*/      OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 30775*/      OPC_CheckType, MVT::v8i16,
/* 30777*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30779*/      OPC_EmitMergeInputChains1_0,
/* 30780*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30783*/      OPC_EmitConvertToTarget, 2,
/* 30785*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30794*/     /*Scope*/ 23, /*->30818*/
/* 30795*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30797*/      OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 30799*/      OPC_CheckType, MVT::v4i32,
/* 30801*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30803*/      OPC_EmitMergeInputChains1_0,
/* 30804*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30807*/      OPC_EmitConvertToTarget, 2,
/* 30809*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30818*/     /*Scope*/ 23, /*->30842*/
/* 30819*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30821*/      OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 30823*/      OPC_CheckType, MVT::v4i32,
/* 30825*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30827*/      OPC_EmitMergeInputChains1_0,
/* 30828*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30831*/      OPC_EmitConvertToTarget, 2,
/* 30833*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30842*/     /*Scope*/ 23, /*->30866*/
/* 30843*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30845*/      OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 30847*/      OPC_CheckType, MVT::v4i32,
/* 30849*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30851*/      OPC_EmitMergeInputChains1_0,
/* 30852*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30855*/      OPC_EmitConvertToTarget, 2,
/* 30857*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30866*/     /*Scope*/ 23, /*->30890*/
/* 30867*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 30869*/      OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 30871*/      OPC_CheckType, MVT::v2i64,
/* 30873*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30875*/      OPC_EmitMergeInputChains1_0,
/* 30876*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30879*/      OPC_EmitConvertToTarget, 2,
/* 30881*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30890*/     /*Scope*/ 23, /*->30914*/
/* 30891*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 30893*/      OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 30895*/      OPC_CheckType, MVT::v2i64,
/* 30897*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30899*/      OPC_EmitMergeInputChains1_0,
/* 30900*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30903*/      OPC_EmitConvertToTarget, 2,
/* 30905*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30914*/     /*Scope*/ 23, /*->30938*/
/* 30915*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 30917*/      OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 30919*/      OPC_CheckType, MVT::v2i64,
/* 30921*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 30923*/      OPC_EmitMergeInputChains1_0,
/* 30924*/      OPC_EmitInteger, MVT::i32, 0, 
/* 30927*/      OPC_EmitConvertToTarget, 2,
/* 30929*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30938*/     0, /*End of Scope*/
/* 30939*/    /*SwitchType*/ 46|128,2/*302*/, MVT::i64,// ->31244
/* 30942*/     OPC_MoveParent,
/* 30943*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 30945*/     OPC_Scope, 80, /*->31027*/ // 10 children in Scope
/* 30947*/      OPC_CheckPredicate, 20, // Predicate_load
/* 30949*/      OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->30969
/* 30952*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30954*/       OPC_EmitMergeInputChains1_0,
/* 30955*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30958*/       OPC_EmitConvertToTarget, 2,
/* 30960*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v16i8] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30969*/      /*SwitchType*/ 17, MVT::v8i16,// ->30988
/* 30971*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30973*/       OPC_EmitMergeInputChains1_0,
/* 30974*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30977*/       OPC_EmitConvertToTarget, 2,
/* 30979*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v8i16] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 30988*/      /*SwitchType*/ 17, MVT::v4i32,// ->31007
/* 30990*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 30992*/       OPC_EmitMergeInputChains1_0,
/* 30993*/       OPC_EmitInteger, MVT::i32, 0, 
/* 30996*/       OPC_EmitConvertToTarget, 2,
/* 30998*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v4i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31007*/      /*SwitchType*/ 17, MVT::v2i64,// ->31026
/* 31009*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31011*/       OPC_EmitMergeInputChains1_0,
/* 31012*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31015*/       OPC_EmitConvertToTarget, 2,
/* 31017*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (ld:{ *:[v2i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                 // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31026*/      0, // EndSwitchType
/* 31027*/     /*Scope*/ 23, /*->31051*/
/* 31028*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 31030*/      OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 31032*/      OPC_CheckType, MVT::v8i16,
/* 31034*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31036*/      OPC_EmitMergeInputChains1_0,
/* 31037*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31040*/      OPC_EmitConvertToTarget, 2,
/* 31042*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31051*/     /*Scope*/ 23, /*->31075*/
/* 31052*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 31054*/      OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 31056*/      OPC_CheckType, MVT::v8i16,
/* 31058*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31060*/      OPC_EmitMergeInputChains1_0,
/* 31061*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31064*/      OPC_EmitConvertToTarget, 2,
/* 31066*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31075*/     /*Scope*/ 23, /*->31099*/
/* 31076*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 31078*/      OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 31080*/      OPC_CheckType, MVT::v8i16,
/* 31082*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31084*/      OPC_EmitMergeInputChains1_0,
/* 31085*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31088*/      OPC_EmitConvertToTarget, 2,
/* 31090*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v8i16] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31099*/     /*Scope*/ 23, /*->31123*/
/* 31100*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 31102*/      OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 31104*/      OPC_CheckType, MVT::v4i32,
/* 31106*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31108*/      OPC_EmitMergeInputChains1_0,
/* 31109*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31112*/      OPC_EmitConvertToTarget, 2,
/* 31114*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31123*/     /*Scope*/ 23, /*->31147*/
/* 31124*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 31126*/      OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 31128*/      OPC_CheckType, MVT::v4i32,
/* 31130*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31132*/      OPC_EmitMergeInputChains1_0,
/* 31133*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31136*/      OPC_EmitConvertToTarget, 2,
/* 31138*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31147*/     /*Scope*/ 23, /*->31171*/
/* 31148*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 31150*/      OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 31152*/      OPC_CheckType, MVT::v4i32,
/* 31154*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31156*/      OPC_EmitMergeInputChains1_0,
/* 31157*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31160*/      OPC_EmitConvertToTarget, 2,
/* 31162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31171*/     /*Scope*/ 23, /*->31195*/
/* 31172*/      OPC_CheckPredicate, 21, // Predicate_sextload
/* 31174*/      OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 31176*/      OPC_CheckType, MVT::v2i64,
/* 31178*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31180*/      OPC_EmitMergeInputChains1_0,
/* 31181*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31184*/      OPC_EmitConvertToTarget, 2,
/* 31186*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31195*/     /*Scope*/ 23, /*->31219*/
/* 31196*/      OPC_CheckPredicate, 22, // Predicate_zextload
/* 31198*/      OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 31200*/      OPC_CheckType, MVT::v2i64,
/* 31202*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31204*/      OPC_EmitMergeInputChains1_0,
/* 31205*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31208*/      OPC_EmitConvertToTarget, 2,
/* 31210*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31219*/     /*Scope*/ 23, /*->31243*/
/* 31220*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 31222*/      OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 31224*/      OPC_CheckType, MVT::v2i64,
/* 31226*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 31228*/      OPC_EmitMergeInputChains1_0,
/* 31229*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31232*/      OPC_EmitConvertToTarget, 2,
/* 31234*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 11
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 31243*/     0, /*End of Scope*/
/* 31244*/    0, // EndSwitchType
/* 31245*/   /*SwitchOpcode*/ 22|128,6/*790*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->32039
/* 31249*/    OPC_RecordChild0, // #1 = $off
/* 31250*/    OPC_MoveChild0,
/* 31251*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 31254*/    OPC_MoveParent,
/* 31255*/    OPC_MoveParent,
/* 31256*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 31258*/    OPC_Scope, 100|128,1/*228*/, /*->31489*/ // 10 children in Scope
/* 31261*/     OPC_CheckPredicate, 20, // Predicate_load
/* 31263*/     OPC_SwitchType /*4 cases */, 54, MVT::v16i8,// ->31320
/* 31266*/      OPC_Scope, 25, /*->31293*/ // 2 children in Scope
/* 31268*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31270*/       OPC_EmitMergeInputChains1_0,
/* 31271*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31274*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31277*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31284*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31293*/      /*Scope*/ 25, /*->31319*/
/* 31294*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31296*/       OPC_EmitMergeInputChains1_0,
/* 31297*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31300*/       OPC_EmitInteger, MVT::i64, 0, 
/* 31303*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31310*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31319*/      0, /*End of Scope*/
/* 31320*/     /*SwitchType*/ 54, MVT::v8i16,// ->31376
/* 31322*/      OPC_Scope, 25, /*->31349*/ // 2 children in Scope
/* 31324*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31326*/       OPC_EmitMergeInputChains1_0,
/* 31327*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31330*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31333*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31340*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31349*/      /*Scope*/ 25, /*->31375*/
/* 31350*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31352*/       OPC_EmitMergeInputChains1_0,
/* 31353*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31356*/       OPC_EmitInteger, MVT::i64, 0, 
/* 31359*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31366*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31375*/      0, /*End of Scope*/
/* 31376*/     /*SwitchType*/ 54, MVT::v4i32,// ->31432
/* 31378*/      OPC_Scope, 25, /*->31405*/ // 2 children in Scope
/* 31380*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31382*/       OPC_EmitMergeInputChains1_0,
/* 31383*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31386*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31389*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31396*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31405*/      /*Scope*/ 25, /*->31431*/
/* 31406*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31408*/       OPC_EmitMergeInputChains1_0,
/* 31409*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31412*/       OPC_EmitInteger, MVT::i64, 0, 
/* 31415*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31422*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31431*/      0, /*End of Scope*/
/* 31432*/     /*SwitchType*/ 54, MVT::v2i64,// ->31488
/* 31434*/      OPC_Scope, 25, /*->31461*/ // 2 children in Scope
/* 31436*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31438*/       OPC_EmitMergeInputChains1_0,
/* 31439*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31442*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31445*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31452*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31461*/      /*Scope*/ 25, /*->31487*/
/* 31462*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31464*/       OPC_EmitMergeInputChains1_0,
/* 31465*/       OPC_EmitInteger, MVT::i32, 0, 
/* 31468*/       OPC_EmitInteger, MVT::i64, 0, 
/* 31471*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31478*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                 // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31487*/      0, /*End of Scope*/
/* 31488*/     0, // EndSwitchType
/* 31489*/    /*Scope*/ 60, /*->31550*/
/* 31490*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 31492*/     OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 31494*/     OPC_CheckType, MVT::v8i16,
/* 31496*/     OPC_Scope, 25, /*->31523*/ // 2 children in Scope
/* 31498*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31500*/      OPC_EmitMergeInputChains1_0,
/* 31501*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31504*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31507*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 10
                // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31523*/     /*Scope*/ 25, /*->31549*/
/* 31524*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31526*/      OPC_EmitMergeInputChains1_0,
/* 31527*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31530*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31533*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 10
                // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31549*/     0, /*End of Scope*/
/* 31550*/    /*Scope*/ 60, /*->31611*/
/* 31551*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 31553*/     OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 31555*/     OPC_CheckType, MVT::v8i16,
/* 31557*/     OPC_Scope, 25, /*->31584*/ // 2 children in Scope
/* 31559*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31561*/      OPC_EmitMergeInputChains1_0,
/* 31562*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31565*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31568*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31575*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31584*/     /*Scope*/ 25, /*->31610*/
/* 31585*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31587*/      OPC_EmitMergeInputChains1_0,
/* 31588*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31591*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31594*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31601*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31610*/     0, /*End of Scope*/
/* 31611*/    /*Scope*/ 60, /*->31672*/
/* 31612*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 31614*/     OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 31616*/     OPC_CheckType, MVT::v8i16,
/* 31618*/     OPC_Scope, 25, /*->31645*/ // 2 children in Scope
/* 31620*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31622*/      OPC_EmitMergeInputChains1_0,
/* 31623*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31626*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31629*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31636*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31645*/     /*Scope*/ 25, /*->31671*/
/* 31646*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31648*/      OPC_EmitMergeInputChains1_0,
/* 31649*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31652*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31655*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31671*/     0, /*End of Scope*/
/* 31672*/    /*Scope*/ 60, /*->31733*/
/* 31673*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 31675*/     OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 31677*/     OPC_CheckType, MVT::v4i32,
/* 31679*/     OPC_Scope, 25, /*->31706*/ // 2 children in Scope
/* 31681*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31683*/      OPC_EmitMergeInputChains1_0,
/* 31684*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31687*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31690*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31697*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 10
                // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31706*/     /*Scope*/ 25, /*->31732*/
/* 31707*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31709*/      OPC_EmitMergeInputChains1_0,
/* 31710*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31713*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31716*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31723*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 10
                // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31732*/     0, /*End of Scope*/
/* 31733*/    /*Scope*/ 60, /*->31794*/
/* 31734*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 31736*/     OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 31738*/     OPC_CheckType, MVT::v4i32,
/* 31740*/     OPC_Scope, 25, /*->31767*/ // 2 children in Scope
/* 31742*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31744*/      OPC_EmitMergeInputChains1_0,
/* 31745*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31748*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31751*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31758*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31767*/     /*Scope*/ 25, /*->31793*/
/* 31768*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31770*/      OPC_EmitMergeInputChains1_0,
/* 31771*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31774*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31777*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31784*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31793*/     0, /*End of Scope*/
/* 31794*/    /*Scope*/ 60, /*->31855*/
/* 31795*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 31797*/     OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 31799*/     OPC_CheckType, MVT::v4i32,
/* 31801*/     OPC_Scope, 25, /*->31828*/ // 2 children in Scope
/* 31803*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31805*/      OPC_EmitMergeInputChains1_0,
/* 31806*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31809*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31812*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31819*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31828*/     /*Scope*/ 25, /*->31854*/
/* 31829*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31831*/      OPC_EmitMergeInputChains1_0,
/* 31832*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31835*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31838*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31854*/     0, /*End of Scope*/
/* 31855*/    /*Scope*/ 60, /*->31916*/
/* 31856*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 31858*/     OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 31860*/     OPC_CheckType, MVT::v2i64,
/* 31862*/     OPC_Scope, 25, /*->31889*/ // 2 children in Scope
/* 31864*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31866*/      OPC_EmitMergeInputChains1_0,
/* 31867*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31870*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31873*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31880*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 10
                // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31889*/     /*Scope*/ 25, /*->31915*/
/* 31890*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31892*/      OPC_EmitMergeInputChains1_0,
/* 31893*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31896*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31899*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 10
                // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31915*/     0, /*End of Scope*/
/* 31916*/    /*Scope*/ 60, /*->31977*/
/* 31917*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 31919*/     OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 31921*/     OPC_CheckType, MVT::v2i64,
/* 31923*/     OPC_Scope, 25, /*->31950*/ // 2 children in Scope
/* 31925*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31927*/      OPC_EmitMergeInputChains1_0,
/* 31928*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31931*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31934*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 31941*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 31950*/     /*Scope*/ 25, /*->31976*/
/* 31951*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31953*/      OPC_EmitMergeInputChains1_0,
/* 31954*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31957*/      OPC_EmitInteger, MVT::i64, 0, 
/* 31960*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 31967*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 31976*/     0, /*End of Scope*/
/* 31977*/    /*Scope*/ 60, /*->32038*/
/* 31978*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 31980*/     OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 31982*/     OPC_CheckType, MVT::v2i64,
/* 31984*/     OPC_Scope, 25, /*->32011*/ // 2 children in Scope
/* 31986*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 31988*/      OPC_EmitMergeInputChains1_0,
/* 31989*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31992*/      OPC_EmitInteger, MVT::i32, 0, 
/* 31995*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32002*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32011*/     /*Scope*/ 25, /*->32037*/
/* 32012*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 32014*/      OPC_EmitMergeInputChains1_0,
/* 32015*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32018*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32021*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 32028*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 10
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32037*/     0, /*End of Scope*/
/* 32038*/    0, /*End of Scope*/
/* 32039*/   0, // EndSwitchOpcode
/* 32040*/  /*Scope*/ 73|128,11/*1481*/, /*->33523*/
/* 32042*/   OPC_RecordChild1, // #1 = $off
/* 32043*/   OPC_Scope, 72|128,6/*840*/, /*->32886*/ // 3 children in Scope
/* 32046*/    OPC_MoveChild1,
/* 32047*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 32050*/    OPC_MoveParent,
/* 32051*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 32053*/    OPC_Scope, 116|128,1/*244*/, /*->32300*/ // 10 children in Scope
/* 32056*/     OPC_CheckPredicate, 20, // Predicate_load
/* 32058*/     OPC_SwitchType /*4 cases */, 58, MVT::v16i8,// ->32119
/* 32061*/      OPC_Scope, 27, /*->32090*/ // 2 children in Scope
/* 32063*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32065*/       OPC_EmitMergeInputChains1_0,
/* 32066*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32069*/       OPC_EmitConvertToTarget, 1,
/* 32071*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32074*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32081*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v16i8] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32090*/      /*Scope*/ 27, /*->32118*/
/* 32091*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32093*/       OPC_EmitMergeInputChains1_0,
/* 32094*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32097*/       OPC_EmitConvertToTarget, 1,
/* 32099*/       OPC_EmitInteger, MVT::i64, 0, 
/* 32102*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32109*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v16i8] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32118*/      0, /*End of Scope*/
/* 32119*/     /*SwitchType*/ 58, MVT::v8i16,// ->32179
/* 32121*/      OPC_Scope, 27, /*->32150*/ // 2 children in Scope
/* 32123*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32125*/       OPC_EmitMergeInputChains1_0,
/* 32126*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32129*/       OPC_EmitConvertToTarget, 1,
/* 32131*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32134*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32141*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32150*/      /*Scope*/ 27, /*->32178*/
/* 32151*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32153*/       OPC_EmitMergeInputChains1_0,
/* 32154*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32157*/       OPC_EmitConvertToTarget, 1,
/* 32159*/       OPC_EmitInteger, MVT::i64, 0, 
/* 32162*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32169*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32178*/      0, /*End of Scope*/
/* 32179*/     /*SwitchType*/ 58, MVT::v4i32,// ->32239
/* 32181*/      OPC_Scope, 27, /*->32210*/ // 2 children in Scope
/* 32183*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32185*/       OPC_EmitMergeInputChains1_0,
/* 32186*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32189*/       OPC_EmitConvertToTarget, 1,
/* 32191*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32194*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32201*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32210*/      /*Scope*/ 27, /*->32238*/
/* 32211*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32213*/       OPC_EmitMergeInputChains1_0,
/* 32214*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32217*/       OPC_EmitConvertToTarget, 1,
/* 32219*/       OPC_EmitInteger, MVT::i64, 0, 
/* 32222*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32229*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32238*/      0, /*End of Scope*/
/* 32239*/     /*SwitchType*/ 58, MVT::v2i64,// ->32299
/* 32241*/      OPC_Scope, 27, /*->32270*/ // 2 children in Scope
/* 32243*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32245*/       OPC_EmitMergeInputChains1_0,
/* 32246*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32249*/       OPC_EmitConvertToTarget, 1,
/* 32251*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32254*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32261*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32270*/      /*Scope*/ 27, /*->32298*/
/* 32271*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32273*/       OPC_EmitMergeInputChains1_0,
/* 32274*/       OPC_EmitInteger, MVT::i32, 0, 
/* 32277*/       OPC_EmitConvertToTarget, 1,
/* 32279*/       OPC_EmitInteger, MVT::i64, 0, 
/* 32282*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32289*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                 // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32298*/      0, /*End of Scope*/
/* 32299*/     0, // EndSwitchType
/* 32300*/    /*Scope*/ 64, /*->32365*/
/* 32301*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 32303*/     OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 32305*/     OPC_CheckType, MVT::v8i16,
/* 32307*/     OPC_Scope, 27, /*->32336*/ // 2 children in Scope
/* 32309*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32311*/      OPC_EmitMergeInputChains1_0,
/* 32312*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32315*/      OPC_EmitConvertToTarget, 1,
/* 32317*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32320*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32327*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 7
                // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32336*/     /*Scope*/ 27, /*->32364*/
/* 32337*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32339*/      OPC_EmitMergeInputChains1_0,
/* 32340*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32343*/      OPC_EmitConvertToTarget, 1,
/* 32345*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32348*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32355*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 7
                // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32364*/     0, /*End of Scope*/
/* 32365*/    /*Scope*/ 64, /*->32430*/
/* 32366*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 32368*/     OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 32370*/     OPC_CheckType, MVT::v8i16,
/* 32372*/     OPC_Scope, 27, /*->32401*/ // 2 children in Scope
/* 32374*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32376*/      OPC_EmitMergeInputChains1_0,
/* 32377*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32380*/      OPC_EmitConvertToTarget, 1,
/* 32382*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32385*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32392*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32401*/     /*Scope*/ 27, /*->32429*/
/* 32402*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32404*/      OPC_EmitMergeInputChains1_0,
/* 32405*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32408*/      OPC_EmitConvertToTarget, 1,
/* 32410*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32413*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32420*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32429*/     0, /*End of Scope*/
/* 32430*/    /*Scope*/ 64, /*->32495*/
/* 32431*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 32433*/     OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 32435*/     OPC_CheckType, MVT::v8i16,
/* 32437*/     OPC_Scope, 27, /*->32466*/ // 2 children in Scope
/* 32439*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32441*/      OPC_EmitMergeInputChains1_0,
/* 32442*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32445*/      OPC_EmitConvertToTarget, 1,
/* 32447*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32450*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32457*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32466*/     /*Scope*/ 27, /*->32494*/
/* 32467*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32469*/      OPC_EmitMergeInputChains1_0,
/* 32470*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32473*/      OPC_EmitConvertToTarget, 1,
/* 32475*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32478*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32494*/     0, /*End of Scope*/
/* 32495*/    /*Scope*/ 64, /*->32560*/
/* 32496*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 32498*/     OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 32500*/     OPC_CheckType, MVT::v4i32,
/* 32502*/     OPC_Scope, 27, /*->32531*/ // 2 children in Scope
/* 32504*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32506*/      OPC_EmitMergeInputChains1_0,
/* 32507*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32510*/      OPC_EmitConvertToTarget, 1,
/* 32512*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32515*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32522*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 7
                // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32531*/     /*Scope*/ 27, /*->32559*/
/* 32532*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32534*/      OPC_EmitMergeInputChains1_0,
/* 32535*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32538*/      OPC_EmitConvertToTarget, 1,
/* 32540*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32543*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32550*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 7
                // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32559*/     0, /*End of Scope*/
/* 32560*/    /*Scope*/ 64, /*->32625*/
/* 32561*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 32563*/     OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 32565*/     OPC_CheckType, MVT::v4i32,
/* 32567*/     OPC_Scope, 27, /*->32596*/ // 2 children in Scope
/* 32569*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32571*/      OPC_EmitMergeInputChains1_0,
/* 32572*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32575*/      OPC_EmitConvertToTarget, 1,
/* 32577*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32580*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32587*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32596*/     /*Scope*/ 27, /*->32624*/
/* 32597*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32599*/      OPC_EmitMergeInputChains1_0,
/* 32600*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32603*/      OPC_EmitConvertToTarget, 1,
/* 32605*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32608*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32615*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32624*/     0, /*End of Scope*/
/* 32625*/    /*Scope*/ 64, /*->32690*/
/* 32626*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 32628*/     OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 32630*/     OPC_CheckType, MVT::v4i32,
/* 32632*/     OPC_Scope, 27, /*->32661*/ // 2 children in Scope
/* 32634*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32636*/      OPC_EmitMergeInputChains1_0,
/* 32637*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32640*/      OPC_EmitConvertToTarget, 1,
/* 32642*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32645*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32652*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32661*/     /*Scope*/ 27, /*->32689*/
/* 32662*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32664*/      OPC_EmitMergeInputChains1_0,
/* 32665*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32668*/      OPC_EmitConvertToTarget, 1,
/* 32670*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32673*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32680*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32689*/     0, /*End of Scope*/
/* 32690*/    /*Scope*/ 64, /*->32755*/
/* 32691*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 32693*/     OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 32695*/     OPC_CheckType, MVT::v2i64,
/* 32697*/     OPC_Scope, 27, /*->32726*/ // 2 children in Scope
/* 32699*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32701*/      OPC_EmitMergeInputChains1_0,
/* 32702*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32705*/      OPC_EmitConvertToTarget, 1,
/* 32707*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32710*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32717*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 7
                // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32726*/     /*Scope*/ 27, /*->32754*/
/* 32727*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32729*/      OPC_EmitMergeInputChains1_0,
/* 32730*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32733*/      OPC_EmitConvertToTarget, 1,
/* 32735*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32738*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32745*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 7
                // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32754*/     0, /*End of Scope*/
/* 32755*/    /*Scope*/ 64, /*->32820*/
/* 32756*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 32758*/     OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 32760*/     OPC_CheckType, MVT::v2i64,
/* 32762*/     OPC_Scope, 27, /*->32791*/ // 2 children in Scope
/* 32764*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32766*/      OPC_EmitMergeInputChains1_0,
/* 32767*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32770*/      OPC_EmitConvertToTarget, 1,
/* 32772*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32775*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32782*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32791*/     /*Scope*/ 27, /*->32819*/
/* 32792*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32794*/      OPC_EmitMergeInputChains1_0,
/* 32795*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32798*/      OPC_EmitConvertToTarget, 1,
/* 32800*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32803*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32810*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32819*/     0, /*End of Scope*/
/* 32820*/    /*Scope*/ 64, /*->32885*/
/* 32821*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 32823*/     OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 32825*/     OPC_CheckType, MVT::v2i64,
/* 32827*/     OPC_Scope, 27, /*->32856*/ // 2 children in Scope
/* 32829*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32831*/      OPC_EmitMergeInputChains1_0,
/* 32832*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32835*/      OPC_EmitConvertToTarget, 1,
/* 32837*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32840*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 32847*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32856*/     /*Scope*/ 27, /*->32884*/
/* 32857*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 32859*/      OPC_EmitMergeInputChains1_0,
/* 32860*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32863*/      OPC_EmitConvertToTarget, 1,
/* 32865*/      OPC_EmitInteger, MVT::i64, 0, 
/* 32868*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 32875*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 7
                // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 32884*/     0, /*End of Scope*/
/* 32885*/    0, /*End of Scope*/
/* 32886*/   /*Scope*/ 60|128,2/*316*/, /*->33204*/
/* 32888*/    OPC_CheckChild1Type, MVT::i32,
/* 32890*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 32892*/    OPC_Scope, 84, /*->32978*/ // 10 children in Scope
/* 32894*/     OPC_CheckPredicate, 20, // Predicate_load
/* 32896*/     OPC_SwitchType /*4 cases */, 18, MVT::v16i8,// ->32917
/* 32899*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32901*/      OPC_EmitMergeInputChains1_0,
/* 32902*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32905*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32908*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v16i8] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 32917*/     /*SwitchType*/ 18, MVT::v8i16,// ->32937
/* 32919*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32921*/      OPC_EmitMergeInputChains1_0,
/* 32922*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32925*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32928*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v8i16] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 32937*/     /*SwitchType*/ 18, MVT::v4i32,// ->32957
/* 32939*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32941*/      OPC_EmitMergeInputChains1_0,
/* 32942*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32945*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32948*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v4i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 32957*/     /*SwitchType*/ 18, MVT::v2i64,// ->32977
/* 32959*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32961*/      OPC_EmitMergeInputChains1_0,
/* 32962*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32965*/      OPC_EmitInteger, MVT::i32, 0, 
/* 32968*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v2i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 32977*/     0, // EndSwitchType
/* 32978*/    /*Scope*/ 24, /*->33003*/
/* 32979*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 32981*/     OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 32983*/     OPC_CheckType, MVT::v8i16,
/* 32985*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 32987*/     OPC_EmitMergeInputChains1_0,
/* 32988*/     OPC_EmitInteger, MVT::i32, 0, 
/* 32991*/     OPC_EmitInteger, MVT::i32, 0, 
/* 32994*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v8i16] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 4
               // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33003*/    /*Scope*/ 24, /*->33028*/
/* 33004*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 33006*/     OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 33008*/     OPC_CheckType, MVT::v8i16,
/* 33010*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33012*/     OPC_EmitMergeInputChains1_0,
/* 33013*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33016*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33019*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v8i16] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33028*/    /*Scope*/ 24, /*->33053*/
/* 33029*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 33031*/     OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 33033*/     OPC_CheckType, MVT::v8i16,
/* 33035*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33037*/     OPC_EmitMergeInputChains1_0,
/* 33038*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33041*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33044*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v8i16] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33053*/    /*Scope*/ 24, /*->33078*/
/* 33054*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 33056*/     OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 33058*/     OPC_CheckType, MVT::v4i32,
/* 33060*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33062*/     OPC_EmitMergeInputChains1_0,
/* 33063*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33066*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33069*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 4
               // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33078*/    /*Scope*/ 24, /*->33103*/
/* 33079*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 33081*/     OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 33083*/     OPC_CheckType, MVT::v4i32,
/* 33085*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33087*/     OPC_EmitMergeInputChains1_0,
/* 33088*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33091*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33094*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33103*/    /*Scope*/ 24, /*->33128*/
/* 33104*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 33106*/     OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 33108*/     OPC_CheckType, MVT::v4i32,
/* 33110*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33112*/     OPC_EmitMergeInputChains1_0,
/* 33113*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33116*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33119*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33128*/    /*Scope*/ 24, /*->33153*/
/* 33129*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 33131*/     OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 33133*/     OPC_CheckType, MVT::v2i64,
/* 33135*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33137*/     OPC_EmitMergeInputChains1_0,
/* 33138*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33141*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33144*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 4
               // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33153*/    /*Scope*/ 24, /*->33178*/
/* 33154*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 33156*/     OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 33158*/     OPC_CheckType, MVT::v2i64,
/* 33160*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33162*/     OPC_EmitMergeInputChains1_0,
/* 33163*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33166*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33169*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33178*/    /*Scope*/ 24, /*->33203*/
/* 33179*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 33181*/     OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 33183*/     OPC_CheckType, MVT::v2i64,
/* 33185*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33187*/     OPC_EmitMergeInputChains1_0,
/* 33188*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33191*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33194*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33203*/    0, /*End of Scope*/
/* 33204*/   /*Scope*/ 60|128,2/*316*/, /*->33522*/
/* 33206*/    OPC_CheckChild1Type, MVT::i64,
/* 33208*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33210*/    OPC_Scope, 84, /*->33296*/ // 10 children in Scope
/* 33212*/     OPC_CheckPredicate, 20, // Predicate_load
/* 33214*/     OPC_SwitchType /*4 cases */, 18, MVT::v16i8,// ->33235
/* 33217*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33219*/      OPC_EmitMergeInputChains1_0,
/* 33220*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33223*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33226*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v16i8] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33235*/     /*SwitchType*/ 18, MVT::v8i16,// ->33255
/* 33237*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33239*/      OPC_EmitMergeInputChains1_0,
/* 33240*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33243*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v8i16] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33255*/     /*SwitchType*/ 18, MVT::v4i32,// ->33275
/* 33257*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33259*/      OPC_EmitMergeInputChains1_0,
/* 33260*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33263*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33266*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v4i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33275*/     /*SwitchType*/ 18, MVT::v2i64,// ->33295
/* 33277*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33279*/      OPC_EmitMergeInputChains1_0,
/* 33280*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33283*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33286*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (ld:{ *:[v2i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33295*/     0, // EndSwitchType
/* 33296*/    /*Scope*/ 24, /*->33321*/
/* 33297*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 33299*/     OPC_CheckPredicate, 24, // Predicate_sextloadvi8
/* 33301*/     OPC_CheckType, MVT::v8i16,
/* 33303*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33305*/     OPC_EmitMergeInputChains1_0,
/* 33306*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33309*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33312*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v8i16] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 4
               // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33321*/    /*Scope*/ 24, /*->33346*/
/* 33322*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 33324*/     OPC_CheckPredicate, 24, // Predicate_zextloadvi8
/* 33326*/     OPC_CheckType, MVT::v8i16,
/* 33328*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33330*/     OPC_EmitMergeInputChains1_0,
/* 33331*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33334*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33337*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v8i16] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33346*/    /*Scope*/ 24, /*->33371*/
/* 33347*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 33349*/     OPC_CheckPredicate, 24, // Predicate_extloadvi8
/* 33351*/     OPC_CheckType, MVT::v8i16,
/* 33353*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33355*/     OPC_EmitMergeInputChains1_0,
/* 33356*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33359*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33362*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v8i16] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33371*/    /*Scope*/ 24, /*->33396*/
/* 33372*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 33374*/     OPC_CheckPredicate, 25, // Predicate_sextloadvi16
/* 33376*/     OPC_CheckType, MVT::v4i32,
/* 33378*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33380*/     OPC_EmitMergeInputChains1_0,
/* 33381*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33384*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33387*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 4
               // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33396*/    /*Scope*/ 24, /*->33421*/
/* 33397*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 33399*/     OPC_CheckPredicate, 25, // Predicate_zextloadvi16
/* 33401*/     OPC_CheckType, MVT::v4i32,
/* 33403*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33405*/     OPC_EmitMergeInputChains1_0,
/* 33406*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33409*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33412*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33421*/    /*Scope*/ 24, /*->33446*/
/* 33422*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 33424*/     OPC_CheckPredicate, 25, // Predicate_extloadvi16
/* 33426*/     OPC_CheckType, MVT::v4i32,
/* 33428*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33430*/     OPC_EmitMergeInputChains1_0,
/* 33431*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33434*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33437*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33446*/    /*Scope*/ 24, /*->33471*/
/* 33447*/     OPC_CheckPredicate, 21, // Predicate_sextload
/* 33449*/     OPC_CheckPredicate, 26, // Predicate_sextloadvi32
/* 33451*/     OPC_CheckType, MVT::v2i64,
/* 33453*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33455*/     OPC_EmitMergeInputChains1_0,
/* 33456*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33459*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33462*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 4
               // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33471*/    /*Scope*/ 24, /*->33496*/
/* 33472*/     OPC_CheckPredicate, 22, // Predicate_zextload
/* 33474*/     OPC_CheckPredicate, 26, // Predicate_zextloadvi32
/* 33476*/     OPC_CheckType, MVT::v2i64,
/* 33478*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33480*/     OPC_EmitMergeInputChains1_0,
/* 33481*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33484*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33487*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33496*/    /*Scope*/ 24, /*->33521*/
/* 33497*/     OPC_CheckPredicate, 23, // Predicate_extload
/* 33499*/     OPC_CheckPredicate, 26, // Predicate_extloadvi32
/* 33501*/     OPC_CheckType, MVT::v2i64,
/* 33503*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33505*/     OPC_EmitMergeInputChains1_0,
/* 33506*/     OPC_EmitInteger, MVT::i32, 0, 
/* 33509*/     OPC_EmitInteger, MVT::i64, 0, 
/* 33512*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 4
               // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 33521*/    0, /*End of Scope*/
/* 33522*/   0, /*End of Scope*/
/* 33523*/  /*Scope*/ 91|128,2/*347*/, /*->33872*/
/* 33525*/   OPC_MoveChild1,
/* 33526*/   OPC_SwitchOpcode /*3 cases */, 105, TARGET_VAL(ISD::ADD),// ->33635
/* 33530*/    OPC_RecordChild0, // #1 = $addr
/* 33531*/    OPC_RecordChild1, // #2 = $off
/* 33532*/    OPC_MoveChild1,
/* 33533*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 33536*/    OPC_MoveParent,
/* 33537*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 33539*/    OPC_SwitchType /*2 cases */, 45, MVT::i32,// ->33587
/* 33542*/     OPC_MoveParent,
/* 33543*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33545*/     OPC_CheckPredicate, 20, // Predicate_load
/* 33547*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->33567
/* 33550*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33552*/      OPC_EmitMergeInputChains1_0,
/* 33553*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33556*/      OPC_EmitConvertToTarget, 2,
/* 33558*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 33567*/     /*SwitchType*/ 17, MVT::v2f64,// ->33586
/* 33569*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33571*/      OPC_EmitMergeInputChains1_0,
/* 33572*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33575*/      OPC_EmitConvertToTarget, 2,
/* 33577*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 33586*/     0, // EndSwitchType
/* 33587*/    /*SwitchType*/ 45, MVT::i64,// ->33634
/* 33589*/     OPC_MoveParent,
/* 33590*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33592*/     OPC_CheckPredicate, 20, // Predicate_load
/* 33594*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->33614
/* 33597*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33599*/      OPC_EmitMergeInputChains1_0,
/* 33600*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33603*/      OPC_EmitConvertToTarget, 2,
/* 33605*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4f32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 33614*/     /*SwitchType*/ 17, MVT::v2f64,// ->33633
/* 33616*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33618*/      OPC_EmitMergeInputChains1_0,
/* 33619*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33622*/      OPC_EmitConvertToTarget, 2,
/* 33624*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2f64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 33633*/     0, // EndSwitchType
/* 33634*/    0, // EndSwitchType
/* 33635*/   /*SwitchOpcode*/ 105, TARGET_VAL(ISD::OR),// ->33743
/* 33638*/    OPC_RecordChild0, // #1 = $addr
/* 33639*/    OPC_RecordChild1, // #2 = $off
/* 33640*/    OPC_MoveChild1,
/* 33641*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 33644*/    OPC_MoveParent,
/* 33645*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 33647*/    OPC_SwitchType /*2 cases */, 45, MVT::i32,// ->33695
/* 33650*/     OPC_MoveParent,
/* 33651*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33653*/     OPC_CheckPredicate, 20, // Predicate_load
/* 33655*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->33675
/* 33658*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33660*/      OPC_EmitMergeInputChains1_0,
/* 33661*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33664*/      OPC_EmitConvertToTarget, 2,
/* 33666*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4f32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 33675*/     /*SwitchType*/ 17, MVT::v2f64,// ->33694
/* 33677*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33679*/      OPC_EmitMergeInputChains1_0,
/* 33680*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33683*/      OPC_EmitConvertToTarget, 2,
/* 33685*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2f64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 33694*/     0, // EndSwitchType
/* 33695*/    /*SwitchType*/ 45, MVT::i64,// ->33742
/* 33697*/     OPC_MoveParent,
/* 33698*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33700*/     OPC_CheckPredicate, 20, // Predicate_load
/* 33702*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->33722
/* 33705*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33707*/      OPC_EmitMergeInputChains1_0,
/* 33708*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33711*/      OPC_EmitConvertToTarget, 2,
/* 33713*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v4f32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 33722*/     /*SwitchType*/ 17, MVT::v2f64,// ->33741
/* 33724*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33726*/      OPC_EmitMergeInputChains1_0,
/* 33727*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33730*/      OPC_EmitConvertToTarget, 2,
/* 33732*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (ld:{ *:[v2f64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 33741*/     0, // EndSwitchType
/* 33742*/    0, // EndSwitchType
/* 33743*/   /*SwitchOpcode*/ 125, TARGET_VAL(WebAssemblyISD::Wrapper),// ->33871
/* 33746*/    OPC_RecordChild0, // #1 = $off
/* 33747*/    OPC_MoveChild0,
/* 33748*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 33751*/    OPC_MoveParent,
/* 33752*/    OPC_MoveParent,
/* 33753*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33755*/    OPC_CheckPredicate, 20, // Predicate_load
/* 33757*/    OPC_SwitchType /*2 cases */, 54, MVT::v4f32,// ->33814
/* 33760*/     OPC_Scope, 25, /*->33787*/ // 2 children in Scope
/* 33762*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 33764*/      OPC_EmitMergeInputChains1_0,
/* 33765*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33768*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33771*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 33778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33787*/     /*Scope*/ 25, /*->33813*/
/* 33788*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 33790*/      OPC_EmitMergeInputChains1_0,
/* 33791*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33794*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33797*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 33804*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 33813*/     0, /*End of Scope*/
/* 33814*/    /*SwitchType*/ 54, MVT::v2f64,// ->33870
/* 33816*/     OPC_Scope, 25, /*->33843*/ // 2 children in Scope
/* 33818*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 33820*/      OPC_EmitMergeInputChains1_0,
/* 33821*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33824*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33827*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 33834*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33843*/     /*Scope*/ 25, /*->33869*/
/* 33844*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 33846*/      OPC_EmitMergeInputChains1_0,
/* 33847*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33850*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33853*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 33860*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (ld:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 33869*/     0, /*End of Scope*/
/* 33870*/    0, // EndSwitchType
/* 33871*/   0, // EndSwitchOpcode
/* 33872*/  /*Scope*/ 106|128,1/*234*/, /*->34108*/
/* 33874*/   OPC_RecordChild1, // #1 = $off
/* 33875*/   OPC_Scope, 3|128,1/*131*/, /*->34009*/ // 3 children in Scope
/* 33878*/    OPC_MoveChild1,
/* 33879*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 33882*/    OPC_MoveParent,
/* 33883*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 33885*/    OPC_CheckPredicate, 20, // Predicate_load
/* 33887*/    OPC_SwitchType /*2 cases */, 58, MVT::v4f32,// ->33948
/* 33890*/     OPC_Scope, 27, /*->33919*/ // 2 children in Scope
/* 33892*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33894*/      OPC_EmitMergeInputChains1_0,
/* 33895*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33898*/      OPC_EmitConvertToTarget, 1,
/* 33900*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33903*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33910*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4f32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33919*/     /*Scope*/ 27, /*->33947*/
/* 33920*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33922*/      OPC_EmitMergeInputChains1_0,
/* 33923*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33926*/      OPC_EmitConvertToTarget, 1,
/* 33928*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33931*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 33938*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v4f32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 33947*/     0, /*End of Scope*/
/* 33948*/    /*SwitchType*/ 58, MVT::v2f64,// ->34008
/* 33950*/     OPC_Scope, 27, /*->33979*/ // 2 children in Scope
/* 33952*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 33954*/      OPC_EmitMergeInputChains1_0,
/* 33955*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33958*/      OPC_EmitConvertToTarget, 1,
/* 33960*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33963*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33970*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2f64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33979*/     /*Scope*/ 27, /*->34007*/
/* 33980*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 33982*/      OPC_EmitMergeInputChains1_0,
/* 33983*/      OPC_EmitInteger, MVT::i32, 0, 
/* 33986*/      OPC_EmitConvertToTarget, 1,
/* 33988*/      OPC_EmitInteger, MVT::i64, 0, 
/* 33991*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 33998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (ld:{ *:[v2f64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 34007*/     0, /*End of Scope*/
/* 34008*/    0, // EndSwitchType
/* 34009*/   /*Scope*/ 48, /*->34058*/
/* 34010*/    OPC_CheckChild1Type, MVT::i32,
/* 34012*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 34014*/    OPC_CheckPredicate, 20, // Predicate_load
/* 34016*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->34037
/* 34019*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 34021*/     OPC_EmitMergeInputChains1_0,
/* 34022*/     OPC_EmitInteger, MVT::i32, 0, 
/* 34025*/     OPC_EmitInteger, MVT::i32, 0, 
/* 34028*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 34037*/    /*SwitchType*/ 18, MVT::v2f64,// ->34057
/* 34039*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 34041*/     OPC_EmitMergeInputChains1_0,
/* 34042*/     OPC_EmitInteger, MVT::i32, 0, 
/* 34045*/     OPC_EmitInteger, MVT::i32, 0, 
/* 34048*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 34057*/    0, // EndSwitchType
/* 34058*/   /*Scope*/ 48, /*->34107*/
/* 34059*/    OPC_CheckChild1Type, MVT::i64,
/* 34061*/    OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 34063*/    OPC_CheckPredicate, 20, // Predicate_load
/* 34065*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->34086
/* 34068*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 34070*/     OPC_EmitMergeInputChains1_0,
/* 34071*/     OPC_EmitInteger, MVT::i32, 0, 
/* 34074*/     OPC_EmitInteger, MVT::i64, 0, 
/* 34077*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v4f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 34086*/    /*SwitchType*/ 18, MVT::v2f64,// ->34106
/* 34088*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 34090*/     OPC_EmitMergeInputChains1_0,
/* 34091*/     OPC_EmitInteger, MVT::i32, 0, 
/* 34094*/     OPC_EmitInteger, MVT::i64, 0, 
/* 34097*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 34106*/    0, // EndSwitchType
/* 34107*/   0, /*End of Scope*/
/* 34108*/  0, /*End of Scope*/
/* 34109*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SHL),// ->34179
/* 34112*/  OPC_RecordChild0, // #0 = $lhs
/* 34113*/  OPC_Scope, 35, /*->34150*/ // 2 children in Scope
/* 34115*/   OPC_MoveChild1,
/* 34116*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->34133
/* 34119*/    OPC_CheckAndImm, 31, 
/* 34121*/    OPC_RecordChild0, // #1 = $rhs
/* 34122*/    OPC_MoveParent,
/* 34123*/    OPC_CheckType, MVT::i32,
/* 34125*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34133*/   /*SwitchType*/ 14, MVT::i64,// ->34149
/* 34135*/    OPC_CheckAndImm, 63, 
/* 34137*/    OPC_RecordChild0, // #1 = $rhs
/* 34138*/    OPC_MoveParent,
/* 34139*/    OPC_CheckType, MVT::i64,
/* 34141*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34149*/   0, // EndSwitchType
/* 34150*/  /*Scope*/ 27, /*->34178*/
/* 34151*/   OPC_RecordChild1, // #1 = $rhs
/* 34152*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->34165
/* 34155*/    OPC_CheckChild1Type, MVT::i32,
/* 34157*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34165*/   /*SwitchType*/ 10, MVT::i64,// ->34177
/* 34167*/    OPC_CheckChild1Type, MVT::i64,
/* 34169*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34177*/   0, // EndSwitchType
/* 34178*/  0, /*End of Scope*/
/* 34179*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SRA),// ->34249
/* 34182*/  OPC_RecordChild0, // #0 = $lhs
/* 34183*/  OPC_Scope, 35, /*->34220*/ // 2 children in Scope
/* 34185*/   OPC_MoveChild1,
/* 34186*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->34203
/* 34189*/    OPC_CheckAndImm, 31, 
/* 34191*/    OPC_RecordChild0, // #1 = $rhs
/* 34192*/    OPC_MoveParent,
/* 34193*/    OPC_CheckType, MVT::i32,
/* 34195*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34203*/   /*SwitchType*/ 14, MVT::i64,// ->34219
/* 34205*/    OPC_CheckAndImm, 63, 
/* 34207*/    OPC_RecordChild0, // #1 = $rhs
/* 34208*/    OPC_MoveParent,
/* 34209*/    OPC_CheckType, MVT::i64,
/* 34211*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34219*/   0, // EndSwitchType
/* 34220*/  /*Scope*/ 27, /*->34248*/
/* 34221*/   OPC_RecordChild1, // #1 = $rhs
/* 34222*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->34235
/* 34225*/    OPC_CheckChild1Type, MVT::i32,
/* 34227*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34235*/   /*SwitchType*/ 10, MVT::i64,// ->34247
/* 34237*/    OPC_CheckChild1Type, MVT::i64,
/* 34239*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34247*/   0, // EndSwitchType
/* 34248*/  0, /*End of Scope*/
/* 34249*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SRL),// ->34319
/* 34252*/  OPC_RecordChild0, // #0 = $lhs
/* 34253*/  OPC_Scope, 35, /*->34290*/ // 2 children in Scope
/* 34255*/   OPC_MoveChild1,
/* 34256*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->34273
/* 34259*/    OPC_CheckAndImm, 31, 
/* 34261*/    OPC_RecordChild0, // #1 = $rhs
/* 34262*/    OPC_MoveParent,
/* 34263*/    OPC_CheckType, MVT::i32,
/* 34265*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34273*/   /*SwitchType*/ 14, MVT::i64,// ->34289
/* 34275*/    OPC_CheckAndImm, 63, 
/* 34277*/    OPC_RecordChild0, // #1 = $rhs
/* 34278*/    OPC_MoveParent,
/* 34279*/    OPC_CheckType, MVT::i64,
/* 34281*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34289*/   0, // EndSwitchType
/* 34290*/  /*Scope*/ 27, /*->34318*/
/* 34291*/   OPC_RecordChild1, // #1 = $rhs
/* 34292*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->34305
/* 34295*/    OPC_CheckChild1Type, MVT::i32,
/* 34297*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34305*/   /*SwitchType*/ 10, MVT::i64,// ->34317
/* 34307*/    OPC_CheckChild1Type, MVT::i64,
/* 34309*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34317*/   0, // EndSwitchType
/* 34318*/  0, /*End of Scope*/
/* 34319*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTL),// ->34389
/* 34322*/  OPC_RecordChild0, // #0 = $lhs
/* 34323*/  OPC_Scope, 35, /*->34360*/ // 2 children in Scope
/* 34325*/   OPC_MoveChild1,
/* 34326*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->34343
/* 34329*/    OPC_CheckAndImm, 31, 
/* 34331*/    OPC_RecordChild0, // #1 = $rhs
/* 34332*/    OPC_MoveParent,
/* 34333*/    OPC_CheckType, MVT::i32,
/* 34335*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34343*/   /*SwitchType*/ 14, MVT::i64,// ->34359
/* 34345*/    OPC_CheckAndImm, 63, 
/* 34347*/    OPC_RecordChild0, // #1 = $rhs
/* 34348*/    OPC_MoveParent,
/* 34349*/    OPC_CheckType, MVT::i64,
/* 34351*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34359*/   0, // EndSwitchType
/* 34360*/  /*Scope*/ 27, /*->34388*/
/* 34361*/   OPC_RecordChild1, // #1 = $rhs
/* 34362*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->34375
/* 34365*/    OPC_CheckChild1Type, MVT::i32,
/* 34367*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34375*/   /*SwitchType*/ 10, MVT::i64,// ->34387
/* 34377*/    OPC_CheckChild1Type, MVT::i64,
/* 34379*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34387*/   0, // EndSwitchType
/* 34388*/  0, /*End of Scope*/
/* 34389*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTR),// ->34459
/* 34392*/  OPC_RecordChild0, // #0 = $lhs
/* 34393*/  OPC_Scope, 35, /*->34430*/ // 2 children in Scope
/* 34395*/   OPC_MoveChild1,
/* 34396*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->34413
/* 34399*/    OPC_CheckAndImm, 31, 
/* 34401*/    OPC_RecordChild0, // #1 = $rhs
/* 34402*/    OPC_MoveParent,
/* 34403*/    OPC_CheckType, MVT::i32,
/* 34405*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34413*/   /*SwitchType*/ 14, MVT::i64,// ->34429
/* 34415*/    OPC_CheckAndImm, 63, 
/* 34417*/    OPC_RecordChild0, // #1 = $rhs
/* 34418*/    OPC_MoveParent,
/* 34419*/    OPC_CheckType, MVT::i64,
/* 34421*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34429*/   0, // EndSwitchType
/* 34430*/  /*Scope*/ 27, /*->34458*/
/* 34431*/   OPC_RecordChild1, // #1 = $rhs
/* 34432*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->34445
/* 34435*/    OPC_CheckChild1Type, MVT::i32,
/* 34437*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 34445*/   /*SwitchType*/ 10, MVT::i64,// ->34457
/* 34447*/    OPC_CheckChild1Type, MVT::i64,
/* 34449*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 34457*/   0, // EndSwitchType
/* 34458*/  0, /*End of Scope*/
/* 34459*/ /*SwitchOpcode*/ 42|128,4/*554*/, TARGET_VAL(ISD::SELECT),// ->35017
/* 34463*/  OPC_Scope, 117, /*->34582*/ // 8 children in Scope
/* 34465*/   OPC_MoveChild0,
/* 34466*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 34469*/   OPC_RecordChild0, // #0 = $cond
/* 34470*/   OPC_CheckChild0Type, MVT::i32,
/* 34472*/   OPC_CheckChild1Integer, 0, 
/* 34474*/   OPC_CheckType, MVT::i32,
/* 34476*/   OPC_Scope, 51, /*->34529*/ // 2 children in Scope
/* 34478*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 34480*/    OPC_MoveParent,
/* 34481*/    OPC_RecordChild1, // #1 = $lhs
/* 34482*/    OPC_RecordChild2, // #2 = $rhs
/* 34483*/    OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->34495
/* 34486*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34495*/    /*SwitchType*/ 9, MVT::i64,// ->34506
/* 34497*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34506*/    /*SwitchType*/ 9, MVT::funcref,// ->34517
/* 34508*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34517*/    /*SwitchType*/ 9, MVT::externref,// ->34528
/* 34519*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34528*/    0, // EndSwitchType
/* 34529*/   /*Scope*/ 51, /*->34581*/
/* 34530*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 34532*/    OPC_MoveParent,
/* 34533*/    OPC_RecordChild1, // #1 = $lhs
/* 34534*/    OPC_RecordChild2, // #2 = $rhs
/* 34535*/    OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->34547
/* 34538*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 34547*/    /*SwitchType*/ 9, MVT::i64,// ->34558
/* 34549*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 34558*/    /*SwitchType*/ 9, MVT::funcref,// ->34569
/* 34560*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 34569*/    /*SwitchType*/ 9, MVT::externref,// ->34580
/* 34571*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 34580*/    0, // EndSwitchType
/* 34581*/   0, /*End of Scope*/
/* 34582*/  /*Scope*/ 55, /*->34638*/
/* 34583*/   OPC_RecordChild0, // #0 = $cond
/* 34584*/   OPC_CheckChild0Type, MVT::i32,
/* 34586*/   OPC_RecordChild1, // #1 = $lhs
/* 34587*/   OPC_RecordChild2, // #2 = $rhs
/* 34588*/   OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->34600
/* 34591*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34600*/   /*SwitchType*/ 9, MVT::i64,// ->34611
/* 34602*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34611*/   /*SwitchType*/ 11, MVT::funcref,// ->34624
/* 34613*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 34615*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34624*/   /*SwitchType*/ 11, MVT::externref,// ->34637
/* 34626*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 34628*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34637*/   0, // EndSwitchType
/* 34638*/  /*Scope*/ 73, /*->34712*/
/* 34639*/   OPC_MoveChild0,
/* 34640*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 34643*/   OPC_RecordChild0, // #0 = $cond
/* 34644*/   OPC_CheckChild0Type, MVT::i32,
/* 34646*/   OPC_CheckChild1Integer, 0, 
/* 34648*/   OPC_CheckType, MVT::i32,
/* 34650*/   OPC_Scope, 29, /*->34681*/ // 2 children in Scope
/* 34652*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 34654*/    OPC_MoveParent,
/* 34655*/    OPC_RecordChild1, // #1 = $lhs
/* 34656*/    OPC_RecordChild2, // #2 = $rhs
/* 34657*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->34669
/* 34660*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34669*/    /*SwitchType*/ 9, MVT::f64,// ->34680
/* 34671*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34680*/    0, // EndSwitchType
/* 34681*/   /*Scope*/ 29, /*->34711*/
/* 34682*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 34684*/    OPC_MoveParent,
/* 34685*/    OPC_RecordChild1, // #1 = $lhs
/* 34686*/    OPC_RecordChild2, // #2 = $rhs
/* 34687*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->34699
/* 34690*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 34699*/    /*SwitchType*/ 9, MVT::f64,// ->34710
/* 34701*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 34710*/    0, // EndSwitchType
/* 34711*/   0, /*End of Scope*/
/* 34712*/  /*Scope*/ 29, /*->34742*/
/* 34713*/   OPC_RecordChild0, // #0 = $cond
/* 34714*/   OPC_CheckChild0Type, MVT::i32,
/* 34716*/   OPC_RecordChild1, // #1 = $lhs
/* 34717*/   OPC_RecordChild2, // #2 = $rhs
/* 34718*/   OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->34730
/* 34721*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34730*/   /*SwitchType*/ 9, MVT::f64,// ->34741
/* 34732*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 34741*/   0, // EndSwitchType
/* 34742*/  /*Scope*/ 117, /*->34860*/
/* 34743*/   OPC_MoveChild0,
/* 34744*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 34747*/   OPC_RecordChild0, // #0 = $cond
/* 34748*/   OPC_CheckChild0Type, MVT::i32,
/* 34750*/   OPC_CheckChild1Integer, 0, 
/* 34752*/   OPC_CheckType, MVT::i32,
/* 34754*/   OPC_Scope, 51, /*->34807*/ // 2 children in Scope
/* 34756*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 34758*/    OPC_MoveParent,
/* 34759*/    OPC_RecordChild1, // #1 = $lhs
/* 34760*/    OPC_RecordChild2, // #2 = $rhs
/* 34761*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->34773
/* 34764*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34773*/    /*SwitchType*/ 9, MVT::v8i16,// ->34784
/* 34775*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34784*/    /*SwitchType*/ 9, MVT::v4i32,// ->34795
/* 34786*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34795*/    /*SwitchType*/ 9, MVT::v2i64,// ->34806
/* 34797*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34806*/    0, // EndSwitchType
/* 34807*/   /*Scope*/ 51, /*->34859*/
/* 34808*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 34810*/    OPC_MoveParent,
/* 34811*/    OPC_RecordChild1, // #1 = $lhs
/* 34812*/    OPC_RecordChild2, // #2 = $rhs
/* 34813*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->34825
/* 34816*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 34825*/    /*SwitchType*/ 9, MVT::v8i16,// ->34836
/* 34827*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 34836*/    /*SwitchType*/ 9, MVT::v4i32,// ->34847
/* 34838*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 34847*/    /*SwitchType*/ 9, MVT::v2i64,// ->34858
/* 34849*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 34858*/    0, // EndSwitchType
/* 34859*/   0, /*End of Scope*/
/* 34860*/  /*Scope*/ 51, /*->34912*/
/* 34861*/   OPC_RecordChild0, // #0 = $cond
/* 34862*/   OPC_CheckChild0Type, MVT::i32,
/* 34864*/   OPC_RecordChild1, // #1 = $lhs
/* 34865*/   OPC_RecordChild2, // #2 = $rhs
/* 34866*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->34878
/* 34869*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34878*/   /*SwitchType*/ 9, MVT::v8i16,// ->34889
/* 34880*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34889*/   /*SwitchType*/ 9, MVT::v4i32,// ->34900
/* 34891*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34900*/   /*SwitchType*/ 9, MVT::v2i64,// ->34911
/* 34902*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34911*/   0, // EndSwitchType
/* 34912*/  /*Scope*/ 73, /*->34986*/
/* 34913*/   OPC_MoveChild0,
/* 34914*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 34917*/   OPC_RecordChild0, // #0 = $cond
/* 34918*/   OPC_CheckChild0Type, MVT::i32,
/* 34920*/   OPC_CheckChild1Integer, 0, 
/* 34922*/   OPC_CheckType, MVT::i32,
/* 34924*/   OPC_Scope, 29, /*->34955*/ // 2 children in Scope
/* 34926*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 34928*/    OPC_MoveParent,
/* 34929*/    OPC_RecordChild1, // #1 = $lhs
/* 34930*/    OPC_RecordChild2, // #2 = $rhs
/* 34931*/    OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->34943
/* 34934*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34943*/    /*SwitchType*/ 9, MVT::v2f64,// ->34954
/* 34945*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 34954*/    0, // EndSwitchType
/* 34955*/   /*Scope*/ 29, /*->34985*/
/* 34956*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 34958*/    OPC_MoveParent,
/* 34959*/    OPC_RecordChild1, // #1 = $lhs
/* 34960*/    OPC_RecordChild2, // #2 = $rhs
/* 34961*/    OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->34973
/* 34964*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 34973*/    /*SwitchType*/ 9, MVT::v2f64,// ->34984
/* 34975*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 34984*/    0, // EndSwitchType
/* 34985*/   0, /*End of Scope*/
/* 34986*/  /*Scope*/ 29, /*->35016*/
/* 34987*/   OPC_RecordChild0, // #0 = $cond
/* 34988*/   OPC_CheckChild0Type, MVT::i32,
/* 34990*/   OPC_RecordChild1, // #1 = $lhs
/* 34991*/   OPC_RecordChild2, // #2 = $rhs
/* 34992*/   OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->35004
/* 34995*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 35004*/   /*SwitchType*/ 9, MVT::v2f64,// ->35015
/* 35006*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 35015*/   0, // EndSwitchType
/* 35016*/  0, /*End of Scope*/
/* 35017*/ /*SwitchOpcode*/ 74|128,8/*1098*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->36119
/* 35021*/  OPC_RecordMemRef,
/* 35022*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 35023*/  OPC_Scope, 0|128,5/*640*/, /*->35666*/ // 2 children in Scope
/* 35026*/   OPC_MoveChild1,
/* 35027*/   OPC_SwitchOpcode /*3 cases */, 63|128,1/*191*/, TARGET_VAL(ISD::ADD),// ->35223
/* 35032*/    OPC_RecordChild0, // #1 = $addr
/* 35033*/    OPC_RecordChild1, // #2 = $off
/* 35034*/    OPC_MoveChild1,
/* 35035*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35038*/    OPC_MoveParent,
/* 35039*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 35041*/    OPC_SwitchType /*2 cases */, 88, MVT::i32,// ->35132
/* 35044*/     OPC_MoveParent,
/* 35045*/     OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->35110
/* 35048*/      OPC_Scope, 19, /*->35069*/ // 3 children in Scope
/* 35050*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35052*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35054*/       OPC_EmitMergeInputChains1_0,
/* 35055*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35058*/       OPC_EmitConvertToTarget, 2,
/* 35060*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_32>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35069*/      /*Scope*/ 19, /*->35089*/
/* 35070*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35072*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35074*/       OPC_EmitMergeInputChains1_0,
/* 35075*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35078*/       OPC_EmitConvertToTarget, 2,
/* 35080*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35089*/      /*Scope*/ 19, /*->35109*/
/* 35090*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35092*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35094*/       OPC_EmitMergeInputChains1_0,
/* 35095*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35098*/       OPC_EmitConvertToTarget, 2,
/* 35100*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35109*/      0, /*End of Scope*/
/* 35110*/     /*SwitchType*/ 19, MVT::i64,// ->35131
/* 35112*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 35114*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35116*/      OPC_EmitMergeInputChains1_0,
/* 35117*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35120*/      OPC_EmitConvertToTarget, 2,
/* 35122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (atomic_load:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_64>> - Complexity = 11
                // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35131*/     0, // EndSwitchType
/* 35132*/    /*SwitchType*/ 88, MVT::i64,// ->35222
/* 35134*/     OPC_MoveParent,
/* 35135*/     OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->35200
/* 35138*/      OPC_Scope, 19, /*->35159*/ // 3 children in Scope
/* 35140*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35142*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35144*/       OPC_EmitMergeInputChains1_0,
/* 35145*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35148*/       OPC_EmitConvertToTarget, 2,
/* 35150*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_32>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35159*/      /*Scope*/ 19, /*->35179*/
/* 35160*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35162*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35164*/       OPC_EmitMergeInputChains1_0,
/* 35165*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35168*/       OPC_EmitConvertToTarget, 2,
/* 35170*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35179*/      /*Scope*/ 19, /*->35199*/
/* 35180*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35182*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35184*/       OPC_EmitMergeInputChains1_0,
/* 35185*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35188*/       OPC_EmitConvertToTarget, 2,
/* 35190*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35199*/      0, /*End of Scope*/
/* 35200*/     /*SwitchType*/ 19, MVT::i64,// ->35221
/* 35202*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 35204*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35206*/      OPC_EmitMergeInputChains1_0,
/* 35207*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35210*/      OPC_EmitConvertToTarget, 2,
/* 35212*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (atomic_load:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_64>> - Complexity = 11
                // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35221*/     0, // EndSwitchType
/* 35222*/    0, // EndSwitchType
/* 35223*/   /*SwitchOpcode*/ 63|128,1/*191*/, TARGET_VAL(ISD::OR),// ->35418
/* 35227*/    OPC_RecordChild0, // #1 = $addr
/* 35228*/    OPC_RecordChild1, // #2 = $off
/* 35229*/    OPC_MoveChild1,
/* 35230*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35233*/    OPC_MoveParent,
/* 35234*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 35236*/    OPC_SwitchType /*2 cases */, 88, MVT::i32,// ->35327
/* 35239*/     OPC_MoveParent,
/* 35240*/     OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->35305
/* 35243*/      OPC_Scope, 19, /*->35264*/ // 3 children in Scope
/* 35245*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35247*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35249*/       OPC_EmitMergeInputChains1_0,
/* 35250*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35253*/       OPC_EmitConvertToTarget, 2,
/* 35255*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_32>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35264*/      /*Scope*/ 19, /*->35284*/
/* 35265*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35267*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35269*/       OPC_EmitMergeInputChains1_0,
/* 35270*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35273*/       OPC_EmitConvertToTarget, 2,
/* 35275*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35284*/      /*Scope*/ 19, /*->35304*/
/* 35285*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35287*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35289*/       OPC_EmitMergeInputChains1_0,
/* 35290*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35293*/       OPC_EmitConvertToTarget, 2,
/* 35295*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35304*/      0, /*End of Scope*/
/* 35305*/     /*SwitchType*/ 19, MVT::i64,// ->35326
/* 35307*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 35309*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35311*/      OPC_EmitMergeInputChains1_0,
/* 35312*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35315*/      OPC_EmitConvertToTarget, 2,
/* 35317*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (atomic_load:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_64>> - Complexity = 11
                // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35326*/     0, // EndSwitchType
/* 35327*/    /*SwitchType*/ 88, MVT::i64,// ->35417
/* 35329*/     OPC_MoveParent,
/* 35330*/     OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->35395
/* 35333*/      OPC_Scope, 19, /*->35354*/ // 3 children in Scope
/* 35335*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35337*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35339*/       OPC_EmitMergeInputChains1_0,
/* 35340*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35343*/       OPC_EmitConvertToTarget, 2,
/* 35345*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_32>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35354*/      /*Scope*/ 19, /*->35374*/
/* 35355*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35357*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35359*/       OPC_EmitMergeInputChains1_0,
/* 35360*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35363*/       OPC_EmitConvertToTarget, 2,
/* 35365*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35374*/      /*Scope*/ 19, /*->35394*/
/* 35375*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35377*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35379*/       OPC_EmitMergeInputChains1_0,
/* 35380*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35383*/       OPC_EmitConvertToTarget, 2,
/* 35385*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (atomic_load:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>> - Complexity = 11
                 // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35394*/      0, /*End of Scope*/
/* 35395*/     /*SwitchType*/ 19, MVT::i64,// ->35416
/* 35397*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 35399*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35401*/      OPC_EmitMergeInputChains1_0,
/* 35402*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35405*/      OPC_EmitConvertToTarget, 2,
/* 35407*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (atomic_load:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_64>> - Complexity = 11
                // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 35416*/     0, // EndSwitchType
/* 35417*/    0, // EndSwitchType
/* 35418*/   /*SwitchOpcode*/ 115|128,1/*243*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->35665
/* 35422*/    OPC_RecordChild0, // #1 = $off
/* 35423*/    OPC_MoveChild0,
/* 35424*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 35427*/    OPC_MoveParent,
/* 35428*/    OPC_MoveParent,
/* 35429*/    OPC_SwitchType /*2 cases */, 45|128,1/*173*/, MVT::i32,// ->35606
/* 35433*/     OPC_Scope, 56, /*->35491*/ // 3 children in Scope
/* 35435*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35437*/      OPC_Scope, 25, /*->35464*/ // 2 children in Scope
/* 35439*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35441*/       OPC_EmitMergeInputChains1_0,
/* 35442*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35445*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35448*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35455*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_32>> - Complexity = 10
                 // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35464*/      /*Scope*/ 25, /*->35490*/
/* 35465*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35467*/       OPC_EmitMergeInputChains1_0,
/* 35468*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35471*/       OPC_EmitInteger, MVT::i64, 0, 
/* 35474*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 35481*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_32>> - Complexity = 10
                 // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35490*/      0, /*End of Scope*/
/* 35491*/     /*Scope*/ 56, /*->35548*/
/* 35492*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35494*/      OPC_Scope, 25, /*->35521*/ // 2 children in Scope
/* 35496*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35498*/       OPC_EmitMergeInputChains1_0,
/* 35499*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35502*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35505*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35512*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>> - Complexity = 10
                 // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35521*/      /*Scope*/ 25, /*->35547*/
/* 35522*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35524*/       OPC_EmitMergeInputChains1_0,
/* 35525*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35528*/       OPC_EmitInteger, MVT::i64, 0, 
/* 35531*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 35538*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>> - Complexity = 10
                 // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35547*/      0, /*End of Scope*/
/* 35548*/     /*Scope*/ 56, /*->35605*/
/* 35549*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35551*/      OPC_Scope, 25, /*->35578*/ // 2 children in Scope
/* 35553*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35555*/       OPC_EmitMergeInputChains1_0,
/* 35556*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35559*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35562*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35569*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>> - Complexity = 10
                 // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35578*/      /*Scope*/ 25, /*->35604*/
/* 35579*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35581*/       OPC_EmitMergeInputChains1_0,
/* 35582*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35585*/       OPC_EmitInteger, MVT::i64, 0, 
/* 35588*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 35595*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>> - Complexity = 10
                 // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35604*/      0, /*End of Scope*/
/* 35605*/     0, /*End of Scope*/
/* 35606*/    /*SwitchType*/ 56, MVT::i64,// ->35664
/* 35608*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 35610*/     OPC_Scope, 25, /*->35637*/ // 2 children in Scope
/* 35612*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35614*/      OPC_EmitMergeInputChains1_0,
/* 35615*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35618*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35621*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35628*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (atomic_load:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_64>> - Complexity = 10
                // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35637*/     /*Scope*/ 25, /*->35663*/
/* 35638*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 35640*/      OPC_EmitMergeInputChains1_0,
/* 35641*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35644*/      OPC_EmitInteger, MVT::i64, 0, 
/* 35647*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 35654*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (atomic_load:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_64>> - Complexity = 10
                // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35663*/     0, /*End of Scope*/
/* 35664*/    0, // EndSwitchType
/* 35665*/   0, // EndSwitchOpcode
/* 35666*/  /*Scope*/ 66|128,3/*450*/, /*->36118*/
/* 35668*/   OPC_RecordChild1, // #1 = $off
/* 35669*/   OPC_Scope, 1|128,2/*257*/, /*->35929*/ // 3 children in Scope
/* 35672*/    OPC_MoveChild1,
/* 35673*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35676*/    OPC_MoveParent,
/* 35677*/    OPC_SwitchType /*2 cases */, 57|128,1/*185*/, MVT::i32,// ->35866
/* 35681*/     OPC_Scope, 60, /*->35743*/ // 3 children in Scope
/* 35683*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35685*/      OPC_Scope, 27, /*->35714*/ // 2 children in Scope
/* 35687*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35689*/       OPC_EmitMergeInputChains1_0,
/* 35690*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35693*/       OPC_EmitConvertToTarget, 1,
/* 35695*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35698*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35705*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_32>> - Complexity = 7
                 // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35714*/      /*Scope*/ 27, /*->35742*/
/* 35715*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35717*/       OPC_EmitMergeInputChains1_0,
/* 35718*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35721*/       OPC_EmitConvertToTarget, 1,
/* 35723*/       OPC_EmitInteger, MVT::i64, 0, 
/* 35726*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 35733*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_32>> - Complexity = 7
                 // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35742*/      0, /*End of Scope*/
/* 35743*/     /*Scope*/ 60, /*->35804*/
/* 35744*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35746*/      OPC_Scope, 27, /*->35775*/ // 2 children in Scope
/* 35748*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35750*/       OPC_EmitMergeInputChains1_0,
/* 35751*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35754*/       OPC_EmitConvertToTarget, 1,
/* 35756*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35759*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35766*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>> - Complexity = 7
                 // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35775*/      /*Scope*/ 27, /*->35803*/
/* 35776*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35778*/       OPC_EmitMergeInputChains1_0,
/* 35779*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35782*/       OPC_EmitConvertToTarget, 1,
/* 35784*/       OPC_EmitInteger, MVT::i64, 0, 
/* 35787*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 35794*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>> - Complexity = 7
                 // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35803*/      0, /*End of Scope*/
/* 35804*/     /*Scope*/ 60, /*->35865*/
/* 35805*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35807*/      OPC_Scope, 27, /*->35836*/ // 2 children in Scope
/* 35809*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35811*/       OPC_EmitMergeInputChains1_0,
/* 35812*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35815*/       OPC_EmitConvertToTarget, 1,
/* 35817*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35820*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35827*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>> - Complexity = 7
                 // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35836*/      /*Scope*/ 27, /*->35864*/
/* 35837*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35839*/       OPC_EmitMergeInputChains1_0,
/* 35840*/       OPC_EmitInteger, MVT::i32, 0, 
/* 35843*/       OPC_EmitConvertToTarget, 1,
/* 35845*/       OPC_EmitInteger, MVT::i64, 0, 
/* 35848*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 35855*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>> - Complexity = 7
                 // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35864*/      0, /*End of Scope*/
/* 35865*/     0, /*End of Scope*/
/* 35866*/    /*SwitchType*/ 60, MVT::i64,// ->35928
/* 35868*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 35870*/     OPC_Scope, 27, /*->35899*/ // 2 children in Scope
/* 35872*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35874*/      OPC_EmitMergeInputChains1_0,
/* 35875*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35878*/      OPC_EmitConvertToTarget, 1,
/* 35880*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35883*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35890*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (atomic_load:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_64>> - Complexity = 7
                // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35899*/     /*Scope*/ 27, /*->35927*/
/* 35900*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 35902*/      OPC_EmitMergeInputChains1_0,
/* 35903*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35906*/      OPC_EmitConvertToTarget, 1,
/* 35908*/      OPC_EmitInteger, MVT::i64, 0, 
/* 35911*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 35918*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (atomic_load:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_64>> - Complexity = 7
                // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 35927*/     0, /*End of Scope*/
/* 35928*/    0, // EndSwitchType
/* 35929*/   /*Scope*/ 93, /*->36023*/
/* 35930*/    OPC_CheckChild1Type, MVT::i32,
/* 35932*/    OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->36000
/* 35935*/     OPC_Scope, 20, /*->35957*/ // 3 children in Scope
/* 35937*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 35939*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35941*/      OPC_EmitMergeInputChains1_0,
/* 35942*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35945*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35948*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_32>> - Complexity = 4
                // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35957*/     /*Scope*/ 20, /*->35978*/
/* 35958*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 35960*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35962*/      OPC_EmitMergeInputChains1_0,
/* 35963*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35966*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>> - Complexity = 4
                // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35978*/     /*Scope*/ 20, /*->35999*/
/* 35979*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 35981*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 35983*/      OPC_EmitMergeInputChains1_0,
/* 35984*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35987*/      OPC_EmitInteger, MVT::i32, 0, 
/* 35990*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>> - Complexity = 4
                // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35999*/     0, /*End of Scope*/
/* 36000*/    /*SwitchType*/ 20, MVT::i64,// ->36022
/* 36002*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 36004*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 36006*/     OPC_EmitMergeInputChains1_0,
/* 36007*/     OPC_EmitInteger, MVT::i32, 0, 
/* 36010*/     OPC_EmitInteger, MVT::i32, 0, 
/* 36013*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (atomic_load:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_64>> - Complexity = 4
               // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 36022*/    0, // EndSwitchType
/* 36023*/   /*Scope*/ 93, /*->36117*/
/* 36024*/    OPC_CheckChild1Type, MVT::i64,
/* 36026*/    OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->36094
/* 36029*/     OPC_Scope, 20, /*->36051*/ // 3 children in Scope
/* 36031*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_32
/* 36033*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 36035*/      OPC_EmitMergeInputChains1_0,
/* 36036*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36039*/      OPC_EmitInteger, MVT::i64, 0, 
/* 36042*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_32>> - Complexity = 4
                // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 36051*/     /*Scope*/ 20, /*->36072*/
/* 36052*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 36054*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 36056*/      OPC_EmitMergeInputChains1_0,
/* 36057*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36060*/      OPC_EmitInteger, MVT::i64, 0, 
/* 36063*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_8>> - Complexity = 4
                // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 36072*/     /*Scope*/ 20, /*->36093*/
/* 36073*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 36075*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 36077*/      OPC_EmitMergeInputChains1_0,
/* 36078*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36081*/      OPC_EmitInteger, MVT::i64, 0, 
/* 36084*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (atomic_load:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_16>> - Complexity = 4
                // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 36093*/     0, /*End of Scope*/
/* 36094*/    /*SwitchType*/ 20, MVT::i64,// ->36116
/* 36096*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_64
/* 36098*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 36100*/     OPC_EmitMergeInputChains1_0,
/* 36101*/     OPC_EmitInteger, MVT::i32, 0, 
/* 36104*/     OPC_EmitInteger, MVT::i64, 0, 
/* 36107*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (atomic_load:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_atomic_load_64>> - Complexity = 4
               // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 36116*/    0, // EndSwitchType
/* 36117*/   0, /*End of Scope*/
/* 36118*/  0, /*End of Scope*/
/* 36119*/ /*SwitchOpcode*/ 116|128,12/*1652*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->37775
/* 36123*/  OPC_RecordMemRef,
/* 36124*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 36125*/  OPC_Scope, 63|128,7/*959*/, /*->37087*/ // 2 children in Scope
/* 36128*/   OPC_MoveChild1,
/* 36129*/   OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->36421
/* 36134*/    OPC_RecordChild0, // #1 = $addr
/* 36135*/    OPC_RecordChild1, // #2 = $off
/* 36136*/    OPC_MoveChild1,
/* 36137*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 36140*/    OPC_MoveParent,
/* 36141*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 36143*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->36282
/* 36147*/     OPC_MoveParent,
/* 36148*/     OPC_RecordChild2, // #3 = $val
/* 36149*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->36259
/* 36152*/      OPC_Scope, 20, /*->36174*/ // 5 children in Scope
/* 36154*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 36156*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36158*/       OPC_EmitMergeInputChains1_0,
/* 36159*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36162*/       OPC_EmitConvertToTarget, 2,
/* 36164*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36174*/      /*Scope*/ 20, /*->36195*/
/* 36175*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36177*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36179*/       OPC_EmitMergeInputChains1_0,
/* 36180*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36183*/       OPC_EmitConvertToTarget, 2,
/* 36185*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36195*/      /*Scope*/ 20, /*->36216*/
/* 36196*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36198*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36200*/       OPC_EmitMergeInputChains1_0,
/* 36201*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36204*/       OPC_EmitConvertToTarget, 2,
/* 36206*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36216*/      /*Scope*/ 20, /*->36237*/
/* 36217*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36219*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36221*/       OPC_EmitMergeInputChains1_0,
/* 36222*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36225*/       OPC_EmitConvertToTarget, 2,
/* 36227*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36237*/      /*Scope*/ 20, /*->36258*/
/* 36238*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36240*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36242*/       OPC_EmitMergeInputChains1_0,
/* 36243*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36246*/       OPC_EmitConvertToTarget, 2,
/* 36248*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36258*/      0, /*End of Scope*/
/* 36259*/     /*SwitchType*/ 20, MVT::i64,// ->36281
/* 36261*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 36263*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36265*/      OPC_EmitMergeInputChains1_0,
/* 36266*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36269*/      OPC_EmitConvertToTarget, 2,
/* 36271*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 36281*/     0, // EndSwitchType
/* 36282*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->36420
/* 36285*/     OPC_MoveParent,
/* 36286*/     OPC_RecordChild2, // #3 = $val
/* 36287*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->36397
/* 36290*/      OPC_Scope, 20, /*->36312*/ // 5 children in Scope
/* 36292*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 36294*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36296*/       OPC_EmitMergeInputChains1_0,
/* 36297*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36300*/       OPC_EmitConvertToTarget, 2,
/* 36302*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36312*/      /*Scope*/ 20, /*->36333*/
/* 36313*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36315*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36317*/       OPC_EmitMergeInputChains1_0,
/* 36318*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36321*/       OPC_EmitConvertToTarget, 2,
/* 36323*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36333*/      /*Scope*/ 20, /*->36354*/
/* 36334*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36336*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36338*/       OPC_EmitMergeInputChains1_0,
/* 36339*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36342*/       OPC_EmitConvertToTarget, 2,
/* 36344*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36354*/      /*Scope*/ 20, /*->36375*/
/* 36355*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36357*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36359*/       OPC_EmitMergeInputChains1_0,
/* 36360*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36363*/       OPC_EmitConvertToTarget, 2,
/* 36365*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36375*/      /*Scope*/ 20, /*->36396*/
/* 36376*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36378*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36380*/       OPC_EmitMergeInputChains1_0,
/* 36381*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36384*/       OPC_EmitConvertToTarget, 2,
/* 36386*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36396*/      0, /*End of Scope*/
/* 36397*/     /*SwitchType*/ 20, MVT::i64,// ->36419
/* 36399*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 36401*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36403*/      OPC_EmitMergeInputChains1_0,
/* 36404*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36407*/      OPC_EmitConvertToTarget, 2,
/* 36409*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 36419*/     0, // EndSwitchType
/* 36420*/    0, // EndSwitchType
/* 36421*/   /*SwitchOpcode*/ 31|128,2/*287*/, TARGET_VAL(ISD::OR),// ->36712
/* 36425*/    OPC_RecordChild0, // #1 = $addr
/* 36426*/    OPC_RecordChild1, // #2 = $off
/* 36427*/    OPC_MoveChild1,
/* 36428*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 36431*/    OPC_MoveParent,
/* 36432*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 36434*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->36573
/* 36438*/     OPC_MoveParent,
/* 36439*/     OPC_RecordChild2, // #3 = $val
/* 36440*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->36550
/* 36443*/      OPC_Scope, 20, /*->36465*/ // 5 children in Scope
/* 36445*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 36447*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36449*/       OPC_EmitMergeInputChains1_0,
/* 36450*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36453*/       OPC_EmitConvertToTarget, 2,
/* 36455*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36465*/      /*Scope*/ 20, /*->36486*/
/* 36466*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36468*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36470*/       OPC_EmitMergeInputChains1_0,
/* 36471*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36474*/       OPC_EmitConvertToTarget, 2,
/* 36476*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36486*/      /*Scope*/ 20, /*->36507*/
/* 36487*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36489*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36491*/       OPC_EmitMergeInputChains1_0,
/* 36492*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36495*/       OPC_EmitConvertToTarget, 2,
/* 36497*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36507*/      /*Scope*/ 20, /*->36528*/
/* 36508*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36510*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36512*/       OPC_EmitMergeInputChains1_0,
/* 36513*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36516*/       OPC_EmitConvertToTarget, 2,
/* 36518*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36528*/      /*Scope*/ 20, /*->36549*/
/* 36529*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36531*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36533*/       OPC_EmitMergeInputChains1_0,
/* 36534*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36537*/       OPC_EmitConvertToTarget, 2,
/* 36539*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36549*/      0, /*End of Scope*/
/* 36550*/     /*SwitchType*/ 20, MVT::i64,// ->36572
/* 36552*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 36554*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36556*/      OPC_EmitMergeInputChains1_0,
/* 36557*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36560*/      OPC_EmitConvertToTarget, 2,
/* 36562*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_add:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 36572*/     0, // EndSwitchType
/* 36573*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->36711
/* 36576*/     OPC_MoveParent,
/* 36577*/     OPC_RecordChild2, // #3 = $val
/* 36578*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->36688
/* 36581*/      OPC_Scope, 20, /*->36603*/ // 5 children in Scope
/* 36583*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 36585*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36587*/       OPC_EmitMergeInputChains1_0,
/* 36588*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36591*/       OPC_EmitConvertToTarget, 2,
/* 36593*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36603*/      /*Scope*/ 20, /*->36624*/
/* 36604*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36606*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36608*/       OPC_EmitMergeInputChains1_0,
/* 36609*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36612*/       OPC_EmitConvertToTarget, 2,
/* 36614*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36624*/      /*Scope*/ 20, /*->36645*/
/* 36625*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36627*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36629*/       OPC_EmitMergeInputChains1_0,
/* 36630*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36633*/       OPC_EmitConvertToTarget, 2,
/* 36635*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36645*/      /*Scope*/ 20, /*->36666*/
/* 36646*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36648*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36650*/       OPC_EmitMergeInputChains1_0,
/* 36651*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36654*/       OPC_EmitConvertToTarget, 2,
/* 36656*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36666*/      /*Scope*/ 20, /*->36687*/
/* 36667*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36669*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36671*/       OPC_EmitMergeInputChains1_0,
/* 36672*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36675*/       OPC_EmitConvertToTarget, 2,
/* 36677*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 36687*/      0, /*End of Scope*/
/* 36688*/     /*SwitchType*/ 20, MVT::i64,// ->36710
/* 36690*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 36692*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 36694*/      OPC_EmitMergeInputChains1_0,
/* 36695*/      OPC_EmitInteger, MVT::i32, 0, 
/* 36698*/      OPC_EmitConvertToTarget, 2,
/* 36700*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_add:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 36710*/     0, // EndSwitchType
/* 36711*/    0, // EndSwitchType
/* 36712*/   /*SwitchOpcode*/ 114|128,2/*370*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->37086
/* 36716*/    OPC_RecordChild0, // #1 = $off
/* 36717*/    OPC_MoveChild0,
/* 36718*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 36721*/    OPC_MoveParent,
/* 36722*/    OPC_MoveParent,
/* 36723*/    OPC_RecordChild2, // #2 = $val
/* 36724*/    OPC_SwitchType /*2 cases */, 41|128,2/*297*/, MVT::i32,// ->37025
/* 36728*/     OPC_Scope, 58, /*->36788*/ // 5 children in Scope
/* 36730*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 36732*/      OPC_Scope, 26, /*->36760*/ // 2 children in Scope
/* 36734*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36736*/       OPC_EmitMergeInputChains1_0,
/* 36737*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36740*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36743*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36750*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36760*/      /*Scope*/ 26, /*->36787*/
/* 36761*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36763*/       OPC_EmitMergeInputChains1_0,
/* 36764*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36767*/       OPC_EmitInteger, MVT::i64, 0, 
/* 36770*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 36777*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 36787*/      0, /*End of Scope*/
/* 36788*/     /*Scope*/ 58, /*->36847*/
/* 36789*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36791*/      OPC_Scope, 26, /*->36819*/ // 2 children in Scope
/* 36793*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36795*/       OPC_EmitMergeInputChains1_0,
/* 36796*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36799*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36802*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36809*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36819*/      /*Scope*/ 26, /*->36846*/
/* 36820*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36822*/       OPC_EmitMergeInputChains1_0,
/* 36823*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36826*/       OPC_EmitInteger, MVT::i64, 0, 
/* 36829*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 36836*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 36846*/      0, /*End of Scope*/
/* 36847*/     /*Scope*/ 58, /*->36906*/
/* 36848*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36850*/      OPC_Scope, 26, /*->36878*/ // 2 children in Scope
/* 36852*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36854*/       OPC_EmitMergeInputChains1_0,
/* 36855*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36858*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36861*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36868*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36878*/      /*Scope*/ 26, /*->36905*/
/* 36879*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36881*/       OPC_EmitMergeInputChains1_0,
/* 36882*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36885*/       OPC_EmitInteger, MVT::i64, 0, 
/* 36888*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 36895*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 36905*/      0, /*End of Scope*/
/* 36906*/     /*Scope*/ 58, /*->36965*/
/* 36907*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 36909*/      OPC_Scope, 26, /*->36937*/ // 2 children in Scope
/* 36911*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36913*/       OPC_EmitMergeInputChains1_0,
/* 36914*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36917*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36920*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36927*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36937*/      /*Scope*/ 26, /*->36964*/
/* 36938*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36940*/       OPC_EmitMergeInputChains1_0,
/* 36941*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36944*/       OPC_EmitInteger, MVT::i64, 0, 
/* 36947*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 36954*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 36964*/      0, /*End of Scope*/
/* 36965*/     /*Scope*/ 58, /*->37024*/
/* 36966*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 36968*/      OPC_Scope, 26, /*->36996*/ // 2 children in Scope
/* 36970*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36972*/       OPC_EmitMergeInputChains1_0,
/* 36973*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36976*/       OPC_EmitInteger, MVT::i32, 0, 
/* 36979*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36986*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36996*/      /*Scope*/ 26, /*->37023*/
/* 36997*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 36999*/       OPC_EmitMergeInputChains1_0,
/* 37000*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37003*/       OPC_EmitInteger, MVT::i64, 0, 
/* 37006*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 37013*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 37023*/      0, /*End of Scope*/
/* 37024*/     0, /*End of Scope*/
/* 37025*/    /*SwitchType*/ 58, MVT::i64,// ->37085
/* 37027*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 37029*/     OPC_Scope, 26, /*->37057*/ // 2 children in Scope
/* 37031*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 37033*/      OPC_EmitMergeInputChains1_0,
/* 37034*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37037*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37040*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37047*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_add:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37057*/     /*Scope*/ 26, /*->37084*/
/* 37058*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 37060*/      OPC_EmitMergeInputChains1_0,
/* 37061*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37064*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37067*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 37074*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_add:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 37084*/     0, /*End of Scope*/
/* 37085*/    0, // EndSwitchType
/* 37086*/   0, // EndSwitchOpcode
/* 37087*/  /*Scope*/ 45|128,5/*685*/, /*->37774*/
/* 37089*/   OPC_RecordChild1, // #1 = $off
/* 37090*/   OPC_Scope, 8|128,3/*392*/, /*->37485*/ // 3 children in Scope
/* 37093*/    OPC_MoveChild1,
/* 37094*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 37097*/    OPC_MoveParent,
/* 37098*/    OPC_RecordChild2, // #2 = $val
/* 37099*/    OPC_SwitchType /*2 cases */, 61|128,2/*317*/, MVT::i32,// ->37420
/* 37103*/     OPC_Scope, 62, /*->37167*/ // 5 children in Scope
/* 37105*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 37107*/      OPC_Scope, 28, /*->37137*/ // 2 children in Scope
/* 37109*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37111*/       OPC_EmitMergeInputChains1_0,
/* 37112*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37115*/       OPC_EmitConvertToTarget, 1,
/* 37117*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37120*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37127*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 37137*/      /*Scope*/ 28, /*->37166*/
/* 37138*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37140*/       OPC_EmitMergeInputChains1_0,
/* 37141*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37144*/       OPC_EmitConvertToTarget, 1,
/* 37146*/       OPC_EmitInteger, MVT::i64, 0, 
/* 37149*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 37156*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 37166*/      0, /*End of Scope*/
/* 37167*/     /*Scope*/ 62, /*->37230*/
/* 37168*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 37170*/      OPC_Scope, 28, /*->37200*/ // 2 children in Scope
/* 37172*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37174*/       OPC_EmitMergeInputChains1_0,
/* 37175*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37178*/       OPC_EmitConvertToTarget, 1,
/* 37180*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37183*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37190*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 37200*/      /*Scope*/ 28, /*->37229*/
/* 37201*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37203*/       OPC_EmitMergeInputChains1_0,
/* 37204*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37207*/       OPC_EmitConvertToTarget, 1,
/* 37209*/       OPC_EmitInteger, MVT::i64, 0, 
/* 37212*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 37219*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 37229*/      0, /*End of Scope*/
/* 37230*/     /*Scope*/ 62, /*->37293*/
/* 37231*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 37233*/      OPC_Scope, 28, /*->37263*/ // 2 children in Scope
/* 37235*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37237*/       OPC_EmitMergeInputChains1_0,
/* 37238*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37241*/       OPC_EmitConvertToTarget, 1,
/* 37243*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37246*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37253*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 37263*/      /*Scope*/ 28, /*->37292*/
/* 37264*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37266*/       OPC_EmitMergeInputChains1_0,
/* 37267*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37270*/       OPC_EmitConvertToTarget, 1,
/* 37272*/       OPC_EmitInteger, MVT::i64, 0, 
/* 37275*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 37282*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 37292*/      0, /*End of Scope*/
/* 37293*/     /*Scope*/ 62, /*->37356*/
/* 37294*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 37296*/      OPC_Scope, 28, /*->37326*/ // 2 children in Scope
/* 37298*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37300*/       OPC_EmitMergeInputChains1_0,
/* 37301*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37304*/       OPC_EmitConvertToTarget, 1,
/* 37306*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37309*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37316*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 37326*/      /*Scope*/ 28, /*->37355*/
/* 37327*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37329*/       OPC_EmitMergeInputChains1_0,
/* 37330*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37333*/       OPC_EmitConvertToTarget, 1,
/* 37335*/       OPC_EmitInteger, MVT::i64, 0, 
/* 37338*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 37345*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 37355*/      0, /*End of Scope*/
/* 37356*/     /*Scope*/ 62, /*->37419*/
/* 37357*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 37359*/      OPC_Scope, 28, /*->37389*/ // 2 children in Scope
/* 37361*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37363*/       OPC_EmitMergeInputChains1_0,
/* 37364*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37367*/       OPC_EmitConvertToTarget, 1,
/* 37369*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37372*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37379*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 37389*/      /*Scope*/ 28, /*->37418*/
/* 37390*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37392*/       OPC_EmitMergeInputChains1_0,
/* 37393*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37396*/       OPC_EmitConvertToTarget, 1,
/* 37398*/       OPC_EmitInteger, MVT::i64, 0, 
/* 37401*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 37408*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 37418*/      0, /*End of Scope*/
/* 37419*/     0, /*End of Scope*/
/* 37420*/    /*SwitchType*/ 62, MVT::i64,// ->37484
/* 37422*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 37424*/     OPC_Scope, 28, /*->37454*/ // 2 children in Scope
/* 37426*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37428*/      OPC_EmitMergeInputChains1_0,
/* 37429*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37432*/      OPC_EmitConvertToTarget, 1,
/* 37434*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37437*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37444*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_add:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37454*/     /*Scope*/ 28, /*->37483*/
/* 37455*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37457*/      OPC_EmitMergeInputChains1_0,
/* 37458*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37461*/      OPC_EmitConvertToTarget, 1,
/* 37463*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37466*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 37473*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_add:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 37483*/     0, /*End of Scope*/
/* 37484*/    0, // EndSwitchType
/* 37485*/   /*Scope*/ 14|128,1/*142*/, /*->37629*/
/* 37487*/    OPC_CheckChild1Type, MVT::i32,
/* 37489*/    OPC_RecordChild2, // #2 = $val
/* 37490*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->37605
/* 37493*/     OPC_Scope, 21, /*->37516*/ // 5 children in Scope
/* 37495*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 37497*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37499*/      OPC_EmitMergeInputChains1_0,
/* 37500*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37503*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37506*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37516*/     /*Scope*/ 21, /*->37538*/
/* 37517*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 37519*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37521*/      OPC_EmitMergeInputChains1_0,
/* 37522*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37525*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37528*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37538*/     /*Scope*/ 21, /*->37560*/
/* 37539*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 37541*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37543*/      OPC_EmitMergeInputChains1_0,
/* 37544*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37547*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37550*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37560*/     /*Scope*/ 21, /*->37582*/
/* 37561*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 37563*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37565*/      OPC_EmitMergeInputChains1_0,
/* 37566*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37569*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37572*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37582*/     /*Scope*/ 21, /*->37604*/
/* 37583*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 37585*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37587*/      OPC_EmitMergeInputChains1_0,
/* 37588*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37591*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37594*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37604*/     0, /*End of Scope*/
/* 37605*/    /*SwitchType*/ 21, MVT::i64,// ->37628
/* 37607*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 37609*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37611*/     OPC_EmitMergeInputChains1_0,
/* 37612*/     OPC_EmitInteger, MVT::i32, 0, 
/* 37615*/     OPC_EmitInteger, MVT::i32, 0, 
/* 37618*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_add:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37628*/    0, // EndSwitchType
/* 37629*/   /*Scope*/ 14|128,1/*142*/, /*->37773*/
/* 37631*/    OPC_CheckChild1Type, MVT::i64,
/* 37633*/    OPC_RecordChild2, // #2 = $val
/* 37634*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->37749
/* 37637*/     OPC_Scope, 21, /*->37660*/ // 5 children in Scope
/* 37639*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_add_32
/* 37641*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37643*/      OPC_EmitMergeInputChains1_0,
/* 37644*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37647*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37650*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37660*/     /*Scope*/ 21, /*->37682*/
/* 37661*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 37663*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37665*/      OPC_EmitMergeInputChains1_0,
/* 37666*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37669*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37672*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37682*/     /*Scope*/ 21, /*->37704*/
/* 37683*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 37685*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37687*/      OPC_EmitMergeInputChains1_0,
/* 37688*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37691*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37694*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37704*/     /*Scope*/ 21, /*->37726*/
/* 37705*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 37707*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37709*/      OPC_EmitMergeInputChains1_0,
/* 37710*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37713*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37716*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37726*/     /*Scope*/ 21, /*->37748*/
/* 37727*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 37729*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37731*/      OPC_EmitMergeInputChains1_0,
/* 37732*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37735*/      OPC_EmitInteger, MVT::i64, 0, 
/* 37738*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_add:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37748*/     0, /*End of Scope*/
/* 37749*/    /*SwitchType*/ 21, MVT::i64,// ->37772
/* 37751*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_add_64
/* 37753*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37755*/     OPC_EmitMergeInputChains1_0,
/* 37756*/     OPC_EmitInteger, MVT::i32, 0, 
/* 37759*/     OPC_EmitInteger, MVT::i64, 0, 
/* 37762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_add:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 37772*/    0, // EndSwitchType
/* 37773*/   0, /*End of Scope*/
/* 37774*/  0, /*End of Scope*/
/* 37775*/ /*SwitchOpcode*/ 116|128,12/*1652*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->39431
/* 37779*/  OPC_RecordMemRef,
/* 37780*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 37781*/  OPC_Scope, 63|128,7/*959*/, /*->38743*/ // 2 children in Scope
/* 37784*/   OPC_MoveChild1,
/* 37785*/   OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->38077
/* 37790*/    OPC_RecordChild0, // #1 = $addr
/* 37791*/    OPC_RecordChild1, // #2 = $off
/* 37792*/    OPC_MoveChild1,
/* 37793*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 37796*/    OPC_MoveParent,
/* 37797*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 37799*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->37938
/* 37803*/     OPC_MoveParent,
/* 37804*/     OPC_RecordChild2, // #3 = $val
/* 37805*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->37915
/* 37808*/      OPC_Scope, 20, /*->37830*/ // 5 children in Scope
/* 37810*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 37812*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37814*/       OPC_EmitMergeInputChains1_0,
/* 37815*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37818*/       OPC_EmitConvertToTarget, 2,
/* 37820*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37830*/      /*Scope*/ 20, /*->37851*/
/* 37831*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 37833*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37835*/       OPC_EmitMergeInputChains1_0,
/* 37836*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37839*/       OPC_EmitConvertToTarget, 2,
/* 37841*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37851*/      /*Scope*/ 20, /*->37872*/
/* 37852*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 37854*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37856*/       OPC_EmitMergeInputChains1_0,
/* 37857*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37860*/       OPC_EmitConvertToTarget, 2,
/* 37862*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37872*/      /*Scope*/ 20, /*->37893*/
/* 37873*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 37875*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37877*/       OPC_EmitMergeInputChains1_0,
/* 37878*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37881*/       OPC_EmitConvertToTarget, 2,
/* 37883*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37893*/      /*Scope*/ 20, /*->37914*/
/* 37894*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 37896*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37898*/       OPC_EmitMergeInputChains1_0,
/* 37899*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37902*/       OPC_EmitConvertToTarget, 2,
/* 37904*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 37914*/      0, /*End of Scope*/
/* 37915*/     /*SwitchType*/ 20, MVT::i64,// ->37937
/* 37917*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 37919*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37921*/      OPC_EmitMergeInputChains1_0,
/* 37922*/      OPC_EmitInteger, MVT::i32, 0, 
/* 37925*/      OPC_EmitConvertToTarget, 2,
/* 37927*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37937*/     0, // EndSwitchType
/* 37938*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->38076
/* 37941*/     OPC_MoveParent,
/* 37942*/     OPC_RecordChild2, // #3 = $val
/* 37943*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->38053
/* 37946*/      OPC_Scope, 20, /*->37968*/ // 5 children in Scope
/* 37948*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 37950*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37952*/       OPC_EmitMergeInputChains1_0,
/* 37953*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37956*/       OPC_EmitConvertToTarget, 2,
/* 37958*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37968*/      /*Scope*/ 20, /*->37989*/
/* 37969*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 37971*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37973*/       OPC_EmitMergeInputChains1_0,
/* 37974*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37977*/       OPC_EmitConvertToTarget, 2,
/* 37979*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 37989*/      /*Scope*/ 20, /*->38010*/
/* 37990*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 37992*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 37994*/       OPC_EmitMergeInputChains1_0,
/* 37995*/       OPC_EmitInteger, MVT::i32, 0, 
/* 37998*/       OPC_EmitConvertToTarget, 2,
/* 38000*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38010*/      /*Scope*/ 20, /*->38031*/
/* 38011*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38013*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38015*/       OPC_EmitMergeInputChains1_0,
/* 38016*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38019*/       OPC_EmitConvertToTarget, 2,
/* 38021*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38031*/      /*Scope*/ 20, /*->38052*/
/* 38032*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38034*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38036*/       OPC_EmitMergeInputChains1_0,
/* 38037*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38040*/       OPC_EmitConvertToTarget, 2,
/* 38042*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38052*/      0, /*End of Scope*/
/* 38053*/     /*SwitchType*/ 20, MVT::i64,// ->38075
/* 38055*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 38057*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38059*/      OPC_EmitMergeInputChains1_0,
/* 38060*/      OPC_EmitInteger, MVT::i32, 0, 
/* 38063*/      OPC_EmitConvertToTarget, 2,
/* 38065*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 38075*/     0, // EndSwitchType
/* 38076*/    0, // EndSwitchType
/* 38077*/   /*SwitchOpcode*/ 31|128,2/*287*/, TARGET_VAL(ISD::OR),// ->38368
/* 38081*/    OPC_RecordChild0, // #1 = $addr
/* 38082*/    OPC_RecordChild1, // #2 = $off
/* 38083*/    OPC_MoveChild1,
/* 38084*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38087*/    OPC_MoveParent,
/* 38088*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 38090*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->38229
/* 38094*/     OPC_MoveParent,
/* 38095*/     OPC_RecordChild2, // #3 = $val
/* 38096*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->38206
/* 38099*/      OPC_Scope, 20, /*->38121*/ // 5 children in Scope
/* 38101*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 38103*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38105*/       OPC_EmitMergeInputChains1_0,
/* 38106*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38109*/       OPC_EmitConvertToTarget, 2,
/* 38111*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 38121*/      /*Scope*/ 20, /*->38142*/
/* 38122*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38124*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38126*/       OPC_EmitMergeInputChains1_0,
/* 38127*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38130*/       OPC_EmitConvertToTarget, 2,
/* 38132*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 38142*/      /*Scope*/ 20, /*->38163*/
/* 38143*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38145*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38147*/       OPC_EmitMergeInputChains1_0,
/* 38148*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38151*/       OPC_EmitConvertToTarget, 2,
/* 38153*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 38163*/      /*Scope*/ 20, /*->38184*/
/* 38164*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38166*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38168*/       OPC_EmitMergeInputChains1_0,
/* 38169*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38172*/       OPC_EmitConvertToTarget, 2,
/* 38174*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 38184*/      /*Scope*/ 20, /*->38205*/
/* 38185*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38187*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38189*/       OPC_EmitMergeInputChains1_0,
/* 38190*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38193*/       OPC_EmitConvertToTarget, 2,
/* 38195*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 38205*/      0, /*End of Scope*/
/* 38206*/     /*SwitchType*/ 20, MVT::i64,// ->38228
/* 38208*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 38210*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38212*/      OPC_EmitMergeInputChains1_0,
/* 38213*/      OPC_EmitInteger, MVT::i32, 0, 
/* 38216*/      OPC_EmitConvertToTarget, 2,
/* 38218*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_sub:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 38228*/     0, // EndSwitchType
/* 38229*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->38367
/* 38232*/     OPC_MoveParent,
/* 38233*/     OPC_RecordChild2, // #3 = $val
/* 38234*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->38344
/* 38237*/      OPC_Scope, 20, /*->38259*/ // 5 children in Scope
/* 38239*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 38241*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38243*/       OPC_EmitMergeInputChains1_0,
/* 38244*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38247*/       OPC_EmitConvertToTarget, 2,
/* 38249*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38259*/      /*Scope*/ 20, /*->38280*/
/* 38260*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38262*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38264*/       OPC_EmitMergeInputChains1_0,
/* 38265*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38268*/       OPC_EmitConvertToTarget, 2,
/* 38270*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38280*/      /*Scope*/ 20, /*->38301*/
/* 38281*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38283*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38285*/       OPC_EmitMergeInputChains1_0,
/* 38286*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38289*/       OPC_EmitConvertToTarget, 2,
/* 38291*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38301*/      /*Scope*/ 20, /*->38322*/
/* 38302*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38304*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38306*/       OPC_EmitMergeInputChains1_0,
/* 38307*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38310*/       OPC_EmitConvertToTarget, 2,
/* 38312*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38322*/      /*Scope*/ 20, /*->38343*/
/* 38323*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38325*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38327*/       OPC_EmitMergeInputChains1_0,
/* 38328*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38331*/       OPC_EmitConvertToTarget, 2,
/* 38333*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 38343*/      0, /*End of Scope*/
/* 38344*/     /*SwitchType*/ 20, MVT::i64,// ->38366
/* 38346*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 38348*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38350*/      OPC_EmitMergeInputChains1_0,
/* 38351*/      OPC_EmitInteger, MVT::i32, 0, 
/* 38354*/      OPC_EmitConvertToTarget, 2,
/* 38356*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_sub:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 38366*/     0, // EndSwitchType
/* 38367*/    0, // EndSwitchType
/* 38368*/   /*SwitchOpcode*/ 114|128,2/*370*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->38742
/* 38372*/    OPC_RecordChild0, // #1 = $off
/* 38373*/    OPC_MoveChild0,
/* 38374*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38377*/    OPC_MoveParent,
/* 38378*/    OPC_MoveParent,
/* 38379*/    OPC_RecordChild2, // #2 = $val
/* 38380*/    OPC_SwitchType /*2 cases */, 41|128,2/*297*/, MVT::i32,// ->38681
/* 38384*/     OPC_Scope, 58, /*->38444*/ // 5 children in Scope
/* 38386*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 38388*/      OPC_Scope, 26, /*->38416*/ // 2 children in Scope
/* 38390*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38392*/       OPC_EmitMergeInputChains1_0,
/* 38393*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38396*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38399*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38406*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38416*/      /*Scope*/ 26, /*->38443*/
/* 38417*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38419*/       OPC_EmitMergeInputChains1_0,
/* 38420*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38423*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38426*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 38433*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38443*/      0, /*End of Scope*/
/* 38444*/     /*Scope*/ 58, /*->38503*/
/* 38445*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38447*/      OPC_Scope, 26, /*->38475*/ // 2 children in Scope
/* 38449*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38451*/       OPC_EmitMergeInputChains1_0,
/* 38452*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38455*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38458*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38465*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38475*/      /*Scope*/ 26, /*->38502*/
/* 38476*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38478*/       OPC_EmitMergeInputChains1_0,
/* 38479*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38482*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38485*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 38492*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38502*/      0, /*End of Scope*/
/* 38503*/     /*Scope*/ 58, /*->38562*/
/* 38504*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38506*/      OPC_Scope, 26, /*->38534*/ // 2 children in Scope
/* 38508*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38510*/       OPC_EmitMergeInputChains1_0,
/* 38511*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38514*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38517*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38524*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38534*/      /*Scope*/ 26, /*->38561*/
/* 38535*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38537*/       OPC_EmitMergeInputChains1_0,
/* 38538*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38541*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38544*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 38551*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38561*/      0, /*End of Scope*/
/* 38562*/     /*Scope*/ 58, /*->38621*/
/* 38563*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38565*/      OPC_Scope, 26, /*->38593*/ // 2 children in Scope
/* 38567*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38569*/       OPC_EmitMergeInputChains1_0,
/* 38570*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38573*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38576*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38583*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38593*/      /*Scope*/ 26, /*->38620*/
/* 38594*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38596*/       OPC_EmitMergeInputChains1_0,
/* 38597*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38600*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38603*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 38610*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38620*/      0, /*End of Scope*/
/* 38621*/     /*Scope*/ 58, /*->38680*/
/* 38622*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38624*/      OPC_Scope, 26, /*->38652*/ // 2 children in Scope
/* 38626*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38628*/       OPC_EmitMergeInputChains1_0,
/* 38629*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38632*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38635*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38642*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38652*/      /*Scope*/ 26, /*->38679*/
/* 38653*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38655*/       OPC_EmitMergeInputChains1_0,
/* 38656*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38659*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38662*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 38669*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38679*/      0, /*End of Scope*/
/* 38680*/     0, /*End of Scope*/
/* 38681*/    /*SwitchType*/ 58, MVT::i64,// ->38741
/* 38683*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 38685*/     OPC_Scope, 26, /*->38713*/ // 2 children in Scope
/* 38687*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38689*/      OPC_EmitMergeInputChains1_0,
/* 38690*/      OPC_EmitInteger, MVT::i32, 0, 
/* 38693*/      OPC_EmitInteger, MVT::i32, 0, 
/* 38696*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38703*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_sub:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 38713*/     /*Scope*/ 26, /*->38740*/
/* 38714*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 38716*/      OPC_EmitMergeInputChains1_0,
/* 38717*/      OPC_EmitInteger, MVT::i32, 0, 
/* 38720*/      OPC_EmitInteger, MVT::i64, 0, 
/* 38723*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 38730*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_sub:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 38740*/     0, /*End of Scope*/
/* 38741*/    0, // EndSwitchType
/* 38742*/   0, // EndSwitchOpcode
/* 38743*/  /*Scope*/ 45|128,5/*685*/, /*->39430*/
/* 38745*/   OPC_RecordChild1, // #1 = $off
/* 38746*/   OPC_Scope, 8|128,3/*392*/, /*->39141*/ // 3 children in Scope
/* 38749*/    OPC_MoveChild1,
/* 38750*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38753*/    OPC_MoveParent,
/* 38754*/    OPC_RecordChild2, // #2 = $val
/* 38755*/    OPC_SwitchType /*2 cases */, 61|128,2/*317*/, MVT::i32,// ->39076
/* 38759*/     OPC_Scope, 62, /*->38823*/ // 5 children in Scope
/* 38761*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 38763*/      OPC_Scope, 28, /*->38793*/ // 2 children in Scope
/* 38765*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38767*/       OPC_EmitMergeInputChains1_0,
/* 38768*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38771*/       OPC_EmitConvertToTarget, 1,
/* 38773*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38776*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 38783*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38793*/      /*Scope*/ 28, /*->38822*/
/* 38794*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38796*/       OPC_EmitMergeInputChains1_0,
/* 38797*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38800*/       OPC_EmitConvertToTarget, 1,
/* 38802*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38805*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 38812*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38822*/      0, /*End of Scope*/
/* 38823*/     /*Scope*/ 62, /*->38886*/
/* 38824*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38826*/      OPC_Scope, 28, /*->38856*/ // 2 children in Scope
/* 38828*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38830*/       OPC_EmitMergeInputChains1_0,
/* 38831*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38834*/       OPC_EmitConvertToTarget, 1,
/* 38836*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38839*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 38846*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38856*/      /*Scope*/ 28, /*->38885*/
/* 38857*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38859*/       OPC_EmitMergeInputChains1_0,
/* 38860*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38863*/       OPC_EmitConvertToTarget, 1,
/* 38865*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38868*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 38875*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38885*/      0, /*End of Scope*/
/* 38886*/     /*Scope*/ 62, /*->38949*/
/* 38887*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 38889*/      OPC_Scope, 28, /*->38919*/ // 2 children in Scope
/* 38891*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38893*/       OPC_EmitMergeInputChains1_0,
/* 38894*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38897*/       OPC_EmitConvertToTarget, 1,
/* 38899*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38902*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 38909*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38919*/      /*Scope*/ 28, /*->38948*/
/* 38920*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38922*/       OPC_EmitMergeInputChains1_0,
/* 38923*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38926*/       OPC_EmitConvertToTarget, 1,
/* 38928*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38931*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 38938*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 38948*/      0, /*End of Scope*/
/* 38949*/     /*Scope*/ 62, /*->39012*/
/* 38950*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 38952*/      OPC_Scope, 28, /*->38982*/ // 2 children in Scope
/* 38954*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38956*/       OPC_EmitMergeInputChains1_0,
/* 38957*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38960*/       OPC_EmitConvertToTarget, 1,
/* 38962*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38965*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 38972*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 38982*/      /*Scope*/ 28, /*->39011*/
/* 38983*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 38985*/       OPC_EmitMergeInputChains1_0,
/* 38986*/       OPC_EmitInteger, MVT::i32, 0, 
/* 38989*/       OPC_EmitConvertToTarget, 1,
/* 38991*/       OPC_EmitInteger, MVT::i64, 0, 
/* 38994*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 39001*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 39011*/      0, /*End of Scope*/
/* 39012*/     /*Scope*/ 62, /*->39075*/
/* 39013*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 39015*/      OPC_Scope, 28, /*->39045*/ // 2 children in Scope
/* 39017*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39019*/       OPC_EmitMergeInputChains1_0,
/* 39020*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39023*/       OPC_EmitConvertToTarget, 1,
/* 39025*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39028*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 39035*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 39045*/      /*Scope*/ 28, /*->39074*/
/* 39046*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39048*/       OPC_EmitMergeInputChains1_0,
/* 39049*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39052*/       OPC_EmitConvertToTarget, 1,
/* 39054*/       OPC_EmitInteger, MVT::i64, 0, 
/* 39057*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 39064*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 39074*/      0, /*End of Scope*/
/* 39075*/     0, /*End of Scope*/
/* 39076*/    /*SwitchType*/ 62, MVT::i64,// ->39140
/* 39078*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 39080*/     OPC_Scope, 28, /*->39110*/ // 2 children in Scope
/* 39082*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39084*/      OPC_EmitMergeInputChains1_0,
/* 39085*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39088*/      OPC_EmitConvertToTarget, 1,
/* 39090*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39093*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 39100*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_sub:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 39110*/     /*Scope*/ 28, /*->39139*/
/* 39111*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39113*/      OPC_EmitMergeInputChains1_0,
/* 39114*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39117*/      OPC_EmitConvertToTarget, 1,
/* 39119*/      OPC_EmitInteger, MVT::i64, 0, 
/* 39122*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 39129*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_sub:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 39139*/     0, /*End of Scope*/
/* 39140*/    0, // EndSwitchType
/* 39141*/   /*Scope*/ 14|128,1/*142*/, /*->39285*/
/* 39143*/    OPC_CheckChild1Type, MVT::i32,
/* 39145*/    OPC_RecordChild2, // #2 = $val
/* 39146*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->39261
/* 39149*/     OPC_Scope, 21, /*->39172*/ // 5 children in Scope
/* 39151*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 39153*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39155*/      OPC_EmitMergeInputChains1_0,
/* 39156*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39159*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39172*/     /*Scope*/ 21, /*->39194*/
/* 39173*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 39175*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39177*/      OPC_EmitMergeInputChains1_0,
/* 39178*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39181*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39194*/     /*Scope*/ 21, /*->39216*/
/* 39195*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 39197*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39199*/      OPC_EmitMergeInputChains1_0,
/* 39200*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39203*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39206*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39216*/     /*Scope*/ 21, /*->39238*/
/* 39217*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 39219*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39221*/      OPC_EmitMergeInputChains1_0,
/* 39222*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39225*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39228*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39238*/     /*Scope*/ 21, /*->39260*/
/* 39239*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 39241*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39243*/      OPC_EmitMergeInputChains1_0,
/* 39244*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39247*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39250*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39260*/     0, /*End of Scope*/
/* 39261*/    /*SwitchType*/ 21, MVT::i64,// ->39284
/* 39263*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 39265*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39267*/     OPC_EmitMergeInputChains1_0,
/* 39268*/     OPC_EmitInteger, MVT::i32, 0, 
/* 39271*/     OPC_EmitInteger, MVT::i32, 0, 
/* 39274*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_sub:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 39284*/    0, // EndSwitchType
/* 39285*/   /*Scope*/ 14|128,1/*142*/, /*->39429*/
/* 39287*/    OPC_CheckChild1Type, MVT::i64,
/* 39289*/    OPC_RecordChild2, // #2 = $val
/* 39290*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->39405
/* 39293*/     OPC_Scope, 21, /*->39316*/ // 5 children in Scope
/* 39295*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_sub_32
/* 39297*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39299*/      OPC_EmitMergeInputChains1_0,
/* 39300*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39303*/      OPC_EmitInteger, MVT::i64, 0, 
/* 39306*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39316*/     /*Scope*/ 21, /*->39338*/
/* 39317*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 39319*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39321*/      OPC_EmitMergeInputChains1_0,
/* 39322*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39325*/      OPC_EmitInteger, MVT::i64, 0, 
/* 39328*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39338*/     /*Scope*/ 21, /*->39360*/
/* 39339*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 39341*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39343*/      OPC_EmitMergeInputChains1_0,
/* 39344*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39347*/      OPC_EmitInteger, MVT::i64, 0, 
/* 39350*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39360*/     /*Scope*/ 21, /*->39382*/
/* 39361*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 39363*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39365*/      OPC_EmitMergeInputChains1_0,
/* 39366*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39369*/      OPC_EmitInteger, MVT::i64, 0, 
/* 39372*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39382*/     /*Scope*/ 21, /*->39404*/
/* 39383*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 39385*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39387*/      OPC_EmitMergeInputChains1_0,
/* 39388*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39391*/      OPC_EmitInteger, MVT::i64, 0, 
/* 39394*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_sub:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39404*/     0, /*End of Scope*/
/* 39405*/    /*SwitchType*/ 21, MVT::i64,// ->39428
/* 39407*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_64
/* 39409*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39411*/     OPC_EmitMergeInputChains1_0,
/* 39412*/     OPC_EmitInteger, MVT::i32, 0, 
/* 39415*/     OPC_EmitInteger, MVT::i64, 0, 
/* 39418*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_sub:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 39428*/    0, // EndSwitchType
/* 39429*/   0, /*End of Scope*/
/* 39430*/  0, /*End of Scope*/
/* 39431*/ /*SwitchOpcode*/ 116|128,12/*1652*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->41087
/* 39435*/  OPC_RecordMemRef,
/* 39436*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 39437*/  OPC_Scope, 63|128,7/*959*/, /*->40399*/ // 2 children in Scope
/* 39440*/   OPC_MoveChild1,
/* 39441*/   OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->39733
/* 39446*/    OPC_RecordChild0, // #1 = $addr
/* 39447*/    OPC_RecordChild1, // #2 = $off
/* 39448*/    OPC_MoveChild1,
/* 39449*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39452*/    OPC_MoveParent,
/* 39453*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 39455*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->39594
/* 39459*/     OPC_MoveParent,
/* 39460*/     OPC_RecordChild2, // #3 = $val
/* 39461*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->39571
/* 39464*/      OPC_Scope, 20, /*->39486*/ // 5 children in Scope
/* 39466*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 39468*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39470*/       OPC_EmitMergeInputChains1_0,
/* 39471*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39474*/       OPC_EmitConvertToTarget, 2,
/* 39476*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39486*/      /*Scope*/ 20, /*->39507*/
/* 39487*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39489*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39491*/       OPC_EmitMergeInputChains1_0,
/* 39492*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39495*/       OPC_EmitConvertToTarget, 2,
/* 39497*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39507*/      /*Scope*/ 20, /*->39528*/
/* 39508*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39510*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39512*/       OPC_EmitMergeInputChains1_0,
/* 39513*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39516*/       OPC_EmitConvertToTarget, 2,
/* 39518*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39528*/      /*Scope*/ 20, /*->39549*/
/* 39529*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39531*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39533*/       OPC_EmitMergeInputChains1_0,
/* 39534*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39537*/       OPC_EmitConvertToTarget, 2,
/* 39539*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39549*/      /*Scope*/ 20, /*->39570*/
/* 39550*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39552*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39554*/       OPC_EmitMergeInputChains1_0,
/* 39555*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39558*/       OPC_EmitConvertToTarget, 2,
/* 39560*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39570*/      0, /*End of Scope*/
/* 39571*/     /*SwitchType*/ 20, MVT::i64,// ->39593
/* 39573*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 39575*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39577*/      OPC_EmitMergeInputChains1_0,
/* 39578*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39581*/      OPC_EmitConvertToTarget, 2,
/* 39583*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 39593*/     0, // EndSwitchType
/* 39594*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->39732
/* 39597*/     OPC_MoveParent,
/* 39598*/     OPC_RecordChild2, // #3 = $val
/* 39599*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->39709
/* 39602*/      OPC_Scope, 20, /*->39624*/ // 5 children in Scope
/* 39604*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 39606*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39608*/       OPC_EmitMergeInputChains1_0,
/* 39609*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39612*/       OPC_EmitConvertToTarget, 2,
/* 39614*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39624*/      /*Scope*/ 20, /*->39645*/
/* 39625*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39627*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39629*/       OPC_EmitMergeInputChains1_0,
/* 39630*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39633*/       OPC_EmitConvertToTarget, 2,
/* 39635*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39645*/      /*Scope*/ 20, /*->39666*/
/* 39646*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39648*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39650*/       OPC_EmitMergeInputChains1_0,
/* 39651*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39654*/       OPC_EmitConvertToTarget, 2,
/* 39656*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39666*/      /*Scope*/ 20, /*->39687*/
/* 39667*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39669*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39671*/       OPC_EmitMergeInputChains1_0,
/* 39672*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39675*/       OPC_EmitConvertToTarget, 2,
/* 39677*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39687*/      /*Scope*/ 20, /*->39708*/
/* 39688*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39690*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39692*/       OPC_EmitMergeInputChains1_0,
/* 39693*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39696*/       OPC_EmitConvertToTarget, 2,
/* 39698*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39708*/      0, /*End of Scope*/
/* 39709*/     /*SwitchType*/ 20, MVT::i64,// ->39731
/* 39711*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 39713*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39715*/      OPC_EmitMergeInputChains1_0,
/* 39716*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39719*/      OPC_EmitConvertToTarget, 2,
/* 39721*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 39731*/     0, // EndSwitchType
/* 39732*/    0, // EndSwitchType
/* 39733*/   /*SwitchOpcode*/ 31|128,2/*287*/, TARGET_VAL(ISD::OR),// ->40024
/* 39737*/    OPC_RecordChild0, // #1 = $addr
/* 39738*/    OPC_RecordChild1, // #2 = $off
/* 39739*/    OPC_MoveChild1,
/* 39740*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39743*/    OPC_MoveParent,
/* 39744*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 39746*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->39885
/* 39750*/     OPC_MoveParent,
/* 39751*/     OPC_RecordChild2, // #3 = $val
/* 39752*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->39862
/* 39755*/      OPC_Scope, 20, /*->39777*/ // 5 children in Scope
/* 39757*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 39759*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39761*/       OPC_EmitMergeInputChains1_0,
/* 39762*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39765*/       OPC_EmitConvertToTarget, 2,
/* 39767*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39777*/      /*Scope*/ 20, /*->39798*/
/* 39778*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39780*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39782*/       OPC_EmitMergeInputChains1_0,
/* 39783*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39786*/       OPC_EmitConvertToTarget, 2,
/* 39788*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39798*/      /*Scope*/ 20, /*->39819*/
/* 39799*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39801*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39803*/       OPC_EmitMergeInputChains1_0,
/* 39804*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39807*/       OPC_EmitConvertToTarget, 2,
/* 39809*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39819*/      /*Scope*/ 20, /*->39840*/
/* 39820*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39822*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39824*/       OPC_EmitMergeInputChains1_0,
/* 39825*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39828*/       OPC_EmitConvertToTarget, 2,
/* 39830*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39840*/      /*Scope*/ 20, /*->39861*/
/* 39841*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39843*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39845*/       OPC_EmitMergeInputChains1_0,
/* 39846*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39849*/       OPC_EmitConvertToTarget, 2,
/* 39851*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 39861*/      0, /*End of Scope*/
/* 39862*/     /*SwitchType*/ 20, MVT::i64,// ->39884
/* 39864*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 39866*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39868*/      OPC_EmitMergeInputChains1_0,
/* 39869*/      OPC_EmitInteger, MVT::i32, 0, 
/* 39872*/      OPC_EmitConvertToTarget, 2,
/* 39874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_and:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 39884*/     0, // EndSwitchType
/* 39885*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->40023
/* 39888*/     OPC_MoveParent,
/* 39889*/     OPC_RecordChild2, // #3 = $val
/* 39890*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->40000
/* 39893*/      OPC_Scope, 20, /*->39915*/ // 5 children in Scope
/* 39895*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 39897*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39899*/       OPC_EmitMergeInputChains1_0,
/* 39900*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39903*/       OPC_EmitConvertToTarget, 2,
/* 39905*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39915*/      /*Scope*/ 20, /*->39936*/
/* 39916*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39918*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39920*/       OPC_EmitMergeInputChains1_0,
/* 39921*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39924*/       OPC_EmitConvertToTarget, 2,
/* 39926*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39936*/      /*Scope*/ 20, /*->39957*/
/* 39937*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39939*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39941*/       OPC_EmitMergeInputChains1_0,
/* 39942*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39945*/       OPC_EmitConvertToTarget, 2,
/* 39947*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39957*/      /*Scope*/ 20, /*->39978*/
/* 39958*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 39960*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39962*/       OPC_EmitMergeInputChains1_0,
/* 39963*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39966*/       OPC_EmitConvertToTarget, 2,
/* 39968*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39978*/      /*Scope*/ 20, /*->39999*/
/* 39979*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 39981*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 39983*/       OPC_EmitMergeInputChains1_0,
/* 39984*/       OPC_EmitInteger, MVT::i32, 0, 
/* 39987*/       OPC_EmitConvertToTarget, 2,
/* 39989*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 39999*/      0, /*End of Scope*/
/* 40000*/     /*SwitchType*/ 20, MVT::i64,// ->40022
/* 40002*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 40004*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40006*/      OPC_EmitMergeInputChains1_0,
/* 40007*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40010*/      OPC_EmitConvertToTarget, 2,
/* 40012*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_and:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 40022*/     0, // EndSwitchType
/* 40023*/    0, // EndSwitchType
/* 40024*/   /*SwitchOpcode*/ 114|128,2/*370*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->40398
/* 40028*/    OPC_RecordChild0, // #1 = $off
/* 40029*/    OPC_MoveChild0,
/* 40030*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40033*/    OPC_MoveParent,
/* 40034*/    OPC_MoveParent,
/* 40035*/    OPC_RecordChild2, // #2 = $val
/* 40036*/    OPC_SwitchType /*2 cases */, 41|128,2/*297*/, MVT::i32,// ->40337
/* 40040*/     OPC_Scope, 58, /*->40100*/ // 5 children in Scope
/* 40042*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 40044*/      OPC_Scope, 26, /*->40072*/ // 2 children in Scope
/* 40046*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40048*/       OPC_EmitMergeInputChains1_0,
/* 40049*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40052*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40055*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40062*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40072*/      /*Scope*/ 26, /*->40099*/
/* 40073*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40075*/       OPC_EmitMergeInputChains1_0,
/* 40076*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40079*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40082*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 40089*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40099*/      0, /*End of Scope*/
/* 40100*/     /*Scope*/ 58, /*->40159*/
/* 40101*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40103*/      OPC_Scope, 26, /*->40131*/ // 2 children in Scope
/* 40105*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40107*/       OPC_EmitMergeInputChains1_0,
/* 40108*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40111*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40114*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40121*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40131*/      /*Scope*/ 26, /*->40158*/
/* 40132*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40134*/       OPC_EmitMergeInputChains1_0,
/* 40135*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40138*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40141*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 40148*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40158*/      0, /*End of Scope*/
/* 40159*/     /*Scope*/ 58, /*->40218*/
/* 40160*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40162*/      OPC_Scope, 26, /*->40190*/ // 2 children in Scope
/* 40164*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40166*/       OPC_EmitMergeInputChains1_0,
/* 40167*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40170*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40173*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40180*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40190*/      /*Scope*/ 26, /*->40217*/
/* 40191*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40193*/       OPC_EmitMergeInputChains1_0,
/* 40194*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40197*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40200*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 40207*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40217*/      0, /*End of Scope*/
/* 40218*/     /*Scope*/ 58, /*->40277*/
/* 40219*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40221*/      OPC_Scope, 26, /*->40249*/ // 2 children in Scope
/* 40223*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40225*/       OPC_EmitMergeInputChains1_0,
/* 40226*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40229*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40232*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40239*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40249*/      /*Scope*/ 26, /*->40276*/
/* 40250*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40252*/       OPC_EmitMergeInputChains1_0,
/* 40253*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40256*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40259*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 40266*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40276*/      0, /*End of Scope*/
/* 40277*/     /*Scope*/ 58, /*->40336*/
/* 40278*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40280*/      OPC_Scope, 26, /*->40308*/ // 2 children in Scope
/* 40282*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40284*/       OPC_EmitMergeInputChains1_0,
/* 40285*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40288*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40291*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40298*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40308*/      /*Scope*/ 26, /*->40335*/
/* 40309*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40311*/       OPC_EmitMergeInputChains1_0,
/* 40312*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40315*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40318*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 40325*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40335*/      0, /*End of Scope*/
/* 40336*/     0, /*End of Scope*/
/* 40337*/    /*SwitchType*/ 58, MVT::i64,// ->40397
/* 40339*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 40341*/     OPC_Scope, 26, /*->40369*/ // 2 children in Scope
/* 40343*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40345*/      OPC_EmitMergeInputChains1_0,
/* 40346*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40349*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40352*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40359*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_and:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 40369*/     /*Scope*/ 26, /*->40396*/
/* 40370*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 40372*/      OPC_EmitMergeInputChains1_0,
/* 40373*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40376*/      OPC_EmitInteger, MVT::i64, 0, 
/* 40379*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 40386*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_and:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 40396*/     0, /*End of Scope*/
/* 40397*/    0, // EndSwitchType
/* 40398*/   0, // EndSwitchOpcode
/* 40399*/  /*Scope*/ 45|128,5/*685*/, /*->41086*/
/* 40401*/   OPC_RecordChild1, // #1 = $off
/* 40402*/   OPC_Scope, 8|128,3/*392*/, /*->40797*/ // 3 children in Scope
/* 40405*/    OPC_MoveChild1,
/* 40406*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40409*/    OPC_MoveParent,
/* 40410*/    OPC_RecordChild2, // #2 = $val
/* 40411*/    OPC_SwitchType /*2 cases */, 61|128,2/*317*/, MVT::i32,// ->40732
/* 40415*/     OPC_Scope, 62, /*->40479*/ // 5 children in Scope
/* 40417*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 40419*/      OPC_Scope, 28, /*->40449*/ // 2 children in Scope
/* 40421*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40423*/       OPC_EmitMergeInputChains1_0,
/* 40424*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40427*/       OPC_EmitConvertToTarget, 1,
/* 40429*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40432*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40439*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40449*/      /*Scope*/ 28, /*->40478*/
/* 40450*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40452*/       OPC_EmitMergeInputChains1_0,
/* 40453*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40456*/       OPC_EmitConvertToTarget, 1,
/* 40458*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40461*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 40468*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40478*/      0, /*End of Scope*/
/* 40479*/     /*Scope*/ 62, /*->40542*/
/* 40480*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40482*/      OPC_Scope, 28, /*->40512*/ // 2 children in Scope
/* 40484*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40486*/       OPC_EmitMergeInputChains1_0,
/* 40487*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40490*/       OPC_EmitConvertToTarget, 1,
/* 40492*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40495*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40502*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40512*/      /*Scope*/ 28, /*->40541*/
/* 40513*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40515*/       OPC_EmitMergeInputChains1_0,
/* 40516*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40519*/       OPC_EmitConvertToTarget, 1,
/* 40521*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40524*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 40531*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40541*/      0, /*End of Scope*/
/* 40542*/     /*Scope*/ 62, /*->40605*/
/* 40543*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40545*/      OPC_Scope, 28, /*->40575*/ // 2 children in Scope
/* 40547*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40549*/       OPC_EmitMergeInputChains1_0,
/* 40550*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40553*/       OPC_EmitConvertToTarget, 1,
/* 40555*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40558*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40565*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40575*/      /*Scope*/ 28, /*->40604*/
/* 40576*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40578*/       OPC_EmitMergeInputChains1_0,
/* 40579*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40582*/       OPC_EmitConvertToTarget, 1,
/* 40584*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40587*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 40594*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40604*/      0, /*End of Scope*/
/* 40605*/     /*Scope*/ 62, /*->40668*/
/* 40606*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40608*/      OPC_Scope, 28, /*->40638*/ // 2 children in Scope
/* 40610*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40612*/       OPC_EmitMergeInputChains1_0,
/* 40613*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40616*/       OPC_EmitConvertToTarget, 1,
/* 40618*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40621*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40628*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40638*/      /*Scope*/ 28, /*->40667*/
/* 40639*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40641*/       OPC_EmitMergeInputChains1_0,
/* 40642*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40645*/       OPC_EmitConvertToTarget, 1,
/* 40647*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40650*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 40657*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40667*/      0, /*End of Scope*/
/* 40668*/     /*Scope*/ 62, /*->40731*/
/* 40669*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40671*/      OPC_Scope, 28, /*->40701*/ // 2 children in Scope
/* 40673*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40675*/       OPC_EmitMergeInputChains1_0,
/* 40676*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40679*/       OPC_EmitConvertToTarget, 1,
/* 40681*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40684*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40691*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 40701*/      /*Scope*/ 28, /*->40730*/
/* 40702*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40704*/       OPC_EmitMergeInputChains1_0,
/* 40705*/       OPC_EmitInteger, MVT::i32, 0, 
/* 40708*/       OPC_EmitConvertToTarget, 1,
/* 40710*/       OPC_EmitInteger, MVT::i64, 0, 
/* 40713*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 40720*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 40730*/      0, /*End of Scope*/
/* 40731*/     0, /*End of Scope*/
/* 40732*/    /*SwitchType*/ 62, MVT::i64,// ->40796
/* 40734*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 40736*/     OPC_Scope, 28, /*->40766*/ // 2 children in Scope
/* 40738*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40740*/      OPC_EmitMergeInputChains1_0,
/* 40741*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40744*/      OPC_EmitConvertToTarget, 1,
/* 40746*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40749*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40756*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_and:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 40766*/     /*Scope*/ 28, /*->40795*/
/* 40767*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40769*/      OPC_EmitMergeInputChains1_0,
/* 40770*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40773*/      OPC_EmitConvertToTarget, 1,
/* 40775*/      OPC_EmitInteger, MVT::i64, 0, 
/* 40778*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 40785*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_and:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 40795*/     0, /*End of Scope*/
/* 40796*/    0, // EndSwitchType
/* 40797*/   /*Scope*/ 14|128,1/*142*/, /*->40941*/
/* 40799*/    OPC_CheckChild1Type, MVT::i32,
/* 40801*/    OPC_RecordChild2, // #2 = $val
/* 40802*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->40917
/* 40805*/     OPC_Scope, 21, /*->40828*/ // 5 children in Scope
/* 40807*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 40809*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40811*/      OPC_EmitMergeInputChains1_0,
/* 40812*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40815*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40818*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 40828*/     /*Scope*/ 21, /*->40850*/
/* 40829*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40831*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40833*/      OPC_EmitMergeInputChains1_0,
/* 40834*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40837*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40840*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 40850*/     /*Scope*/ 21, /*->40872*/
/* 40851*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40853*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40855*/      OPC_EmitMergeInputChains1_0,
/* 40856*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40859*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40862*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 40872*/     /*Scope*/ 21, /*->40894*/
/* 40873*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40875*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40877*/      OPC_EmitMergeInputChains1_0,
/* 40878*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40881*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40884*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 40894*/     /*Scope*/ 21, /*->40916*/
/* 40895*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40897*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40899*/      OPC_EmitMergeInputChains1_0,
/* 40900*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40903*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 40916*/     0, /*End of Scope*/
/* 40917*/    /*SwitchType*/ 21, MVT::i64,// ->40940
/* 40919*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 40921*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40923*/     OPC_EmitMergeInputChains1_0,
/* 40924*/     OPC_EmitInteger, MVT::i32, 0, 
/* 40927*/     OPC_EmitInteger, MVT::i32, 0, 
/* 40930*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_and:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 40940*/    0, // EndSwitchType
/* 40941*/   /*Scope*/ 14|128,1/*142*/, /*->41085*/
/* 40943*/    OPC_CheckChild1Type, MVT::i64,
/* 40945*/    OPC_RecordChild2, // #2 = $val
/* 40946*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->41061
/* 40949*/     OPC_Scope, 21, /*->40972*/ // 5 children in Scope
/* 40951*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_and_32
/* 40953*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40955*/      OPC_EmitMergeInputChains1_0,
/* 40956*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40959*/      OPC_EmitInteger, MVT::i64, 0, 
/* 40962*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 40972*/     /*Scope*/ 21, /*->40994*/
/* 40973*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 40975*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40977*/      OPC_EmitMergeInputChains1_0,
/* 40978*/      OPC_EmitInteger, MVT::i32, 0, 
/* 40981*/      OPC_EmitInteger, MVT::i64, 0, 
/* 40984*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 40994*/     /*Scope*/ 21, /*->41016*/
/* 40995*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 40997*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 40999*/      OPC_EmitMergeInputChains1_0,
/* 41000*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41003*/      OPC_EmitInteger, MVT::i64, 0, 
/* 41006*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41016*/     /*Scope*/ 21, /*->41038*/
/* 41017*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 41019*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41021*/      OPC_EmitMergeInputChains1_0,
/* 41022*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41025*/      OPC_EmitInteger, MVT::i64, 0, 
/* 41028*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41038*/     /*Scope*/ 21, /*->41060*/
/* 41039*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 41041*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41043*/      OPC_EmitMergeInputChains1_0,
/* 41044*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41047*/      OPC_EmitInteger, MVT::i64, 0, 
/* 41050*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_and:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41060*/     0, /*End of Scope*/
/* 41061*/    /*SwitchType*/ 21, MVT::i64,// ->41084
/* 41063*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_and_64
/* 41065*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41067*/     OPC_EmitMergeInputChains1_0,
/* 41068*/     OPC_EmitInteger, MVT::i32, 0, 
/* 41071*/     OPC_EmitInteger, MVT::i64, 0, 
/* 41074*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_and:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 41084*/    0, // EndSwitchType
/* 41085*/   0, /*End of Scope*/
/* 41086*/  0, /*End of Scope*/
/* 41087*/ /*SwitchOpcode*/ 116|128,12/*1652*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->42743
/* 41091*/  OPC_RecordMemRef,
/* 41092*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 41093*/  OPC_Scope, 63|128,7/*959*/, /*->42055*/ // 2 children in Scope
/* 41096*/   OPC_MoveChild1,
/* 41097*/   OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->41389
/* 41102*/    OPC_RecordChild0, // #1 = $addr
/* 41103*/    OPC_RecordChild1, // #2 = $off
/* 41104*/    OPC_MoveChild1,
/* 41105*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 41108*/    OPC_MoveParent,
/* 41109*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 41111*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->41250
/* 41115*/     OPC_MoveParent,
/* 41116*/     OPC_RecordChild2, // #3 = $val
/* 41117*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->41227
/* 41120*/      OPC_Scope, 20, /*->41142*/ // 5 children in Scope
/* 41122*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 41124*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41126*/       OPC_EmitMergeInputChains1_0,
/* 41127*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41130*/       OPC_EmitConvertToTarget, 2,
/* 41132*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41142*/      /*Scope*/ 20, /*->41163*/
/* 41143*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41145*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41147*/       OPC_EmitMergeInputChains1_0,
/* 41148*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41151*/       OPC_EmitConvertToTarget, 2,
/* 41153*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41163*/      /*Scope*/ 20, /*->41184*/
/* 41164*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41166*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41168*/       OPC_EmitMergeInputChains1_0,
/* 41169*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41172*/       OPC_EmitConvertToTarget, 2,
/* 41174*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41184*/      /*Scope*/ 20, /*->41205*/
/* 41185*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41187*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41189*/       OPC_EmitMergeInputChains1_0,
/* 41190*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41193*/       OPC_EmitConvertToTarget, 2,
/* 41195*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41205*/      /*Scope*/ 20, /*->41226*/
/* 41206*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41208*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41210*/       OPC_EmitMergeInputChains1_0,
/* 41211*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41214*/       OPC_EmitConvertToTarget, 2,
/* 41216*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41226*/      0, /*End of Scope*/
/* 41227*/     /*SwitchType*/ 20, MVT::i64,// ->41249
/* 41229*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 41231*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41233*/      OPC_EmitMergeInputChains1_0,
/* 41234*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41237*/      OPC_EmitConvertToTarget, 2,
/* 41239*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 41249*/     0, // EndSwitchType
/* 41250*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->41388
/* 41253*/     OPC_MoveParent,
/* 41254*/     OPC_RecordChild2, // #3 = $val
/* 41255*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->41365
/* 41258*/      OPC_Scope, 20, /*->41280*/ // 5 children in Scope
/* 41260*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 41262*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41264*/       OPC_EmitMergeInputChains1_0,
/* 41265*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41268*/       OPC_EmitConvertToTarget, 2,
/* 41270*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41280*/      /*Scope*/ 20, /*->41301*/
/* 41281*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41283*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41285*/       OPC_EmitMergeInputChains1_0,
/* 41286*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41289*/       OPC_EmitConvertToTarget, 2,
/* 41291*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41301*/      /*Scope*/ 20, /*->41322*/
/* 41302*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41304*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41306*/       OPC_EmitMergeInputChains1_0,
/* 41307*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41310*/       OPC_EmitConvertToTarget, 2,
/* 41312*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41322*/      /*Scope*/ 20, /*->41343*/
/* 41323*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41325*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41327*/       OPC_EmitMergeInputChains1_0,
/* 41328*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41331*/       OPC_EmitConvertToTarget, 2,
/* 41333*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41343*/      /*Scope*/ 20, /*->41364*/
/* 41344*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41346*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41348*/       OPC_EmitMergeInputChains1_0,
/* 41349*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41352*/       OPC_EmitConvertToTarget, 2,
/* 41354*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41364*/      0, /*End of Scope*/
/* 41365*/     /*SwitchType*/ 20, MVT::i64,// ->41387
/* 41367*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 41369*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41371*/      OPC_EmitMergeInputChains1_0,
/* 41372*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41375*/      OPC_EmitConvertToTarget, 2,
/* 41377*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 41387*/     0, // EndSwitchType
/* 41388*/    0, // EndSwitchType
/* 41389*/   /*SwitchOpcode*/ 31|128,2/*287*/, TARGET_VAL(ISD::OR),// ->41680
/* 41393*/    OPC_RecordChild0, // #1 = $addr
/* 41394*/    OPC_RecordChild1, // #2 = $off
/* 41395*/    OPC_MoveChild1,
/* 41396*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 41399*/    OPC_MoveParent,
/* 41400*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 41402*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->41541
/* 41406*/     OPC_MoveParent,
/* 41407*/     OPC_RecordChild2, // #3 = $val
/* 41408*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->41518
/* 41411*/      OPC_Scope, 20, /*->41433*/ // 5 children in Scope
/* 41413*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 41415*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41417*/       OPC_EmitMergeInputChains1_0,
/* 41418*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41421*/       OPC_EmitConvertToTarget, 2,
/* 41423*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41433*/      /*Scope*/ 20, /*->41454*/
/* 41434*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41436*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41438*/       OPC_EmitMergeInputChains1_0,
/* 41439*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41442*/       OPC_EmitConvertToTarget, 2,
/* 41444*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41454*/      /*Scope*/ 20, /*->41475*/
/* 41455*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41457*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41459*/       OPC_EmitMergeInputChains1_0,
/* 41460*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41463*/       OPC_EmitConvertToTarget, 2,
/* 41465*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41475*/      /*Scope*/ 20, /*->41496*/
/* 41476*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41478*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41480*/       OPC_EmitMergeInputChains1_0,
/* 41481*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41484*/       OPC_EmitConvertToTarget, 2,
/* 41486*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41496*/      /*Scope*/ 20, /*->41517*/
/* 41497*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41499*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41501*/       OPC_EmitMergeInputChains1_0,
/* 41502*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41505*/       OPC_EmitConvertToTarget, 2,
/* 41507*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41517*/      0, /*End of Scope*/
/* 41518*/     /*SwitchType*/ 20, MVT::i64,// ->41540
/* 41520*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 41522*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41524*/      OPC_EmitMergeInputChains1_0,
/* 41525*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41528*/      OPC_EmitConvertToTarget, 2,
/* 41530*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_or:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 41540*/     0, // EndSwitchType
/* 41541*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->41679
/* 41544*/     OPC_MoveParent,
/* 41545*/     OPC_RecordChild2, // #3 = $val
/* 41546*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->41656
/* 41549*/      OPC_Scope, 20, /*->41571*/ // 5 children in Scope
/* 41551*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 41553*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41555*/       OPC_EmitMergeInputChains1_0,
/* 41556*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41559*/       OPC_EmitConvertToTarget, 2,
/* 41561*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41571*/      /*Scope*/ 20, /*->41592*/
/* 41572*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41574*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41576*/       OPC_EmitMergeInputChains1_0,
/* 41577*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41580*/       OPC_EmitConvertToTarget, 2,
/* 41582*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41592*/      /*Scope*/ 20, /*->41613*/
/* 41593*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41595*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41597*/       OPC_EmitMergeInputChains1_0,
/* 41598*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41601*/       OPC_EmitConvertToTarget, 2,
/* 41603*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41613*/      /*Scope*/ 20, /*->41634*/
/* 41614*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41616*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41618*/       OPC_EmitMergeInputChains1_0,
/* 41619*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41622*/       OPC_EmitConvertToTarget, 2,
/* 41624*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41634*/      /*Scope*/ 20, /*->41655*/
/* 41635*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41637*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41639*/       OPC_EmitMergeInputChains1_0,
/* 41640*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41643*/       OPC_EmitConvertToTarget, 2,
/* 41645*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 41655*/      0, /*End of Scope*/
/* 41656*/     /*SwitchType*/ 20, MVT::i64,// ->41678
/* 41658*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 41660*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 41662*/      OPC_EmitMergeInputChains1_0,
/* 41663*/      OPC_EmitInteger, MVT::i32, 0, 
/* 41666*/      OPC_EmitConvertToTarget, 2,
/* 41668*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_or:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 41678*/     0, // EndSwitchType
/* 41679*/    0, // EndSwitchType
/* 41680*/   /*SwitchOpcode*/ 114|128,2/*370*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->42054
/* 41684*/    OPC_RecordChild0, // #1 = $off
/* 41685*/    OPC_MoveChild0,
/* 41686*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 41689*/    OPC_MoveParent,
/* 41690*/    OPC_MoveParent,
/* 41691*/    OPC_RecordChild2, // #2 = $val
/* 41692*/    OPC_SwitchType /*2 cases */, 41|128,2/*297*/, MVT::i32,// ->41993
/* 41696*/     OPC_Scope, 58, /*->41756*/ // 5 children in Scope
/* 41698*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 41700*/      OPC_Scope, 26, /*->41728*/ // 2 children in Scope
/* 41702*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41704*/       OPC_EmitMergeInputChains1_0,
/* 41705*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41708*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41711*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41718*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 41728*/      /*Scope*/ 26, /*->41755*/
/* 41729*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41731*/       OPC_EmitMergeInputChains1_0,
/* 41732*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41735*/       OPC_EmitInteger, MVT::i64, 0, 
/* 41738*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 41745*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 41755*/      0, /*End of Scope*/
/* 41756*/     /*Scope*/ 58, /*->41815*/
/* 41757*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41759*/      OPC_Scope, 26, /*->41787*/ // 2 children in Scope
/* 41761*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41763*/       OPC_EmitMergeInputChains1_0,
/* 41764*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41767*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41770*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41777*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 41787*/      /*Scope*/ 26, /*->41814*/
/* 41788*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41790*/       OPC_EmitMergeInputChains1_0,
/* 41791*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41794*/       OPC_EmitInteger, MVT::i64, 0, 
/* 41797*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 41804*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 41814*/      0, /*End of Scope*/
/* 41815*/     /*Scope*/ 58, /*->41874*/
/* 41816*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41818*/      OPC_Scope, 26, /*->41846*/ // 2 children in Scope
/* 41820*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41822*/       OPC_EmitMergeInputChains1_0,
/* 41823*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41826*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41829*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41836*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 41846*/      /*Scope*/ 26, /*->41873*/
/* 41847*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41849*/       OPC_EmitMergeInputChains1_0,
/* 41850*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41853*/       OPC_EmitInteger, MVT::i64, 0, 
/* 41856*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 41863*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 41873*/      0, /*End of Scope*/
/* 41874*/     /*Scope*/ 58, /*->41933*/
/* 41875*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 41877*/      OPC_Scope, 26, /*->41905*/ // 2 children in Scope
/* 41879*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41881*/       OPC_EmitMergeInputChains1_0,
/* 41882*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41885*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41888*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41895*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 41905*/      /*Scope*/ 26, /*->41932*/
/* 41906*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41908*/       OPC_EmitMergeInputChains1_0,
/* 41909*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41912*/       OPC_EmitInteger, MVT::i64, 0, 
/* 41915*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 41922*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 41932*/      0, /*End of Scope*/
/* 41933*/     /*Scope*/ 58, /*->41992*/
/* 41934*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 41936*/      OPC_Scope, 26, /*->41964*/ // 2 children in Scope
/* 41938*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41940*/       OPC_EmitMergeInputChains1_0,
/* 41941*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41944*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41947*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41954*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 41964*/      /*Scope*/ 26, /*->41991*/
/* 41965*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 41967*/       OPC_EmitMergeInputChains1_0,
/* 41968*/       OPC_EmitInteger, MVT::i32, 0, 
/* 41971*/       OPC_EmitInteger, MVT::i64, 0, 
/* 41974*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 41981*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 41991*/      0, /*End of Scope*/
/* 41992*/     0, /*End of Scope*/
/* 41993*/    /*SwitchType*/ 58, MVT::i64,// ->42053
/* 41995*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 41997*/     OPC_Scope, 26, /*->42025*/ // 2 children in Scope
/* 41999*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 42001*/      OPC_EmitMergeInputChains1_0,
/* 42002*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42005*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42008*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42015*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_or:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 42025*/     /*Scope*/ 26, /*->42052*/
/* 42026*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 42028*/      OPC_EmitMergeInputChains1_0,
/* 42029*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42032*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42035*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 42042*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_or:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 42052*/     0, /*End of Scope*/
/* 42053*/    0, // EndSwitchType
/* 42054*/   0, // EndSwitchOpcode
/* 42055*/  /*Scope*/ 45|128,5/*685*/, /*->42742*/
/* 42057*/   OPC_RecordChild1, // #1 = $off
/* 42058*/   OPC_Scope, 8|128,3/*392*/, /*->42453*/ // 3 children in Scope
/* 42061*/    OPC_MoveChild1,
/* 42062*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 42065*/    OPC_MoveParent,
/* 42066*/    OPC_RecordChild2, // #2 = $val
/* 42067*/    OPC_SwitchType /*2 cases */, 61|128,2/*317*/, MVT::i32,// ->42388
/* 42071*/     OPC_Scope, 62, /*->42135*/ // 5 children in Scope
/* 42073*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 42075*/      OPC_Scope, 28, /*->42105*/ // 2 children in Scope
/* 42077*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42079*/       OPC_EmitMergeInputChains1_0,
/* 42080*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42083*/       OPC_EmitConvertToTarget, 1,
/* 42085*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42088*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42095*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42105*/      /*Scope*/ 28, /*->42134*/
/* 42106*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42108*/       OPC_EmitMergeInputChains1_0,
/* 42109*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42112*/       OPC_EmitConvertToTarget, 1,
/* 42114*/       OPC_EmitInteger, MVT::i64, 0, 
/* 42117*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 42124*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 42134*/      0, /*End of Scope*/
/* 42135*/     /*Scope*/ 62, /*->42198*/
/* 42136*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 42138*/      OPC_Scope, 28, /*->42168*/ // 2 children in Scope
/* 42140*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42142*/       OPC_EmitMergeInputChains1_0,
/* 42143*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42146*/       OPC_EmitConvertToTarget, 1,
/* 42148*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42151*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42158*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42168*/      /*Scope*/ 28, /*->42197*/
/* 42169*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42171*/       OPC_EmitMergeInputChains1_0,
/* 42172*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42175*/       OPC_EmitConvertToTarget, 1,
/* 42177*/       OPC_EmitInteger, MVT::i64, 0, 
/* 42180*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 42187*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 42197*/      0, /*End of Scope*/
/* 42198*/     /*Scope*/ 62, /*->42261*/
/* 42199*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 42201*/      OPC_Scope, 28, /*->42231*/ // 2 children in Scope
/* 42203*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42205*/       OPC_EmitMergeInputChains1_0,
/* 42206*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42209*/       OPC_EmitConvertToTarget, 1,
/* 42211*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42214*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42221*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42231*/      /*Scope*/ 28, /*->42260*/
/* 42232*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42234*/       OPC_EmitMergeInputChains1_0,
/* 42235*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42238*/       OPC_EmitConvertToTarget, 1,
/* 42240*/       OPC_EmitInteger, MVT::i64, 0, 
/* 42243*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 42250*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 42260*/      0, /*End of Scope*/
/* 42261*/     /*Scope*/ 62, /*->42324*/
/* 42262*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 42264*/      OPC_Scope, 28, /*->42294*/ // 2 children in Scope
/* 42266*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42268*/       OPC_EmitMergeInputChains1_0,
/* 42269*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42272*/       OPC_EmitConvertToTarget, 1,
/* 42274*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42277*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42284*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42294*/      /*Scope*/ 28, /*->42323*/
/* 42295*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42297*/       OPC_EmitMergeInputChains1_0,
/* 42298*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42301*/       OPC_EmitConvertToTarget, 1,
/* 42303*/       OPC_EmitInteger, MVT::i64, 0, 
/* 42306*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 42313*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 42323*/      0, /*End of Scope*/
/* 42324*/     /*Scope*/ 62, /*->42387*/
/* 42325*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 42327*/      OPC_Scope, 28, /*->42357*/ // 2 children in Scope
/* 42329*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42331*/       OPC_EmitMergeInputChains1_0,
/* 42332*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42335*/       OPC_EmitConvertToTarget, 1,
/* 42337*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42340*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42347*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42357*/      /*Scope*/ 28, /*->42386*/
/* 42358*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42360*/       OPC_EmitMergeInputChains1_0,
/* 42361*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42364*/       OPC_EmitConvertToTarget, 1,
/* 42366*/       OPC_EmitInteger, MVT::i64, 0, 
/* 42369*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 42376*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 42386*/      0, /*End of Scope*/
/* 42387*/     0, /*End of Scope*/
/* 42388*/    /*SwitchType*/ 62, MVT::i64,// ->42452
/* 42390*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 42392*/     OPC_Scope, 28, /*->42422*/ // 2 children in Scope
/* 42394*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42396*/      OPC_EmitMergeInputChains1_0,
/* 42397*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42400*/      OPC_EmitConvertToTarget, 1,
/* 42402*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42405*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42412*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_or:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 42422*/     /*Scope*/ 28, /*->42451*/
/* 42423*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42425*/      OPC_EmitMergeInputChains1_0,
/* 42426*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42429*/      OPC_EmitConvertToTarget, 1,
/* 42431*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42434*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 42441*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_or:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 42451*/     0, /*End of Scope*/
/* 42452*/    0, // EndSwitchType
/* 42453*/   /*Scope*/ 14|128,1/*142*/, /*->42597*/
/* 42455*/    OPC_CheckChild1Type, MVT::i32,
/* 42457*/    OPC_RecordChild2, // #2 = $val
/* 42458*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->42573
/* 42461*/     OPC_Scope, 21, /*->42484*/ // 5 children in Scope
/* 42463*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 42465*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42467*/      OPC_EmitMergeInputChains1_0,
/* 42468*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42471*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42474*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42484*/     /*Scope*/ 21, /*->42506*/
/* 42485*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 42487*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42489*/      OPC_EmitMergeInputChains1_0,
/* 42490*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42493*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42496*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42506*/     /*Scope*/ 21, /*->42528*/
/* 42507*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 42509*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42511*/      OPC_EmitMergeInputChains1_0,
/* 42512*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42515*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42518*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42528*/     /*Scope*/ 21, /*->42550*/
/* 42529*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 42531*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42533*/      OPC_EmitMergeInputChains1_0,
/* 42534*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42537*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42550*/     /*Scope*/ 21, /*->42572*/
/* 42551*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 42553*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42555*/      OPC_EmitMergeInputChains1_0,
/* 42556*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42559*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42562*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42572*/     0, /*End of Scope*/
/* 42573*/    /*SwitchType*/ 21, MVT::i64,// ->42596
/* 42575*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 42577*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42579*/     OPC_EmitMergeInputChains1_0,
/* 42580*/     OPC_EmitInteger, MVT::i32, 0, 
/* 42583*/     OPC_EmitInteger, MVT::i32, 0, 
/* 42586*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_or:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42596*/    0, // EndSwitchType
/* 42597*/   /*Scope*/ 14|128,1/*142*/, /*->42741*/
/* 42599*/    OPC_CheckChild1Type, MVT::i64,
/* 42601*/    OPC_RecordChild2, // #2 = $val
/* 42602*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->42717
/* 42605*/     OPC_Scope, 21, /*->42628*/ // 5 children in Scope
/* 42607*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_or_32
/* 42609*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42611*/      OPC_EmitMergeInputChains1_0,
/* 42612*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42615*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42628*/     /*Scope*/ 21, /*->42650*/
/* 42629*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 42631*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42633*/      OPC_EmitMergeInputChains1_0,
/* 42634*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42637*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42640*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42650*/     /*Scope*/ 21, /*->42672*/
/* 42651*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 42653*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42655*/      OPC_EmitMergeInputChains1_0,
/* 42656*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42659*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42672*/     /*Scope*/ 21, /*->42694*/
/* 42673*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 42675*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42677*/      OPC_EmitMergeInputChains1_0,
/* 42678*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42681*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42684*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42694*/     /*Scope*/ 21, /*->42716*/
/* 42695*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 42697*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42699*/      OPC_EmitMergeInputChains1_0,
/* 42700*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42703*/      OPC_EmitInteger, MVT::i64, 0, 
/* 42706*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_or:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42716*/     0, /*End of Scope*/
/* 42717*/    /*SwitchType*/ 21, MVT::i64,// ->42740
/* 42719*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_or_64
/* 42721*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42723*/     OPC_EmitMergeInputChains1_0,
/* 42724*/     OPC_EmitInteger, MVT::i32, 0, 
/* 42727*/     OPC_EmitInteger, MVT::i64, 0, 
/* 42730*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_or:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 42740*/    0, // EndSwitchType
/* 42741*/   0, /*End of Scope*/
/* 42742*/  0, /*End of Scope*/
/* 42743*/ /*SwitchOpcode*/ 116|128,12/*1652*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->44399
/* 42747*/  OPC_RecordMemRef,
/* 42748*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 42749*/  OPC_Scope, 63|128,7/*959*/, /*->43711*/ // 2 children in Scope
/* 42752*/   OPC_MoveChild1,
/* 42753*/   OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->43045
/* 42758*/    OPC_RecordChild0, // #1 = $addr
/* 42759*/    OPC_RecordChild1, // #2 = $off
/* 42760*/    OPC_MoveChild1,
/* 42761*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 42764*/    OPC_MoveParent,
/* 42765*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 42767*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->42906
/* 42771*/     OPC_MoveParent,
/* 42772*/     OPC_RecordChild2, // #3 = $val
/* 42773*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->42883
/* 42776*/      OPC_Scope, 20, /*->42798*/ // 5 children in Scope
/* 42778*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 42780*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42782*/       OPC_EmitMergeInputChains1_0,
/* 42783*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42786*/       OPC_EmitConvertToTarget, 2,
/* 42788*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42798*/      /*Scope*/ 20, /*->42819*/
/* 42799*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 42801*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42803*/       OPC_EmitMergeInputChains1_0,
/* 42804*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42807*/       OPC_EmitConvertToTarget, 2,
/* 42809*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42819*/      /*Scope*/ 20, /*->42840*/
/* 42820*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 42822*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42824*/       OPC_EmitMergeInputChains1_0,
/* 42825*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42828*/       OPC_EmitConvertToTarget, 2,
/* 42830*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42840*/      /*Scope*/ 20, /*->42861*/
/* 42841*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 42843*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42845*/       OPC_EmitMergeInputChains1_0,
/* 42846*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42849*/       OPC_EmitConvertToTarget, 2,
/* 42851*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42861*/      /*Scope*/ 20, /*->42882*/
/* 42862*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 42864*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42866*/       OPC_EmitMergeInputChains1_0,
/* 42867*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42870*/       OPC_EmitConvertToTarget, 2,
/* 42872*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42882*/      0, /*End of Scope*/
/* 42883*/     /*SwitchType*/ 20, MVT::i64,// ->42905
/* 42885*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 42887*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42889*/      OPC_EmitMergeInputChains1_0,
/* 42890*/      OPC_EmitInteger, MVT::i32, 0, 
/* 42893*/      OPC_EmitConvertToTarget, 2,
/* 42895*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42905*/     0, // EndSwitchType
/* 42906*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->43044
/* 42909*/     OPC_MoveParent,
/* 42910*/     OPC_RecordChild2, // #3 = $val
/* 42911*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->43021
/* 42914*/      OPC_Scope, 20, /*->42936*/ // 5 children in Scope
/* 42916*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 42918*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42920*/       OPC_EmitMergeInputChains1_0,
/* 42921*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42924*/       OPC_EmitConvertToTarget, 2,
/* 42926*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42936*/      /*Scope*/ 20, /*->42957*/
/* 42937*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 42939*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42941*/       OPC_EmitMergeInputChains1_0,
/* 42942*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42945*/       OPC_EmitConvertToTarget, 2,
/* 42947*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42957*/      /*Scope*/ 20, /*->42978*/
/* 42958*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 42960*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42962*/       OPC_EmitMergeInputChains1_0,
/* 42963*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42966*/       OPC_EmitConvertToTarget, 2,
/* 42968*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42978*/      /*Scope*/ 20, /*->42999*/
/* 42979*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 42981*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 42983*/       OPC_EmitMergeInputChains1_0,
/* 42984*/       OPC_EmitInteger, MVT::i32, 0, 
/* 42987*/       OPC_EmitConvertToTarget, 2,
/* 42989*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 42999*/      /*Scope*/ 20, /*->43020*/
/* 43000*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43002*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43004*/       OPC_EmitMergeInputChains1_0,
/* 43005*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43008*/       OPC_EmitConvertToTarget, 2,
/* 43010*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 43020*/      0, /*End of Scope*/
/* 43021*/     /*SwitchType*/ 20, MVT::i64,// ->43043
/* 43023*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 43025*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43027*/      OPC_EmitMergeInputChains1_0,
/* 43028*/      OPC_EmitInteger, MVT::i32, 0, 
/* 43031*/      OPC_EmitConvertToTarget, 2,
/* 43033*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 43043*/     0, // EndSwitchType
/* 43044*/    0, // EndSwitchType
/* 43045*/   /*SwitchOpcode*/ 31|128,2/*287*/, TARGET_VAL(ISD::OR),// ->43336
/* 43049*/    OPC_RecordChild0, // #1 = $addr
/* 43050*/    OPC_RecordChild1, // #2 = $off
/* 43051*/    OPC_MoveChild1,
/* 43052*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 43055*/    OPC_MoveParent,
/* 43056*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 43058*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->43197
/* 43062*/     OPC_MoveParent,
/* 43063*/     OPC_RecordChild2, // #3 = $val
/* 43064*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->43174
/* 43067*/      OPC_Scope, 20, /*->43089*/ // 5 children in Scope
/* 43069*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 43071*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43073*/       OPC_EmitMergeInputChains1_0,
/* 43074*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43077*/       OPC_EmitConvertToTarget, 2,
/* 43079*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43089*/      /*Scope*/ 20, /*->43110*/
/* 43090*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43092*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43094*/       OPC_EmitMergeInputChains1_0,
/* 43095*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43098*/       OPC_EmitConvertToTarget, 2,
/* 43100*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43110*/      /*Scope*/ 20, /*->43131*/
/* 43111*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43113*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43115*/       OPC_EmitMergeInputChains1_0,
/* 43116*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43119*/       OPC_EmitConvertToTarget, 2,
/* 43121*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43131*/      /*Scope*/ 20, /*->43152*/
/* 43132*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43134*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43136*/       OPC_EmitMergeInputChains1_0,
/* 43137*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43140*/       OPC_EmitConvertToTarget, 2,
/* 43142*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43152*/      /*Scope*/ 20, /*->43173*/
/* 43153*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43155*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43157*/       OPC_EmitMergeInputChains1_0,
/* 43158*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43161*/       OPC_EmitConvertToTarget, 2,
/* 43163*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43173*/      0, /*End of Scope*/
/* 43174*/     /*SwitchType*/ 20, MVT::i64,// ->43196
/* 43176*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 43178*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43180*/      OPC_EmitMergeInputChains1_0,
/* 43181*/      OPC_EmitInteger, MVT::i32, 0, 
/* 43184*/      OPC_EmitConvertToTarget, 2,
/* 43186*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_xor:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43196*/     0, // EndSwitchType
/* 43197*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->43335
/* 43200*/     OPC_MoveParent,
/* 43201*/     OPC_RecordChild2, // #3 = $val
/* 43202*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->43312
/* 43205*/      OPC_Scope, 20, /*->43227*/ // 5 children in Scope
/* 43207*/       OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 43209*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43211*/       OPC_EmitMergeInputChains1_0,
/* 43212*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43215*/       OPC_EmitConvertToTarget, 2,
/* 43217*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 43227*/      /*Scope*/ 20, /*->43248*/
/* 43228*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43230*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43232*/       OPC_EmitMergeInputChains1_0,
/* 43233*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43236*/       OPC_EmitConvertToTarget, 2,
/* 43238*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 43248*/      /*Scope*/ 20, /*->43269*/
/* 43249*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43251*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43253*/       OPC_EmitMergeInputChains1_0,
/* 43254*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43257*/       OPC_EmitConvertToTarget, 2,
/* 43259*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 43269*/      /*Scope*/ 20, /*->43290*/
/* 43270*/       OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43272*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43274*/       OPC_EmitMergeInputChains1_0,
/* 43275*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43278*/       OPC_EmitConvertToTarget, 2,
/* 43280*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 43290*/      /*Scope*/ 20, /*->43311*/
/* 43291*/       OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43293*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43295*/       OPC_EmitMergeInputChains1_0,
/* 43296*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43299*/       OPC_EmitConvertToTarget, 2,
/* 43301*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 43311*/      0, /*End of Scope*/
/* 43312*/     /*SwitchType*/ 20, MVT::i64,// ->43334
/* 43314*/      OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 43316*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43318*/      OPC_EmitMergeInputChains1_0,
/* 43319*/      OPC_EmitInteger, MVT::i32, 0, 
/* 43322*/      OPC_EmitConvertToTarget, 2,
/* 43324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_load_xor:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 43334*/     0, // EndSwitchType
/* 43335*/    0, // EndSwitchType
/* 43336*/   /*SwitchOpcode*/ 114|128,2/*370*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->43710
/* 43340*/    OPC_RecordChild0, // #1 = $off
/* 43341*/    OPC_MoveChild0,
/* 43342*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 43345*/    OPC_MoveParent,
/* 43346*/    OPC_MoveParent,
/* 43347*/    OPC_RecordChild2, // #2 = $val
/* 43348*/    OPC_SwitchType /*2 cases */, 41|128,2/*297*/, MVT::i32,// ->43649
/* 43352*/     OPC_Scope, 58, /*->43412*/ // 5 children in Scope
/* 43354*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 43356*/      OPC_Scope, 26, /*->43384*/ // 2 children in Scope
/* 43358*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43360*/       OPC_EmitMergeInputChains1_0,
/* 43361*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43364*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43367*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43374*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43384*/      /*Scope*/ 26, /*->43411*/
/* 43385*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43387*/       OPC_EmitMergeInputChains1_0,
/* 43388*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43391*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43394*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 43401*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43411*/      0, /*End of Scope*/
/* 43412*/     /*Scope*/ 58, /*->43471*/
/* 43413*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43415*/      OPC_Scope, 26, /*->43443*/ // 2 children in Scope
/* 43417*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43419*/       OPC_EmitMergeInputChains1_0,
/* 43420*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43423*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43426*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43433*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43443*/      /*Scope*/ 26, /*->43470*/
/* 43444*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43446*/       OPC_EmitMergeInputChains1_0,
/* 43447*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43450*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43453*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 43460*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43470*/      0, /*End of Scope*/
/* 43471*/     /*Scope*/ 58, /*->43530*/
/* 43472*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43474*/      OPC_Scope, 26, /*->43502*/ // 2 children in Scope
/* 43476*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43478*/       OPC_EmitMergeInputChains1_0,
/* 43479*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43482*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43485*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43492*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43502*/      /*Scope*/ 26, /*->43529*/
/* 43503*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43505*/       OPC_EmitMergeInputChains1_0,
/* 43506*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43509*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43512*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 43519*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43529*/      0, /*End of Scope*/
/* 43530*/     /*Scope*/ 58, /*->43589*/
/* 43531*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43533*/      OPC_Scope, 26, /*->43561*/ // 2 children in Scope
/* 43535*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43537*/       OPC_EmitMergeInputChains1_0,
/* 43538*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43541*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43544*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43551*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43561*/      /*Scope*/ 26, /*->43588*/
/* 43562*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43564*/       OPC_EmitMergeInputChains1_0,
/* 43565*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43568*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43571*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 43578*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43588*/      0, /*End of Scope*/
/* 43589*/     /*Scope*/ 58, /*->43648*/
/* 43590*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43592*/      OPC_Scope, 26, /*->43620*/ // 2 children in Scope
/* 43594*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43596*/       OPC_EmitMergeInputChains1_0,
/* 43597*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43600*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43603*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43610*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43620*/      /*Scope*/ 26, /*->43647*/
/* 43621*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43623*/       OPC_EmitMergeInputChains1_0,
/* 43624*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43627*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43630*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 43637*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43647*/      0, /*End of Scope*/
/* 43648*/     0, /*End of Scope*/
/* 43649*/    /*SwitchType*/ 58, MVT::i64,// ->43709
/* 43651*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 43653*/     OPC_Scope, 26, /*->43681*/ // 2 children in Scope
/* 43655*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43657*/      OPC_EmitMergeInputChains1_0,
/* 43658*/      OPC_EmitInteger, MVT::i32, 0, 
/* 43661*/      OPC_EmitInteger, MVT::i32, 0, 
/* 43664*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43671*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_xor:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 43681*/     /*Scope*/ 26, /*->43708*/
/* 43682*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 43684*/      OPC_EmitMergeInputChains1_0,
/* 43685*/      OPC_EmitInteger, MVT::i32, 0, 
/* 43688*/      OPC_EmitInteger, MVT::i64, 0, 
/* 43691*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 43698*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_load_xor:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 43708*/     0, /*End of Scope*/
/* 43709*/    0, // EndSwitchType
/* 43710*/   0, // EndSwitchOpcode
/* 43711*/  /*Scope*/ 45|128,5/*685*/, /*->44398*/
/* 43713*/   OPC_RecordChild1, // #1 = $off
/* 43714*/   OPC_Scope, 8|128,3/*392*/, /*->44109*/ // 3 children in Scope
/* 43717*/    OPC_MoveChild1,
/* 43718*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 43721*/    OPC_MoveParent,
/* 43722*/    OPC_RecordChild2, // #2 = $val
/* 43723*/    OPC_SwitchType /*2 cases */, 61|128,2/*317*/, MVT::i32,// ->44044
/* 43727*/     OPC_Scope, 62, /*->43791*/ // 5 children in Scope
/* 43729*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 43731*/      OPC_Scope, 28, /*->43761*/ // 2 children in Scope
/* 43733*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43735*/       OPC_EmitMergeInputChains1_0,
/* 43736*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43739*/       OPC_EmitConvertToTarget, 1,
/* 43741*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43744*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 43751*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43761*/      /*Scope*/ 28, /*->43790*/
/* 43762*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43764*/       OPC_EmitMergeInputChains1_0,
/* 43765*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43768*/       OPC_EmitConvertToTarget, 1,
/* 43770*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43773*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 43780*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43790*/      0, /*End of Scope*/
/* 43791*/     /*Scope*/ 62, /*->43854*/
/* 43792*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43794*/      OPC_Scope, 28, /*->43824*/ // 2 children in Scope
/* 43796*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43798*/       OPC_EmitMergeInputChains1_0,
/* 43799*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43802*/       OPC_EmitConvertToTarget, 1,
/* 43804*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43807*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 43814*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43824*/      /*Scope*/ 28, /*->43853*/
/* 43825*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43827*/       OPC_EmitMergeInputChains1_0,
/* 43828*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43831*/       OPC_EmitConvertToTarget, 1,
/* 43833*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43836*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 43843*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43853*/      0, /*End of Scope*/
/* 43854*/     /*Scope*/ 62, /*->43917*/
/* 43855*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43857*/      OPC_Scope, 28, /*->43887*/ // 2 children in Scope
/* 43859*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43861*/       OPC_EmitMergeInputChains1_0,
/* 43862*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43865*/       OPC_EmitConvertToTarget, 1,
/* 43867*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43870*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 43877*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43887*/      /*Scope*/ 28, /*->43916*/
/* 43888*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43890*/       OPC_EmitMergeInputChains1_0,
/* 43891*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43894*/       OPC_EmitConvertToTarget, 1,
/* 43896*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43899*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 43906*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43916*/      0, /*End of Scope*/
/* 43917*/     /*Scope*/ 62, /*->43980*/
/* 43918*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 43920*/      OPC_Scope, 28, /*->43950*/ // 2 children in Scope
/* 43922*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43924*/       OPC_EmitMergeInputChains1_0,
/* 43925*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43928*/       OPC_EmitConvertToTarget, 1,
/* 43930*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43933*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 43940*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43950*/      /*Scope*/ 28, /*->43979*/
/* 43951*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43953*/       OPC_EmitMergeInputChains1_0,
/* 43954*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43957*/       OPC_EmitConvertToTarget, 1,
/* 43959*/       OPC_EmitInteger, MVT::i64, 0, 
/* 43962*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 43969*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 43979*/      0, /*End of Scope*/
/* 43980*/     /*Scope*/ 62, /*->44043*/
/* 43981*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 43983*/      OPC_Scope, 28, /*->44013*/ // 2 children in Scope
/* 43985*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 43987*/       OPC_EmitMergeInputChains1_0,
/* 43988*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43991*/       OPC_EmitConvertToTarget, 1,
/* 43993*/       OPC_EmitInteger, MVT::i32, 0, 
/* 43996*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 44003*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44013*/      /*Scope*/ 28, /*->44042*/
/* 44014*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44016*/       OPC_EmitMergeInputChains1_0,
/* 44017*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44020*/       OPC_EmitConvertToTarget, 1,
/* 44022*/       OPC_EmitInteger, MVT::i64, 0, 
/* 44025*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 44032*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 44042*/      0, /*End of Scope*/
/* 44043*/     0, /*End of Scope*/
/* 44044*/    /*SwitchType*/ 62, MVT::i64,// ->44108
/* 44046*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 44048*/     OPC_Scope, 28, /*->44078*/ // 2 children in Scope
/* 44050*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44052*/      OPC_EmitMergeInputChains1_0,
/* 44053*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44056*/      OPC_EmitConvertToTarget, 1,
/* 44058*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44061*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 44068*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_xor:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 44078*/     /*Scope*/ 28, /*->44107*/
/* 44079*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44081*/      OPC_EmitMergeInputChains1_0,
/* 44082*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44085*/      OPC_EmitConvertToTarget, 1,
/* 44087*/      OPC_EmitInteger, MVT::i64, 0, 
/* 44090*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 44097*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_load_xor:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 44107*/     0, /*End of Scope*/
/* 44108*/    0, // EndSwitchType
/* 44109*/   /*Scope*/ 14|128,1/*142*/, /*->44253*/
/* 44111*/    OPC_CheckChild1Type, MVT::i32,
/* 44113*/    OPC_RecordChild2, // #2 = $val
/* 44114*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->44229
/* 44117*/     OPC_Scope, 21, /*->44140*/ // 5 children in Scope
/* 44119*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 44121*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44123*/      OPC_EmitMergeInputChains1_0,
/* 44124*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44127*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44130*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44140*/     /*Scope*/ 21, /*->44162*/
/* 44141*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 44143*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44145*/      OPC_EmitMergeInputChains1_0,
/* 44146*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44149*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44152*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44162*/     /*Scope*/ 21, /*->44184*/
/* 44163*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 44165*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44167*/      OPC_EmitMergeInputChains1_0,
/* 44168*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44171*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44174*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44184*/     /*Scope*/ 21, /*->44206*/
/* 44185*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 44187*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44189*/      OPC_EmitMergeInputChains1_0,
/* 44190*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44193*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44196*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44206*/     /*Scope*/ 21, /*->44228*/
/* 44207*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 44209*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44211*/      OPC_EmitMergeInputChains1_0,
/* 44212*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44215*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44218*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44228*/     0, /*End of Scope*/
/* 44229*/    /*SwitchType*/ 21, MVT::i64,// ->44252
/* 44231*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 44233*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44235*/     OPC_EmitMergeInputChains1_0,
/* 44236*/     OPC_EmitInteger, MVT::i32, 0, 
/* 44239*/     OPC_EmitInteger, MVT::i32, 0, 
/* 44242*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_xor:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44252*/    0, // EndSwitchType
/* 44253*/   /*Scope*/ 14|128,1/*142*/, /*->44397*/
/* 44255*/    OPC_CheckChild1Type, MVT::i64,
/* 44257*/    OPC_RecordChild2, // #2 = $val
/* 44258*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->44373
/* 44261*/     OPC_Scope, 21, /*->44284*/ // 5 children in Scope
/* 44263*/      OPC_CheckPredicate, 4, // Predicate_atomic_load_xor_32
/* 44265*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44267*/      OPC_EmitMergeInputChains1_0,
/* 44268*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44271*/      OPC_EmitInteger, MVT::i64, 0, 
/* 44274*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44284*/     /*Scope*/ 21, /*->44306*/
/* 44285*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 44287*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44289*/      OPC_EmitMergeInputChains1_0,
/* 44290*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44293*/      OPC_EmitInteger, MVT::i64, 0, 
/* 44296*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44306*/     /*Scope*/ 21, /*->44328*/
/* 44307*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 44309*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44311*/      OPC_EmitMergeInputChains1_0,
/* 44312*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44315*/      OPC_EmitInteger, MVT::i64, 0, 
/* 44318*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44328*/     /*Scope*/ 21, /*->44350*/
/* 44329*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 44331*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44333*/      OPC_EmitMergeInputChains1_0,
/* 44334*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44337*/      OPC_EmitInteger, MVT::i64, 0, 
/* 44340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44350*/     /*Scope*/ 21, /*->44372*/
/* 44351*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 44353*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44355*/      OPC_EmitMergeInputChains1_0,
/* 44356*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44359*/      OPC_EmitInteger, MVT::i64, 0, 
/* 44362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_load_xor:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44372*/     0, /*End of Scope*/
/* 44373*/    /*SwitchType*/ 21, MVT::i64,// ->44396
/* 44375*/     OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_64
/* 44377*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44379*/     OPC_EmitMergeInputChains1_0,
/* 44380*/     OPC_EmitInteger, MVT::i32, 0, 
/* 44383*/     OPC_EmitInteger, MVT::i64, 0, 
/* 44386*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_load_xor:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 44396*/    0, // EndSwitchType
/* 44397*/   0, /*End of Scope*/
/* 44398*/  0, /*End of Scope*/
/* 44399*/ /*SwitchOpcode*/ 116|128,12/*1652*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->46055
/* 44403*/  OPC_RecordMemRef,
/* 44404*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 44405*/  OPC_Scope, 63|128,7/*959*/, /*->45367*/ // 2 children in Scope
/* 44408*/   OPC_MoveChild1,
/* 44409*/   OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->44701
/* 44414*/    OPC_RecordChild0, // #1 = $addr
/* 44415*/    OPC_RecordChild1, // #2 = $off
/* 44416*/    OPC_MoveChild1,
/* 44417*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 44420*/    OPC_MoveParent,
/* 44421*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 44423*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->44562
/* 44427*/     OPC_MoveParent,
/* 44428*/     OPC_RecordChild2, // #3 = $val
/* 44429*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->44539
/* 44432*/      OPC_Scope, 20, /*->44454*/ // 5 children in Scope
/* 44434*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 44436*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44438*/       OPC_EmitMergeInputChains1_0,
/* 44439*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44442*/       OPC_EmitConvertToTarget, 2,
/* 44444*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44454*/      /*Scope*/ 20, /*->44475*/
/* 44455*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44457*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44459*/       OPC_EmitMergeInputChains1_0,
/* 44460*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44463*/       OPC_EmitConvertToTarget, 2,
/* 44465*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44475*/      /*Scope*/ 20, /*->44496*/
/* 44476*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44478*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44480*/       OPC_EmitMergeInputChains1_0,
/* 44481*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44484*/       OPC_EmitConvertToTarget, 2,
/* 44486*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44496*/      /*Scope*/ 20, /*->44517*/
/* 44497*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44499*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44501*/       OPC_EmitMergeInputChains1_0,
/* 44502*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44505*/       OPC_EmitConvertToTarget, 2,
/* 44507*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44517*/      /*Scope*/ 20, /*->44538*/
/* 44518*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44520*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44522*/       OPC_EmitMergeInputChains1_0,
/* 44523*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44526*/       OPC_EmitConvertToTarget, 2,
/* 44528*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44538*/      0, /*End of Scope*/
/* 44539*/     /*SwitchType*/ 20, MVT::i64,// ->44561
/* 44541*/      OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 44543*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44545*/      OPC_EmitMergeInputChains1_0,
/* 44546*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44549*/      OPC_EmitConvertToTarget, 2,
/* 44551*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44561*/     0, // EndSwitchType
/* 44562*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->44700
/* 44565*/     OPC_MoveParent,
/* 44566*/     OPC_RecordChild2, // #3 = $val
/* 44567*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->44677
/* 44570*/      OPC_Scope, 20, /*->44592*/ // 5 children in Scope
/* 44572*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 44574*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44576*/       OPC_EmitMergeInputChains1_0,
/* 44577*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44580*/       OPC_EmitConvertToTarget, 2,
/* 44582*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44592*/      /*Scope*/ 20, /*->44613*/
/* 44593*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44595*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44597*/       OPC_EmitMergeInputChains1_0,
/* 44598*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44601*/       OPC_EmitConvertToTarget, 2,
/* 44603*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44613*/      /*Scope*/ 20, /*->44634*/
/* 44614*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44616*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44618*/       OPC_EmitMergeInputChains1_0,
/* 44619*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44622*/       OPC_EmitConvertToTarget, 2,
/* 44624*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44634*/      /*Scope*/ 20, /*->44655*/
/* 44635*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44637*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44639*/       OPC_EmitMergeInputChains1_0,
/* 44640*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44643*/       OPC_EmitConvertToTarget, 2,
/* 44645*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44655*/      /*Scope*/ 20, /*->44676*/
/* 44656*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44658*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44660*/       OPC_EmitMergeInputChains1_0,
/* 44661*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44664*/       OPC_EmitConvertToTarget, 2,
/* 44666*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44676*/      0, /*End of Scope*/
/* 44677*/     /*SwitchType*/ 20, MVT::i64,// ->44699
/* 44679*/      OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 44681*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44683*/      OPC_EmitMergeInputChains1_0,
/* 44684*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44687*/      OPC_EmitConvertToTarget, 2,
/* 44689*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 44699*/     0, // EndSwitchType
/* 44700*/    0, // EndSwitchType
/* 44701*/   /*SwitchOpcode*/ 31|128,2/*287*/, TARGET_VAL(ISD::OR),// ->44992
/* 44705*/    OPC_RecordChild0, // #1 = $addr
/* 44706*/    OPC_RecordChild1, // #2 = $off
/* 44707*/    OPC_MoveChild1,
/* 44708*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 44711*/    OPC_MoveParent,
/* 44712*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 44714*/    OPC_SwitchType /*2 cases */, 7|128,1/*135*/, MVT::i32,// ->44853
/* 44718*/     OPC_MoveParent,
/* 44719*/     OPC_RecordChild2, // #3 = $val
/* 44720*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->44830
/* 44723*/      OPC_Scope, 20, /*->44745*/ // 5 children in Scope
/* 44725*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 44727*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44729*/       OPC_EmitMergeInputChains1_0,
/* 44730*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44733*/       OPC_EmitConvertToTarget, 2,
/* 44735*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44745*/      /*Scope*/ 20, /*->44766*/
/* 44746*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44748*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44750*/       OPC_EmitMergeInputChains1_0,
/* 44751*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44754*/       OPC_EmitConvertToTarget, 2,
/* 44756*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44766*/      /*Scope*/ 20, /*->44787*/
/* 44767*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44769*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44771*/       OPC_EmitMergeInputChains1_0,
/* 44772*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44775*/       OPC_EmitConvertToTarget, 2,
/* 44777*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44787*/      /*Scope*/ 20, /*->44808*/
/* 44788*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44790*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44792*/       OPC_EmitMergeInputChains1_0,
/* 44793*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44796*/       OPC_EmitConvertToTarget, 2,
/* 44798*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44808*/      /*Scope*/ 20, /*->44829*/
/* 44809*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44811*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44813*/       OPC_EmitMergeInputChains1_0,
/* 44814*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44817*/       OPC_EmitConvertToTarget, 2,
/* 44819*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44829*/      0, /*End of Scope*/
/* 44830*/     /*SwitchType*/ 20, MVT::i64,// ->44852
/* 44832*/      OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 44834*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44836*/      OPC_EmitMergeInputChains1_0,
/* 44837*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44840*/      OPC_EmitConvertToTarget, 2,
/* 44842*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_swap:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44852*/     0, // EndSwitchType
/* 44853*/    /*SwitchType*/ 7|128,1/*135*/, MVT::i64,// ->44991
/* 44856*/     OPC_MoveParent,
/* 44857*/     OPC_RecordChild2, // #3 = $val
/* 44858*/     OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->44968
/* 44861*/      OPC_Scope, 20, /*->44883*/ // 5 children in Scope
/* 44863*/       OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 44865*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44867*/       OPC_EmitMergeInputChains1_0,
/* 44868*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44871*/       OPC_EmitConvertToTarget, 2,
/* 44873*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44883*/      /*Scope*/ 20, /*->44904*/
/* 44884*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44886*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44888*/       OPC_EmitMergeInputChains1_0,
/* 44889*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44892*/       OPC_EmitConvertToTarget, 2,
/* 44894*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44904*/      /*Scope*/ 20, /*->44925*/
/* 44905*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44907*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44909*/       OPC_EmitMergeInputChains1_0,
/* 44910*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44913*/       OPC_EmitConvertToTarget, 2,
/* 44915*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44925*/      /*Scope*/ 20, /*->44946*/
/* 44926*/       OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 44928*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44930*/       OPC_EmitMergeInputChains1_0,
/* 44931*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44934*/       OPC_EmitConvertToTarget, 2,
/* 44936*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44946*/      /*Scope*/ 20, /*->44967*/
/* 44947*/       OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 44949*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44951*/       OPC_EmitMergeInputChains1_0,
/* 44952*/       OPC_EmitInteger, MVT::i32, 0, 
/* 44955*/       OPC_EmitConvertToTarget, 2,
/* 44957*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                 // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 44967*/      0, /*End of Scope*/
/* 44968*/     /*SwitchType*/ 20, MVT::i64,// ->44990
/* 44970*/      OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 44972*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 44974*/      OPC_EmitMergeInputChains1_0,
/* 44975*/      OPC_EmitInteger, MVT::i32, 0, 
/* 44978*/      OPC_EmitConvertToTarget, 2,
/* 44980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (atomic_swap:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 44990*/     0, // EndSwitchType
/* 44991*/    0, // EndSwitchType
/* 44992*/   /*SwitchOpcode*/ 114|128,2/*370*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->45366
/* 44996*/    OPC_RecordChild0, // #1 = $off
/* 44997*/    OPC_MoveChild0,
/* 44998*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 45001*/    OPC_MoveParent,
/* 45002*/    OPC_MoveParent,
/* 45003*/    OPC_RecordChild2, // #2 = $val
/* 45004*/    OPC_SwitchType /*2 cases */, 41|128,2/*297*/, MVT::i32,// ->45305
/* 45008*/     OPC_Scope, 58, /*->45068*/ // 5 children in Scope
/* 45010*/      OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 45012*/      OPC_Scope, 26, /*->45040*/ // 2 children in Scope
/* 45014*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45016*/       OPC_EmitMergeInputChains1_0,
/* 45017*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45020*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45023*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45030*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45040*/      /*Scope*/ 26, /*->45067*/
/* 45041*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45043*/       OPC_EmitMergeInputChains1_0,
/* 45044*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45047*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45050*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 45057*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45067*/      0, /*End of Scope*/
/* 45068*/     /*Scope*/ 58, /*->45127*/
/* 45069*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45071*/      OPC_Scope, 26, /*->45099*/ // 2 children in Scope
/* 45073*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45075*/       OPC_EmitMergeInputChains1_0,
/* 45076*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45079*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45082*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45089*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45099*/      /*Scope*/ 26, /*->45126*/
/* 45100*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45102*/       OPC_EmitMergeInputChains1_0,
/* 45103*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45106*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45109*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 45116*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45126*/      0, /*End of Scope*/
/* 45127*/     /*Scope*/ 58, /*->45186*/
/* 45128*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45130*/      OPC_Scope, 26, /*->45158*/ // 2 children in Scope
/* 45132*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45134*/       OPC_EmitMergeInputChains1_0,
/* 45135*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45138*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45141*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45148*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45158*/      /*Scope*/ 26, /*->45185*/
/* 45159*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45161*/       OPC_EmitMergeInputChains1_0,
/* 45162*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45165*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45168*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 45175*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45185*/      0, /*End of Scope*/
/* 45186*/     /*Scope*/ 58, /*->45245*/
/* 45187*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45189*/      OPC_Scope, 26, /*->45217*/ // 2 children in Scope
/* 45191*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45193*/       OPC_EmitMergeInputChains1_0,
/* 45194*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45197*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45200*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45207*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45217*/      /*Scope*/ 26, /*->45244*/
/* 45218*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45220*/       OPC_EmitMergeInputChains1_0,
/* 45221*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45224*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45227*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 45234*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45244*/      0, /*End of Scope*/
/* 45245*/     /*Scope*/ 58, /*->45304*/
/* 45246*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45248*/      OPC_Scope, 26, /*->45276*/ // 2 children in Scope
/* 45250*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45252*/       OPC_EmitMergeInputChains1_0,
/* 45253*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45256*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45259*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45266*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45276*/      /*Scope*/ 26, /*->45303*/
/* 45277*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45279*/       OPC_EmitMergeInputChains1_0,
/* 45280*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45283*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45286*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 45293*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45303*/      0, /*End of Scope*/
/* 45304*/     0, /*End of Scope*/
/* 45305*/    /*SwitchType*/ 58, MVT::i64,// ->45365
/* 45307*/     OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 45309*/     OPC_Scope, 26, /*->45337*/ // 2 children in Scope
/* 45311*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45313*/      OPC_EmitMergeInputChains1_0,
/* 45314*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45317*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45320*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45327*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 45337*/     /*Scope*/ 26, /*->45364*/
/* 45338*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 45340*/      OPC_EmitMergeInputChains1_0,
/* 45341*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45344*/      OPC_EmitInteger, MVT::i64, 0, 
/* 45347*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 45354*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (atomic_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 45364*/     0, /*End of Scope*/
/* 45365*/    0, // EndSwitchType
/* 45366*/   0, // EndSwitchOpcode
/* 45367*/  /*Scope*/ 45|128,5/*685*/, /*->46054*/
/* 45369*/   OPC_RecordChild1, // #1 = $off
/* 45370*/   OPC_Scope, 8|128,3/*392*/, /*->45765*/ // 3 children in Scope
/* 45373*/    OPC_MoveChild1,
/* 45374*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 45377*/    OPC_MoveParent,
/* 45378*/    OPC_RecordChild2, // #2 = $val
/* 45379*/    OPC_SwitchType /*2 cases */, 61|128,2/*317*/, MVT::i32,// ->45700
/* 45383*/     OPC_Scope, 62, /*->45447*/ // 5 children in Scope
/* 45385*/      OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 45387*/      OPC_Scope, 28, /*->45417*/ // 2 children in Scope
/* 45389*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45391*/       OPC_EmitMergeInputChains1_0,
/* 45392*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45395*/       OPC_EmitConvertToTarget, 1,
/* 45397*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45400*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45407*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45417*/      /*Scope*/ 28, /*->45446*/
/* 45418*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45420*/       OPC_EmitMergeInputChains1_0,
/* 45421*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45424*/       OPC_EmitConvertToTarget, 1,
/* 45426*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45429*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 45436*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45446*/      0, /*End of Scope*/
/* 45447*/     /*Scope*/ 62, /*->45510*/
/* 45448*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45450*/      OPC_Scope, 28, /*->45480*/ // 2 children in Scope
/* 45452*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45454*/       OPC_EmitMergeInputChains1_0,
/* 45455*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45458*/       OPC_EmitConvertToTarget, 1,
/* 45460*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45463*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45470*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45480*/      /*Scope*/ 28, /*->45509*/
/* 45481*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45483*/       OPC_EmitMergeInputChains1_0,
/* 45484*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45487*/       OPC_EmitConvertToTarget, 1,
/* 45489*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45492*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 45499*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45509*/      0, /*End of Scope*/
/* 45510*/     /*Scope*/ 62, /*->45573*/
/* 45511*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45513*/      OPC_Scope, 28, /*->45543*/ // 2 children in Scope
/* 45515*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45517*/       OPC_EmitMergeInputChains1_0,
/* 45518*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45521*/       OPC_EmitConvertToTarget, 1,
/* 45523*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45526*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45533*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45543*/      /*Scope*/ 28, /*->45572*/
/* 45544*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45546*/       OPC_EmitMergeInputChains1_0,
/* 45547*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45550*/       OPC_EmitConvertToTarget, 1,
/* 45552*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45555*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 45562*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45572*/      0, /*End of Scope*/
/* 45573*/     /*Scope*/ 62, /*->45636*/
/* 45574*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45576*/      OPC_Scope, 28, /*->45606*/ // 2 children in Scope
/* 45578*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45580*/       OPC_EmitMergeInputChains1_0,
/* 45581*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45584*/       OPC_EmitConvertToTarget, 1,
/* 45586*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45589*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45596*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45606*/      /*Scope*/ 28, /*->45635*/
/* 45607*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45609*/       OPC_EmitMergeInputChains1_0,
/* 45610*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45613*/       OPC_EmitConvertToTarget, 1,
/* 45615*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45618*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 45625*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45635*/      0, /*End of Scope*/
/* 45636*/     /*Scope*/ 62, /*->45699*/
/* 45637*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45639*/      OPC_Scope, 28, /*->45669*/ // 2 children in Scope
/* 45641*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45643*/       OPC_EmitMergeInputChains1_0,
/* 45644*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45647*/       OPC_EmitConvertToTarget, 1,
/* 45649*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45652*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45659*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45669*/      /*Scope*/ 28, /*->45698*/
/* 45670*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45672*/       OPC_EmitMergeInputChains1_0,
/* 45673*/       OPC_EmitInteger, MVT::i32, 0, 
/* 45676*/       OPC_EmitConvertToTarget, 1,
/* 45678*/       OPC_EmitInteger, MVT::i64, 0, 
/* 45681*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 45688*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                 // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$val)
/* 45698*/      0, /*End of Scope*/
/* 45699*/     0, /*End of Scope*/
/* 45700*/    /*SwitchType*/ 62, MVT::i64,// ->45764
/* 45702*/     OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 45704*/     OPC_Scope, 28, /*->45734*/ // 2 children in Scope
/* 45706*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45708*/      OPC_EmitMergeInputChains1_0,
/* 45709*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45712*/      OPC_EmitConvertToTarget, 1,
/* 45714*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45717*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45724*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_swap:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 45734*/     /*Scope*/ 28, /*->45763*/
/* 45735*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45737*/      OPC_EmitMergeInputChains1_0,
/* 45738*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45741*/      OPC_EmitConvertToTarget, 1,
/* 45743*/      OPC_EmitInteger, MVT::i64, 0, 
/* 45746*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 45753*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (atomic_swap:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$val)
/* 45763*/     0, /*End of Scope*/
/* 45764*/    0, // EndSwitchType
/* 45765*/   /*Scope*/ 14|128,1/*142*/, /*->45909*/
/* 45767*/    OPC_CheckChild1Type, MVT::i32,
/* 45769*/    OPC_RecordChild2, // #2 = $val
/* 45770*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->45885
/* 45773*/     OPC_Scope, 21, /*->45796*/ // 5 children in Scope
/* 45775*/      OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 45777*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45779*/      OPC_EmitMergeInputChains1_0,
/* 45780*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45783*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45786*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45796*/     /*Scope*/ 21, /*->45818*/
/* 45797*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45799*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45801*/      OPC_EmitMergeInputChains1_0,
/* 45802*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45805*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45808*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45818*/     /*Scope*/ 21, /*->45840*/
/* 45819*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45821*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45823*/      OPC_EmitMergeInputChains1_0,
/* 45824*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45827*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45830*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45840*/     /*Scope*/ 21, /*->45862*/
/* 45841*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45843*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45845*/      OPC_EmitMergeInputChains1_0,
/* 45846*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45849*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45852*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45862*/     /*Scope*/ 21, /*->45884*/
/* 45863*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45865*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45867*/      OPC_EmitMergeInputChains1_0,
/* 45868*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45871*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45884*/     0, /*End of Scope*/
/* 45885*/    /*SwitchType*/ 21, MVT::i64,// ->45908
/* 45887*/     OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 45889*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45891*/     OPC_EmitMergeInputChains1_0,
/* 45892*/     OPC_EmitInteger, MVT::i32, 0, 
/* 45895*/     OPC_EmitInteger, MVT::i32, 0, 
/* 45898*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_swap:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45908*/    0, // EndSwitchType
/* 45909*/   /*Scope*/ 14|128,1/*142*/, /*->46053*/
/* 45911*/    OPC_CheckChild1Type, MVT::i64,
/* 45913*/    OPC_RecordChild2, // #2 = $val
/* 45914*/    OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->46029
/* 45917*/     OPC_Scope, 21, /*->45940*/ // 5 children in Scope
/* 45919*/      OPC_CheckPredicate, 4, // Predicate_atomic_swap_32
/* 45921*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45923*/      OPC_EmitMergeInputChains1_0,
/* 45924*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45927*/      OPC_EmitInteger, MVT::i64, 0, 
/* 45930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 45940*/     /*Scope*/ 21, /*->45962*/
/* 45941*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45943*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45945*/      OPC_EmitMergeInputChains1_0,
/* 45946*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45949*/      OPC_EmitInteger, MVT::i64, 0, 
/* 45952*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 45962*/     /*Scope*/ 21, /*->45984*/
/* 45963*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 45965*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45967*/      OPC_EmitMergeInputChains1_0,
/* 45968*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45971*/      OPC_EmitInteger, MVT::i64, 0, 
/* 45974*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 45984*/     /*Scope*/ 21, /*->46006*/
/* 45985*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 45987*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 45989*/      OPC_EmitMergeInputChains1_0,
/* 45990*/      OPC_EmitInteger, MVT::i32, 0, 
/* 45993*/      OPC_EmitInteger, MVT::i64, 0, 
/* 45996*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 46006*/     /*Scope*/ 21, /*->46028*/
/* 46007*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 46009*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46011*/      OPC_EmitMergeInputChains1_0,
/* 46012*/      OPC_EmitInteger, MVT::i32, 0, 
/* 46015*/      OPC_EmitInteger, MVT::i64, 0, 
/* 46018*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (atomic_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/* 46028*/     0, /*End of Scope*/
/* 46029*/    /*SwitchType*/ 21, MVT::i64,// ->46052
/* 46031*/     OPC_CheckPredicate, 7, // Predicate_atomic_swap_64
/* 46033*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46035*/     OPC_EmitMergeInputChains1_0,
/* 46036*/     OPC_EmitInteger, MVT::i32, 0, 
/* 46039*/     OPC_EmitInteger, MVT::i64, 0, 
/* 46042*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
               // Src: (atomic_swap:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/* 46052*/    0, // EndSwitchType
/* 46053*/   0, /*End of Scope*/
/* 46054*/  0, /*End of Scope*/
/* 46055*/ /*SwitchOpcode*/ 124|128,12/*1660*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->47719
/* 46059*/  OPC_RecordMemRef,
/* 46060*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 46061*/  OPC_Scope, 104|128,7/*1000*/, /*->47064*/ // 2 children in Scope
/* 46064*/   OPC_MoveChild1,
/* 46065*/   OPC_SwitchOpcode /*3 cases */, 45|128,2/*301*/, TARGET_VAL(ISD::ADD),// ->46371
/* 46070*/    OPC_RecordChild0, // #1 = $addr
/* 46071*/    OPC_RecordChild1, // #2 = $off
/* 46072*/    OPC_MoveChild1,
/* 46073*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 46076*/    OPC_MoveParent,
/* 46077*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 46079*/    OPC_SwitchType /*2 cases */, 14|128,1/*142*/, MVT::i32,// ->46225
/* 46083*/     OPC_MoveParent,
/* 46084*/     OPC_RecordChild2, // #3 = $exp
/* 46085*/     OPC_RecordChild3, // #4 = $new
/* 46086*/     OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->46201
/* 46089*/      OPC_Scope, 21, /*->46112*/ // 5 children in Scope
/* 46091*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 46093*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46095*/       OPC_EmitMergeInputChains1_0,
/* 46096*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46099*/       OPC_EmitConvertToTarget, 2,
/* 46101*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46112*/      /*Scope*/ 21, /*->46134*/
/* 46113*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46115*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46117*/       OPC_EmitMergeInputChains1_0,
/* 46118*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46121*/       OPC_EmitConvertToTarget, 2,
/* 46123*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46134*/      /*Scope*/ 21, /*->46156*/
/* 46135*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46137*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46139*/       OPC_EmitMergeInputChains1_0,
/* 46140*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46143*/       OPC_EmitConvertToTarget, 2,
/* 46145*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46156*/      /*Scope*/ 21, /*->46178*/
/* 46157*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46159*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46161*/       OPC_EmitMergeInputChains1_0,
/* 46162*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46165*/       OPC_EmitConvertToTarget, 2,
/* 46167*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46178*/      /*Scope*/ 21, /*->46200*/
/* 46179*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46181*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46183*/       OPC_EmitMergeInputChains1_0,
/* 46184*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46187*/       OPC_EmitConvertToTarget, 2,
/* 46189*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46200*/      0, /*End of Scope*/
/* 46201*/     /*SwitchType*/ 21, MVT::i64,// ->46224
/* 46203*/      OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 46205*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46207*/      OPC_EmitMergeInputChains1_0,
/* 46208*/      OPC_EmitInteger, MVT::i32, 0, 
/* 46211*/      OPC_EmitConvertToTarget, 2,
/* 46213*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 46224*/     0, // EndSwitchType
/* 46225*/    /*SwitchType*/ 14|128,1/*142*/, MVT::i64,// ->46370
/* 46228*/     OPC_MoveParent,
/* 46229*/     OPC_RecordChild2, // #3 = $exp
/* 46230*/     OPC_RecordChild3, // #4 = $new
/* 46231*/     OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->46346
/* 46234*/      OPC_Scope, 21, /*->46257*/ // 5 children in Scope
/* 46236*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 46238*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46240*/       OPC_EmitMergeInputChains1_0,
/* 46241*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46244*/       OPC_EmitConvertToTarget, 2,
/* 46246*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46257*/      /*Scope*/ 21, /*->46279*/
/* 46258*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46260*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46262*/       OPC_EmitMergeInputChains1_0,
/* 46263*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46266*/       OPC_EmitConvertToTarget, 2,
/* 46268*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46279*/      /*Scope*/ 21, /*->46301*/
/* 46280*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46282*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46284*/       OPC_EmitMergeInputChains1_0,
/* 46285*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46288*/       OPC_EmitConvertToTarget, 2,
/* 46290*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46301*/      /*Scope*/ 21, /*->46323*/
/* 46302*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46304*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46306*/       OPC_EmitMergeInputChains1_0,
/* 46307*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46310*/       OPC_EmitConvertToTarget, 2,
/* 46312*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46323*/      /*Scope*/ 21, /*->46345*/
/* 46324*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46326*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46328*/       OPC_EmitMergeInputChains1_0,
/* 46329*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46332*/       OPC_EmitConvertToTarget, 2,
/* 46334*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46345*/      0, /*End of Scope*/
/* 46346*/     /*SwitchType*/ 21, MVT::i64,// ->46369
/* 46348*/      OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 46350*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46352*/      OPC_EmitMergeInputChains1_0,
/* 46353*/      OPC_EmitInteger, MVT::i32, 0, 
/* 46356*/      OPC_EmitConvertToTarget, 2,
/* 46358*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 46369*/     0, // EndSwitchType
/* 46370*/    0, // EndSwitchType
/* 46371*/   /*SwitchOpcode*/ 45|128,2/*301*/, TARGET_VAL(ISD::OR),// ->46676
/* 46375*/    OPC_RecordChild0, // #1 = $addr
/* 46376*/    OPC_RecordChild1, // #2 = $off
/* 46377*/    OPC_MoveChild1,
/* 46378*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 46381*/    OPC_MoveParent,
/* 46382*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 46384*/    OPC_SwitchType /*2 cases */, 14|128,1/*142*/, MVT::i32,// ->46530
/* 46388*/     OPC_MoveParent,
/* 46389*/     OPC_RecordChild2, // #3 = $exp
/* 46390*/     OPC_RecordChild3, // #4 = $new
/* 46391*/     OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->46506
/* 46394*/      OPC_Scope, 21, /*->46417*/ // 5 children in Scope
/* 46396*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 46398*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46400*/       OPC_EmitMergeInputChains1_0,
/* 46401*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46404*/       OPC_EmitConvertToTarget, 2,
/* 46406*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46417*/      /*Scope*/ 21, /*->46439*/
/* 46418*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46420*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46422*/       OPC_EmitMergeInputChains1_0,
/* 46423*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46426*/       OPC_EmitConvertToTarget, 2,
/* 46428*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46439*/      /*Scope*/ 21, /*->46461*/
/* 46440*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46442*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46444*/       OPC_EmitMergeInputChains1_0,
/* 46445*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46448*/       OPC_EmitConvertToTarget, 2,
/* 46450*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46461*/      /*Scope*/ 21, /*->46483*/
/* 46462*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46464*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46466*/       OPC_EmitMergeInputChains1_0,
/* 46467*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46470*/       OPC_EmitConvertToTarget, 2,
/* 46472*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46483*/      /*Scope*/ 21, /*->46505*/
/* 46484*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46486*/       OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46488*/       OPC_EmitMergeInputChains1_0,
/* 46489*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46492*/       OPC_EmitConvertToTarget, 2,
/* 46494*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46505*/      0, /*End of Scope*/
/* 46506*/     /*SwitchType*/ 21, MVT::i64,// ->46529
/* 46508*/      OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 46510*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46512*/      OPC_EmitMergeInputChains1_0,
/* 46513*/      OPC_EmitInteger, MVT::i32, 0, 
/* 46516*/      OPC_EmitConvertToTarget, 2,
/* 46518*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 46529*/     0, // EndSwitchType
/* 46530*/    /*SwitchType*/ 14|128,1/*142*/, MVT::i64,// ->46675
/* 46533*/     OPC_MoveParent,
/* 46534*/     OPC_RecordChild2, // #3 = $exp
/* 46535*/     OPC_RecordChild3, // #4 = $new
/* 46536*/     OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->46651
/* 46539*/      OPC_Scope, 21, /*->46562*/ // 5 children in Scope
/* 46541*/       OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 46543*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46545*/       OPC_EmitMergeInputChains1_0,
/* 46546*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46549*/       OPC_EmitConvertToTarget, 2,
/* 46551*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 11
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46562*/      /*Scope*/ 21, /*->46584*/
/* 46563*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46565*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46567*/       OPC_EmitMergeInputChains1_0,
/* 46568*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46571*/       OPC_EmitConvertToTarget, 2,
/* 46573*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46584*/      /*Scope*/ 21, /*->46606*/
/* 46585*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46587*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46589*/       OPC_EmitMergeInputChains1_0,
/* 46590*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46593*/       OPC_EmitConvertToTarget, 2,
/* 46595*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46606*/      /*Scope*/ 21, /*->46628*/
/* 46607*/       OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46609*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46611*/       OPC_EmitMergeInputChains1_0,
/* 46612*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46615*/       OPC_EmitConvertToTarget, 2,
/* 46617*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46628*/      /*Scope*/ 21, /*->46650*/
/* 46629*/       OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46631*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46633*/       OPC_EmitMergeInputChains1_0,
/* 46634*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46637*/       OPC_EmitConvertToTarget, 2,
/* 46639*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46650*/      0, /*End of Scope*/
/* 46651*/     /*SwitchType*/ 21, MVT::i64,// ->46674
/* 46653*/      OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 46655*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 46657*/      OPC_EmitMergeInputChains1_0,
/* 46658*/      OPC_EmitInteger, MVT::i32, 0, 
/* 46661*/      OPC_EmitConvertToTarget, 2,
/* 46663*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 11
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 46674*/     0, // EndSwitchType
/* 46675*/    0, // EndSwitchType
/* 46676*/   /*SwitchOpcode*/ 127|128,2/*383*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->47063
/* 46680*/    OPC_RecordChild0, // #1 = $off
/* 46681*/    OPC_MoveChild0,
/* 46682*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 46685*/    OPC_MoveParent,
/* 46686*/    OPC_MoveParent,
/* 46687*/    OPC_RecordChild2, // #2 = $exp
/* 46688*/    OPC_RecordChild3, // #3 = $new
/* 46689*/    OPC_SwitchType /*2 cases */, 51|128,2/*307*/, MVT::i32,// ->47000
/* 46693*/     OPC_Scope, 60, /*->46755*/ // 5 children in Scope
/* 46695*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 46697*/      OPC_Scope, 27, /*->46726*/ // 2 children in Scope
/* 46699*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46701*/       OPC_EmitMergeInputChains1_0,
/* 46702*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46705*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46708*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46715*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46726*/      /*Scope*/ 27, /*->46754*/
/* 46727*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46729*/       OPC_EmitMergeInputChains1_0,
/* 46730*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46733*/       OPC_EmitInteger, MVT::i64, 0, 
/* 46736*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 46743*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 10
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46754*/      0, /*End of Scope*/
/* 46755*/     /*Scope*/ 60, /*->46816*/
/* 46756*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46758*/      OPC_Scope, 27, /*->46787*/ // 2 children in Scope
/* 46760*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46762*/       OPC_EmitMergeInputChains1_0,
/* 46763*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46766*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46769*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46776*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46787*/      /*Scope*/ 27, /*->46815*/
/* 46788*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46790*/       OPC_EmitMergeInputChains1_0,
/* 46791*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46794*/       OPC_EmitInteger, MVT::i64, 0, 
/* 46797*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 46804*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46815*/      0, /*End of Scope*/
/* 46816*/     /*Scope*/ 60, /*->46877*/
/* 46817*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46819*/      OPC_Scope, 27, /*->46848*/ // 2 children in Scope
/* 46821*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46823*/       OPC_EmitMergeInputChains1_0,
/* 46824*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46827*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46830*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46837*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46848*/      /*Scope*/ 27, /*->46876*/
/* 46849*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46851*/       OPC_EmitMergeInputChains1_0,
/* 46852*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46855*/       OPC_EmitInteger, MVT::i64, 0, 
/* 46858*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 46865*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46876*/      0, /*End of Scope*/
/* 46877*/     /*Scope*/ 60, /*->46938*/
/* 46878*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 46880*/      OPC_Scope, 27, /*->46909*/ // 2 children in Scope
/* 46882*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46884*/       OPC_EmitMergeInputChains1_0,
/* 46885*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46888*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46891*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46898*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46909*/      /*Scope*/ 27, /*->46937*/
/* 46910*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46912*/       OPC_EmitMergeInputChains1_0,
/* 46913*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46916*/       OPC_EmitInteger, MVT::i64, 0, 
/* 46919*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 46926*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 10
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46937*/      0, /*End of Scope*/
/* 46938*/     /*Scope*/ 60, /*->46999*/
/* 46939*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 46941*/      OPC_Scope, 27, /*->46970*/ // 2 children in Scope
/* 46943*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46945*/       OPC_EmitMergeInputChains1_0,
/* 46946*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46949*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46952*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46959*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46970*/      /*Scope*/ 27, /*->46998*/
/* 46971*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 46973*/       OPC_EmitMergeInputChains1_0,
/* 46974*/       OPC_EmitInteger, MVT::i32, 0, 
/* 46977*/       OPC_EmitInteger, MVT::i64, 0, 
/* 46980*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 46987*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 10
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 46998*/      0, /*End of Scope*/
/* 46999*/     0, /*End of Scope*/
/* 47000*/    /*SwitchType*/ 60, MVT::i64,// ->47062
/* 47002*/     OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 47004*/     OPC_Scope, 27, /*->47033*/ // 2 children in Scope
/* 47006*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 47008*/      OPC_EmitMergeInputChains1_0,
/* 47009*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47012*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47015*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 47022*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 47033*/     /*Scope*/ 27, /*->47061*/
/* 47034*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent())
/* 47036*/      OPC_EmitMergeInputChains1_0,
/* 47037*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47040*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47043*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 5,  // Results = #6
/* 47050*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 10
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 47061*/     0, /*End of Scope*/
/* 47062*/    0, // EndSwitchType
/* 47063*/   0, // EndSwitchOpcode
/* 47064*/  /*Scope*/ 12|128,5/*652*/, /*->47718*/
/* 47066*/   OPC_RecordChild1, // #1 = $off
/* 47067*/   OPC_Scope, 89|128,2/*345*/, /*->47415*/ // 3 children in Scope
/* 47070*/    OPC_MoveChild1,
/* 47071*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 47074*/    OPC_MoveParent,
/* 47075*/    OPC_RecordChild2, // #2 = $exp
/* 47076*/    OPC_RecordChild3, // #3 = $new
/* 47077*/    OPC_SwitchType /*2 cases */, 21|128,2/*277*/, MVT::i32,// ->47358
/* 47081*/     OPC_Scope, 54, /*->47137*/ // 5 children in Scope
/* 47083*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 47085*/      OPC_EmitMergeInputChains1_0,
/* 47086*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47089*/      OPC_EmitConvertToTarget, 1,
/* 47091*/      OPC_Scope, 21, /*->47114*/ // 2 children in Scope
/* 47093*/       OPC_EmitInteger, MVT::i32, 0, 
/* 47096*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 47103*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47114*/      /*Scope*/ 21, /*->47136*/
/* 47115*/       OPC_EmitInteger, MVT::i64, 0, 
/* 47118*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 47125*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 7
                 // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47136*/      0, /*End of Scope*/
/* 47137*/     /*Scope*/ 54, /*->47192*/
/* 47138*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 47140*/      OPC_EmitMergeInputChains1_0,
/* 47141*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47144*/      OPC_EmitConvertToTarget, 1,
/* 47146*/      OPC_Scope, 21, /*->47169*/ // 2 children in Scope
/* 47148*/       OPC_EmitInteger, MVT::i32, 0, 
/* 47151*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 47158*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47169*/      /*Scope*/ 21, /*->47191*/
/* 47170*/       OPC_EmitInteger, MVT::i64, 0, 
/* 47173*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 47180*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47191*/      0, /*End of Scope*/
/* 47192*/     /*Scope*/ 54, /*->47247*/
/* 47193*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 47195*/      OPC_EmitMergeInputChains1_0,
/* 47196*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47199*/      OPC_EmitConvertToTarget, 1,
/* 47201*/      OPC_Scope, 21, /*->47224*/ // 2 children in Scope
/* 47203*/       OPC_EmitInteger, MVT::i32, 0, 
/* 47206*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 47213*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47224*/      /*Scope*/ 21, /*->47246*/
/* 47225*/       OPC_EmitInteger, MVT::i64, 0, 
/* 47228*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 47235*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47246*/      0, /*End of Scope*/
/* 47247*/     /*Scope*/ 54, /*->47302*/
/* 47248*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 47250*/      OPC_EmitMergeInputChains1_0,
/* 47251*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47254*/      OPC_EmitConvertToTarget, 1,
/* 47256*/      OPC_Scope, 21, /*->47279*/ // 2 children in Scope
/* 47258*/       OPC_EmitInteger, MVT::i32, 0, 
/* 47261*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 47268*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47279*/      /*Scope*/ 21, /*->47301*/
/* 47280*/       OPC_EmitInteger, MVT::i64, 0, 
/* 47283*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 47290*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 7
                 // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47301*/      0, /*End of Scope*/
/* 47302*/     /*Scope*/ 54, /*->47357*/
/* 47303*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 47305*/      OPC_EmitMergeInputChains1_0,
/* 47306*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47309*/      OPC_EmitConvertToTarget, 1,
/* 47311*/      OPC_Scope, 21, /*->47334*/ // 2 children in Scope
/* 47313*/       OPC_EmitInteger, MVT::i32, 0, 
/* 47316*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 47323*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47334*/      /*Scope*/ 21, /*->47356*/
/* 47335*/       OPC_EmitInteger, MVT::i64, 0, 
/* 47338*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 47345*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                 // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 7
                 // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47356*/      0, /*End of Scope*/
/* 47357*/     0, /*End of Scope*/
/* 47358*/    /*SwitchType*/ 54, MVT::i64,// ->47414
/* 47360*/     OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 47362*/     OPC_EmitMergeInputChains1_0,
/* 47363*/     OPC_EmitInteger, MVT::i32, 0, 
/* 47366*/     OPC_EmitConvertToTarget, 1,
/* 47368*/     OPC_Scope, 21, /*->47391*/ // 2 children in Scope
/* 47370*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47373*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 47380*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 47391*/     /*Scope*/ 21, /*->47413*/
/* 47392*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47395*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 6,  // Results = #7
/* 47402*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 7
                // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 47413*/     0, /*End of Scope*/
/* 47414*/    0, // EndSwitchType
/* 47415*/   /*Scope*/ 21|128,1/*149*/, /*->47566*/
/* 47417*/    OPC_CheckChild1Type, MVT::i32,
/* 47419*/    OPC_RecordChild2, // #2 = $exp
/* 47420*/    OPC_RecordChild3, // #3 = $new
/* 47421*/    OPC_SwitchType /*2 cases */, 117, MVT::i32,// ->47541
/* 47424*/     OPC_Scope, 22, /*->47448*/ // 5 children in Scope
/* 47426*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 47428*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47430*/      OPC_EmitMergeInputChains1_0,
/* 47431*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47434*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47437*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47448*/     /*Scope*/ 22, /*->47471*/
/* 47449*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 47451*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47453*/      OPC_EmitMergeInputChains1_0,
/* 47454*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47457*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47460*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47471*/     /*Scope*/ 22, /*->47494*/
/* 47472*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 47474*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47476*/      OPC_EmitMergeInputChains1_0,
/* 47477*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47480*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47494*/     /*Scope*/ 22, /*->47517*/
/* 47495*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 47497*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47499*/      OPC_EmitMergeInputChains1_0,
/* 47500*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47503*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47506*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47517*/     /*Scope*/ 22, /*->47540*/
/* 47518*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 47520*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47522*/      OPC_EmitMergeInputChains1_0,
/* 47523*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47526*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47529*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47540*/     0, /*End of Scope*/
/* 47541*/    /*SwitchType*/ 22, MVT::i64,// ->47565
/* 47543*/     OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 47545*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47547*/     OPC_EmitMergeInputChains1_0,
/* 47548*/     OPC_EmitInteger, MVT::i32, 0, 
/* 47551*/     OPC_EmitInteger, MVT::i32, 0, 
/* 47554*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 47565*/    0, // EndSwitchType
/* 47566*/   /*Scope*/ 21|128,1/*149*/, /*->47717*/
/* 47568*/    OPC_CheckChild1Type, MVT::i64,
/* 47570*/    OPC_RecordChild2, // #2 = $exp
/* 47571*/    OPC_RecordChild3, // #3 = $new
/* 47572*/    OPC_SwitchType /*2 cases */, 117, MVT::i32,// ->47692
/* 47575*/     OPC_Scope, 22, /*->47599*/ // 5 children in Scope
/* 47577*/      OPC_CheckPredicate, 4, // Predicate_atomic_cmp_swap_32
/* 47579*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47581*/      OPC_EmitMergeInputChains1_0,
/* 47582*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47585*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 4
                // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47599*/     /*Scope*/ 22, /*->47622*/
/* 47600*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 47602*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47604*/      OPC_EmitMergeInputChains1_0,
/* 47605*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47608*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47611*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47622*/     /*Scope*/ 22, /*->47645*/
/* 47623*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 47625*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47627*/      OPC_EmitMergeInputChains1_0,
/* 47628*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47631*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47634*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47645*/     /*Scope*/ 22, /*->47668*/
/* 47646*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 47648*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47650*/      OPC_EmitMergeInputChains1_0,
/* 47651*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47654*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47657*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 4
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47668*/     /*Scope*/ 22, /*->47691*/
/* 47669*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 47671*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47673*/      OPC_EmitMergeInputChains1_0,
/* 47674*/      OPC_EmitInteger, MVT::i32, 0, 
/* 47677*/      OPC_EmitInteger, MVT::i64, 0, 
/* 47680*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (atomic_cmp_swap:{ *:[i32] } I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 4
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 47691*/     0, /*End of Scope*/
/* 47692*/    /*SwitchType*/ 22, MVT::i64,// ->47716
/* 47694*/     OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_64
/* 47696*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 47698*/     OPC_EmitMergeInputChains1_0,
/* 47699*/     OPC_EmitInteger, MVT::i32, 0, 
/* 47702*/     OPC_EmitInteger, MVT::i64, 0, 
/* 47705*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i64] } I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 4
               // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 47716*/    0, // EndSwitchType
/* 47717*/   0, /*End of Scope*/
/* 47718*/  0, /*End of Scope*/
/* 47719*/ /*SwitchOpcode*/ 16|128,1/*144*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->47867
/* 47723*/  OPC_Scope, 67, /*->47792*/ // 2 children in Scope
/* 47725*/   OPC_MoveChild0,
/* 47726*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 47729*/   OPC_RecordChild0, // #0 = $vec
/* 47730*/   OPC_Scope, 29, /*->47761*/ // 2 children in Scope
/* 47732*/    OPC_CheckChild0Type, MVT::v16i8,
/* 47734*/    OPC_RecordChild1, // #1 = $idx
/* 47735*/    OPC_MoveChild1,
/* 47736*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 47739*/    OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 47741*/    OPC_CheckType, MVT::i32,
/* 47743*/    OPC_MoveParent,
/* 47744*/    OPC_MoveParent,
/* 47745*/    OPC_MoveChild1,
/* 47746*/    OPC_CheckValueType, MVT::i8,
/* 47748*/    OPC_MoveParent,
/* 47749*/    OPC_CheckType, MVT::i32,
/* 47751*/    OPC_EmitConvertToTarget, 1,
/* 47753*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s), 0,
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 47761*/   /*Scope*/ 29, /*->47791*/
/* 47762*/    OPC_CheckChild0Type, MVT::v8i16,
/* 47764*/    OPC_RecordChild1, // #1 = $idx
/* 47765*/    OPC_MoveChild1,
/* 47766*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 47769*/    OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 47771*/    OPC_CheckType, MVT::i32,
/* 47773*/    OPC_MoveParent,
/* 47774*/    OPC_MoveParent,
/* 47775*/    OPC_MoveChild1,
/* 47776*/    OPC_CheckValueType, MVT::i16,
/* 47778*/    OPC_MoveParent,
/* 47779*/    OPC_CheckType, MVT::i32,
/* 47781*/    OPC_EmitConvertToTarget, 1,
/* 47783*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s), 0,
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 47791*/   0, /*End of Scope*/
/* 47792*/  /*Scope*/ 73, /*->47866*/
/* 47793*/   OPC_RecordChild0, // #0 = $src
/* 47794*/   OPC_MoveChild1,
/* 47795*/   OPC_Scope, 27, /*->47824*/ // 3 children in Scope
/* 47797*/    OPC_CheckValueType, MVT::i8,
/* 47799*/    OPC_MoveParent,
/* 47800*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->47812
/* 47803*/     OPC_CheckPatternPredicate, 10, // (Subtarget->hasSignExt())
/* 47805*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 47812*/    /*SwitchType*/ 9, MVT::i64,// ->47823
/* 47814*/     OPC_CheckPatternPredicate, 10, // (Subtarget->hasSignExt())
/* 47816*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 47823*/    0, // EndSwitchType
/* 47824*/   /*Scope*/ 27, /*->47852*/
/* 47825*/    OPC_CheckValueType, MVT::i16,
/* 47827*/    OPC_MoveParent,
/* 47828*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->47840
/* 47831*/     OPC_CheckPatternPredicate, 10, // (Subtarget->hasSignExt())
/* 47833*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 47840*/    /*SwitchType*/ 9, MVT::i64,// ->47851
/* 47842*/     OPC_CheckPatternPredicate, 10, // (Subtarget->hasSignExt())
/* 47844*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 47851*/    0, // EndSwitchType
/* 47852*/   /*Scope*/ 12, /*->47865*/
/* 47853*/    OPC_CheckValueType, MVT::i32,
/* 47855*/    OPC_MoveParent,
/* 47856*/    OPC_CheckPatternPredicate, 10, // (Subtarget->hasSignExt())
/* 47858*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 47865*/   0, /*End of Scope*/
/* 47866*/  0, /*End of Scope*/
/* 47867*/ /*SwitchOpcode*/ 23|128,1/*151*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->48022
/* 47871*/  OPC_RecordMemRef,
/* 47872*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 47873*/  OPC_MoveChild1,
/* 47874*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 47877*/  OPC_RecordChild0, // #1 = $addr
/* 47878*/  OPC_MoveChild0,
/* 47879*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 47882*/  OPC_MoveParent,
/* 47883*/  OPC_MoveParent,
/* 47884*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->47895
/* 47887*/   OPC_EmitMergeInputChains1_0,
/* 47888*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47895*/  /*SwitchType*/ 8, MVT::i64,// ->47905
/* 47897*/   OPC_EmitMergeInputChains1_0,
/* 47898*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 47905*/  /*SwitchType*/ 10, MVT::funcref,// ->47917
/* 47907*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 47909*/   OPC_EmitMergeInputChains1_0,
/* 47910*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47917*/  /*SwitchType*/ 10, MVT::externref,// ->47929
/* 47919*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 47921*/   OPC_EmitMergeInputChains1_0,
/* 47922*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47929*/  /*SwitchType*/ 8, MVT::f32,// ->47939
/* 47931*/   OPC_EmitMergeInputChains1_0,
/* 47932*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47939*/  /*SwitchType*/ 8, MVT::f64,// ->47949
/* 47941*/   OPC_EmitMergeInputChains1_0,
/* 47942*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47949*/  /*SwitchType*/ 10, MVT::v2i64,// ->47961
/* 47951*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 47953*/   OPC_EmitMergeInputChains1_0,
/* 47954*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47961*/  /*SwitchType*/ 10, MVT::v4i32,// ->47973
/* 47963*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 47965*/   OPC_EmitMergeInputChains1_0,
/* 47966*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47973*/  /*SwitchType*/ 10, MVT::v16i8,// ->47985
/* 47975*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 47977*/   OPC_EmitMergeInputChains1_0,
/* 47978*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47985*/  /*SwitchType*/ 10, MVT::v8i16,// ->47997
/* 47987*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 47989*/   OPC_EmitMergeInputChains1_0,
/* 47990*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 47997*/  /*SwitchType*/ 10, MVT::v4f32,// ->48009
/* 47999*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48001*/   OPC_EmitMergeInputChains1_0,
/* 48002*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 48009*/  /*SwitchType*/ 10, MVT::v2f64,// ->48021
/* 48011*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48013*/   OPC_EmitMergeInputChains1_0,
/* 48014*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 48021*/  0, // EndSwitchType
/* 48022*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->48311
/* 48026*/  OPC_RecordMemRef,
/* 48027*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 48028*/  OPC_RecordChild1, // #1 = $src
/* 48029*/  OPC_Scope, 21, /*->48052*/ // 12 children in Scope
/* 48031*/   OPC_CheckChild1Type, MVT::i32,
/* 48033*/   OPC_MoveChild2,
/* 48034*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48037*/   OPC_RecordChild0, // #2 = $addr
/* 48038*/   OPC_MoveChild0,
/* 48039*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48042*/   OPC_MoveParent,
/* 48043*/   OPC_MoveParent,
/* 48044*/   OPC_EmitMergeInputChains1_0,
/* 48045*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 48052*/  /*Scope*/ 21, /*->48074*/
/* 48053*/   OPC_CheckChild1Type, MVT::i64,
/* 48055*/   OPC_MoveChild2,
/* 48056*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48059*/   OPC_RecordChild0, // #2 = $addr
/* 48060*/   OPC_MoveChild0,
/* 48061*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48064*/   OPC_MoveParent,
/* 48065*/   OPC_MoveParent,
/* 48066*/   OPC_EmitMergeInputChains1_0,
/* 48067*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 48074*/  /*Scope*/ 21, /*->48096*/
/* 48075*/   OPC_CheckChild1Type, MVT::f32,
/* 48077*/   OPC_MoveChild2,
/* 48078*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48081*/   OPC_RecordChild0, // #2 = $addr
/* 48082*/   OPC_MoveChild0,
/* 48083*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48086*/   OPC_MoveParent,
/* 48087*/   OPC_MoveParent,
/* 48088*/   OPC_EmitMergeInputChains1_0,
/* 48089*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 48096*/  /*Scope*/ 21, /*->48118*/
/* 48097*/   OPC_CheckChild1Type, MVT::f64,
/* 48099*/   OPC_MoveChild2,
/* 48100*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48103*/   OPC_RecordChild0, // #2 = $addr
/* 48104*/   OPC_MoveChild0,
/* 48105*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48108*/   OPC_MoveParent,
/* 48109*/   OPC_MoveParent,
/* 48110*/   OPC_EmitMergeInputChains1_0,
/* 48111*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 48118*/  /*Scope*/ 23, /*->48142*/
/* 48119*/   OPC_CheckChild1Type, MVT::v4f32,
/* 48121*/   OPC_MoveChild2,
/* 48122*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48125*/   OPC_RecordChild0, // #2 = $addr
/* 48126*/   OPC_MoveChild0,
/* 48127*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48130*/   OPC_MoveParent,
/* 48131*/   OPC_MoveParent,
/* 48132*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48134*/   OPC_EmitMergeInputChains1_0,
/* 48135*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 48142*/  /*Scope*/ 23, /*->48166*/
/* 48143*/   OPC_CheckChild1Type, MVT::v2f64,
/* 48145*/   OPC_MoveChild2,
/* 48146*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48149*/   OPC_RecordChild0, // #2 = $addr
/* 48150*/   OPC_MoveChild0,
/* 48151*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48154*/   OPC_MoveParent,
/* 48155*/   OPC_MoveParent,
/* 48156*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48158*/   OPC_EmitMergeInputChains1_0,
/* 48159*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 48166*/  /*Scope*/ 23, /*->48190*/
/* 48167*/   OPC_CheckChild1Type, MVT::v2i64,
/* 48169*/   OPC_MoveChild2,
/* 48170*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48173*/   OPC_RecordChild0, // #2 = $addr
/* 48174*/   OPC_MoveChild0,
/* 48175*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48178*/   OPC_MoveParent,
/* 48179*/   OPC_MoveParent,
/* 48180*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48182*/   OPC_EmitMergeInputChains1_0,
/* 48183*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 48190*/  /*Scope*/ 23, /*->48214*/
/* 48191*/   OPC_CheckChild1Type, MVT::v4i32,
/* 48193*/   OPC_MoveChild2,
/* 48194*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48197*/   OPC_RecordChild0, // #2 = $addr
/* 48198*/   OPC_MoveChild0,
/* 48199*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48202*/   OPC_MoveParent,
/* 48203*/   OPC_MoveParent,
/* 48204*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48206*/   OPC_EmitMergeInputChains1_0,
/* 48207*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 48214*/  /*Scope*/ 23, /*->48238*/
/* 48215*/   OPC_CheckChild1Type, MVT::v16i8,
/* 48217*/   OPC_MoveChild2,
/* 48218*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48221*/   OPC_RecordChild0, // #2 = $addr
/* 48222*/   OPC_MoveChild0,
/* 48223*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48226*/   OPC_MoveParent,
/* 48227*/   OPC_MoveParent,
/* 48228*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48230*/   OPC_EmitMergeInputChains1_0,
/* 48231*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 48238*/  /*Scope*/ 23, /*->48262*/
/* 48239*/   OPC_CheckChild1Type, MVT::v8i16,
/* 48241*/   OPC_MoveChild2,
/* 48242*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48245*/   OPC_RecordChild0, // #2 = $addr
/* 48246*/   OPC_MoveChild0,
/* 48247*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48250*/   OPC_MoveParent,
/* 48251*/   OPC_MoveParent,
/* 48252*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48254*/   OPC_EmitMergeInputChains1_0,
/* 48255*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 48262*/  /*Scope*/ 23, /*->48286*/
/* 48263*/   OPC_CheckChild1Type, MVT::funcref,
/* 48265*/   OPC_MoveChild2,
/* 48266*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48269*/   OPC_RecordChild0, // #2 = $addr
/* 48270*/   OPC_MoveChild0,
/* 48271*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48274*/   OPC_MoveParent,
/* 48275*/   OPC_MoveParent,
/* 48276*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 48278*/   OPC_EmitMergeInputChains1_0,
/* 48279*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 48286*/  /*Scope*/ 23, /*->48310*/
/* 48287*/   OPC_CheckChild1Type, MVT::externref,
/* 48289*/   OPC_MoveChild2,
/* 48290*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48293*/   OPC_RecordChild0, // #2 = $addr
/* 48294*/   OPC_MoveChild0,
/* 48295*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48298*/   OPC_MoveParent,
/* 48299*/   OPC_MoveParent,
/* 48300*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 48302*/   OPC_EmitMergeInputChains1_0,
/* 48303*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 48310*/  0, /*End of Scope*/
/* 48311*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_START),// ->48336
/* 48314*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 48315*/  OPC_RecordChild1, // #1 = $amt
/* 48316*/  OPC_MoveChild1,
/* 48317*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 48320*/  OPC_MoveParent,
/* 48321*/  OPC_RecordChild2, // #2 = $amt2
/* 48322*/  OPC_MoveChild2,
/* 48323*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 48326*/  OPC_MoveParent,
/* 48327*/  OPC_EmitMergeInputChains1_0,
/* 48328*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 48336*/ /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CALLSEQ_END),// ->48362
/* 48339*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 48340*/  OPC_CaptureGlueInput,
/* 48341*/  OPC_RecordChild1, // #1 = $amt
/* 48342*/  OPC_MoveChild1,
/* 48343*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 48346*/  OPC_MoveParent,
/* 48347*/  OPC_RecordChild2, // #2 = $amt2
/* 48348*/  OPC_MoveChild2,
/* 48349*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 48352*/  OPC_MoveParent,
/* 48353*/  OPC_EmitMergeInputChains1_0,
/* 48354*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 48362*/ /*SwitchOpcode*/ 21, TARGET_VAL(WebAssemblyISD::THROW),// ->48386
/* 48365*/  OPC_RecordNode, // #0 = 'WebAssemblythrow' chained node
/* 48366*/  OPC_MoveChild1,
/* 48367*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48370*/  OPC_RecordChild0, // #1 = $tag
/* 48371*/  OPC_MoveChild0,
/* 48372*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 48375*/  OPC_MoveParent,
/* 48376*/  OPC_MoveParent,
/* 48377*/  OPC_CheckPatternPredicate, 11, // (Subtarget->hasExceptionHandling())
/* 48379*/  OPC_EmitMergeInputChains1_0,
/* 48380*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::THROW), 0|OPFL_Chain|OPFL_Variadic1,
                1/*#Ops*/, 1, 
            // Src: (WebAssemblythrow (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$tag)) - Complexity = 9
            // Dst: (THROW (texternalsym:{ *:[i32] }):$tag)
/* 48386*/ /*SwitchOpcode*/ 24, TARGET_VAL(WebAssemblyISD::CATCH),// ->48413
/* 48389*/  OPC_RecordNode, // #0 = 'WebAssemblycatch' chained node
/* 48390*/  OPC_MoveChild1,
/* 48391*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48394*/  OPC_RecordChild0, // #1 = $tag
/* 48395*/  OPC_MoveChild0,
/* 48396*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 48399*/  OPC_MoveParent,
/* 48400*/  OPC_MoveParent,
/* 48401*/  OPC_CheckType, MVT::i32,
/* 48403*/  OPC_CheckPatternPredicate, 11, // (Subtarget->hasExceptionHandling())
/* 48405*/  OPC_EmitMergeInputChains1_0,
/* 48406*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CATCH), 0|OPFL_Chain,
                MVT::i32, 1/*#Ops*/, 1, 
            // Src: (WebAssemblycatch:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$tag)) - Complexity = 9
            // Dst: (CATCH:{ *:[i32] } (texternalsym:{ *:[i32] }):$tag)
/* 48413*/ /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->48488
/* 48416*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 48417*/  OPC_RecordChild1, // #1 = $src_idx
/* 48418*/  OPC_MoveChild1,
/* 48419*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 48422*/  OPC_CheckType, MVT::i32,
/* 48424*/  OPC_MoveParent,
/* 48425*/  OPC_RecordChild2, // #2 = $dst_idx
/* 48426*/  OPC_MoveChild2,
/* 48427*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 48430*/  OPC_CheckType, MVT::i32,
/* 48432*/  OPC_MoveParent,
/* 48433*/  OPC_RecordChild3, // #3 = $dst
/* 48434*/  OPC_Scope, 25, /*->48461*/ // 2 children in Scope
/* 48436*/   OPC_CheckChild3Type, MVT::i32,
/* 48438*/   OPC_RecordChild4, // #4 = $src
/* 48439*/   OPC_CheckChild4Type, MVT::i32,
/* 48441*/   OPC_RecordChild5, // #5 = $len
/* 48442*/   OPC_CheckChild5Type, MVT::i32,
/* 48444*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 48446*/   OPC_EmitMergeInputChains1_0,
/* 48447*/   OPC_EmitConvertToTarget, 1,
/* 48449*/   OPC_EmitConvertToTarget, 2,
/* 48451*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_6166MEMORY_COPY_A32), 0|OPFL_Chain,
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_6166MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 48461*/  /*Scope*/ 25, /*->48487*/
/* 48462*/   OPC_CheckChild3Type, MVT::i64,
/* 48464*/   OPC_RecordChild4, // #4 = $src
/* 48465*/   OPC_CheckChild4Type, MVT::i64,
/* 48467*/   OPC_RecordChild5, // #5 = $len
/* 48468*/   OPC_CheckChild5Type, MVT::i64,
/* 48470*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 48472*/   OPC_EmitMergeInputChains1_0,
/* 48473*/   OPC_EmitConvertToTarget, 1,
/* 48475*/   OPC_EmitConvertToTarget, 2,
/* 48477*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_6167MEMORY_COPY_A64), 0|OPFL_Chain,
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_6167MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 48487*/  0, /*End of Scope*/
/* 48488*/ /*SwitchOpcode*/ 17, TARGET_VAL(ISD::INTRINSIC_VOID),// ->48508
/* 48491*/  OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/* 48492*/  OPC_CheckChild1Integer, 56|128,13|128,1/*18104*/, 
/* 48496*/  OPC_CheckPatternPredicate, 11, // (Subtarget->hasExceptionHandling())
/* 48498*/  OPC_EmitMergeInputChains1_0,
/* 48499*/  OPC_EmitInteger, MVT::i32, 0, 
/* 48502*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETHROW), 0|OPFL_Chain,
                1/*#Ops*/, 1, 
            // Src: (intrinsic_void 9052:{ *:[iPTR] }) - Complexity = 8
            // Dst: (RETHROW 0:{ *:[i32] })
/* 48508*/ /*SwitchOpcode*/ 79|128,5/*719*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->49231
/* 48512*/  OPC_Scope, 53, /*->48567*/ // 16 children in Scope
/* 48514*/   OPC_CheckChild0Integer, 78|128,13|128,1/*18126*/, 
/* 48518*/   OPC_RecordChild1, // #0 = $src
/* 48519*/   OPC_Scope, 22, /*->48543*/ // 2 children in Scope
/* 48521*/    OPC_CheckChild1Type, MVT::f32,
/* 48523*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->48533
/* 48526*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9063:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 48533*/    /*SwitchType*/ 7, MVT::i64,// ->48542
/* 48535*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9063:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 48542*/    0, // EndSwitchType
/* 48543*/   /*Scope*/ 22, /*->48566*/
/* 48544*/    OPC_CheckChild1Type, MVT::f64,
/* 48546*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->48556
/* 48549*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9063:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 48556*/    /*SwitchType*/ 7, MVT::i64,// ->48565
/* 48558*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9063:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 48565*/    0, // EndSwitchType
/* 48566*/   0, /*End of Scope*/
/* 48567*/  /*Scope*/ 53, /*->48621*/
/* 48568*/   OPC_CheckChild0Integer, 80|128,13|128,1/*18128*/, 
/* 48572*/   OPC_RecordChild1, // #0 = $src
/* 48573*/   OPC_Scope, 22, /*->48597*/ // 2 children in Scope
/* 48575*/    OPC_CheckChild1Type, MVT::f32,
/* 48577*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->48587
/* 48580*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9064:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 48587*/    /*SwitchType*/ 7, MVT::i64,// ->48596
/* 48589*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9064:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 48596*/    0, // EndSwitchType
/* 48597*/   /*Scope*/ 22, /*->48620*/
/* 48598*/    OPC_CheckChild1Type, MVT::f64,
/* 48600*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->48610
/* 48603*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9064:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 48610*/    /*SwitchType*/ 7, MVT::i64,// ->48619
/* 48612*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9064:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 48619*/    0, // EndSwitchType
/* 48620*/   0, /*End of Scope*/
/* 48621*/  /*Scope*/ 47, /*->48669*/
/* 48622*/   OPC_CheckChild0Integer, 16|128,13|128,1/*18064*/, 
/* 48626*/   OPC_RecordChild1, // #0 = $vec
/* 48627*/   OPC_Scope, 9, /*->48638*/ // 4 children in Scope
/* 48629*/    OPC_CheckChild1Type, MVT::v16i8,
/* 48631*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 48638*/   /*Scope*/ 9, /*->48648*/
/* 48639*/    OPC_CheckChild1Type, MVT::v8i16,
/* 48641*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 48648*/   /*Scope*/ 9, /*->48658*/
/* 48649*/    OPC_CheckChild1Type, MVT::v4i32,
/* 48651*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 48658*/   /*Scope*/ 9, /*->48668*/
/* 48659*/    OPC_CheckChild1Type, MVT::v2i64,
/* 48661*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9032:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 48668*/   0, /*End of Scope*/
/* 48669*/  /*Scope*/ 55, /*->48725*/
/* 48670*/   OPC_CheckChild0Integer, 14|128,13|128,1/*18062*/, 
/* 48674*/   OPC_RecordChild1, // #0 = $vec
/* 48675*/   OPC_Scope, 11, /*->48688*/ // 4 children in Scope
/* 48677*/    OPC_CheckChild1Type, MVT::v16i8,
/* 48679*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48681*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 48688*/   /*Scope*/ 11, /*->48700*/
/* 48689*/    OPC_CheckChild1Type, MVT::v8i16,
/* 48691*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48693*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 48700*/   /*Scope*/ 11, /*->48712*/
/* 48701*/    OPC_CheckChild1Type, MVT::v4i32,
/* 48703*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48705*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 48712*/   /*Scope*/ 11, /*->48724*/
/* 48713*/    OPC_CheckChild1Type, MVT::v2i64,
/* 48715*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48717*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9031:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 48724*/   0, /*End of Scope*/
/* 48725*/  /*Scope*/ 55, /*->48781*/
/* 48726*/   OPC_CheckChild0Integer, 20|128,13|128,1/*18068*/, 
/* 48730*/   OPC_RecordChild1, // #0 = $vec
/* 48731*/   OPC_Scope, 11, /*->48744*/ // 4 children in Scope
/* 48733*/    OPC_CheckChild1Type, MVT::v16i8,
/* 48735*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48737*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I8x16), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9034:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 48744*/   /*Scope*/ 11, /*->48756*/
/* 48745*/    OPC_CheckChild1Type, MVT::v8i16,
/* 48747*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48749*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I16x8), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9034:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 48756*/   /*Scope*/ 11, /*->48768*/
/* 48757*/    OPC_CheckChild1Type, MVT::v4i32,
/* 48759*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48761*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I32x4), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9034:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 48768*/   /*Scope*/ 11, /*->48780*/
/* 48769*/    OPC_CheckChild1Type, MVT::v2i64,
/* 48771*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48773*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I64x2), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9034:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 48780*/   0, /*End of Scope*/
/* 48781*/  /*Scope*/ 14, /*->48796*/
/* 48782*/   OPC_CheckChild0Integer, 64|128,13|128,1/*18112*/, 
/* 48786*/   OPC_RecordChild1, // #0 = $src
/* 48787*/   OPC_RecordChild2, // #1 = $mask
/* 48788*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SWIZZLE), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9056:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 48796*/  /*Scope*/ 121, /*->48918*/
/* 48797*/   OPC_CheckChild0Integer, 22|128,13|128,1/*18070*/, 
/* 48801*/   OPC_RecordChild1, // #0 = $v1
/* 48802*/   OPC_SwitchType /*6 cases */, 17, MVT::v16i8,// ->48822
/* 48805*/    OPC_CheckChild1Type, MVT::v16i8,
/* 48807*/    OPC_RecordChild2, // #1 = $v2
/* 48808*/    OPC_CheckChild2Type, MVT::v16i8,
/* 48810*/    OPC_RecordChild3, // #2 = $c
/* 48811*/    OPC_CheckChild3Type, MVT::v16i8,
/* 48813*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9035:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 48822*/   /*SwitchType*/ 17, MVT::v8i16,// ->48841
/* 48824*/    OPC_CheckChild1Type, MVT::v8i16,
/* 48826*/    OPC_RecordChild2, // #1 = $v2
/* 48827*/    OPC_CheckChild2Type, MVT::v8i16,
/* 48829*/    OPC_RecordChild3, // #2 = $c
/* 48830*/    OPC_CheckChild3Type, MVT::v8i16,
/* 48832*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9035:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 48841*/   /*SwitchType*/ 17, MVT::v4i32,// ->48860
/* 48843*/    OPC_CheckChild1Type, MVT::v4i32,
/* 48845*/    OPC_RecordChild2, // #1 = $v2
/* 48846*/    OPC_CheckChild2Type, MVT::v4i32,
/* 48848*/    OPC_RecordChild3, // #2 = $c
/* 48849*/    OPC_CheckChild3Type, MVT::v4i32,
/* 48851*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9035:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 48860*/   /*SwitchType*/ 17, MVT::v2i64,// ->48879
/* 48862*/    OPC_CheckChild1Type, MVT::v2i64,
/* 48864*/    OPC_RecordChild2, // #1 = $v2
/* 48865*/    OPC_CheckChild2Type, MVT::v2i64,
/* 48867*/    OPC_RecordChild3, // #2 = $c
/* 48868*/    OPC_CheckChild3Type, MVT::v2i64,
/* 48870*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 9035:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 48879*/   /*SwitchType*/ 17, MVT::v4f32,// ->48898
/* 48881*/    OPC_CheckChild1Type, MVT::v4f32,
/* 48883*/    OPC_RecordChild2, // #1 = $v2
/* 48884*/    OPC_CheckChild2Type, MVT::v4f32,
/* 48886*/    OPC_RecordChild3, // #2 = $c
/* 48887*/    OPC_CheckChild3Type, MVT::v4f32,
/* 48889*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9035:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 48898*/   /*SwitchType*/ 17, MVT::v2f64,// ->48917
/* 48900*/    OPC_CheckChild1Type, MVT::v2f64,
/* 48902*/    OPC_RecordChild2, // #1 = $v2
/* 48903*/    OPC_CheckChild2Type, MVT::v2f64,
/* 48905*/    OPC_RecordChild3, // #2 = $c
/* 48906*/    OPC_CheckChild3Type, MVT::v2f64,
/* 48908*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9035:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 48917*/   0, // EndSwitchType
/* 48918*/  /*Scope*/ 41, /*->48960*/
/* 48919*/   OPC_CheckChild0Integer, 60|128,13|128,1/*18108*/, 
/* 48923*/   OPC_RecordChild1, // #0 = $lhs
/* 48924*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->48942
/* 48927*/    OPC_CheckChild1Type, MVT::v16i8,
/* 48929*/    OPC_RecordChild2, // #1 = $rhs
/* 48930*/    OPC_CheckChild2Type, MVT::v16i8,
/* 48932*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48934*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9054:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 48942*/   /*SwitchType*/ 15, MVT::v8i16,// ->48959
/* 48944*/    OPC_CheckChild1Type, MVT::v8i16,
/* 48946*/    OPC_RecordChild2, // #1 = $rhs
/* 48947*/    OPC_CheckChild2Type, MVT::v8i16,
/* 48949*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48951*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9054:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 48959*/   0, // EndSwitchType
/* 48960*/  /*Scope*/ 41, /*->49002*/
/* 48961*/   OPC_CheckChild0Integer, 62|128,13|128,1/*18110*/, 
/* 48965*/   OPC_RecordChild1, // #0 = $lhs
/* 48966*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->48984
/* 48969*/    OPC_CheckChild1Type, MVT::v16i8,
/* 48971*/    OPC_RecordChild2, // #1 = $rhs
/* 48972*/    OPC_CheckChild2Type, MVT::v16i8,
/* 48974*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48976*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9055:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 48984*/   /*SwitchType*/ 15, MVT::v8i16,// ->49001
/* 48986*/    OPC_CheckChild1Type, MVT::v8i16,
/* 48988*/    OPC_RecordChild2, // #1 = $rhs
/* 48989*/    OPC_CheckChild2Type, MVT::v8i16,
/* 48991*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 48993*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9055:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 49001*/   0, // EndSwitchType
/* 49002*/  /*Scope*/ 41, /*->49044*/
/* 49003*/   OPC_CheckChild0Integer, 18|128,13|128,1/*18066*/, 
/* 49007*/   OPC_RecordChild1, // #0 = $lhs
/* 49008*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->49026
/* 49011*/    OPC_CheckChild1Type, MVT::v16i8,
/* 49013*/    OPC_RecordChild2, // #1 = $rhs
/* 49014*/    OPC_CheckChild2Type, MVT::v16i8,
/* 49016*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49018*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9033:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 49026*/   /*SwitchType*/ 15, MVT::v8i16,// ->49043
/* 49028*/    OPC_CheckChild1Type, MVT::v8i16,
/* 49030*/    OPC_RecordChild2, // #1 = $rhs
/* 49031*/    OPC_CheckChild2Type, MVT::v8i16,
/* 49033*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49035*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9033:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 49043*/   0, // EndSwitchType
/* 49044*/  /*Scope*/ 16, /*->49061*/
/* 49045*/   OPC_CheckChild0Integer, 26|128,13|128,1/*18074*/, 
/* 49049*/   OPC_RecordChild1, // #0 = $lhs
/* 49050*/   OPC_RecordChild2, // #1 = $rhs
/* 49051*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49053*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DOT), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9037:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 49061*/  /*Scope*/ 41, /*->49103*/
/* 49062*/   OPC_CheckChild0Integer, 50|128,13|128,1/*18098*/, 
/* 49066*/   OPC_RecordChild1, // #0 = $low
/* 49067*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->49085
/* 49070*/    OPC_CheckChild1Type, MVT::v8i16,
/* 49072*/    OPC_RecordChild2, // #1 = $high
/* 49073*/    OPC_CheckChild2Type, MVT::v8i16,
/* 49075*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49077*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9049:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 49085*/   /*SwitchType*/ 15, MVT::v8i16,// ->49102
/* 49087*/    OPC_CheckChild1Type, MVT::v4i32,
/* 49089*/    OPC_RecordChild2, // #1 = $high
/* 49090*/    OPC_CheckChild2Type, MVT::v4i32,
/* 49092*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49094*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9049:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 49102*/   0, // EndSwitchType
/* 49103*/  /*Scope*/ 41, /*->49145*/
/* 49104*/   OPC_CheckChild0Integer, 52|128,13|128,1/*18100*/, 
/* 49108*/   OPC_RecordChild1, // #0 = $low
/* 49109*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->49127
/* 49112*/    OPC_CheckChild1Type, MVT::v8i16,
/* 49114*/    OPC_RecordChild2, // #1 = $high
/* 49115*/    OPC_CheckChild2Type, MVT::v8i16,
/* 49117*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49119*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9050:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 49127*/   /*SwitchType*/ 15, MVT::v8i16,// ->49144
/* 49129*/    OPC_CheckChild1Type, MVT::v4i32,
/* 49131*/    OPC_RecordChild2, // #1 = $high
/* 49132*/    OPC_CheckChild2Type, MVT::v4i32,
/* 49134*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49136*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9050:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 49144*/   0, // EndSwitchType
/* 49145*/  /*Scope*/ 33, /*->49179*/
/* 49146*/   OPC_CheckChild0Integer, 28|128,13|128,1/*18076*/, 
/* 49150*/   OPC_RecordChild1, // #0 = $vec
/* 49151*/   OPC_SwitchType /*2 cases */, 11, MVT::v8i16,// ->49165
/* 49154*/    OPC_CheckChild1Type, MVT::v16i8,
/* 49156*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49158*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9038:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 49165*/   /*SwitchType*/ 11, MVT::v4i32,// ->49178
/* 49167*/    OPC_CheckChild1Type, MVT::v8i16,
/* 49169*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49171*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9038:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 49178*/   0, // EndSwitchType
/* 49179*/  /*Scope*/ 33, /*->49213*/
/* 49180*/   OPC_CheckChild0Integer, 30|128,13|128,1/*18078*/, 
/* 49184*/   OPC_RecordChild1, // #0 = $vec
/* 49185*/   OPC_SwitchType /*2 cases */, 11, MVT::v8i16,// ->49199
/* 49188*/    OPC_CheckChild1Type, MVT::v16i8,
/* 49190*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49192*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9039:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 49199*/   /*SwitchType*/ 11, MVT::v4i32,// ->49212
/* 49201*/    OPC_CheckChild1Type, MVT::v8i16,
/* 49203*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49205*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9039:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 49212*/   0, // EndSwitchType
/* 49213*/  /*Scope*/ 16, /*->49230*/
/* 49214*/   OPC_CheckChild0Integer, 54|128,13|128,1/*18102*/, 
/* 49218*/   OPC_RecordChild1, // #0 = $lhs
/* 49219*/   OPC_RecordChild2, // #1 = $rhs
/* 49220*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49222*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9051:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 49230*/  0, /*End of Scope*/
/* 49231*/ /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->49388
/* 49235*/  OPC_RecordChild0, // #0 = $vec
/* 49236*/  OPC_Scope, 24, /*->49262*/ // 6 children in Scope
/* 49238*/   OPC_CheckChild0Type, MVT::v16i8,
/* 49240*/   OPC_RecordChild1, // #1 = $idx
/* 49241*/   OPC_MoveChild1,
/* 49242*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49245*/   OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 49247*/   OPC_CheckType, MVT::i32,
/* 49249*/   OPC_MoveParent,
/* 49250*/   OPC_CheckType, MVT::i32,
/* 49252*/   OPC_EmitConvertToTarget, 1,
/* 49254*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 49262*/  /*Scope*/ 24, /*->49287*/
/* 49263*/   OPC_CheckChild0Type, MVT::v8i16,
/* 49265*/   OPC_RecordChild1, // #1 = $idx
/* 49266*/   OPC_MoveChild1,
/* 49267*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49270*/   OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 49272*/   OPC_CheckType, MVT::i32,
/* 49274*/   OPC_MoveParent,
/* 49275*/   OPC_CheckType, MVT::i32,
/* 49277*/   OPC_EmitConvertToTarget, 1,
/* 49279*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 49287*/  /*Scope*/ 24, /*->49312*/
/* 49288*/   OPC_CheckChild0Type, MVT::v4i32,
/* 49290*/   OPC_RecordChild1, // #1 = $idx
/* 49291*/   OPC_MoveChild1,
/* 49292*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49295*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 49297*/   OPC_CheckType, MVT::i32,
/* 49299*/   OPC_MoveParent,
/* 49300*/   OPC_CheckType, MVT::i32,
/* 49302*/   OPC_EmitConvertToTarget, 1,
/* 49304*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 49312*/  /*Scope*/ 24, /*->49337*/
/* 49313*/   OPC_CheckChild0Type, MVT::v2i64,
/* 49315*/   OPC_RecordChild1, // #1 = $idx
/* 49316*/   OPC_MoveChild1,
/* 49317*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49320*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 49322*/   OPC_CheckType, MVT::i32,
/* 49324*/   OPC_MoveParent,
/* 49325*/   OPC_CheckType, MVT::i64,
/* 49327*/   OPC_EmitConvertToTarget, 1,
/* 49329*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 49337*/  /*Scope*/ 24, /*->49362*/
/* 49338*/   OPC_CheckChild0Type, MVT::v4f32,
/* 49340*/   OPC_RecordChild1, // #1 = $idx
/* 49341*/   OPC_MoveChild1,
/* 49342*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49345*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 49347*/   OPC_CheckType, MVT::i32,
/* 49349*/   OPC_MoveParent,
/* 49350*/   OPC_CheckType, MVT::f32,
/* 49352*/   OPC_EmitConvertToTarget, 1,
/* 49354*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4), 0,
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 49362*/  /*Scope*/ 24, /*->49387*/
/* 49363*/   OPC_CheckChild0Type, MVT::v2f64,
/* 49365*/   OPC_RecordChild1, // #1 = $idx
/* 49366*/   OPC_MoveChild1,
/* 49367*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49370*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 49372*/   OPC_CheckType, MVT::i32,
/* 49374*/   OPC_MoveParent,
/* 49375*/   OPC_CheckType, MVT::f64,
/* 49377*/   OPC_EmitConvertToTarget, 1,
/* 49379*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2), 0,
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 49387*/  0, /*End of Scope*/
/* 49388*/ /*SwitchOpcode*/ 116, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->49507
/* 49391*/  OPC_RecordChild0, // #0 = $argno
/* 49392*/  OPC_MoveChild0,
/* 49393*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 49396*/  OPC_MoveParent,
/* 49397*/  OPC_SwitchType /*12 cases */, 7, MVT::i32,// ->49407
/* 49400*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 49407*/  /*SwitchType*/ 7, MVT::i64,// ->49416
/* 49409*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 49416*/  /*SwitchType*/ 7, MVT::funcref,// ->49425
/* 49418*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_funcref), 0,
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 49425*/  /*SwitchType*/ 7, MVT::externref,// ->49434
/* 49427*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_externref), 0,
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 49434*/  /*SwitchType*/ 7, MVT::f32,// ->49443
/* 49436*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 49443*/  /*SwitchType*/ 7, MVT::f64,// ->49452
/* 49445*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 49452*/  /*SwitchType*/ 7, MVT::v16i8,// ->49461
/* 49454*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v16i8), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 49461*/  /*SwitchType*/ 7, MVT::v8i16,// ->49470
/* 49463*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v8i16), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 49470*/  /*SwitchType*/ 7, MVT::v4i32,// ->49479
/* 49472*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4i32), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 49479*/  /*SwitchType*/ 7, MVT::v2i64,// ->49488
/* 49481*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2i64), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 49488*/  /*SwitchType*/ 7, MVT::v4f32,// ->49497
/* 49490*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4f32), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 49497*/  /*SwitchType*/ 7, MVT::v2f64,// ->49506
/* 49499*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2f64), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 49506*/  0, // EndSwitchType
/* 49507*/ /*SwitchOpcode*/ 17|128,1/*145*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->49656
/* 49511*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 49512*/  OPC_RecordChild1, // #1 = $local
/* 49513*/  OPC_MoveChild1,
/* 49514*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 49517*/  OPC_MoveParent,
/* 49518*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->49529
/* 49521*/   OPC_EmitMergeInputChains1_0,
/* 49522*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_I32), 0|OPFL_Chain,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 49529*/  /*SwitchType*/ 8, MVT::i64,// ->49539
/* 49531*/   OPC_EmitMergeInputChains1_0,
/* 49532*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_I64), 0|OPFL_Chain,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 49539*/  /*SwitchType*/ 10, MVT::funcref,// ->49551
/* 49541*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 49543*/   OPC_EmitMergeInputChains1_0,
/* 49544*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF), 0|OPFL_Chain,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 49551*/  /*SwitchType*/ 10, MVT::externref,// ->49563
/* 49553*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 49555*/   OPC_EmitMergeInputChains1_0,
/* 49556*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF), 0|OPFL_Chain,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 49563*/  /*SwitchType*/ 8, MVT::f32,// ->49573
/* 49565*/   OPC_EmitMergeInputChains1_0,
/* 49566*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_F32), 0|OPFL_Chain,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 49573*/  /*SwitchType*/ 8, MVT::f64,// ->49583
/* 49575*/   OPC_EmitMergeInputChains1_0,
/* 49576*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_F64), 0|OPFL_Chain,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 49583*/  /*SwitchType*/ 10, MVT::v2i64,// ->49595
/* 49585*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49587*/   OPC_EmitMergeInputChains1_0,
/* 49588*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 49595*/  /*SwitchType*/ 10, MVT::v4i32,// ->49607
/* 49597*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49599*/   OPC_EmitMergeInputChains1_0,
/* 49600*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 49607*/  /*SwitchType*/ 10, MVT::v16i8,// ->49619
/* 49609*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49611*/   OPC_EmitMergeInputChains1_0,
/* 49612*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 49619*/  /*SwitchType*/ 10, MVT::v8i16,// ->49631
/* 49621*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49623*/   OPC_EmitMergeInputChains1_0,
/* 49624*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 49631*/  /*SwitchType*/ 10, MVT::v4f32,// ->49643
/* 49633*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49635*/   OPC_EmitMergeInputChains1_0,
/* 49636*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 49643*/  /*SwitchType*/ 10, MVT::v2f64,// ->49655
/* 49645*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49647*/   OPC_EmitMergeInputChains1_0,
/* 49648*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 49655*/  0, // EndSwitchType
/* 49656*/ /*SwitchOpcode*/ 30|128,1/*158*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->49818
/* 49660*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 49661*/  OPC_RecordChild1, // #1 = $local
/* 49662*/  OPC_MoveChild1,
/* 49663*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 49666*/  OPC_MoveParent,
/* 49667*/  OPC_RecordChild2, // #2 = $src
/* 49668*/  OPC_Scope, 10, /*->49680*/ // 12 children in Scope
/* 49670*/   OPC_CheckChild2Type, MVT::i32,
/* 49672*/   OPC_EmitMergeInputChains1_0,
/* 49673*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_I32), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 49680*/  /*Scope*/ 10, /*->49691*/
/* 49681*/   OPC_CheckChild2Type, MVT::i64,
/* 49683*/   OPC_EmitMergeInputChains1_0,
/* 49684*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_I64), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 49691*/  /*Scope*/ 10, /*->49702*/
/* 49692*/   OPC_CheckChild2Type, MVT::f32,
/* 49694*/   OPC_EmitMergeInputChains1_0,
/* 49695*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_F32), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 49702*/  /*Scope*/ 10, /*->49713*/
/* 49703*/   OPC_CheckChild2Type, MVT::f64,
/* 49705*/   OPC_EmitMergeInputChains1_0,
/* 49706*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_F64), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 49713*/  /*Scope*/ 12, /*->49726*/
/* 49714*/   OPC_CheckChild2Type, MVT::v4f32,
/* 49716*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49718*/   OPC_EmitMergeInputChains1_0,
/* 49719*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 49726*/  /*Scope*/ 12, /*->49739*/
/* 49727*/   OPC_CheckChild2Type, MVT::v2f64,
/* 49729*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49731*/   OPC_EmitMergeInputChains1_0,
/* 49732*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 49739*/  /*Scope*/ 12, /*->49752*/
/* 49740*/   OPC_CheckChild2Type, MVT::v2i64,
/* 49742*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49744*/   OPC_EmitMergeInputChains1_0,
/* 49745*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 49752*/  /*Scope*/ 12, /*->49765*/
/* 49753*/   OPC_CheckChild2Type, MVT::v4i32,
/* 49755*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49757*/   OPC_EmitMergeInputChains1_0,
/* 49758*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 49765*/  /*Scope*/ 12, /*->49778*/
/* 49766*/   OPC_CheckChild2Type, MVT::v16i8,
/* 49768*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49770*/   OPC_EmitMergeInputChains1_0,
/* 49771*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 49778*/  /*Scope*/ 12, /*->49791*/
/* 49779*/   OPC_CheckChild2Type, MVT::v8i16,
/* 49781*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 49783*/   OPC_EmitMergeInputChains1_0,
/* 49784*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 49791*/  /*Scope*/ 12, /*->49804*/
/* 49792*/   OPC_CheckChild2Type, MVT::funcref,
/* 49794*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 49796*/   OPC_EmitMergeInputChains1_0,
/* 49797*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 49804*/  /*Scope*/ 12, /*->49817*/
/* 49805*/   OPC_CheckChild2Type, MVT::externref,
/* 49807*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 49809*/   OPC_EmitMergeInputChains1_0,
/* 49810*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 49817*/  0, /*End of Scope*/
/* 49818*/ /*SwitchOpcode*/ 36|128,1/*164*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->49986
/* 49822*/  OPC_RecordChild0, // #0 = $addr
/* 49823*/  OPC_MoveChild0,
/* 49824*/  OPC_SwitchOpcode /*4 cases */, 51, TARGET_VAL(ISD::TargetGlobalAddress),// ->49879
/* 49828*/   OPC_MoveParent,
/* 49829*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->49854
/* 49832*/    OPC_Scope, 9, /*->49843*/ // 2 children in Scope
/* 49834*/     OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 49836*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 49843*/    /*Scope*/ 9, /*->49853*/
/* 49844*/     OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 49846*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 49853*/    0, /*End of Scope*/
/* 49854*/   /*SwitchType*/ 22, MVT::i64,// ->49878
/* 49856*/    OPC_Scope, 9, /*->49867*/ // 2 children in Scope
/* 49858*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 49860*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 49867*/    /*Scope*/ 9, /*->49877*/
/* 49868*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 49870*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 49877*/    0, /*End of Scope*/
/* 49878*/   0, // EndSwitchType
/* 49879*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->49907
/* 49882*/   OPC_MoveParent,
/* 49883*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->49895
/* 49886*/    OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 49888*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblywrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 49895*/   /*SwitchType*/ 9, MVT::i64,// ->49906
/* 49897*/    OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 49899*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblywrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 49906*/   0, // EndSwitchType
/* 49907*/  /*SwitchOpcode*/ 51, TARGET_VAL(ISD::TargetExternalSymbol),// ->49961
/* 49910*/   OPC_MoveParent,
/* 49911*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->49936
/* 49914*/    OPC_Scope, 9, /*->49925*/ // 2 children in Scope
/* 49916*/     OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 49918*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 49925*/    /*Scope*/ 9, /*->49935*/
/* 49926*/     OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 49928*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 49935*/    0, /*End of Scope*/
/* 49936*/   /*SwitchType*/ 22, MVT::i64,// ->49960
/* 49938*/    OPC_Scope, 9, /*->49949*/ // 2 children in Scope
/* 49940*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 49942*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 49949*/    /*Scope*/ 9, /*->49959*/
/* 49950*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 49952*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblywrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 49959*/    0, /*End of Scope*/
/* 49960*/   0, // EndSwitchType
/* 49961*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::MCSymbol),// ->49985
/* 49964*/   OPC_MoveParent,
/* 49965*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->49975
/* 49968*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblywrapper:{ *:[i32] } (mcsym:{ *:[i32] }):$sym) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (mcsym:{ *:[i32] }):$sym)
/* 49975*/   /*SwitchType*/ 7, MVT::i64,// ->49984
/* 49977*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblywrapper:{ *:[i64] } (mcsym:{ *:[i64] }):$sym) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (mcsym:{ *:[i64] }):$sym)
/* 49984*/   0, // EndSwitchType
/* 49985*/  0, // EndSwitchOpcode
/* 49986*/ /*SwitchOpcode*/ 30, TARGET_VAL(WebAssemblyISD::WrapperPIC),// ->50019
/* 49989*/  OPC_RecordChild0, // #0 = $addr
/* 49990*/  OPC_MoveChild0,
/* 49991*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 49994*/  OPC_MoveParent,
/* 49995*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->50007
/* 49998*/   OPC_CheckPatternPredicate, 13, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 50000*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblywrapperPIC:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
             // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 50007*/  /*SwitchType*/ 9, MVT::i64,// ->50018
/* 50009*/   OPC_CheckPatternPredicate, 14, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 50011*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblywrapperPIC:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
             // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 50018*/  0, // EndSwitchType
/* 50019*/ /*SwitchOpcode*/ 58, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->50080
/* 50022*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 50023*/  OPC_RecordChild1, // #1 = $idx
/* 50024*/  OPC_MoveChild1,
/* 50025*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 50028*/  OPC_CheckType, MVT::i32,
/* 50030*/  OPC_MoveParent,
/* 50031*/  OPC_RecordChild2, // #2 = $dst
/* 50032*/  OPC_Scope, 22, /*->50056*/ // 2 children in Scope
/* 50034*/   OPC_CheckChild2Type, MVT::i32,
/* 50036*/   OPC_RecordChild3, // #3 = $value
/* 50037*/   OPC_CheckChild3Type, MVT::i32,
/* 50039*/   OPC_RecordChild4, // #4 = $size
/* 50040*/   OPC_CheckChild4Type, MVT::i32,
/* 50042*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 50044*/   OPC_EmitMergeInputChains1_0,
/* 50045*/   OPC_EmitConvertToTarget, 1,
/* 50047*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_6166MEMORY_FILL_A32), 0|OPFL_Chain,
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_6166MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 50056*/  /*Scope*/ 22, /*->50079*/
/* 50057*/   OPC_CheckChild2Type, MVT::i64,
/* 50059*/   OPC_RecordChild3, // #3 = $value
/* 50060*/   OPC_CheckChild3Type, MVT::i32,
/* 50062*/   OPC_RecordChild4, // #4 = $size
/* 50063*/   OPC_CheckChild4Type, MVT::i64,
/* 50065*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 50067*/   OPC_EmitMergeInputChains1_0,
/* 50068*/   OPC_EmitConvertToTarget, 1,
/* 50070*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_6167MEMORY_FILL_A64), 0|OPFL_Chain,
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_6167MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 50079*/  0, /*End of Scope*/
/* 50080*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::Constant),// ->50108
/* 50083*/  OPC_RecordNode, // #0 = $imm
/* 50084*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->50096
/* 50087*/   OPC_EmitConvertToTarget, 0,
/* 50089*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 50096*/  /*SwitchType*/ 9, MVT::i64,// ->50107
/* 50098*/   OPC_EmitConvertToTarget, 0,
/* 50100*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 50107*/  0, // EndSwitchType
/* 50108*/ /*SwitchOpcode*/ 14, TARGET_VAL(ISD::BR),// ->50125
/* 50111*/  OPC_RecordNode, // #0 = 'br' chained node
/* 50112*/  OPC_RecordChild1, // #1 = $dst
/* 50113*/  OPC_MoveChild1,
/* 50114*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 50117*/  OPC_MoveParent,
/* 50118*/  OPC_EmitMergeInputChains1_0,
/* 50119*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR), 0|OPFL_Chain,
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 50125*/ /*SwitchOpcode*/ 24, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->50152
/* 50128*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 50129*/  OPC_RecordChild1, // #1 = $index
/* 50130*/  OPC_Scope, 9, /*->50141*/ // 2 children in Scope
/* 50132*/   OPC_CheckChild1Type, MVT::i32,
/* 50134*/   OPC_EmitMergeInputChains1_0,
/* 50135*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 50141*/  /*Scope*/ 9, /*->50151*/
/* 50142*/   OPC_CheckChild1Type, MVT::i64,
/* 50144*/   OPC_EmitMergeInputChains1_0,
/* 50145*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 50151*/  0, /*End of Scope*/
/* 50152*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->50162
/* 50155*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 50156*/  OPC_EmitMergeInputChains1_0,
/* 50157*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 50162*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRAP),// ->50172
/* 50165*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 50166*/  OPC_EmitMergeInputChains1_0,
/* 50167*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::UNREACHABLE), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 50172*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::DEBUGTRAP),// ->50182
/* 50175*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 50176*/  OPC_EmitMergeInputChains1_0,
/* 50177*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 50182*/ /*SwitchOpcode*/ 9, TARGET_VAL(ISD::CLEANUPRET),// ->50194
/* 50185*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 50186*/  OPC_CheckPatternPredicate, 11, // (Subtarget->hasExceptionHandling())
/* 50188*/  OPC_EmitMergeInputChains1_0,
/* 50189*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CLEANUPRET), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 50194*/ /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CATCHRET),// ->50220
/* 50197*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 50198*/  OPC_RecordChild1, // #1 = $dst
/* 50199*/  OPC_MoveChild1,
/* 50200*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 50203*/  OPC_MoveParent,
/* 50204*/  OPC_RecordChild2, // #2 = $from
/* 50205*/  OPC_MoveChild2,
/* 50206*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 50209*/  OPC_MoveParent,
/* 50210*/  OPC_CheckPatternPredicate, 11, // (Subtarget->hasExceptionHandling())
/* 50212*/  OPC_EmitMergeInputChains1_0,
/* 50213*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CATCHRET), 0|OPFL_Chain,
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 50220*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::ADD),// ->50295
/* 50223*/  OPC_RecordChild0, // #0 = $lhs
/* 50224*/  OPC_RecordChild1, // #1 = $rhs
/* 50225*/  OPC_SwitchType /*6 cases */, 8, MVT::i32,// ->50236
/* 50228*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50236*/  /*SwitchType*/ 8, MVT::i64,// ->50246
/* 50238*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50246*/  /*SwitchType*/ 10, MVT::v16i8,// ->50258
/* 50248*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50250*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 50258*/  /*SwitchType*/ 10, MVT::v8i16,// ->50270
/* 50260*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50262*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50270*/  /*SwitchType*/ 10, MVT::v4i32,// ->50282
/* 50272*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50274*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50282*/  /*SwitchType*/ 10, MVT::v2i64,// ->50294
/* 50284*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50286*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64x2), 0,
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 50294*/  0, // EndSwitchType
/* 50295*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::SUB),// ->50430
/* 50299*/  OPC_Scope, 24, /*->50325*/ // 3 children in Scope
/* 50301*/   OPC_RecordChild0, // #0 = $lhs
/* 50302*/   OPC_RecordChild1, // #1 = $rhs
/* 50303*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50314
/* 50306*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50314*/   /*SwitchType*/ 8, MVT::i64,// ->50324
/* 50316*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50324*/   0, // EndSwitchType
/* 50325*/  /*Scope*/ 50, /*->50376*/
/* 50326*/   OPC_MoveChild0,
/* 50327*/   OPC_CheckImmAllZerosV,
/* 50328*/   OPC_MoveParent,
/* 50329*/   OPC_RecordChild1, // #0 = $v
/* 50330*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->50342
/* 50333*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50335*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I8x16), 0,
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 50342*/   /*SwitchType*/ 9, MVT::v8i16,// ->50353
/* 50344*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50346*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 50353*/   /*SwitchType*/ 9, MVT::v4i32,// ->50364
/* 50355*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50357*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 50364*/   /*SwitchType*/ 9, MVT::v2i64,// ->50375
/* 50366*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50368*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 50375*/   0, // EndSwitchType
/* 50376*/  /*Scope*/ 52, /*->50429*/
/* 50377*/   OPC_RecordChild0, // #0 = $lhs
/* 50378*/   OPC_RecordChild1, // #1 = $rhs
/* 50379*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->50392
/* 50382*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50384*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 50392*/   /*SwitchType*/ 10, MVT::v8i16,// ->50404
/* 50394*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50396*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50404*/   /*SwitchType*/ 10, MVT::v4i32,// ->50416
/* 50406*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50408*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50416*/   /*SwitchType*/ 10, MVT::v2i64,// ->50428
/* 50418*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50420*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 50428*/   0, // EndSwitchType
/* 50429*/  0, /*End of Scope*/
/* 50430*/ /*SwitchOpcode*/ 1|128,3/*385*/, TARGET_VAL(ISD::MUL),// ->50819
/* 50434*/  OPC_Scope, 24, /*->50460*/ // 3 children in Scope
/* 50436*/   OPC_RecordChild0, // #0 = $lhs
/* 50437*/   OPC_RecordChild1, // #1 = $rhs
/* 50438*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50449
/* 50441*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50449*/   /*SwitchType*/ 8, MVT::i64,// ->50459
/* 50451*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50459*/   0, // EndSwitchType
/* 50460*/  /*Scope*/ 59|128,2/*315*/, /*->50777*/
/* 50462*/   OPC_MoveChild0,
/* 50463*/   OPC_SwitchOpcode /*4 cases */, 75, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->50542
/* 50467*/    OPC_RecordChild0, // #0 = $lhs
/* 50468*/    OPC_Scope, 23, /*->50493*/ // 3 children in Scope
/* 50470*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50472*/     OPC_MoveParent,
/* 50473*/     OPC_MoveChild1,
/* 50474*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 50477*/     OPC_RecordChild0, // #1 = $rhs
/* 50478*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50480*/     OPC_MoveParent,
/* 50481*/     OPC_CheckType, MVT::v8i16,
/* 50483*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50485*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 50493*/    /*Scope*/ 23, /*->50517*/
/* 50494*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50496*/     OPC_MoveParent,
/* 50497*/     OPC_MoveChild1,
/* 50498*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 50501*/     OPC_RecordChild0, // #1 = $rhs
/* 50502*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50504*/     OPC_MoveParent,
/* 50505*/     OPC_CheckType, MVT::v4i32,
/* 50507*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50509*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50517*/    /*Scope*/ 23, /*->50541*/
/* 50518*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50520*/     OPC_MoveParent,
/* 50521*/     OPC_MoveChild1,
/* 50522*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 50525*/     OPC_RecordChild0, // #1 = $rhs
/* 50526*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50528*/     OPC_MoveParent,
/* 50529*/     OPC_CheckType, MVT::v2i64,
/* 50531*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50533*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50541*/    0, /*End of Scope*/
/* 50542*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->50620
/* 50545*/    OPC_RecordChild0, // #0 = $lhs
/* 50546*/    OPC_Scope, 23, /*->50571*/ // 3 children in Scope
/* 50548*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50550*/     OPC_MoveParent,
/* 50551*/     OPC_MoveChild1,
/* 50552*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 50555*/     OPC_RecordChild0, // #1 = $rhs
/* 50556*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50558*/     OPC_MoveParent,
/* 50559*/     OPC_CheckType, MVT::v8i16,
/* 50561*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50563*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 50571*/    /*Scope*/ 23, /*->50595*/
/* 50572*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50574*/     OPC_MoveParent,
/* 50575*/     OPC_MoveChild1,
/* 50576*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 50579*/     OPC_RecordChild0, // #1 = $rhs
/* 50580*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50582*/     OPC_MoveParent,
/* 50583*/     OPC_CheckType, MVT::v4i32,
/* 50585*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50587*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50595*/    /*Scope*/ 23, /*->50619*/
/* 50596*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50598*/     OPC_MoveParent,
/* 50599*/     OPC_MoveChild1,
/* 50600*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 50603*/     OPC_RecordChild0, // #1 = $rhs
/* 50604*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50606*/     OPC_MoveParent,
/* 50607*/     OPC_CheckType, MVT::v2i64,
/* 50609*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50611*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50619*/    0, /*End of Scope*/
/* 50620*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->50698
/* 50623*/    OPC_RecordChild0, // #0 = $lhs
/* 50624*/    OPC_Scope, 23, /*->50649*/ // 3 children in Scope
/* 50626*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50628*/     OPC_MoveParent,
/* 50629*/     OPC_MoveChild1,
/* 50630*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 50633*/     OPC_RecordChild0, // #1 = $rhs
/* 50634*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50636*/     OPC_MoveParent,
/* 50637*/     OPC_CheckType, MVT::v8i16,
/* 50639*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50641*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 50649*/    /*Scope*/ 23, /*->50673*/
/* 50650*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50652*/     OPC_MoveParent,
/* 50653*/     OPC_MoveChild1,
/* 50654*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 50657*/     OPC_RecordChild0, // #1 = $rhs
/* 50658*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50660*/     OPC_MoveParent,
/* 50661*/     OPC_CheckType, MVT::v4i32,
/* 50663*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50665*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50673*/    /*Scope*/ 23, /*->50697*/
/* 50674*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50676*/     OPC_MoveParent,
/* 50677*/     OPC_MoveChild1,
/* 50678*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 50681*/     OPC_RecordChild0, // #1 = $rhs
/* 50682*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50684*/     OPC_MoveParent,
/* 50685*/     OPC_CheckType, MVT::v2i64,
/* 50687*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50689*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50697*/    0, /*End of Scope*/
/* 50698*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->50776
/* 50701*/    OPC_RecordChild0, // #0 = $lhs
/* 50702*/    OPC_Scope, 23, /*->50727*/ // 3 children in Scope
/* 50704*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50706*/     OPC_MoveParent,
/* 50707*/     OPC_MoveChild1,
/* 50708*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 50711*/     OPC_RecordChild0, // #1 = $rhs
/* 50712*/     OPC_CheckChild0Type, MVT::v16i8,
/* 50714*/     OPC_MoveParent,
/* 50715*/     OPC_CheckType, MVT::v8i16,
/* 50717*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50719*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 50727*/    /*Scope*/ 23, /*->50751*/
/* 50728*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50730*/     OPC_MoveParent,
/* 50731*/     OPC_MoveChild1,
/* 50732*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 50735*/     OPC_RecordChild0, // #1 = $rhs
/* 50736*/     OPC_CheckChild0Type, MVT::v8i16,
/* 50738*/     OPC_MoveParent,
/* 50739*/     OPC_CheckType, MVT::v4i32,
/* 50741*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50743*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50751*/    /*Scope*/ 23, /*->50775*/
/* 50752*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50754*/     OPC_MoveParent,
/* 50755*/     OPC_MoveChild1,
/* 50756*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 50759*/     OPC_RecordChild0, // #1 = $rhs
/* 50760*/     OPC_CheckChild0Type, MVT::v4i32,
/* 50762*/     OPC_MoveParent,
/* 50763*/     OPC_CheckType, MVT::v2i64,
/* 50765*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50767*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50775*/    0, /*End of Scope*/
/* 50776*/   0, // EndSwitchOpcode
/* 50777*/  /*Scope*/ 40, /*->50818*/
/* 50778*/   OPC_RecordChild0, // #0 = $lhs
/* 50779*/   OPC_RecordChild1, // #1 = $rhs
/* 50780*/   OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->50793
/* 50783*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50785*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 50793*/   /*SwitchType*/ 10, MVT::v4i32,// ->50805
/* 50795*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50797*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 50805*/   /*SwitchType*/ 10, MVT::v2i64,// ->50817
/* 50807*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 50809*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 50817*/   0, // EndSwitchType
/* 50818*/  0, /*End of Scope*/
/* 50819*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SDIV),// ->50846
/* 50822*/  OPC_RecordChild0, // #0 = $lhs
/* 50823*/  OPC_RecordChild1, // #1 = $rhs
/* 50824*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50835
/* 50827*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50835*/  /*SwitchType*/ 8, MVT::i64,// ->50845
/* 50837*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50845*/  0, // EndSwitchType
/* 50846*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UDIV),// ->50873
/* 50849*/  OPC_RecordChild0, // #0 = $lhs
/* 50850*/  OPC_RecordChild1, // #1 = $rhs
/* 50851*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50862
/* 50854*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50862*/  /*SwitchType*/ 8, MVT::i64,// ->50872
/* 50864*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50872*/  0, // EndSwitchType
/* 50873*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SREM),// ->50900
/* 50876*/  OPC_RecordChild0, // #0 = $lhs
/* 50877*/  OPC_RecordChild1, // #1 = $rhs
/* 50878*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50889
/* 50881*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50889*/  /*SwitchType*/ 8, MVT::i64,// ->50899
/* 50891*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50899*/  0, // EndSwitchType
/* 50900*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UREM),// ->50927
/* 50903*/  OPC_RecordChild0, // #0 = $lhs
/* 50904*/  OPC_RecordChild1, // #1 = $rhs
/* 50905*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50916
/* 50908*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50916*/  /*SwitchType*/ 8, MVT::i64,// ->50926
/* 50918*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50926*/  0, // EndSwitchType
/* 50927*/ /*SwitchOpcode*/ 109|128,6/*877*/, TARGET_VAL(ISD::OR),// ->51808
/* 50931*/  OPC_Scope, 24, /*->50957*/ // 3 children in Scope
/* 50933*/   OPC_RecordChild0, // #0 = $lhs
/* 50934*/   OPC_RecordChild1, // #1 = $rhs
/* 50935*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->50946
/* 50938*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50946*/   /*SwitchType*/ 8, MVT::i64,// ->50956
/* 50948*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50956*/   0, // EndSwitchType
/* 50957*/  /*Scope*/ 35|128,6/*803*/, /*->51762*/
/* 50959*/   OPC_MoveChild0,
/* 50960*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 50963*/   OPC_Scope, 12|128,1/*140*/, /*->51106*/ // 9 children in Scope
/* 50966*/    OPC_RecordChild0, // #0 = $c
/* 50967*/    OPC_RecordChild1, // #1 = $v1
/* 50968*/    OPC_MoveParent,
/* 50969*/    OPC_MoveChild1,
/* 50970*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 50973*/    OPC_Scope, 58, /*->51033*/ // 4 children in Scope
/* 50975*/     OPC_MoveChild0,
/* 50976*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 50979*/     OPC_CheckChild0Same, 0,
/* 50981*/     OPC_MoveChild1,
/* 50982*/     OPC_CheckImmAllOnesV,
/* 50983*/     OPC_MoveParent,
/* 50984*/     OPC_MoveParent,
/* 50985*/     OPC_RecordChild1, // #2 = $v2
/* 50986*/     OPC_MoveParent,
/* 50987*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->50999
/* 50990*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 50999*/     /*SwitchType*/ 9, MVT::v8i16,// ->51010
/* 51001*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51010*/     /*SwitchType*/ 9, MVT::v4i32,// ->51021
/* 51012*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51021*/     /*SwitchType*/ 9, MVT::v2i64,// ->51032
/* 51023*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51032*/     0, // EndSwitchType
/* 51033*/    /*Scope*/ 23, /*->51057*/
/* 51034*/     OPC_RecordChild0, // #2 = $v2
/* 51035*/     OPC_MoveChild1,
/* 51036*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51039*/     OPC_CheckChild0Same, 0,
/* 51041*/     OPC_MoveChild1,
/* 51042*/     OPC_CheckImmAllOnesV,
/* 51043*/     OPC_MoveParent,
/* 51044*/     OPC_MoveParent,
/* 51045*/     OPC_MoveParent,
/* 51046*/     OPC_CheckType, MVT::v16i8,
/* 51048*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51057*/    /*Scope*/ 23, /*->51081*/
/* 51058*/     OPC_MoveChild0,
/* 51059*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51062*/     OPC_CheckChild0Same, 1,
/* 51064*/     OPC_MoveChild1,
/* 51065*/     OPC_CheckImmAllOnesV,
/* 51066*/     OPC_MoveParent,
/* 51067*/     OPC_MoveParent,
/* 51068*/     OPC_RecordChild1, // #2 = $v2
/* 51069*/     OPC_MoveParent,
/* 51070*/     OPC_CheckType, MVT::v16i8,
/* 51072*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51081*/    /*Scope*/ 23, /*->51105*/
/* 51082*/     OPC_RecordChild0, // #2 = $v2
/* 51083*/     OPC_MoveChild1,
/* 51084*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51087*/     OPC_CheckChild0Same, 1,
/* 51089*/     OPC_MoveChild1,
/* 51090*/     OPC_CheckImmAllOnesV,
/* 51091*/     OPC_MoveParent,
/* 51092*/     OPC_MoveParent,
/* 51093*/     OPC_MoveParent,
/* 51094*/     OPC_CheckType, MVT::v16i8,
/* 51096*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51105*/    0, /*End of Scope*/
/* 51106*/   /*Scope*/ 49, /*->51156*/
/* 51107*/    OPC_MoveChild0,
/* 51108*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51111*/    OPC_RecordChild0, // #0 = $c
/* 51112*/    OPC_MoveChild1,
/* 51113*/    OPC_CheckImmAllOnesV,
/* 51114*/    OPC_MoveParent,
/* 51115*/    OPC_MoveParent,
/* 51116*/    OPC_RecordChild1, // #1 = $v2
/* 51117*/    OPC_MoveParent,
/* 51118*/    OPC_MoveChild1,
/* 51119*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51122*/    OPC_Scope, 15, /*->51139*/ // 2 children in Scope
/* 51124*/     OPC_CheckChild0Same, 0,
/* 51126*/     OPC_RecordChild1, // #2 = $v1
/* 51127*/     OPC_MoveParent,
/* 51128*/     OPC_CheckType, MVT::v16i8,
/* 51130*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51139*/    /*Scope*/ 15, /*->51155*/
/* 51140*/     OPC_RecordChild0, // #2 = $v1
/* 51141*/     OPC_CheckChild1Same, 0,
/* 51143*/     OPC_MoveParent,
/* 51144*/     OPC_CheckType, MVT::v16i8,
/* 51146*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51155*/    0, /*End of Scope*/
/* 51156*/   /*Scope*/ 5|128,1/*133*/, /*->51291*/
/* 51158*/    OPC_RecordChild0, // #0 = $v2
/* 51159*/    OPC_Scope, 48, /*->51209*/ // 2 children in Scope
/* 51161*/     OPC_MoveChild1,
/* 51162*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51165*/     OPC_RecordChild0, // #1 = $c
/* 51166*/     OPC_MoveChild1,
/* 51167*/     OPC_CheckImmAllOnesV,
/* 51168*/     OPC_MoveParent,
/* 51169*/     OPC_MoveParent,
/* 51170*/     OPC_MoveParent,
/* 51171*/     OPC_MoveChild1,
/* 51172*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51175*/     OPC_Scope, 15, /*->51192*/ // 2 children in Scope
/* 51177*/      OPC_CheckChild0Same, 1,
/* 51179*/      OPC_RecordChild1, // #2 = $v1
/* 51180*/      OPC_MoveParent,
/* 51181*/      OPC_CheckType, MVT::v16i8,
/* 51183*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51192*/     /*Scope*/ 15, /*->51208*/
/* 51193*/      OPC_RecordChild0, // #2 = $v1
/* 51194*/      OPC_CheckChild1Same, 1,
/* 51196*/      OPC_MoveParent,
/* 51197*/      OPC_CheckType, MVT::v16i8,
/* 51199*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 51208*/     0, /*End of Scope*/
/* 51209*/    /*Scope*/ 80, /*->51290*/
/* 51210*/     OPC_RecordChild1, // #1 = $v1
/* 51211*/     OPC_MoveParent,
/* 51212*/     OPC_MoveChild1,
/* 51213*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51216*/     OPC_Scope, 23, /*->51241*/ // 3 children in Scope
/* 51218*/      OPC_RecordChild0, // #2 = $v2
/* 51219*/      OPC_MoveChild1,
/* 51220*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51223*/      OPC_CheckChild0Same, 0,
/* 51225*/      OPC_MoveChild1,
/* 51226*/      OPC_CheckImmAllOnesV,
/* 51227*/      OPC_MoveParent,
/* 51228*/      OPC_MoveParent,
/* 51229*/      OPC_MoveParent,
/* 51230*/      OPC_CheckType, MVT::v8i16,
/* 51232*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51241*/     /*Scope*/ 23, /*->51265*/
/* 51242*/      OPC_MoveChild0,
/* 51243*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51246*/      OPC_CheckChild0Same, 1,
/* 51248*/      OPC_MoveChild1,
/* 51249*/      OPC_CheckImmAllOnesV,
/* 51250*/      OPC_MoveParent,
/* 51251*/      OPC_MoveParent,
/* 51252*/      OPC_RecordChild1, // #2 = $v2
/* 51253*/      OPC_MoveParent,
/* 51254*/      OPC_CheckType, MVT::v8i16,
/* 51256*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51265*/     /*Scope*/ 23, /*->51289*/
/* 51266*/      OPC_RecordChild0, // #2 = $v2
/* 51267*/      OPC_MoveChild1,
/* 51268*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51271*/      OPC_CheckChild0Same, 1,
/* 51273*/      OPC_MoveChild1,
/* 51274*/      OPC_CheckImmAllOnesV,
/* 51275*/      OPC_MoveParent,
/* 51276*/      OPC_MoveParent,
/* 51277*/      OPC_MoveParent,
/* 51278*/      OPC_CheckType, MVT::v8i16,
/* 51280*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51289*/     0, /*End of Scope*/
/* 51290*/    0, /*End of Scope*/
/* 51291*/   /*Scope*/ 49, /*->51341*/
/* 51292*/    OPC_MoveChild0,
/* 51293*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51296*/    OPC_RecordChild0, // #0 = $c
/* 51297*/    OPC_MoveChild1,
/* 51298*/    OPC_CheckImmAllOnesV,
/* 51299*/    OPC_MoveParent,
/* 51300*/    OPC_MoveParent,
/* 51301*/    OPC_RecordChild1, // #1 = $v2
/* 51302*/    OPC_MoveParent,
/* 51303*/    OPC_MoveChild1,
/* 51304*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51307*/    OPC_Scope, 15, /*->51324*/ // 2 children in Scope
/* 51309*/     OPC_CheckChild0Same, 0,
/* 51311*/     OPC_RecordChild1, // #2 = $v1
/* 51312*/     OPC_MoveParent,
/* 51313*/     OPC_CheckType, MVT::v8i16,
/* 51315*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51324*/    /*Scope*/ 15, /*->51340*/
/* 51325*/     OPC_RecordChild0, // #2 = $v1
/* 51326*/     OPC_CheckChild1Same, 0,
/* 51328*/     OPC_MoveParent,
/* 51329*/     OPC_CheckType, MVT::v8i16,
/* 51331*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51340*/    0, /*End of Scope*/
/* 51341*/   /*Scope*/ 5|128,1/*133*/, /*->51476*/
/* 51343*/    OPC_RecordChild0, // #0 = $v2
/* 51344*/    OPC_Scope, 48, /*->51394*/ // 2 children in Scope
/* 51346*/     OPC_MoveChild1,
/* 51347*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51350*/     OPC_RecordChild0, // #1 = $c
/* 51351*/     OPC_MoveChild1,
/* 51352*/     OPC_CheckImmAllOnesV,
/* 51353*/     OPC_MoveParent,
/* 51354*/     OPC_MoveParent,
/* 51355*/     OPC_MoveParent,
/* 51356*/     OPC_MoveChild1,
/* 51357*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51360*/     OPC_Scope, 15, /*->51377*/ // 2 children in Scope
/* 51362*/      OPC_CheckChild0Same, 1,
/* 51364*/      OPC_RecordChild1, // #2 = $v1
/* 51365*/      OPC_MoveParent,
/* 51366*/      OPC_CheckType, MVT::v8i16,
/* 51368*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51377*/     /*Scope*/ 15, /*->51393*/
/* 51378*/      OPC_RecordChild0, // #2 = $v1
/* 51379*/      OPC_CheckChild1Same, 1,
/* 51381*/      OPC_MoveParent,
/* 51382*/      OPC_CheckType, MVT::v8i16,
/* 51384*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 51393*/     0, /*End of Scope*/
/* 51394*/    /*Scope*/ 80, /*->51475*/
/* 51395*/     OPC_RecordChild1, // #1 = $v1
/* 51396*/     OPC_MoveParent,
/* 51397*/     OPC_MoveChild1,
/* 51398*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51401*/     OPC_Scope, 23, /*->51426*/ // 3 children in Scope
/* 51403*/      OPC_RecordChild0, // #2 = $v2
/* 51404*/      OPC_MoveChild1,
/* 51405*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51408*/      OPC_CheckChild0Same, 0,
/* 51410*/      OPC_MoveChild1,
/* 51411*/      OPC_CheckImmAllOnesV,
/* 51412*/      OPC_MoveParent,
/* 51413*/      OPC_MoveParent,
/* 51414*/      OPC_MoveParent,
/* 51415*/      OPC_CheckType, MVT::v4i32,
/* 51417*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51426*/     /*Scope*/ 23, /*->51450*/
/* 51427*/      OPC_MoveChild0,
/* 51428*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51431*/      OPC_CheckChild0Same, 1,
/* 51433*/      OPC_MoveChild1,
/* 51434*/      OPC_CheckImmAllOnesV,
/* 51435*/      OPC_MoveParent,
/* 51436*/      OPC_MoveParent,
/* 51437*/      OPC_RecordChild1, // #2 = $v2
/* 51438*/      OPC_MoveParent,
/* 51439*/      OPC_CheckType, MVT::v4i32,
/* 51441*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51450*/     /*Scope*/ 23, /*->51474*/
/* 51451*/      OPC_RecordChild0, // #2 = $v2
/* 51452*/      OPC_MoveChild1,
/* 51453*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51456*/      OPC_CheckChild0Same, 1,
/* 51458*/      OPC_MoveChild1,
/* 51459*/      OPC_CheckImmAllOnesV,
/* 51460*/      OPC_MoveParent,
/* 51461*/      OPC_MoveParent,
/* 51462*/      OPC_MoveParent,
/* 51463*/      OPC_CheckType, MVT::v4i32,
/* 51465*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51474*/     0, /*End of Scope*/
/* 51475*/    0, /*End of Scope*/
/* 51476*/   /*Scope*/ 49, /*->51526*/
/* 51477*/    OPC_MoveChild0,
/* 51478*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51481*/    OPC_RecordChild0, // #0 = $c
/* 51482*/    OPC_MoveChild1,
/* 51483*/    OPC_CheckImmAllOnesV,
/* 51484*/    OPC_MoveParent,
/* 51485*/    OPC_MoveParent,
/* 51486*/    OPC_RecordChild1, // #1 = $v2
/* 51487*/    OPC_MoveParent,
/* 51488*/    OPC_MoveChild1,
/* 51489*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51492*/    OPC_Scope, 15, /*->51509*/ // 2 children in Scope
/* 51494*/     OPC_CheckChild0Same, 0,
/* 51496*/     OPC_RecordChild1, // #2 = $v1
/* 51497*/     OPC_MoveParent,
/* 51498*/     OPC_CheckType, MVT::v4i32,
/* 51500*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51509*/    /*Scope*/ 15, /*->51525*/
/* 51510*/     OPC_RecordChild0, // #2 = $v1
/* 51511*/     OPC_CheckChild1Same, 0,
/* 51513*/     OPC_MoveParent,
/* 51514*/     OPC_CheckType, MVT::v4i32,
/* 51516*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51525*/    0, /*End of Scope*/
/* 51526*/   /*Scope*/ 5|128,1/*133*/, /*->51661*/
/* 51528*/    OPC_RecordChild0, // #0 = $v2
/* 51529*/    OPC_Scope, 48, /*->51579*/ // 2 children in Scope
/* 51531*/     OPC_MoveChild1,
/* 51532*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51535*/     OPC_RecordChild0, // #1 = $c
/* 51536*/     OPC_MoveChild1,
/* 51537*/     OPC_CheckImmAllOnesV,
/* 51538*/     OPC_MoveParent,
/* 51539*/     OPC_MoveParent,
/* 51540*/     OPC_MoveParent,
/* 51541*/     OPC_MoveChild1,
/* 51542*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51545*/     OPC_Scope, 15, /*->51562*/ // 2 children in Scope
/* 51547*/      OPC_CheckChild0Same, 1,
/* 51549*/      OPC_RecordChild1, // #2 = $v1
/* 51550*/      OPC_MoveParent,
/* 51551*/      OPC_CheckType, MVT::v4i32,
/* 51553*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51562*/     /*Scope*/ 15, /*->51578*/
/* 51563*/      OPC_RecordChild0, // #2 = $v1
/* 51564*/      OPC_CheckChild1Same, 1,
/* 51566*/      OPC_MoveParent,
/* 51567*/      OPC_CheckType, MVT::v4i32,
/* 51569*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 51578*/     0, /*End of Scope*/
/* 51579*/    /*Scope*/ 80, /*->51660*/
/* 51580*/     OPC_RecordChild1, // #1 = $v1
/* 51581*/     OPC_MoveParent,
/* 51582*/     OPC_MoveChild1,
/* 51583*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51586*/     OPC_Scope, 23, /*->51611*/ // 3 children in Scope
/* 51588*/      OPC_RecordChild0, // #2 = $v2
/* 51589*/      OPC_MoveChild1,
/* 51590*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51593*/      OPC_CheckChild0Same, 0,
/* 51595*/      OPC_MoveChild1,
/* 51596*/      OPC_CheckImmAllOnesV,
/* 51597*/      OPC_MoveParent,
/* 51598*/      OPC_MoveParent,
/* 51599*/      OPC_MoveParent,
/* 51600*/      OPC_CheckType, MVT::v2i64,
/* 51602*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51611*/     /*Scope*/ 23, /*->51635*/
/* 51612*/      OPC_MoveChild0,
/* 51613*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51616*/      OPC_CheckChild0Same, 1,
/* 51618*/      OPC_MoveChild1,
/* 51619*/      OPC_CheckImmAllOnesV,
/* 51620*/      OPC_MoveParent,
/* 51621*/      OPC_MoveParent,
/* 51622*/      OPC_RecordChild1, // #2 = $v2
/* 51623*/      OPC_MoveParent,
/* 51624*/      OPC_CheckType, MVT::v2i64,
/* 51626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51635*/     /*Scope*/ 23, /*->51659*/
/* 51636*/      OPC_RecordChild0, // #2 = $v2
/* 51637*/      OPC_MoveChild1,
/* 51638*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51641*/      OPC_CheckChild0Same, 1,
/* 51643*/      OPC_MoveChild1,
/* 51644*/      OPC_CheckImmAllOnesV,
/* 51645*/      OPC_MoveParent,
/* 51646*/      OPC_MoveParent,
/* 51647*/      OPC_MoveParent,
/* 51648*/      OPC_CheckType, MVT::v2i64,
/* 51650*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51659*/     0, /*End of Scope*/
/* 51660*/    0, /*End of Scope*/
/* 51661*/   /*Scope*/ 49, /*->51711*/
/* 51662*/    OPC_MoveChild0,
/* 51663*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51666*/    OPC_RecordChild0, // #0 = $c
/* 51667*/    OPC_MoveChild1,
/* 51668*/    OPC_CheckImmAllOnesV,
/* 51669*/    OPC_MoveParent,
/* 51670*/    OPC_MoveParent,
/* 51671*/    OPC_RecordChild1, // #1 = $v2
/* 51672*/    OPC_MoveParent,
/* 51673*/    OPC_MoveChild1,
/* 51674*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51677*/    OPC_Scope, 15, /*->51694*/ // 2 children in Scope
/* 51679*/     OPC_CheckChild0Same, 0,
/* 51681*/     OPC_RecordChild1, // #2 = $v1
/* 51682*/     OPC_MoveParent,
/* 51683*/     OPC_CheckType, MVT::v2i64,
/* 51685*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51694*/    /*Scope*/ 15, /*->51710*/
/* 51695*/     OPC_RecordChild0, // #2 = $v1
/* 51696*/     OPC_CheckChild1Same, 0,
/* 51698*/     OPC_MoveParent,
/* 51699*/     OPC_CheckType, MVT::v2i64,
/* 51701*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51710*/    0, /*End of Scope*/
/* 51711*/   /*Scope*/ 49, /*->51761*/
/* 51712*/    OPC_RecordChild0, // #0 = $v2
/* 51713*/    OPC_MoveChild1,
/* 51714*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 51717*/    OPC_RecordChild0, // #1 = $c
/* 51718*/    OPC_MoveChild1,
/* 51719*/    OPC_CheckImmAllOnesV,
/* 51720*/    OPC_MoveParent,
/* 51721*/    OPC_MoveParent,
/* 51722*/    OPC_MoveParent,
/* 51723*/    OPC_MoveChild1,
/* 51724*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 51727*/    OPC_Scope, 15, /*->51744*/ // 2 children in Scope
/* 51729*/     OPC_CheckChild0Same, 1,
/* 51731*/     OPC_RecordChild1, // #2 = $v1
/* 51732*/     OPC_MoveParent,
/* 51733*/     OPC_CheckType, MVT::v2i64,
/* 51735*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51744*/    /*Scope*/ 15, /*->51760*/
/* 51745*/     OPC_RecordChild0, // #2 = $v1
/* 51746*/     OPC_CheckChild1Same, 1,
/* 51748*/     OPC_MoveParent,
/* 51749*/     OPC_CheckType, MVT::v2i64,
/* 51751*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 51760*/    0, /*End of Scope*/
/* 51761*/   0, /*End of Scope*/
/* 51762*/  /*Scope*/ 44, /*->51807*/
/* 51763*/   OPC_RecordChild0, // #0 = $lhs
/* 51764*/   OPC_RecordChild1, // #1 = $rhs
/* 51765*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->51776
/* 51768*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 51776*/   /*SwitchType*/ 8, MVT::v8i16,// ->51786
/* 51778*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 51786*/   /*SwitchType*/ 8, MVT::v4i32,// ->51796
/* 51788*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 51796*/   /*SwitchType*/ 8, MVT::v2i64,// ->51806
/* 51798*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 51806*/   0, // EndSwitchType
/* 51807*/  0, /*End of Scope*/
/* 51808*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::XOR),// ->51924
/* 51811*/  OPC_RecordChild0, // #0 = $lhs
/* 51812*/  OPC_Scope, 23, /*->51837*/ // 3 children in Scope
/* 51814*/   OPC_RecordChild1, // #1 = $rhs
/* 51815*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->51826
/* 51818*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51826*/   /*SwitchType*/ 8, MVT::i64,// ->51836
/* 51828*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51836*/   0, // EndSwitchType
/* 51837*/  /*Scope*/ 41, /*->51879*/
/* 51838*/   OPC_MoveChild1,
/* 51839*/   OPC_CheckImmAllOnesV,
/* 51840*/   OPC_MoveParent,
/* 51841*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->51851
/* 51844*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
              // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 51851*/   /*SwitchType*/ 7, MVT::v8i16,// ->51860
/* 51853*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
              // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 51860*/   /*SwitchType*/ 7, MVT::v4i32,// ->51869
/* 51862*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
              // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 51869*/   /*SwitchType*/ 7, MVT::v2i64,// ->51878
/* 51871*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
              // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 51878*/   0, // EndSwitchType
/* 51879*/  /*Scope*/ 43, /*->51923*/
/* 51880*/   OPC_RecordChild1, // #1 = $rhs
/* 51881*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->51892
/* 51884*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 51892*/   /*SwitchType*/ 8, MVT::v8i16,// ->51902
/* 51894*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 51902*/   /*SwitchType*/ 8, MVT::v4i32,// ->51912
/* 51904*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 51912*/   /*SwitchType*/ 8, MVT::v2i64,// ->51922
/* 51914*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 51922*/   0, // EndSwitchType
/* 51923*/  0, /*End of Scope*/
/* 51924*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::CTLZ),// ->51952
/* 51927*/  OPC_RecordChild0, // #0 = $src
/* 51928*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->51940
/* 51931*/   OPC_CheckChild0Type, MVT::i32,
/* 51933*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 51940*/  /*SwitchType*/ 9, MVT::i64,// ->51951
/* 51942*/   OPC_CheckChild0Type, MVT::i64,
/* 51944*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 51951*/  0, // EndSwitchType
/* 51952*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::CTTZ),// ->51980
/* 51955*/  OPC_RecordChild0, // #0 = $src
/* 51956*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->51968
/* 51959*/   OPC_CheckChild0Type, MVT::i32,
/* 51961*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 51968*/  /*SwitchType*/ 9, MVT::i64,// ->51979
/* 51970*/   OPC_CheckChild0Type, MVT::i64,
/* 51972*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 51979*/  0, // EndSwitchType
/* 51980*/ /*SwitchOpcode*/ 38, TARGET_VAL(ISD::CTPOP),// ->52021
/* 51983*/  OPC_RecordChild0, // #0 = $src
/* 51984*/  OPC_SwitchType /*3 cases */, 9, MVT::i32,// ->51996
/* 51987*/   OPC_CheckChild0Type, MVT::i32,
/* 51989*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 51996*/  /*SwitchType*/ 9, MVT::i64,// ->52007
/* 51998*/   OPC_CheckChild0Type, MVT::i64,
/* 52000*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 52007*/  /*SwitchType*/ 11, MVT::v16i8,// ->52020
/* 52009*/   OPC_CheckChild0Type, MVT::v16i8,
/* 52011*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52013*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I8x16), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 52020*/  0, // EndSwitchType
/* 52021*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::TRUNCATE),// ->52032
/* 52024*/  OPC_RecordChild0, // #0 = $src
/* 52025*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 52032*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::SIGN_EXTEND),// ->52043
/* 52035*/  OPC_RecordChild0, // #0 = $src
/* 52036*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32), 0,
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 52043*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->52167
/* 52046*/  OPC_RecordChild0, // #0 = $src
/* 52047*/  OPC_Scope, 52, /*->52101*/ // 3 children in Scope
/* 52049*/   OPC_CheckChild0Type, MVT::f32,
/* 52051*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->52076
/* 52054*/    OPC_Scope, 9, /*->52065*/ // 2 children in Scope
/* 52056*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52058*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52065*/    /*Scope*/ 9, /*->52075*/
/* 52066*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52068*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52075*/    0, /*End of Scope*/
/* 52076*/   /*SwitchType*/ 22, MVT::i64,// ->52100
/* 52078*/    OPC_Scope, 9, /*->52089*/ // 2 children in Scope
/* 52080*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52082*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 52089*/    /*Scope*/ 9, /*->52099*/
/* 52090*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52092*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 52099*/    0, /*End of Scope*/
/* 52100*/   0, // EndSwitchType
/* 52101*/  /*Scope*/ 52, /*->52154*/
/* 52102*/   OPC_CheckChild0Type, MVT::f64,
/* 52104*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->52129
/* 52107*/    OPC_Scope, 9, /*->52118*/ // 2 children in Scope
/* 52109*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52111*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 52118*/    /*Scope*/ 9, /*->52128*/
/* 52119*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52121*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 52128*/    0, /*End of Scope*/
/* 52129*/   /*SwitchType*/ 22, MVT::i64,// ->52153
/* 52131*/    OPC_Scope, 9, /*->52142*/ // 2 children in Scope
/* 52133*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52135*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52142*/    /*Scope*/ 9, /*->52152*/
/* 52143*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52145*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52152*/    0, /*End of Scope*/
/* 52153*/   0, // EndSwitchType
/* 52154*/  /*Scope*/ 11, /*->52166*/
/* 52155*/   OPC_CheckType, MVT::v4i32,
/* 52157*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52159*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 52166*/  0, /*End of Scope*/
/* 52167*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->52291
/* 52170*/  OPC_RecordChild0, // #0 = $src
/* 52171*/  OPC_Scope, 52, /*->52225*/ // 3 children in Scope
/* 52173*/   OPC_CheckChild0Type, MVT::f32,
/* 52175*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->52200
/* 52178*/    OPC_Scope, 9, /*->52189*/ // 2 children in Scope
/* 52180*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52182*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52189*/    /*Scope*/ 9, /*->52199*/
/* 52190*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52192*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52199*/    0, /*End of Scope*/
/* 52200*/   /*SwitchType*/ 22, MVT::i64,// ->52224
/* 52202*/    OPC_Scope, 9, /*->52213*/ // 2 children in Scope
/* 52204*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52206*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 52213*/    /*Scope*/ 9, /*->52223*/
/* 52214*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52216*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 52223*/    0, /*End of Scope*/
/* 52224*/   0, // EndSwitchType
/* 52225*/  /*Scope*/ 52, /*->52278*/
/* 52226*/   OPC_CheckChild0Type, MVT::f64,
/* 52228*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->52253
/* 52231*/    OPC_Scope, 9, /*->52242*/ // 2 children in Scope
/* 52233*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52235*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 52242*/    /*Scope*/ 9, /*->52252*/
/* 52243*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52245*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 52252*/    0, /*End of Scope*/
/* 52253*/   /*SwitchType*/ 22, MVT::i64,// ->52277
/* 52255*/    OPC_Scope, 9, /*->52266*/ // 2 children in Scope
/* 52257*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasNontrappingFPToInt())
/* 52259*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52266*/    /*Scope*/ 9, /*->52276*/
/* 52267*/     OPC_CheckPatternPredicate, 16, // (!Subtarget->hasNontrappingFPToInt())
/* 52269*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52276*/    0, /*End of Scope*/
/* 52277*/   0, // EndSwitchType
/* 52278*/  /*Scope*/ 11, /*->52290*/
/* 52279*/   OPC_CheckType, MVT::v4i32,
/* 52281*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52283*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 52290*/  0, /*End of Scope*/
/* 52291*/ /*SwitchOpcode*/ 81, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->52375
/* 52294*/  OPC_RecordChild0, // #0 = $src
/* 52295*/  OPC_Scope, 31, /*->52328*/ // 3 children in Scope
/* 52297*/   OPC_CheckChild0Type, MVT::f32,
/* 52299*/   OPC_MoveChild1,
/* 52300*/   OPC_Scope, 12, /*->52314*/ // 2 children in Scope
/* 52302*/    OPC_CheckValueType, MVT::i32,
/* 52304*/    OPC_MoveParent,
/* 52305*/    OPC_CheckType, MVT::i32,
/* 52307*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52314*/   /*Scope*/ 12, /*->52327*/
/* 52315*/    OPC_CheckValueType, MVT::i64,
/* 52317*/    OPC_MoveParent,
/* 52318*/    OPC_CheckType, MVT::i64,
/* 52320*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 52327*/   0, /*End of Scope*/
/* 52328*/  /*Scope*/ 31, /*->52360*/
/* 52329*/   OPC_CheckChild0Type, MVT::f64,
/* 52331*/   OPC_MoveChild1,
/* 52332*/   OPC_Scope, 12, /*->52346*/ // 2 children in Scope
/* 52334*/    OPC_CheckValueType, MVT::i32,
/* 52336*/    OPC_MoveParent,
/* 52337*/    OPC_CheckType, MVT::i32,
/* 52339*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 52346*/   /*Scope*/ 12, /*->52359*/
/* 52347*/    OPC_CheckValueType, MVT::i64,
/* 52349*/    OPC_MoveParent,
/* 52350*/    OPC_CheckType, MVT::i64,
/* 52352*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52359*/   0, /*End of Scope*/
/* 52360*/  /*Scope*/ 13, /*->52374*/
/* 52361*/   OPC_MoveChild1,
/* 52362*/   OPC_CheckValueType, MVT::i32,
/* 52364*/   OPC_MoveParent,
/* 52365*/   OPC_CheckType, MVT::v4i32,
/* 52367*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 52374*/  0, /*End of Scope*/
/* 52375*/ /*SwitchOpcode*/ 81, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->52459
/* 52378*/  OPC_RecordChild0, // #0 = $src
/* 52379*/  OPC_Scope, 31, /*->52412*/ // 3 children in Scope
/* 52381*/   OPC_CheckChild0Type, MVT::f32,
/* 52383*/   OPC_MoveChild1,
/* 52384*/   OPC_Scope, 12, /*->52398*/ // 2 children in Scope
/* 52386*/    OPC_CheckValueType, MVT::i32,
/* 52388*/    OPC_MoveParent,
/* 52389*/    OPC_CheckType, MVT::i32,
/* 52391*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52398*/   /*Scope*/ 12, /*->52411*/
/* 52399*/    OPC_CheckValueType, MVT::i64,
/* 52401*/    OPC_MoveParent,
/* 52402*/    OPC_CheckType, MVT::i64,
/* 52404*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 52411*/   0, /*End of Scope*/
/* 52412*/  /*Scope*/ 31, /*->52444*/
/* 52413*/   OPC_CheckChild0Type, MVT::f64,
/* 52415*/   OPC_MoveChild1,
/* 52416*/   OPC_Scope, 12, /*->52430*/ // 2 children in Scope
/* 52418*/    OPC_CheckValueType, MVT::i32,
/* 52420*/    OPC_MoveParent,
/* 52421*/    OPC_CheckType, MVT::i32,
/* 52423*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 52430*/   /*Scope*/ 12, /*->52443*/
/* 52431*/    OPC_CheckValueType, MVT::i64,
/* 52433*/    OPC_MoveParent,
/* 52434*/    OPC_CheckType, MVT::i64,
/* 52436*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52443*/   0, /*End of Scope*/
/* 52444*/  /*Scope*/ 13, /*->52458*/
/* 52445*/   OPC_MoveChild1,
/* 52446*/   OPC_CheckValueType, MVT::i32,
/* 52448*/   OPC_MoveParent,
/* 52449*/   OPC_CheckType, MVT::v4i32,
/* 52451*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 52458*/  0, /*End of Scope*/
/* 52459*/ /*SwitchOpcode*/ 103|128,1/*231*/, TARGET_VAL(ISD::BITCAST),// ->52694
/* 52463*/  OPC_RecordChild0, // #0 = $src
/* 52464*/  OPC_Scope, 11, /*->52477*/ // 10 children in Scope
/* 52466*/   OPC_CheckChild0Type, MVT::f32,
/* 52468*/   OPC_CheckType, MVT::i32,
/* 52470*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 52477*/  /*Scope*/ 11, /*->52489*/
/* 52478*/   OPC_CheckChild0Type, MVT::f64,
/* 52480*/   OPC_CheckType, MVT::i64,
/* 52482*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 52489*/  /*Scope*/ 11, /*->52501*/
/* 52490*/   OPC_CheckChild0Type, MVT::i32,
/* 52492*/   OPC_CheckType, MVT::f32,
/* 52494*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 52501*/  /*Scope*/ 11, /*->52513*/
/* 52502*/   OPC_CheckChild0Type, MVT::i64,
/* 52504*/   OPC_CheckType, MVT::f64,
/* 52506*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 52513*/  /*Scope*/ 29, /*->52543*/
/* 52514*/   OPC_CheckChild0Type, MVT::v8i16,
/* 52516*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->52522
/* 52519*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 52522*/   /*SwitchType*/ 3, MVT::v4i32,// ->52527
/* 52524*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 52527*/   /*SwitchType*/ 3, MVT::v2i64,// ->52532
/* 52529*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 52532*/   /*SwitchType*/ 3, MVT::v4f32,// ->52537
/* 52534*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 52537*/   /*SwitchType*/ 3, MVT::v2f64,// ->52542
/* 52539*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 52542*/   0, // EndSwitchType
/* 52543*/  /*Scope*/ 29, /*->52573*/
/* 52544*/   OPC_CheckChild0Type, MVT::v4i32,
/* 52546*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->52552
/* 52549*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 52552*/   /*SwitchType*/ 3, MVT::v8i16,// ->52557
/* 52554*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 52557*/   /*SwitchType*/ 3, MVT::v2i64,// ->52562
/* 52559*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 52562*/   /*SwitchType*/ 3, MVT::v4f32,// ->52567
/* 52564*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 52567*/   /*SwitchType*/ 3, MVT::v2f64,// ->52572
/* 52569*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 52572*/   0, // EndSwitchType
/* 52573*/  /*Scope*/ 29, /*->52603*/
/* 52574*/   OPC_CheckChild0Type, MVT::v2i64,
/* 52576*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->52582
/* 52579*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 52582*/   /*SwitchType*/ 3, MVT::v8i16,// ->52587
/* 52584*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 52587*/   /*SwitchType*/ 3, MVT::v4i32,// ->52592
/* 52589*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 52592*/   /*SwitchType*/ 3, MVT::v4f32,// ->52597
/* 52594*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 52597*/   /*SwitchType*/ 3, MVT::v2f64,// ->52602
/* 52599*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 52602*/   0, // EndSwitchType
/* 52603*/  /*Scope*/ 29, /*->52633*/
/* 52604*/   OPC_CheckChild0Type, MVT::v4f32,
/* 52606*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->52612
/* 52609*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 52612*/   /*SwitchType*/ 3, MVT::v8i16,// ->52617
/* 52614*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 52617*/   /*SwitchType*/ 3, MVT::v4i32,// ->52622
/* 52619*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 52622*/   /*SwitchType*/ 3, MVT::v2i64,// ->52627
/* 52624*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 52627*/   /*SwitchType*/ 3, MVT::v2f64,// ->52632
/* 52629*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 52632*/   0, // EndSwitchType
/* 52633*/  /*Scope*/ 29, /*->52663*/
/* 52634*/   OPC_CheckChild0Type, MVT::v2f64,
/* 52636*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->52642
/* 52639*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 52642*/   /*SwitchType*/ 3, MVT::v8i16,// ->52647
/* 52644*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 52647*/   /*SwitchType*/ 3, MVT::v4i32,// ->52652
/* 52649*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 52652*/   /*SwitchType*/ 3, MVT::v2i64,// ->52657
/* 52654*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 52657*/   /*SwitchType*/ 3, MVT::v4f32,// ->52662
/* 52659*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 52662*/   0, // EndSwitchType
/* 52663*/  /*Scope*/ 29, /*->52693*/
/* 52664*/   OPC_CheckChild0Type, MVT::v16i8,
/* 52666*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->52672
/* 52669*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 52672*/   /*SwitchType*/ 3, MVT::v4i32,// ->52677
/* 52674*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 52677*/   /*SwitchType*/ 3, MVT::v2i64,// ->52682
/* 52679*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 52682*/   /*SwitchType*/ 3, MVT::v4f32,// ->52687
/* 52684*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 52687*/   /*SwitchType*/ 3, MVT::v2f64,// ->52692
/* 52689*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 52692*/   0, // EndSwitchType
/* 52693*/  0, /*End of Scope*/
/* 52694*/ /*SwitchOpcode*/ 39, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->52736
/* 52697*/  OPC_RecordMemRef,
/* 52698*/  OPC_RecordNode, // #0 = 'wasm_table_set' chained node
/* 52699*/  OPC_RecordChild1, // #1 = $table
/* 52700*/  OPC_CheckChild1Type, MVT::i32,
/* 52702*/  OPC_RecordChild2, // #2 = $idx
/* 52703*/  OPC_CheckChild2Type, MVT::i32,
/* 52705*/  OPC_RecordChild3, // #3 = $r
/* 52706*/  OPC_Scope, 13, /*->52721*/ // 2 children in Scope
/* 52708*/   OPC_CheckChild3Type, MVT::funcref,
/* 52710*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 52712*/   OPC_EmitMergeInputChains1_0,
/* 52713*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (wasm_table_set i32:{ *:[i32] }:$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 3
             // Dst: (TABLE_SET_FUNCREF i32:{ *:[i32] }:$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 52721*/  /*Scope*/ 13, /*->52735*/
/* 52722*/   OPC_CheckChild3Type, MVT::externref,
/* 52724*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasReferenceTypes())
/* 52726*/   OPC_EmitMergeInputChains1_0,
/* 52727*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (wasm_table_set i32:{ *:[i32] }:$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$r) - Complexity = 3
             // Dst: (TABLE_SET_EXTERNREF i32:{ *:[i32] }:$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$r)
/* 52735*/  0, /*End of Scope*/
/* 52736*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::ConstantFP),// ->52764
/* 52739*/  OPC_RecordNode, // #0 = $imm
/* 52740*/  OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->52752
/* 52743*/   OPC_EmitConvertToTarget, 0,
/* 52745*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 52752*/  /*SwitchType*/ 9, MVT::f64,// ->52763
/* 52754*/   OPC_EmitConvertToTarget, 0,
/* 52756*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 52763*/  0, // EndSwitchType
/* 52764*/ /*SwitchOpcode*/ 61, TARGET_VAL(ISD::SINT_TO_FP),// ->52828
/* 52767*/  OPC_RecordChild0, // #0 = $src
/* 52768*/  OPC_Scope, 22, /*->52792*/ // 3 children in Scope
/* 52770*/   OPC_CheckChild0Type, MVT::i32,
/* 52772*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->52782
/* 52775*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 52782*/   /*SwitchType*/ 7, MVT::f64,// ->52791
/* 52784*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 52791*/   0, // EndSwitchType
/* 52792*/  /*Scope*/ 22, /*->52815*/
/* 52793*/   OPC_CheckChild0Type, MVT::i64,
/* 52795*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->52805
/* 52798*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 52805*/   /*SwitchType*/ 7, MVT::f64,// ->52814
/* 52807*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 52814*/   0, // EndSwitchType
/* 52815*/  /*Scope*/ 11, /*->52827*/
/* 52816*/   OPC_CheckType, MVT::v4f32,
/* 52818*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52820*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::sint_to_fp_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 52827*/  0, /*End of Scope*/
/* 52828*/ /*SwitchOpcode*/ 61, TARGET_VAL(ISD::UINT_TO_FP),// ->52892
/* 52831*/  OPC_RecordChild0, // #0 = $src
/* 52832*/  OPC_Scope, 22, /*->52856*/ // 3 children in Scope
/* 52834*/   OPC_CheckChild0Type, MVT::i32,
/* 52836*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->52846
/* 52839*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 52846*/   /*SwitchType*/ 7, MVT::f64,// ->52855
/* 52848*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 52855*/   0, // EndSwitchType
/* 52856*/  /*Scope*/ 22, /*->52879*/
/* 52857*/   OPC_CheckChild0Type, MVT::i64,
/* 52859*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->52869
/* 52862*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 52869*/   /*SwitchType*/ 7, MVT::f64,// ->52878
/* 52871*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 52878*/   0, // EndSwitchType
/* 52879*/  /*Scope*/ 11, /*->52891*/
/* 52880*/   OPC_CheckType, MVT::v4f32,
/* 52882*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52884*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::uint_to_fp_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 52891*/  0, /*End of Scope*/
/* 52892*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_EXTEND),// ->52903
/* 52895*/  OPC_RecordChild0, // #0 = $src
/* 52896*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 52903*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_ROUND),// ->52914
/* 52906*/  OPC_RecordChild0, // #0 = $src
/* 52907*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 52914*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FADD),// ->52965
/* 52917*/  OPC_RecordChild0, // #0 = $lhs
/* 52918*/  OPC_RecordChild1, // #1 = $rhs
/* 52919*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->52930
/* 52922*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 52930*/  /*SwitchType*/ 8, MVT::f64,// ->52940
/* 52932*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52940*/  /*SwitchType*/ 10, MVT::v4f32,// ->52952
/* 52942*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52944*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52952*/  /*SwitchType*/ 10, MVT::v2f64,// ->52964
/* 52954*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52956*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52964*/  0, // EndSwitchType
/* 52965*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSUB),// ->53016
/* 52968*/  OPC_RecordChild0, // #0 = $lhs
/* 52969*/  OPC_RecordChild1, // #1 = $rhs
/* 52970*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->52981
/* 52973*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 52981*/  /*SwitchType*/ 8, MVT::f64,// ->52991
/* 52983*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52991*/  /*SwitchType*/ 10, MVT::v4f32,// ->53003
/* 52993*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 52995*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 53003*/  /*SwitchType*/ 10, MVT::v2f64,// ->53015
/* 53005*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53007*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 53015*/  0, // EndSwitchType
/* 53016*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMUL),// ->53067
/* 53019*/  OPC_RecordChild0, // #0 = $lhs
/* 53020*/  OPC_RecordChild1, // #1 = $rhs
/* 53021*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->53032
/* 53024*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 53032*/  /*SwitchType*/ 8, MVT::f64,// ->53042
/* 53034*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 53042*/  /*SwitchType*/ 10, MVT::v4f32,// ->53054
/* 53044*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53046*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 53054*/  /*SwitchType*/ 10, MVT::v2f64,// ->53066
/* 53056*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53058*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 53066*/  0, // EndSwitchType
/* 53067*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FDIV),// ->53118
/* 53070*/  OPC_RecordChild0, // #0 = $lhs
/* 53071*/  OPC_RecordChild1, // #1 = $rhs
/* 53072*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->53083
/* 53075*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 53083*/  /*SwitchType*/ 8, MVT::f64,// ->53093
/* 53085*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 53093*/  /*SwitchType*/ 10, MVT::v4f32,// ->53105
/* 53095*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53097*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 53105*/  /*SwitchType*/ 10, MVT::v2f64,// ->53117
/* 53107*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53109*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 53117*/  0, // EndSwitchType
/* 53118*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FSQRT),// ->53164
/* 53121*/  OPC_RecordChild0, // #0 = $src
/* 53122*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53132
/* 53125*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53132*/  /*SwitchType*/ 7, MVT::f64,// ->53141
/* 53134*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53141*/  /*SwitchType*/ 9, MVT::v4f32,// ->53152
/* 53143*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53145*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53152*/  /*SwitchType*/ 9, MVT::v2f64,// ->53163
/* 53154*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53156*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53163*/  0, // EndSwitchType
/* 53164*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FABS),// ->53210
/* 53167*/  OPC_RecordChild0, // #0 = $src
/* 53168*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53178
/* 53171*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53178*/  /*SwitchType*/ 7, MVT::f64,// ->53187
/* 53180*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53187*/  /*SwitchType*/ 9, MVT::v4f32,// ->53198
/* 53189*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53191*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53198*/  /*SwitchType*/ 9, MVT::v2f64,// ->53209
/* 53200*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53202*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53209*/  0, // EndSwitchType
/* 53210*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEG),// ->53256
/* 53213*/  OPC_RecordChild0, // #0 = $src
/* 53214*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53224
/* 53217*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53224*/  /*SwitchType*/ 7, MVT::f64,// ->53233
/* 53226*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53233*/  /*SwitchType*/ 9, MVT::v4f32,// ->53244
/* 53235*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53237*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53244*/  /*SwitchType*/ 9, MVT::v2f64,// ->53255
/* 53246*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53248*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53255*/  0, // EndSwitchType
/* 53256*/ /*SwitchOpcode*/ 68, TARGET_VAL(ISD::FCOPYSIGN),// ->53327
/* 53259*/  OPC_RecordChild0, // #0 = $lhs
/* 53260*/  OPC_RecordChild1, // #1 = $rhs
/* 53261*/  OPC_Scope, 31, /*->53294*/ // 2 children in Scope
/* 53263*/   OPC_CheckChild1Type, MVT::f32,
/* 53265*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->53276
/* 53268*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 53276*/   /*SwitchType*/ 15, MVT::f64,// ->53293
/* 53278*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 53285*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 53293*/   0, // EndSwitchType
/* 53294*/  /*Scope*/ 31, /*->53326*/
/* 53295*/   OPC_CheckChild1Type, MVT::f64,
/* 53297*/   OPC_SwitchType /*2 cases */, 8, MVT::f64,// ->53308
/* 53300*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 53308*/   /*SwitchType*/ 15, MVT::f32,// ->53325
/* 53310*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 53317*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 53325*/   0, // EndSwitchType
/* 53326*/  0, /*End of Scope*/
/* 53327*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMINIMUM),// ->53378
/* 53330*/  OPC_RecordChild0, // #0 = $lhs
/* 53331*/  OPC_RecordChild1, // #1 = $rhs
/* 53332*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->53343
/* 53335*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 53343*/  /*SwitchType*/ 8, MVT::f64,// ->53353
/* 53345*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 53353*/  /*SwitchType*/ 10, MVT::v4f32,// ->53365
/* 53355*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53357*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 53365*/  /*SwitchType*/ 10, MVT::v2f64,// ->53377
/* 53367*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53369*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 53377*/  0, // EndSwitchType
/* 53378*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMAXIMUM),// ->53429
/* 53381*/  OPC_RecordChild0, // #0 = $lhs
/* 53382*/  OPC_RecordChild1, // #1 = $rhs
/* 53383*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->53394
/* 53386*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 53394*/  /*SwitchType*/ 8, MVT::f64,// ->53404
/* 53396*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 53404*/  /*SwitchType*/ 10, MVT::v4f32,// ->53416
/* 53406*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53408*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 53416*/  /*SwitchType*/ 10, MVT::v2f64,// ->53428
/* 53418*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53420*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 53428*/  0, // EndSwitchType
/* 53429*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FCEIL),// ->53475
/* 53432*/  OPC_RecordChild0, // #0 = $src
/* 53433*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53443
/* 53436*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53443*/  /*SwitchType*/ 7, MVT::f64,// ->53452
/* 53445*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53452*/  /*SwitchType*/ 9, MVT::v4f32,// ->53463
/* 53454*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53456*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53463*/  /*SwitchType*/ 9, MVT::v2f64,// ->53474
/* 53465*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53467*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53474*/  0, // EndSwitchType
/* 53475*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FFLOOR),// ->53521
/* 53478*/  OPC_RecordChild0, // #0 = $src
/* 53479*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53489
/* 53482*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53489*/  /*SwitchType*/ 7, MVT::f64,// ->53498
/* 53491*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53498*/  /*SwitchType*/ 9, MVT::v4f32,// ->53509
/* 53500*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53502*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53509*/  /*SwitchType*/ 9, MVT::v2f64,// ->53520
/* 53511*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53513*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53520*/  0, // EndSwitchType
/* 53521*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FTRUNC),// ->53567
/* 53524*/  OPC_RecordChild0, // #0 = $src
/* 53525*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53535
/* 53528*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53535*/  /*SwitchType*/ 7, MVT::f64,// ->53544
/* 53537*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53544*/  /*SwitchType*/ 9, MVT::v4f32,// ->53555
/* 53546*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53548*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53555*/  /*SwitchType*/ 9, MVT::v2f64,// ->53566
/* 53557*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53559*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53566*/  0, // EndSwitchType
/* 53567*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEARBYINT),// ->53613
/* 53570*/  OPC_RecordChild0, // #0 = $src
/* 53571*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->53581
/* 53574*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 53581*/  /*SwitchType*/ 7, MVT::f64,// ->53590
/* 53583*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 53590*/  /*SwitchType*/ 9, MVT::v4f32,// ->53601
/* 53592*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53594*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 53601*/  /*SwitchType*/ 9, MVT::v2f64,// ->53612
/* 53603*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 53605*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 53612*/  0, // EndSwitchType
/* 53613*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FRINT),// ->53637
/* 53616*/  OPC_RecordChild0, // #0 = $src
/* 53617*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->53627
/* 53620*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 53627*/  /*SwitchType*/ 7, MVT::f64,// ->53636
/* 53629*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 53636*/  0, // EndSwitchType
/* 53637*/ /*SwitchOpcode*/ 55|128,3/*439*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->54080
/* 53641*/  OPC_Scope, 46|128,2/*302*/, /*->53946*/ // 2 children in Scope
/* 53644*/   OPC_MoveChild0,
/* 53645*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 53648*/   OPC_MoveChild0,
/* 53649*/   OPC_SwitchOpcode /*2 cases */, 11|128,1/*139*/, TARGET_VAL(ISD::ADD),// ->53793
/* 53654*/    OPC_RecordChild0, // #0 = $lhs
/* 53655*/    OPC_RecordChild1, // #1 = $rhs
/* 53656*/    OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53658*/    OPC_MoveParent,
/* 53659*/    OPC_MoveChild1,
/* 53660*/    OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 53663*/    OPC_CheckChild0Integer, 2, 
/* 53665*/    OPC_CheckChild0Type, MVT::i32,
/* 53667*/    OPC_CheckChild1Integer, 2, 
/* 53669*/    OPC_CheckChild1Type, MVT::i32,
/* 53671*/    OPC_CheckChild2Integer, 2, 
/* 53673*/    OPC_CheckChild2Type, MVT::i32,
/* 53675*/    OPC_CheckChild3Integer, 2, 
/* 53677*/    OPC_CheckChild3Type, MVT::i32,
/* 53679*/    OPC_CheckChild4Integer, 2, 
/* 53681*/    OPC_CheckChild4Type, MVT::i32,
/* 53683*/    OPC_MoveChild5,
/* 53684*/    OPC_CheckInteger, 2, 
/* 53686*/    OPC_CheckType, MVT::i32,
/* 53688*/    OPC_MoveParent,
/* 53689*/    OPC_MoveChild6,
/* 53690*/    OPC_CheckInteger, 2, 
/* 53692*/    OPC_CheckType, MVT::i32,
/* 53694*/    OPC_MoveParent,
/* 53695*/    OPC_MoveChild7,
/* 53696*/    OPC_CheckInteger, 2, 
/* 53698*/    OPC_CheckType, MVT::i32,
/* 53700*/    OPC_MoveParent,
/* 53701*/    OPC_Scope, 72, /*->53775*/ // 2 children in Scope
/* 53703*/     OPC_MoveChild, 8,
/* 53705*/     OPC_CheckInteger, 2, 
/* 53707*/     OPC_CheckType, MVT::i32,
/* 53709*/     OPC_MoveParent,
/* 53710*/     OPC_MoveChild, 9,
/* 53712*/     OPC_CheckInteger, 2, 
/* 53714*/     OPC_CheckType, MVT::i32,
/* 53716*/     OPC_MoveParent,
/* 53717*/     OPC_MoveChild, 10,
/* 53719*/     OPC_CheckInteger, 2, 
/* 53721*/     OPC_CheckType, MVT::i32,
/* 53723*/     OPC_MoveParent,
/* 53724*/     OPC_MoveChild, 11,
/* 53726*/     OPC_CheckInteger, 2, 
/* 53728*/     OPC_CheckType, MVT::i32,
/* 53730*/     OPC_MoveParent,
/* 53731*/     OPC_MoveChild, 12,
/* 53733*/     OPC_CheckInteger, 2, 
/* 53735*/     OPC_CheckType, MVT::i32,
/* 53737*/     OPC_MoveParent,
/* 53738*/     OPC_MoveChild, 13,
/* 53740*/     OPC_CheckInteger, 2, 
/* 53742*/     OPC_CheckType, MVT::i32,
/* 53744*/     OPC_MoveParent,
/* 53745*/     OPC_MoveChild, 14,
/* 53747*/     OPC_CheckInteger, 2, 
/* 53749*/     OPC_CheckType, MVT::i32,
/* 53751*/     OPC_MoveParent,
/* 53752*/     OPC_MoveChild, 15,
/* 53754*/     OPC_CheckInteger, 2, 
/* 53756*/     OPC_CheckType, MVT::i32,
/* 53758*/     OPC_MoveParent,
/* 53759*/     OPC_MoveParent,
/* 53760*/     OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53762*/     OPC_MoveParent,
/* 53763*/     OPC_CheckChild1Integer, 2, 
/* 53765*/     OPC_CheckType, MVT::v16i8,
/* 53767*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (build_vector:{ *:[v16i8] } 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 99
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 53775*/    /*Scope*/ 16, /*->53792*/
/* 53776*/     OPC_MoveParent,
/* 53777*/     OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53779*/     OPC_MoveParent,
/* 53780*/     OPC_CheckChild1Integer, 2, 
/* 53782*/     OPC_CheckType, MVT::v8i16,
/* 53784*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (build_vector:{ *:[v8i16] } 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 59
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 53792*/    0, /*End of Scope*/
/* 53793*/   /*SwitchOpcode*/ 20|128,1/*148*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->53945
/* 53797*/    OPC_CheckChild0Integer, 2, 
/* 53799*/    OPC_CheckChild0Type, MVT::i32,
/* 53801*/    OPC_CheckChild1Integer, 2, 
/* 53803*/    OPC_CheckChild1Type, MVT::i32,
/* 53805*/    OPC_CheckChild2Integer, 2, 
/* 53807*/    OPC_CheckChild2Type, MVT::i32,
/* 53809*/    OPC_CheckChild3Integer, 2, 
/* 53811*/    OPC_CheckChild3Type, MVT::i32,
/* 53813*/    OPC_CheckChild4Integer, 2, 
/* 53815*/    OPC_CheckChild4Type, MVT::i32,
/* 53817*/    OPC_MoveChild5,
/* 53818*/    OPC_CheckInteger, 2, 
/* 53820*/    OPC_CheckType, MVT::i32,
/* 53822*/    OPC_MoveParent,
/* 53823*/    OPC_MoveChild6,
/* 53824*/    OPC_CheckInteger, 2, 
/* 53826*/    OPC_CheckType, MVT::i32,
/* 53828*/    OPC_MoveParent,
/* 53829*/    OPC_MoveChild7,
/* 53830*/    OPC_CheckInteger, 2, 
/* 53832*/    OPC_CheckType, MVT::i32,
/* 53834*/    OPC_MoveParent,
/* 53835*/    OPC_Scope, 81, /*->53918*/ // 2 children in Scope
/* 53837*/     OPC_MoveChild, 8,
/* 53839*/     OPC_CheckInteger, 2, 
/* 53841*/     OPC_CheckType, MVT::i32,
/* 53843*/     OPC_MoveParent,
/* 53844*/     OPC_MoveChild, 9,
/* 53846*/     OPC_CheckInteger, 2, 
/* 53848*/     OPC_CheckType, MVT::i32,
/* 53850*/     OPC_MoveParent,
/* 53851*/     OPC_MoveChild, 10,
/* 53853*/     OPC_CheckInteger, 2, 
/* 53855*/     OPC_CheckType, MVT::i32,
/* 53857*/     OPC_MoveParent,
/* 53858*/     OPC_MoveChild, 11,
/* 53860*/     OPC_CheckInteger, 2, 
/* 53862*/     OPC_CheckType, MVT::i32,
/* 53864*/     OPC_MoveParent,
/* 53865*/     OPC_MoveChild, 12,
/* 53867*/     OPC_CheckInteger, 2, 
/* 53869*/     OPC_CheckType, MVT::i32,
/* 53871*/     OPC_MoveParent,
/* 53872*/     OPC_MoveChild, 13,
/* 53874*/     OPC_CheckInteger, 2, 
/* 53876*/     OPC_CheckType, MVT::i32,
/* 53878*/     OPC_MoveParent,
/* 53879*/     OPC_MoveChild, 14,
/* 53881*/     OPC_CheckInteger, 2, 
/* 53883*/     OPC_CheckType, MVT::i32,
/* 53885*/     OPC_MoveParent,
/* 53886*/     OPC_MoveChild, 15,
/* 53888*/     OPC_CheckInteger, 2, 
/* 53890*/     OPC_CheckType, MVT::i32,
/* 53892*/     OPC_MoveParent,
/* 53893*/     OPC_MoveParent,
/* 53894*/     OPC_MoveChild1,
/* 53895*/     OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 53898*/     OPC_RecordChild0, // #0 = $lhs
/* 53899*/     OPC_RecordChild1, // #1 = $rhs
/* 53900*/     OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53902*/     OPC_MoveParent,
/* 53903*/     OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53905*/     OPC_MoveParent,
/* 53906*/     OPC_CheckChild1Integer, 2, 
/* 53908*/     OPC_CheckType, MVT::v16i8,
/* 53910*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (build_vector:{ *:[v16i8] } 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 99
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 53918*/    /*Scope*/ 25, /*->53944*/
/* 53919*/     OPC_MoveParent,
/* 53920*/     OPC_MoveChild1,
/* 53921*/     OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 53924*/     OPC_RecordChild0, // #0 = $lhs
/* 53925*/     OPC_RecordChild1, // #1 = $rhs
/* 53926*/     OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53928*/     OPC_MoveParent,
/* 53929*/     OPC_CheckPredicate, 27, // Predicate_add_nuw
/* 53931*/     OPC_MoveParent,
/* 53932*/     OPC_CheckChild1Integer, 2, 
/* 53934*/     OPC_CheckType, MVT::v8i16,
/* 53936*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (build_vector:{ *:[v8i16] } 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 59
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 53944*/    0, /*End of Scope*/
/* 53945*/   0, // EndSwitchOpcode
/* 53946*/  /*Scope*/ 3|128,1/*131*/, /*->54079*/
/* 53948*/   OPC_RecordChild0, // #0 = $lhs
/* 53949*/   OPC_Scope, 75, /*->54026*/ // 2 children in Scope
/* 53951*/    OPC_MoveChild1,
/* 53952*/    OPC_Scope, 26, /*->53980*/ // 4 children in Scope
/* 53954*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 53957*/     OPC_MoveChild0,
/* 53958*/     OPC_CheckAndImm, 63, 
/* 53960*/     OPC_RecordChild0, // #1 = $rhs
/* 53961*/     OPC_MoveParent,
/* 53962*/     OPC_MoveParent,
/* 53963*/     OPC_CheckType, MVT::v2i64,
/* 53965*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 53972*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 53980*/    /*Scope*/ 14, /*->53995*/
/* 53981*/     OPC_CheckAndImm, 7, 
/* 53983*/     OPC_RecordChild0, // #1 = $rhs
/* 53984*/     OPC_MoveParent,
/* 53985*/     OPC_CheckType, MVT::v16i8,
/* 53987*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 53995*/    /*Scope*/ 14, /*->54010*/
/* 53996*/     OPC_CheckAndImm, 15, 
/* 53998*/     OPC_RecordChild0, // #1 = $rhs
/* 53999*/     OPC_MoveParent,
/* 54000*/     OPC_CheckType, MVT::v8i16,
/* 54002*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54010*/    /*Scope*/ 14, /*->54025*/
/* 54011*/     OPC_CheckAndImm, 31, 
/* 54013*/     OPC_RecordChild0, // #1 = $rhs
/* 54014*/     OPC_MoveParent,
/* 54015*/     OPC_CheckType, MVT::v4i32,
/* 54017*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54025*/    0, /*End of Scope*/
/* 54026*/   /*Scope*/ 51, /*->54078*/
/* 54027*/    OPC_RecordChild1, // #1 = $x
/* 54028*/    OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->54041
/* 54031*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54033*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 54041*/    /*SwitchType*/ 10, MVT::v8i16,// ->54053
/* 54043*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54045*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 54053*/    /*SwitchType*/ 10, MVT::v4i32,// ->54065
/* 54055*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54057*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 54065*/    /*SwitchType*/ 10, MVT::v2i64,// ->54077
/* 54067*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54069*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 54077*/    0, // EndSwitchType
/* 54078*/   0, /*End of Scope*/
/* 54079*/  0, /*End of Scope*/
/* 54080*/ /*SwitchOpcode*/ 21|128,5/*661*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->54745
/* 54084*/  OPC_RecordChild0, // #0 = $i0
/* 54085*/  OPC_Scope, 31|128,3/*415*/, /*->54503*/ // 6 children in Scope
/* 54088*/   OPC_MoveChild0,
/* 54089*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54092*/   OPC_SwitchType /*2 cases */, 123|128,2/*379*/, MVT::i32,// ->54475
/* 54096*/    OPC_Scope, 91|128,1/*219*/, /*->54318*/ // 3 children in Scope
/* 54099*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54101*/     OPC_MoveParent,
/* 54102*/     OPC_RecordChild1, // #1 = $i1
/* 54103*/     OPC_MoveChild1,
/* 54104*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54107*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54109*/     OPC_CheckType, MVT::i32,
/* 54111*/     OPC_MoveParent,
/* 54112*/     OPC_RecordChild2, // #2 = $i2
/* 54113*/     OPC_MoveChild2,
/* 54114*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54117*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54119*/     OPC_CheckType, MVT::i32,
/* 54121*/     OPC_MoveParent,
/* 54122*/     OPC_RecordChild3, // #3 = $i3
/* 54123*/     OPC_MoveChild3,
/* 54124*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54127*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54129*/     OPC_CheckType, MVT::i32,
/* 54131*/     OPC_MoveParent,
/* 54132*/     OPC_RecordChild4, // #4 = $i4
/* 54133*/     OPC_MoveChild4,
/* 54134*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54137*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54139*/     OPC_CheckType, MVT::i32,
/* 54141*/     OPC_MoveParent,
/* 54142*/     OPC_RecordChild5, // #5 = $i5
/* 54143*/     OPC_MoveChild5,
/* 54144*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54147*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54149*/     OPC_CheckType, MVT::i32,
/* 54151*/     OPC_MoveParent,
/* 54152*/     OPC_RecordChild6, // #6 = $i6
/* 54153*/     OPC_MoveChild6,
/* 54154*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54157*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54159*/     OPC_CheckType, MVT::i32,
/* 54161*/     OPC_MoveParent,
/* 54162*/     OPC_RecordChild7, // #7 = $i7
/* 54163*/     OPC_MoveChild7,
/* 54164*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54167*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54169*/     OPC_CheckType, MVT::i32,
/* 54171*/     OPC_MoveParent,
/* 54172*/     OPC_MoveChild, 8,
/* 54174*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54177*/     OPC_RecordNode, // #8 = $i8
/* 54178*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54180*/     OPC_CheckType, MVT::i32,
/* 54182*/     OPC_MoveParent,
/* 54183*/     OPC_MoveChild, 9,
/* 54185*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54188*/     OPC_RecordNode, // #9 = $i9
/* 54189*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54191*/     OPC_CheckType, MVT::i32,
/* 54193*/     OPC_MoveParent,
/* 54194*/     OPC_MoveChild, 10,
/* 54196*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54199*/     OPC_RecordNode, // #10 = $iA
/* 54200*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54202*/     OPC_CheckType, MVT::i32,
/* 54204*/     OPC_MoveParent,
/* 54205*/     OPC_MoveChild, 11,
/* 54207*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54210*/     OPC_RecordNode, // #11 = $iB
/* 54211*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54213*/     OPC_CheckType, MVT::i32,
/* 54215*/     OPC_MoveParent,
/* 54216*/     OPC_MoveChild, 12,
/* 54218*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54221*/     OPC_RecordNode, // #12 = $iC
/* 54222*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54224*/     OPC_CheckType, MVT::i32,
/* 54226*/     OPC_MoveParent,
/* 54227*/     OPC_MoveChild, 13,
/* 54229*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54232*/     OPC_RecordNode, // #13 = $iD
/* 54233*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54235*/     OPC_CheckType, MVT::i32,
/* 54237*/     OPC_MoveParent,
/* 54238*/     OPC_MoveChild, 14,
/* 54240*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54243*/     OPC_RecordNode, // #14 = $iE
/* 54244*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54246*/     OPC_CheckType, MVT::i32,
/* 54248*/     OPC_MoveParent,
/* 54249*/     OPC_MoveChild, 15,
/* 54251*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54254*/     OPC_RecordNode, // #15 = $iF
/* 54255*/     OPC_CheckPredicate, 28, // Predicate_ImmI8
/* 54257*/     OPC_CheckType, MVT::i32,
/* 54259*/     OPC_MoveParent,
/* 54260*/     OPC_CheckType, MVT::v16i8,
/* 54262*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54264*/     OPC_EmitConvertToTarget, 0,
/* 54266*/     OPC_EmitConvertToTarget, 1,
/* 54268*/     OPC_EmitConvertToTarget, 2,
/* 54270*/     OPC_EmitConvertToTarget, 3,
/* 54272*/     OPC_EmitConvertToTarget, 4,
/* 54274*/     OPC_EmitConvertToTarget, 5,
/* 54276*/     OPC_EmitConvertToTarget, 6,
/* 54278*/     OPC_EmitConvertToTarget, 7,
/* 54280*/     OPC_EmitConvertToTarget, 8,
/* 54282*/     OPC_EmitConvertToTarget, 9,
/* 54284*/     OPC_EmitConvertToTarget, 10,
/* 54286*/     OPC_EmitConvertToTarget, 11,
/* 54288*/     OPC_EmitConvertToTarget, 12,
/* 54290*/     OPC_EmitConvertToTarget, 13,
/* 54292*/     OPC_EmitConvertToTarget, 14,
/* 54294*/     OPC_EmitConvertToTarget, 15,
/* 54296*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I8x16), 0,
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 54318*/    /*Scope*/ 107, /*->54426*/
/* 54319*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54321*/     OPC_MoveParent,
/* 54322*/     OPC_RecordChild1, // #1 = $i1
/* 54323*/     OPC_MoveChild1,
/* 54324*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54327*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54329*/     OPC_CheckType, MVT::i32,
/* 54331*/     OPC_MoveParent,
/* 54332*/     OPC_RecordChild2, // #2 = $i2
/* 54333*/     OPC_MoveChild2,
/* 54334*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54337*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54339*/     OPC_CheckType, MVT::i32,
/* 54341*/     OPC_MoveParent,
/* 54342*/     OPC_RecordChild3, // #3 = $i3
/* 54343*/     OPC_MoveChild3,
/* 54344*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54347*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54349*/     OPC_CheckType, MVT::i32,
/* 54351*/     OPC_MoveParent,
/* 54352*/     OPC_RecordChild4, // #4 = $i4
/* 54353*/     OPC_MoveChild4,
/* 54354*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54357*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54359*/     OPC_CheckType, MVT::i32,
/* 54361*/     OPC_MoveParent,
/* 54362*/     OPC_RecordChild5, // #5 = $i5
/* 54363*/     OPC_MoveChild5,
/* 54364*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54367*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54369*/     OPC_CheckType, MVT::i32,
/* 54371*/     OPC_MoveParent,
/* 54372*/     OPC_RecordChild6, // #6 = $i6
/* 54373*/     OPC_MoveChild6,
/* 54374*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54377*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54379*/     OPC_CheckType, MVT::i32,
/* 54381*/     OPC_MoveParent,
/* 54382*/     OPC_RecordChild7, // #7 = $i7
/* 54383*/     OPC_MoveChild7,
/* 54384*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54387*/     OPC_CheckPredicate, 29, // Predicate_ImmI16
/* 54389*/     OPC_CheckType, MVT::i32,
/* 54391*/     OPC_MoveParent,
/* 54392*/     OPC_CheckType, MVT::v8i16,
/* 54394*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54396*/     OPC_EmitConvertToTarget, 0,
/* 54398*/     OPC_EmitConvertToTarget, 1,
/* 54400*/     OPC_EmitConvertToTarget, 2,
/* 54402*/     OPC_EmitConvertToTarget, 3,
/* 54404*/     OPC_EmitConvertToTarget, 4,
/* 54406*/     OPC_EmitConvertToTarget, 5,
/* 54408*/     OPC_EmitConvertToTarget, 6,
/* 54410*/     OPC_EmitConvertToTarget, 7,
/* 54412*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 54426*/    /*Scope*/ 47, /*->54474*/
/* 54427*/     OPC_MoveParent,
/* 54428*/     OPC_RecordChild1, // #1 = $i1
/* 54429*/     OPC_MoveChild1,
/* 54430*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54433*/     OPC_CheckType, MVT::i32,
/* 54435*/     OPC_MoveParent,
/* 54436*/     OPC_RecordChild2, // #2 = $i2
/* 54437*/     OPC_MoveChild2,
/* 54438*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54441*/     OPC_CheckType, MVT::i32,
/* 54443*/     OPC_MoveParent,
/* 54444*/     OPC_RecordChild3, // #3 = $i3
/* 54445*/     OPC_MoveChild3,
/* 54446*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54449*/     OPC_CheckType, MVT::i32,
/* 54451*/     OPC_MoveParent,
/* 54452*/     OPC_CheckType, MVT::v4i32,
/* 54454*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54456*/     OPC_EmitConvertToTarget, 0,
/* 54458*/     OPC_EmitConvertToTarget, 1,
/* 54460*/     OPC_EmitConvertToTarget, 2,
/* 54462*/     OPC_EmitConvertToTarget, 3,
/* 54464*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 54474*/    0, /*End of Scope*/
/* 54475*/   /*SwitchType*/ 25, MVT::i64,// ->54502
/* 54477*/    OPC_MoveParent,
/* 54478*/    OPC_RecordChild1, // #1 = $i1
/* 54479*/    OPC_MoveChild1,
/* 54480*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54483*/    OPC_CheckType, MVT::i64,
/* 54485*/    OPC_MoveParent,
/* 54486*/    OPC_CheckType, MVT::v2i64,
/* 54488*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54490*/    OPC_EmitConvertToTarget, 0,
/* 54492*/    OPC_EmitConvertToTarget, 1,
/* 54494*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 54502*/   0, // EndSwitchType
/* 54503*/  /*Scope*/ 105, /*->54609*/
/* 54504*/   OPC_CheckChild0Type, MVT::i32,
/* 54506*/   OPC_CheckChild1Same, 0,
/* 54508*/   OPC_CheckChild2Same, 0,
/* 54510*/   OPC_CheckChild3Same, 0,
/* 54512*/   OPC_Scope, 82, /*->54596*/ // 2 children in Scope
/* 54514*/    OPC_MoveChild4,
/* 54515*/    OPC_CheckSame, 0,
/* 54517*/    OPC_MoveParent,
/* 54518*/    OPC_MoveChild5,
/* 54519*/    OPC_CheckSame, 0,
/* 54521*/    OPC_MoveParent,
/* 54522*/    OPC_MoveChild6,
/* 54523*/    OPC_CheckSame, 0,
/* 54525*/    OPC_MoveParent,
/* 54526*/    OPC_MoveChild7,
/* 54527*/    OPC_CheckSame, 0,
/* 54529*/    OPC_MoveParent,
/* 54530*/    OPC_Scope, 51, /*->54583*/ // 2 children in Scope
/* 54532*/     OPC_MoveChild, 8,
/* 54534*/     OPC_CheckSame, 0,
/* 54536*/     OPC_MoveParent,
/* 54537*/     OPC_MoveChild, 9,
/* 54539*/     OPC_CheckSame, 0,
/* 54541*/     OPC_MoveParent,
/* 54542*/     OPC_MoveChild, 10,
/* 54544*/     OPC_CheckSame, 0,
/* 54546*/     OPC_MoveParent,
/* 54547*/     OPC_MoveChild, 11,
/* 54549*/     OPC_CheckSame, 0,
/* 54551*/     OPC_MoveParent,
/* 54552*/     OPC_MoveChild, 12,
/* 54554*/     OPC_CheckSame, 0,
/* 54556*/     OPC_MoveParent,
/* 54557*/     OPC_MoveChild, 13,
/* 54559*/     OPC_CheckSame, 0,
/* 54561*/     OPC_MoveParent,
/* 54562*/     OPC_MoveChild, 14,
/* 54564*/     OPC_CheckSame, 0,
/* 54566*/     OPC_MoveParent,
/* 54567*/     OPC_MoveChild, 15,
/* 54569*/     OPC_CheckSame, 0,
/* 54571*/     OPC_MoveParent,
/* 54572*/     OPC_CheckType, MVT::v16i8,
/* 54574*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54576*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I8x16), 0,
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (build_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 54583*/    /*Scope*/ 11, /*->54595*/
/* 54584*/     OPC_CheckType, MVT::v8i16,
/* 54586*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54588*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I16x8), 0,
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (build_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 54595*/    0, /*End of Scope*/
/* 54596*/   /*Scope*/ 11, /*->54608*/
/* 54597*/    OPC_CheckType, MVT::v4i32,
/* 54599*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54601*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (build_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 54608*/   0, /*End of Scope*/
/* 54609*/  /*Scope*/ 15, /*->54625*/
/* 54610*/   OPC_CheckChild0Type, MVT::i64,
/* 54612*/   OPC_CheckChild1Same, 0,
/* 54614*/   OPC_CheckType, MVT::v2i64,
/* 54616*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54618*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (build_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$x) - Complexity = 3
             // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 54625*/  /*Scope*/ 82, /*->54708*/
/* 54626*/   OPC_MoveChild0,
/* 54627*/   OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 54630*/   OPC_SwitchType /*2 cases */, 47, MVT::f32,// ->54680
/* 54633*/    OPC_MoveParent,
/* 54634*/    OPC_RecordChild1, // #1 = $i1
/* 54635*/    OPC_MoveChild1,
/* 54636*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 54639*/    OPC_CheckType, MVT::f32,
/* 54641*/    OPC_MoveParent,
/* 54642*/    OPC_RecordChild2, // #2 = $i2
/* 54643*/    OPC_MoveChild2,
/* 54644*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 54647*/    OPC_CheckType, MVT::f32,
/* 54649*/    OPC_MoveParent,
/* 54650*/    OPC_RecordChild3, // #3 = $i3
/* 54651*/    OPC_MoveChild3,
/* 54652*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 54655*/    OPC_CheckType, MVT::f32,
/* 54657*/    OPC_MoveParent,
/* 54658*/    OPC_CheckType, MVT::v4f32,
/* 54660*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54662*/    OPC_EmitConvertToTarget, 0,
/* 54664*/    OPC_EmitConvertToTarget, 1,
/* 54666*/    OPC_EmitConvertToTarget, 2,
/* 54668*/    OPC_EmitConvertToTarget, 3,
/* 54670*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F32x4), 0,
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 54680*/   /*SwitchType*/ 25, MVT::f64,// ->54707
/* 54682*/    OPC_MoveParent,
/* 54683*/    OPC_RecordChild1, // #1 = $i1
/* 54684*/    OPC_MoveChild1,
/* 54685*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 54688*/    OPC_CheckType, MVT::f64,
/* 54690*/    OPC_MoveParent,
/* 54691*/    OPC_CheckType, MVT::v2f64,
/* 54693*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54695*/    OPC_EmitConvertToTarget, 0,
/* 54697*/    OPC_EmitConvertToTarget, 1,
/* 54699*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 54707*/   0, // EndSwitchType
/* 54708*/  /*Scope*/ 19, /*->54728*/
/* 54709*/   OPC_CheckChild0Type, MVT::f32,
/* 54711*/   OPC_CheckChild1Same, 0,
/* 54713*/   OPC_CheckChild2Same, 0,
/* 54715*/   OPC_CheckChild3Same, 0,
/* 54717*/   OPC_CheckType, MVT::v4f32,
/* 54719*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54721*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (build_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x, F32:{ *:[f32] }:$x, F32:{ *:[f32] }:$x, F32:{ *:[f32] }:$x) - Complexity = 3
             // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 54728*/  /*Scope*/ 15, /*->54744*/
/* 54729*/   OPC_CheckChild0Type, MVT::f64,
/* 54731*/   OPC_CheckChild1Same, 0,
/* 54733*/   OPC_CheckType, MVT::v2f64,
/* 54735*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 54737*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (build_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x, F64:{ *:[f64] }:$x) - Complexity = 3
             // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 54744*/  0, /*End of Scope*/
/* 54745*/ /*SwitchOpcode*/ 5|128,11/*1413*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->56162
/* 54749*/  OPC_RecordChild0, // #0 = $x
/* 54750*/  OPC_Scope, 105|128,1/*233*/, /*->54986*/ // 6 children in Scope
/* 54753*/   OPC_CheckChild0Type, MVT::v16i8,
/* 54755*/   OPC_RecordChild1, // #1 = $y
/* 54756*/   OPC_CheckChild1Type, MVT::v16i8,
/* 54758*/   OPC_RecordChild2, // #2 = $m0
/* 54759*/   OPC_MoveChild2,
/* 54760*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54763*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54765*/   OPC_CheckType, MVT::i32,
/* 54767*/   OPC_MoveParent,
/* 54768*/   OPC_RecordChild3, // #3 = $m1
/* 54769*/   OPC_MoveChild3,
/* 54770*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54773*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54775*/   OPC_CheckType, MVT::i32,
/* 54777*/   OPC_MoveParent,
/* 54778*/   OPC_RecordChild4, // #4 = $m2
/* 54779*/   OPC_MoveChild4,
/* 54780*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54783*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54785*/   OPC_CheckType, MVT::i32,
/* 54787*/   OPC_MoveParent,
/* 54788*/   OPC_RecordChild5, // #5 = $m3
/* 54789*/   OPC_MoveChild5,
/* 54790*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54793*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54795*/   OPC_CheckType, MVT::i32,
/* 54797*/   OPC_MoveParent,
/* 54798*/   OPC_RecordChild6, // #6 = $m4
/* 54799*/   OPC_MoveChild6,
/* 54800*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54803*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54805*/   OPC_CheckType, MVT::i32,
/* 54807*/   OPC_MoveParent,
/* 54808*/   OPC_RecordChild7, // #7 = $m5
/* 54809*/   OPC_MoveChild7,
/* 54810*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54813*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54815*/   OPC_CheckType, MVT::i32,
/* 54817*/   OPC_MoveParent,
/* 54818*/   OPC_MoveChild, 8,
/* 54820*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54823*/   OPC_RecordNode, // #8 = $m6
/* 54824*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54826*/   OPC_CheckType, MVT::i32,
/* 54828*/   OPC_MoveParent,
/* 54829*/   OPC_MoveChild, 9,
/* 54831*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54834*/   OPC_RecordNode, // #9 = $m7
/* 54835*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54837*/   OPC_CheckType, MVT::i32,
/* 54839*/   OPC_MoveParent,
/* 54840*/   OPC_MoveChild, 10,
/* 54842*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54845*/   OPC_RecordNode, // #10 = $m8
/* 54846*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54848*/   OPC_CheckType, MVT::i32,
/* 54850*/   OPC_MoveParent,
/* 54851*/   OPC_MoveChild, 11,
/* 54853*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54856*/   OPC_RecordNode, // #11 = $m9
/* 54857*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54859*/   OPC_CheckType, MVT::i32,
/* 54861*/   OPC_MoveParent,
/* 54862*/   OPC_MoveChild, 12,
/* 54864*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54867*/   OPC_RecordNode, // #12 = $mA
/* 54868*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54870*/   OPC_CheckType, MVT::i32,
/* 54872*/   OPC_MoveParent,
/* 54873*/   OPC_MoveChild, 13,
/* 54875*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54878*/   OPC_RecordNode, // #13 = $mB
/* 54879*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54881*/   OPC_CheckType, MVT::i32,
/* 54883*/   OPC_MoveParent,
/* 54884*/   OPC_MoveChild, 14,
/* 54886*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54889*/   OPC_RecordNode, // #14 = $mC
/* 54890*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54892*/   OPC_CheckType, MVT::i32,
/* 54894*/   OPC_MoveParent,
/* 54895*/   OPC_MoveChild, 15,
/* 54897*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54900*/   OPC_RecordNode, // #15 = $mD
/* 54901*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54903*/   OPC_CheckType, MVT::i32,
/* 54905*/   OPC_MoveParent,
/* 54906*/   OPC_MoveChild, 16,
/* 54908*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54911*/   OPC_RecordNode, // #16 = $mE
/* 54912*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54914*/   OPC_CheckType, MVT::i32,
/* 54916*/   OPC_MoveParent,
/* 54917*/   OPC_MoveChild, 17,
/* 54919*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54922*/   OPC_RecordNode, // #17 = $mF
/* 54923*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 54925*/   OPC_CheckType, MVT::i32,
/* 54927*/   OPC_MoveParent,
/* 54928*/   OPC_CheckType, MVT::v16i8,
/* 54930*/   OPC_EmitConvertToTarget, 2,
/* 54932*/   OPC_EmitConvertToTarget, 3,
/* 54934*/   OPC_EmitConvertToTarget, 4,
/* 54936*/   OPC_EmitConvertToTarget, 5,
/* 54938*/   OPC_EmitConvertToTarget, 6,
/* 54940*/   OPC_EmitConvertToTarget, 7,
/* 54942*/   OPC_EmitConvertToTarget, 8,
/* 54944*/   OPC_EmitConvertToTarget, 9,
/* 54946*/   OPC_EmitConvertToTarget, 10,
/* 54948*/   OPC_EmitConvertToTarget, 11,
/* 54950*/   OPC_EmitConvertToTarget, 12,
/* 54952*/   OPC_EmitConvertToTarget, 13,
/* 54954*/   OPC_EmitConvertToTarget, 14,
/* 54956*/   OPC_EmitConvertToTarget, 15,
/* 54958*/   OPC_EmitConvertToTarget, 16,
/* 54960*/   OPC_EmitConvertToTarget, 17,
/* 54962*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 54986*/  /*Scope*/ 105|128,1/*233*/, /*->55221*/
/* 54988*/   OPC_CheckChild0Type, MVT::v8i16,
/* 54990*/   OPC_RecordChild1, // #1 = $y
/* 54991*/   OPC_CheckChild1Type, MVT::v8i16,
/* 54993*/   OPC_RecordChild2, // #2 = $m0
/* 54994*/   OPC_MoveChild2,
/* 54995*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 54998*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55000*/   OPC_CheckType, MVT::i32,
/* 55002*/   OPC_MoveParent,
/* 55003*/   OPC_RecordChild3, // #3 = $m1
/* 55004*/   OPC_MoveChild3,
/* 55005*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55008*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55010*/   OPC_CheckType, MVT::i32,
/* 55012*/   OPC_MoveParent,
/* 55013*/   OPC_RecordChild4, // #4 = $m2
/* 55014*/   OPC_MoveChild4,
/* 55015*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55018*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55020*/   OPC_CheckType, MVT::i32,
/* 55022*/   OPC_MoveParent,
/* 55023*/   OPC_RecordChild5, // #5 = $m3
/* 55024*/   OPC_MoveChild5,
/* 55025*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55028*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55030*/   OPC_CheckType, MVT::i32,
/* 55032*/   OPC_MoveParent,
/* 55033*/   OPC_RecordChild6, // #6 = $m4
/* 55034*/   OPC_MoveChild6,
/* 55035*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55038*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55040*/   OPC_CheckType, MVT::i32,
/* 55042*/   OPC_MoveParent,
/* 55043*/   OPC_RecordChild7, // #7 = $m5
/* 55044*/   OPC_MoveChild7,
/* 55045*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55048*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55050*/   OPC_CheckType, MVT::i32,
/* 55052*/   OPC_MoveParent,
/* 55053*/   OPC_MoveChild, 8,
/* 55055*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55058*/   OPC_RecordNode, // #8 = $m6
/* 55059*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55061*/   OPC_CheckType, MVT::i32,
/* 55063*/   OPC_MoveParent,
/* 55064*/   OPC_MoveChild, 9,
/* 55066*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55069*/   OPC_RecordNode, // #9 = $m7
/* 55070*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55072*/   OPC_CheckType, MVT::i32,
/* 55074*/   OPC_MoveParent,
/* 55075*/   OPC_MoveChild, 10,
/* 55077*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55080*/   OPC_RecordNode, // #10 = $m8
/* 55081*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55083*/   OPC_CheckType, MVT::i32,
/* 55085*/   OPC_MoveParent,
/* 55086*/   OPC_MoveChild, 11,
/* 55088*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55091*/   OPC_RecordNode, // #11 = $m9
/* 55092*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55094*/   OPC_CheckType, MVT::i32,
/* 55096*/   OPC_MoveParent,
/* 55097*/   OPC_MoveChild, 12,
/* 55099*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55102*/   OPC_RecordNode, // #12 = $mA
/* 55103*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55105*/   OPC_CheckType, MVT::i32,
/* 55107*/   OPC_MoveParent,
/* 55108*/   OPC_MoveChild, 13,
/* 55110*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55113*/   OPC_RecordNode, // #13 = $mB
/* 55114*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55116*/   OPC_CheckType, MVT::i32,
/* 55118*/   OPC_MoveParent,
/* 55119*/   OPC_MoveChild, 14,
/* 55121*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55124*/   OPC_RecordNode, // #14 = $mC
/* 55125*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55127*/   OPC_CheckType, MVT::i32,
/* 55129*/   OPC_MoveParent,
/* 55130*/   OPC_MoveChild, 15,
/* 55132*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55135*/   OPC_RecordNode, // #15 = $mD
/* 55136*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55138*/   OPC_CheckType, MVT::i32,
/* 55140*/   OPC_MoveParent,
/* 55141*/   OPC_MoveChild, 16,
/* 55143*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55146*/   OPC_RecordNode, // #16 = $mE
/* 55147*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55149*/   OPC_CheckType, MVT::i32,
/* 55151*/   OPC_MoveParent,
/* 55152*/   OPC_MoveChild, 17,
/* 55154*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55157*/   OPC_RecordNode, // #17 = $mF
/* 55158*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55160*/   OPC_CheckType, MVT::i32,
/* 55162*/   OPC_MoveParent,
/* 55163*/   OPC_CheckType, MVT::v8i16,
/* 55165*/   OPC_EmitConvertToTarget, 2,
/* 55167*/   OPC_EmitConvertToTarget, 3,
/* 55169*/   OPC_EmitConvertToTarget, 4,
/* 55171*/   OPC_EmitConvertToTarget, 5,
/* 55173*/   OPC_EmitConvertToTarget, 6,
/* 55175*/   OPC_EmitConvertToTarget, 7,
/* 55177*/   OPC_EmitConvertToTarget, 8,
/* 55179*/   OPC_EmitConvertToTarget, 9,
/* 55181*/   OPC_EmitConvertToTarget, 10,
/* 55183*/   OPC_EmitConvertToTarget, 11,
/* 55185*/   OPC_EmitConvertToTarget, 12,
/* 55187*/   OPC_EmitConvertToTarget, 13,
/* 55189*/   OPC_EmitConvertToTarget, 14,
/* 55191*/   OPC_EmitConvertToTarget, 15,
/* 55193*/   OPC_EmitConvertToTarget, 16,
/* 55195*/   OPC_EmitConvertToTarget, 17,
/* 55197*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 55221*/  /*Scope*/ 105|128,1/*233*/, /*->55456*/
/* 55223*/   OPC_CheckChild0Type, MVT::v4i32,
/* 55225*/   OPC_RecordChild1, // #1 = $y
/* 55226*/   OPC_CheckChild1Type, MVT::v4i32,
/* 55228*/   OPC_RecordChild2, // #2 = $m0
/* 55229*/   OPC_MoveChild2,
/* 55230*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55233*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55235*/   OPC_CheckType, MVT::i32,
/* 55237*/   OPC_MoveParent,
/* 55238*/   OPC_RecordChild3, // #3 = $m1
/* 55239*/   OPC_MoveChild3,
/* 55240*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55243*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55245*/   OPC_CheckType, MVT::i32,
/* 55247*/   OPC_MoveParent,
/* 55248*/   OPC_RecordChild4, // #4 = $m2
/* 55249*/   OPC_MoveChild4,
/* 55250*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55253*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55255*/   OPC_CheckType, MVT::i32,
/* 55257*/   OPC_MoveParent,
/* 55258*/   OPC_RecordChild5, // #5 = $m3
/* 55259*/   OPC_MoveChild5,
/* 55260*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55263*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55265*/   OPC_CheckType, MVT::i32,
/* 55267*/   OPC_MoveParent,
/* 55268*/   OPC_RecordChild6, // #6 = $m4
/* 55269*/   OPC_MoveChild6,
/* 55270*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55273*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55275*/   OPC_CheckType, MVT::i32,
/* 55277*/   OPC_MoveParent,
/* 55278*/   OPC_RecordChild7, // #7 = $m5
/* 55279*/   OPC_MoveChild7,
/* 55280*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55283*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55285*/   OPC_CheckType, MVT::i32,
/* 55287*/   OPC_MoveParent,
/* 55288*/   OPC_MoveChild, 8,
/* 55290*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55293*/   OPC_RecordNode, // #8 = $m6
/* 55294*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55296*/   OPC_CheckType, MVT::i32,
/* 55298*/   OPC_MoveParent,
/* 55299*/   OPC_MoveChild, 9,
/* 55301*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55304*/   OPC_RecordNode, // #9 = $m7
/* 55305*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55307*/   OPC_CheckType, MVT::i32,
/* 55309*/   OPC_MoveParent,
/* 55310*/   OPC_MoveChild, 10,
/* 55312*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55315*/   OPC_RecordNode, // #10 = $m8
/* 55316*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55318*/   OPC_CheckType, MVT::i32,
/* 55320*/   OPC_MoveParent,
/* 55321*/   OPC_MoveChild, 11,
/* 55323*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55326*/   OPC_RecordNode, // #11 = $m9
/* 55327*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55329*/   OPC_CheckType, MVT::i32,
/* 55331*/   OPC_MoveParent,
/* 55332*/   OPC_MoveChild, 12,
/* 55334*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55337*/   OPC_RecordNode, // #12 = $mA
/* 55338*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55340*/   OPC_CheckType, MVT::i32,
/* 55342*/   OPC_MoveParent,
/* 55343*/   OPC_MoveChild, 13,
/* 55345*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55348*/   OPC_RecordNode, // #13 = $mB
/* 55349*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55351*/   OPC_CheckType, MVT::i32,
/* 55353*/   OPC_MoveParent,
/* 55354*/   OPC_MoveChild, 14,
/* 55356*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55359*/   OPC_RecordNode, // #14 = $mC
/* 55360*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55362*/   OPC_CheckType, MVT::i32,
/* 55364*/   OPC_MoveParent,
/* 55365*/   OPC_MoveChild, 15,
/* 55367*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55370*/   OPC_RecordNode, // #15 = $mD
/* 55371*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55373*/   OPC_CheckType, MVT::i32,
/* 55375*/   OPC_MoveParent,
/* 55376*/   OPC_MoveChild, 16,
/* 55378*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55381*/   OPC_RecordNode, // #16 = $mE
/* 55382*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55384*/   OPC_CheckType, MVT::i32,
/* 55386*/   OPC_MoveParent,
/* 55387*/   OPC_MoveChild, 17,
/* 55389*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55392*/   OPC_RecordNode, // #17 = $mF
/* 55393*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55395*/   OPC_CheckType, MVT::i32,
/* 55397*/   OPC_MoveParent,
/* 55398*/   OPC_CheckType, MVT::v4i32,
/* 55400*/   OPC_EmitConvertToTarget, 2,
/* 55402*/   OPC_EmitConvertToTarget, 3,
/* 55404*/   OPC_EmitConvertToTarget, 4,
/* 55406*/   OPC_EmitConvertToTarget, 5,
/* 55408*/   OPC_EmitConvertToTarget, 6,
/* 55410*/   OPC_EmitConvertToTarget, 7,
/* 55412*/   OPC_EmitConvertToTarget, 8,
/* 55414*/   OPC_EmitConvertToTarget, 9,
/* 55416*/   OPC_EmitConvertToTarget, 10,
/* 55418*/   OPC_EmitConvertToTarget, 11,
/* 55420*/   OPC_EmitConvertToTarget, 12,
/* 55422*/   OPC_EmitConvertToTarget, 13,
/* 55424*/   OPC_EmitConvertToTarget, 14,
/* 55426*/   OPC_EmitConvertToTarget, 15,
/* 55428*/   OPC_EmitConvertToTarget, 16,
/* 55430*/   OPC_EmitConvertToTarget, 17,
/* 55432*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 55456*/  /*Scope*/ 105|128,1/*233*/, /*->55691*/
/* 55458*/   OPC_CheckChild0Type, MVT::v2i64,
/* 55460*/   OPC_RecordChild1, // #1 = $y
/* 55461*/   OPC_CheckChild1Type, MVT::v2i64,
/* 55463*/   OPC_RecordChild2, // #2 = $m0
/* 55464*/   OPC_MoveChild2,
/* 55465*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55468*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55470*/   OPC_CheckType, MVT::i32,
/* 55472*/   OPC_MoveParent,
/* 55473*/   OPC_RecordChild3, // #3 = $m1
/* 55474*/   OPC_MoveChild3,
/* 55475*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55478*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55480*/   OPC_CheckType, MVT::i32,
/* 55482*/   OPC_MoveParent,
/* 55483*/   OPC_RecordChild4, // #4 = $m2
/* 55484*/   OPC_MoveChild4,
/* 55485*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55488*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55490*/   OPC_CheckType, MVT::i32,
/* 55492*/   OPC_MoveParent,
/* 55493*/   OPC_RecordChild5, // #5 = $m3
/* 55494*/   OPC_MoveChild5,
/* 55495*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55498*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55500*/   OPC_CheckType, MVT::i32,
/* 55502*/   OPC_MoveParent,
/* 55503*/   OPC_RecordChild6, // #6 = $m4
/* 55504*/   OPC_MoveChild6,
/* 55505*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55508*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55510*/   OPC_CheckType, MVT::i32,
/* 55512*/   OPC_MoveParent,
/* 55513*/   OPC_RecordChild7, // #7 = $m5
/* 55514*/   OPC_MoveChild7,
/* 55515*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55518*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55520*/   OPC_CheckType, MVT::i32,
/* 55522*/   OPC_MoveParent,
/* 55523*/   OPC_MoveChild, 8,
/* 55525*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55528*/   OPC_RecordNode, // #8 = $m6
/* 55529*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55531*/   OPC_CheckType, MVT::i32,
/* 55533*/   OPC_MoveParent,
/* 55534*/   OPC_MoveChild, 9,
/* 55536*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55539*/   OPC_RecordNode, // #9 = $m7
/* 55540*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55542*/   OPC_CheckType, MVT::i32,
/* 55544*/   OPC_MoveParent,
/* 55545*/   OPC_MoveChild, 10,
/* 55547*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55550*/   OPC_RecordNode, // #10 = $m8
/* 55551*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55553*/   OPC_CheckType, MVT::i32,
/* 55555*/   OPC_MoveParent,
/* 55556*/   OPC_MoveChild, 11,
/* 55558*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55561*/   OPC_RecordNode, // #11 = $m9
/* 55562*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55564*/   OPC_CheckType, MVT::i32,
/* 55566*/   OPC_MoveParent,
/* 55567*/   OPC_MoveChild, 12,
/* 55569*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55572*/   OPC_RecordNode, // #12 = $mA
/* 55573*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55575*/   OPC_CheckType, MVT::i32,
/* 55577*/   OPC_MoveParent,
/* 55578*/   OPC_MoveChild, 13,
/* 55580*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55583*/   OPC_RecordNode, // #13 = $mB
/* 55584*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55586*/   OPC_CheckType, MVT::i32,
/* 55588*/   OPC_MoveParent,
/* 55589*/   OPC_MoveChild, 14,
/* 55591*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55594*/   OPC_RecordNode, // #14 = $mC
/* 55595*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55597*/   OPC_CheckType, MVT::i32,
/* 55599*/   OPC_MoveParent,
/* 55600*/   OPC_MoveChild, 15,
/* 55602*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55605*/   OPC_RecordNode, // #15 = $mD
/* 55606*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55608*/   OPC_CheckType, MVT::i32,
/* 55610*/   OPC_MoveParent,
/* 55611*/   OPC_MoveChild, 16,
/* 55613*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55616*/   OPC_RecordNode, // #16 = $mE
/* 55617*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55619*/   OPC_CheckType, MVT::i32,
/* 55621*/   OPC_MoveParent,
/* 55622*/   OPC_MoveChild, 17,
/* 55624*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55627*/   OPC_RecordNode, // #17 = $mF
/* 55628*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55630*/   OPC_CheckType, MVT::i32,
/* 55632*/   OPC_MoveParent,
/* 55633*/   OPC_CheckType, MVT::v2i64,
/* 55635*/   OPC_EmitConvertToTarget, 2,
/* 55637*/   OPC_EmitConvertToTarget, 3,
/* 55639*/   OPC_EmitConvertToTarget, 4,
/* 55641*/   OPC_EmitConvertToTarget, 5,
/* 55643*/   OPC_EmitConvertToTarget, 6,
/* 55645*/   OPC_EmitConvertToTarget, 7,
/* 55647*/   OPC_EmitConvertToTarget, 8,
/* 55649*/   OPC_EmitConvertToTarget, 9,
/* 55651*/   OPC_EmitConvertToTarget, 10,
/* 55653*/   OPC_EmitConvertToTarget, 11,
/* 55655*/   OPC_EmitConvertToTarget, 12,
/* 55657*/   OPC_EmitConvertToTarget, 13,
/* 55659*/   OPC_EmitConvertToTarget, 14,
/* 55661*/   OPC_EmitConvertToTarget, 15,
/* 55663*/   OPC_EmitConvertToTarget, 16,
/* 55665*/   OPC_EmitConvertToTarget, 17,
/* 55667*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 55691*/  /*Scope*/ 105|128,1/*233*/, /*->55926*/
/* 55693*/   OPC_CheckChild0Type, MVT::v4f32,
/* 55695*/   OPC_RecordChild1, // #1 = $y
/* 55696*/   OPC_CheckChild1Type, MVT::v4f32,
/* 55698*/   OPC_RecordChild2, // #2 = $m0
/* 55699*/   OPC_MoveChild2,
/* 55700*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55703*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55705*/   OPC_CheckType, MVT::i32,
/* 55707*/   OPC_MoveParent,
/* 55708*/   OPC_RecordChild3, // #3 = $m1
/* 55709*/   OPC_MoveChild3,
/* 55710*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55713*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55715*/   OPC_CheckType, MVT::i32,
/* 55717*/   OPC_MoveParent,
/* 55718*/   OPC_RecordChild4, // #4 = $m2
/* 55719*/   OPC_MoveChild4,
/* 55720*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55723*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55725*/   OPC_CheckType, MVT::i32,
/* 55727*/   OPC_MoveParent,
/* 55728*/   OPC_RecordChild5, // #5 = $m3
/* 55729*/   OPC_MoveChild5,
/* 55730*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55733*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55735*/   OPC_CheckType, MVT::i32,
/* 55737*/   OPC_MoveParent,
/* 55738*/   OPC_RecordChild6, // #6 = $m4
/* 55739*/   OPC_MoveChild6,
/* 55740*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55743*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55745*/   OPC_CheckType, MVT::i32,
/* 55747*/   OPC_MoveParent,
/* 55748*/   OPC_RecordChild7, // #7 = $m5
/* 55749*/   OPC_MoveChild7,
/* 55750*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55753*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55755*/   OPC_CheckType, MVT::i32,
/* 55757*/   OPC_MoveParent,
/* 55758*/   OPC_MoveChild, 8,
/* 55760*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55763*/   OPC_RecordNode, // #8 = $m6
/* 55764*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55766*/   OPC_CheckType, MVT::i32,
/* 55768*/   OPC_MoveParent,
/* 55769*/   OPC_MoveChild, 9,
/* 55771*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55774*/   OPC_RecordNode, // #9 = $m7
/* 55775*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55777*/   OPC_CheckType, MVT::i32,
/* 55779*/   OPC_MoveParent,
/* 55780*/   OPC_MoveChild, 10,
/* 55782*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55785*/   OPC_RecordNode, // #10 = $m8
/* 55786*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55788*/   OPC_CheckType, MVT::i32,
/* 55790*/   OPC_MoveParent,
/* 55791*/   OPC_MoveChild, 11,
/* 55793*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55796*/   OPC_RecordNode, // #11 = $m9
/* 55797*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55799*/   OPC_CheckType, MVT::i32,
/* 55801*/   OPC_MoveParent,
/* 55802*/   OPC_MoveChild, 12,
/* 55804*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55807*/   OPC_RecordNode, // #12 = $mA
/* 55808*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55810*/   OPC_CheckType, MVT::i32,
/* 55812*/   OPC_MoveParent,
/* 55813*/   OPC_MoveChild, 13,
/* 55815*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55818*/   OPC_RecordNode, // #13 = $mB
/* 55819*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55821*/   OPC_CheckType, MVT::i32,
/* 55823*/   OPC_MoveParent,
/* 55824*/   OPC_MoveChild, 14,
/* 55826*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55829*/   OPC_RecordNode, // #14 = $mC
/* 55830*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55832*/   OPC_CheckType, MVT::i32,
/* 55834*/   OPC_MoveParent,
/* 55835*/   OPC_MoveChild, 15,
/* 55837*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55840*/   OPC_RecordNode, // #15 = $mD
/* 55841*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55843*/   OPC_CheckType, MVT::i32,
/* 55845*/   OPC_MoveParent,
/* 55846*/   OPC_MoveChild, 16,
/* 55848*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55851*/   OPC_RecordNode, // #16 = $mE
/* 55852*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55854*/   OPC_CheckType, MVT::i32,
/* 55856*/   OPC_MoveParent,
/* 55857*/   OPC_MoveChild, 17,
/* 55859*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55862*/   OPC_RecordNode, // #17 = $mF
/* 55863*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55865*/   OPC_CheckType, MVT::i32,
/* 55867*/   OPC_MoveParent,
/* 55868*/   OPC_CheckType, MVT::v4f32,
/* 55870*/   OPC_EmitConvertToTarget, 2,
/* 55872*/   OPC_EmitConvertToTarget, 3,
/* 55874*/   OPC_EmitConvertToTarget, 4,
/* 55876*/   OPC_EmitConvertToTarget, 5,
/* 55878*/   OPC_EmitConvertToTarget, 6,
/* 55880*/   OPC_EmitConvertToTarget, 7,
/* 55882*/   OPC_EmitConvertToTarget, 8,
/* 55884*/   OPC_EmitConvertToTarget, 9,
/* 55886*/   OPC_EmitConvertToTarget, 10,
/* 55888*/   OPC_EmitConvertToTarget, 11,
/* 55890*/   OPC_EmitConvertToTarget, 12,
/* 55892*/   OPC_EmitConvertToTarget, 13,
/* 55894*/   OPC_EmitConvertToTarget, 14,
/* 55896*/   OPC_EmitConvertToTarget, 15,
/* 55898*/   OPC_EmitConvertToTarget, 16,
/* 55900*/   OPC_EmitConvertToTarget, 17,
/* 55902*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 55926*/  /*Scope*/ 105|128,1/*233*/, /*->56161*/
/* 55928*/   OPC_CheckChild0Type, MVT::v2f64,
/* 55930*/   OPC_RecordChild1, // #1 = $y
/* 55931*/   OPC_CheckChild1Type, MVT::v2f64,
/* 55933*/   OPC_RecordChild2, // #2 = $m0
/* 55934*/   OPC_MoveChild2,
/* 55935*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55938*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55940*/   OPC_CheckType, MVT::i32,
/* 55942*/   OPC_MoveParent,
/* 55943*/   OPC_RecordChild3, // #3 = $m1
/* 55944*/   OPC_MoveChild3,
/* 55945*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55948*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55950*/   OPC_CheckType, MVT::i32,
/* 55952*/   OPC_MoveParent,
/* 55953*/   OPC_RecordChild4, // #4 = $m2
/* 55954*/   OPC_MoveChild4,
/* 55955*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55958*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55960*/   OPC_CheckType, MVT::i32,
/* 55962*/   OPC_MoveParent,
/* 55963*/   OPC_RecordChild5, // #5 = $m3
/* 55964*/   OPC_MoveChild5,
/* 55965*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55968*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55970*/   OPC_CheckType, MVT::i32,
/* 55972*/   OPC_MoveParent,
/* 55973*/   OPC_RecordChild6, // #6 = $m4
/* 55974*/   OPC_MoveChild6,
/* 55975*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55978*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55980*/   OPC_CheckType, MVT::i32,
/* 55982*/   OPC_MoveParent,
/* 55983*/   OPC_RecordChild7, // #7 = $m5
/* 55984*/   OPC_MoveChild7,
/* 55985*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55988*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 55990*/   OPC_CheckType, MVT::i32,
/* 55992*/   OPC_MoveParent,
/* 55993*/   OPC_MoveChild, 8,
/* 55995*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 55998*/   OPC_RecordNode, // #8 = $m6
/* 55999*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56001*/   OPC_CheckType, MVT::i32,
/* 56003*/   OPC_MoveParent,
/* 56004*/   OPC_MoveChild, 9,
/* 56006*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56009*/   OPC_RecordNode, // #9 = $m7
/* 56010*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56012*/   OPC_CheckType, MVT::i32,
/* 56014*/   OPC_MoveParent,
/* 56015*/   OPC_MoveChild, 10,
/* 56017*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56020*/   OPC_RecordNode, // #10 = $m8
/* 56021*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56023*/   OPC_CheckType, MVT::i32,
/* 56025*/   OPC_MoveParent,
/* 56026*/   OPC_MoveChild, 11,
/* 56028*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56031*/   OPC_RecordNode, // #11 = $m9
/* 56032*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56034*/   OPC_CheckType, MVT::i32,
/* 56036*/   OPC_MoveParent,
/* 56037*/   OPC_MoveChild, 12,
/* 56039*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56042*/   OPC_RecordNode, // #12 = $mA
/* 56043*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56045*/   OPC_CheckType, MVT::i32,
/* 56047*/   OPC_MoveParent,
/* 56048*/   OPC_MoveChild, 13,
/* 56050*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56053*/   OPC_RecordNode, // #13 = $mB
/* 56054*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56056*/   OPC_CheckType, MVT::i32,
/* 56058*/   OPC_MoveParent,
/* 56059*/   OPC_MoveChild, 14,
/* 56061*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56064*/   OPC_RecordNode, // #14 = $mC
/* 56065*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56067*/   OPC_CheckType, MVT::i32,
/* 56069*/   OPC_MoveParent,
/* 56070*/   OPC_MoveChild, 15,
/* 56072*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56075*/   OPC_RecordNode, // #15 = $mD
/* 56076*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56078*/   OPC_CheckType, MVT::i32,
/* 56080*/   OPC_MoveParent,
/* 56081*/   OPC_MoveChild, 16,
/* 56083*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56086*/   OPC_RecordNode, // #16 = $mE
/* 56087*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56089*/   OPC_CheckType, MVT::i32,
/* 56091*/   OPC_MoveParent,
/* 56092*/   OPC_MoveChild, 17,
/* 56094*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56097*/   OPC_RecordNode, // #17 = $mF
/* 56098*/   OPC_CheckPredicate, 30, // Predicate_LaneIdx32
/* 56100*/   OPC_CheckType, MVT::i32,
/* 56102*/   OPC_MoveParent,
/* 56103*/   OPC_CheckType, MVT::v2f64,
/* 56105*/   OPC_EmitConvertToTarget, 2,
/* 56107*/   OPC_EmitConvertToTarget, 3,
/* 56109*/   OPC_EmitConvertToTarget, 4,
/* 56111*/   OPC_EmitConvertToTarget, 5,
/* 56113*/   OPC_EmitConvertToTarget, 6,
/* 56115*/   OPC_EmitConvertToTarget, 7,
/* 56117*/   OPC_EmitConvertToTarget, 8,
/* 56119*/   OPC_EmitConvertToTarget, 9,
/* 56121*/   OPC_EmitConvertToTarget, 10,
/* 56123*/   OPC_EmitConvertToTarget, 11,
/* 56125*/   OPC_EmitConvertToTarget, 12,
/* 56127*/   OPC_EmitConvertToTarget, 13,
/* 56129*/   OPC_EmitConvertToTarget, 14,
/* 56131*/   OPC_EmitConvertToTarget, 15,
/* 56133*/   OPC_EmitConvertToTarget, 16,
/* 56135*/   OPC_EmitConvertToTarget, 17,
/* 56137*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 56161*/  0, /*End of Scope*/
/* 56162*/ /*SwitchOpcode*/ 37|128,11/*1445*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->57611
/* 56166*/  OPC_Scope, 36|128,6/*804*/, /*->56973*/ // 2 children in Scope
/* 56169*/   OPC_MoveChild0,
/* 56170*/   OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56173*/   OPC_CheckChild0Integer, 0, 
/* 56175*/   OPC_Scope, 16|128,3/*400*/, /*->56578*/ // 2 children in Scope
/* 56178*/    OPC_CheckChild0Type, MVT::i32,
/* 56180*/    OPC_CheckChild1Integer, 0, 
/* 56182*/    OPC_CheckChild1Type, MVT::i32,
/* 56184*/    OPC_CheckChild2Integer, 0, 
/* 56186*/    OPC_CheckChild2Type, MVT::i32,
/* 56188*/    OPC_CheckChild3Integer, 0, 
/* 56190*/    OPC_CheckChild3Type, MVT::i32,
/* 56192*/    OPC_MoveParent,
/* 56193*/    OPC_MoveChild1,
/* 56194*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 56197*/    OPC_RecordMemRef,
/* 56198*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 56199*/    OPC_CheckFoldableChainNode,
/* 56200*/    OPC_Scope, 102|128,1/*230*/, /*->56433*/ // 2 children in Scope
/* 56203*/     OPC_MoveChild1,
/* 56204*/     OPC_SwitchOpcode /*3 cases */, 73, TARGET_VAL(ISD::ADD),// ->56281
/* 56208*/      OPC_RecordChild0, // #1 = $addr
/* 56209*/      OPC_RecordChild1, // #2 = $off
/* 56210*/      OPC_MoveChild1,
/* 56211*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56214*/      OPC_MoveParent,
/* 56215*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 56217*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->56249
/* 56220*/       OPC_MoveParent,
/* 56221*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56223*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56225*/       OPC_CheckType, MVT::i32,
/* 56227*/       OPC_MoveParent,
/* 56228*/       OPC_CheckChild2Integer, 0, 
/* 56230*/       OPC_CheckType, MVT::v4i32,
/* 56232*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56234*/       OPC_EmitMergeInputChains1_0,
/* 56235*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56238*/       OPC_EmitConvertToTarget, 2,
/* 56240*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 42
                 // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 56249*/      /*SwitchType*/ 29, MVT::i64,// ->56280
/* 56251*/       OPC_MoveParent,
/* 56252*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56254*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56256*/       OPC_CheckType, MVT::i32,
/* 56258*/       OPC_MoveParent,
/* 56259*/       OPC_CheckChild2Integer, 0, 
/* 56261*/       OPC_CheckType, MVT::v4i32,
/* 56263*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56265*/       OPC_EmitMergeInputChains1_0,
/* 56266*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56269*/       OPC_EmitConvertToTarget, 2,
/* 56271*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 42
                 // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 56280*/      0, // EndSwitchType
/* 56281*/     /*SwitchOpcode*/ 73, TARGET_VAL(ISD::OR),// ->56357
/* 56284*/      OPC_RecordChild0, // #1 = $addr
/* 56285*/      OPC_RecordChild1, // #2 = $off
/* 56286*/      OPC_MoveChild1,
/* 56287*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56290*/      OPC_MoveParent,
/* 56291*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 56293*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->56325
/* 56296*/       OPC_MoveParent,
/* 56297*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56299*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56301*/       OPC_CheckType, MVT::i32,
/* 56303*/       OPC_MoveParent,
/* 56304*/       OPC_CheckChild2Integer, 0, 
/* 56306*/       OPC_CheckType, MVT::v4i32,
/* 56308*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56310*/       OPC_EmitMergeInputChains1_0,
/* 56311*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56314*/       OPC_EmitConvertToTarget, 2,
/* 56316*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 42
                 // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 56325*/      /*SwitchType*/ 29, MVT::i64,// ->56356
/* 56327*/       OPC_MoveParent,
/* 56328*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56330*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56332*/       OPC_CheckType, MVT::i32,
/* 56334*/       OPC_MoveParent,
/* 56335*/       OPC_CheckChild2Integer, 0, 
/* 56337*/       OPC_CheckType, MVT::v4i32,
/* 56339*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56341*/       OPC_EmitMergeInputChains1_0,
/* 56342*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56345*/       OPC_EmitConvertToTarget, 2,
/* 56347*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 42
                 // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 56356*/      0, // EndSwitchType
/* 56357*/     /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::Wrapper),// ->56432
/* 56360*/      OPC_RecordChild0, // #1 = $off
/* 56361*/      OPC_MoveChild0,
/* 56362*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 56365*/      OPC_MoveParent,
/* 56366*/      OPC_MoveParent,
/* 56367*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56369*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56371*/      OPC_CheckType, MVT::i32,
/* 56373*/      OPC_MoveParent,
/* 56374*/      OPC_CheckChild2Integer, 0, 
/* 56376*/      OPC_CheckType, MVT::v4i32,
/* 56378*/      OPC_Scope, 25, /*->56405*/ // 2 children in Scope
/* 56380*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 56382*/       OPC_EmitMergeInputChains1_0,
/* 56383*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56386*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56389*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 56396*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 41
                 // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 56405*/      /*Scope*/ 25, /*->56431*/
/* 56406*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 56408*/       OPC_EmitMergeInputChains1_0,
/* 56409*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56412*/       OPC_EmitInteger, MVT::i64, 0, 
/* 56415*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 56422*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 41
                 // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 56431*/      0, /*End of Scope*/
/* 56432*/     0, // EndSwitchOpcode
/* 56433*/    /*Scope*/ 14|128,1/*142*/, /*->56577*/
/* 56435*/     OPC_RecordChild1, // #1 = $off
/* 56436*/     OPC_Scope, 74, /*->56512*/ // 3 children in Scope
/* 56438*/      OPC_MoveChild1,
/* 56439*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56442*/      OPC_MoveParent,
/* 56443*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56445*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56447*/      OPC_CheckType, MVT::i32,
/* 56449*/      OPC_MoveParent,
/* 56450*/      OPC_CheckChild2Integer, 0, 
/* 56452*/      OPC_CheckType, MVT::v4i32,
/* 56454*/      OPC_Scope, 27, /*->56483*/ // 2 children in Scope
/* 56456*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56458*/       OPC_EmitMergeInputChains1_0,
/* 56459*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56462*/       OPC_EmitConvertToTarget, 1,
/* 56464*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56467*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 56474*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 38
                 // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 56483*/      /*Scope*/ 27, /*->56511*/
/* 56484*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56486*/       OPC_EmitMergeInputChains1_0,
/* 56487*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56490*/       OPC_EmitConvertToTarget, 1,
/* 56492*/       OPC_EmitInteger, MVT::i64, 0, 
/* 56495*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 56502*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 38
                 // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 56511*/      0, /*End of Scope*/
/* 56512*/     /*Scope*/ 31, /*->56544*/
/* 56513*/      OPC_CheckChild1Type, MVT::i32,
/* 56515*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56517*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56519*/      OPC_CheckType, MVT::i32,
/* 56521*/      OPC_MoveParent,
/* 56522*/      OPC_CheckChild2Integer, 0, 
/* 56524*/      OPC_CheckType, MVT::v4i32,
/* 56526*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56528*/      OPC_EmitMergeInputChains1_0,
/* 56529*/      OPC_EmitInteger, MVT::i32, 0, 
/* 56532*/      OPC_EmitInteger, MVT::i32, 0, 
/* 56535*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 35
                // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 56544*/     /*Scope*/ 31, /*->56576*/
/* 56545*/      OPC_CheckChild1Type, MVT::i64,
/* 56547*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56549*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56551*/      OPC_CheckType, MVT::i32,
/* 56553*/      OPC_MoveParent,
/* 56554*/      OPC_CheckChild2Integer, 0, 
/* 56556*/      OPC_CheckType, MVT::v4i32,
/* 56558*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56560*/      OPC_EmitMergeInputChains1_0,
/* 56561*/      OPC_EmitInteger, MVT::i32, 0, 
/* 56564*/      OPC_EmitInteger, MVT::i64, 0, 
/* 56567*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (vector_insert:{ *:[v4i32] } (build_vector:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }), (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 35
                // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 56576*/     0, /*End of Scope*/
/* 56577*/    0, /*End of Scope*/
/* 56578*/   /*Scope*/ 8|128,3/*392*/, /*->56972*/
/* 56580*/    OPC_CheckChild0Type, MVT::i64,
/* 56582*/    OPC_CheckChild1Integer, 0, 
/* 56584*/    OPC_CheckChild1Type, MVT::i64,
/* 56586*/    OPC_MoveParent,
/* 56587*/    OPC_MoveChild1,
/* 56588*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 56591*/    OPC_RecordMemRef,
/* 56592*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 56593*/    OPC_CheckFoldableChainNode,
/* 56594*/    OPC_Scope, 102|128,1/*230*/, /*->56827*/ // 2 children in Scope
/* 56597*/     OPC_MoveChild1,
/* 56598*/     OPC_SwitchOpcode /*3 cases */, 73, TARGET_VAL(ISD::ADD),// ->56675
/* 56602*/      OPC_RecordChild0, // #1 = $addr
/* 56603*/      OPC_RecordChild1, // #2 = $off
/* 56604*/      OPC_MoveChild1,
/* 56605*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56608*/      OPC_MoveParent,
/* 56609*/      OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 56611*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->56643
/* 56614*/       OPC_MoveParent,
/* 56615*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56617*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56619*/       OPC_CheckType, MVT::i64,
/* 56621*/       OPC_MoveParent,
/* 56622*/       OPC_CheckChild2Integer, 0, 
/* 56624*/       OPC_CheckType, MVT::v2i64,
/* 56626*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56628*/       OPC_EmitMergeInputChains1_0,
/* 56629*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56632*/       OPC_EmitConvertToTarget, 2,
/* 56634*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 32
                 // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 56643*/      /*SwitchType*/ 29, MVT::i64,// ->56674
/* 56645*/       OPC_MoveParent,
/* 56646*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56648*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56650*/       OPC_CheckType, MVT::i64,
/* 56652*/       OPC_MoveParent,
/* 56653*/       OPC_CheckChild2Integer, 0, 
/* 56655*/       OPC_CheckType, MVT::v2i64,
/* 56657*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56659*/       OPC_EmitMergeInputChains1_0,
/* 56660*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56663*/       OPC_EmitConvertToTarget, 2,
/* 56665*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 32
                 // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 56674*/      0, // EndSwitchType
/* 56675*/     /*SwitchOpcode*/ 73, TARGET_VAL(ISD::OR),// ->56751
/* 56678*/      OPC_RecordChild0, // #1 = $addr
/* 56679*/      OPC_RecordChild1, // #2 = $off
/* 56680*/      OPC_MoveChild1,
/* 56681*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56684*/      OPC_MoveParent,
/* 56685*/      OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 56687*/      OPC_SwitchType /*2 cases */, 29, MVT::i32,// ->56719
/* 56690*/       OPC_MoveParent,
/* 56691*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56693*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56695*/       OPC_CheckType, MVT::i64,
/* 56697*/       OPC_MoveParent,
/* 56698*/       OPC_CheckChild2Integer, 0, 
/* 56700*/       OPC_CheckType, MVT::v2i64,
/* 56702*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56704*/       OPC_EmitMergeInputChains1_0,
/* 56705*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56708*/       OPC_EmitConvertToTarget, 2,
/* 56710*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 32
                 // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 56719*/      /*SwitchType*/ 29, MVT::i64,// ->56750
/* 56721*/       OPC_MoveParent,
/* 56722*/       OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56724*/       OPC_CheckPredicate, 20, // Predicate_load
/* 56726*/       OPC_CheckType, MVT::i64,
/* 56728*/       OPC_MoveParent,
/* 56729*/       OPC_CheckChild2Integer, 0, 
/* 56731*/       OPC_CheckType, MVT::v2i64,
/* 56733*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56735*/       OPC_EmitMergeInputChains1_0,
/* 56736*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56739*/       OPC_EmitConvertToTarget, 2,
/* 56741*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 32
                 // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 56750*/      0, // EndSwitchType
/* 56751*/     /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::Wrapper),// ->56826
/* 56754*/      OPC_RecordChild0, // #1 = $off
/* 56755*/      OPC_MoveChild0,
/* 56756*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 56759*/      OPC_MoveParent,
/* 56760*/      OPC_MoveParent,
/* 56761*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56763*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56765*/      OPC_CheckType, MVT::i64,
/* 56767*/      OPC_MoveParent,
/* 56768*/      OPC_CheckChild2Integer, 0, 
/* 56770*/      OPC_CheckType, MVT::v2i64,
/* 56772*/      OPC_Scope, 25, /*->56799*/ // 2 children in Scope
/* 56774*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 56776*/       OPC_EmitMergeInputChains1_0,
/* 56777*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56780*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56783*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 56790*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 31
                 // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 56799*/      /*Scope*/ 25, /*->56825*/
/* 56800*/       OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 56802*/       OPC_EmitMergeInputChains1_0,
/* 56803*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56806*/       OPC_EmitInteger, MVT::i64, 0, 
/* 56809*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 56816*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 31
                 // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 56825*/      0, /*End of Scope*/
/* 56826*/     0, // EndSwitchOpcode
/* 56827*/    /*Scope*/ 14|128,1/*142*/, /*->56971*/
/* 56829*/     OPC_RecordChild1, // #1 = $off
/* 56830*/     OPC_Scope, 74, /*->56906*/ // 3 children in Scope
/* 56832*/      OPC_MoveChild1,
/* 56833*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 56836*/      OPC_MoveParent,
/* 56837*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56839*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56841*/      OPC_CheckType, MVT::i64,
/* 56843*/      OPC_MoveParent,
/* 56844*/      OPC_CheckChild2Integer, 0, 
/* 56846*/      OPC_CheckType, MVT::v2i64,
/* 56848*/      OPC_Scope, 27, /*->56877*/ // 2 children in Scope
/* 56850*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56852*/       OPC_EmitMergeInputChains1_0,
/* 56853*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56856*/       OPC_EmitConvertToTarget, 1,
/* 56858*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56861*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                     MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 56868*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 28
                 // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 56877*/      /*Scope*/ 27, /*->56905*/
/* 56878*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56880*/       OPC_EmitMergeInputChains1_0,
/* 56881*/       OPC_EmitInteger, MVT::i32, 0, 
/* 56884*/       OPC_EmitConvertToTarget, 1,
/* 56886*/       OPC_EmitInteger, MVT::i64, 0, 
/* 56889*/       OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                     MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 56896*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                 // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 28
                 // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 56905*/      0, /*End of Scope*/
/* 56906*/     /*Scope*/ 31, /*->56938*/
/* 56907*/      OPC_CheckChild1Type, MVT::i32,
/* 56909*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56911*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56913*/      OPC_CheckType, MVT::i64,
/* 56915*/      OPC_MoveParent,
/* 56916*/      OPC_CheckChild2Integer, 0, 
/* 56918*/      OPC_CheckType, MVT::v2i64,
/* 56920*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 56922*/      OPC_EmitMergeInputChains1_0,
/* 56923*/      OPC_EmitInteger, MVT::i32, 0, 
/* 56926*/      OPC_EmitInteger, MVT::i32, 0, 
/* 56929*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 25
                // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 56938*/     /*Scope*/ 31, /*->56970*/
/* 56939*/      OPC_CheckChild1Type, MVT::i64,
/* 56941*/      OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56943*/      OPC_CheckPredicate, 20, // Predicate_load
/* 56945*/      OPC_CheckType, MVT::i64,
/* 56947*/      OPC_MoveParent,
/* 56948*/      OPC_CheckChild2Integer, 0, 
/* 56950*/      OPC_CheckType, MVT::v2i64,
/* 56952*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 56954*/      OPC_EmitMergeInputChains1_0,
/* 56955*/      OPC_EmitInteger, MVT::i32, 0, 
/* 56958*/      OPC_EmitInteger, MVT::i64, 0, 
/* 56961*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } (build_vector:{ *:[v2i64] } 0:{ *:[i64] }, 0:{ *:[i64] }), (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 25
                // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 56970*/     0, /*End of Scope*/
/* 56971*/    0, /*End of Scope*/
/* 56972*/   0, /*End of Scope*/
/* 56973*/  /*Scope*/ 123|128,4/*635*/, /*->57610*/
/* 56975*/   OPC_RecordChild0, // #0 = $vec
/* 56976*/   OPC_Scope, 94|128,2/*350*/, /*->57329*/ // 2 children in Scope
/* 56979*/    OPC_MoveChild1,
/* 56980*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 56983*/    OPC_RecordMemRef,
/* 56984*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 56985*/    OPC_CheckFoldableChainNode,
/* 56986*/    OPC_RecordChild1, // #2 = $addr
/* 56987*/    OPC_Scope, 40|128,1/*168*/, /*->57158*/ // 2 children in Scope
/* 56990*/     OPC_CheckChild1Type, MVT::i32,
/* 56992*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 56994*/     OPC_Scope, 82, /*->57078*/ // 2 children in Scope
/* 56996*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 56998*/      OPC_CheckType, MVT::i32,
/* 57000*/      OPC_Scope, 37, /*->57039*/ // 2 children in Scope
/* 57002*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 57004*/       OPC_MoveParent,
/* 57005*/       OPC_RecordChild2, // #3 = $idx
/* 57006*/       OPC_MoveChild2,
/* 57007*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57010*/       OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 57012*/       OPC_CheckType, MVT::i32,
/* 57014*/       OPC_MoveParent,
/* 57015*/       OPC_CheckType, MVT::v16i8,
/* 57017*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 57019*/       OPC_EmitMergeInputChains1_1,
/* 57020*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57023*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57026*/       OPC_EmitConvertToTarget, 3,
/* 57028*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 57039*/      /*Scope*/ 37, /*->57077*/
/* 57040*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 57042*/       OPC_MoveParent,
/* 57043*/       OPC_RecordChild2, // #3 = $idx
/* 57044*/       OPC_MoveChild2,
/* 57045*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57048*/       OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 57050*/       OPC_CheckType, MVT::i32,
/* 57052*/       OPC_MoveParent,
/* 57053*/       OPC_CheckType, MVT::v8i16,
/* 57055*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 57057*/       OPC_EmitMergeInputChains1_1,
/* 57058*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57061*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57064*/       OPC_EmitConvertToTarget, 3,
/* 57066*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 57077*/      0, /*End of Scope*/
/* 57078*/     /*Scope*/ 78, /*->57157*/
/* 57079*/      OPC_CheckPredicate, 20, // Predicate_load
/* 57081*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->57119
/* 57084*/       OPC_MoveParent,
/* 57085*/       OPC_RecordChild2, // #3 = $idx
/* 57086*/       OPC_MoveChild2,
/* 57087*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57090*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 57092*/       OPC_CheckType, MVT::i32,
/* 57094*/       OPC_MoveParent,
/* 57095*/       OPC_CheckType, MVT::v4i32,
/* 57097*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 57099*/       OPC_EmitMergeInputChains1_1,
/* 57100*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57103*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57106*/       OPC_EmitConvertToTarget, 3,
/* 57108*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 57119*/      /*SwitchType*/ 35, MVT::i64,// ->57156
/* 57121*/       OPC_MoveParent,
/* 57122*/       OPC_RecordChild2, // #3 = $idx
/* 57123*/       OPC_MoveChild2,
/* 57124*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57127*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 57129*/       OPC_CheckType, MVT::i32,
/* 57131*/       OPC_MoveParent,
/* 57132*/       OPC_CheckType, MVT::v2i64,
/* 57134*/       OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 57136*/       OPC_EmitMergeInputChains1_1,
/* 57137*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57140*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57143*/       OPC_EmitConvertToTarget, 3,
/* 57145*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 57156*/      0, // EndSwitchType
/* 57157*/     0, /*End of Scope*/
/* 57158*/    /*Scope*/ 40|128,1/*168*/, /*->57328*/
/* 57160*/     OPC_CheckChild1Type, MVT::i64,
/* 57162*/     OPC_CheckPredicate, 19, // Predicate_unindexedload
/* 57164*/     OPC_Scope, 82, /*->57248*/ // 2 children in Scope
/* 57166*/      OPC_CheckPredicate, 23, // Predicate_extload
/* 57168*/      OPC_CheckType, MVT::i32,
/* 57170*/      OPC_Scope, 37, /*->57209*/ // 2 children in Scope
/* 57172*/       OPC_CheckPredicate, 1, // Predicate_extloadi8
/* 57174*/       OPC_MoveParent,
/* 57175*/       OPC_RecordChild2, // #3 = $idx
/* 57176*/       OPC_MoveChild2,
/* 57177*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57180*/       OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 57182*/       OPC_CheckType, MVT::i32,
/* 57184*/       OPC_MoveParent,
/* 57185*/       OPC_CheckType, MVT::v16i8,
/* 57187*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 57189*/       OPC_EmitMergeInputChains1_1,
/* 57190*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57193*/       OPC_EmitInteger, MVT::i64, 0, 
/* 57196*/       OPC_EmitConvertToTarget, 3,
/* 57198*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 57209*/      /*Scope*/ 37, /*->57247*/
/* 57210*/       OPC_CheckPredicate, 2, // Predicate_extloadi16
/* 57212*/       OPC_MoveParent,
/* 57213*/       OPC_RecordChild2, // #3 = $idx
/* 57214*/       OPC_MoveChild2,
/* 57215*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57218*/       OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 57220*/       OPC_CheckType, MVT::i32,
/* 57222*/       OPC_MoveParent,
/* 57223*/       OPC_CheckType, MVT::v8i16,
/* 57225*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 57227*/       OPC_EmitMergeInputChains1_1,
/* 57228*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57231*/       OPC_EmitInteger, MVT::i64, 0, 
/* 57234*/       OPC_EmitConvertToTarget, 3,
/* 57236*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 57247*/      0, /*End of Scope*/
/* 57248*/     /*Scope*/ 78, /*->57327*/
/* 57249*/      OPC_CheckPredicate, 20, // Predicate_load
/* 57251*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->57289
/* 57254*/       OPC_MoveParent,
/* 57255*/       OPC_RecordChild2, // #3 = $idx
/* 57256*/       OPC_MoveChild2,
/* 57257*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57260*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 57262*/       OPC_CheckType, MVT::i32,
/* 57264*/       OPC_MoveParent,
/* 57265*/       OPC_CheckType, MVT::v4i32,
/* 57267*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 57269*/       OPC_EmitMergeInputChains1_1,
/* 57270*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57273*/       OPC_EmitInteger, MVT::i64, 0, 
/* 57276*/       OPC_EmitConvertToTarget, 3,
/* 57278*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 57289*/      /*SwitchType*/ 35, MVT::i64,// ->57326
/* 57291*/       OPC_MoveParent,
/* 57292*/       OPC_RecordChild2, // #3 = $idx
/* 57293*/       OPC_MoveChild2,
/* 57294*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57297*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 57299*/       OPC_CheckType, MVT::i32,
/* 57301*/       OPC_MoveParent,
/* 57302*/       OPC_CheckType, MVT::v2i64,
/* 57304*/       OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 57306*/       OPC_EmitMergeInputChains1_1,
/* 57307*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57310*/       OPC_EmitInteger, MVT::i64, 0, 
/* 57313*/       OPC_EmitConvertToTarget, 3,
/* 57315*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 57326*/      0, // EndSwitchType
/* 57327*/     0, /*End of Scope*/
/* 57328*/    0, /*End of Scope*/
/* 57329*/   /*Scope*/ 22|128,2/*278*/, /*->57609*/
/* 57331*/    OPC_RecordChild1, // #1 = $x
/* 57332*/    OPC_Scope, 121, /*->57455*/ // 4 children in Scope
/* 57334*/     OPC_CheckChild1Type, MVT::i32,
/* 57336*/     OPC_Scope, 66, /*->57404*/ // 2 children in Scope
/* 57338*/      OPC_RecordChild2, // #2 = $idx
/* 57339*/      OPC_MoveChild2,
/* 57340*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57343*/      OPC_CheckType, MVT::i32,
/* 57345*/      OPC_Scope, 18, /*->57365*/ // 3 children in Scope
/* 57347*/       OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 57349*/       OPC_MoveParent,
/* 57350*/       OPC_CheckType, MVT::v16i8,
/* 57352*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57354*/       OPC_EmitConvertToTarget, 2,
/* 57356*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16), 0,
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 57365*/      /*Scope*/ 18, /*->57384*/
/* 57366*/       OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 57368*/       OPC_MoveParent,
/* 57369*/       OPC_CheckType, MVT::v8i16,
/* 57371*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57373*/       OPC_EmitConvertToTarget, 2,
/* 57375*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8), 0,
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 57384*/      /*Scope*/ 18, /*->57403*/
/* 57385*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 57387*/       OPC_MoveParent,
/* 57388*/       OPC_CheckType, MVT::v4i32,
/* 57390*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57392*/       OPC_EmitConvertToTarget, 2,
/* 57394*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4), 0,
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 57403*/      0, /*End of Scope*/
/* 57404*/     /*Scope*/ 49, /*->57454*/
/* 57405*/      OPC_MoveChild2,
/* 57406*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 57409*/      OPC_MoveParent,
/* 57410*/      OPC_SwitchType /*3 cases */, 12, MVT::v16i8,// ->57425
/* 57413*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57416*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16), 0,
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 57425*/      /*SwitchType*/ 12, MVT::v8i16,// ->57439
/* 57427*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57430*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8), 0,
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 57439*/      /*SwitchType*/ 12, MVT::v4i32,// ->57453
/* 57441*/       OPC_EmitInteger, MVT::i32, 0, 
/* 57444*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4), 0,
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 57453*/      0, // EndSwitchType
/* 57454*/     0, /*End of Scope*/
/* 57455*/    /*Scope*/ 50, /*->57506*/
/* 57456*/     OPC_CheckChild1Type, MVT::i64,
/* 57458*/     OPC_Scope, 25, /*->57485*/ // 2 children in Scope
/* 57460*/      OPC_RecordChild2, // #2 = $idx
/* 57461*/      OPC_MoveChild2,
/* 57462*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57465*/      OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 57467*/      OPC_CheckType, MVT::i32,
/* 57469*/      OPC_MoveParent,
/* 57470*/      OPC_CheckType, MVT::v2i64,
/* 57472*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57474*/      OPC_EmitConvertToTarget, 2,
/* 57476*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 57485*/     /*Scope*/ 19, /*->57505*/
/* 57486*/      OPC_MoveChild2,
/* 57487*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 57490*/      OPC_MoveParent,
/* 57491*/      OPC_CheckType, MVT::v2i64,
/* 57493*/      OPC_EmitInteger, MVT::i32, 0, 
/* 57496*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 57505*/     0, /*End of Scope*/
/* 57506*/    /*Scope*/ 50, /*->57557*/
/* 57507*/     OPC_CheckChild1Type, MVT::f32,
/* 57509*/     OPC_Scope, 25, /*->57536*/ // 2 children in Scope
/* 57511*/      OPC_RecordChild2, // #2 = $idx
/* 57512*/      OPC_MoveChild2,
/* 57513*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57516*/      OPC_CheckPredicate, 13, // Predicate_LaneIdx4
/* 57518*/      OPC_CheckType, MVT::i32,
/* 57520*/      OPC_MoveParent,
/* 57521*/      OPC_CheckType, MVT::v4f32,
/* 57523*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57525*/      OPC_EmitConvertToTarget, 2,
/* 57527*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4), 0,
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 57536*/     /*Scope*/ 19, /*->57556*/
/* 57537*/      OPC_MoveChild2,
/* 57538*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 57541*/      OPC_MoveParent,
/* 57542*/      OPC_CheckType, MVT::v4f32,
/* 57544*/      OPC_EmitInteger, MVT::i32, 0, 
/* 57547*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4), 0,
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 57556*/     0, /*End of Scope*/
/* 57557*/    /*Scope*/ 50, /*->57608*/
/* 57558*/     OPC_CheckChild1Type, MVT::f64,
/* 57560*/     OPC_Scope, 25, /*->57587*/ // 2 children in Scope
/* 57562*/      OPC_RecordChild2, // #2 = $idx
/* 57563*/      OPC_MoveChild2,
/* 57564*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 57567*/      OPC_CheckPredicate, 15, // Predicate_LaneIdx2
/* 57569*/      OPC_CheckType, MVT::i32,
/* 57571*/      OPC_MoveParent,
/* 57572*/      OPC_CheckType, MVT::v2f64,
/* 57574*/      OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57576*/      OPC_EmitConvertToTarget, 2,
/* 57578*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2), 0,
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 57587*/     /*Scope*/ 19, /*->57607*/
/* 57588*/      OPC_MoveChild2,
/* 57589*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 57592*/      OPC_MoveParent,
/* 57593*/      OPC_CheckType, MVT::v2f64,
/* 57595*/      OPC_EmitInteger, MVT::i32, 0, 
/* 57598*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2), 0,
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 57607*/     0, /*End of Scope*/
/* 57608*/    0, /*End of Scope*/
/* 57609*/   0, /*End of Scope*/
/* 57610*/  0, /*End of Scope*/
/* 57611*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->57746
/* 57615*/  OPC_RecordChild0, // #0 = $lhs
/* 57616*/  OPC_Scope, 75, /*->57693*/ // 2 children in Scope
/* 57618*/   OPC_MoveChild1,
/* 57619*/   OPC_Scope, 26, /*->57647*/ // 4 children in Scope
/* 57621*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 57624*/    OPC_MoveChild0,
/* 57625*/    OPC_CheckAndImm, 63, 
/* 57627*/    OPC_RecordChild0, // #1 = $rhs
/* 57628*/    OPC_MoveParent,
/* 57629*/    OPC_MoveParent,
/* 57630*/    OPC_CheckType, MVT::v2i64,
/* 57632*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 57639*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 57647*/   /*Scope*/ 14, /*->57662*/
/* 57648*/    OPC_CheckAndImm, 7, 
/* 57650*/    OPC_RecordChild0, // #1 = $rhs
/* 57651*/    OPC_MoveParent,
/* 57652*/    OPC_CheckType, MVT::v16i8,
/* 57654*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57662*/   /*Scope*/ 14, /*->57677*/
/* 57663*/    OPC_CheckAndImm, 15, 
/* 57665*/    OPC_RecordChild0, // #1 = $rhs
/* 57666*/    OPC_MoveParent,
/* 57667*/    OPC_CheckType, MVT::v8i16,
/* 57669*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57677*/   /*Scope*/ 14, /*->57692*/
/* 57678*/    OPC_CheckAndImm, 31, 
/* 57680*/    OPC_RecordChild0, // #1 = $rhs
/* 57681*/    OPC_MoveParent,
/* 57682*/    OPC_CheckType, MVT::v4i32,
/* 57684*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57692*/   0, /*End of Scope*/
/* 57693*/  /*Scope*/ 51, /*->57745*/
/* 57694*/   OPC_RecordChild1, // #1 = $x
/* 57695*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->57708
/* 57698*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57700*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 57708*/   /*SwitchType*/ 10, MVT::v8i16,// ->57720
/* 57710*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57712*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 57720*/   /*SwitchType*/ 10, MVT::v4i32,// ->57732
/* 57722*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57724*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 57732*/   /*SwitchType*/ 10, MVT::v2i64,// ->57744
/* 57734*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57736*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 57744*/   0, // EndSwitchType
/* 57745*/  0, /*End of Scope*/
/* 57746*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->57881
/* 57750*/  OPC_RecordChild0, // #0 = $lhs
/* 57751*/  OPC_Scope, 75, /*->57828*/ // 2 children in Scope
/* 57753*/   OPC_MoveChild1,
/* 57754*/   OPC_Scope, 26, /*->57782*/ // 4 children in Scope
/* 57756*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 57759*/    OPC_MoveChild0,
/* 57760*/    OPC_CheckAndImm, 63, 
/* 57762*/    OPC_RecordChild0, // #1 = $rhs
/* 57763*/    OPC_MoveParent,
/* 57764*/    OPC_MoveParent,
/* 57765*/    OPC_CheckType, MVT::v2i64,
/* 57767*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 57774*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 57782*/   /*Scope*/ 14, /*->57797*/
/* 57783*/    OPC_CheckAndImm, 7, 
/* 57785*/    OPC_RecordChild0, // #1 = $rhs
/* 57786*/    OPC_MoveParent,
/* 57787*/    OPC_CheckType, MVT::v16i8,
/* 57789*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57797*/   /*Scope*/ 14, /*->57812*/
/* 57798*/    OPC_CheckAndImm, 15, 
/* 57800*/    OPC_RecordChild0, // #1 = $rhs
/* 57801*/    OPC_MoveParent,
/* 57802*/    OPC_CheckType, MVT::v8i16,
/* 57804*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57812*/   /*Scope*/ 14, /*->57827*/
/* 57813*/    OPC_CheckAndImm, 31, 
/* 57815*/    OPC_RecordChild0, // #1 = $rhs
/* 57816*/    OPC_MoveParent,
/* 57817*/    OPC_CheckType, MVT::v4i32,
/* 57819*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57827*/   0, /*End of Scope*/
/* 57828*/  /*Scope*/ 51, /*->57880*/
/* 57829*/   OPC_RecordChild1, // #1 = $x
/* 57830*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->57843
/* 57833*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57835*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 57843*/   /*SwitchType*/ 10, MVT::v8i16,// ->57855
/* 57845*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57847*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 57855*/   /*SwitchType*/ 10, MVT::v4i32,// ->57867
/* 57857*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57859*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 57867*/   /*SwitchType*/ 10, MVT::v2i64,// ->57879
/* 57869*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 57871*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 57879*/   0, // EndSwitchType
/* 57880*/  0, /*End of Scope*/
/* 57881*/ /*SwitchOpcode*/ 18|128,2/*274*/, TARGET_VAL(ISD::VSELECT),// ->58159
/* 57885*/  OPC_Scope, 103, /*->57990*/ // 4 children in Scope
/* 57887*/   OPC_MoveChild0,
/* 57888*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 57891*/   OPC_MoveChild0,
/* 57892*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 57895*/   OPC_RecordChild0, // #0 = $rhs
/* 57896*/   OPC_SwitchType /*2 cases */, 44, MVT::v4f32,// ->57943
/* 57899*/    OPC_CheckChild0Type, MVT::v4i32,
/* 57901*/    OPC_MoveParent,
/* 57902*/    OPC_MoveChild1,
/* 57903*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 57906*/    OPC_RecordChild0, // #1 = $lhs
/* 57907*/    OPC_CheckChild0Type, MVT::v4i32,
/* 57909*/    OPC_MoveParent,
/* 57910*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 57912*/    OPC_MoveParent,
/* 57913*/    OPC_CheckType, MVT::v4i32,
/* 57915*/    OPC_Scope, 12, /*->57929*/ // 2 children in Scope
/* 57917*/     OPC_CheckChild1Same, 0,
/* 57919*/     OPC_CheckChild2Same, 1,
/* 57921*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 57929*/    /*Scope*/ 12, /*->57942*/
/* 57930*/     OPC_CheckChild1Same, 1,
/* 57932*/     OPC_CheckChild2Same, 0,
/* 57934*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 57942*/    0, /*End of Scope*/
/* 57943*/   /*SwitchType*/ 44, MVT::v2f64,// ->57989
/* 57945*/    OPC_CheckChild0Type, MVT::v2i64,
/* 57947*/    OPC_MoveParent,
/* 57948*/    OPC_MoveChild1,
/* 57949*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 57952*/    OPC_RecordChild0, // #1 = $lhs
/* 57953*/    OPC_CheckChild0Type, MVT::v2i64,
/* 57955*/    OPC_MoveParent,
/* 57956*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 57958*/    OPC_MoveParent,
/* 57959*/    OPC_CheckType, MVT::v2i64,
/* 57961*/    OPC_Scope, 12, /*->57975*/ // 2 children in Scope
/* 57963*/     OPC_CheckChild1Same, 0,
/* 57965*/     OPC_CheckChild2Same, 1,
/* 57967*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 57975*/    /*Scope*/ 12, /*->57988*/
/* 57976*/     OPC_CheckChild1Same, 1,
/* 57978*/     OPC_CheckChild2Same, 0,
/* 57980*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 57988*/    0, /*End of Scope*/
/* 57989*/   0, // EndSwitchType
/* 57990*/  /*Scope*/ 49, /*->58040*/
/* 57991*/   OPC_RecordChild0, // #0 = $c
/* 57992*/   OPC_RecordChild1, // #1 = $v1
/* 57993*/   OPC_RecordChild2, // #2 = $v2
/* 57994*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->58006
/* 57997*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 58006*/   /*SwitchType*/ 9, MVT::v8i16,// ->58017
/* 58008*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 58017*/   /*SwitchType*/ 9, MVT::v4i32,// ->58028
/* 58019*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 58028*/   /*SwitchType*/ 9, MVT::v2i64,// ->58039
/* 58030*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 58039*/   0, // EndSwitchType
/* 58040*/  /*Scope*/ 89, /*->58130*/
/* 58041*/   OPC_MoveChild0,
/* 58042*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 58045*/   OPC_RecordChild0, // #0 = $rhs
/* 58046*/   OPC_Scope, 40, /*->58088*/ // 2 children in Scope
/* 58048*/    OPC_CheckChild0Type, MVT::v4f32,
/* 58050*/    OPC_RecordChild1, // #1 = $lhs
/* 58051*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 58053*/    OPC_MoveParent,
/* 58054*/    OPC_CheckType, MVT::v4f32,
/* 58056*/    OPC_Scope, 14, /*->58072*/ // 2 children in Scope
/* 58058*/     OPC_CheckChild1Same, 0,
/* 58060*/     OPC_CheckChild2Same, 1,
/* 58062*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 58064*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                   MVT::v4f32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
               // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58072*/    /*Scope*/ 14, /*->58087*/
/* 58073*/     OPC_CheckChild1Same, 1,
/* 58075*/     OPC_CheckChild2Same, 0,
/* 58077*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 58079*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                   MVT::v4f32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
               // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58087*/    0, /*End of Scope*/
/* 58088*/   /*Scope*/ 40, /*->58129*/
/* 58089*/    OPC_CheckChild0Type, MVT::v2f64,
/* 58091*/    OPC_RecordChild1, // #1 = $lhs
/* 58092*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 58094*/    OPC_MoveParent,
/* 58095*/    OPC_CheckType, MVT::v2f64,
/* 58097*/    OPC_Scope, 14, /*->58113*/ // 2 children in Scope
/* 58099*/     OPC_CheckChild1Same, 0,
/* 58101*/     OPC_CheckChild2Same, 1,
/* 58103*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 58105*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                   MVT::v2f64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
               // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58113*/    /*Scope*/ 14, /*->58128*/
/* 58114*/     OPC_CheckChild1Same, 1,
/* 58116*/     OPC_CheckChild2Same, 0,
/* 58118*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 58120*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                   MVT::v2f64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
               // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58128*/    0, /*End of Scope*/
/* 58129*/   0, /*End of Scope*/
/* 58130*/  /*Scope*/ 27, /*->58158*/
/* 58131*/   OPC_RecordChild0, // #0 = $c
/* 58132*/   OPC_RecordChild1, // #1 = $v1
/* 58133*/   OPC_RecordChild2, // #2 = $v2
/* 58134*/   OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->58146
/* 58137*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 58146*/   /*SwitchType*/ 9, MVT::v2f64,// ->58157
/* 58148*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 58157*/   0, // EndSwitchType
/* 58158*/  0, /*End of Scope*/
/* 58159*/ /*SwitchOpcode*/ 40|128,12/*1576*/, TARGET_VAL(WebAssemblyISD::LOAD_SPLAT),// ->59739
/* 58163*/  OPC_RecordMemRef,
/* 58164*/  OPC_RecordNode, // #0 = 'wasm_load_splat' chained node
/* 58165*/  OPC_Scope, 82|128,4/*594*/, /*->58762*/ // 4 children in Scope
/* 58168*/   OPC_MoveChild1,
/* 58169*/   OPC_SwitchOpcode /*3 cases */, 45|128,1/*173*/, TARGET_VAL(ISD::ADD),// ->58347
/* 58174*/    OPC_RecordChild0, // #1 = $addr
/* 58175*/    OPC_RecordChild1, // #2 = $off
/* 58176*/    OPC_MoveChild1,
/* 58177*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58180*/    OPC_MoveParent,
/* 58181*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 58183*/    OPC_SwitchType /*2 cases */, 79, MVT::i32,// ->58265
/* 58186*/     OPC_MoveParent,
/* 58187*/     OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->58207
/* 58190*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58192*/      OPC_EmitMergeInputChains1_0,
/* 58193*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58196*/      OPC_EmitConvertToTarget, 2,
/* 58198*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58207*/     /*SwitchType*/ 17, MVT::v8i16,// ->58226
/* 58209*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58211*/      OPC_EmitMergeInputChains1_0,
/* 58212*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58215*/      OPC_EmitConvertToTarget, 2,
/* 58217*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58226*/     /*SwitchType*/ 17, MVT::v4i32,// ->58245
/* 58228*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58230*/      OPC_EmitMergeInputChains1_0,
/* 58231*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58234*/      OPC_EmitConvertToTarget, 2,
/* 58236*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58245*/     /*SwitchType*/ 17, MVT::v2i64,// ->58264
/* 58247*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58249*/      OPC_EmitMergeInputChains1_0,
/* 58250*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58253*/      OPC_EmitConvertToTarget, 2,
/* 58255*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58264*/     0, // EndSwitchType
/* 58265*/    /*SwitchType*/ 79, MVT::i64,// ->58346
/* 58267*/     OPC_MoveParent,
/* 58268*/     OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->58288
/* 58271*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58273*/      OPC_EmitMergeInputChains1_0,
/* 58274*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58277*/      OPC_EmitConvertToTarget, 2,
/* 58279*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58288*/     /*SwitchType*/ 17, MVT::v8i16,// ->58307
/* 58290*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58292*/      OPC_EmitMergeInputChains1_0,
/* 58293*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58296*/      OPC_EmitConvertToTarget, 2,
/* 58298*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58307*/     /*SwitchType*/ 17, MVT::v4i32,// ->58326
/* 58309*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58311*/      OPC_EmitMergeInputChains1_0,
/* 58312*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58315*/      OPC_EmitConvertToTarget, 2,
/* 58317*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58326*/     /*SwitchType*/ 17, MVT::v2i64,// ->58345
/* 58328*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58330*/      OPC_EmitMergeInputChains1_0,
/* 58331*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58334*/      OPC_EmitConvertToTarget, 2,
/* 58336*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58345*/     0, // EndSwitchType
/* 58346*/    0, // EndSwitchType
/* 58347*/   /*SwitchOpcode*/ 45|128,1/*173*/, TARGET_VAL(ISD::OR),// ->58524
/* 58351*/    OPC_RecordChild0, // #1 = $addr
/* 58352*/    OPC_RecordChild1, // #2 = $off
/* 58353*/    OPC_MoveChild1,
/* 58354*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58357*/    OPC_MoveParent,
/* 58358*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 58360*/    OPC_SwitchType /*2 cases */, 79, MVT::i32,// ->58442
/* 58363*/     OPC_MoveParent,
/* 58364*/     OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->58384
/* 58367*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58369*/      OPC_EmitMergeInputChains1_0,
/* 58370*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58373*/      OPC_EmitConvertToTarget, 2,
/* 58375*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58384*/     /*SwitchType*/ 17, MVT::v8i16,// ->58403
/* 58386*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58388*/      OPC_EmitMergeInputChains1_0,
/* 58389*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58392*/      OPC_EmitConvertToTarget, 2,
/* 58394*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58403*/     /*SwitchType*/ 17, MVT::v4i32,// ->58422
/* 58405*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58407*/      OPC_EmitMergeInputChains1_0,
/* 58408*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58411*/      OPC_EmitConvertToTarget, 2,
/* 58413*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58422*/     /*SwitchType*/ 17, MVT::v2i64,// ->58441
/* 58424*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58426*/      OPC_EmitMergeInputChains1_0,
/* 58427*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58430*/      OPC_EmitConvertToTarget, 2,
/* 58432*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 58441*/     0, // EndSwitchType
/* 58442*/    /*SwitchType*/ 79, MVT::i64,// ->58523
/* 58444*/     OPC_MoveParent,
/* 58445*/     OPC_SwitchType /*4 cases */, 17, MVT::v16i8,// ->58465
/* 58448*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58450*/      OPC_EmitMergeInputChains1_0,
/* 58451*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58454*/      OPC_EmitConvertToTarget, 2,
/* 58456*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58465*/     /*SwitchType*/ 17, MVT::v8i16,// ->58484
/* 58467*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58469*/      OPC_EmitMergeInputChains1_0,
/* 58470*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58473*/      OPC_EmitConvertToTarget, 2,
/* 58475*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58484*/     /*SwitchType*/ 17, MVT::v4i32,// ->58503
/* 58486*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58488*/      OPC_EmitMergeInputChains1_0,
/* 58489*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58492*/      OPC_EmitConvertToTarget, 2,
/* 58494*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58503*/     /*SwitchType*/ 17, MVT::v2i64,// ->58522
/* 58505*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58507*/      OPC_EmitMergeInputChains1_0,
/* 58508*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58511*/      OPC_EmitConvertToTarget, 2,
/* 58513*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 58522*/     0, // EndSwitchType
/* 58523*/    0, // EndSwitchType
/* 58524*/   /*SwitchOpcode*/ 105|128,1/*233*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->58761
/* 58528*/    OPC_RecordChild0, // #1 = $off
/* 58529*/    OPC_MoveChild0,
/* 58530*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 58533*/    OPC_MoveParent,
/* 58534*/    OPC_MoveParent,
/* 58535*/    OPC_SwitchType /*4 cases */, 54, MVT::v16i8,// ->58592
/* 58538*/     OPC_Scope, 25, /*->58565*/ // 2 children in Scope
/* 58540*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58542*/      OPC_EmitMergeInputChains1_0,
/* 58543*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58546*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58549*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 58556*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58565*/     /*Scope*/ 25, /*->58591*/
/* 58566*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58568*/      OPC_EmitMergeInputChains1_0,
/* 58569*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58572*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58575*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 58582*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58591*/     0, /*End of Scope*/
/* 58592*/    /*SwitchType*/ 54, MVT::v8i16,// ->58648
/* 58594*/     OPC_Scope, 25, /*->58621*/ // 2 children in Scope
/* 58596*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58598*/      OPC_EmitMergeInputChains1_0,
/* 58599*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58602*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58605*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 58612*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58621*/     /*Scope*/ 25, /*->58647*/
/* 58622*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58624*/      OPC_EmitMergeInputChains1_0,
/* 58625*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58628*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58631*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 58638*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58647*/     0, /*End of Scope*/
/* 58648*/    /*SwitchType*/ 54, MVT::v4i32,// ->58704
/* 58650*/     OPC_Scope, 25, /*->58677*/ // 2 children in Scope
/* 58652*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58654*/      OPC_EmitMergeInputChains1_0,
/* 58655*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58658*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58661*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 58668*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58677*/     /*Scope*/ 25, /*->58703*/
/* 58678*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58680*/      OPC_EmitMergeInputChains1_0,
/* 58681*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58684*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58687*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 58694*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58703*/     0, /*End of Scope*/
/* 58704*/    /*SwitchType*/ 54, MVT::v2i64,// ->58760
/* 58706*/     OPC_Scope, 25, /*->58733*/ // 2 children in Scope
/* 58708*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58710*/      OPC_EmitMergeInputChains1_0,
/* 58711*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58714*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58717*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 58724*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58733*/     /*Scope*/ 25, /*->58759*/
/* 58734*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 58736*/      OPC_EmitMergeInputChains1_0,
/* 58737*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58740*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58743*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 58750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58759*/     0, /*End of Scope*/
/* 58760*/    0, // EndSwitchType
/* 58761*/   0, // EndSwitchOpcode
/* 58762*/  /*Scope*/ 38|128,3/*422*/, /*->59186*/
/* 58764*/   OPC_RecordChild1, // #1 = $off
/* 58765*/   OPC_Scope, 119|128,1/*247*/, /*->59015*/ // 3 children in Scope
/* 58768*/    OPC_MoveChild1,
/* 58769*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58772*/    OPC_MoveParent,
/* 58773*/    OPC_SwitchType /*4 cases */, 58, MVT::v16i8,// ->58834
/* 58776*/     OPC_Scope, 27, /*->58805*/ // 2 children in Scope
/* 58778*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58780*/      OPC_EmitMergeInputChains1_0,
/* 58781*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58784*/      OPC_EmitConvertToTarget, 1,
/* 58786*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58789*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 58796*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58805*/     /*Scope*/ 27, /*->58833*/
/* 58806*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58808*/      OPC_EmitMergeInputChains1_0,
/* 58809*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58812*/      OPC_EmitConvertToTarget, 1,
/* 58814*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58817*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 58824*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v16i8] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58833*/     0, /*End of Scope*/
/* 58834*/    /*SwitchType*/ 58, MVT::v8i16,// ->58894
/* 58836*/     OPC_Scope, 27, /*->58865*/ // 2 children in Scope
/* 58838*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58840*/      OPC_EmitMergeInputChains1_0,
/* 58841*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58844*/      OPC_EmitConvertToTarget, 1,
/* 58846*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58849*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 58856*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58865*/     /*Scope*/ 27, /*->58893*/
/* 58866*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58868*/      OPC_EmitMergeInputChains1_0,
/* 58869*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58872*/      OPC_EmitConvertToTarget, 1,
/* 58874*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58877*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 58884*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58893*/     0, /*End of Scope*/
/* 58894*/    /*SwitchType*/ 58, MVT::v4i32,// ->58954
/* 58896*/     OPC_Scope, 27, /*->58925*/ // 2 children in Scope
/* 58898*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58900*/      OPC_EmitMergeInputChains1_0,
/* 58901*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58904*/      OPC_EmitConvertToTarget, 1,
/* 58906*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58909*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 58916*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58925*/     /*Scope*/ 27, /*->58953*/
/* 58926*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58928*/      OPC_EmitMergeInputChains1_0,
/* 58929*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58932*/      OPC_EmitConvertToTarget, 1,
/* 58934*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58937*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 58944*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 58953*/     0, /*End of Scope*/
/* 58954*/    /*SwitchType*/ 58, MVT::v2i64,// ->59014
/* 58956*/     OPC_Scope, 27, /*->58985*/ // 2 children in Scope
/* 58958*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 58960*/      OPC_EmitMergeInputChains1_0,
/* 58961*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58964*/      OPC_EmitConvertToTarget, 1,
/* 58966*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58969*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 58976*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 58985*/     /*Scope*/ 27, /*->59013*/
/* 58986*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 58988*/      OPC_EmitMergeInputChains1_0,
/* 58989*/      OPC_EmitInteger, MVT::i32, 0, 
/* 58992*/      OPC_EmitConvertToTarget, 1,
/* 58994*/      OPC_EmitInteger, MVT::i64, 0, 
/* 58997*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 59004*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 59013*/     0, /*End of Scope*/
/* 59014*/    0, // EndSwitchType
/* 59015*/   /*Scope*/ 84, /*->59100*/
/* 59016*/    OPC_CheckChild1Type, MVT::i32,
/* 59018*/    OPC_SwitchType /*4 cases */, 18, MVT::v16i8,// ->59039
/* 59021*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59023*/     OPC_EmitMergeInputChains1_0,
/* 59024*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59027*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59030*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v16i8] } I32:{ *:[i32] }:$addr) - Complexity = 3
               // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 59039*/    /*SwitchType*/ 18, MVT::v8i16,// ->59059
/* 59041*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59043*/     OPC_EmitMergeInputChains1_0,
/* 59044*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59047*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59050*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v8i16] } I32:{ *:[i32] }:$addr) - Complexity = 3
               // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 59059*/    /*SwitchType*/ 18, MVT::v4i32,// ->59079
/* 59061*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59063*/     OPC_EmitMergeInputChains1_0,
/* 59064*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59067*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59070*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v4i32] } I32:{ *:[i32] }:$addr) - Complexity = 3
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 59079*/    /*SwitchType*/ 18, MVT::v2i64,// ->59099
/* 59081*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59083*/     OPC_EmitMergeInputChains1_0,
/* 59084*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59087*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59090*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v2i64] } I32:{ *:[i32] }:$addr) - Complexity = 3
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 59099*/    0, // EndSwitchType
/* 59100*/   /*Scope*/ 84, /*->59185*/
/* 59101*/    OPC_CheckChild1Type, MVT::i64,
/* 59103*/    OPC_SwitchType /*4 cases */, 18, MVT::v16i8,// ->59124
/* 59106*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59108*/     OPC_EmitMergeInputChains1_0,
/* 59109*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59112*/     OPC_EmitInteger, MVT::i64, 0, 
/* 59115*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v16i8] } I64:{ *:[i64] }:$addr) - Complexity = 3
               // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 59124*/    /*SwitchType*/ 18, MVT::v8i16,// ->59144
/* 59126*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59128*/     OPC_EmitMergeInputChains1_0,
/* 59129*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59132*/     OPC_EmitInteger, MVT::i64, 0, 
/* 59135*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v8i16] } I64:{ *:[i64] }:$addr) - Complexity = 3
               // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 59144*/    /*SwitchType*/ 18, MVT::v4i32,// ->59164
/* 59146*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59148*/     OPC_EmitMergeInputChains1_0,
/* 59149*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59152*/     OPC_EmitInteger, MVT::i64, 0, 
/* 59155*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v4i32] } I64:{ *:[i64] }:$addr) - Complexity = 3
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 59164*/    /*SwitchType*/ 18, MVT::v2i64,// ->59184
/* 59166*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59168*/     OPC_EmitMergeInputChains1_0,
/* 59169*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59172*/     OPC_EmitInteger, MVT::i64, 0, 
/* 59175*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v2i64] } I64:{ *:[i64] }:$addr) - Complexity = 3
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 59184*/    0, // EndSwitchType
/* 59185*/   0, /*End of Scope*/
/* 59186*/  /*Scope*/ 71|128,2/*327*/, /*->59515*/
/* 59188*/   OPC_MoveChild1,
/* 59189*/   OPC_SwitchOpcode /*3 cases */, 97, TARGET_VAL(ISD::ADD),// ->59290
/* 59193*/    OPC_RecordChild0, // #1 = $addr
/* 59194*/    OPC_RecordChild1, // #2 = $off
/* 59195*/    OPC_MoveChild1,
/* 59196*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59199*/    OPC_MoveParent,
/* 59200*/    OPC_CheckPredicate, 0, // Predicate_regPlusImm
/* 59202*/    OPC_SwitchType /*2 cases */, 41, MVT::i32,// ->59246
/* 59205*/     OPC_MoveParent,
/* 59206*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->59226
/* 59209*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59211*/      OPC_EmitMergeInputChains1_0,
/* 59212*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59215*/      OPC_EmitConvertToTarget, 2,
/* 59217*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 59226*/     /*SwitchType*/ 17, MVT::v2f64,// ->59245
/* 59228*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59230*/      OPC_EmitMergeInputChains1_0,
/* 59231*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59234*/      OPC_EmitConvertToTarget, 2,
/* 59236*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 59245*/     0, // EndSwitchType
/* 59246*/    /*SwitchType*/ 41, MVT::i64,// ->59289
/* 59248*/     OPC_MoveParent,
/* 59249*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->59269
/* 59252*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59254*/      OPC_EmitMergeInputChains1_0,
/* 59255*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59258*/      OPC_EmitConvertToTarget, 2,
/* 59260*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 59269*/     /*SwitchType*/ 17, MVT::v2f64,// ->59288
/* 59271*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59273*/      OPC_EmitMergeInputChains1_0,
/* 59274*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59277*/      OPC_EmitConvertToTarget, 2,
/* 59279*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (add:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_regPlusImm>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 59288*/     0, // EndSwitchType
/* 59289*/    0, // EndSwitchType
/* 59290*/   /*SwitchOpcode*/ 97, TARGET_VAL(ISD::OR),// ->59390
/* 59293*/    OPC_RecordChild0, // #1 = $addr
/* 59294*/    OPC_RecordChild1, // #2 = $off
/* 59295*/    OPC_MoveChild1,
/* 59296*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59299*/    OPC_MoveParent,
/* 59300*/    OPC_CheckPredicate, 3, // Predicate_or_is_add
/* 59302*/    OPC_SwitchType /*2 cases */, 41, MVT::i32,// ->59346
/* 59305*/     OPC_MoveParent,
/* 59306*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->59326
/* 59309*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59311*/      OPC_EmitMergeInputChains1_0,
/* 59312*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59315*/      OPC_EmitConvertToTarget, 2,
/* 59317*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 59326*/     /*SwitchType*/ 17, MVT::v2f64,// ->59345
/* 59328*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59330*/      OPC_EmitMergeInputChains1_0,
/* 59331*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59334*/      OPC_EmitConvertToTarget, 2,
/* 59336*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 59345*/     0, // EndSwitchType
/* 59346*/    /*SwitchType*/ 41, MVT::i64,// ->59389
/* 59348*/     OPC_MoveParent,
/* 59349*/     OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->59369
/* 59352*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59354*/      OPC_EmitMergeInputChains1_0,
/* 59355*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59358*/      OPC_EmitConvertToTarget, 2,
/* 59360*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 59369*/     /*SwitchType*/ 17, MVT::v2f64,// ->59388
/* 59371*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59373*/      OPC_EmitMergeInputChains1_0,
/* 59374*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59377*/      OPC_EmitConvertToTarget, 2,
/* 59379*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (or:{ *:[i64] } I64:{ *:[i64] }:$addr, (imm:{ *:[i64] }):$off)<<P:Predicate_or_is_add>>) - Complexity = 10
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, I64:{ *:[i64] }:$addr)
/* 59388*/     0, // EndSwitchType
/* 59389*/    0, // EndSwitchType
/* 59390*/   /*SwitchOpcode*/ 121, TARGET_VAL(WebAssemblyISD::Wrapper),// ->59514
/* 59393*/    OPC_RecordChild0, // #1 = $off
/* 59394*/    OPC_MoveChild0,
/* 59395*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 59398*/    OPC_MoveParent,
/* 59399*/    OPC_MoveParent,
/* 59400*/    OPC_SwitchType /*2 cases */, 54, MVT::v4f32,// ->59457
/* 59403*/     OPC_Scope, 25, /*->59430*/ // 2 children in Scope
/* 59405*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 59407*/      OPC_EmitMergeInputChains1_0,
/* 59408*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59411*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59414*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 59421*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 59430*/     /*Scope*/ 25, /*->59456*/
/* 59431*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 59433*/      OPC_EmitMergeInputChains1_0,
/* 59434*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59437*/      OPC_EmitInteger, MVT::i64, 0, 
/* 59440*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 59447*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 59456*/     0, /*End of Scope*/
/* 59457*/    /*SwitchType*/ 54, MVT::v2f64,// ->59513
/* 59459*/     OPC_Scope, 25, /*->59486*/ // 2 children in Scope
/* 59461*/      OPC_CheckPatternPredicate, 6, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 59463*/      OPC_EmitMergeInputChains1_0,
/* 59464*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59467*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59470*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 59477*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 59486*/     /*Scope*/ 25, /*->59512*/
/* 59487*/      OPC_CheckPatternPredicate, 7, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 59489*/      OPC_EmitMergeInputChains1_0,
/* 59490*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59493*/      OPC_EmitInteger, MVT::i64, 0, 
/* 59496*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 3,  // Results = #4
/* 59503*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off)) - Complexity = 9
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 59512*/     0, /*End of Scope*/
/* 59513*/    0, // EndSwitchType
/* 59514*/   0, // EndSwitchOpcode
/* 59515*/  /*Scope*/ 93|128,1/*221*/, /*->59738*/
/* 59517*/   OPC_RecordChild1, // #1 = $off
/* 59518*/   OPC_Scope, 127, /*->59647*/ // 3 children in Scope
/* 59520*/    OPC_MoveChild1,
/* 59521*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59524*/    OPC_MoveParent,
/* 59525*/    OPC_SwitchType /*2 cases */, 58, MVT::v4f32,// ->59586
/* 59528*/     OPC_Scope, 27, /*->59557*/ // 2 children in Scope
/* 59530*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59532*/      OPC_EmitMergeInputChains1_0,
/* 59533*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59536*/      OPC_EmitConvertToTarget, 1,
/* 59538*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59541*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 59548*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 59557*/     /*Scope*/ 27, /*->59585*/
/* 59558*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59560*/      OPC_EmitMergeInputChains1_0,
/* 59561*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59564*/      OPC_EmitConvertToTarget, 1,
/* 59566*/      OPC_EmitInteger, MVT::i64, 0, 
/* 59569*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 59576*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4f32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v4f32] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 59585*/     0, /*End of Scope*/
/* 59586*/    /*SwitchType*/ 58, MVT::v2f64,// ->59646
/* 59588*/     OPC_Scope, 27, /*->59617*/ // 2 children in Scope
/* 59590*/      OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59592*/      OPC_EmitMergeInputChains1_0,
/* 59593*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59596*/      OPC_EmitConvertToTarget, 1,
/* 59598*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59601*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 59608*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 59617*/     /*Scope*/ 27, /*->59645*/
/* 59618*/      OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59620*/      OPC_EmitMergeInputChains1_0,
/* 59621*/      OPC_EmitInteger, MVT::i32, 0, 
/* 59624*/      OPC_EmitConvertToTarget, 1,
/* 59626*/      OPC_EmitInteger, MVT::i64, 0, 
/* 59629*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 4,  // Results = #5
/* 59636*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2f64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (wasm_load_splat:{ *:[v2f64] } (imm:{ *:[iPTR] }):$off) - Complexity = 6
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i64] }):$off, (CONST_I64:{ *:[i64] } 0:{ *:[i64] }))
/* 59645*/     0, /*End of Scope*/
/* 59646*/    0, // EndSwitchType
/* 59647*/   /*Scope*/ 44, /*->59692*/
/* 59648*/    OPC_CheckChild1Type, MVT::i32,
/* 59650*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->59671
/* 59653*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59655*/     OPC_EmitMergeInputChains1_0,
/* 59656*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59659*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59662*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v4f32] } I32:{ *:[i32] }:$addr) - Complexity = 3
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 59671*/    /*SwitchType*/ 18, MVT::v2f64,// ->59691
/* 59673*/     OPC_CheckPatternPredicate, 4, // (!Subtarget->hasAddr64())
/* 59675*/     OPC_EmitMergeInputChains1_0,
/* 59676*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59679*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59682*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v2f64] } I32:{ *:[i32] }:$addr) - Complexity = 3
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 59691*/    0, // EndSwitchType
/* 59692*/   /*Scope*/ 44, /*->59737*/
/* 59693*/    OPC_CheckChild1Type, MVT::i64,
/* 59695*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->59716
/* 59698*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59700*/     OPC_EmitMergeInputChains1_0,
/* 59701*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59704*/     OPC_EmitInteger, MVT::i64, 0, 
/* 59707*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v4f32] } I64:{ *:[i64] }:$addr) - Complexity = 3
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 59716*/    /*SwitchType*/ 18, MVT::v2f64,// ->59736
/* 59718*/     OPC_CheckPatternPredicate, 5, // (Subtarget->hasAddr64())
/* 59720*/     OPC_EmitMergeInputChains1_0,
/* 59721*/     OPC_EmitInteger, MVT::i32, 0, 
/* 59724*/     OPC_EmitInteger, MVT::i64, 0, 
/* 59727*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 2, 3, 1, 
               // Src: (wasm_load_splat:{ *:[v2f64] } I64:{ *:[i64] }:$addr) - Complexity = 3
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr)
/* 59736*/    0, // EndSwitchType
/* 59737*/   0, /*End of Scope*/
/* 59738*/  0, /*End of Scope*/
/* 59739*/ /*SwitchOpcode*/ 18, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->59760
/* 59742*/  OPC_RecordChild0, // #0 = $src
/* 59743*/  OPC_CheckChild0Type, MVT::v16i8,
/* 59745*/  OPC_RecordChild1, // #1 = $mask
/* 59746*/  OPC_CheckChild1Type, MVT::v16i8,
/* 59748*/  OPC_CheckType, MVT::v16i8,
/* 59750*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59752*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SWIZZLE), 0,
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 59760*/ /*SwitchOpcode*/ 71, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->59834
/* 59763*/  OPC_RecordChild0, // #0 = $x
/* 59764*/  OPC_Scope, 31, /*->59797*/ // 4 children in Scope
/* 59766*/   OPC_CheckChild0Type, MVT::i32,
/* 59768*/   OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->59778
/* 59771*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I8x16), 0,
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 59778*/   /*SwitchType*/ 7, MVT::v8i16,// ->59787
/* 59780*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 59787*/   /*SwitchType*/ 7, MVT::v4i32,// ->59796
/* 59789*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 59796*/   0, // EndSwitchType
/* 59797*/  /*Scope*/ 11, /*->59809*/
/* 59798*/   OPC_CheckChild0Type, MVT::i64,
/* 59800*/   OPC_CheckType, MVT::v2i64,
/* 59802*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
             // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 59809*/  /*Scope*/ 11, /*->59821*/
/* 59810*/   OPC_CheckChild0Type, MVT::f32,
/* 59812*/   OPC_CheckType, MVT::v4f32,
/* 59814*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
             // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 59821*/  /*Scope*/ 11, /*->59833*/
/* 59822*/   OPC_CheckChild0Type, MVT::f64,
/* 59824*/   OPC_CheckType, MVT::v2f64,
/* 59826*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
             // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 59833*/  0, /*End of Scope*/
/* 59834*/ /*SwitchOpcode*/ 47, TARGET_VAL(ISD::ABS),// ->59884
/* 59837*/  OPC_RecordChild0, // #0 = $v
/* 59838*/  OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->59850
/* 59841*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59843*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I8x16), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 59850*/  /*SwitchType*/ 9, MVT::v8i16,// ->59861
/* 59852*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59854*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 59861*/  /*SwitchType*/ 9, MVT::v4i32,// ->59872
/* 59863*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59865*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 59872*/  /*SwitchType*/ 9, MVT::v2i64,// ->59883
/* 59874*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59876*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 59883*/  0, // EndSwitchType
/* 59884*/ /*SwitchOpcode*/ 28, TARGET_VAL(ISD::SADDSAT),// ->59915
/* 59887*/  OPC_RecordChild0, // #0 = $lhs
/* 59888*/  OPC_RecordChild1, // #1 = $rhs
/* 59889*/  OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->59902
/* 59892*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59894*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 59902*/  /*SwitchType*/ 10, MVT::v8i16,// ->59914
/* 59904*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59906*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 59914*/  0, // EndSwitchType
/* 59915*/ /*SwitchOpcode*/ 28, TARGET_VAL(ISD::UADDSAT),// ->59946
/* 59918*/  OPC_RecordChild0, // #0 = $lhs
/* 59919*/  OPC_RecordChild1, // #1 = $rhs
/* 59920*/  OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->59933
/* 59923*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59925*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 59933*/  /*SwitchType*/ 10, MVT::v8i16,// ->59945
/* 59935*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59937*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 59945*/  0, // EndSwitchType
/* 59946*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::SMIN),// ->59989
/* 59949*/  OPC_RecordChild0, // #0 = $lhs
/* 59950*/  OPC_RecordChild1, // #1 = $rhs
/* 59951*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->59964
/* 59954*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59956*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 59964*/  /*SwitchType*/ 10, MVT::v8i16,// ->59976
/* 59966*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59968*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 59976*/  /*SwitchType*/ 10, MVT::v4i32,// ->59988
/* 59978*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59980*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 59988*/  0, // EndSwitchType
/* 59989*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::UMIN),// ->60032
/* 59992*/  OPC_RecordChild0, // #0 = $lhs
/* 59993*/  OPC_RecordChild1, // #1 = $rhs
/* 59994*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->60007
/* 59997*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 59999*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 60007*/  /*SwitchType*/ 10, MVT::v8i16,// ->60019
/* 60009*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60011*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 60019*/  /*SwitchType*/ 10, MVT::v4i32,// ->60031
/* 60021*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60023*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 60031*/  0, // EndSwitchType
/* 60032*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::SMAX),// ->60075
/* 60035*/  OPC_RecordChild0, // #0 = $lhs
/* 60036*/  OPC_RecordChild1, // #1 = $rhs
/* 60037*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->60050
/* 60040*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60042*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 60050*/  /*SwitchType*/ 10, MVT::v8i16,// ->60062
/* 60052*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60054*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 60062*/  /*SwitchType*/ 10, MVT::v4i32,// ->60074
/* 60064*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60066*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 60074*/  0, // EndSwitchType
/* 60075*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::UMAX),// ->60118
/* 60078*/  OPC_RecordChild0, // #0 = $lhs
/* 60079*/  OPC_RecordChild1, // #1 = $rhs
/* 60080*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->60093
/* 60083*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60085*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 60093*/  /*SwitchType*/ 10, MVT::v8i16,// ->60105
/* 60095*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60097*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 60105*/  /*SwitchType*/ 10, MVT::v4i32,// ->60117
/* 60107*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60109*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 60117*/  0, // EndSwitchType
/* 60118*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->60135
/* 60121*/  OPC_RecordChild0, // #0 = $vec
/* 60122*/  OPC_CheckChild0Type, MVT::v2f64,
/* 60124*/  OPC_CheckType, MVT::v4i32,
/* 60126*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60128*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4), 0,
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 60135*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->60152
/* 60138*/  OPC_RecordChild0, // #0 = $vec
/* 60139*/  OPC_CheckChild0Type, MVT::v2f64,
/* 60141*/  OPC_CheckType, MVT::v4i32,
/* 60143*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60145*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4), 0,
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 60152*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->60197
/* 60155*/  OPC_RecordChild0, // #0 = $vec
/* 60156*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->60170
/* 60159*/   OPC_CheckChild0Type, MVT::v16i8,
/* 60161*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60163*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 60170*/  /*SwitchType*/ 11, MVT::v4i32,// ->60183
/* 60172*/   OPC_CheckChild0Type, MVT::v8i16,
/* 60174*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60176*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 60183*/  /*SwitchType*/ 11, MVT::v2i64,// ->60196
/* 60185*/   OPC_CheckChild0Type, MVT::v4i32,
/* 60187*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60189*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 60196*/  0, // EndSwitchType
/* 60197*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->60242
/* 60200*/  OPC_RecordChild0, // #0 = $vec
/* 60201*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->60215
/* 60204*/   OPC_CheckChild0Type, MVT::v16i8,
/* 60206*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60208*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 60215*/  /*SwitchType*/ 11, MVT::v4i32,// ->60228
/* 60217*/   OPC_CheckChild0Type, MVT::v8i16,
/* 60219*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60221*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 60228*/  /*SwitchType*/ 11, MVT::v2i64,// ->60241
/* 60230*/   OPC_CheckChild0Type, MVT::v4i32,
/* 60232*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60234*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 60241*/  0, // EndSwitchType
/* 60242*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->60287
/* 60245*/  OPC_RecordChild0, // #0 = $vec
/* 60246*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->60260
/* 60249*/   OPC_CheckChild0Type, MVT::v16i8,
/* 60251*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60253*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 60260*/  /*SwitchType*/ 11, MVT::v4i32,// ->60273
/* 60262*/   OPC_CheckChild0Type, MVT::v8i16,
/* 60264*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60266*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 60273*/  /*SwitchType*/ 11, MVT::v2i64,// ->60286
/* 60275*/   OPC_CheckChild0Type, MVT::v4i32,
/* 60277*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60279*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 60286*/  0, // EndSwitchType
/* 60287*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->60332
/* 60290*/  OPC_RecordChild0, // #0 = $vec
/* 60291*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->60305
/* 60294*/   OPC_CheckChild0Type, MVT::v16i8,
/* 60296*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60298*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 60305*/  /*SwitchType*/ 11, MVT::v4i32,// ->60318
/* 60307*/   OPC_CheckChild0Type, MVT::v8i16,
/* 60309*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60311*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 60318*/  /*SwitchType*/ 11, MVT::v2i64,// ->60331
/* 60320*/   OPC_CheckChild0Type, MVT::v4i32,
/* 60322*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60324*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 60331*/  0, // EndSwitchType
/* 60332*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->60349
/* 60335*/  OPC_RecordChild0, // #0 = $vec
/* 60336*/  OPC_CheckChild0Type, MVT::v4i32,
/* 60338*/  OPC_CheckType, MVT::v2f64,
/* 60340*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60342*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::convert_low_s_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 60349*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->60366
/* 60352*/  OPC_RecordChild0, // #0 = $vec
/* 60353*/  OPC_CheckChild0Type, MVT::v4i32,
/* 60355*/  OPC_CheckType, MVT::v2f64,
/* 60357*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60359*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::convert_low_u_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 60366*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->60383
/* 60369*/  OPC_RecordChild0, // #0 = $vec
/* 60370*/  OPC_CheckChild0Type, MVT::v2f64,
/* 60372*/  OPC_CheckType, MVT::v4f32,
/* 60374*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60376*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::demote_zero_F32x4), 0,
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 60383*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->60400
/* 60386*/  OPC_RecordChild0, // #0 = $vec
/* 60387*/  OPC_CheckChild0Type, MVT::v4f32,
/* 60389*/  OPC_CheckType, MVT::v2f64,
/* 60391*/  OPC_CheckPatternPredicate, 8, // (Subtarget->hasSIMD128())
/* 60393*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 60400*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 60402 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 852
  // #OPC_RecordNode                           = 125
  // #OPC_RecordChild                          = 1018
  // #OPC_RecordMemRef                         = 37
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 757
  // #OPC_MoveParent                           = 1416
  // #OPC_CheckSame                            = 12
  // #OPC_CheckChildSame                       = 53
  // #OPC_CheckPatternPredicate                = 1821
  // #OPC_CheckPredicate                       = 1716
  // #OPC_CheckOpcode                          = 627
  // #OPC_SwitchOpcode                         = 54
  // #OPC_CheckType                            = 525
  // #OPC_SwitchType                           = 339
  // #OPC_CheckChildType                       = 414
  // #OPC_CheckInteger                         = 22
  // #OPC_CheckChildInteger                    = 96
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 136
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 0
  // #OPC_CheckAndImm                          = 24
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 24
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 2644
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 1093
  // #OPC_EmitMergeInputChains                 = 1626
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 705
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 30
  // #OPC_MorphNodeTo                          = 2244

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 1: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent());
  case 3: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics()) && (!TM.isPositionIndependent());
  case 4: return (!Subtarget->hasAddr64());
  case 5: return (Subtarget->hasAddr64());
  case 6: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 7: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 8: return (Subtarget->hasSIMD128());
  case 9: return (Subtarget->hasReferenceTypes());
  case 10: return (Subtarget->hasSignExt());
  case 11: return (Subtarget->hasExceptionHandling());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 14: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasNontrappingFPToInt());
  case 16: return (!Subtarget->hasNontrappingFPToInt());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_regPlusImm
    SDNode *N = Node;
    (void)N;
 return N->getFlags().hasNoUnsignedWrap(); 
  }
  case 1: {
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_store_8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    // Predicate_extloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_store_16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    // Predicate_extloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_or_is_add
    SDNode *N = Node;
    (void)N;

  if (ConstantSDNode *CN = dyn_cast<ConstantSDNode>(N->getOperand(1)))
    return CurDAG->MaskedValueIsZero(N->getOperand(0), CN->getAPIntValue());

  KnownBits Known0 = CurDAG->computeKnownBits(N->getOperand(0), 0);
  KnownBits Known1 = CurDAG->computeKnownBits(N->getOperand(1), 0);
  return (~Known0.Zero & ~Known1.Zero) == 0;

  }
  case 4: {
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_swap_32
    // Predicate_atomic_load_32
    // Predicate_atomic_store_32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    // Predicate_extloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 5: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 6: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 7: {
    // Predicate_atomic_store_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_swap_64
    // Predicate_atomic_cmp_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  case 9: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 10: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 11: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 12: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 14: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 15: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 16: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 17: {
    // Predicate_truncstorevi8
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 18: {
    // Predicate_truncstorevi16
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 19: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 20: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 21: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 22: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 23: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 24: {
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    // Predicate_extloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 25: {
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    // Predicate_extloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 26: {
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    // Predicate_extloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 27: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 28: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << (8 - 1));
  }
  case 29: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << (16 - 1));
  }
  case 30: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
